# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class S1AP_CommonDataTypes:

    _name_  = 'S1AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 3]
    
    _obj_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name='ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessfull-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class S1AP_Constants:

    _name_  = 'S1AP-Constants'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 4]
    
    _obj_ = [
        'id-HandoverPreparation',
        'id-HandoverResourceAllocation',
        'id-HandoverNotification',
        'id-PathSwitchRequest',
        'id-HandoverCancel',
        'id-E-RABSetup',
        'id-E-RABModify',
        'id-E-RABRelease',
        'id-E-RABReleaseIndication',
        'id-InitialContextSetup',
        'id-Paging',
        'id-downlinkNASTransport',
        'id-initialUEMessage',
        'id-uplinkNASTransport',
        'id-Reset',
        'id-ErrorIndication',
        'id-NASNonDeliveryIndication',
        'id-S1Setup',
        'id-UEContextReleaseRequest',
        'id-DownlinkS1cdma2000tunnelling',
        'id-UplinkS1cdma2000tunnelling',
        'id-UEContextModification',
        'id-UECapabilityInfoIndication',
        'id-UEContextRelease',
        'id-eNBStatusTransfer',
        'id-MMEStatusTransfer',
        'id-DeactivateTrace',
        'id-TraceStart',
        'id-TraceFailureIndication',
        'id-ENBConfigurationUpdate',
        'id-MMEConfigurationUpdate',
        'id-LocationReportingControl',
        'id-LocationReportingFailureIndication',
        'id-LocationReport',
        'id-OverloadStart',
        'id-OverloadStop',
        'id-WriteReplaceWarning',
        'id-eNBDirectInformationTransfer',
        'id-MMEDirectInformationTransfer',
        'id-PrivateMessage',
        'id-eNBConfigurationTransfer',
        'id-MMEConfigurationTransfer',
        'id-CellTrafficTrace',
        'id-Kill',
        'id-downlinkUEAssociatedLPPaTransport',
        'id-uplinkUEAssociatedLPPaTransport',
        'id-downlinkNonUEAssociatedLPPaTransport',
        'id-uplinkNonUEAssociatedLPPaTransport',
        'id-UERadioCapabilityMatch',
        'id-PWSRestartIndication',
        'id-E-RABModificationIndication',
        'id-PWSFailureIndication',
        'id-RerouteNASRequest',
        'id-UEContextModificationIndication',
        'id-ConnectionEstablishmentIndication',
        'id-UEContextSuspend',
        'id-UEContextResume',
        'id-NASDeliveryIndication',
        'id-RetrieveUEInformation',
        'id-UEInformationTransfer',
        'id-eNBCPRelocationIndication',
        'id-MMECPRelocationIndication',
        'id-SecondaryRATDataUsageReport',
        'id-UERadioCapabilityIDMapping',
        'id-HandoverSuccess',
        'id-eNBEarlyStatusTransfer',
        'id-MMEEarlyStatusTransfer',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxnoofCSGs',
        'maxnoofE-RABs',
        'maxnoofTAIs',
        'maxnoofTACs',
        'maxnoofErrors',
        'maxnoofBPLMNs',
        'maxnoofPLMNsPerMME',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofForbLACs',
        'maxnoofForbTACs',
        'maxnoofIndividualS1ConnectionsToReset',
        'maxnoofCellsinUEHistoryInfo',
        'maxnoofCellsineNB',
        'maxnoofTAIforWarning',
        'maxnoofCellID',
        'maxnoofDCNs',
        'maxnoofEmergencyAreaID',
        'maxnoofCellinTAI',
        'maxnoofCellinEAI',
        'maxnoofeNBX2TLAs',
        'maxnoofeNBX2ExtTLAs',
        'maxnoofeNBX2GTPTLAs',
        'maxnoofRATs',
        'maxnoofGroupIDs',
        'maxnoofMMECs',
        'maxnoofCellIDforMDT',
        'maxnoofTAforMDT',
        'maxnoofMDTPLMNs',
        'maxnoofCellsforRestart',
        'maxnoofRestartTAIs',
        'maxnoofRestartEmergencyAreaIDs',
        'maxEARFCN',
        'maxnoofMBSFNAreaMDT',
        'maxnoofRecommendedCells',
        'maxnoofRecommendedENBs',
        'maxnooftimeperiods',
        'maxnoofCellIDforQMC',
        'maxnoofTAforQMC',
        'maxnoofPLMNforQMC',
        'maxnoofBluetoothName',
        'maxnoofWLANName',
        'maxnoofConnectedengNBs',
        'maxnoofPC5QoSFlows',
        'maxnooffrequencies',
        'maxNARFCN',
        'maxRS-IndexCellQual',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofTACsInNTN',
        'maxnoofSensorName',
        'id-MME-UE-S1AP-ID',
        'id-HandoverType',
        'id-Cause',
        'id-SourceID',
        'id-TargetID',
        'id-eNB-UE-S1AP-ID',
        'id-E-RABSubjecttoDataForwardingList',
        'id-E-RABtoReleaseListHOCmd',
        'id-E-RABDataForwardingItem',
        'id-E-RABReleaseItemBearerRelComp',
        'id-E-RABToBeSetupListBearerSUReq',
        'id-E-RABToBeSetupItemBearerSUReq',
        'id-E-RABAdmittedList',
        'id-E-RABFailedToSetupListHOReqAck',
        'id-E-RABAdmittedItem',
        'id-E-RABFailedtoSetupItemHOReqAck',
        'id-E-RABToBeSwitchedDLList',
        'id-E-RABToBeSwitchedDLItem',
        'id-E-RABToBeSetupListCtxtSUReq',
        'id-TraceActivation',
        'id-NAS-PDU',
        'id-E-RABToBeSetupItemHOReq',
        'id-E-RABSetupListBearerSURes',
        'id-E-RABFailedToSetupListBearerSURes',
        'id-E-RABToBeModifiedListBearerModReq',
        'id-E-RABModifyListBearerModRes',
        'id-E-RABFailedToModifyList',
        'id-E-RABToBeReleasedList',
        'id-E-RABFailedToReleaseList',
        'id-E-RABItem',
        'id-E-RABToBeModifiedItemBearerModReq',
        'id-E-RABModifyItemBearerModRes',
        'id-E-RABReleaseItem',
        'id-E-RABSetupItemBearerSURes',
        'id-SecurityContext',
        'id-HandoverRestrictionList',
        'id-UEPagingID',
        'id-pagingDRX',
        'id-TAIList',
        'id-TAIItem',
        'id-E-RABFailedToSetupListCtxtSURes',
        'id-E-RABReleaseItemHOCmd',
        'id-E-RABSetupItemCtxtSURes',
        'id-E-RABSetupListCtxtSURes',
        'id-E-RABToBeSetupItemCtxtSUReq',
        'id-E-RABToBeSetupListHOReq',
        'id-GERANtoLTEHOInformationRes',
        'id-UTRANtoLTEHOInformationRes',
        'id-CriticalityDiagnostics',
        'id-Global-ENB-ID',
        'id-eNBname',
        'id-MMEname',
        'id-ServedPLMNs',
        'id-SupportedTAs',
        'id-TimeToWait',
        'id-uEaggregateMaximumBitrate',
        'id-TAI',
        'id-E-RABReleaseListBearerRelComp',
        'id-cdma2000PDU',
        'id-cdma2000RATType',
        'id-cdma2000SectorID',
        'id-SecurityKey',
        'id-UERadioCapability',
        'id-GUMMEI-ID',
        'id-E-RABInformationListItem',
        'id-Direct-Forwarding-Path-Availability',
        'id-UEIdentityIndexValue',
        'id-cdma2000HOStatus',
        'id-cdma2000HORequiredIndication',
        'id-E-UTRAN-Trace-ID',
        'id-RelativeMMECapacity',
        'id-SourceMME-UE-S1AP-ID',
        'id-Bearers-SubjectToStatusTransfer-Item',
        'id-eNB-StatusTransfer-TransparentContainer',
        'id-UE-associatedLogicalS1-ConnectionItem',
        'id-ResetType',
        'id-UE-associatedLogicalS1-ConnectionListResAck',
        'id-E-RABToBeSwitchedULItem',
        'id-E-RABToBeSwitchedULList',
        'id-S-TMSI',
        'id-cdma2000OneXRAND',
        'id-RequestType',
        'id-UE-S1AP-IDs',
        'id-EUTRAN-CGI',
        'id-OverloadResponse',
        'id-cdma2000OneXSRVCCInfo',
        'id-E-RABFailedToBeReleasedList',
        'id-Source-ToTarget-TransparentContainer',
        'id-ServedGUMMEIs',
        'id-SubscriberProfileIDforRFP',
        'id-UESecurityCapabilities',
        'id-CSFallbackIndicator',
        'id-CNDomain',
        'id-E-RABReleasedList',
        'id-MessageIdentifier',
        'id-SerialNumber',
        'id-WarningAreaList',
        'id-RepetitionPeriod',
        'id-NumberofBroadcastRequest',
        'id-WarningType',
        'id-WarningSecurityInfo',
        'id-DataCodingScheme',
        'id-WarningMessageContents',
        'id-BroadcastCompletedAreaList',
        'id-Inter-SystemInformationTransferTypeEDT',
        'id-Inter-SystemInformationTransferTypeMDT',
        'id-Target-ToSource-TransparentContainer',
        'id-SRVCCOperationPossible',
        'id-SRVCCHOIndication',
        'id-NAS-DownlinkCount',
        'id-CSG-Id',
        'id-CSG-IdList',
        'id-SONConfigurationTransferECT',
        'id-SONConfigurationTransferMCT',
        'id-TraceCollectionEntityIPAddress',
        'id-MSClassmark2',
        'id-MSClassmark3',
        'id-RRC-Establishment-Cause',
        'id-NASSecurityParametersfromE-UTRAN',
        'id-NASSecurityParameterstoE-UTRAN',
        'id-DefaultPagingDRX',
        'id-Source-ToTarget-TransparentContainer-Secondary',
        'id-Target-ToSource-TransparentContainer-Secondary',
        'id-EUTRANRoundTripDelayEstimationInfo',
        'id-BroadcastCancelledAreaList',
        'id-ConcurrentWarningMessageIndicator',
        'id-Data-Forwarding-Not-Possible',
        'id-ExtendedRepetitionPeriod',
        'id-CellAccessMode',
        'id-CSGMembershipStatus',
        'id-LPPa-PDU',
        'id-Routing-ID',
        'id-Time-Synchronisation-Info',
        'id-PS-ServiceNotAvailable',
        'id-PagingPriority',
        'id-x2TNLConfigurationInfo',
        'id-eNBX2ExtendedTransportLayerAddresses',
        'id-GUMMEIList',
        'id-GW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-SourceMME-GUMMEI',
        'id-MME-UE-S1AP-ID-2',
        'id-RegisteredLAI',
        'id-RelayNode-Indicator',
        'id-TrafficLoadReductionIndication',
        'id-MDTConfiguration',
        'id-MMERelaySupportIndicator',
        'id-GWContextReleaseIndication',
        'id-ManagementBasedMDTAllowed',
        'id-PrivacyIndicator',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-HO-Cause',
        'id-VoiceSupportMatchIndicator',
        'id-GUMMEIType',
        'id-M3Configuration',
        'id-M4Configuration',
        'id-M5Configuration',
        'id-MDT-Location-Info',
        'id-MobilityInformation',
        'id-Tunnel-Information-for-BBF',
        'id-ManagementBasedMDTPLMNList',
        'id-SignallingBasedMDTPLMNList',
        'id-ULCOUNTValueExtended',
        'id-DLCOUNTValueExtended',
        'id-ReceiveStatusOfULPDCPSDUsExtended',
        'id-ECGIListForRestart',
        'id-SIPTO-Correlation-ID',
        'id-SIPTO-L-GW-TransportLayerAddress',
        'id-TransportInformation',
        'id-LHN-ID',
        'id-AdditionalCSFallbackIndicator',
        'id-TAIListForRestart',
        'id-UserLocationInformation',
        'id-EmergencyAreaIDListForRestart',
        'id-KillAllWarningMessages',
        'id-Masked-IMEISV',
        'id-eNBIndirectX2TransportLayerAddresses',
        'id-uE-HistoryInformationFromTheUE',
        'id-ProSeAuthorized',
        'id-ExpectedUEBehaviour',
        'id-LoggedMBSFNMDT',
        'id-UERadioCapabilityForPaging',
        'id-E-RABToBeModifiedListBearerModInd',
        'id-E-RABToBeModifiedItemBearerModInd',
        'id-E-RABNotToBeModifiedListBearerModInd',
        'id-E-RABNotToBeModifiedItemBearerModInd',
        'id-E-RABModifyListBearerModConf',
        'id-E-RABModifyItemBearerModConf',
        'id-E-RABFailedToModifyListBearerModConf',
        'id-SON-Information-Report',
        'id-Muting-Availability-Indication',
        'id-Muting-Pattern-Information',
        'id-Synchronisation-Information',
        'id-E-RABToBeReleasedListBearerModConf',
        'id-AssistanceDataForPaging',
        'id-CellIdentifierAndCELevelForCECapableUEs',
        'id-InformationOnRecommendedCellsAndENBsForPaging',
        'id-RecommendedCellItem',
        'id-RecommendedENBItem',
        'id-ProSeUEtoNetworkRelaying',
        'id-ULCOUNTValuePDCP-SNlength18',
        'id-DLCOUNTValuePDCP-SNlength18',
        'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'id-M6Configuration',
        'id-M7Configuration',
        'id-PWSfailedECGIList',
        'id-MME-Group-ID',
        'id-Additional-GUTI',
        'id-S1-Message',
        'id-CSGMembershipInfo',
        'id-Paging-eDRXInformation',
        'id-UE-RetentionInformation',
        'id-UE-Usage-Type',
        'id-extended-UEIdentityIndexValue',
        'id-RAT-Type',
        'id-BearerType',
        'id-NB-IoT-DefaultPagingDRX',
        'id-E-RABFailedToResumeListResumeReq',
        'id-E-RABFailedToResumeItemResumeReq',
        'id-E-RABFailedToResumeListResumeRes',
        'id-E-RABFailedToResumeItemResumeRes',
        'id-NB-IoT-Paging-eDRXInformation',
        'id-V2XServicesAuthorized',
        'id-UEUserPlaneCIoTSupportIndicator',
        'id-CE-mode-B-SupportIndicator',
        'id-SRVCCOperationNotPossible',
        'id-NB-IoT-UEIdentityIndexValue',
        'id-RRC-Resume-Cause',
        'id-DCN-ID',
        'id-ServedDCNs',
        'id-UESidelinkAggregateMaximumBitrate',
        'id-DLNASPDUDeliveryAckRequest',
        'id-Coverage-Level',
        'id-EnhancedCoverageRestricted',
        'id-UE-Level-QoS-Parameters',
        'id-DL-CP-SecurityInformation',
        'id-UL-CP-SecurityInformation',
        'id-extended-e-RAB-MaximumBitrateDL',
        'id-extended-e-RAB-MaximumBitrateUL',
        'id-extended-e-RAB-GuaranteedBitrateDL',
        'id-extended-e-RAB-GuaranteedBitrateUL',
        'id-extended-uEaggregateMaximumBitRateDL',
        'id-extended-uEaggregateMaximumBitRateUL',
        'id-NRrestrictioninEPSasSecondaryRAT',
        'id-UEAppLayerMeasConfig',
        'id-UE-Application-Layer-Measurement-Capability',
        'id-SecondaryRATDataUsageReportList',
        'id-SecondaryRATDataUsageReportItem',
        'id-HandoverFlag',
        'id-E-RABUsageReportItem',
        'id-SecondaryRATDataUsageRequest',
        'id-NRUESecurityCapabilities',
        'id-UnlicensedSpectrumRestriction',
        'id-CE-ModeBRestricted',
        'id-LTE-M-Indication',
        'id-DownlinkPacketLossRate',
        'id-UplinkPacketLossRate',
        'id-UECapabilityInfoRequest',
        'id-serviceType',
        'id-AerialUEsubscriptionInformation',
        'id-Subscription-Based-UE-DifferentiationInfo',
        'id-EndIndication',
        'id-EDT-Session',
        'id-CNTypeRestrictions',
        'id-PendingDataIndication',
        'id-BluetoothMeasurementConfiguration',
        'id-WLANMeasurementConfiguration',
        'id-WarningAreaCoordinates',
        'id-NRrestrictionin5GS',
        'id-PSCellInformation',
        'id-LastNG-RANPLMNIdentity',
        'id-ConnectedengNBList',
        'id-ConnectedengNBToAddList',
        'id-ConnectedengNBToRemoveList',
        'id-EN-DCSONConfigurationTransfer-ECT',
        'id-EN-DCSONConfigurationTransfer-MCT',
        'id-IMSvoiceEPSfallbackfrom5G',
        'id-TimeSinceSecondaryNodeRelease',
        'id-RequestTypeAdditionalInfo',
        'id-AdditionalRRMPriorityIndex',
        'id-ContextatSource',
        'id-IAB-Authorized',
        'id-IAB-Node-Indication',
        'id-IAB-Supported',
        'id-DataSize',
        'id-Ethernet-Type',
        'id-NRV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-PC5QoSParameters',
        'id-IntersystemSONConfigurationTransferMCT',
        'id-IntersystemSONConfigurationTransferECT',
        'id-IntersystemMeasurementConfiguration',
        'id-SourceNodeID',
        'id-NB-IoT-RLF-Report-Container',
        'id-UERadioCapabilityID',
        'id-UERadioCapability-NR-Format',
        'id-MDTConfigurationNR',
        'id-DAPSRequestInfo',
        'id-DAPSResponseInfoList',
        'id-DAPSResponseInfoItem',
        'id-NotifySourceeNB',
        'id-eNB-EarlyStatusTransfer-TransparentContainer',
        'id-Bearers-SubjectToEarlyStatusTransfer-Item',
        'id-WUS-Assistance-Information',
        'id-NB-IoT-PagingDRX',
        'id-TraceCollectionEntityURI',
        'id-EmergencyIndicator',
        'id-UERadioCapabilityForPaging-NR-Format',
        'id-SourceTransportLayerAddress',
        'id-lastVisitedPSCellList',
        'id-RACSIndication',
        'id-PagingCause',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-E-RABSecurityResultItem',
        'id-E-RABSecurityResultList',
        'id-RAT-Restrictions',
        'id-UEContextReferenceatSourceeNB',
        'id-LTE-NTN-TAI-Information',
        'id-SourceNodeTransportLayerAddress',
        'id-E-RABToBeUpdatedList',
        'id-E-RABToBeUpdatedItem',
        'id-SourceSNID',
        'id-LoggedMDTTrigger',
        'id-SensorMeasurementConfiguration',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-HandoverPreparation',
        'id-HandoverResourceAllocation',
        'id-HandoverNotification',
        'id-PathSwitchRequest',
        'id-HandoverCancel',
        'id-E-RABSetup',
        'id-E-RABModify',
        'id-E-RABRelease',
        'id-E-RABReleaseIndication',
        'id-InitialContextSetup',
        'id-Paging',
        'id-downlinkNASTransport',
        'id-initialUEMessage',
        'id-uplinkNASTransport',
        'id-Reset',
        'id-ErrorIndication',
        'id-NASNonDeliveryIndication',
        'id-S1Setup',
        'id-UEContextReleaseRequest',
        'id-DownlinkS1cdma2000tunnelling',
        'id-UplinkS1cdma2000tunnelling',
        'id-UEContextModification',
        'id-UECapabilityInfoIndication',
        'id-UEContextRelease',
        'id-eNBStatusTransfer',
        'id-MMEStatusTransfer',
        'id-DeactivateTrace',
        'id-TraceStart',
        'id-TraceFailureIndication',
        'id-ENBConfigurationUpdate',
        'id-MMEConfigurationUpdate',
        'id-LocationReportingControl',
        'id-LocationReportingFailureIndication',
        'id-LocationReport',
        'id-OverloadStart',
        'id-OverloadStop',
        'id-WriteReplaceWarning',
        'id-eNBDirectInformationTransfer',
        'id-MMEDirectInformationTransfer',
        'id-PrivateMessage',
        'id-eNBConfigurationTransfer',
        'id-MMEConfigurationTransfer',
        'id-CellTrafficTrace',
        'id-Kill',
        'id-downlinkUEAssociatedLPPaTransport',
        'id-uplinkUEAssociatedLPPaTransport',
        'id-downlinkNonUEAssociatedLPPaTransport',
        'id-uplinkNonUEAssociatedLPPaTransport',
        'id-UERadioCapabilityMatch',
        'id-PWSRestartIndication',
        'id-E-RABModificationIndication',
        'id-PWSFailureIndication',
        'id-RerouteNASRequest',
        'id-UEContextModificationIndication',
        'id-ConnectionEstablishmentIndication',
        'id-UEContextSuspend',
        'id-UEContextResume',
        'id-NASDeliveryIndication',
        'id-RetrieveUEInformation',
        'id-UEInformationTransfer',
        'id-eNBCPRelocationIndication',
        'id-MMECPRelocationIndication',
        'id-SecondaryRATDataUsageReport',
        'id-UERadioCapabilityIDMapping',
        'id-HandoverSuccess',
        'id-eNBEarlyStatusTransfer',
        'id-MMEEarlyStatusTransfer',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxnoofCSGs',
        'maxnoofE-RABs',
        'maxnoofTAIs',
        'maxnoofTACs',
        'maxnoofErrors',
        'maxnoofBPLMNs',
        'maxnoofPLMNsPerMME',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofForbLACs',
        'maxnoofForbTACs',
        'maxnoofIndividualS1ConnectionsToReset',
        'maxnoofCellsinUEHistoryInfo',
        'maxnoofCellsineNB',
        'maxnoofTAIforWarning',
        'maxnoofCellID',
        'maxnoofDCNs',
        'maxnoofEmergencyAreaID',
        'maxnoofCellinTAI',
        'maxnoofCellinEAI',
        'maxnoofeNBX2TLAs',
        'maxnoofeNBX2ExtTLAs',
        'maxnoofeNBX2GTPTLAs',
        'maxnoofRATs',
        'maxnoofGroupIDs',
        'maxnoofMMECs',
        'maxnoofCellIDforMDT',
        'maxnoofTAforMDT',
        'maxnoofMDTPLMNs',
        'maxnoofCellsforRestart',
        'maxnoofRestartTAIs',
        'maxnoofRestartEmergencyAreaIDs',
        'maxEARFCN',
        'maxnoofMBSFNAreaMDT',
        'maxnoofRecommendedCells',
        'maxnoofRecommendedENBs',
        'maxnooftimeperiods',
        'maxnoofCellIDforQMC',
        'maxnoofTAforQMC',
        'maxnoofPLMNforQMC',
        'maxnoofBluetoothName',
        'maxnoofWLANName',
        'maxnoofConnectedengNBs',
        'maxnoofPC5QoSFlows',
        'maxnooffrequencies',
        'maxNARFCN',
        'maxRS-IndexCellQual',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofTACsInNTN',
        'maxnoofSensorName',
        'id-MME-UE-S1AP-ID',
        'id-HandoverType',
        'id-Cause',
        'id-SourceID',
        'id-TargetID',
        'id-eNB-UE-S1AP-ID',
        'id-E-RABSubjecttoDataForwardingList',
        'id-E-RABtoReleaseListHOCmd',
        'id-E-RABDataForwardingItem',
        'id-E-RABReleaseItemBearerRelComp',
        'id-E-RABToBeSetupListBearerSUReq',
        'id-E-RABToBeSetupItemBearerSUReq',
        'id-E-RABAdmittedList',
        'id-E-RABFailedToSetupListHOReqAck',
        'id-E-RABAdmittedItem',
        'id-E-RABFailedtoSetupItemHOReqAck',
        'id-E-RABToBeSwitchedDLList',
        'id-E-RABToBeSwitchedDLItem',
        'id-E-RABToBeSetupListCtxtSUReq',
        'id-TraceActivation',
        'id-NAS-PDU',
        'id-E-RABToBeSetupItemHOReq',
        'id-E-RABSetupListBearerSURes',
        'id-E-RABFailedToSetupListBearerSURes',
        'id-E-RABToBeModifiedListBearerModReq',
        'id-E-RABModifyListBearerModRes',
        'id-E-RABFailedToModifyList',
        'id-E-RABToBeReleasedList',
        'id-E-RABFailedToReleaseList',
        'id-E-RABItem',
        'id-E-RABToBeModifiedItemBearerModReq',
        'id-E-RABModifyItemBearerModRes',
        'id-E-RABReleaseItem',
        'id-E-RABSetupItemBearerSURes',
        'id-SecurityContext',
        'id-HandoverRestrictionList',
        'id-UEPagingID',
        'id-pagingDRX',
        'id-TAIList',
        'id-TAIItem',
        'id-E-RABFailedToSetupListCtxtSURes',
        'id-E-RABReleaseItemHOCmd',
        'id-E-RABSetupItemCtxtSURes',
        'id-E-RABSetupListCtxtSURes',
        'id-E-RABToBeSetupItemCtxtSUReq',
        'id-E-RABToBeSetupListHOReq',
        'id-GERANtoLTEHOInformationRes',
        'id-UTRANtoLTEHOInformationRes',
        'id-CriticalityDiagnostics',
        'id-Global-ENB-ID',
        'id-eNBname',
        'id-MMEname',
        'id-ServedPLMNs',
        'id-SupportedTAs',
        'id-TimeToWait',
        'id-uEaggregateMaximumBitrate',
        'id-TAI',
        'id-E-RABReleaseListBearerRelComp',
        'id-cdma2000PDU',
        'id-cdma2000RATType',
        'id-cdma2000SectorID',
        'id-SecurityKey',
        'id-UERadioCapability',
        'id-GUMMEI-ID',
        'id-E-RABInformationListItem',
        'id-Direct-Forwarding-Path-Availability',
        'id-UEIdentityIndexValue',
        'id-cdma2000HOStatus',
        'id-cdma2000HORequiredIndication',
        'id-E-UTRAN-Trace-ID',
        'id-RelativeMMECapacity',
        'id-SourceMME-UE-S1AP-ID',
        'id-Bearers-SubjectToStatusTransfer-Item',
        'id-eNB-StatusTransfer-TransparentContainer',
        'id-UE-associatedLogicalS1-ConnectionItem',
        'id-ResetType',
        'id-UE-associatedLogicalS1-ConnectionListResAck',
        'id-E-RABToBeSwitchedULItem',
        'id-E-RABToBeSwitchedULList',
        'id-S-TMSI',
        'id-cdma2000OneXRAND',
        'id-RequestType',
        'id-UE-S1AP-IDs',
        'id-EUTRAN-CGI',
        'id-OverloadResponse',
        'id-cdma2000OneXSRVCCInfo',
        'id-E-RABFailedToBeReleasedList',
        'id-Source-ToTarget-TransparentContainer',
        'id-ServedGUMMEIs',
        'id-SubscriberProfileIDforRFP',
        'id-UESecurityCapabilities',
        'id-CSFallbackIndicator',
        'id-CNDomain',
        'id-E-RABReleasedList',
        'id-MessageIdentifier',
        'id-SerialNumber',
        'id-WarningAreaList',
        'id-RepetitionPeriod',
        'id-NumberofBroadcastRequest',
        'id-WarningType',
        'id-WarningSecurityInfo',
        'id-DataCodingScheme',
        'id-WarningMessageContents',
        'id-BroadcastCompletedAreaList',
        'id-Inter-SystemInformationTransferTypeEDT',
        'id-Inter-SystemInformationTransferTypeMDT',
        'id-Target-ToSource-TransparentContainer',
        'id-SRVCCOperationPossible',
        'id-SRVCCHOIndication',
        'id-NAS-DownlinkCount',
        'id-CSG-Id',
        'id-CSG-IdList',
        'id-SONConfigurationTransferECT',
        'id-SONConfigurationTransferMCT',
        'id-TraceCollectionEntityIPAddress',
        'id-MSClassmark2',
        'id-MSClassmark3',
        'id-RRC-Establishment-Cause',
        'id-NASSecurityParametersfromE-UTRAN',
        'id-NASSecurityParameterstoE-UTRAN',
        'id-DefaultPagingDRX',
        'id-Source-ToTarget-TransparentContainer-Secondary',
        'id-Target-ToSource-TransparentContainer-Secondary',
        'id-EUTRANRoundTripDelayEstimationInfo',
        'id-BroadcastCancelledAreaList',
        'id-ConcurrentWarningMessageIndicator',
        'id-Data-Forwarding-Not-Possible',
        'id-ExtendedRepetitionPeriod',
        'id-CellAccessMode',
        'id-CSGMembershipStatus',
        'id-LPPa-PDU',
        'id-Routing-ID',
        'id-Time-Synchronisation-Info',
        'id-PS-ServiceNotAvailable',
        'id-PagingPriority',
        'id-x2TNLConfigurationInfo',
        'id-eNBX2ExtendedTransportLayerAddresses',
        'id-GUMMEIList',
        'id-GW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-SourceMME-GUMMEI',
        'id-MME-UE-S1AP-ID-2',
        'id-RegisteredLAI',
        'id-RelayNode-Indicator',
        'id-TrafficLoadReductionIndication',
        'id-MDTConfiguration',
        'id-MMERelaySupportIndicator',
        'id-GWContextReleaseIndication',
        'id-ManagementBasedMDTAllowed',
        'id-PrivacyIndicator',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-HO-Cause',
        'id-VoiceSupportMatchIndicator',
        'id-GUMMEIType',
        'id-M3Configuration',
        'id-M4Configuration',
        'id-M5Configuration',
        'id-MDT-Location-Info',
        'id-MobilityInformation',
        'id-Tunnel-Information-for-BBF',
        'id-ManagementBasedMDTPLMNList',
        'id-SignallingBasedMDTPLMNList',
        'id-ULCOUNTValueExtended',
        'id-DLCOUNTValueExtended',
        'id-ReceiveStatusOfULPDCPSDUsExtended',
        'id-ECGIListForRestart',
        'id-SIPTO-Correlation-ID',
        'id-SIPTO-L-GW-TransportLayerAddress',
        'id-TransportInformation',
        'id-LHN-ID',
        'id-AdditionalCSFallbackIndicator',
        'id-TAIListForRestart',
        'id-UserLocationInformation',
        'id-EmergencyAreaIDListForRestart',
        'id-KillAllWarningMessages',
        'id-Masked-IMEISV',
        'id-eNBIndirectX2TransportLayerAddresses',
        'id-uE-HistoryInformationFromTheUE',
        'id-ProSeAuthorized',
        'id-ExpectedUEBehaviour',
        'id-LoggedMBSFNMDT',
        'id-UERadioCapabilityForPaging',
        'id-E-RABToBeModifiedListBearerModInd',
        'id-E-RABToBeModifiedItemBearerModInd',
        'id-E-RABNotToBeModifiedListBearerModInd',
        'id-E-RABNotToBeModifiedItemBearerModInd',
        'id-E-RABModifyListBearerModConf',
        'id-E-RABModifyItemBearerModConf',
        'id-E-RABFailedToModifyListBearerModConf',
        'id-SON-Information-Report',
        'id-Muting-Availability-Indication',
        'id-Muting-Pattern-Information',
        'id-Synchronisation-Information',
        'id-E-RABToBeReleasedListBearerModConf',
        'id-AssistanceDataForPaging',
        'id-CellIdentifierAndCELevelForCECapableUEs',
        'id-InformationOnRecommendedCellsAndENBsForPaging',
        'id-RecommendedCellItem',
        'id-RecommendedENBItem',
        'id-ProSeUEtoNetworkRelaying',
        'id-ULCOUNTValuePDCP-SNlength18',
        'id-DLCOUNTValuePDCP-SNlength18',
        'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'id-M6Configuration',
        'id-M7Configuration',
        'id-PWSfailedECGIList',
        'id-MME-Group-ID',
        'id-Additional-GUTI',
        'id-S1-Message',
        'id-CSGMembershipInfo',
        'id-Paging-eDRXInformation',
        'id-UE-RetentionInformation',
        'id-UE-Usage-Type',
        'id-extended-UEIdentityIndexValue',
        'id-RAT-Type',
        'id-BearerType',
        'id-NB-IoT-DefaultPagingDRX',
        'id-E-RABFailedToResumeListResumeReq',
        'id-E-RABFailedToResumeItemResumeReq',
        'id-E-RABFailedToResumeListResumeRes',
        'id-E-RABFailedToResumeItemResumeRes',
        'id-NB-IoT-Paging-eDRXInformation',
        'id-V2XServicesAuthorized',
        'id-UEUserPlaneCIoTSupportIndicator',
        'id-CE-mode-B-SupportIndicator',
        'id-SRVCCOperationNotPossible',
        'id-NB-IoT-UEIdentityIndexValue',
        'id-RRC-Resume-Cause',
        'id-DCN-ID',
        'id-ServedDCNs',
        'id-UESidelinkAggregateMaximumBitrate',
        'id-DLNASPDUDeliveryAckRequest',
        'id-Coverage-Level',
        'id-EnhancedCoverageRestricted',
        'id-UE-Level-QoS-Parameters',
        'id-DL-CP-SecurityInformation',
        'id-UL-CP-SecurityInformation',
        'id-extended-e-RAB-MaximumBitrateDL',
        'id-extended-e-RAB-MaximumBitrateUL',
        'id-extended-e-RAB-GuaranteedBitrateDL',
        'id-extended-e-RAB-GuaranteedBitrateUL',
        'id-extended-uEaggregateMaximumBitRateDL',
        'id-extended-uEaggregateMaximumBitRateUL',
        'id-NRrestrictioninEPSasSecondaryRAT',
        'id-UEAppLayerMeasConfig',
        'id-UE-Application-Layer-Measurement-Capability',
        'id-SecondaryRATDataUsageReportList',
        'id-SecondaryRATDataUsageReportItem',
        'id-HandoverFlag',
        'id-E-RABUsageReportItem',
        'id-SecondaryRATDataUsageRequest',
        'id-NRUESecurityCapabilities',
        'id-UnlicensedSpectrumRestriction',
        'id-CE-ModeBRestricted',
        'id-LTE-M-Indication',
        'id-DownlinkPacketLossRate',
        'id-UplinkPacketLossRate',
        'id-UECapabilityInfoRequest',
        'id-serviceType',
        'id-AerialUEsubscriptionInformation',
        'id-Subscription-Based-UE-DifferentiationInfo',
        'id-EndIndication',
        'id-EDT-Session',
        'id-CNTypeRestrictions',
        'id-PendingDataIndication',
        'id-BluetoothMeasurementConfiguration',
        'id-WLANMeasurementConfiguration',
        'id-WarningAreaCoordinates',
        'id-NRrestrictionin5GS',
        'id-PSCellInformation',
        'id-LastNG-RANPLMNIdentity',
        'id-ConnectedengNBList',
        'id-ConnectedengNBToAddList',
        'id-ConnectedengNBToRemoveList',
        'id-EN-DCSONConfigurationTransfer-ECT',
        'id-EN-DCSONConfigurationTransfer-MCT',
        'id-IMSvoiceEPSfallbackfrom5G',
        'id-TimeSinceSecondaryNodeRelease',
        'id-RequestTypeAdditionalInfo',
        'id-AdditionalRRMPriorityIndex',
        'id-ContextatSource',
        'id-IAB-Authorized',
        'id-IAB-Node-Indication',
        'id-IAB-Supported',
        'id-DataSize',
        'id-Ethernet-Type',
        'id-NRV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-PC5QoSParameters',
        'id-IntersystemSONConfigurationTransferMCT',
        'id-IntersystemSONConfigurationTransferECT',
        'id-IntersystemMeasurementConfiguration',
        'id-SourceNodeID',
        'id-NB-IoT-RLF-Report-Container',
        'id-UERadioCapabilityID',
        'id-UERadioCapability-NR-Format',
        'id-MDTConfigurationNR',
        'id-DAPSRequestInfo',
        'id-DAPSResponseInfoList',
        'id-DAPSResponseInfoItem',
        'id-NotifySourceeNB',
        'id-eNB-EarlyStatusTransfer-TransparentContainer',
        'id-Bearers-SubjectToEarlyStatusTransfer-Item',
        'id-WUS-Assistance-Information',
        'id-NB-IoT-PagingDRX',
        'id-TraceCollectionEntityURI',
        'id-EmergencyIndicator',
        'id-UERadioCapabilityForPaging-NR-Format',
        'id-SourceTransportLayerAddress',
        'id-lastVisitedPSCellList',
        'id-RACSIndication',
        'id-PagingCause',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-E-RABSecurityResultItem',
        'id-E-RABSecurityResultList',
        'id-RAT-Restrictions',
        'id-UEContextReferenceatSourceeNB',
        'id-LTE-NTN-TAI-Information',
        'id-SourceNodeTransportLayerAddress',
        'id-E-RABToBeUpdatedList',
        'id-E-RABToBeUpdatedItem',
        'id-SourceSNID',
        'id-LoggedMDTTrigger',
        'id-SensorMeasurementConfiguration',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-HandoverPreparation >-----#
    id_HandoverPreparation = INT(name='id-HandoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverPreparation._val = 0
    
    #-----< id-HandoverResourceAllocation >-----#
    id_HandoverResourceAllocation = INT(name='id-HandoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverResourceAllocation._val = 1
    
    #-----< id-HandoverNotification >-----#
    id_HandoverNotification = INT(name='id-HandoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverNotification._val = 2
    
    #-----< id-PathSwitchRequest >-----#
    id_PathSwitchRequest = INT(name='id-PathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PathSwitchRequest._val = 3
    
    #-----< id-HandoverCancel >-----#
    id_HandoverCancel = INT(name='id-HandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverCancel._val = 4
    
    #-----< id-E-RABSetup >-----#
    id_E_RABSetup = INT(name='id-E-RABSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABSetup._val = 5
    
    #-----< id-E-RABModify >-----#
    id_E_RABModify = INT(name='id-E-RABModify', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABModify._val = 6
    
    #-----< id-E-RABRelease >-----#
    id_E_RABRelease = INT(name='id-E-RABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABRelease._val = 7
    
    #-----< id-E-RABReleaseIndication >-----#
    id_E_RABReleaseIndication = INT(name='id-E-RABReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABReleaseIndication._val = 8
    
    #-----< id-InitialContextSetup >-----#
    id_InitialContextSetup = INT(name='id-InitialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_InitialContextSetup._val = 9
    
    #-----< id-Paging >-----#
    id_Paging = INT(name='id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 10
    
    #-----< id-downlinkNASTransport >-----#
    id_downlinkNASTransport = INT(name='id-downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkNASTransport._val = 11
    
    #-----< id-initialUEMessage >-----#
    id_initialUEMessage = INT(name='id-initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_initialUEMessage._val = 12
    
    #-----< id-uplinkNASTransport >-----#
    id_uplinkNASTransport = INT(name='id-uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkNASTransport._val = 13
    
    #-----< id-Reset >-----#
    id_Reset = INT(name='id-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Reset._val = 14
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 15
    
    #-----< id-NASNonDeliveryIndication >-----#
    id_NASNonDeliveryIndication = INT(name='id-NASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_NASNonDeliveryIndication._val = 16
    
    #-----< id-S1Setup >-----#
    id_S1Setup = INT(name='id-S1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_S1Setup._val = 17
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name='id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 18
    
    #-----< id-DownlinkS1cdma2000tunnelling >-----#
    id_DownlinkS1cdma2000tunnelling = INT(name='id-DownlinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkS1cdma2000tunnelling._val = 19
    
    #-----< id-UplinkS1cdma2000tunnelling >-----#
    id_UplinkS1cdma2000tunnelling = INT(name='id-UplinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkS1cdma2000tunnelling._val = 20
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name='id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 21
    
    #-----< id-UECapabilityInfoIndication >-----#
    id_UECapabilityInfoIndication = INT(name='id-UECapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UECapabilityInfoIndication._val = 22
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name='id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 23
    
    #-----< id-eNBStatusTransfer >-----#
    id_eNBStatusTransfer = INT(name='id-eNBStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBStatusTransfer._val = 24
    
    #-----< id-MMEStatusTransfer >-----#
    id_MMEStatusTransfer = INT(name='id-MMEStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEStatusTransfer._val = 25
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name='id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 26
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name='id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 27
    
    #-----< id-TraceFailureIndication >-----#
    id_TraceFailureIndication = INT(name='id-TraceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceFailureIndication._val = 28
    
    #-----< id-ENBConfigurationUpdate >-----#
    id_ENBConfigurationUpdate = INT(name='id-ENBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ENBConfigurationUpdate._val = 29
    
    #-----< id-MMEConfigurationUpdate >-----#
    id_MMEConfigurationUpdate = INT(name='id-MMEConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEConfigurationUpdate._val = 30
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name='id-LocationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingControl._val = 31
    
    #-----< id-LocationReportingFailureIndication >-----#
    id_LocationReportingFailureIndication = INT(name='id-LocationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingFailureIndication._val = 32
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name='id-LocationReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReport._val = 33
    
    #-----< id-OverloadStart >-----#
    id_OverloadStart = INT(name='id-OverloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStart._val = 34
    
    #-----< id-OverloadStop >-----#
    id_OverloadStop = INT(name='id-OverloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStop._val = 35
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name='id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 36
    
    #-----< id-eNBDirectInformationTransfer >-----#
    id_eNBDirectInformationTransfer = INT(name='id-eNBDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBDirectInformationTransfer._val = 37
    
    #-----< id-MMEDirectInformationTransfer >-----#
    id_MMEDirectInformationTransfer = INT(name='id-MMEDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEDirectInformationTransfer._val = 38
    
    #-----< id-PrivateMessage >-----#
    id_PrivateMessage = INT(name='id-PrivateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PrivateMessage._val = 39
    
    #-----< id-eNBConfigurationTransfer >-----#
    id_eNBConfigurationTransfer = INT(name='id-eNBConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBConfigurationTransfer._val = 40
    
    #-----< id-MMEConfigurationTransfer >-----#
    id_MMEConfigurationTransfer = INT(name='id-MMEConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEConfigurationTransfer._val = 41
    
    #-----< id-CellTrafficTrace >-----#
    id_CellTrafficTrace = INT(name='id-CellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_CellTrafficTrace._val = 42
    
    #-----< id-Kill >-----#
    id_Kill = INT(name='id-Kill', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Kill._val = 43
    
    #-----< id-downlinkUEAssociatedLPPaTransport >-----#
    id_downlinkUEAssociatedLPPaTransport = INT(name='id-downlinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkUEAssociatedLPPaTransport._val = 44
    
    #-----< id-uplinkUEAssociatedLPPaTransport >-----#
    id_uplinkUEAssociatedLPPaTransport = INT(name='id-uplinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkUEAssociatedLPPaTransport._val = 45
    
    #-----< id-downlinkNonUEAssociatedLPPaTransport >-----#
    id_downlinkNonUEAssociatedLPPaTransport = INT(name='id-downlinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkNonUEAssociatedLPPaTransport._val = 46
    
    #-----< id-uplinkNonUEAssociatedLPPaTransport >-----#
    id_uplinkNonUEAssociatedLPPaTransport = INT(name='id-uplinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkNonUEAssociatedLPPaTransport._val = 47
    
    #-----< id-UERadioCapabilityMatch >-----#
    id_UERadioCapabilityMatch = INT(name='id-UERadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityMatch._val = 48
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name='id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 49
    
    #-----< id-E-RABModificationIndication >-----#
    id_E_RABModificationIndication = INT(name='id-E-RABModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABModificationIndication._val = 50
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name='id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 51
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name='id-RerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_RerouteNASRequest._val = 52
    
    #-----< id-UEContextModificationIndication >-----#
    id_UEContextModificationIndication = INT(name='id-UEContextModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModificationIndication._val = 53
    
    #-----< id-ConnectionEstablishmentIndication >-----#
    id_ConnectionEstablishmentIndication = INT(name='id-ConnectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionEstablishmentIndication._val = 54
    
    #-----< id-UEContextSuspend >-----#
    id_UEContextSuspend = INT(name='id-UEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSuspend._val = 55
    
    #-----< id-UEContextResume >-----#
    id_UEContextResume = INT(name='id-UEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextResume._val = 56
    
    #-----< id-NASDeliveryIndication >-----#
    id_NASDeliveryIndication = INT(name='id-NASDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_NASDeliveryIndication._val = 57
    
    #-----< id-RetrieveUEInformation >-----#
    id_RetrieveUEInformation = INT(name='id-RetrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_RetrieveUEInformation._val = 58
    
    #-----< id-UEInformationTransfer >-----#
    id_UEInformationTransfer = INT(name='id-UEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEInformationTransfer._val = 59
    
    #-----< id-eNBCPRelocationIndication >-----#
    id_eNBCPRelocationIndication = INT(name='id-eNBCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBCPRelocationIndication._val = 60
    
    #-----< id-MMECPRelocationIndication >-----#
    id_MMECPRelocationIndication = INT(name='id-MMECPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMECPRelocationIndication._val = 61
    
    #-----< id-SecondaryRATDataUsageReport >-----#
    id_SecondaryRATDataUsageReport = INT(name='id-SecondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_SecondaryRATDataUsageReport._val = 62
    
    #-----< id-UERadioCapabilityIDMapping >-----#
    id_UERadioCapabilityIDMapping = INT(name='id-UERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityIDMapping._val = 63
    
    #-----< id-HandoverSuccess >-----#
    id_HandoverSuccess = INT(name='id-HandoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverSuccess._val = 64
    
    #-----< id-eNBEarlyStatusTransfer >-----#
    id_eNBEarlyStatusTransfer = INT(name='id-eNBEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBEarlyStatusTransfer._val = 65
    
    #-----< id-MMEEarlyStatusTransfer >-----#
    id_MMEEarlyStatusTransfer = INT(name='id-MMEEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEEarlyStatusTransfer._val = 66
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofCSGs >-----#
    maxnoofCSGs = INT(name='maxnoofCSGs', mode=MODE_VALUE)
    maxnoofCSGs._val = 256
    
    #-----< maxnoofE-RABs >-----#
    maxnoofE_RABs = INT(name='maxnoofE-RABs', mode=MODE_VALUE)
    maxnoofE_RABs._val = 256
    
    #-----< maxnoofTAIs >-----#
    maxnoofTAIs = INT(name='maxnoofTAIs', mode=MODE_VALUE)
    maxnoofTAIs._val = 256
    
    #-----< maxnoofTACs >-----#
    maxnoofTACs = INT(name='maxnoofTACs', mode=MODE_VALUE)
    maxnoofTACs._val = 256
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name='maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name='maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofPLMNsPerMME >-----#
    maxnoofPLMNsPerMME = INT(name='maxnoofPLMNsPerMME', mode=MODE_VALUE)
    maxnoofPLMNsPerMME._val = 32
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name='maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name='maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofForbLACs >-----#
    maxnoofForbLACs = INT(name='maxnoofForbLACs', mode=MODE_VALUE)
    maxnoofForbLACs._val = 4096
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name='maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofIndividualS1ConnectionsToReset >-----#
    maxnoofIndividualS1ConnectionsToReset = INT(name='maxnoofIndividualS1ConnectionsToReset', mode=MODE_VALUE)
    maxnoofIndividualS1ConnectionsToReset._val = 256
    
    #-----< maxnoofCellsinUEHistoryInfo >-----#
    maxnoofCellsinUEHistoryInfo = INT(name='maxnoofCellsinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofCellsinUEHistoryInfo._val = 16
    
    #-----< maxnoofCellsineNB >-----#
    maxnoofCellsineNB = INT(name='maxnoofCellsineNB', mode=MODE_VALUE)
    maxnoofCellsineNB._val = 256
    
    #-----< maxnoofTAIforWarning >-----#
    maxnoofTAIforWarning = INT(name='maxnoofTAIforWarning', mode=MODE_VALUE)
    maxnoofTAIforWarning._val = 65535
    
    #-----< maxnoofCellID >-----#
    maxnoofCellID = INT(name='maxnoofCellID', mode=MODE_VALUE)
    maxnoofCellID._val = 65535
    
    #-----< maxnoofDCNs >-----#
    maxnoofDCNs = INT(name='maxnoofDCNs', mode=MODE_VALUE)
    maxnoofDCNs._val = 32
    
    #-----< maxnoofEmergencyAreaID >-----#
    maxnoofEmergencyAreaID = INT(name='maxnoofEmergencyAreaID', mode=MODE_VALUE)
    maxnoofEmergencyAreaID._val = 65535
    
    #-----< maxnoofCellinTAI >-----#
    maxnoofCellinTAI = INT(name='maxnoofCellinTAI', mode=MODE_VALUE)
    maxnoofCellinTAI._val = 65535
    
    #-----< maxnoofCellinEAI >-----#
    maxnoofCellinEAI = INT(name='maxnoofCellinEAI', mode=MODE_VALUE)
    maxnoofCellinEAI._val = 65535
    
    #-----< maxnoofeNBX2TLAs >-----#
    maxnoofeNBX2TLAs = INT(name='maxnoofeNBX2TLAs', mode=MODE_VALUE)
    maxnoofeNBX2TLAs._val = 2
    
    #-----< maxnoofeNBX2ExtTLAs >-----#
    maxnoofeNBX2ExtTLAs = INT(name='maxnoofeNBX2ExtTLAs', mode=MODE_VALUE)
    maxnoofeNBX2ExtTLAs._val = 16
    
    #-----< maxnoofeNBX2GTPTLAs >-----#
    maxnoofeNBX2GTPTLAs = INT(name='maxnoofeNBX2GTPTLAs', mode=MODE_VALUE)
    maxnoofeNBX2GTPTLAs._val = 16
    
    #-----< maxnoofRATs >-----#
    maxnoofRATs = INT(name='maxnoofRATs', mode=MODE_VALUE)
    maxnoofRATs._val = 8
    
    #-----< maxnoofGroupIDs >-----#
    maxnoofGroupIDs = INT(name='maxnoofGroupIDs', mode=MODE_VALUE)
    maxnoofGroupIDs._val = 65535
    
    #-----< maxnoofMMECs >-----#
    maxnoofMMECs = INT(name='maxnoofMMECs', mode=MODE_VALUE)
    maxnoofMMECs._val = 256
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name='maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name='maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCellsforRestart >-----#
    maxnoofCellsforRestart = INT(name='maxnoofCellsforRestart', mode=MODE_VALUE)
    maxnoofCellsforRestart._val = 256
    
    #-----< maxnoofRestartTAIs >-----#
    maxnoofRestartTAIs = INT(name='maxnoofRestartTAIs', mode=MODE_VALUE)
    maxnoofRestartTAIs._val = 2048
    
    #-----< maxnoofRestartEmergencyAreaIDs >-----#
    maxnoofRestartEmergencyAreaIDs = INT(name='maxnoofRestartEmergencyAreaIDs', mode=MODE_VALUE)
    maxnoofRestartEmergencyAreaIDs._val = 256
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name='maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 262143
    
    #-----< maxnoofMBSFNAreaMDT >-----#
    maxnoofMBSFNAreaMDT = INT(name='maxnoofMBSFNAreaMDT', mode=MODE_VALUE)
    maxnoofMBSFNAreaMDT._val = 8
    
    #-----< maxnoofRecommendedCells >-----#
    maxnoofRecommendedCells = INT(name='maxnoofRecommendedCells', mode=MODE_VALUE)
    maxnoofRecommendedCells._val = 16
    
    #-----< maxnoofRecommendedENBs >-----#
    maxnoofRecommendedENBs = INT(name='maxnoofRecommendedENBs', mode=MODE_VALUE)
    maxnoofRecommendedENBs._val = 16
    
    #-----< maxnooftimeperiods >-----#
    maxnooftimeperiods = INT(name='maxnooftimeperiods', mode=MODE_VALUE)
    maxnooftimeperiods._val = 2
    
    #-----< maxnoofCellIDforQMC >-----#
    maxnoofCellIDforQMC = INT(name='maxnoofCellIDforQMC', mode=MODE_VALUE)
    maxnoofCellIDforQMC._val = 32
    
    #-----< maxnoofTAforQMC >-----#
    maxnoofTAforQMC = INT(name='maxnoofTAforQMC', mode=MODE_VALUE)
    maxnoofTAforQMC._val = 8
    
    #-----< maxnoofPLMNforQMC >-----#
    maxnoofPLMNforQMC = INT(name='maxnoofPLMNforQMC', mode=MODE_VALUE)
    maxnoofPLMNforQMC._val = 16
    
    #-----< maxnoofBluetoothName >-----#
    maxnoofBluetoothName = INT(name='maxnoofBluetoothName', mode=MODE_VALUE)
    maxnoofBluetoothName._val = 4
    
    #-----< maxnoofWLANName >-----#
    maxnoofWLANName = INT(name='maxnoofWLANName', mode=MODE_VALUE)
    maxnoofWLANName._val = 4
    
    #-----< maxnoofConnectedengNBs >-----#
    maxnoofConnectedengNBs = INT(name='maxnoofConnectedengNBs', mode=MODE_VALUE)
    maxnoofConnectedengNBs._val = 256
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name='maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnooffrequencies >-----#
    maxnooffrequencies = INT(name='maxnooffrequencies', mode=MODE_VALUE)
    maxnooffrequencies._val = 64
    
    #-----< maxNARFCN >-----#
    maxNARFCN = INT(name='maxNARFCN', mode=MODE_VALUE)
    maxNARFCN._val = 3279165
    
    #-----< maxRS-IndexCellQual >-----#
    maxRS_IndexCellQual = INT(name='maxRS-IndexCellQual', mode=MODE_VALUE)
    maxRS_IndexCellQual._val = 16
    
    #-----< maxnoofPSCellsPerPrimaryCellinUEHistoryInfo >-----#
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo = INT(name='maxnoofPSCellsPerPrimaryCellinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo._val = 8
    
    #-----< maxnoofTACsInNTN >-----#
    maxnoofTACsInNTN = INT(name='maxnoofTACsInNTN', mode=MODE_VALUE)
    maxnoofTACsInNTN._val = 12
    
    #-----< maxnoofSensorName >-----#
    maxnoofSensorName = INT(name='maxnoofSensorName', mode=MODE_VALUE)
    maxnoofSensorName._val = 3
    
    #-----< id-MME-UE-S1AP-ID >-----#
    id_MME_UE_S1AP_ID = INT(name='id-MME-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_UE_S1AP_ID._val = 0
    
    #-----< id-HandoverType >-----#
    id_HandoverType = INT(name='id-HandoverType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverType._val = 1
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 2
    
    #-----< id-SourceID >-----#
    id_SourceID = INT(name='id-SourceID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceID._val = 3
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name='id-TargetID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetID._val = 4
    
    #-----< id-eNB-UE-S1AP-ID >-----#
    id_eNB_UE_S1AP_ID = INT(name='id-eNB-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_UE_S1AP_ID._val = 8
    
    #-----< id-E-RABSubjecttoDataForwardingList >-----#
    id_E_RABSubjecttoDataForwardingList = INT(name='id-E-RABSubjecttoDataForwardingList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSubjecttoDataForwardingList._val = 12
    
    #-----< id-E-RABtoReleaseListHOCmd >-----#
    id_E_RABtoReleaseListHOCmd = INT(name='id-E-RABtoReleaseListHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABtoReleaseListHOCmd._val = 13
    
    #-----< id-E-RABDataForwardingItem >-----#
    id_E_RABDataForwardingItem = INT(name='id-E-RABDataForwardingItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABDataForwardingItem._val = 14
    
    #-----< id-E-RABReleaseItemBearerRelComp >-----#
    id_E_RABReleaseItemBearerRelComp = INT(name='id-E-RABReleaseItemBearerRelComp', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItemBearerRelComp._val = 15
    
    #-----< id-E-RABToBeSetupListBearerSUReq >-----#
    id_E_RABToBeSetupListBearerSUReq = INT(name='id-E-RABToBeSetupListBearerSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListBearerSUReq._val = 16
    
    #-----< id-E-RABToBeSetupItemBearerSUReq >-----#
    id_E_RABToBeSetupItemBearerSUReq = INT(name='id-E-RABToBeSetupItemBearerSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemBearerSUReq._val = 17
    
    #-----< id-E-RABAdmittedList >-----#
    id_E_RABAdmittedList = INT(name='id-E-RABAdmittedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABAdmittedList._val = 18
    
    #-----< id-E-RABFailedToSetupListHOReqAck >-----#
    id_E_RABFailedToSetupListHOReqAck = INT(name='id-E-RABFailedToSetupListHOReqAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListHOReqAck._val = 19
    
    #-----< id-E-RABAdmittedItem >-----#
    id_E_RABAdmittedItem = INT(name='id-E-RABAdmittedItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABAdmittedItem._val = 20
    
    #-----< id-E-RABFailedtoSetupItemHOReqAck >-----#
    id_E_RABFailedtoSetupItemHOReqAck = INT(name='id-E-RABFailedtoSetupItemHOReqAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedtoSetupItemHOReqAck._val = 21
    
    #-----< id-E-RABToBeSwitchedDLList >-----#
    id_E_RABToBeSwitchedDLList = INT(name='id-E-RABToBeSwitchedDLList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedDLList._val = 22
    
    #-----< id-E-RABToBeSwitchedDLItem >-----#
    id_E_RABToBeSwitchedDLItem = INT(name='id-E-RABToBeSwitchedDLItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedDLItem._val = 23
    
    #-----< id-E-RABToBeSetupListCtxtSUReq >-----#
    id_E_RABToBeSetupListCtxtSUReq = INT(name='id-E-RABToBeSetupListCtxtSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListCtxtSUReq._val = 24
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name='id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 25
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name='id-NAS-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_PDU._val = 26
    
    #-----< id-E-RABToBeSetupItemHOReq >-----#
    id_E_RABToBeSetupItemHOReq = INT(name='id-E-RABToBeSetupItemHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemHOReq._val = 27
    
    #-----< id-E-RABSetupListBearerSURes >-----#
    id_E_RABSetupListBearerSURes = INT(name='id-E-RABSetupListBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupListBearerSURes._val = 28
    
    #-----< id-E-RABFailedToSetupListBearerSURes >-----#
    id_E_RABFailedToSetupListBearerSURes = INT(name='id-E-RABFailedToSetupListBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListBearerSURes._val = 29
    
    #-----< id-E-RABToBeModifiedListBearerModReq >-----#
    id_E_RABToBeModifiedListBearerModReq = INT(name='id-E-RABToBeModifiedListBearerModReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedListBearerModReq._val = 30
    
    #-----< id-E-RABModifyListBearerModRes >-----#
    id_E_RABModifyListBearerModRes = INT(name='id-E-RABModifyListBearerModRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyListBearerModRes._val = 31
    
    #-----< id-E-RABFailedToModifyList >-----#
    id_E_RABFailedToModifyList = INT(name='id-E-RABFailedToModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToModifyList._val = 32
    
    #-----< id-E-RABToBeReleasedList >-----#
    id_E_RABToBeReleasedList = INT(name='id-E-RABToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeReleasedList._val = 33
    
    #-----< id-E-RABFailedToReleaseList >-----#
    id_E_RABFailedToReleaseList = INT(name='id-E-RABFailedToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToReleaseList._val = 34
    
    #-----< id-E-RABItem >-----#
    id_E_RABItem = INT(name='id-E-RABItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABItem._val = 35
    
    #-----< id-E-RABToBeModifiedItemBearerModReq >-----#
    id_E_RABToBeModifiedItemBearerModReq = INT(name='id-E-RABToBeModifiedItemBearerModReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedItemBearerModReq._val = 36
    
    #-----< id-E-RABModifyItemBearerModRes >-----#
    id_E_RABModifyItemBearerModRes = INT(name='id-E-RABModifyItemBearerModRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyItemBearerModRes._val = 37
    
    #-----< id-E-RABReleaseItem >-----#
    id_E_RABReleaseItem = INT(name='id-E-RABReleaseItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItem._val = 38
    
    #-----< id-E-RABSetupItemBearerSURes >-----#
    id_E_RABSetupItemBearerSURes = INT(name='id-E-RABSetupItemBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupItemBearerSURes._val = 39
    
    #-----< id-SecurityContext >-----#
    id_SecurityContext = INT(name='id-SecurityContext', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityContext._val = 40
    
    #-----< id-HandoverRestrictionList >-----#
    id_HandoverRestrictionList = INT(name='id-HandoverRestrictionList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverRestrictionList._val = 41
    
    #-----< id-UEPagingID >-----#
    id_UEPagingID = INT(name='id-UEPagingID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPagingID._val = 43
    
    #-----< id-pagingDRX >-----#
    id_pagingDRX = INT(name='id-pagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_pagingDRX._val = 44
    
    #-----< id-TAIList >-----#
    id_TAIList = INT(name='id-TAIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIList._val = 46
    
    #-----< id-TAIItem >-----#
    id_TAIItem = INT(name='id-TAIItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIItem._val = 47
    
    #-----< id-E-RABFailedToSetupListCtxtSURes >-----#
    id_E_RABFailedToSetupListCtxtSURes = INT(name='id-E-RABFailedToSetupListCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListCtxtSURes._val = 48
    
    #-----< id-E-RABReleaseItemHOCmd >-----#
    id_E_RABReleaseItemHOCmd = INT(name='id-E-RABReleaseItemHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItemHOCmd._val = 49
    
    #-----< id-E-RABSetupItemCtxtSURes >-----#
    id_E_RABSetupItemCtxtSURes = INT(name='id-E-RABSetupItemCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupItemCtxtSURes._val = 50
    
    #-----< id-E-RABSetupListCtxtSURes >-----#
    id_E_RABSetupListCtxtSURes = INT(name='id-E-RABSetupListCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupListCtxtSURes._val = 51
    
    #-----< id-E-RABToBeSetupItemCtxtSUReq >-----#
    id_E_RABToBeSetupItemCtxtSUReq = INT(name='id-E-RABToBeSetupItemCtxtSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemCtxtSUReq._val = 52
    
    #-----< id-E-RABToBeSetupListHOReq >-----#
    id_E_RABToBeSetupListHOReq = INT(name='id-E-RABToBeSetupListHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListHOReq._val = 53
    
    #-----< id-GERANtoLTEHOInformationRes >-----#
    id_GERANtoLTEHOInformationRes = INT(name='id-GERANtoLTEHOInformationRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GERANtoLTEHOInformationRes._val = 55
    
    #-----< id-UTRANtoLTEHOInformationRes >-----#
    id_UTRANtoLTEHOInformationRes = INT(name='id-UTRANtoLTEHOInformationRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRANtoLTEHOInformationRes._val = 57
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 58
    
    #-----< id-Global-ENB-ID >-----#
    id_Global_ENB_ID = INT(name='id-Global-ENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Global_ENB_ID._val = 59
    
    #-----< id-eNBname >-----#
    id_eNBname = INT(name='id-eNBname', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBname._val = 60
    
    #-----< id-MMEname >-----#
    id_MMEname = INT(name='id-MMEname', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MMEname._val = 61
    
    #-----< id-ServedPLMNs >-----#
    id_ServedPLMNs = INT(name='id-ServedPLMNs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedPLMNs._val = 63
    
    #-----< id-SupportedTAs >-----#
    id_SupportedTAs = INT(name='id-SupportedTAs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SupportedTAs._val = 64
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 65
    
    #-----< id-uEaggregateMaximumBitrate >-----#
    id_uEaggregateMaximumBitrate = INT(name='id-uEaggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uEaggregateMaximumBitrate._val = 66
    
    #-----< id-TAI >-----#
    id_TAI = INT(name='id-TAI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAI._val = 67
    
    #-----< id-E-RABReleaseListBearerRelComp >-----#
    id_E_RABReleaseListBearerRelComp = INT(name='id-E-RABReleaseListBearerRelComp', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseListBearerRelComp._val = 69
    
    #-----< id-cdma2000PDU >-----#
    id_cdma2000PDU = INT(name='id-cdma2000PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000PDU._val = 70
    
    #-----< id-cdma2000RATType >-----#
    id_cdma2000RATType = INT(name='id-cdma2000RATType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000RATType._val = 71
    
    #-----< id-cdma2000SectorID >-----#
    id_cdma2000SectorID = INT(name='id-cdma2000SectorID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000SectorID._val = 72
    
    #-----< id-SecurityKey >-----#
    id_SecurityKey = INT(name='id-SecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityKey._val = 73
    
    #-----< id-UERadioCapability >-----#
    id_UERadioCapability = INT(name='id-UERadioCapability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability._val = 74
    
    #-----< id-GUMMEI-ID >-----#
    id_GUMMEI_ID = INT(name='id-GUMMEI-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEI_ID._val = 75
    
    #-----< id-E-RABInformationListItem >-----#
    id_E_RABInformationListItem = INT(name='id-E-RABInformationListItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABInformationListItem._val = 78
    
    #-----< id-Direct-Forwarding-Path-Availability >-----#
    id_Direct_Forwarding_Path_Availability = INT(name='id-Direct-Forwarding-Path-Availability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Direct_Forwarding_Path_Availability._val = 79
    
    #-----< id-UEIdentityIndexValue >-----#
    id_UEIdentityIndexValue = INT(name='id-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentityIndexValue._val = 80
    
    #-----< id-cdma2000HOStatus >-----#
    id_cdma2000HOStatus = INT(name='id-cdma2000HOStatus', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000HOStatus._val = 83
    
    #-----< id-cdma2000HORequiredIndication >-----#
    id_cdma2000HORequiredIndication = INT(name='id-cdma2000HORequiredIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000HORequiredIndication._val = 84
    
    #-----< id-E-UTRAN-Trace-ID >-----#
    id_E_UTRAN_Trace_ID = INT(name='id-E-UTRAN-Trace-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_UTRAN_Trace_ID._val = 86
    
    #-----< id-RelativeMMECapacity >-----#
    id_RelativeMMECapacity = INT(name='id-RelativeMMECapacity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelativeMMECapacity._val = 87
    
    #-----< id-SourceMME-UE-S1AP-ID >-----#
    id_SourceMME_UE_S1AP_ID = INT(name='id-SourceMME-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceMME_UE_S1AP_ID._val = 88
    
    #-----< id-Bearers-SubjectToStatusTransfer-Item >-----#
    id_Bearers_SubjectToStatusTransfer_Item = INT(name='id-Bearers-SubjectToStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Bearers_SubjectToStatusTransfer_Item._val = 89
    
    #-----< id-eNB-StatusTransfer-TransparentContainer >-----#
    id_eNB_StatusTransfer_TransparentContainer = INT(name='id-eNB-StatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_StatusTransfer_TransparentContainer._val = 90
    
    #-----< id-UE-associatedLogicalS1-ConnectionItem >-----#
    id_UE_associatedLogicalS1_ConnectionItem = INT(name='id-UE-associatedLogicalS1-ConnectionItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalS1_ConnectionItem._val = 91
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name='id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 92
    
    #-----< id-UE-associatedLogicalS1-ConnectionListResAck >-----#
    id_UE_associatedLogicalS1_ConnectionListResAck = INT(name='id-UE-associatedLogicalS1-ConnectionListResAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalS1_ConnectionListResAck._val = 93
    
    #-----< id-E-RABToBeSwitchedULItem >-----#
    id_E_RABToBeSwitchedULItem = INT(name='id-E-RABToBeSwitchedULItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedULItem._val = 94
    
    #-----< id-E-RABToBeSwitchedULList >-----#
    id_E_RABToBeSwitchedULList = INT(name='id-E-RABToBeSwitchedULList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedULList._val = 95
    
    #-----< id-S-TMSI >-----#
    id_S_TMSI = INT(name='id-S-TMSI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_TMSI._val = 96
    
    #-----< id-cdma2000OneXRAND >-----#
    id_cdma2000OneXRAND = INT(name='id-cdma2000OneXRAND', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000OneXRAND._val = 97
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name='id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 98
    
    #-----< id-UE-S1AP-IDs >-----#
    id_UE_S1AP_IDs = INT(name='id-UE-S1AP-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_S1AP_IDs._val = 99
    
    #-----< id-EUTRAN-CGI >-----#
    id_EUTRAN_CGI = INT(name='id-EUTRAN-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRAN_CGI._val = 100
    
    #-----< id-OverloadResponse >-----#
    id_OverloadResponse = INT(name='id-OverloadResponse', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OverloadResponse._val = 101
    
    #-----< id-cdma2000OneXSRVCCInfo >-----#
    id_cdma2000OneXSRVCCInfo = INT(name='id-cdma2000OneXSRVCCInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000OneXSRVCCInfo._val = 102
    
    #-----< id-E-RABFailedToBeReleasedList >-----#
    id_E_RABFailedToBeReleasedList = INT(name='id-E-RABFailedToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToBeReleasedList._val = 103
    
    #-----< id-Source-ToTarget-TransparentContainer >-----#
    id_Source_ToTarget_TransparentContainer = INT(name='id-Source-ToTarget-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Source_ToTarget_TransparentContainer._val = 104
    
    #-----< id-ServedGUMMEIs >-----#
    id_ServedGUMMEIs = INT(name='id-ServedGUMMEIs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedGUMMEIs._val = 105
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name='id-SubscriberProfileIDforRFP', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SubscriberProfileIDforRFP._val = 106
    
    #-----< id-UESecurityCapabilities >-----#
    id_UESecurityCapabilities = INT(name='id-UESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESecurityCapabilities._val = 107
    
    #-----< id-CSFallbackIndicator >-----#
    id_CSFallbackIndicator = INT(name='id-CSFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSFallbackIndicator._val = 108
    
    #-----< id-CNDomain >-----#
    id_CNDomain = INT(name='id-CNDomain', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNDomain._val = 109
    
    #-----< id-E-RABReleasedList >-----#
    id_E_RABReleasedList = INT(name='id-E-RABReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleasedList._val = 110
    
    #-----< id-MessageIdentifier >-----#
    id_MessageIdentifier = INT(name='id-MessageIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageIdentifier._val = 111
    
    #-----< id-SerialNumber >-----#
    id_SerialNumber = INT(name='id-SerialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SerialNumber._val = 112
    
    #-----< id-WarningAreaList >-----#
    id_WarningAreaList = INT(name='id-WarningAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaList._val = 113
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name='id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 114
    
    #-----< id-NumberofBroadcastRequest >-----#
    id_NumberofBroadcastRequest = INT(name='id-NumberofBroadcastRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberofBroadcastRequest._val = 115
    
    #-----< id-WarningType >-----#
    id_WarningType = INT(name='id-WarningType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningType._val = 116
    
    #-----< id-WarningSecurityInfo >-----#
    id_WarningSecurityInfo = INT(name='id-WarningSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningSecurityInfo._val = 117
    
    #-----< id-DataCodingScheme >-----#
    id_DataCodingScheme = INT(name='id-DataCodingScheme', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataCodingScheme._val = 118
    
    #-----< id-WarningMessageContents >-----#
    id_WarningMessageContents = INT(name='id-WarningMessageContents', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningMessageContents._val = 119
    
    #-----< id-BroadcastCompletedAreaList >-----#
    id_BroadcastCompletedAreaList = INT(name='id-BroadcastCompletedAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCompletedAreaList._val = 120
    
    #-----< id-Inter-SystemInformationTransferTypeEDT >-----#
    id_Inter_SystemInformationTransferTypeEDT = INT(name='id-Inter-SystemInformationTransferTypeEDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_SystemInformationTransferTypeEDT._val = 121
    
    #-----< id-Inter-SystemInformationTransferTypeMDT >-----#
    id_Inter_SystemInformationTransferTypeMDT = INT(name='id-Inter-SystemInformationTransferTypeMDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_SystemInformationTransferTypeMDT._val = 122
    
    #-----< id-Target-ToSource-TransparentContainer >-----#
    id_Target_ToSource_TransparentContainer = INT(name='id-Target-ToSource-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_ToSource_TransparentContainer._val = 123
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name='id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 124
    
    #-----< id-SRVCCHOIndication >-----#
    id_SRVCCHOIndication = INT(name='id-SRVCCHOIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCHOIndication._val = 125
    
    #-----< id-NAS-DownlinkCount >-----#
    id_NAS_DownlinkCount = INT(name='id-NAS-DownlinkCount', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_DownlinkCount._val = 126
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name='id-CSG-Id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_Id._val = 127
    
    #-----< id-CSG-IdList >-----#
    id_CSG_IdList = INT(name='id-CSG-IdList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_IdList._val = 128
    
    #-----< id-SONConfigurationTransferECT >-----#
    id_SONConfigurationTransferECT = INT(name='id-SONConfigurationTransferECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferECT._val = 129
    
    #-----< id-SONConfigurationTransferMCT >-----#
    id_SONConfigurationTransferMCT = INT(name='id-SONConfigurationTransferMCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferMCT._val = 130
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name='id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 131
    
    #-----< id-MSClassmark2 >-----#
    id_MSClassmark2 = INT(name='id-MSClassmark2', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MSClassmark2._val = 132
    
    #-----< id-MSClassmark3 >-----#
    id_MSClassmark3 = INT(name='id-MSClassmark3', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MSClassmark3._val = 133
    
    #-----< id-RRC-Establishment-Cause >-----#
    id_RRC_Establishment_Cause = INT(name='id-RRC-Establishment-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Establishment_Cause._val = 134
    
    #-----< id-NASSecurityParametersfromE-UTRAN >-----#
    id_NASSecurityParametersfromE_UTRAN = INT(name='id-NASSecurityParametersfromE-UTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParametersfromE_UTRAN._val = 135
    
    #-----< id-NASSecurityParameterstoE-UTRAN >-----#
    id_NASSecurityParameterstoE_UTRAN = INT(name='id-NASSecurityParameterstoE-UTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParameterstoE_UTRAN._val = 136
    
    #-----< id-DefaultPagingDRX >-----#
    id_DefaultPagingDRX = INT(name='id-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DefaultPagingDRX._val = 137
    
    #-----< id-Source-ToTarget-TransparentContainer-Secondary >-----#
    id_Source_ToTarget_TransparentContainer_Secondary = INT(name='id-Source-ToTarget-TransparentContainer-Secondary', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Source_ToTarget_TransparentContainer_Secondary._val = 138
    
    #-----< id-Target-ToSource-TransparentContainer-Secondary >-----#
    id_Target_ToSource_TransparentContainer_Secondary = INT(name='id-Target-ToSource-TransparentContainer-Secondary', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_ToSource_TransparentContainer_Secondary._val = 139
    
    #-----< id-EUTRANRoundTripDelayEstimationInfo >-----#
    id_EUTRANRoundTripDelayEstimationInfo = INT(name='id-EUTRANRoundTripDelayEstimationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRANRoundTripDelayEstimationInfo._val = 140
    
    #-----< id-BroadcastCancelledAreaList >-----#
    id_BroadcastCancelledAreaList = INT(name='id-BroadcastCancelledAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCancelledAreaList._val = 141
    
    #-----< id-ConcurrentWarningMessageIndicator >-----#
    id_ConcurrentWarningMessageIndicator = INT(name='id-ConcurrentWarningMessageIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConcurrentWarningMessageIndicator._val = 142
    
    #-----< id-Data-Forwarding-Not-Possible >-----#
    id_Data_Forwarding_Not_Possible = INT(name='id-Data-Forwarding-Not-Possible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Data_Forwarding_Not_Possible._val = 143
    
    #-----< id-ExtendedRepetitionPeriod >-----#
    id_ExtendedRepetitionPeriod = INT(name='id-ExtendedRepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedRepetitionPeriod._val = 144
    
    #-----< id-CellAccessMode >-----#
    id_CellAccessMode = INT(name='id-CellAccessMode', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellAccessMode._val = 145
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name='id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 146
    
    #-----< id-LPPa-PDU >-----#
    id_LPPa_PDU = INT(name='id-LPPa-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LPPa_PDU._val = 147
    
    #-----< id-Routing-ID >-----#
    id_Routing_ID = INT(name='id-Routing-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Routing_ID._val = 148
    
    #-----< id-Time-Synchronisation-Info >-----#
    id_Time_Synchronisation_Info = INT(name='id-Time-Synchronisation-Info', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_Synchronisation_Info._val = 149
    
    #-----< id-PS-ServiceNotAvailable >-----#
    id_PS_ServiceNotAvailable = INT(name='id-PS-ServiceNotAvailable', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PS_ServiceNotAvailable._val = 150
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name='id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 151
    
    #-----< id-x2TNLConfigurationInfo >-----#
    id_x2TNLConfigurationInfo = INT(name='id-x2TNLConfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_x2TNLConfigurationInfo._val = 152
    
    #-----< id-eNBX2ExtendedTransportLayerAddresses >-----#
    id_eNBX2ExtendedTransportLayerAddresses = INT(name='id-eNBX2ExtendedTransportLayerAddresses', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBX2ExtendedTransportLayerAddresses._val = 153
    
    #-----< id-GUMMEIList >-----#
    id_GUMMEIList = INT(name='id-GUMMEIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEIList._val = 154
    
    #-----< id-GW-TransportLayerAddress >-----#
    id_GW_TransportLayerAddress = INT(name='id-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GW_TransportLayerAddress._val = 155
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name='id-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Correlation_ID._val = 156
    
    #-----< id-SourceMME-GUMMEI >-----#
    id_SourceMME_GUMMEI = INT(name='id-SourceMME-GUMMEI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceMME_GUMMEI._val = 157
    
    #-----< id-MME-UE-S1AP-ID-2 >-----#
    id_MME_UE_S1AP_ID_2 = INT(name='id-MME-UE-S1AP-ID-2', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_UE_S1AP_ID_2._val = 158
    
    #-----< id-RegisteredLAI >-----#
    id_RegisteredLAI = INT(name='id-RegisteredLAI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RegisteredLAI._val = 159
    
    #-----< id-RelayNode-Indicator >-----#
    id_RelayNode_Indicator = INT(name='id-RelayNode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelayNode_Indicator._val = 160
    
    #-----< id-TrafficLoadReductionIndication >-----#
    id_TrafficLoadReductionIndication = INT(name='id-TrafficLoadReductionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrafficLoadReductionIndication._val = 161
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name='id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 162
    
    #-----< id-MMERelaySupportIndicator >-----#
    id_MMERelaySupportIndicator = INT(name='id-MMERelaySupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MMERelaySupportIndicator._val = 163
    
    #-----< id-GWContextReleaseIndication >-----#
    id_GWContextReleaseIndication = INT(name='id-GWContextReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GWContextReleaseIndication._val = 164
    
    #-----< id-ManagementBasedMDTAllowed >-----#
    id_ManagementBasedMDTAllowed = INT(name='id-ManagementBasedMDTAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTAllowed._val = 165
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name='id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 166
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name='id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 167
    
    #-----< id-HO-Cause >-----#
    id_HO_Cause = INT(name='id-HO-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HO_Cause._val = 168
    
    #-----< id-VoiceSupportMatchIndicator >-----#
    id_VoiceSupportMatchIndicator = INT(name='id-VoiceSupportMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VoiceSupportMatchIndicator._val = 169
    
    #-----< id-GUMMEIType >-----#
    id_GUMMEIType = INT(name='id-GUMMEIType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEIType._val = 170
    
    #-----< id-M3Configuration >-----#
    id_M3Configuration = INT(name='id-M3Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M3Configuration._val = 171
    
    #-----< id-M4Configuration >-----#
    id_M4Configuration = INT(name='id-M4Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4Configuration._val = 172
    
    #-----< id-M5Configuration >-----#
    id_M5Configuration = INT(name='id-M5Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5Configuration._val = 173
    
    #-----< id-MDT-Location-Info >-----#
    id_MDT_Location_Info = INT(name='id-MDT-Location-Info', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDT_Location_Info._val = 174
    
    #-----< id-MobilityInformation >-----#
    id_MobilityInformation = INT(name='id-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityInformation._val = 175
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name='id-Tunnel-Information-for-BBF', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tunnel_Information_for_BBF._val = 176
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name='id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 177
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name='id-SignallingBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SignallingBasedMDTPLMNList._val = 178
    
    #-----< id-ULCOUNTValueExtended >-----#
    id_ULCOUNTValueExtended = INT(name='id-ULCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValueExtended._val = 179
    
    #-----< id-DLCOUNTValueExtended >-----#
    id_DLCOUNTValueExtended = INT(name='id-DLCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValueExtended._val = 180
    
    #-----< id-ReceiveStatusOfULPDCPSDUsExtended >-----#
    id_ReceiveStatusOfULPDCPSDUsExtended = INT(name='id-ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsExtended._val = 181
    
    #-----< id-ECGIListForRestart >-----#
    id_ECGIListForRestart = INT(name='id-ECGIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ECGIListForRestart._val = 182
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name='id-SIPTO-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_Correlation_ID._val = 183
    
    #-----< id-SIPTO-L-GW-TransportLayerAddress >-----#
    id_SIPTO_L_GW_TransportLayerAddress = INT(name='id-SIPTO-L-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_L_GW_TransportLayerAddress._val = 184
    
    #-----< id-TransportInformation >-----#
    id_TransportInformation = INT(name='id-TransportInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportInformation._val = 185
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name='id-LHN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LHN_ID._val = 186
    
    #-----< id-AdditionalCSFallbackIndicator >-----#
    id_AdditionalCSFallbackIndicator = INT(name='id-AdditionalCSFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalCSFallbackIndicator._val = 187
    
    #-----< id-TAIListForRestart >-----#
    id_TAIListForRestart = INT(name='id-TAIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForRestart._val = 188
    
    #-----< id-UserLocationInformation >-----#
    id_UserLocationInformation = INT(name='id-UserLocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformation._val = 189
    
    #-----< id-EmergencyAreaIDListForRestart >-----#
    id_EmergencyAreaIDListForRestart = INT(name='id-EmergencyAreaIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyAreaIDListForRestart._val = 190
    
    #-----< id-KillAllWarningMessages >-----#
    id_KillAllWarningMessages = INT(name='id-KillAllWarningMessages', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_KillAllWarningMessages._val = 191
    
    #-----< id-Masked-IMEISV >-----#
    id_Masked_IMEISV = INT(name='id-Masked-IMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Masked_IMEISV._val = 192
    
    #-----< id-eNBIndirectX2TransportLayerAddresses >-----#
    id_eNBIndirectX2TransportLayerAddresses = INT(name='id-eNBIndirectX2TransportLayerAddresses', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBIndirectX2TransportLayerAddresses._val = 193
    
    #-----< id-uE-HistoryInformationFromTheUE >-----#
    id_uE_HistoryInformationFromTheUE = INT(name='id-uE-HistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uE_HistoryInformationFromTheUE._val = 194
    
    #-----< id-ProSeAuthorized >-----#
    id_ProSeAuthorized = INT(name='id-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeAuthorized._val = 195
    
    #-----< id-ExpectedUEBehaviour >-----#
    id_ExpectedUEBehaviour = INT(name='id-ExpectedUEBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExpectedUEBehaviour._val = 196
    
    #-----< id-LoggedMBSFNMDT >-----#
    id_LoggedMBSFNMDT = INT(name='id-LoggedMBSFNMDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoggedMBSFNMDT._val = 197
    
    #-----< id-UERadioCapabilityForPaging >-----#
    id_UERadioCapabilityForPaging = INT(name='id-UERadioCapabilityForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging._val = 198
    
    #-----< id-E-RABToBeModifiedListBearerModInd >-----#
    id_E_RABToBeModifiedListBearerModInd = INT(name='id-E-RABToBeModifiedListBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedListBearerModInd._val = 199
    
    #-----< id-E-RABToBeModifiedItemBearerModInd >-----#
    id_E_RABToBeModifiedItemBearerModInd = INT(name='id-E-RABToBeModifiedItemBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedItemBearerModInd._val = 200
    
    #-----< id-E-RABNotToBeModifiedListBearerModInd >-----#
    id_E_RABNotToBeModifiedListBearerModInd = INT(name='id-E-RABNotToBeModifiedListBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABNotToBeModifiedListBearerModInd._val = 201
    
    #-----< id-E-RABNotToBeModifiedItemBearerModInd >-----#
    id_E_RABNotToBeModifiedItemBearerModInd = INT(name='id-E-RABNotToBeModifiedItemBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABNotToBeModifiedItemBearerModInd._val = 202
    
    #-----< id-E-RABModifyListBearerModConf >-----#
    id_E_RABModifyListBearerModConf = INT(name='id-E-RABModifyListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyListBearerModConf._val = 203
    
    #-----< id-E-RABModifyItemBearerModConf >-----#
    id_E_RABModifyItemBearerModConf = INT(name='id-E-RABModifyItemBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyItemBearerModConf._val = 204
    
    #-----< id-E-RABFailedToModifyListBearerModConf >-----#
    id_E_RABFailedToModifyListBearerModConf = INT(name='id-E-RABFailedToModifyListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToModifyListBearerModConf._val = 205
    
    #-----< id-SON-Information-Report >-----#
    id_SON_Information_Report = INT(name='id-SON-Information-Report', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SON_Information_Report._val = 206
    
    #-----< id-Muting-Availability-Indication >-----#
    id_Muting_Availability_Indication = INT(name='id-Muting-Availability-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Muting_Availability_Indication._val = 207
    
    #-----< id-Muting-Pattern-Information >-----#
    id_Muting_Pattern_Information = INT(name='id-Muting-Pattern-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Muting_Pattern_Information._val = 208
    
    #-----< id-Synchronisation-Information >-----#
    id_Synchronisation_Information = INT(name='id-Synchronisation-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Synchronisation_Information._val = 209
    
    #-----< id-E-RABToBeReleasedListBearerModConf >-----#
    id_E_RABToBeReleasedListBearerModConf = INT(name='id-E-RABToBeReleasedListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeReleasedListBearerModConf._val = 210
    
    #-----< id-AssistanceDataForPaging >-----#
    id_AssistanceDataForPaging = INT(name='id-AssistanceDataForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceDataForPaging._val = 211
    
    #-----< id-CellIdentifierAndCELevelForCECapableUEs >-----#
    id_CellIdentifierAndCELevelForCECapableUEs = INT(name='id-CellIdentifierAndCELevelForCECapableUEs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIdentifierAndCELevelForCECapableUEs._val = 212
    
    #-----< id-InformationOnRecommendedCellsAndENBsForPaging >-----#
    id_InformationOnRecommendedCellsAndENBsForPaging = INT(name='id-InformationOnRecommendedCellsAndENBsForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationOnRecommendedCellsAndENBsForPaging._val = 213
    
    #-----< id-RecommendedCellItem >-----#
    id_RecommendedCellItem = INT(name='id-RecommendedCellItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RecommendedCellItem._val = 214
    
    #-----< id-RecommendedENBItem >-----#
    id_RecommendedENBItem = INT(name='id-RecommendedENBItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RecommendedENBItem._val = 215
    
    #-----< id-ProSeUEtoNetworkRelaying >-----#
    id_ProSeUEtoNetworkRelaying = INT(name='id-ProSeUEtoNetworkRelaying', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeUEtoNetworkRelaying._val = 216
    
    #-----< id-ULCOUNTValuePDCP-SNlength18 >-----#
    id_ULCOUNTValuePDCP_SNlength18 = INT(name='id-ULCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValuePDCP_SNlength18._val = 217
    
    #-----< id-DLCOUNTValuePDCP-SNlength18 >-----#
    id_DLCOUNTValuePDCP_SNlength18 = INT(name='id-DLCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValuePDCP_SNlength18._val = 218
    
    #-----< id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = INT(name='id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._val = 219
    
    #-----< id-M6Configuration >-----#
    id_M6Configuration = INT(name='id-M6Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6Configuration._val = 220
    
    #-----< id-M7Configuration >-----#
    id_M7Configuration = INT(name='id-M7Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7Configuration._val = 221
    
    #-----< id-PWSfailedECGIList >-----#
    id_PWSfailedECGIList = INT(name='id-PWSfailedECGIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSfailedECGIList._val = 222
    
    #-----< id-MME-Group-ID >-----#
    id_MME_Group_ID = INT(name='id-MME-Group-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_Group_ID._val = 223
    
    #-----< id-Additional-GUTI >-----#
    id_Additional_GUTI = INT(name='id-Additional-GUTI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_GUTI._val = 224
    
    #-----< id-S1-Message >-----#
    id_S1_Message = INT(name='id-S1-Message', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S1_Message._val = 225
    
    #-----< id-CSGMembershipInfo >-----#
    id_CSGMembershipInfo = INT(name='id-CSGMembershipInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipInfo._val = 226
    
    #-----< id-Paging-eDRXInformation >-----#
    id_Paging_eDRXInformation = INT(name='id-Paging-eDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Paging_eDRXInformation._val = 227
    
    #-----< id-UE-RetentionInformation >-----#
    id_UE_RetentionInformation = INT(name='id-UE-RetentionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RetentionInformation._val = 228
    
    #-----< id-UE-Usage-Type >-----#
    id_UE_Usage_Type = INT(name='id-UE-Usage-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Usage_Type._val = 230
    
    #-----< id-extended-UEIdentityIndexValue >-----#
    id_extended_UEIdentityIndexValue = INT(name='id-extended-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_UEIdentityIndexValue._val = 231
    
    #-----< id-RAT-Type >-----#
    id_RAT_Type = INT(name='id-RAT-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Type._val = 232
    
    #-----< id-BearerType >-----#
    id_BearerType = INT(name='id-BearerType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerType._val = 233
    
    #-----< id-NB-IoT-DefaultPagingDRX >-----#
    id_NB_IoT_DefaultPagingDRX = INT(name='id-NB-IoT-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_DefaultPagingDRX._val = 234
    
    #-----< id-E-RABFailedToResumeListResumeReq >-----#
    id_E_RABFailedToResumeListResumeReq = INT(name='id-E-RABFailedToResumeListResumeReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeListResumeReq._val = 235
    
    #-----< id-E-RABFailedToResumeItemResumeReq >-----#
    id_E_RABFailedToResumeItemResumeReq = INT(name='id-E-RABFailedToResumeItemResumeReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeItemResumeReq._val = 236
    
    #-----< id-E-RABFailedToResumeListResumeRes >-----#
    id_E_RABFailedToResumeListResumeRes = INT(name='id-E-RABFailedToResumeListResumeRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeListResumeRes._val = 237
    
    #-----< id-E-RABFailedToResumeItemResumeRes >-----#
    id_E_RABFailedToResumeItemResumeRes = INT(name='id-E-RABFailedToResumeItemResumeRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeItemResumeRes._val = 238
    
    #-----< id-NB-IoT-Paging-eDRXInformation >-----#
    id_NB_IoT_Paging_eDRXInformation = INT(name='id-NB-IoT-Paging-eDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_Paging_eDRXInformation._val = 239
    
    #-----< id-V2XServicesAuthorized >-----#
    id_V2XServicesAuthorized = INT(name='id-V2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_V2XServicesAuthorized._val = 240
    
    #-----< id-UEUserPlaneCIoTSupportIndicator >-----#
    id_UEUserPlaneCIoTSupportIndicator = INT(name='id-UEUserPlaneCIoTSupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEUserPlaneCIoTSupportIndicator._val = 241
    
    #-----< id-CE-mode-B-SupportIndicator >-----#
    id_CE_mode_B_SupportIndicator = INT(name='id-CE-mode-B-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CE_mode_B_SupportIndicator._val = 242
    
    #-----< id-SRVCCOperationNotPossible >-----#
    id_SRVCCOperationNotPossible = INT(name='id-SRVCCOperationNotPossible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationNotPossible._val = 243
    
    #-----< id-NB-IoT-UEIdentityIndexValue >-----#
    id_NB_IoT_UEIdentityIndexValue = INT(name='id-NB-IoT-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_UEIdentityIndexValue._val = 244
    
    #-----< id-RRC-Resume-Cause >-----#
    id_RRC_Resume_Cause = INT(name='id-RRC-Resume-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Resume_Cause._val = 245
    
    #-----< id-DCN-ID >-----#
    id_DCN_ID = INT(name='id-DCN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCN_ID._val = 246
    
    #-----< id-ServedDCNs >-----#
    id_ServedDCNs = INT(name='id-ServedDCNs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedDCNs._val = 247
    
    #-----< id-UESidelinkAggregateMaximumBitrate >-----#
    id_UESidelinkAggregateMaximumBitrate = INT(name='id-UESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESidelinkAggregateMaximumBitrate._val = 248
    
    #-----< id-DLNASPDUDeliveryAckRequest >-----#
    id_DLNASPDUDeliveryAckRequest = INT(name='id-DLNASPDUDeliveryAckRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLNASPDUDeliveryAckRequest._val = 249
    
    #-----< id-Coverage-Level >-----#
    id_Coverage_Level = INT(name='id-Coverage-Level', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Coverage_Level._val = 250
    
    #-----< id-EnhancedCoverageRestricted >-----#
    id_EnhancedCoverageRestricted = INT(name='id-EnhancedCoverageRestricted', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnhancedCoverageRestricted._val = 251
    
    #-----< id-UE-Level-QoS-Parameters >-----#
    id_UE_Level_QoS_Parameters = INT(name='id-UE-Level-QoS-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Level_QoS_Parameters._val = 252
    
    #-----< id-DL-CP-SecurityInformation >-----#
    id_DL_CP_SecurityInformation = INT(name='id-DL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CP_SecurityInformation._val = 253
    
    #-----< id-UL-CP-SecurityInformation >-----#
    id_UL_CP_SecurityInformation = INT(name='id-UL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CP_SecurityInformation._val = 254
    
    #-----< id-extended-e-RAB-MaximumBitrateDL >-----#
    id_extended_e_RAB_MaximumBitrateDL = INT(name='id-extended-e-RAB-MaximumBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateDL._val = 255
    
    #-----< id-extended-e-RAB-MaximumBitrateUL >-----#
    id_extended_e_RAB_MaximumBitrateUL = INT(name='id-extended-e-RAB-MaximumBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateUL._val = 256
    
    #-----< id-extended-e-RAB-GuaranteedBitrateDL >-----#
    id_extended_e_RAB_GuaranteedBitrateDL = INT(name='id-extended-e-RAB-GuaranteedBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateDL._val = 257
    
    #-----< id-extended-e-RAB-GuaranteedBitrateUL >-----#
    id_extended_e_RAB_GuaranteedBitrateUL = INT(name='id-extended-e-RAB-GuaranteedBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateUL._val = 258
    
    #-----< id-extended-uEaggregateMaximumBitRateDL >-----#
    id_extended_uEaggregateMaximumBitRateDL = INT(name='id-extended-uEaggregateMaximumBitRateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateDL._val = 259
    
    #-----< id-extended-uEaggregateMaximumBitRateUL >-----#
    id_extended_uEaggregateMaximumBitRateUL = INT(name='id-extended-uEaggregateMaximumBitRateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateUL._val = 260
    
    #-----< id-NRrestrictioninEPSasSecondaryRAT >-----#
    id_NRrestrictioninEPSasSecondaryRAT = INT(name='id-NRrestrictioninEPSasSecondaryRAT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictioninEPSasSecondaryRAT._val = 261
    
    #-----< id-UEAppLayerMeasConfig >-----#
    id_UEAppLayerMeasConfig = INT(name='id-UEAppLayerMeasConfig', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAppLayerMeasConfig._val = 262
    
    #-----< id-UE-Application-Layer-Measurement-Capability >-----#
    id_UE_Application_Layer_Measurement_Capability = INT(name='id-UE-Application-Layer-Measurement-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Application_Layer_Measurement_Capability._val = 263
    
    #-----< id-SecondaryRATDataUsageReportList >-----#
    id_SecondaryRATDataUsageReportList = INT(name='id-SecondaryRATDataUsageReportList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageReportList._val = 264
    
    #-----< id-SecondaryRATDataUsageReportItem >-----#
    id_SecondaryRATDataUsageReportItem = INT(name='id-SecondaryRATDataUsageReportItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageReportItem._val = 265
    
    #-----< id-HandoverFlag >-----#
    id_HandoverFlag = INT(name='id-HandoverFlag', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverFlag._val = 266
    
    #-----< id-E-RABUsageReportItem >-----#
    id_E_RABUsageReportItem = INT(name='id-E-RABUsageReportItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABUsageReportItem._val = 267
    
    #-----< id-SecondaryRATDataUsageRequest >-----#
    id_SecondaryRATDataUsageRequest = INT(name='id-SecondaryRATDataUsageRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageRequest._val = 268
    
    #-----< id-NRUESecurityCapabilities >-----#
    id_NRUESecurityCapabilities = INT(name='id-NRUESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESecurityCapabilities._val = 269
    
    #-----< id-UnlicensedSpectrumRestriction >-----#
    id_UnlicensedSpectrumRestriction = INT(name='id-UnlicensedSpectrumRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnlicensedSpectrumRestriction._val = 270
    
    #-----< id-CE-ModeBRestricted >-----#
    id_CE_ModeBRestricted = INT(name='id-CE-ModeBRestricted', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CE_ModeBRestricted._val = 271
    
    #-----< id-LTE-M-Indication >-----#
    id_LTE_M_Indication = INT(name='id-LTE-M-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTE_M_Indication._val = 272
    
    #-----< id-DownlinkPacketLossRate >-----#
    id_DownlinkPacketLossRate = INT(name='id-DownlinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DownlinkPacketLossRate._val = 273
    
    #-----< id-UplinkPacketLossRate >-----#
    id_UplinkPacketLossRate = INT(name='id-UplinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkPacketLossRate._val = 274
    
    #-----< id-UECapabilityInfoRequest >-----#
    id_UECapabilityInfoRequest = INT(name='id-UECapabilityInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UECapabilityInfoRequest._val = 275
    
    #-----< id-serviceType >-----#
    id_serviceType = INT(name='id-serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_serviceType._val = 276
    
    #-----< id-AerialUEsubscriptionInformation >-----#
    id_AerialUEsubscriptionInformation = INT(name='id-AerialUEsubscriptionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AerialUEsubscriptionInformation._val = 277
    
    #-----< id-Subscription-Based-UE-DifferentiationInfo >-----#
    id_Subscription_Based_UE_DifferentiationInfo = INT(name='id-Subscription-Based-UE-DifferentiationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Subscription_Based_UE_DifferentiationInfo._val = 278
    
    #-----< id-EndIndication >-----#
    id_EndIndication = INT(name='id-EndIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndIndication._val = 280
    
    #-----< id-EDT-Session >-----#
    id_EDT_Session = INT(name='id-EDT-Session', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDT_Session._val = 281
    
    #-----< id-CNTypeRestrictions >-----#
    id_CNTypeRestrictions = INT(name='id-CNTypeRestrictions', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictions._val = 282
    
    #-----< id-PendingDataIndication >-----#
    id_PendingDataIndication = INT(name='id-PendingDataIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PendingDataIndication._val = 283
    
    #-----< id-BluetoothMeasurementConfiguration >-----#
    id_BluetoothMeasurementConfiguration = INT(name='id-BluetoothMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BluetoothMeasurementConfiguration._val = 284
    
    #-----< id-WLANMeasurementConfiguration >-----#
    id_WLANMeasurementConfiguration = INT(name='id-WLANMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementConfiguration._val = 285
    
    #-----< id-WarningAreaCoordinates >-----#
    id_WarningAreaCoordinates = INT(name='id-WarningAreaCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaCoordinates._val = 286
    
    #-----< id-NRrestrictionin5GS >-----#
    id_NRrestrictionin5GS = INT(name='id-NRrestrictionin5GS', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictionin5GS._val = 287
    
    #-----< id-PSCellInformation >-----#
    id_PSCellInformation = INT(name='id-PSCellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellInformation._val = 288
    
    #-----< id-LastNG-RANPLMNIdentity >-----#
    id_LastNG_RANPLMNIdentity = INT(name='id-LastNG-RANPLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastNG_RANPLMNIdentity._val = 290
    
    #-----< id-ConnectedengNBList >-----#
    id_ConnectedengNBList = INT(name='id-ConnectedengNBList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBList._val = 291
    
    #-----< id-ConnectedengNBToAddList >-----#
    id_ConnectedengNBToAddList = INT(name='id-ConnectedengNBToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBToAddList._val = 292
    
    #-----< id-ConnectedengNBToRemoveList >-----#
    id_ConnectedengNBToRemoveList = INT(name='id-ConnectedengNBToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBToRemoveList._val = 293
    
    #-----< id-EN-DCSONConfigurationTransfer-ECT >-----#
    id_EN_DCSONConfigurationTransfer_ECT = INT(name='id-EN-DCSONConfigurationTransfer-ECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EN_DCSONConfigurationTransfer_ECT._val = 294
    
    #-----< id-EN-DCSONConfigurationTransfer-MCT >-----#
    id_EN_DCSONConfigurationTransfer_MCT = INT(name='id-EN-DCSONConfigurationTransfer-MCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EN_DCSONConfigurationTransfer_MCT._val = 295
    
    #-----< id-IMSvoiceEPSfallbackfrom5G >-----#
    id_IMSvoiceEPSfallbackfrom5G = INT(name='id-IMSvoiceEPSfallbackfrom5G', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSvoiceEPSfallbackfrom5G._val = 296
    
    #-----< id-TimeSinceSecondaryNodeRelease >-----#
    id_TimeSinceSecondaryNodeRelease = INT(name='id-TimeSinceSecondaryNodeRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSinceSecondaryNodeRelease._val = 297
    
    #-----< id-RequestTypeAdditionalInfo >-----#
    id_RequestTypeAdditionalInfo = INT(name='id-RequestTypeAdditionalInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestTypeAdditionalInfo._val = 298
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name='id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 299
    
    #-----< id-ContextatSource >-----#
    id_ContextatSource = INT(name='id-ContextatSource', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContextatSource._val = 300
    
    #-----< id-IAB-Authorized >-----#
    id_IAB_Authorized = INT(name='id-IAB-Authorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Authorized._val = 301
    
    #-----< id-IAB-Node-Indication >-----#
    id_IAB_Node_Indication = INT(name='id-IAB-Node-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Node_Indication._val = 302
    
    #-----< id-IAB-Supported >-----#
    id_IAB_Supported = INT(name='id-IAB-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Supported._val = 303
    
    #-----< id-DataSize >-----#
    id_DataSize = INT(name='id-DataSize', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataSize._val = 304
    
    #-----< id-Ethernet-Type >-----#
    id_Ethernet_Type = INT(name='id-Ethernet-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ethernet_Type._val = 305
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name='id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 306
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name='id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 307
    
    #-----< id-PC5QoSParameters >-----#
    id_PC5QoSParameters = INT(name='id-PC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5QoSParameters._val = 308
    
    #-----< id-IntersystemSONConfigurationTransferMCT >-----#
    id_IntersystemSONConfigurationTransferMCT = INT(name='id-IntersystemSONConfigurationTransferMCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferMCT._val = 309
    
    #-----< id-IntersystemSONConfigurationTransferECT >-----#
    id_IntersystemSONConfigurationTransferECT = INT(name='id-IntersystemSONConfigurationTransferECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferECT._val = 310
    
    #-----< id-IntersystemMeasurementConfiguration >-----#
    id_IntersystemMeasurementConfiguration = INT(name='id-IntersystemMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemMeasurementConfiguration._val = 311
    
    #-----< id-SourceNodeID >-----#
    id_SourceNodeID = INT(name='id-SourceNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeID._val = 312
    
    #-----< id-NB-IoT-RLF-Report-Container >-----#
    id_NB_IoT_RLF_Report_Container = INT(name='id-NB-IoT-RLF-Report-Container', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_RLF_Report_Container._val = 313
    
    #-----< id-UERadioCapabilityID >-----#
    id_UERadioCapabilityID = INT(name='id-UERadioCapabilityID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityID._val = 314
    
    #-----< id-UERadioCapability-NR-Format >-----#
    id_UERadioCapability_NR_Format = INT(name='id-UERadioCapability-NR-Format', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability_NR_Format._val = 315
    
    #-----< id-MDTConfigurationNR >-----#
    id_MDTConfigurationNR = INT(name='id-MDTConfigurationNR', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfigurationNR._val = 316
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name='id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 317
    
    #-----< id-DAPSResponseInfoList >-----#
    id_DAPSResponseInfoList = INT(name='id-DAPSResponseInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoList._val = 318
    
    #-----< id-DAPSResponseInfoItem >-----#
    id_DAPSResponseInfoItem = INT(name='id-DAPSResponseInfoItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoItem._val = 319
    
    #-----< id-NotifySourceeNB >-----#
    id_NotifySourceeNB = INT(name='id-NotifySourceeNB', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotifySourceeNB._val = 320
    
    #-----< id-eNB-EarlyStatusTransfer-TransparentContainer >-----#
    id_eNB_EarlyStatusTransfer_TransparentContainer = INT(name='id-eNB-EarlyStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_EarlyStatusTransfer_TransparentContainer._val = 321
    
    #-----< id-Bearers-SubjectToEarlyStatusTransfer-Item >-----#
    id_Bearers_SubjectToEarlyStatusTransfer_Item = INT(name='id-Bearers-SubjectToEarlyStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Bearers_SubjectToEarlyStatusTransfer_Item._val = 322
    
    #-----< id-WUS-Assistance-Information >-----#
    id_WUS_Assistance_Information = INT(name='id-WUS-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WUS_Assistance_Information._val = 323
    
    #-----< id-NB-IoT-PagingDRX >-----#
    id_NB_IoT_PagingDRX = INT(name='id-NB-IoT-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_PagingDRX._val = 324
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name='id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 325
    
    #-----< id-EmergencyIndicator >-----#
    id_EmergencyIndicator = INT(name='id-EmergencyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyIndicator._val = 326
    
    #-----< id-UERadioCapabilityForPaging-NR-Format >-----#
    id_UERadioCapabilityForPaging_NR_Format = INT(name='id-UERadioCapabilityForPaging-NR-Format', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging_NR_Format._val = 327
    
    #-----< id-SourceTransportLayerAddress >-----#
    id_SourceTransportLayerAddress = INT(name='id-SourceTransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceTransportLayerAddress._val = 328
    
    #-----< id-lastVisitedPSCellList >-----#
    id_lastVisitedPSCellList = INT(name='id-lastVisitedPSCellList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_lastVisitedPSCellList._val = 329
    
    #-----< id-RACSIndication >-----#
    id_RACSIndication = INT(name='id-RACSIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RACSIndication._val = 330
    
    #-----< id-PagingCause >-----#
    id_PagingCause = INT(name='id-PagingCause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCause._val = 331
    
    #-----< id-SecurityIndication >-----#
    id_SecurityIndication = INT(name='id-SecurityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndication._val = 332
    
    #-----< id-SecurityResult >-----#
    id_SecurityResult = INT(name='id-SecurityResult', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityResult._val = 333
    
    #-----< id-E-RABSecurityResultItem >-----#
    id_E_RABSecurityResultItem = INT(name='id-E-RABSecurityResultItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSecurityResultItem._val = 334
    
    #-----< id-E-RABSecurityResultList >-----#
    id_E_RABSecurityResultList = INT(name='id-E-RABSecurityResultList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSecurityResultList._val = 335
    
    #-----< id-RAT-Restrictions >-----#
    id_RAT_Restrictions = INT(name='id-RAT-Restrictions', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Restrictions._val = 336
    
    #-----< id-UEContextReferenceatSourceeNB >-----#
    id_UEContextReferenceatSourceeNB = INT(name='id-UEContextReferenceatSourceeNB', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextReferenceatSourceeNB._val = 337
    
    #-----< id-LTE-NTN-TAI-Information >-----#
    id_LTE_NTN_TAI_Information = INT(name='id-LTE-NTN-TAI-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTE_NTN_TAI_Information._val = 339
    
    #-----< id-SourceNodeTransportLayerAddress >-----#
    id_SourceNodeTransportLayerAddress = INT(name='id-SourceNodeTransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeTransportLayerAddress._val = 340
    
    #-----< id-E-RABToBeUpdatedList >-----#
    id_E_RABToBeUpdatedList = INT(name='id-E-RABToBeUpdatedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeUpdatedList._val = 341
    
    #-----< id-E-RABToBeUpdatedItem >-----#
    id_E_RABToBeUpdatedItem = INT(name='id-E-RABToBeUpdatedItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeUpdatedItem._val = 342
    
    #-----< id-SourceSNID >-----#
    id_SourceSNID = INT(name='id-SourceSNID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceSNID._val = 343
    
    #-----< id-LoggedMDTTrigger >-----#
    id_LoggedMDTTrigger = INT(name='id-LoggedMDTTrigger', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoggedMDTTrigger._val = 344
    
    #-----< id-SensorMeasurementConfiguration >-----#
    id_SensorMeasurementConfiguration = INT(name='id-SensorMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SensorMeasurementConfiguration._val = 345
    
    _all_ = [
        id_HandoverPreparation,
        id_HandoverResourceAllocation,
        id_HandoverNotification,
        id_PathSwitchRequest,
        id_HandoverCancel,
        id_E_RABSetup,
        id_E_RABModify,
        id_E_RABRelease,
        id_E_RABReleaseIndication,
        id_InitialContextSetup,
        id_Paging,
        id_downlinkNASTransport,
        id_initialUEMessage,
        id_uplinkNASTransport,
        id_Reset,
        id_ErrorIndication,
        id_NASNonDeliveryIndication,
        id_S1Setup,
        id_UEContextReleaseRequest,
        id_DownlinkS1cdma2000tunnelling,
        id_UplinkS1cdma2000tunnelling,
        id_UEContextModification,
        id_UECapabilityInfoIndication,
        id_UEContextRelease,
        id_eNBStatusTransfer,
        id_MMEStatusTransfer,
        id_DeactivateTrace,
        id_TraceStart,
        id_TraceFailureIndication,
        id_ENBConfigurationUpdate,
        id_MMEConfigurationUpdate,
        id_LocationReportingControl,
        id_LocationReportingFailureIndication,
        id_LocationReport,
        id_OverloadStart,
        id_OverloadStop,
        id_WriteReplaceWarning,
        id_eNBDirectInformationTransfer,
        id_MMEDirectInformationTransfer,
        id_PrivateMessage,
        id_eNBConfigurationTransfer,
        id_MMEConfigurationTransfer,
        id_CellTrafficTrace,
        id_Kill,
        id_downlinkUEAssociatedLPPaTransport,
        id_uplinkUEAssociatedLPPaTransport,
        id_downlinkNonUEAssociatedLPPaTransport,
        id_uplinkNonUEAssociatedLPPaTransport,
        id_UERadioCapabilityMatch,
        id_PWSRestartIndication,
        id_E_RABModificationIndication,
        id_PWSFailureIndication,
        id_RerouteNASRequest,
        id_UEContextModificationIndication,
        id_ConnectionEstablishmentIndication,
        id_UEContextSuspend,
        id_UEContextResume,
        id_NASDeliveryIndication,
        id_RetrieveUEInformation,
        id_UEInformationTransfer,
        id_eNBCPRelocationIndication,
        id_MMECPRelocationIndication,
        id_SecondaryRATDataUsageReport,
        id_UERadioCapabilityIDMapping,
        id_HandoverSuccess,
        id_eNBEarlyStatusTransfer,
        id_MMEEarlyStatusTransfer,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxnoofCSGs,
        maxnoofE_RABs,
        maxnoofTAIs,
        maxnoofTACs,
        maxnoofErrors,
        maxnoofBPLMNs,
        maxnoofPLMNsPerMME,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofForbLACs,
        maxnoofForbTACs,
        maxnoofIndividualS1ConnectionsToReset,
        maxnoofCellsinUEHistoryInfo,
        maxnoofCellsineNB,
        maxnoofTAIforWarning,
        maxnoofCellID,
        maxnoofDCNs,
        maxnoofEmergencyAreaID,
        maxnoofCellinTAI,
        maxnoofCellinEAI,
        maxnoofeNBX2TLAs,
        maxnoofeNBX2ExtTLAs,
        maxnoofeNBX2GTPTLAs,
        maxnoofRATs,
        maxnoofGroupIDs,
        maxnoofMMECs,
        maxnoofCellIDforMDT,
        maxnoofTAforMDT,
        maxnoofMDTPLMNs,
        maxnoofCellsforRestart,
        maxnoofRestartTAIs,
        maxnoofRestartEmergencyAreaIDs,
        maxEARFCN,
        maxnoofMBSFNAreaMDT,
        maxnoofRecommendedCells,
        maxnoofRecommendedENBs,
        maxnooftimeperiods,
        maxnoofCellIDforQMC,
        maxnoofTAforQMC,
        maxnoofPLMNforQMC,
        maxnoofBluetoothName,
        maxnoofWLANName,
        maxnoofConnectedengNBs,
        maxnoofPC5QoSFlows,
        maxnooffrequencies,
        maxNARFCN,
        maxRS_IndexCellQual,
        maxnoofPSCellsPerPrimaryCellinUEHistoryInfo,
        maxnoofTACsInNTN,
        maxnoofSensorName,
        id_MME_UE_S1AP_ID,
        id_HandoverType,
        id_Cause,
        id_SourceID,
        id_TargetID,
        id_eNB_UE_S1AP_ID,
        id_E_RABSubjecttoDataForwardingList,
        id_E_RABtoReleaseListHOCmd,
        id_E_RABDataForwardingItem,
        id_E_RABReleaseItemBearerRelComp,
        id_E_RABToBeSetupListBearerSUReq,
        id_E_RABToBeSetupItemBearerSUReq,
        id_E_RABAdmittedList,
        id_E_RABFailedToSetupListHOReqAck,
        id_E_RABAdmittedItem,
        id_E_RABFailedtoSetupItemHOReqAck,
        id_E_RABToBeSwitchedDLList,
        id_E_RABToBeSwitchedDLItem,
        id_E_RABToBeSetupListCtxtSUReq,
        id_TraceActivation,
        id_NAS_PDU,
        id_E_RABToBeSetupItemHOReq,
        id_E_RABSetupListBearerSURes,
        id_E_RABFailedToSetupListBearerSURes,
        id_E_RABToBeModifiedListBearerModReq,
        id_E_RABModifyListBearerModRes,
        id_E_RABFailedToModifyList,
        id_E_RABToBeReleasedList,
        id_E_RABFailedToReleaseList,
        id_E_RABItem,
        id_E_RABToBeModifiedItemBearerModReq,
        id_E_RABModifyItemBearerModRes,
        id_E_RABReleaseItem,
        id_E_RABSetupItemBearerSURes,
        id_SecurityContext,
        id_HandoverRestrictionList,
        id_UEPagingID,
        id_pagingDRX,
        id_TAIList,
        id_TAIItem,
        id_E_RABFailedToSetupListCtxtSURes,
        id_E_RABReleaseItemHOCmd,
        id_E_RABSetupItemCtxtSURes,
        id_E_RABSetupListCtxtSURes,
        id_E_RABToBeSetupItemCtxtSUReq,
        id_E_RABToBeSetupListHOReq,
        id_GERANtoLTEHOInformationRes,
        id_UTRANtoLTEHOInformationRes,
        id_CriticalityDiagnostics,
        id_Global_ENB_ID,
        id_eNBname,
        id_MMEname,
        id_ServedPLMNs,
        id_SupportedTAs,
        id_TimeToWait,
        id_uEaggregateMaximumBitrate,
        id_TAI,
        id_E_RABReleaseListBearerRelComp,
        id_cdma2000PDU,
        id_cdma2000RATType,
        id_cdma2000SectorID,
        id_SecurityKey,
        id_UERadioCapability,
        id_GUMMEI_ID,
        id_E_RABInformationListItem,
        id_Direct_Forwarding_Path_Availability,
        id_UEIdentityIndexValue,
        id_cdma2000HOStatus,
        id_cdma2000HORequiredIndication,
        id_E_UTRAN_Trace_ID,
        id_RelativeMMECapacity,
        id_SourceMME_UE_S1AP_ID,
        id_Bearers_SubjectToStatusTransfer_Item,
        id_eNB_StatusTransfer_TransparentContainer,
        id_UE_associatedLogicalS1_ConnectionItem,
        id_ResetType,
        id_UE_associatedLogicalS1_ConnectionListResAck,
        id_E_RABToBeSwitchedULItem,
        id_E_RABToBeSwitchedULList,
        id_S_TMSI,
        id_cdma2000OneXRAND,
        id_RequestType,
        id_UE_S1AP_IDs,
        id_EUTRAN_CGI,
        id_OverloadResponse,
        id_cdma2000OneXSRVCCInfo,
        id_E_RABFailedToBeReleasedList,
        id_Source_ToTarget_TransparentContainer,
        id_ServedGUMMEIs,
        id_SubscriberProfileIDforRFP,
        id_UESecurityCapabilities,
        id_CSFallbackIndicator,
        id_CNDomain,
        id_E_RABReleasedList,
        id_MessageIdentifier,
        id_SerialNumber,
        id_WarningAreaList,
        id_RepetitionPeriod,
        id_NumberofBroadcastRequest,
        id_WarningType,
        id_WarningSecurityInfo,
        id_DataCodingScheme,
        id_WarningMessageContents,
        id_BroadcastCompletedAreaList,
        id_Inter_SystemInformationTransferTypeEDT,
        id_Inter_SystemInformationTransferTypeMDT,
        id_Target_ToSource_TransparentContainer,
        id_SRVCCOperationPossible,
        id_SRVCCHOIndication,
        id_NAS_DownlinkCount,
        id_CSG_Id,
        id_CSG_IdList,
        id_SONConfigurationTransferECT,
        id_SONConfigurationTransferMCT,
        id_TraceCollectionEntityIPAddress,
        id_MSClassmark2,
        id_MSClassmark3,
        id_RRC_Establishment_Cause,
        id_NASSecurityParametersfromE_UTRAN,
        id_NASSecurityParameterstoE_UTRAN,
        id_DefaultPagingDRX,
        id_Source_ToTarget_TransparentContainer_Secondary,
        id_Target_ToSource_TransparentContainer_Secondary,
        id_EUTRANRoundTripDelayEstimationInfo,
        id_BroadcastCancelledAreaList,
        id_ConcurrentWarningMessageIndicator,
        id_Data_Forwarding_Not_Possible,
        id_ExtendedRepetitionPeriod,
        id_CellAccessMode,
        id_CSGMembershipStatus,
        id_LPPa_PDU,
        id_Routing_ID,
        id_Time_Synchronisation_Info,
        id_PS_ServiceNotAvailable,
        id_PagingPriority,
        id_x2TNLConfigurationInfo,
        id_eNBX2ExtendedTransportLayerAddresses,
        id_GUMMEIList,
        id_GW_TransportLayerAddress,
        id_Correlation_ID,
        id_SourceMME_GUMMEI,
        id_MME_UE_S1AP_ID_2,
        id_RegisteredLAI,
        id_RelayNode_Indicator,
        id_TrafficLoadReductionIndication,
        id_MDTConfiguration,
        id_MMERelaySupportIndicator,
        id_GWContextReleaseIndication,
        id_ManagementBasedMDTAllowed,
        id_PrivacyIndicator,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_HO_Cause,
        id_VoiceSupportMatchIndicator,
        id_GUMMEIType,
        id_M3Configuration,
        id_M4Configuration,
        id_M5Configuration,
        id_MDT_Location_Info,
        id_MobilityInformation,
        id_Tunnel_Information_for_BBF,
        id_ManagementBasedMDTPLMNList,
        id_SignallingBasedMDTPLMNList,
        id_ULCOUNTValueExtended,
        id_DLCOUNTValueExtended,
        id_ReceiveStatusOfULPDCPSDUsExtended,
        id_ECGIListForRestart,
        id_SIPTO_Correlation_ID,
        id_SIPTO_L_GW_TransportLayerAddress,
        id_TransportInformation,
        id_LHN_ID,
        id_AdditionalCSFallbackIndicator,
        id_TAIListForRestart,
        id_UserLocationInformation,
        id_EmergencyAreaIDListForRestart,
        id_KillAllWarningMessages,
        id_Masked_IMEISV,
        id_eNBIndirectX2TransportLayerAddresses,
        id_uE_HistoryInformationFromTheUE,
        id_ProSeAuthorized,
        id_ExpectedUEBehaviour,
        id_LoggedMBSFNMDT,
        id_UERadioCapabilityForPaging,
        id_E_RABToBeModifiedListBearerModInd,
        id_E_RABToBeModifiedItemBearerModInd,
        id_E_RABNotToBeModifiedListBearerModInd,
        id_E_RABNotToBeModifiedItemBearerModInd,
        id_E_RABModifyListBearerModConf,
        id_E_RABModifyItemBearerModConf,
        id_E_RABFailedToModifyListBearerModConf,
        id_SON_Information_Report,
        id_Muting_Availability_Indication,
        id_Muting_Pattern_Information,
        id_Synchronisation_Information,
        id_E_RABToBeReleasedListBearerModConf,
        id_AssistanceDataForPaging,
        id_CellIdentifierAndCELevelForCECapableUEs,
        id_InformationOnRecommendedCellsAndENBsForPaging,
        id_RecommendedCellItem,
        id_RecommendedENBItem,
        id_ProSeUEtoNetworkRelaying,
        id_ULCOUNTValuePDCP_SNlength18,
        id_DLCOUNTValuePDCP_SNlength18,
        id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        id_M6Configuration,
        id_M7Configuration,
        id_PWSfailedECGIList,
        id_MME_Group_ID,
        id_Additional_GUTI,
        id_S1_Message,
        id_CSGMembershipInfo,
        id_Paging_eDRXInformation,
        id_UE_RetentionInformation,
        id_UE_Usage_Type,
        id_extended_UEIdentityIndexValue,
        id_RAT_Type,
        id_BearerType,
        id_NB_IoT_DefaultPagingDRX,
        id_E_RABFailedToResumeListResumeReq,
        id_E_RABFailedToResumeItemResumeReq,
        id_E_RABFailedToResumeListResumeRes,
        id_E_RABFailedToResumeItemResumeRes,
        id_NB_IoT_Paging_eDRXInformation,
        id_V2XServicesAuthorized,
        id_UEUserPlaneCIoTSupportIndicator,
        id_CE_mode_B_SupportIndicator,
        id_SRVCCOperationNotPossible,
        id_NB_IoT_UEIdentityIndexValue,
        id_RRC_Resume_Cause,
        id_DCN_ID,
        id_ServedDCNs,
        id_UESidelinkAggregateMaximumBitrate,
        id_DLNASPDUDeliveryAckRequest,
        id_Coverage_Level,
        id_EnhancedCoverageRestricted,
        id_UE_Level_QoS_Parameters,
        id_DL_CP_SecurityInformation,
        id_UL_CP_SecurityInformation,
        id_extended_e_RAB_MaximumBitrateDL,
        id_extended_e_RAB_MaximumBitrateUL,
        id_extended_e_RAB_GuaranteedBitrateDL,
        id_extended_e_RAB_GuaranteedBitrateUL,
        id_extended_uEaggregateMaximumBitRateDL,
        id_extended_uEaggregateMaximumBitRateUL,
        id_NRrestrictioninEPSasSecondaryRAT,
        id_UEAppLayerMeasConfig,
        id_UE_Application_Layer_Measurement_Capability,
        id_SecondaryRATDataUsageReportList,
        id_SecondaryRATDataUsageReportItem,
        id_HandoverFlag,
        id_E_RABUsageReportItem,
        id_SecondaryRATDataUsageRequest,
        id_NRUESecurityCapabilities,
        id_UnlicensedSpectrumRestriction,
        id_CE_ModeBRestricted,
        id_LTE_M_Indication,
        id_DownlinkPacketLossRate,
        id_UplinkPacketLossRate,
        id_UECapabilityInfoRequest,
        id_serviceType,
        id_AerialUEsubscriptionInformation,
        id_Subscription_Based_UE_DifferentiationInfo,
        id_EndIndication,
        id_EDT_Session,
        id_CNTypeRestrictions,
        id_PendingDataIndication,
        id_BluetoothMeasurementConfiguration,
        id_WLANMeasurementConfiguration,
        id_WarningAreaCoordinates,
        id_NRrestrictionin5GS,
        id_PSCellInformation,
        id_LastNG_RANPLMNIdentity,
        id_ConnectedengNBList,
        id_ConnectedengNBToAddList,
        id_ConnectedengNBToRemoveList,
        id_EN_DCSONConfigurationTransfer_ECT,
        id_EN_DCSONConfigurationTransfer_MCT,
        id_IMSvoiceEPSfallbackfrom5G,
        id_TimeSinceSecondaryNodeRelease,
        id_RequestTypeAdditionalInfo,
        id_AdditionalRRMPriorityIndex,
        id_ContextatSource,
        id_IAB_Authorized,
        id_IAB_Node_Indication,
        id_IAB_Supported,
        id_DataSize,
        id_Ethernet_Type,
        id_NRV2XServicesAuthorized,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_PC5QoSParameters,
        id_IntersystemSONConfigurationTransferMCT,
        id_IntersystemSONConfigurationTransferECT,
        id_IntersystemMeasurementConfiguration,
        id_SourceNodeID,
        id_NB_IoT_RLF_Report_Container,
        id_UERadioCapabilityID,
        id_UERadioCapability_NR_Format,
        id_MDTConfigurationNR,
        id_DAPSRequestInfo,
        id_DAPSResponseInfoList,
        id_DAPSResponseInfoItem,
        id_NotifySourceeNB,
        id_eNB_EarlyStatusTransfer_TransparentContainer,
        id_Bearers_SubjectToEarlyStatusTransfer_Item,
        id_WUS_Assistance_Information,
        id_NB_IoT_PagingDRX,
        id_TraceCollectionEntityURI,
        id_EmergencyIndicator,
        id_UERadioCapabilityForPaging_NR_Format,
        id_SourceTransportLayerAddress,
        id_lastVisitedPSCellList,
        id_RACSIndication,
        id_PagingCause,
        id_SecurityIndication,
        id_SecurityResult,
        id_E_RABSecurityResultItem,
        id_E_RABSecurityResultList,
        id_RAT_Restrictions,
        id_UEContextReferenceatSourceeNB,
        id_LTE_NTN_TAI_Information,
        id_SourceNodeTransportLayerAddress,
        id_E_RABToBeUpdatedList,
        id_E_RABToBeUpdatedItem,
        id_SourceSNID,
        id_LoggedMDTTrigger,
        id_SensorMeasurementConfiguration,
    ]

class S1AP_Containers:

    _name_  = 'S1AP-Containers'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 5]
    
    _obj_ = [
        'S1AP-PROTOCOL-IES',
        'S1AP-PROTOCOL-IES-PAIR',
        'S1AP-PROTOCOL-EXTENSION',
        'S1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'S1AP-PROTOCOL-IES',
        'S1AP-PROTOCOL-IES-PAIR',
        'S1AP-PROTOCOL-EXTENSION',
        'S1AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'S1AP-PROTOCOL-IES',
        'S1AP-PROTOCOL-IES-PAIR',
        'S1AP-PROTOCOL-EXTENSION',
        'S1AP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< S1AP-PROTOCOL-IES >-----#
    S1AP_PROTOCOL_IES = CLASS(name='S1AP-PROTOCOL-IES', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _S1AP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _S1AP_PROTOCOL_IES_id),
        ('criticality', _S1AP_PROTOCOL_IES_criticality),
        ('Value', _S1AP_PROTOCOL_IES_Value),
        ('presence', _S1AP_PROTOCOL_IES_presence),
        ])
    
    #-----< S1AP-PROTOCOL-IES-PAIR >-----#
    S1AP_PROTOCOL_IES_PAIR = CLASS(name='S1AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _S1AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _S1AP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _S1AP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _S1AP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _S1AP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _S1AP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _S1AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< S1AP-PROTOCOL-EXTENSION >-----#
    S1AP_PROTOCOL_EXTENSION = CLASS(name='S1AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _S1AP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _S1AP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _S1AP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _S1AP_PROTOCOL_EXTENSION_id),
        ('criticality', _S1AP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _S1AP_PROTOCOL_EXTENSION_Extension),
        ('presence', _S1AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< S1AP-PRIVATE-IES >-----#
    S1AP_PRIVATE_IES = CLASS(name='S1AP-PRIVATE-IES', mode=MODE_TYPE)
    _S1AP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'PrivateIE-ID')))
    _S1AP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _S1AP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _S1AP_PRIVATE_IES_id),
        ('criticality', _S1AP_PRIVATE_IES_criticality),
        ('Value', _S1AP_PRIVATE_IES_Value),
        ('presence', _S1AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name='ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _S1AP_PROTOCOL_IES_id,
        _S1AP_PROTOCOL_IES_criticality,
        _S1AP_PROTOCOL_IES_Value,
        _S1AP_PROTOCOL_IES_presence,
        S1AP_PROTOCOL_IES,
        _S1AP_PROTOCOL_IES_PAIR_id,
        _S1AP_PROTOCOL_IES_PAIR_firstCriticality,
        _S1AP_PROTOCOL_IES_PAIR_FirstValue,
        _S1AP_PROTOCOL_IES_PAIR_secondCriticality,
        _S1AP_PROTOCOL_IES_PAIR_SecondValue,
        _S1AP_PROTOCOL_IES_PAIR_presence,
        S1AP_PROTOCOL_IES_PAIR,
        _S1AP_PROTOCOL_EXTENSION_id,
        _S1AP_PROTOCOL_EXTENSION_criticality,
        _S1AP_PROTOCOL_EXTENSION_Extension,
        _S1AP_PROTOCOL_EXTENSION_presence,
        S1AP_PROTOCOL_EXTENSION,
        _S1AP_PRIVATE_IES_id,
        _S1AP_PRIVATE_IES_criticality,
        _S1AP_PRIVATE_IES_Value,
        _S1AP_PRIVATE_IES_presence,
        S1AP_PRIVATE_IES,
    ]

class S1AP_IEs:

    _name_  = 'S1AP-IEs'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 2]
    
    _obj_ = [
        'Additional-GUTI',
        'Additional-GUTI-ExtIEs',
        'AdditionalRRMPriorityIndex',
        'AerialUEsubscriptionInformation',
        'AreaScopeOfMDT',
        'AreaScopeOfQMC',
        'AllocationAndRetentionPriority',
        'AllocationAndRetentionPriority-ExtIEs',
        'AssistanceDataForCECapableUEs',
        'InformationForCECapableUEs-ExtIEs',
        'AssistanceDataForPaging',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'Bearers-SubjectToStatusTransferList',
        'Bearers-SubjectToStatusTransfer-ItemIEs',
        'Bearers-SubjectToStatusTransfer-Item',
        'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        'Bearers-SubjectToEarlyStatusTransferList',
        'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        'Bearers-SubjectToEarlyStatusTransfer-Item',
        'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        'BearerType',
        'BitRate',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BPLMNs',
        'BroadcastCancelledAreaList',
        'BroadcastCompletedAreaList',
        'CancelledCellinEAI',
        'CancelledCellinEAI-Item',
        'CancelledCellinEAI-Item-ExtIEs',
        'CancelledCellinTAI',
        'CancelledCellinTAI-Item',
        'CancelledCellinTAI-Item-ExtIEs',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseNas',
        'CellAccessMode',
        'CellIdentifierAndCELevelForCECapableUEs',
        'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        'CELevel',
        'CE-mode-B-SupportIndicator',
        'CellIdentity',
        'CellID-Broadcast',
        'CellID-Broadcast-Item',
        'CellID-Broadcast-Item-ExtIEs',
        'CellID-Cancelled',
        'CellID-Cancelled-Item',
        'CellID-Cancelled-Item-ExtIEs',
        'CellBasedMDT',
        'CellBasedMDT-ExtIEs',
        'CellIdListforMDT',
        'CellBasedQMC',
        'CellBasedQMC-ExtIEs',
        'CellIdListforQMC',
        'Cdma2000PDU',
        'Cdma2000RATType',
        'Cdma2000SectorID',
        'Cdma2000HOStatus',
        'Cdma2000HORequiredIndication',
        'Cdma2000OneXSRVCCInfo',
        'Cdma2000OneXSRVCCInfo-ExtIEs',
        'Cdma2000OneXMEID',
        'Cdma2000OneXMSI',
        'Cdma2000OneXPilot',
        'Cdma2000OneXRAND',
        'Cell-Size',
        'CellType',
        'CellType-ExtIEs',
        'CGI',
        'CGI-ExtIEs',
        'CI',
        'CNDomain',
        'CNTypeRestrictions',
        'CNTypeRestrictions-Item',
        'CNTypeRestrictions-Item-ExtIEs',
        'CNType',
        'ConcurrentWarningMessageIndicator',
        'ConnectedengNBList',
        'ConnectedengNBItem',
        'ConnectedengNBItem-ExtIEs',
        'ContextatSource',
        'ContextatSource-ExtIEs',
        'Correlation-ID',
        'CSFallbackIndicator',
        'AdditionalCSFallbackIndicator',
        'CSG-Id',
        'CSG-IdList',
        'CSG-IdList-Item',
        'CSG-IdList-Item-ExtIEs',
        'CSGMembershipStatus',
        'COUNTvalue',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'Coverage-Level',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'DAPSRequestInfo',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoList',
        'DAPSResponseInfoListIEs',
        'DAPSResponseInfoItem',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo',
        'DAPSResponseInfo-ExtIEs',
        'DataCodingScheme',
        'DataSize',
        'DCN-ID',
        'ServedDCNs',
        'ServedDCNsItem',
        'ServedDCNsItem-ExtIEs',
        'DL-CP-SecurityInformation',
        'DL-CP-SecurityInformation-ExtIEs',
        'DL-Forwarding',
        'DL-NAS-MAC',
        'DLCOUNT-PDCP-SNlength',
        'Direct-Forwarding-Path-Availability',
        'Data-Forwarding-Not-Possible',
        'DLNASPDUDeliveryAckRequest',
        'EARFCN',
        'ECGIList',
        'PWSfailedECGIList',
        'EDT-Session',
        'EmergencyAreaIDList',
        'EmergencyAreaID',
        'EmergencyAreaID-Broadcast',
        'EmergencyAreaID-Broadcast-Item',
        'EmergencyAreaID-Broadcast-Item-ExtIEs',
        'EmergencyAreaID-Cancelled',
        'EmergencyAreaID-Cancelled-Item',
        'EmergencyAreaID-Cancelled-Item-ExtIEs',
        'CompletedCellinEAI',
        'CompletedCellinEAI-Item',
        'CompletedCellinEAI-Item-ExtIEs',
        'ECGI-List',
        'EmergencyAreaIDListForRestart',
        'EmergencyIndicator',
        'ENB-EarlyStatusTransfer-TransparentContainer',
        'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'ENB-ID',
        'En-gNB-ID',
        'GERAN-Cell-ID',
        'GERAN-Cell-ID-ExtIEs',
        'Global-ENB-ID',
        'GlobalENB-ID-ExtIEs',
        'Global-en-gNB-ID',
        'Global-en-gNB-ID-ExtIEs',
        'GUMMEIList',
        'ENB-StatusTransfer-TransparentContainer',
        'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        'ENB-UE-S1AP-ID',
        'ENBname',
        'ENBX2TLAs',
        'EncryptionAlgorithms',
        'EN-DCSONConfigurationTransfer',
        'EN-DCSONConfigurationTransfer-ExtIEs',
        'EN-DCSONTransferType',
        'EN-DCTransferTypeRequest',
        'EN-DCTransferTypeRequest-ExtIEs',
        'EN-DCTransferTypeReply',
        'EN-DCTransferTypeReply-ExtIEs',
        'EN-DCSONeNBIdentification',
        'EN-DCSONeNBIdentification-ExtIEs',
        'EN-DCSONengNBIdentification',
        'EN-DCSONengNBIdentification-ExtIEs',
        'EndIndication',
        'EnhancedCoverageRestricted',
        'CE-ModeBRestricted',
        'EPLMNs',
        'EventType',
        'E-RAB-ID',
        'E-RABInformationList',
        'E-RABInformationListIEs',
        'E-RABInformationListItem',
        'E-RABInformationListItem-ExtIEs',
        'E-RABList',
        'E-RABItemIEs',
        'E-RABItem',
        'E-RABItem-ExtIEs',
        'E-RABLevelQoSParameters',
        'E-RABSecurityResultList',
        'E-RABSecurityResultListIEs',
        'E-RABSecurityResultItem',
        'E-RABSecurityResultItem-ExtIEs',
        'E-RABUsageReportList',
        'E-RABUsageReportItemIEs',
        'E-RABUsageReportItem',
        'E-RABUsageReportItem-ExtIEs',
        'E-RABQoSParameters-ExtIEs',
        'Ethernet-Type',
        'EUTRAN-CGI',
        'EUTRAN-CGI-ExtIEs',
        'EUTRANRoundTripDelayEstimationInfo',
        'EventL1LoggedMDTConfig',
        'EventL1LoggedMDTConfig-ExtIEs',
        'EventTrigger',
        'EventTrigger-ExtIEs',
        'ExpectedUEBehaviour',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExpectedActivityPeriod',
        'ExpectedIdlePeriod',
        'SourceOfUEActivityBehaviourInformation',
        'ExpectedHOInterval',
        'ExtendedBitRate',
        'ExtendedRNC-ID',
        'ExtendedRepetitionPeriod',
        'Extended-UEIdentityIndexValue',
        'FiveGSTAC',
        'FiveGSTAI',
        'FiveGSTAI-ExtIEs',
        'FiveQI',
        'ForbiddenInterRATs',
        'ForbiddenTAs',
        'ForbiddenTAs-Item',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenTACs',
        'ForbiddenLAs',
        'ForbiddenLAs-Item',
        'ForbiddenLAs-Item-ExtIEs',
        'ForbiddenLACs',
        'GBR-QosInformation',
        'GBR-QosInformation-ExtIEs',
        'GTP-TEID',
        'GUMMEI',
        'GUMMEI-ExtIEs',
        'GUMMEIType',
        'GWContextReleaseIndication',
        'HandoverFlag',
        'HandoverRestrictionList',
        'HandoverRestrictionList-ExtIEs',
        'HandoverType',
        'HFN',
        'HFNModified',
        'HFNforPDCP-SNlength18',
        'Hysteresis',
        'Masked-IMEISV',
        'ImmediateMDT',
        'ImmediateMDT-ExtIEs',
        'IMSI',
        'InformationOnRecommendedCellsAndENBsForPaging',
        'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        'IntegrityProtectionAlgorithms',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedNumberOfPagingAttempts',
        'InterfacesToTrace',
        'IntersystemMeasurementConfiguration',
        'IntersystemMeasurementConfiguration-ExtIEs',
        'InterSystemMeasurementParameters',
        'InterSystemMeasurementParameters-ExtIEs',
        'InterSystemMeasurementList',
        'InterSystemMeasurementItem',
        'InterSystemMeasurementItem-ExtIEs',
        'IntersystemSONConfigurationTransfer',
        'IMSvoiceEPSfallbackfrom5G',
        'IAB-Authorized',
        'IAB-Node-Indication',
        'IAB-Supported',
        'KillAllWarningMessages',
        'LAC',
        'LAI',
        'LAI-ExtIEs',
        'LastVisitedCell-Item',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LastVisitedPSCellList',
        'LastVisitedPSCellInformation',
        'LastVisitedPSCellInformation-ExtIEs',
        'LastVisitedNGRANCellInformation',
        'LastVisitedUTRANCellInformation',
        'LastVisitedGERANCellInformation',
        'L3-Information',
        'LPPa-PDU',
        'LHN-ID',
        'Links-to-log',
        'ListeningSubframePattern',
        'ListeningSubframePattern-ExtIEs',
        'LoggedMDT',
        'LoggedMDT-ExtIEs',
        'LoggingInterval',
        'LoggingDuration',
        'LoggedMBSFNMDT',
        'LoggedMBSFNMDT-ExtIEs',
        'LoggedMDTTrigger',
        'LTE-M-Indication',
        'LTE-NTN-TAI-Information',
        'LTE-NTN-TAI-Information-ExtIEs',
        'M3Configuration',
        'M3Configuration-ExtIEs',
        'M3period',
        'M4Configuration',
        'M4Configuration-ExtIEs',
        'M4period',
        'M5Configuration',
        'M5Configuration-ExtIEs',
        'M5period',
        'M6Configuration',
        'M6Configuration-ExtIEs',
        'M6report-Interval',
        'M6delay-threshold',
        'M7Configuration',
        'M7Configuration-ExtIEs',
        'M7period',
        'MDT-Activation',
        'MDT-Location-Info',
        'MDT-Configuration',
        'MDT-Configuration-ExtIEs',
        'ManagementBasedMDTAllowed',
        'MBSFN-ResultToLog',
        'MBSFN-ResultToLogInfo',
        'MBSFN-ResultToLogInfo-ExtIEs',
        'MDTPLMNList',
        'PrivacyIndicator',
        'MDTMode',
        'MDTMode-Extension',
        'MDTMode-ExtensionIE',
        'MeasurementsToActivate',
        'MeasurementThresholdA2',
        'MeasurementThresholdL1LoggedMDT',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'MessageIdentifier',
        'MobilityInformation',
        'MMEname',
        'MMEPagingTarget',
        'MMERelaySupportIndicator',
        'MME-Group-ID',
        'MME-Code',
        'MME-UE-S1AP-ID',
        'M-TMSI',
        'MSClassmark2',
        'MSClassmark3',
        'MutingAvailabilityIndication',
        'MutingPatternInformation',
        'MutingPatternInformation-ExtIEs',
        'MDT-ConfigurationNR',
        'NAS-PDU',
        'NASSecurityParametersfromE-UTRAN',
        'NASSecurityParameterstoE-UTRAN',
        'NB-IoT-DefaultPagingDRX',
        'NB-IoT-PagingDRX',
        'NB-IoT-Paging-eDRXInformation',
        'NB-IoT-Paging-eDRXInformation-ExtIEs',
        'NB-IoT-Paging-eDRX-Cycle',
        'NB-IoT-PagingTimeWindow',
        'NB-IoT-RLF-Report-Container',
        'NB-IoT-UEIdentityIndexValue',
        'NextPagingAreaScope',
        'NotifySourceeNB',
        'NRCellIdentity',
        'NR-CGI',
        'NR-CGI-ExtIEs',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NRrestrictioninEPSasSecondaryRAT',
        'NRrestrictionin5GS',
        'NRUESecurityCapabilities',
        'NRUESecurityCapabilities-ExtIEs',
        'NumberofBroadcastRequest',
        'NumberOfBroadcasts',
        'NRV2XServicesAuthorized',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'OldBSS-ToNewBSS-Information',
        'OverloadAction',
        'OverloadResponse',
        'Packet-LossRate',
        'PagingAttemptInformation',
        'PagingAttemptInformation-ExtIEs',
        'PagingAttemptCount',
        'Paging-eDRXInformation',
        'Paging-eDRXInformation-ExtIEs',
        'Paging-eDRX-Cycle',
        'PagingTimeWindow',
        'PagingDRX',
        'PagingPriority',
        'PagingProbabilityInformation',
        'PagingCause',
        'PC5QoSParameters',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates',
        'PC5FlowBitRates-ExtIEs',
        'PDCP-SN',
        'PDCP-SNExtended',
        'PDCP-SNlength18',
        'PendingDataIndication',
        'M1PeriodicReporting',
        'M1PeriodicReporting-ExtIEs',
        'PLMNidentity',
        'PLMNAreaBasedQMC',
        'PLMNAreaBasedQMC-ExtIEs',
        'PLMNListforQMC',
        'Port-Number',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProSeAuthorized',
        'ProSeAuthorized-ExtIEs',
        'ProSeDirectDiscovery',
        'ProSeUEtoNetworkRelaying',
        'ProSeDirectCommunication',
        'PS-ServiceNotAvailable',
        'PSCellInformation',
        'PSCellInformation-ExtIEs',
        'QCI',
        'RACSIndication',
        'RAN-UE-NGAP-ID',
        'Range',
        'ReceiveStatusofULPDCPSDUs',
        'ReceiveStatusOfULPDCPSDUsExtended',
        'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'RecommendedCellsForPaging',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellList',
        'RecommendedCellItemIEs',
        'RecommendedCellItem',
        'RecommendedCellsForPagingItem-ExtIEs',
        'RecommendedENBsForPaging',
        'RecommendedENBsForPaging-ExtIEs',
        'RecommendedENBList',
        'RecommendedENBItemIEs',
        'RecommendedENBItem',
        'RecommendedENBItem-ExtIEs',
        'RelativeMMECapacity',
        'RelayNode-Indicator',
        'RAC',
        'RAT-Restrictions',
        'RAT-RestrictionsItem',
        'RAT-RestrictionsItem-ExtIEs',
        'RAT-Type',
        'ReportAmountMDT',
        'ReportIntervalMDT',
        'M1ReportingTrigger',
        'RequestType',
        'RequestType-ExtIEs',
        'RequestTypeAdditionalInfo',
        'RIMTransfer',
        'RIMTransfer-ExtIEs',
        'RIMInformation',
        'RIMRoutingAddress',
        'ReportArea',
        'RepetitionPeriod',
        'RLFReportInformation',
        'RLFReportInformation-ExtIEs',
        'RNC-ID',
        'RRC-Container',
        'RRC-Establishment-Cause',
        'ECGIListForRestart',
        'Routing-ID',
        'SecurityKey',
        'SecurityContext',
        'SecurityContext-ExtIEs',
        'SecondaryRATType',
        'SecondaryRATDataUsageRequest',
        'SecondaryRATDataUsageReportList',
        'SecondaryRATDataUsageReportItemIEs',
        'SecondaryRATDataUsageReportItem',
        'SecondaryRATDataUsageReportItem-ExtIEs',
        'SecurityIndication',
        'SecurityIndication-ExtIEs',
        'SecurityResult',
        'SecurityResult-ExtIEs',
        'SensorMeasConfig',
        'SensorMeasConfigNameItem',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorMeasConfigNameList',
        'SensorMeasurementConfiguration',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorNameConfig',
        'SensorNameConfig-ExtIEs',
        'SerialNumber',
        'ServiceType',
        'SONInformation',
        'SONInformation-Extension',
        'SONInformation-ExtensionIE',
        'SONInformationRequest',
        'SONInformationReply',
        'SONInformationReply-ExtIEs',
        'SONInformationReport',
        'SONConfigurationTransfer',
        'SONConfigurationTransfer-ExtIEs',
        'SynchronisationInformation',
        'SynchronisationInformation-ExtIEs',
        'Source-ToTarget-TransparentContainer',
        'SourceBSS-ToTargetBSS-TransparentContainer',
        'SourceeNB-ID',
        'SourceeNB-ID-ExtIEs',
        'SRVCCOperationNotPossible',
        'SRVCCOperationPossible',
        'SRVCCHOIndication',
        'SourceNodeID',
        'SourceNodeID-Extension',
        'SourceNodeID-ExtensionIE',
        'SourceeNB-ToTargeteNB-TransparentContainer',
        'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        'SourceNgRanNode-ID',
        'SourceNgRanNode-ID-ExtIEs',
        'SourceRNC-ToTargetRNC-TransparentContainer',
        'SourceNgRanNode-ToTargetNgRanNode-TransparentContainer',
        'ServedGUMMEIs',
        'ServedGUMMEIsItem',
        'ServedGUMMEIsItem-ExtIEs',
        'ServedGroupIDs',
        'ServedMMECs',
        'ServedPLMNs',
        'SubscriberProfileIDforRFP',
        'Subscription-Based-UE-DifferentiationInfo',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime',
        'ScheduledCommunicationTime-ExtIEs',
        'SupportedTAs',
        'SupportedTAs-Item',
        'SupportedTAs-Item-ExtIEs',
        'StratumLevel',
        'SynchronisationStatus',
        'TimeSynchronisationInfo',
        'TimeSynchronisationInfo-ExtIEs',
        'S-TMSI',
        'S-TMSI-ExtIEs',
        'TAC',
        'TACList-In-LTE-NTN',
        'TAIBasedMDT',
        'TAIBasedMDT-ExtIEs',
        'TAIListforMDT',
        'TAIListforWarning',
        'TAI',
        'TAI-ExtIEs',
        'TAI-Broadcast',
        'TAI-Broadcast-Item',
        'TAI-Broadcast-Item-ExtIEs',
        'TAI-Cancelled',
        'TAI-Cancelled-Item',
        'TAI-Cancelled-Item-ExtIEs',
        'TABasedMDT',
        'TABasedMDT-ExtIEs',
        'TAListforMDT',
        'TABasedQMC',
        'TABasedQMC-ExtIEs',
        'TAListforQMC',
        'TAIBasedQMC',
        'TAIBasedQMC-ExtIEs',
        'TAIListforQMC',
        'CompletedCellinTAI',
        'CompletedCellinTAI-Item',
        'CompletedCellinTAI-Item-ExtIEs',
        'TBCD-STRING',
        'TargetID',
        'TargeteNB-ID',
        'TargeteNB-ID-ExtIEs',
        'TargetRNC-ID',
        'TargetRNC-ID-ExtIEs',
        'TargetNgRanNode-ID',
        'TargetNgRanNode-ID-ExtIEs',
        'Global-RAN-NODE-ID',
        'GNB',
        'GNB-ExtIEs',
        'Global-GNB-ID',
        'Global-GNB-ID-ExtIEs',
        'GNB-Identity',
        'NG-eNB',
        'NG-eNB-ExtIEs',
        'GNB-ID',
        'TargeteNB-ToSourceeNB-TransparentContainer',
        'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        'Target-ToSource-TransparentContainer',
        'TargetRNC-ToSourceRNC-TransparentContainer',
        'TargetBSS-ToSourceBSS-TransparentContainer',
        'TargetNgRanNode-ToSourceNgRanNode-TransparentContainer',
        'M1ThresholdEventA2',
        'M1ThresholdEventA2-ExtIEs',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'TimeToTrigger',
        'TimeToWait',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TimeSinceSecondaryNodeRelease',
        'TransportInformation',
        'TransportLayerAddress',
        'TraceActivation',
        'TraceActivation-ExtIEs',
        'TraceDepth',
        'E-UTRAN-Trace-ID',
        'TrafficLoadReductionIndication',
        'TunnelInformation',
        'Tunnel-Information-ExtIEs',
        'TypeOfError',
        'TAIListForRestart',
        'UEAggregateMaximumBitrate',
        'UEAggregate-MaximumBitrates-ExtIEs',
        'UEAppLayerMeasConfig',
        'UEAppLayerMeasConfig-ExtIEs',
        'UECapabilityInfoRequest',
        'UE-RetentionInformation',
        'UE-S1AP-IDs',
        'UE-S1AP-ID-pair',
        'UE-S1AP-ID-pair-ExtIEs',
        'UE-associatedLogicalS1-ConnectionItem',
        'UE-associatedLogicalS1-ConnectionItemExtIEs',
        'UEIdentityIndexValue',
        'UE-HistoryInformation',
        'UE-HistoryInformationFromTheUE',
        'UEPagingID',
        'UERadioCapability',
        'UERadioCapabilityForPaging',
        'UERadioCapabilityID',
        'UE-RLF-Report-Container',
        'UE-RLF-Report-Container-for-extended-bands',
        'UESecurityCapabilities',
        'UESecurityCapabilities-ExtIEs',
        'UESidelinkAggregateMaximumBitrate',
        'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'UE-Usage-Type',
        'UL-CP-SecurityInformation',
        'UL-CP-SecurityInformation-ExtIEs',
        'UL-NAS-MAC',
        'UL-NAS-Count',
        'UnlicensedSpectrumRestriction',
        'URI-Address',
        'UserLocationInformation',
        'UserLocationInformation-ExtIEs',
        'UEUserPlaneCIoTSupportIndicator',
        'UE-Application-Layer-Measurement-Capability',
        'VoiceSupportMatchIndicator',
        'V2XServicesAuthorized',
        'V2XServicesAuthorized-ExtIEs',
        'VehicleUE',
        'PedestrianUE',
        'WarningAreaCoordinates',
        'WarningAreaList',
        'WarningType',
        'WarningSecurityInfo',
        'WarningMessageContents',
        'WLANMeasurementConfiguration',
        'WLANMeasurementConfiguration-ExtIEs',
        'WLANMeasConfigNameList',
        'WLANMeasConfig',
        'WLANName',
        'WUS-Assistance-Information',
        'WUS-Assistance-Information-ExtIEs',
        'X2TNLConfigurationInfo',
        'X2TNLConfigurationInfo-ExtIEs',
        'ENBX2ExtTLAs',
        'ENBX2ExtTLA',
        'ENBX2ExtTLA-ExtIEs',
        'ENBX2GTPTLAs',
        'ENBIndirectX2TransportLayerAddresses',
        ]
    _type_ = [
        'Additional-GUTI',
        'AdditionalRRMPriorityIndex',
        'AerialUEsubscriptionInformation',
        'AreaScopeOfMDT',
        'AreaScopeOfQMC',
        'AllocationAndRetentionPriority',
        'AssistanceDataForCECapableUEs',
        'AssistanceDataForPaging',
        'AssistanceDataForRecommendedCells',
        'Bearers-SubjectToStatusTransferList',
        'Bearers-SubjectToStatusTransfer-Item',
        'Bearers-SubjectToEarlyStatusTransferList',
        'Bearers-SubjectToEarlyStatusTransfer-Item',
        'BearerType',
        'BitRate',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BPLMNs',
        'BroadcastCancelledAreaList',
        'BroadcastCompletedAreaList',
        'CancelledCellinEAI',
        'CancelledCellinEAI-Item',
        'CancelledCellinTAI',
        'CancelledCellinTAI-Item',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseNas',
        'CellAccessMode',
        'CellIdentifierAndCELevelForCECapableUEs',
        'CELevel',
        'CE-mode-B-SupportIndicator',
        'CellIdentity',
        'CellID-Broadcast',
        'CellID-Broadcast-Item',
        'CellID-Cancelled',
        'CellID-Cancelled-Item',
        'CellBasedMDT',
        'CellIdListforMDT',
        'CellBasedQMC',
        'CellIdListforQMC',
        'Cdma2000PDU',
        'Cdma2000RATType',
        'Cdma2000SectorID',
        'Cdma2000HOStatus',
        'Cdma2000HORequiredIndication',
        'Cdma2000OneXSRVCCInfo',
        'Cdma2000OneXMEID',
        'Cdma2000OneXMSI',
        'Cdma2000OneXPilot',
        'Cdma2000OneXRAND',
        'Cell-Size',
        'CellType',
        'CGI',
        'CI',
        'CNDomain',
        'CNTypeRestrictions',
        'CNTypeRestrictions-Item',
        'CNType',
        'ConcurrentWarningMessageIndicator',
        'ConnectedengNBList',
        'ConnectedengNBItem',
        'ContextatSource',
        'Correlation-ID',
        'CSFallbackIndicator',
        'AdditionalCSFallbackIndicator',
        'CSG-Id',
        'CSG-IdList',
        'CSG-IdList-Item',
        'CSGMembershipStatus',
        'COUNTvalue',
        'COUNTValueExtended',
        'COUNTvaluePDCP-SNlength18',
        'Coverage-Level',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'DAPSRequestInfo',
        'DAPSResponseInfoList',
        'DAPSResponseInfoItem',
        'DAPSResponseInfo',
        'DataCodingScheme',
        'DataSize',
        'DCN-ID',
        'ServedDCNs',
        'ServedDCNsItem',
        'DL-CP-SecurityInformation',
        'DL-Forwarding',
        'DL-NAS-MAC',
        'DLCOUNT-PDCP-SNlength',
        'Direct-Forwarding-Path-Availability',
        'Data-Forwarding-Not-Possible',
        'DLNASPDUDeliveryAckRequest',
        'EARFCN',
        'ECGIList',
        'PWSfailedECGIList',
        'EDT-Session',
        'EmergencyAreaIDList',
        'EmergencyAreaID',
        'EmergencyAreaID-Broadcast',
        'EmergencyAreaID-Broadcast-Item',
        'EmergencyAreaID-Cancelled',
        'EmergencyAreaID-Cancelled-Item',
        'CompletedCellinEAI',
        'CompletedCellinEAI-Item',
        'ECGI-List',
        'EmergencyAreaIDListForRestart',
        'EmergencyIndicator',
        'ENB-EarlyStatusTransfer-TransparentContainer',
        'ENB-ID',
        'En-gNB-ID',
        'GERAN-Cell-ID',
        'Global-ENB-ID',
        'Global-en-gNB-ID',
        'GUMMEIList',
        'ENB-StatusTransfer-TransparentContainer',
        'ENB-UE-S1AP-ID',
        'ENBname',
        'ENBX2TLAs',
        'EncryptionAlgorithms',
        'EN-DCSONConfigurationTransfer',
        'EN-DCSONTransferType',
        'EN-DCTransferTypeRequest',
        'EN-DCTransferTypeReply',
        'EN-DCSONeNBIdentification',
        'EN-DCSONengNBIdentification',
        'EndIndication',
        'EnhancedCoverageRestricted',
        'CE-ModeBRestricted',
        'EPLMNs',
        'EventType',
        'E-RAB-ID',
        'E-RABInformationList',
        'E-RABInformationListItem',
        'E-RABList',
        'E-RABItem',
        'E-RABLevelQoSParameters',
        'E-RABSecurityResultList',
        'E-RABSecurityResultItem',
        'E-RABUsageReportList',
        'E-RABUsageReportItem',
        'Ethernet-Type',
        'EUTRAN-CGI',
        'EUTRANRoundTripDelayEstimationInfo',
        'EventL1LoggedMDTConfig',
        'EventTrigger',
        'ExpectedUEBehaviour',
        'ExpectedUEActivityBehaviour',
        'ExpectedActivityPeriod',
        'ExpectedIdlePeriod',
        'SourceOfUEActivityBehaviourInformation',
        'ExpectedHOInterval',
        'ExtendedBitRate',
        'ExtendedRNC-ID',
        'ExtendedRepetitionPeriod',
        'Extended-UEIdentityIndexValue',
        'FiveGSTAC',
        'FiveGSTAI',
        'FiveQI',
        'ForbiddenInterRATs',
        'ForbiddenTAs',
        'ForbiddenTAs-Item',
        'ForbiddenTACs',
        'ForbiddenLAs',
        'ForbiddenLAs-Item',
        'ForbiddenLACs',
        'GBR-QosInformation',
        'GTP-TEID',
        'GUMMEI',
        'GUMMEIType',
        'GWContextReleaseIndication',
        'HandoverFlag',
        'HandoverRestrictionList',
        'HandoverType',
        'HFN',
        'HFNModified',
        'HFNforPDCP-SNlength18',
        'Hysteresis',
        'Masked-IMEISV',
        'ImmediateMDT',
        'IMSI',
        'InformationOnRecommendedCellsAndENBsForPaging',
        'IntegrityProtectionAlgorithms',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedNumberOfPagingAttempts',
        'InterfacesToTrace',
        'IntersystemMeasurementConfiguration',
        'InterSystemMeasurementParameters',
        'InterSystemMeasurementList',
        'InterSystemMeasurementItem',
        'IntersystemSONConfigurationTransfer',
        'IMSvoiceEPSfallbackfrom5G',
        'IAB-Authorized',
        'IAB-Node-Indication',
        'IAB-Supported',
        'KillAllWarningMessages',
        'LAC',
        'LAI',
        'LastVisitedCell-Item',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedPSCellList',
        'LastVisitedPSCellInformation',
        'LastVisitedNGRANCellInformation',
        'LastVisitedUTRANCellInformation',
        'LastVisitedGERANCellInformation',
        'L3-Information',
        'LPPa-PDU',
        'LHN-ID',
        'Links-to-log',
        'ListeningSubframePattern',
        'LoggedMDT',
        'LoggingInterval',
        'LoggingDuration',
        'LoggedMBSFNMDT',
        'LoggedMDTTrigger',
        'LTE-M-Indication',
        'LTE-NTN-TAI-Information',
        'M3Configuration',
        'M3period',
        'M4Configuration',
        'M4period',
        'M5Configuration',
        'M5period',
        'M6Configuration',
        'M6report-Interval',
        'M6delay-threshold',
        'M7Configuration',
        'M7period',
        'MDT-Activation',
        'MDT-Location-Info',
        'MDT-Configuration',
        'ManagementBasedMDTAllowed',
        'MBSFN-ResultToLog',
        'MBSFN-ResultToLogInfo',
        'MDTPLMNList',
        'PrivacyIndicator',
        'MDTMode',
        'MDTMode-Extension',
        'MeasurementsToActivate',
        'MeasurementThresholdA2',
        'MeasurementThresholdL1LoggedMDT',
        'MessageIdentifier',
        'MobilityInformation',
        'MMEname',
        'MMEPagingTarget',
        'MMERelaySupportIndicator',
        'MME-Group-ID',
        'MME-Code',
        'MME-UE-S1AP-ID',
        'M-TMSI',
        'MSClassmark2',
        'MSClassmark3',
        'MutingAvailabilityIndication',
        'MutingPatternInformation',
        'MDT-ConfigurationNR',
        'NAS-PDU',
        'NASSecurityParametersfromE-UTRAN',
        'NASSecurityParameterstoE-UTRAN',
        'NB-IoT-DefaultPagingDRX',
        'NB-IoT-PagingDRX',
        'NB-IoT-Paging-eDRXInformation',
        'NB-IoT-Paging-eDRX-Cycle',
        'NB-IoT-PagingTimeWindow',
        'NB-IoT-RLF-Report-Container',
        'NB-IoT-UEIdentityIndexValue',
        'NextPagingAreaScope',
        'NotifySourceeNB',
        'NRCellIdentity',
        'NR-CGI',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NRrestrictioninEPSasSecondaryRAT',
        'NRrestrictionin5GS',
        'NRUESecurityCapabilities',
        'NumberofBroadcastRequest',
        'NumberOfBroadcasts',
        'NRV2XServicesAuthorized',
        'NRUESidelinkAggregateMaximumBitrate',
        'OldBSS-ToNewBSS-Information',
        'OverloadAction',
        'OverloadResponse',
        'Packet-LossRate',
        'PagingAttemptInformation',
        'PagingAttemptCount',
        'Paging-eDRXInformation',
        'Paging-eDRX-Cycle',
        'PagingTimeWindow',
        'PagingDRX',
        'PagingPriority',
        'PagingProbabilityInformation',
        'PagingCause',
        'PC5QoSParameters',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5FlowBitRates',
        'PDCP-SN',
        'PDCP-SNExtended',
        'PDCP-SNlength18',
        'PendingDataIndication',
        'M1PeriodicReporting',
        'PLMNidentity',
        'PLMNAreaBasedQMC',
        'PLMNListforQMC',
        'Port-Number',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProSeAuthorized',
        'ProSeDirectDiscovery',
        'ProSeUEtoNetworkRelaying',
        'ProSeDirectCommunication',
        'PS-ServiceNotAvailable',
        'PSCellInformation',
        'QCI',
        'RACSIndication',
        'RAN-UE-NGAP-ID',
        'Range',
        'ReceiveStatusofULPDCPSDUs',
        'ReceiveStatusOfULPDCPSDUsExtended',
        'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'RecommendedCellsForPaging',
        'RecommendedCellList',
        'RecommendedCellItem',
        'RecommendedENBsForPaging',
        'RecommendedENBList',
        'RecommendedENBItem',
        'RelativeMMECapacity',
        'RelayNode-Indicator',
        'RAC',
        'RAT-Restrictions',
        'RAT-RestrictionsItem',
        'RAT-Type',
        'ReportAmountMDT',
        'ReportIntervalMDT',
        'M1ReportingTrigger',
        'RequestType',
        'RequestTypeAdditionalInfo',
        'RIMTransfer',
        'RIMInformation',
        'RIMRoutingAddress',
        'ReportArea',
        'RepetitionPeriod',
        'RLFReportInformation',
        'RNC-ID',
        'RRC-Container',
        'RRC-Establishment-Cause',
        'ECGIListForRestart',
        'Routing-ID',
        'SecurityKey',
        'SecurityContext',
        'SecondaryRATType',
        'SecondaryRATDataUsageRequest',
        'SecondaryRATDataUsageReportList',
        'SecondaryRATDataUsageReportItem',
        'SecurityIndication',
        'SecurityResult',
        'SensorMeasConfig',
        'SensorMeasConfigNameItem',
        'SensorMeasConfigNameList',
        'SensorMeasurementConfiguration',
        'SensorNameConfig',
        'SerialNumber',
        'ServiceType',
        'SONInformation',
        'SONInformation-Extension',
        'SONInformationRequest',
        'SONInformationReply',
        'SONInformationReport',
        'SONConfigurationTransfer',
        'SynchronisationInformation',
        'Source-ToTarget-TransparentContainer',
        'SourceBSS-ToTargetBSS-TransparentContainer',
        'SourceeNB-ID',
        'SRVCCOperationNotPossible',
        'SRVCCOperationPossible',
        'SRVCCHOIndication',
        'SourceNodeID',
        'SourceNodeID-Extension',
        'SourceeNB-ToTargeteNB-TransparentContainer',
        'SourceNgRanNode-ID',
        'SourceRNC-ToTargetRNC-TransparentContainer',
        'SourceNgRanNode-ToTargetNgRanNode-TransparentContainer',
        'ServedGUMMEIs',
        'ServedGUMMEIsItem',
        'ServedGroupIDs',
        'ServedMMECs',
        'ServedPLMNs',
        'SubscriberProfileIDforRFP',
        'Subscription-Based-UE-DifferentiationInfo',
        'ScheduledCommunicationTime',
        'SupportedTAs',
        'SupportedTAs-Item',
        'StratumLevel',
        'SynchronisationStatus',
        'TimeSynchronisationInfo',
        'S-TMSI',
        'TAC',
        'TACList-In-LTE-NTN',
        'TAIBasedMDT',
        'TAIListforMDT',
        'TAIListforWarning',
        'TAI',
        'TAI-Broadcast',
        'TAI-Broadcast-Item',
        'TAI-Cancelled',
        'TAI-Cancelled-Item',
        'TABasedMDT',
        'TAListforMDT',
        'TABasedQMC',
        'TAListforQMC',
        'TAIBasedQMC',
        'TAIListforQMC',
        'CompletedCellinTAI',
        'CompletedCellinTAI-Item',
        'TBCD-STRING',
        'TargetID',
        'TargeteNB-ID',
        'TargetRNC-ID',
        'TargetNgRanNode-ID',
        'Global-RAN-NODE-ID',
        'GNB',
        'Global-GNB-ID',
        'GNB-Identity',
        'NG-eNB',
        'GNB-ID',
        'TargeteNB-ToSourceeNB-TransparentContainer',
        'Target-ToSource-TransparentContainer',
        'TargetRNC-ToSourceRNC-TransparentContainer',
        'TargetBSS-ToSourceBSS-TransparentContainer',
        'TargetNgRanNode-ToSourceNgRanNode-TransparentContainer',
        'M1ThresholdEventA2',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'TimeToTrigger',
        'TimeToWait',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TimeSinceSecondaryNodeRelease',
        'TransportInformation',
        'TransportLayerAddress',
        'TraceActivation',
        'TraceDepth',
        'E-UTRAN-Trace-ID',
        'TrafficLoadReductionIndication',
        'TunnelInformation',
        'TypeOfError',
        'TAIListForRestart',
        'UEAggregateMaximumBitrate',
        'UEAppLayerMeasConfig',
        'UECapabilityInfoRequest',
        'UE-RetentionInformation',
        'UE-S1AP-IDs',
        'UE-S1AP-ID-pair',
        'UE-associatedLogicalS1-ConnectionItem',
        'UEIdentityIndexValue',
        'UE-HistoryInformation',
        'UE-HistoryInformationFromTheUE',
        'UEPagingID',
        'UERadioCapability',
        'UERadioCapabilityForPaging',
        'UERadioCapabilityID',
        'UE-RLF-Report-Container',
        'UE-RLF-Report-Container-for-extended-bands',
        'UESecurityCapabilities',
        'UESidelinkAggregateMaximumBitrate',
        'UE-Usage-Type',
        'UL-CP-SecurityInformation',
        'UL-NAS-MAC',
        'UL-NAS-Count',
        'UnlicensedSpectrumRestriction',
        'URI-Address',
        'UserLocationInformation',
        'UEUserPlaneCIoTSupportIndicator',
        'UE-Application-Layer-Measurement-Capability',
        'VoiceSupportMatchIndicator',
        'V2XServicesAuthorized',
        'VehicleUE',
        'PedestrianUE',
        'WarningAreaCoordinates',
        'WarningAreaList',
        'WarningType',
        'WarningSecurityInfo',
        'WarningMessageContents',
        'WLANMeasurementConfiguration',
        'WLANMeasConfigNameList',
        'WLANMeasConfig',
        'WLANName',
        'WUS-Assistance-Information',
        'X2TNLConfigurationInfo',
        'ENBX2ExtTLAs',
        'ENBX2ExtTLA',
        'ENBX2GTPTLAs',
        'ENBIndirectX2TransportLayerAddresses',
        ]
    _set_ = [
        'Additional-GUTI-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'InformationForCECapableUEs-ExtIEs',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'Bearers-SubjectToStatusTransfer-ItemIEs',
        'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'CancelledCellinEAI-Item-ExtIEs',
        'CancelledCellinTAI-Item-ExtIEs',
        'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        'CellID-Broadcast-Item-ExtIEs',
        'CellID-Cancelled-Item-ExtIEs',
        'CellBasedMDT-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'Cdma2000OneXSRVCCInfo-ExtIEs',
        'CellType-ExtIEs',
        'CGI-ExtIEs',
        'CNTypeRestrictions-Item-ExtIEs',
        'ConnectedengNBItem-ExtIEs',
        'ContextatSource-ExtIEs',
        'CSG-IdList-Item-ExtIEs',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoListIEs',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'ServedDCNsItem-ExtIEs',
        'DL-CP-SecurityInformation-ExtIEs',
        'EmergencyAreaID-Broadcast-Item-ExtIEs',
        'EmergencyAreaID-Cancelled-Item-ExtIEs',
        'CompletedCellinEAI-Item-ExtIEs',
        'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'GERAN-Cell-ID-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'Global-en-gNB-ID-ExtIEs',
        'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        'EN-DCSONConfigurationTransfer-ExtIEs',
        'EN-DCTransferTypeRequest-ExtIEs',
        'EN-DCTransferTypeReply-ExtIEs',
        'EN-DCSONeNBIdentification-ExtIEs',
        'EN-DCSONengNBIdentification-ExtIEs',
        'E-RABInformationListIEs',
        'E-RABInformationListItem-ExtIEs',
        'E-RABItemIEs',
        'E-RABItem-ExtIEs',
        'E-RABSecurityResultListIEs',
        'E-RABSecurityResultItem-ExtIEs',
        'E-RABUsageReportItemIEs',
        'E-RABUsageReportItem-ExtIEs',
        'E-RABQoSParameters-ExtIEs',
        'EUTRAN-CGI-ExtIEs',
        'EventL1LoggedMDTConfig-ExtIEs',
        'EventTrigger-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'FiveGSTAI-ExtIEs',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenLAs-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GUMMEI-ExtIEs',
        'HandoverRestrictionList-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        'IntersystemMeasurementConfiguration-ExtIEs',
        'InterSystemMeasurementParameters-ExtIEs',
        'InterSystemMeasurementItem-ExtIEs',
        'LAI-ExtIEs',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LastVisitedPSCellInformation-ExtIEs',
        'ListeningSubframePattern-ExtIEs',
        'LoggedMDT-ExtIEs',
        'LoggedMBSFNMDT-ExtIEs',
        'LTE-NTN-TAI-Information-ExtIEs',
        'M3Configuration-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MBSFN-ResultToLogInfo-ExtIEs',
        'MDTMode-ExtensionIE',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'MutingPatternInformation-ExtIEs',
        'NB-IoT-Paging-eDRXInformation-ExtIEs',
        'NR-CGI-ExtIEs',
        'NRUESecurityCapabilities-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'PagingAttemptInformation-ExtIEs',
        'Paging-eDRXInformation-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'ProSeAuthorized-ExtIEs',
        'PSCellInformation-ExtIEs',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellItemIEs',
        'RecommendedCellsForPagingItem-ExtIEs',
        'RecommendedENBsForPaging-ExtIEs',
        'RecommendedENBItemIEs',
        'RecommendedENBItem-ExtIEs',
        'RAT-RestrictionsItem-ExtIEs',
        'RequestType-ExtIEs',
        'RIMTransfer-ExtIEs',
        'RLFReportInformation-ExtIEs',
        'SecurityContext-ExtIEs',
        'SecondaryRATDataUsageReportItemIEs',
        'SecondaryRATDataUsageReportItem-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'SONInformation-ExtensionIE',
        'SONInformationReply-ExtIEs',
        'SONConfigurationTransfer-ExtIEs',
        'SynchronisationInformation-ExtIEs',
        'SourceeNB-ID-ExtIEs',
        'SourceNodeID-ExtensionIE',
        'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        'SourceNgRanNode-ID-ExtIEs',
        'ServedGUMMEIsItem-ExtIEs',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SupportedTAs-Item-ExtIEs',
        'TimeSynchronisationInfo-ExtIEs',
        'S-TMSI-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAI-ExtIEs',
        'TAI-Broadcast-Item-ExtIEs',
        'TAI-Cancelled-Item-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'CompletedCellinTAI-Item-ExtIEs',
        'TargeteNB-ID-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TargetNgRanNode-ID-ExtIEs',
        'GNB-ExtIEs',
        'Global-GNB-ID-ExtIEs',
        'NG-eNB-ExtIEs',
        'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'TraceActivation-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UEAggregate-MaximumBitrates-ExtIEs',
        'UEAppLayerMeasConfig-ExtIEs',
        'UE-S1AP-ID-pair-ExtIEs',
        'UE-associatedLogicalS1-ConnectionItemExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'UL-CP-SecurityInformation-ExtIEs',
        'UserLocationInformation-ExtIEs',
        'V2XServicesAuthorized-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        'WUS-Assistance-Information-ExtIEs',
        'X2TNLConfigurationInfo-ExtIEs',
        'ENBX2ExtTLA-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'Additional-GUTI-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'InformationForCECapableUEs-ExtIEs',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'Bearers-SubjectToStatusTransfer-ItemIEs',
        'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'CancelledCellinEAI-Item-ExtIEs',
        'CancelledCellinTAI-Item-ExtIEs',
        'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        'CellID-Broadcast-Item-ExtIEs',
        'CellID-Cancelled-Item-ExtIEs',
        'CellBasedMDT-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'Cdma2000OneXSRVCCInfo-ExtIEs',
        'CellType-ExtIEs',
        'CGI-ExtIEs',
        'CNTypeRestrictions-Item-ExtIEs',
        'ConnectedengNBItem-ExtIEs',
        'ContextatSource-ExtIEs',
        'CSG-IdList-Item-ExtIEs',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoListIEs',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'ServedDCNsItem-ExtIEs',
        'DL-CP-SecurityInformation-ExtIEs',
        'EmergencyAreaID-Broadcast-Item-ExtIEs',
        'EmergencyAreaID-Cancelled-Item-ExtIEs',
        'CompletedCellinEAI-Item-ExtIEs',
        'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'GERAN-Cell-ID-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'Global-en-gNB-ID-ExtIEs',
        'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        'EN-DCSONConfigurationTransfer-ExtIEs',
        'EN-DCTransferTypeRequest-ExtIEs',
        'EN-DCTransferTypeReply-ExtIEs',
        'EN-DCSONeNBIdentification-ExtIEs',
        'EN-DCSONengNBIdentification-ExtIEs',
        'E-RABInformationListIEs',
        'E-RABInformationListItem-ExtIEs',
        'E-RABItemIEs',
        'E-RABItem-ExtIEs',
        'E-RABSecurityResultListIEs',
        'E-RABSecurityResultItem-ExtIEs',
        'E-RABUsageReportItemIEs',
        'E-RABUsageReportItem-ExtIEs',
        'E-RABQoSParameters-ExtIEs',
        'EUTRAN-CGI-ExtIEs',
        'EventL1LoggedMDTConfig-ExtIEs',
        'EventTrigger-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'FiveGSTAI-ExtIEs',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenLAs-Item-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GUMMEI-ExtIEs',
        'HandoverRestrictionList-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        'IntersystemMeasurementConfiguration-ExtIEs',
        'InterSystemMeasurementParameters-ExtIEs',
        'InterSystemMeasurementItem-ExtIEs',
        'LAI-ExtIEs',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LastVisitedPSCellInformation-ExtIEs',
        'ListeningSubframePattern-ExtIEs',
        'LoggedMDT-ExtIEs',
        'LoggedMBSFNMDT-ExtIEs',
        'LTE-NTN-TAI-Information-ExtIEs',
        'M3Configuration-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MBSFN-ResultToLogInfo-ExtIEs',
        'MDTMode-ExtensionIE',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'MutingPatternInformation-ExtIEs',
        'NB-IoT-Paging-eDRXInformation-ExtIEs',
        'NR-CGI-ExtIEs',
        'NRUESecurityCapabilities-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'PagingAttemptInformation-ExtIEs',
        'Paging-eDRXInformation-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'ProSeAuthorized-ExtIEs',
        'PSCellInformation-ExtIEs',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellItemIEs',
        'RecommendedCellsForPagingItem-ExtIEs',
        'RecommendedENBsForPaging-ExtIEs',
        'RecommendedENBItemIEs',
        'RecommendedENBItem-ExtIEs',
        'RAT-RestrictionsItem-ExtIEs',
        'RequestType-ExtIEs',
        'RIMTransfer-ExtIEs',
        'RLFReportInformation-ExtIEs',
        'SecurityContext-ExtIEs',
        'SecondaryRATDataUsageReportItemIEs',
        'SecondaryRATDataUsageReportItem-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'SONInformation-ExtensionIE',
        'SONInformationReply-ExtIEs',
        'SONConfigurationTransfer-ExtIEs',
        'SynchronisationInformation-ExtIEs',
        'SourceeNB-ID-ExtIEs',
        'SourceNodeID-ExtensionIE',
        'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        'SourceNgRanNode-ID-ExtIEs',
        'ServedGUMMEIsItem-ExtIEs',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SupportedTAs-Item-ExtIEs',
        'TimeSynchronisationInfo-ExtIEs',
        'S-TMSI-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAI-ExtIEs',
        'TAI-Broadcast-Item-ExtIEs',
        'TAI-Cancelled-Item-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'CompletedCellinTAI-Item-ExtIEs',
        'TargeteNB-ID-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TargetNgRanNode-ID-ExtIEs',
        'GNB-ExtIEs',
        'Global-GNB-ID-ExtIEs',
        'NG-eNB-ExtIEs',
        'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'TraceActivation-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UEAggregate-MaximumBitrates-ExtIEs',
        'UEAppLayerMeasConfig-ExtIEs',
        'UE-S1AP-ID-pair-ExtIEs',
        'UE-associatedLogicalS1-ConnectionItemExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'UL-CP-SecurityInformation-ExtIEs',
        'UserLocationInformation-ExtIEs',
        'V2XServicesAuthorized-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        'WUS-Assistance-Information-ExtIEs',
        'X2TNLConfigurationInfo-ExtIEs',
        'ENBX2ExtTLA-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< Additional-GUTI >-----#
    Additional_GUTI = SEQ(name='Additional-GUTI', mode=MODE_TYPE)
    _Additional_GUTI_gUMMEI = SEQ(name='gUMMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _Additional_GUTI_m_TMSI = OCT_STR(name='m-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M-TMSI')))
    _Additional_GUTI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_GUTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Additional_GUTI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_GUTI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__id._const_tab = ____Additional_GUTI_iE_Extensions__item__id_tab
    ___Additional_GUTI_iE_Extensions__item__id._const_tab_at = None
    ___Additional_GUTI_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_GUTI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_GUTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab = ____Additional_GUTI_iE_Extensions__item__criticality_tab
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_GUTI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_GUTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab = ____Additional_GUTI_iE_Extensions__item__extensionValue_tab
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_GUTI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_GUTI_iE_Extensions__item__id),
        ('criticality', ___Additional_GUTI_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_GUTI_iE_Extensions__item__extensionValue),
        ])
    __Additional_GUTI_iE_Extensions__item_._ext = None
    _Additional_GUTI_iE_Extensions._cont = __Additional_GUTI_iE_Extensions__item_
    _Additional_GUTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_GUTI._cont = ASN1Dict([
        ('gUMMEI', _Additional_GUTI_gUMMEI),
        ('m-TMSI', _Additional_GUTI_m_TMSI),
        ('iE-Extensions', _Additional_GUTI_iE_Extensions),
        ])
    Additional_GUTI._ext = []
    
    #-----< Additional-GUTI-ExtIEs >-----#
    Additional_GUTI_ExtIEs = CLASS(name='Additional-GUTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Additional_GUTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name='AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AerialUEsubscriptionInformation >-----#
    AerialUEsubscriptionInformation = ENUM(name='AerialUEsubscriptionInformation', mode=MODE_TYPE)
    AerialUEsubscriptionInformation._cont = ASN1Dict([('allowed', 0), ('not-allowed', 1)])
    AerialUEsubscriptionInformation._ext = []
    
    #-----< AreaScopeOfMDT >-----#
    AreaScopeOfMDT = CHOICE(name='AreaScopeOfMDT', mode=MODE_TYPE)
    _AreaScopeOfMDT_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellBasedMDT')))
    _AreaScopeOfMDT_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_pLMNWide = NULL(name='pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIBasedMDT')))
    AreaScopeOfMDT._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfMDT_cellBased),
        ('tABased', _AreaScopeOfMDT_tABased),
        ('pLMNWide', _AreaScopeOfMDT_pLMNWide),
        ('tAIBased', _AreaScopeOfMDT_tAIBased),
        ])
    AreaScopeOfMDT._ext = ['tAIBased']
    
    #-----< AreaScopeOfQMC >-----#
    AreaScopeOfQMC = CHOICE(name='AreaScopeOfQMC', mode=MODE_TYPE)
    _AreaScopeOfQMC_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellBasedQMC')))
    _AreaScopeOfQMC_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TABasedQMC')))
    _AreaScopeOfQMC_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIBasedQMC')))
    _AreaScopeOfQMC_pLMNAreaBased = SEQ(name='pLMNAreaBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNAreaBasedQMC')))
    AreaScopeOfQMC._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfQMC_cellBased),
        ('tABased', _AreaScopeOfQMC_tABased),
        ('tAIBased', _AreaScopeOfQMC_tAIBased),
        ('pLMNAreaBased', _AreaScopeOfQMC_pLMNAreaBased),
        ])
    AreaScopeOfQMC._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name='AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name='AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForCECapableUEs >-----#
    AssistanceDataForCECapableUEs = SEQ(name='AssistanceDataForCECapableUEs', mode=MODE_TYPE)
    _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs = SEQ(name='cellIdentifierAndCELevelForCECapableUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _AssistanceDataForCECapableUEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForCECapableUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceDataForCECapableUEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceDataForCECapableUEs_iE_Extensions__item__id),
        ('criticality', ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForCECapableUEs_iE_Extensions__item_._ext = None
    _AssistanceDataForCECapableUEs_iE_Extensions._cont = __AssistanceDataForCECapableUEs_iE_Extensions__item_
    _AssistanceDataForCECapableUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForCECapableUEs._cont = ASN1Dict([
        ('cellIdentifierAndCELevelForCECapableUEs', _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs),
        ('iE-Extensions', _AssistanceDataForCECapableUEs_iE_Extensions),
        ])
    AssistanceDataForCECapableUEs._ext = []
    
    #-----< InformationForCECapableUEs-ExtIEs >-----#
    InformationForCECapableUEs_ExtIEs = CLASS(name='InformationForCECapableUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InformationForCECapableUEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForPaging >-----#
    AssistanceDataForPaging = SEQ(name='AssistanceDataForPaging', mode=MODE_TYPE)
    _AssistanceDataForPaging_assistanceDataForRecommendedCells = SEQ(name='assistanceDataForRecommendedCells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForRecommendedCells')), opt=True)
    _AssistanceDataForPaging_assistanceDataForCECapableUEs = SEQ(name='assistanceDataForCECapableUEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForCECapableUEs')), opt=True)
    _AssistanceDataForPaging_pagingAttemptInformation = SEQ(name='pagingAttemptInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingAttemptInformation')), opt=True)
    _AssistanceDataForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceDataForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceDataForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceDataForPaging_iE_Extensions__item__id),
        ('criticality', ___AssistanceDataForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceDataForPaging_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForPaging_iE_Extensions__item_._ext = None
    _AssistanceDataForPaging_iE_Extensions._cont = __AssistanceDataForPaging_iE_Extensions__item_
    _AssistanceDataForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForPaging._cont = ASN1Dict([
        ('assistanceDataForRecommendedCells', _AssistanceDataForPaging_assistanceDataForRecommendedCells),
        ('assistanceDataForCECapableUEs', _AssistanceDataForPaging_assistanceDataForCECapableUEs),
        ('pagingAttemptInformation', _AssistanceDataForPaging_pagingAttemptInformation),
        ('iE-Extensions', _AssistanceDataForPaging_iE_Extensions),
        ])
    AssistanceDataForPaging._ext = []
    
    #-----< AssistanceDataForPaging-ExtIEs >-----#
    AssistanceDataForPaging_ExtIEs = CLASS(name='AssistanceDataForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AssistanceDataForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForRecommendedCells >-----#
    AssistanceDataForRecommendedCells = SEQ(name='AssistanceDataForRecommendedCells', mode=MODE_TYPE)
    _AssistanceDataForRecommendedCells_recommendedCellsForPaging = SEQ(name='recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellsForPaging')))
    _AssistanceDataForRecommendedCells_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForRecommendedCells_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceDataForRecommendedCells_iE_Extensions__item__id),
        ('criticality', ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._ext = None
    _AssistanceDataForRecommendedCells_iE_Extensions._cont = __AssistanceDataForRecommendedCells_iE_Extensions__item_
    _AssistanceDataForRecommendedCells_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForRecommendedCells._cont = ASN1Dict([
        ('recommendedCellsForPaging', _AssistanceDataForRecommendedCells_recommendedCellsForPaging),
        ('iE-Extensions', _AssistanceDataForRecommendedCells_iE_Extensions),
        ])
    AssistanceDataForRecommendedCells._ext = []
    
    #-----< AssistanceDataForRecommendedCells-ExtIEs >-----#
    AssistanceDataForRecommendedCells_ExtIEs = CLASS(name='AssistanceDataForRecommendedCells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AssistanceDataForRecommendedCells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToStatusTransferList >-----#
    Bearers_SubjectToStatusTransferList = SEQ_OF(name='Bearers-SubjectToStatusTransferList', mode=MODE_TYPE)
    _Bearers_SubjectToStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Bearers_SubjectToStatusTransferList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___Bearers_SubjectToStatusTransferList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransfer-Item')))
    ___Bearers_SubjectToStatusTransferList__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Value', ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Bearers_SubjectToStatusTransferList__item__id._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__id._const_tab_at = None
    __Bearers_SubjectToStatusTransferList__item__id._const_tab_id = 'id'
    __Bearers_SubjectToStatusTransferList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab_at = ('..', 'id')
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab_id = 'criticality'
    __Bearers_SubjectToStatusTransferList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __Bearers_SubjectToStatusTransferList__item__value._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__value._const_tab_at = ('..', 'id')
    __Bearers_SubjectToStatusTransferList__item__value._const_tab_id = 'Value'
    _Bearers_SubjectToStatusTransferList__item_._cont = ASN1Dict([
        ('id', __Bearers_SubjectToStatusTransferList__item__id),
        ('criticality', __Bearers_SubjectToStatusTransferList__item__criticality),
        ('value', __Bearers_SubjectToStatusTransferList__item__value),
        ])
    _Bearers_SubjectToStatusTransferList__item_._ext = None
    Bearers_SubjectToStatusTransferList._cont = _Bearers_SubjectToStatusTransferList__item_
    Bearers_SubjectToStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Bearers-SubjectToStatusTransfer-ItemIEs >-----#
    Bearers_SubjectToStatusTransfer_ItemIEs = CLASS(name='Bearers-SubjectToStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransfer-Item')))
    Bearers_SubjectToStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Value', _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToStatusTransfer-Item >-----#
    Bearers_SubjectToStatusTransfer_Item = SEQ(name='Bearers-SubjectToStatusTransfer-Item', mode=MODE_TYPE)
    _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue = SEQ(name='uL-COUNTvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue = SEQ(name='dL-COUNTvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs = BIT_STR(name='receiveStatusofULPDCPSDUs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusofULPDCPSDUs')), opt=True)
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 179), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id),
        ('criticality', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_._ext = None
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions._cont = __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Bearers_SubjectToStatusTransfer_Item._cont = ASN1Dict([
        ('e-RAB-ID', _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID),
        ('uL-COUNTvalue', _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue),
        ('dL-COUNTvalue', _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue),
        ('receiveStatusofULPDCPSDUs', _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs),
        ('iE-Extensions', _Bearers_SubjectToStatusTransfer_Item_iE_Extensions),
        ])
    Bearers_SubjectToStatusTransfer_Item._ext = []
    
    #-----< Bearers-SubjectToStatusTransfer-ItemExtIEs >-----#
    Bearers_SubjectToStatusTransfer_ItemExtIEs = CLASS(name='Bearers-SubjectToStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    Bearers_SubjectToStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 179), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransferList >-----#
    Bearers_SubjectToEarlyStatusTransferList = SEQ_OF(name='Bearers-SubjectToEarlyStatusTransferList', mode=MODE_TYPE)
    _Bearers_SubjectToEarlyStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Bearers_SubjectToEarlyStatusTransferList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransfer-Item')))
    ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab._val = ASN1Set(rv=[dict([('id', 322), ('criticality', 'ignore'), ('Value', ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab_at = None
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab_id = 'id'
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab_at = ('..', 'id')
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab_id = 'criticality'
    __Bearers_SubjectToEarlyStatusTransferList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab_at = ('..', 'id')
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab_id = 'Value'
    _Bearers_SubjectToEarlyStatusTransferList__item_._cont = ASN1Dict([
        ('id', __Bearers_SubjectToEarlyStatusTransferList__item__id),
        ('criticality', __Bearers_SubjectToEarlyStatusTransferList__item__criticality),
        ('value', __Bearers_SubjectToEarlyStatusTransferList__item__value),
        ])
    _Bearers_SubjectToEarlyStatusTransferList__item_._ext = None
    Bearers_SubjectToEarlyStatusTransferList._cont = _Bearers_SubjectToEarlyStatusTransferList__item_
    Bearers_SubjectToEarlyStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-ItemIEs >-----#
    Bearers_SubjectToEarlyStatusTransfer_ItemIEs = CLASS(name='Bearers-SubjectToEarlyStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransfer-Item')))
    Bearers_SubjectToEarlyStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([('id', 322), ('criticality', 'ignore'), ('Value', _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-Item >-----#
    Bearers_SubjectToEarlyStatusTransfer_Item = SEQ(name='Bearers-SubjectToEarlyStatusTransfer-Item', mode=MODE_TYPE)
    _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength = CHOICE(name='dLCOUNT-PDCP-SNlength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DLCOUNT-PDCP-SNlength')))
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id),
        ('criticality', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_._ext = None
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions._cont = __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Bearers_SubjectToEarlyStatusTransfer_Item._cont = ASN1Dict([
        ('e-RAB-ID', _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID),
        ('dLCOUNT-PDCP-SNlength', _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength),
        ('iE-Extensions', _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions),
        ])
    Bearers_SubjectToEarlyStatusTransfer_Item._ext = []
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs >-----#
    Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs = CLASS(name='Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BearerType >-----#
    BearerType = ENUM(name='BearerType', mode=MODE_TYPE)
    BearerType._cont = ASN1Dict([('non-IP', 0)])
    BearerType._ext = []
    
    #-----< BitRate >-----#
    BitRate = INT(name='BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000000)], ev=None, er=[])
    
    #-----< BluetoothMeasurementConfiguration >-----#
    BluetoothMeasurementConfiguration = SEQ(name='BluetoothMeasurementConfiguration', mode=MODE_TYPE)
    _BluetoothMeasurementConfiguration_bluetoothMeasConfig = ENUM(name='bluetoothMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasConfig')))
    _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList = SEQ_OF(name='bluetoothMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasConfigNameList')), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi = ENUM(name='bt-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi._cont = ASN1Dict([('true', 0)])
    _BluetoothMeasurementConfiguration_bt_rssi._ext = []
    _BluetoothMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BluetoothMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._ext = None
    _BluetoothMeasurementConfiguration_iE_Extensions._cont = __BluetoothMeasurementConfiguration_iE_Extensions__item_
    _BluetoothMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasurementConfiguration._cont = ASN1Dict([
        ('bluetoothMeasConfig', _BluetoothMeasurementConfiguration_bluetoothMeasConfig),
        ('bluetoothMeasConfigNameList', _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList),
        ('bt-rssi', _BluetoothMeasurementConfiguration_bt_rssi),
        ('iE-Extensions', _BluetoothMeasurementConfiguration_iE_Extensions),
        ])
    BluetoothMeasurementConfiguration._ext = []
    
    #-----< BluetoothMeasurementConfiguration-ExtIEs >-----#
    BluetoothMeasurementConfiguration_ExtIEs = CLASS(name='BluetoothMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    BluetoothMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfigNameList >-----#
    BluetoothMeasConfigNameList = SEQ_OF(name='BluetoothMeasConfigNameList', mode=MODE_TYPE)
    _BluetoothMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothName')))
    BluetoothMeasConfigNameList._cont = _BluetoothMeasConfigNameList__item_
    BluetoothMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BluetoothMeasConfig >-----#
    BluetoothMeasConfig = ENUM(name='BluetoothMeasConfig', mode=MODE_TYPE)
    BluetoothMeasConfig._cont = ASN1Dict([('setup', 0)])
    BluetoothMeasConfig._ext = []
    
    #-----< BluetoothName >-----#
    BluetoothName = OCT_STR(name='BluetoothName', mode=MODE_TYPE)
    BluetoothName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< BPLMNs >-----#
    BPLMNs = SEQ_OF(name='BPLMNs', mode=MODE_TYPE)
    _BPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    BPLMNs._cont = _BPLMNs__item_
    BPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< BroadcastCancelledAreaList >-----#
    BroadcastCancelledAreaList = CHOICE(name='BroadcastCancelledAreaList', mode=MODE_TYPE)
    _BroadcastCancelledAreaList_cellID_Cancelled = SEQ_OF(name='cellID-Cancelled', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellID-Cancelled')))
    _BroadcastCancelledAreaList_tAI_Cancelled = SEQ_OF(name='tAI-Cancelled', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI-Cancelled')))
    _BroadcastCancelledAreaList_emergencyAreaID_Cancelled = SEQ_OF(name='emergencyAreaID-Cancelled', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Cancelled')))
    BroadcastCancelledAreaList._cont = ASN1Dict([
        ('cellID-Cancelled', _BroadcastCancelledAreaList_cellID_Cancelled),
        ('tAI-Cancelled', _BroadcastCancelledAreaList_tAI_Cancelled),
        ('emergencyAreaID-Cancelled', _BroadcastCancelledAreaList_emergencyAreaID_Cancelled),
        ])
    BroadcastCancelledAreaList._ext = []
    
    #-----< BroadcastCompletedAreaList >-----#
    BroadcastCompletedAreaList = CHOICE(name='BroadcastCompletedAreaList', mode=MODE_TYPE)
    _BroadcastCompletedAreaList_cellID_Broadcast = SEQ_OF(name='cellID-Broadcast', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellID-Broadcast')))
    _BroadcastCompletedAreaList_tAI_Broadcast = SEQ_OF(name='tAI-Broadcast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI-Broadcast')))
    _BroadcastCompletedAreaList_emergencyAreaID_Broadcast = SEQ_OF(name='emergencyAreaID-Broadcast', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Broadcast')))
    BroadcastCompletedAreaList._cont = ASN1Dict([
        ('cellID-Broadcast', _BroadcastCompletedAreaList_cellID_Broadcast),
        ('tAI-Broadcast', _BroadcastCompletedAreaList_tAI_Broadcast),
        ('emergencyAreaID-Broadcast', _BroadcastCompletedAreaList_emergencyAreaID_Broadcast),
        ])
    BroadcastCompletedAreaList._ext = []
    
    #-----< CancelledCellinEAI >-----#
    CancelledCellinEAI = SEQ_OF(name='CancelledCellinEAI', mode=MODE_TYPE)
    _CancelledCellinEAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinEAI-Item')))
    CancelledCellinEAI._cont = _CancelledCellinEAI__item_
    CancelledCellinEAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellinEAI-Item >-----#
    CancelledCellinEAI_Item = SEQ(name='CancelledCellinEAI-Item', mode=MODE_TYPE)
    _CancelledCellinEAI_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CancelledCellinEAI_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellinEAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellinEAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellinEAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellinEAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellinEAI_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellinEAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellinEAI_Item_iE_Extensions__item_._ext = None
    _CancelledCellinEAI_Item_iE_Extensions._cont = __CancelledCellinEAI_Item_iE_Extensions__item_
    _CancelledCellinEAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellinEAI_Item._cont = ASN1Dict([
        ('eCGI', _CancelledCellinEAI_Item_eCGI),
        ('numberOfBroadcasts', _CancelledCellinEAI_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellinEAI_Item_iE_Extensions),
        ])
    CancelledCellinEAI_Item._ext = []
    
    #-----< CancelledCellinEAI-Item-ExtIEs >-----#
    CancelledCellinEAI_Item_ExtIEs = CLASS(name='CancelledCellinEAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CancelledCellinEAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellinTAI >-----#
    CancelledCellinTAI = SEQ_OF(name='CancelledCellinTAI', mode=MODE_TYPE)
    _CancelledCellinTAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinTAI-Item')))
    CancelledCellinTAI._cont = _CancelledCellinTAI__item_
    CancelledCellinTAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellinTAI-Item >-----#
    CancelledCellinTAI_Item = SEQ(name='CancelledCellinTAI-Item', mode=MODE_TYPE)
    _CancelledCellinTAI_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CancelledCellinTAI_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellinTAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellinTAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellinTAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellinTAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellinTAI_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellinTAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellinTAI_Item_iE_Extensions__item_._ext = None
    _CancelledCellinTAI_Item_iE_Extensions._cont = __CancelledCellinTAI_Item_iE_Extensions__item_
    _CancelledCellinTAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellinTAI_Item._cont = ASN1Dict([
        ('eCGI', _CancelledCellinTAI_Item_eCGI),
        ('numberOfBroadcasts', _CancelledCellinTAI_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellinTAI_Item_iE_Extensions),
        ])
    CancelledCellinTAI_Item._ext = []
    
    #-----< CancelledCellinTAI-Item-ExtIEs >-----#
    CancelledCellinTAI_Item_ExtIEs = CLASS(name='CancelledCellinTAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CancelledCellinTAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseTransport')))
    _Cause_nas = ENUM(name='nas', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseNas')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('nas', _Cause_nas),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('not-enough-user-plane-processing-resources', 1), ('hardware-failure', 2), ('om-intervention', 3), ('unspecified', 4), ('unknown-PLMN', 5)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('abstract-syntax-error-falsely-constructed-message', 5), ('unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unspecified', 0), ('tx2relocoverall-expiry', 1), ('successful-handover', 2), ('release-due-to-eutran-generated-reason', 3), ('handover-cancelled', 4), ('partial-handover', 5), ('ho-failure-in-target-EPC-eNB-or-target-system', 6), ('ho-target-not-allowed', 7), ('tS1relocoverall-expiry', 8), ('tS1relocprep-expiry', 9), ('cell-not-available', 10), ('unknown-targetID', 11), ('no-radio-resources-available-in-target-cell', 12), ('unknown-mme-ue-s1ap-id', 13), ('unknown-enb-ue-s1ap-id', 14), ('unknown-pair-ue-s1ap-id', 15), ('handover-desirable-for-radio-reason', 16), ('time-critical-handover', 17), ('resource-optimisation-handover', 18), ('reduce-load-in-serving-cell', 19), ('user-inactivity', 20), ('radio-connection-with-ue-lost', 21), ('load-balancing-tau-required', 22), ('cs-fallback-triggered', 23), ('ue-not-available-for-ps-service', 24), ('radio-resources-not-available', 25), ('failure-in-radio-interface-procedure', 26), ('invalid-qos-combination', 27), ('interrat-redirection', 28), ('interaction-with-other-procedure', 29), ('unknown-E-RAB-ID', 30), ('multiple-E-RAB-ID-instances', 31), ('encryption-and-or-integrity-protection-algorithms-not-supported', 32), ('s1-intra-system-handover-triggered', 33), ('s1-inter-system-handover-triggered', 34), ('x2-handover-triggered', 35), ('redirection-towards-1xRTT', 36), ('not-supported-QCI-value', 37), ('invalid-CSG-Id', 38), ('release-due-to-pre-emption', 39), ('n26-interface-not-available', 40), ('insufficient-ue-capabilities', 41), ('maximum-bearer-pre-emption-rate-exceeded', 42), ('up-integrity-protection-not-possible', 43)])
    CauseRadioNetwork._ext = ['redirection-towards-1xRTT', 'not-supported-QCI-value', 'invalid-CSG-Id', 'release-due-to-pre-emption', 'n26-interface-not-available', 'insufficient-ue-capabilities', 'maximum-bearer-pre-emption-rate-exceeded', 'up-integrity-protection-not-possible']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseNas >-----#
    CauseNas = ENUM(name='CauseNas', mode=MODE_TYPE)
    CauseNas._cont = ASN1Dict([('normal-release', 0), ('authentication-failure', 1), ('detach', 2), ('unspecified', 3), ('csg-subscription-expiry', 4), ('uE-not-in-PLMN-serving-area', 5)])
    CauseNas._ext = ['csg-subscription-expiry', 'uE-not-in-PLMN-serving-area']
    
    #-----< CellAccessMode >-----#
    CellAccessMode = ENUM(name='CellAccessMode', mode=MODE_TYPE)
    CellAccessMode._cont = ASN1Dict([('hybrid', 0)])
    CellAccessMode._ext = []
    
    #-----< CellIdentifierAndCELevelForCECapableUEs >-----#
    CellIdentifierAndCELevelForCECapableUEs = SEQ(name='CellIdentifierAndCELevelForCECapableUEs', mode=MODE_TYPE)
    _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID = SEQ(name='global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellIdentifierAndCELevelForCECapableUEs_cELevel = OCT_STR(name='cELevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CELevel')))
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab_at = None
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id),
        ('criticality', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue),
        ])
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_._ext = None
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions._cont = __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIdentifierAndCELevelForCECapableUEs._cont = ASN1Dict([
        ('global-Cell-ID', _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID),
        ('cELevel', _CellIdentifierAndCELevelForCECapableUEs_cELevel),
        ('iE-Extensions', _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions),
        ])
    CellIdentifierAndCELevelForCECapableUEs._ext = []
    
    #-----< CellIdentifierAndCELevelForCECapableUEs-ExtIEs >-----#
    CellIdentifierAndCELevelForCECapableUEs_ExtIEs = CLASS(name='CellIdentifierAndCELevelForCECapableUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellIdentifierAndCELevelForCECapableUEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CELevel >-----#
    CELevel = OCT_STR(name='CELevel', mode=MODE_TYPE)
    
    #-----< CE-mode-B-SupportIndicator >-----#
    CE_mode_B_SupportIndicator = ENUM(name='CE-mode-B-SupportIndicator', mode=MODE_TYPE)
    CE_mode_B_SupportIndicator._cont = ASN1Dict([('supported', 0)])
    CE_mode_B_SupportIndicator._ext = []
    
    #-----< CellIdentity >-----#
    CellIdentity = BIT_STR(name='CellIdentity', mode=MODE_TYPE)
    CellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< CellID-Broadcast >-----#
    CellID_Broadcast = SEQ_OF(name='CellID-Broadcast', mode=MODE_TYPE)
    _CellID_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellID-Broadcast-Item')))
    CellID_Broadcast._cont = _CellID_Broadcast__item_
    CellID_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellID-Broadcast-Item >-----#
    CellID_Broadcast_Item = SEQ(name='CellID-Broadcast-Item', mode=MODE_TYPE)
    _CellID_Broadcast_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellID_Broadcast_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellID_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellID_Broadcast_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellID_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__id_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellID_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellID_Broadcast_Item_iE_Extensions__item__id),
        ('criticality', ___CellID_Broadcast_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __CellID_Broadcast_Item_iE_Extensions__item_._ext = None
    _CellID_Broadcast_Item_iE_Extensions._cont = __CellID_Broadcast_Item_iE_Extensions__item_
    _CellID_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellID_Broadcast_Item._cont = ASN1Dict([
        ('eCGI', _CellID_Broadcast_Item_eCGI),
        ('iE-Extensions', _CellID_Broadcast_Item_iE_Extensions),
        ])
    CellID_Broadcast_Item._ext = []
    
    #-----< CellID-Broadcast-Item-ExtIEs >-----#
    CellID_Broadcast_Item_ExtIEs = CLASS(name='CellID-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellID_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellID-Cancelled >-----#
    CellID_Cancelled = SEQ_OF(name='CellID-Cancelled', mode=MODE_TYPE)
    _CellID_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellID-Cancelled-Item')))
    CellID_Cancelled._cont = _CellID_Cancelled__item_
    CellID_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellID-Cancelled-Item >-----#
    CellID_Cancelled_Item = SEQ(name='CellID-Cancelled-Item', mode=MODE_TYPE)
    _CellID_Cancelled_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellID_Cancelled_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CellID_Cancelled_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellID_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellID_Cancelled_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellID_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__id_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellID_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellID_Cancelled_Item_iE_Extensions__item__id),
        ('criticality', ___CellID_Cancelled_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __CellID_Cancelled_Item_iE_Extensions__item_._ext = None
    _CellID_Cancelled_Item_iE_Extensions._cont = __CellID_Cancelled_Item_iE_Extensions__item_
    _CellID_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellID_Cancelled_Item._cont = ASN1Dict([
        ('eCGI', _CellID_Cancelled_Item_eCGI),
        ('numberOfBroadcasts', _CellID_Cancelled_Item_numberOfBroadcasts),
        ('iE-Extensions', _CellID_Cancelled_Item_iE_Extensions),
        ])
    CellID_Cancelled_Item._ext = []
    
    #-----< CellID-Cancelled-Item-ExtIEs >-----#
    CellID_Cancelled_Item_ExtIEs = CLASS(name='CellID-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellID_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedMDT >-----#
    CellBasedMDT = SEQ(name='CellBasedMDT', mode=MODE_TYPE)
    _CellBasedMDT_cellIdListforMDT = SEQ_OF(name='cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdListforMDT')))
    _CellBasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__id._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedMDT_iE_Extensions__item__id),
        ('criticality', ___CellBasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_iE_Extensions__item_._ext = None
    _CellBasedMDT_iE_Extensions._cont = __CellBasedMDT_iE_Extensions__item_
    _CellBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT._cont = ASN1Dict([
        ('cellIdListforMDT', _CellBasedMDT_cellIdListforMDT),
        ('iE-Extensions', _CellBasedMDT_iE_Extensions),
        ])
    CellBasedMDT._ext = []
    
    #-----< CellBasedMDT-ExtIEs >-----#
    CellBasedMDT_ExtIEs = CLASS(name='CellBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforMDT >-----#
    CellIdListforMDT = SEQ_OF(name='CellIdListforMDT', mode=MODE_TYPE)
    _CellIdListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    CellIdListforMDT._cont = _CellIdListforMDT__item_
    CellIdListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellBasedQMC >-----#
    CellBasedQMC = SEQ(name='CellBasedQMC', mode=MODE_TYPE)
    _CellBasedQMC_cellIdListforQMC = SEQ_OF(name='cellIdListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdListforQMC')))
    _CellBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__id._const_tab = ____CellBasedQMC_iE_Extensions__item__id_tab
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab = ____CellBasedQMC_iE_Extensions__item__criticality_tab
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____CellBasedQMC_iE_Extensions__item__extensionValue_tab
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedQMC_iE_Extensions__item__id),
        ('criticality', ___CellBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __CellBasedQMC_iE_Extensions__item_._ext = None
    _CellBasedQMC_iE_Extensions._cont = __CellBasedQMC_iE_Extensions__item_
    _CellBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedQMC._cont = ASN1Dict([
        ('cellIdListforQMC', _CellBasedQMC_cellIdListforQMC),
        ('iE-Extensions', _CellBasedQMC_iE_Extensions),
        ])
    CellBasedQMC._ext = []
    
    #-----< CellBasedQMC-ExtIEs >-----#
    CellBasedQMC_ExtIEs = CLASS(name='CellBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforQMC >-----#
    CellIdListforQMC = SEQ_OF(name='CellIdListforQMC', mode=MODE_TYPE)
    _CellIdListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    CellIdListforQMC._cont = _CellIdListforQMC__item_
    CellIdListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cdma2000PDU >-----#
    Cdma2000PDU = OCT_STR(name='Cdma2000PDU', mode=MODE_TYPE)
    
    #-----< Cdma2000RATType >-----#
    Cdma2000RATType = ENUM(name='Cdma2000RATType', mode=MODE_TYPE)
    Cdma2000RATType._cont = ASN1Dict([('hRPD', 0), ('onexRTT', 1)])
    Cdma2000RATType._ext = []
    
    #-----< Cdma2000SectorID >-----#
    Cdma2000SectorID = OCT_STR(name='Cdma2000SectorID', mode=MODE_TYPE)
    
    #-----< Cdma2000HOStatus >-----#
    Cdma2000HOStatus = ENUM(name='Cdma2000HOStatus', mode=MODE_TYPE)
    Cdma2000HOStatus._cont = ASN1Dict([('hOSuccess', 0), ('hOFailure', 1)])
    Cdma2000HOStatus._ext = []
    
    #-----< Cdma2000HORequiredIndication >-----#
    Cdma2000HORequiredIndication = ENUM(name='Cdma2000HORequiredIndication', mode=MODE_TYPE)
    Cdma2000HORequiredIndication._cont = ASN1Dict([('true', 0)])
    Cdma2000HORequiredIndication._ext = []
    
    #-----< Cdma2000OneXSRVCCInfo >-----#
    Cdma2000OneXSRVCCInfo = SEQ(name='Cdma2000OneXSRVCCInfo', mode=MODE_TYPE)
    _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID = OCT_STR(name='cdma2000OneXMEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXMEID')))
    _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI = OCT_STR(name='cdma2000OneXMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXMSI')))
    _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot = OCT_STR(name='cdma2000OneXPilot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXPilot')))
    _Cdma2000OneXSRVCCInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab_at = None
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id),
        ('criticality', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue),
        ])
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_._ext = None
    _Cdma2000OneXSRVCCInfo_iE_Extensions._cont = __Cdma2000OneXSRVCCInfo_iE_Extensions__item_
    _Cdma2000OneXSRVCCInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cdma2000OneXSRVCCInfo._cont = ASN1Dict([
        ('cdma2000OneXMEID', _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID),
        ('cdma2000OneXMSI', _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI),
        ('cdma2000OneXPilot', _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot),
        ('iE-Extensions', _Cdma2000OneXSRVCCInfo_iE_Extensions),
        ])
    Cdma2000OneXSRVCCInfo._ext = []
    
    #-----< Cdma2000OneXSRVCCInfo-ExtIEs >-----#
    Cdma2000OneXSRVCCInfo_ExtIEs = CLASS(name='Cdma2000OneXSRVCCInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Cdma2000OneXSRVCCInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cdma2000OneXMEID >-----#
    Cdma2000OneXMEID = OCT_STR(name='Cdma2000OneXMEID', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXMSI >-----#
    Cdma2000OneXMSI = OCT_STR(name='Cdma2000OneXMSI', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXPilot >-----#
    Cdma2000OneXPilot = OCT_STR(name='Cdma2000OneXPilot', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXRAND >-----#
    Cdma2000OneXRAND = OCT_STR(name='Cdma2000OneXRAND', mode=MODE_TYPE)
    
    #-----< Cell-Size >-----#
    Cell_Size = ENUM(name='Cell-Size', mode=MODE_TYPE)
    Cell_Size._cont = ASN1Dict([('verysmall', 0), ('small', 1), ('medium', 2), ('large', 3)])
    Cell_Size._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name='CellType', mode=MODE_TYPE)
    _CellType_cell_Size = ENUM(name='cell-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cell-Size')))
    _CellType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellType_iE_Extensions__item__id),
        ('criticality', ___CellType_iE_Extensions__item__criticality),
        ('extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        ('cell-Size', _CellType_cell_Size),
        ('iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name='CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI >-----#
    CGI = SEQ(name='CGI', mode=MODE_TYPE)
    _CGI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _CGI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    _CGI_cI = OCT_STR(name='cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CI')))
    _CGI_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')), opt=True)
    _CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__criticality_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__extensionValue_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CGI_iE_Extensions__item__id),
        ('criticality', ___CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        ('pLMNidentity', _CGI_pLMNidentity),
        ('lAC', _CGI_lAC),
        ('cI', _CGI_cI),
        ('rAC', _CGI_rAC),
        ('iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = []
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name='CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CI >-----#
    CI = OCT_STR(name='CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CNDomain >-----#
    CNDomain = ENUM(name='CNDomain', mode=MODE_TYPE)
    CNDomain._cont = ASN1Dict([('ps', 0), ('cs', 1)])
    CNDomain._ext = None
    
    #-----< CNTypeRestrictions >-----#
    CNTypeRestrictions = SEQ_OF(name='CNTypeRestrictions', mode=MODE_TYPE)
    _CNTypeRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions-Item')))
    CNTypeRestrictions._cont = _CNTypeRestrictions__item_
    CNTypeRestrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CNTypeRestrictions-Item >-----#
    CNTypeRestrictions_Item = SEQ(name='CNTypeRestrictions-Item', mode=MODE_TYPE)
    _CNTypeRestrictions_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _CNTypeRestrictions_Item_cNType = ENUM(name='cNType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CNType')))
    _CNTypeRestrictions_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNTypeRestrictions_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CNTypeRestrictions_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab_at = None
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNTypeRestrictions_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNTypeRestrictions_Item_iE_Extensions__item__id),
        ('criticality', ___CNTypeRestrictions_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue),
        ])
    __CNTypeRestrictions_Item_iE_Extensions__item_._ext = None
    _CNTypeRestrictions_Item_iE_Extensions._cont = __CNTypeRestrictions_Item_iE_Extensions__item_
    _CNTypeRestrictions_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNTypeRestrictions_Item._cont = ASN1Dict([
        ('pLMN-Identity', _CNTypeRestrictions_Item_pLMN_Identity),
        ('cNType', _CNTypeRestrictions_Item_cNType),
        ('iE-Extensions', _CNTypeRestrictions_Item_iE_Extensions),
        ])
    CNTypeRestrictions_Item._ext = []
    
    #-----< CNTypeRestrictions-Item-ExtIEs >-----#
    CNTypeRestrictions_Item_ExtIEs = CLASS(name='CNTypeRestrictions-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CNTypeRestrictions_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNType >-----#
    CNType = ENUM(name='CNType', mode=MODE_TYPE)
    CNType._cont = ASN1Dict([('fiveGCForbidden', 0), ('epc-Forbiddden', 1)])
    CNType._ext = ['epc-Forbiddden']
    
    #-----< ConcurrentWarningMessageIndicator >-----#
    ConcurrentWarningMessageIndicator = ENUM(name='ConcurrentWarningMessageIndicator', mode=MODE_TYPE)
    ConcurrentWarningMessageIndicator._cont = ASN1Dict([('true', 0)])
    ConcurrentWarningMessageIndicator._ext = None
    
    #-----< ConnectedengNBList >-----#
    ConnectedengNBList = SEQ_OF(name='ConnectedengNBList', mode=MODE_TYPE)
    _ConnectedengNBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBItem')))
    ConnectedengNBList._cont = _ConnectedengNBList__item_
    ConnectedengNBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ConnectedengNBItem >-----#
    ConnectedengNBItem = SEQ(name='ConnectedengNBItem', mode=MODE_TYPE)
    _ConnectedengNBItem_en_gNB_ID = BIT_STR(name='en-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'En-gNB-ID')))
    _ConnectedengNBItem_supportedTAs = SEQ_OF(name='supportedTAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _ConnectedengNBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConnectedengNBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ConnectedengNBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ConnectedengNBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab = ____ConnectedengNBItem_iE_Extensions__item__id_tab
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab_at = None
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ConnectedengNBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ConnectedengNBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab = ____ConnectedengNBItem_iE_Extensions__item__criticality_tab
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab = ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ConnectedengNBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ConnectedengNBItem_iE_Extensions__item__id),
        ('criticality', ___ConnectedengNBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ConnectedengNBItem_iE_Extensions__item__extensionValue),
        ])
    __ConnectedengNBItem_iE_Extensions__item_._ext = None
    _ConnectedengNBItem_iE_Extensions._cont = __ConnectedengNBItem_iE_Extensions__item_
    _ConnectedengNBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConnectedengNBItem._cont = ASN1Dict([
        ('en-gNB-ID', _ConnectedengNBItem_en_gNB_ID),
        ('supportedTAs', _ConnectedengNBItem_supportedTAs),
        ('iE-Extensions', _ConnectedengNBItem_iE_Extensions),
        ])
    ConnectedengNBItem._ext = []
    
    #-----< ConnectedengNBItem-ExtIEs >-----#
    ConnectedengNBItem_ExtIEs = CLASS(name='ConnectedengNBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ConnectedengNBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContextatSource >-----#
    ContextatSource = SEQ(name='ContextatSource', mode=MODE_TYPE)
    _ContextatSource_sourceNG_RAN_node_ID = CHOICE(name='sourceNG-RAN-node-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _ContextatSource_rAN_UE_NGAP_ID = INT(name='rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAN-UE-NGAP-ID')))
    _ContextatSource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextatSource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ContextatSource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ContextatSource_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__id._const_tab = ____ContextatSource_iE_Extensions__item__id_tab
    ___ContextatSource_iE_Extensions__item__id._const_tab_at = None
    ___ContextatSource_iE_Extensions__item__id._const_tab_id = 'id'
    ___ContextatSource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ContextatSource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__criticality._const_tab = ____ContextatSource_iE_Extensions__item__criticality_tab
    ___ContextatSource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ContextatSource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ContextatSource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ContextatSource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab = ____ContextatSource_iE_Extensions__item__extensionValue_tab
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ContextatSource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ContextatSource_iE_Extensions__item__id),
        ('criticality', ___ContextatSource_iE_Extensions__item__criticality),
        ('extensionValue', ___ContextatSource_iE_Extensions__item__extensionValue),
        ])
    __ContextatSource_iE_Extensions__item_._ext = None
    _ContextatSource_iE_Extensions._cont = __ContextatSource_iE_Extensions__item_
    _ContextatSource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextatSource._cont = ASN1Dict([
        ('sourceNG-RAN-node-ID', _ContextatSource_sourceNG_RAN_node_ID),
        ('rAN-UE-NGAP-ID', _ContextatSource_rAN_UE_NGAP_ID),
        ('iE-Extensions', _ContextatSource_iE_Extensions),
        ])
    ContextatSource._ext = []
    
    #-----< ContextatSource-ExtIEs >-----#
    ContextatSource_ExtIEs = CLASS(name='ContextatSource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ContextatSource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name='Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CSFallbackIndicator >-----#
    CSFallbackIndicator = ENUM(name='CSFallbackIndicator', mode=MODE_TYPE)
    CSFallbackIndicator._cont = ASN1Dict([('cs-fallback-required', 0), ('cs-fallback-high-priority', 1)])
    CSFallbackIndicator._ext = ['cs-fallback-high-priority']
    
    #-----< AdditionalCSFallbackIndicator >-----#
    AdditionalCSFallbackIndicator = ENUM(name='AdditionalCSFallbackIndicator', mode=MODE_TYPE)
    AdditionalCSFallbackIndicator._cont = ASN1Dict([('no-restriction', 0), ('restriction', 1)])
    AdditionalCSFallbackIndicator._ext = []
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name='CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSG-IdList >-----#
    CSG_IdList = SEQ_OF(name='CSG-IdList', mode=MODE_TYPE)
    _CSG_IdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList-Item')))
    CSG_IdList._cont = _CSG_IdList__item_
    CSG_IdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CSG-IdList-Item >-----#
    CSG_IdList_Item = SEQ(name='CSG-IdList-Item', mode=MODE_TYPE)
    _CSG_IdList_Item_cSG_Id = BIT_STR(name='cSG-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _CSG_IdList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSG_IdList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CSG_IdList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CSG_IdList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab = ____CSG_IdList_Item_iE_Extensions__item__id_tab
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab_at = None
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CSG_IdList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSG_IdList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab = ____CSG_IdList_Item_iE_Extensions__item__criticality_tab
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab = ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CSG_IdList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CSG_IdList_Item_iE_Extensions__item__id),
        ('criticality', ___CSG_IdList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CSG_IdList_Item_iE_Extensions__item__extensionValue),
        ])
    __CSG_IdList_Item_iE_Extensions__item_._ext = None
    _CSG_IdList_Item_iE_Extensions._cont = __CSG_IdList_Item_iE_Extensions__item_
    _CSG_IdList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSG_IdList_Item._cont = ASN1Dict([
        ('cSG-Id', _CSG_IdList_Item_cSG_Id),
        ('iE-Extensions', _CSG_IdList_Item_iE_Extensions),
        ])
    CSG_IdList_Item._ext = []
    
    #-----< CSG-IdList-Item-ExtIEs >-----#
    CSG_IdList_Item_ExtIEs = CLASS(name='CSG-IdList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CSG_IdList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name='CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([('member', 0), ('not-member', 1)])
    CSGMembershipStatus._ext = None
    
    #-----< COUNTvalue >-----#
    COUNTvalue = SEQ(name='COUNTvalue', mode=MODE_TYPE)
    _COUNTvalue_pDCP_SN = INT(name='pDCP-SN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SN')))
    _COUNTvalue_hFN = INT(name='hFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFN')))
    _COUNTvalue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvalue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvalue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTvalue_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__id._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvalue_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTvalue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTvalue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab = ____COUNTvalue_iE_Extensions__item__criticality_tab
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTvalue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab = ____COUNTvalue_iE_Extensions__item__extensionValue_tab
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTvalue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTvalue_iE_Extensions__item__id),
        ('criticality', ___COUNTvalue_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTvalue_iE_Extensions__item__extensionValue),
        ])
    __COUNTvalue_iE_Extensions__item_._ext = None
    _COUNTvalue_iE_Extensions._cont = __COUNTvalue_iE_Extensions__item_
    _COUNTvalue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvalue._cont = ASN1Dict([
        ('pDCP-SN', _COUNTvalue_pDCP_SN),
        ('hFN', _COUNTvalue_hFN),
        ('iE-Extensions', _COUNTvalue_iE_Extensions),
        ])
    COUNTvalue._ext = []
    
    #-----< COUNTvalue-ExtIEs >-----#
    COUNTvalue_ExtIEs = CLASS(name='COUNTvalue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTvalue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueExtended >-----#
    COUNTValueExtended = SEQ(name='COUNTValueExtended', mode=MODE_TYPE)
    _COUNTValueExtended_pDCP_SNExtended = INT(name='pDCP-SNExtended', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SNExtended')))
    _COUNTValueExtended_hFNModified = INT(name='hFNModified', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFNModified')))
    _COUNTValueExtended_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueExtended_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueExtended_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTValueExtended_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTValueExtended_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab = ____COUNTValueExtended_iE_Extensions__item__criticality_tab
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTValueExtended_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTValueExtended_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTValueExtended_iE_Extensions__item__id),
        ('criticality', ___COUNTValueExtended_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTValueExtended_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueExtended_iE_Extensions__item_._ext = None
    _COUNTValueExtended_iE_Extensions._cont = __COUNTValueExtended_iE_Extensions__item_
    _COUNTValueExtended_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueExtended._cont = ASN1Dict([
        ('pDCP-SNExtended', _COUNTValueExtended_pDCP_SNExtended),
        ('hFNModified', _COUNTValueExtended_hFNModified),
        ('iE-Extensions', _COUNTValueExtended_iE_Extensions),
        ])
    COUNTValueExtended._ext = []
    
    #-----< COUNTValueExtended-ExtIEs >-----#
    COUNTValueExtended_ExtIEs = CLASS(name='COUNTValueExtended-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTValueExtended_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTvaluePDCP-SNlength18 >-----#
    COUNTvaluePDCP_SNlength18 = SEQ(name='COUNTvaluePDCP-SNlength18', mode=MODE_TYPE)
    _COUNTvaluePDCP_SNlength18_pDCP_SNlength18 = INT(name='pDCP-SNlength18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18 = INT(name='hFNforPDCP-SNlength18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFNforPDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id),
        ('criticality', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue),
        ])
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._ext = None
    _COUNTvaluePDCP_SNlength18_iE_Extensions._cont = __COUNTvaluePDCP_SNlength18_iE_Extensions__item_
    _COUNTvaluePDCP_SNlength18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvaluePDCP_SNlength18._cont = ASN1Dict([
        ('pDCP-SNlength18', _COUNTvaluePDCP_SNlength18_pDCP_SNlength18),
        ('hFNforPDCP-SNlength18', _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18),
        ('iE-Extensions', _COUNTvaluePDCP_SNlength18_iE_Extensions),
        ])
    COUNTvaluePDCP_SNlength18._ext = []
    
    #-----< COUNTvaluePDCP-SNlength18-ExtIEs >-----#
    COUNTvaluePDCP_SNlength18_ExtIEs = CLASS(name='COUNTvaluePDCP-SNlength18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTvaluePDCP_SNlength18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Coverage-Level >-----#
    Coverage_Level = ENUM(name='Coverage-Level', mode=MODE_TYPE)
    Coverage_Level._cont = ASN1Dict([('extendedcoverage', 0)])
    Coverage_Level._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name='CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        ('iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        ('iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        ('typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        ('iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name='DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dAPSIndicator = ENUM(name='dAPSIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dAPSIndicator._cont = ASN1Dict([('dAPS-HO-required', 0)])
    _DAPSRequestInfo_dAPSIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSRequestInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        ('dAPSIndicator', _DAPSRequestInfo_dAPSIndicator),
        ('iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name='DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoList >-----#
    DAPSResponseInfoList = SEQ_OF(name='DAPSResponseInfoList', mode=MODE_TYPE)
    _DAPSResponseInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DAPSResponseInfoList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___DAPSResponseInfoList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____DAPSResponseInfoList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoItem')))
    ___DAPSResponseInfoList__item__id_tab._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'ignore'), ('Value', ____DAPSResponseInfoList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __DAPSResponseInfoList__item__id._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__id._const_tab_at = None
    __DAPSResponseInfoList__item__id._const_tab_id = 'id'
    __DAPSResponseInfoList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __DAPSResponseInfoList__item__criticality._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__criticality._const_tab_at = ('..', 'id')
    __DAPSResponseInfoList__item__criticality._const_tab_id = 'criticality'
    __DAPSResponseInfoList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __DAPSResponseInfoList__item__value._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__value._const_tab_at = ('..', 'id')
    __DAPSResponseInfoList__item__value._const_tab_id = 'Value'
    _DAPSResponseInfoList__item_._cont = ASN1Dict([
        ('id', __DAPSResponseInfoList__item__id),
        ('criticality', __DAPSResponseInfoList__item__criticality),
        ('value', __DAPSResponseInfoList__item__value),
        ])
    _DAPSResponseInfoList__item_._ext = None
    DAPSResponseInfoList._cont = _DAPSResponseInfoList__item_
    DAPSResponseInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DAPSResponseInfoListIEs >-----#
    DAPSResponseInfoListIEs = CLASS(name='DAPSResponseInfoListIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DAPSResponseInfoListIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoItem')))
    DAPSResponseInfoListIEs._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'ignore'), ('Value', _DAPSResponseInfoListIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoItem >-----#
    DAPSResponseInfoItem = SEQ(name='DAPSResponseInfoItem', mode=MODE_TYPE)
    _DAPSResponseInfoItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _DAPSResponseInfoItem_dAPSResponseInfo = SEQ(name='dAPSResponseInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfo')))
    _DAPSResponseInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSResponseInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__id_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSResponseInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSResponseInfoItem_iE_Extensions__item__id),
        ('criticality', ___DAPSResponseInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfoItem_iE_Extensions__item_._ext = None
    _DAPSResponseInfoItem_iE_Extensions._cont = __DAPSResponseInfoItem_iE_Extensions__item_
    _DAPSResponseInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfoItem._cont = ASN1Dict([
        ('e-RAB-ID', _DAPSResponseInfoItem_e_RAB_ID),
        ('dAPSResponseInfo', _DAPSResponseInfoItem_dAPSResponseInfo),
        ('iE-Extensions', _DAPSResponseInfoItem_iE_Extensions),
        ])
    DAPSResponseInfoItem._ext = []
    
    #-----< DAPSResponseInfoItem-ExtIEs >-----#
    DAPSResponseInfoItem_ExtIEs = CLASS(name='DAPSResponseInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSResponseInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfo >-----#
    DAPSResponseInfo = SEQ(name='DAPSResponseInfo', mode=MODE_TYPE)
    _DAPSResponseInfo_dapsresponseindicator = ENUM(name='dapsresponseindicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSResponseInfo_dapsresponseindicator._cont = ASN1Dict([('dAPS-HO-accepted', 0), ('dAPS-HO-not-accepted', 1)])
    _DAPSResponseInfo_dapsresponseindicator._ext = []
    _DAPSResponseInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab = ____DAPSResponseInfo_iE_Extensions__item__id_tab
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSResponseInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfo_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSResponseInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSResponseInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSResponseInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSResponseInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfo_iE_Extensions__item_._ext = None
    _DAPSResponseInfo_iE_Extensions._cont = __DAPSResponseInfo_iE_Extensions__item_
    _DAPSResponseInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfo._cont = ASN1Dict([
        ('dapsresponseindicator', _DAPSResponseInfo_dapsresponseindicator),
        ('iE-Extensions', _DAPSResponseInfo_iE_Extensions),
        ])
    DAPSResponseInfo._ext = []
    
    #-----< DAPSResponseInfo-ExtIEs >-----#
    DAPSResponseInfo_ExtIEs = CLASS(name='DAPSResponseInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSResponseInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataCodingScheme >-----#
    DataCodingScheme = BIT_STR(name='DataCodingScheme', mode=MODE_TYPE)
    DataCodingScheme._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DataSize >-----#
    DataSize = INT(name='DataSize', mode=MODE_TYPE)
    DataSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< DCN-ID >-----#
    DCN_ID = INT(name='DCN-ID', mode=MODE_TYPE)
    DCN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ServedDCNs >-----#
    ServedDCNs = SEQ_OF(name='ServedDCNs', mode=MODE_TYPE)
    _ServedDCNs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNsItem')))
    ServedDCNs._cont = _ServedDCNs__item_
    ServedDCNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< ServedDCNsItem >-----#
    ServedDCNsItem = SEQ(name='ServedDCNsItem', mode=MODE_TYPE)
    _ServedDCNsItem_dCN_ID = INT(name='dCN-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _ServedDCNsItem_relativeDCNCapacity = INT(name='relativeDCNCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _ServedDCNsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedDCNsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ServedDCNsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedDCNsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab = ____ServedDCNsItem_iE_Extensions__item__id_tab
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedDCNsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedDCNsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab = ____ServedDCNsItem_iE_Extensions__item__criticality_tab
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedDCNsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab = ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedDCNsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedDCNsItem_iE_Extensions__item__id),
        ('criticality', ___ServedDCNsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedDCNsItem_iE_Extensions__item__extensionValue),
        ])
    __ServedDCNsItem_iE_Extensions__item_._ext = None
    _ServedDCNsItem_iE_Extensions._cont = __ServedDCNsItem_iE_Extensions__item_
    _ServedDCNsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedDCNsItem._cont = ASN1Dict([
        ('dCN-ID', _ServedDCNsItem_dCN_ID),
        ('relativeDCNCapacity', _ServedDCNsItem_relativeDCNCapacity),
        ('iE-Extensions', _ServedDCNsItem_iE_Extensions),
        ])
    ServedDCNsItem._ext = []
    
    #-----< ServedDCNsItem-ExtIEs >-----#
    ServedDCNsItem_ExtIEs = CLASS(name='ServedDCNsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ServedDCNsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CP-SecurityInformation >-----#
    DL_CP_SecurityInformation = SEQ(name='DL-CP-SecurityInformation', mode=MODE_TYPE)
    _DL_CP_SecurityInformation_dl_NAS_MAC = BIT_STR(name='dl-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DL-NAS-MAC')))
    _DL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DL_CP_SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CP_SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___DL_CP_SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __DL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _DL_CP_SecurityInformation_iE_Extensions._cont = __DL_CP_SecurityInformation_iE_Extensions__item_
    _DL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CP_SecurityInformation._cont = ASN1Dict([
        ('dl-NAS-MAC', _DL_CP_SecurityInformation_dl_NAS_MAC),
        ('iE-Extensions', _DL_CP_SecurityInformation_iE_Extensions),
        ])
    DL_CP_SecurityInformation._ext = []
    
    #-----< DL-CP-SecurityInformation-ExtIEs >-----#
    DL_CP_SecurityInformation_ExtIEs = CLASS(name='DL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Forwarding >-----#
    DL_Forwarding = ENUM(name='DL-Forwarding', mode=MODE_TYPE)
    DL_Forwarding._cont = ASN1Dict([('dL-Forwarding-proposed', 0)])
    DL_Forwarding._ext = []
    
    #-----< DL-NAS-MAC >-----#
    DL_NAS_MAC = BIT_STR(name='DL-NAS-MAC', mode=MODE_TYPE)
    DL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< DLCOUNT-PDCP-SNlength >-----#
    DLCOUNT_PDCP_SNlength = CHOICE(name='DLCOUNT-PDCP-SNlength', mode=MODE_TYPE)
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12 = SEQ(name='dLCOUNTValuePDCP-SNlength12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15 = SEQ(name='dLCOUNTValuePDCP-SNlength15', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18 = SEQ(name='dLCOUNTValuePDCP-SNlength18', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    DLCOUNT_PDCP_SNlength._cont = ASN1Dict([
        ('dLCOUNTValuePDCP-SNlength12', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12),
        ('dLCOUNTValuePDCP-SNlength15', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15),
        ('dLCOUNTValuePDCP-SNlength18', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18),
        ])
    DLCOUNT_PDCP_SNlength._ext = []
    
    #-----< Direct-Forwarding-Path-Availability >-----#
    Direct_Forwarding_Path_Availability = ENUM(name='Direct-Forwarding-Path-Availability', mode=MODE_TYPE)
    Direct_Forwarding_Path_Availability._cont = ASN1Dict([('directPathAvailable', 0)])
    Direct_Forwarding_Path_Availability._ext = []
    
    #-----< Data-Forwarding-Not-Possible >-----#
    Data_Forwarding_Not_Possible = ENUM(name='Data-Forwarding-Not-Possible', mode=MODE_TYPE)
    Data_Forwarding_Not_Possible._cont = ASN1Dict([('data-Forwarding-not-Possible', 0)])
    Data_Forwarding_Not_Possible._ext = []
    
    #-----< DLNASPDUDeliveryAckRequest >-----#
    DLNASPDUDeliveryAckRequest = ENUM(name='DLNASPDUDeliveryAckRequest', mode=MODE_TYPE)
    DLNASPDUDeliveryAckRequest._cont = ASN1Dict([('requested', 0)])
    DLNASPDUDeliveryAckRequest._ext = []
    
    #-----< EARFCN >-----#
    EARFCN = INT(name='EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=[], er=[])
    
    #-----< ECGIList >-----#
    ECGIList = SEQ_OF(name='ECGIList', mode=MODE_TYPE)
    _ECGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGIList._cont = _ECGIList__item_
    ECGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PWSfailedECGIList >-----#
    PWSfailedECGIList = SEQ_OF(name='PWSfailedECGIList', mode=MODE_TYPE)
    _PWSfailedECGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    PWSfailedECGIList._cont = _PWSfailedECGIList__item_
    PWSfailedECGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EDT-Session >-----#
    EDT_Session = ENUM(name='EDT-Session', mode=MODE_TYPE)
    EDT_Session._cont = ASN1Dict([('true', 0)])
    EDT_Session._ext = []
    
    #-----< EmergencyAreaIDList >-----#
    EmergencyAreaIDList = SEQ_OF(name='EmergencyAreaIDList', mode=MODE_TYPE)
    _EmergencyAreaIDList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDList._cont = _EmergencyAreaIDList__item_
    EmergencyAreaIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID >-----#
    EmergencyAreaID = OCT_STR(name='EmergencyAreaID', mode=MODE_TYPE)
    EmergencyAreaID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< EmergencyAreaID-Broadcast >-----#
    EmergencyAreaID_Broadcast = SEQ_OF(name='EmergencyAreaID-Broadcast', mode=MODE_TYPE)
    _EmergencyAreaID_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Broadcast-Item')))
    EmergencyAreaID_Broadcast._cont = _EmergencyAreaID_Broadcast__item_
    EmergencyAreaID_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID-Broadcast-Item >-----#
    EmergencyAreaID_Broadcast_Item = SEQ(name='EmergencyAreaID-Broadcast-Item', mode=MODE_TYPE)
    _EmergencyAreaID_Broadcast_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaID_Broadcast_Item_completedCellinEAI = SEQ_OF(name='completedCellinEAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinEAI')))
    _EmergencyAreaID_Broadcast_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaID_Broadcast_Item_iE_Extensions._cont = __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_
    _EmergencyAreaID_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaID_Broadcast_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaID_Broadcast_Item_emergencyAreaID),
        ('completedCellinEAI', _EmergencyAreaID_Broadcast_Item_completedCellinEAI),
        ('iE-Extensions', _EmergencyAreaID_Broadcast_Item_iE_Extensions),
        ])
    EmergencyAreaID_Broadcast_Item._ext = []
    
    #-----< EmergencyAreaID-Broadcast-Item-ExtIEs >-----#
    EmergencyAreaID_Broadcast_Item_ExtIEs = CLASS(name='EmergencyAreaID-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EmergencyAreaID_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaID-Cancelled >-----#
    EmergencyAreaID_Cancelled = SEQ_OF(name='EmergencyAreaID-Cancelled', mode=MODE_TYPE)
    _EmergencyAreaID_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Cancelled-Item')))
    EmergencyAreaID_Cancelled._cont = _EmergencyAreaID_Cancelled__item_
    EmergencyAreaID_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID-Cancelled-Item >-----#
    EmergencyAreaID_Cancelled_Item = SEQ(name='EmergencyAreaID-Cancelled-Item', mode=MODE_TYPE)
    _EmergencyAreaID_Cancelled_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI = SEQ_OF(name='cancelledCellinEAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinEAI')))
    _EmergencyAreaID_Cancelled_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaID_Cancelled_Item_iE_Extensions._cont = __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_
    _EmergencyAreaID_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaID_Cancelled_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaID_Cancelled_Item_emergencyAreaID),
        ('cancelledCellinEAI', _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI),
        ('iE-Extensions', _EmergencyAreaID_Cancelled_Item_iE_Extensions),
        ])
    EmergencyAreaID_Cancelled_Item._ext = []
    
    #-----< EmergencyAreaID-Cancelled-Item-ExtIEs >-----#
    EmergencyAreaID_Cancelled_Item_ExtIEs = CLASS(name='EmergencyAreaID-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EmergencyAreaID_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellinEAI >-----#
    CompletedCellinEAI = SEQ_OF(name='CompletedCellinEAI', mode=MODE_TYPE)
    _CompletedCellinEAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinEAI-Item')))
    CompletedCellinEAI._cont = _CompletedCellinEAI__item_
    CompletedCellinEAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellinEAI-Item >-----#
    CompletedCellinEAI_Item = SEQ(name='CompletedCellinEAI-Item', mode=MODE_TYPE)
    _CompletedCellinEAI_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CompletedCellinEAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellinEAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellinEAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellinEAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellinEAI_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellinEAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellinEAI_Item_iE_Extensions__item_._ext = None
    _CompletedCellinEAI_Item_iE_Extensions._cont = __CompletedCellinEAI_Item_iE_Extensions__item_
    _CompletedCellinEAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellinEAI_Item._cont = ASN1Dict([
        ('eCGI', _CompletedCellinEAI_Item_eCGI),
        ('iE-Extensions', _CompletedCellinEAI_Item_iE_Extensions),
        ])
    CompletedCellinEAI_Item._ext = []
    
    #-----< CompletedCellinEAI-Item-ExtIEs >-----#
    CompletedCellinEAI_Item_ExtIEs = CLASS(name='CompletedCellinEAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CompletedCellinEAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ECGI-List >-----#
    ECGI_List = SEQ_OF(name='ECGI-List', mode=MODE_TYPE)
    _ECGI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGI_List._cont = _ECGI_List__item_
    ECGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyAreaIDListForRestart >-----#
    EmergencyAreaIDListForRestart = SEQ_OF(name='EmergencyAreaIDListForRestart', mode=MODE_TYPE)
    _EmergencyAreaIDListForRestart__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDListForRestart._cont = _EmergencyAreaIDListForRestart__item_
    EmergencyAreaIDListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyIndicator >-----#
    EmergencyIndicator = ENUM(name='EmergencyIndicator', mode=MODE_TYPE)
    EmergencyIndicator._cont = ASN1Dict([('true', 0)])
    EmergencyIndicator._ext = []
    
    #-----< ENB-EarlyStatusTransfer-TransparentContainer >-----#
    ENB_EarlyStatusTransfer_TransparentContainer = SEQ(name='ENB-EarlyStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList = SEQ_OF(name='bearers-SubjectToEarlyStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransferList')))
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions._cont = __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENB_EarlyStatusTransfer_TransparentContainer._cont = ASN1Dict([
        ('bearers-SubjectToEarlyStatusTransferList', _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList),
        ('iE-Extensions', _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    ENB_EarlyStatusTransfer_TransparentContainer._ext = []
    
    #-----< ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs >-----#
    ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs = CLASS(name='ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name='ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name='macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name='homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name='short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name='long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        ('macroENB-ID', _ENB_ID_macroENB_ID),
        ('homeENB-ID', _ENB_ID_homeENB_ID),
        ('short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        ('long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ])
    ENB_ID._ext = ['short-macroENB-ID', 'long-macroENB-ID']
    
    #-----< En-gNB-ID >-----#
    En_gNB_ID = BIT_STR(name='En-gNB-ID', mode=MODE_TYPE)
    En_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=[], er=[])
    
    #-----< GERAN-Cell-ID >-----#
    GERAN_Cell_ID = SEQ(name='GERAN-Cell-ID', mode=MODE_TYPE)
    _GERAN_Cell_ID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _GERAN_Cell_ID_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')))
    _GERAN_Cell_ID_cI = OCT_STR(name='cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CI')))
    _GERAN_Cell_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Cell_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Cell_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__id_tab
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GERAN_Cell_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GERAN_Cell_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GERAN_Cell_ID_iE_Extensions__item__id),
        ('criticality', ___GERAN_Cell_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GERAN_Cell_ID_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Cell_ID_iE_Extensions__item_._ext = None
    _GERAN_Cell_ID_iE_Extensions._cont = __GERAN_Cell_ID_iE_Extensions__item_
    _GERAN_Cell_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Cell_ID._cont = ASN1Dict([
        ('lAI', _GERAN_Cell_ID_lAI),
        ('rAC', _GERAN_Cell_ID_rAC),
        ('cI', _GERAN_Cell_ID_cI),
        ('iE-Extensions', _GERAN_Cell_ID_iE_Extensions),
        ])
    GERAN_Cell_ID._ext = []
    
    #-----< GERAN-Cell-ID-ExtIEs >-----#
    GERAN_Cell_ID_ExtIEs = CLASS(name='GERAN-Cell-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GERAN_Cell_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-ENB-ID >-----#
    Global_ENB_ID = SEQ(name='Global-ENB-ID', mode=MODE_TYPE)
    _Global_ENB_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_ENB_ID_eNB_ID = CHOICE(name='eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-ID')))
    _Global_ENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_ENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_ENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Global_ENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab = ____Global_ENB_ID_iE_Extensions__item__id_tab
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___Global_ENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab = ____Global_ENB_ID_iE_Extensions__item__criticality_tab
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Global_ENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Global_ENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Global_ENB_ID_iE_Extensions__item__id),
        ('criticality', ___Global_ENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___Global_ENB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_ENB_ID_iE_Extensions__item_._ext = None
    _Global_ENB_ID_iE_Extensions._cont = __Global_ENB_ID_iE_Extensions__item_
    _Global_ENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_ENB_ID._cont = ASN1Dict([
        ('pLMNidentity', _Global_ENB_ID_pLMNidentity),
        ('eNB-ID', _Global_ENB_ID_eNB_ID),
        ('iE-Extensions', _Global_ENB_ID_iE_Extensions),
        ])
    Global_ENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name='GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-en-gNB-ID >-----#
    Global_en_gNB_ID = SEQ(name='Global-en-gNB-ID', mode=MODE_TYPE)
    _Global_en_gNB_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_en_gNB_ID_en_gNB_ID = BIT_STR(name='en-gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'En-gNB-ID')))
    _Global_en_gNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_en_gNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_en_gNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Global_en_gNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__id_tab
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___Global_en_gNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Global_en_gNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Global_en_gNB_ID_iE_Extensions__item__id),
        ('criticality', ___Global_en_gNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___Global_en_gNB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_en_gNB_ID_iE_Extensions__item_._ext = None
    _Global_en_gNB_ID_iE_Extensions._cont = __Global_en_gNB_ID_iE_Extensions__item_
    _Global_en_gNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_en_gNB_ID._cont = ASN1Dict([
        ('pLMNidentity', _Global_en_gNB_ID_pLMNidentity),
        ('en-gNB-ID', _Global_en_gNB_ID_en_gNB_ID),
        ('iE-Extensions', _Global_en_gNB_ID_iE_Extensions),
        ])
    Global_en_gNB_ID._ext = []
    
    #-----< Global-en-gNB-ID-ExtIEs >-----#
    Global_en_gNB_ID_ExtIEs = CLASS(name='Global-en-gNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Global_en_gNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEIList >-----#
    GUMMEIList = SEQ_OF(name='GUMMEIList', mode=MODE_TYPE)
    _GUMMEIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    GUMMEIList._cont = _GUMMEIList__item_
    GUMMEIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ENB-StatusTransfer-TransparentContainer >-----#
    ENB_StatusTransfer_TransparentContainer = SEQ(name='ENB-StatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList = SEQ_OF(name='bearers-SubjectToStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransferList')))
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions._cont = __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENB_StatusTransfer_TransparentContainer._cont = ASN1Dict([
        ('bearers-SubjectToStatusTransferList', _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList),
        ('iE-Extensions', _ENB_StatusTransfer_TransparentContainer_iE_Extensions),
        ])
    ENB_StatusTransfer_TransparentContainer._ext = []
    
    #-----< ENB-StatusTransfer-TransparentContainer-ExtIEs >-----#
    ENB_StatusTransfer_TransparentContainer_ExtIEs = CLASS(name='ENB-StatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENB_StatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-UE-S1AP-ID >-----#
    ENB_UE_S1AP_ID = INT(name='ENB-UE-S1AP-ID', mode=MODE_TYPE)
    ENB_UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< ENBname >-----#
    ENBname = STR_PRINT(name='ENBname', mode=MODE_TYPE)
    ENBname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< ENBX2TLAs >-----#
    ENBX2TLAs = SEQ_OF(name='ENBX2TLAs', mode=MODE_TYPE)
    _ENBX2TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBX2TLAs._cont = _ENBX2TLAs__item_
    ENBX2TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< EncryptionAlgorithms >-----#
    EncryptionAlgorithms = BIT_STR(name='EncryptionAlgorithms', mode=MODE_TYPE)
    EncryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONConfigurationTransfer >-----#
    EN_DCSONConfigurationTransfer = SEQ(name='EN-DCSONConfigurationTransfer', mode=MODE_TYPE)
    _EN_DCSONConfigurationTransfer_transfertype = CHOICE(name='transfertype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONTransferType')))
    _EN_DCSONConfigurationTransfer_sONInformation = CHOICE(name='sONInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation')))
    _EN_DCSONConfigurationTransfer_x2TNLConfigInfo = SEQ(name='x2TNLConfigInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')), opt=True)
    _EN_DCSONConfigurationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id),
        ('criticality', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_._ext = None
    _EN_DCSONConfigurationTransfer_iE_Extensions._cont = __EN_DCSONConfigurationTransfer_iE_Extensions__item_
    _EN_DCSONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONConfigurationTransfer._cont = ASN1Dict([
        ('transfertype', _EN_DCSONConfigurationTransfer_transfertype),
        ('sONInformation', _EN_DCSONConfigurationTransfer_sONInformation),
        ('x2TNLConfigInfo', _EN_DCSONConfigurationTransfer_x2TNLConfigInfo),
        ('iE-Extensions', _EN_DCSONConfigurationTransfer_iE_Extensions),
        ])
    EN_DCSONConfigurationTransfer._ext = []
    
    #-----< EN-DCSONConfigurationTransfer-ExtIEs >-----#
    EN_DCSONConfigurationTransfer_ExtIEs = CLASS(name='EN-DCSONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONTransferType >-----#
    EN_DCSONTransferType = CHOICE(name='EN-DCSONTransferType', mode=MODE_TYPE)
    _EN_DCSONTransferType_request = SEQ(name='request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCTransferTypeRequest')))
    _EN_DCSONTransferType_reply = SEQ(name='reply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCTransferTypeReply')))
    EN_DCSONTransferType._cont = ASN1Dict([
        ('request', _EN_DCSONTransferType_request),
        ('reply', _EN_DCSONTransferType_reply),
        ])
    EN_DCSONTransferType._ext = []
    
    #-----< EN-DCTransferTypeRequest >-----#
    EN_DCTransferTypeRequest = SEQ(name='EN-DCTransferTypeRequest', mode=MODE_TYPE)
    _EN_DCTransferTypeRequest_sourceeNB = SEQ(name='sourceeNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')))
    _EN_DCTransferTypeRequest_targetengNB = SEQ(name='targetengNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONengNBIdentification')))
    _EN_DCTransferTypeRequest_targeteNB = SEQ(name='targeteNB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')), opt=True)
    _EN_DCTransferTypeRequest_associatedTAI = SEQ(name='associatedTAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')), opt=True)
    _EN_DCTransferTypeRequest_broadcast5GSTAI = SEQ(name='broadcast5GSTAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')), opt=True)
    _EN_DCTransferTypeRequest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCTransferTypeRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DCTransferTypeRequest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DCTransferTypeRequest_iE_Extensions__item__id),
        ('criticality', ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue),
        ])
    __EN_DCTransferTypeRequest_iE_Extensions__item_._ext = None
    _EN_DCTransferTypeRequest_iE_Extensions._cont = __EN_DCTransferTypeRequest_iE_Extensions__item_
    _EN_DCTransferTypeRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCTransferTypeRequest._cont = ASN1Dict([
        ('sourceeNB', _EN_DCTransferTypeRequest_sourceeNB),
        ('targetengNB', _EN_DCTransferTypeRequest_targetengNB),
        ('targeteNB', _EN_DCTransferTypeRequest_targeteNB),
        ('associatedTAI', _EN_DCTransferTypeRequest_associatedTAI),
        ('broadcast5GSTAI', _EN_DCTransferTypeRequest_broadcast5GSTAI),
        ('iE-Extensions', _EN_DCTransferTypeRequest_iE_Extensions),
        ])
    EN_DCTransferTypeRequest._ext = []
    
    #-----< EN-DCTransferTypeRequest-ExtIEs >-----#
    EN_DCTransferTypeRequest_ExtIEs = CLASS(name='EN-DCTransferTypeRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCTransferTypeRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCTransferTypeReply >-----#
    EN_DCTransferTypeReply = SEQ(name='EN-DCTransferTypeReply', mode=MODE_TYPE)
    _EN_DCTransferTypeReply_sourceengNB = SEQ(name='sourceengNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONengNBIdentification')))
    _EN_DCTransferTypeReply_targeteNB = SEQ(name='targeteNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')))
    _EN_DCTransferTypeReply_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCTransferTypeReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCTransferTypeReply_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DCTransferTypeReply_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DCTransferTypeReply_iE_Extensions__item__id),
        ('criticality', ___EN_DCTransferTypeReply_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue),
        ])
    __EN_DCTransferTypeReply_iE_Extensions__item_._ext = None
    _EN_DCTransferTypeReply_iE_Extensions._cont = __EN_DCTransferTypeReply_iE_Extensions__item_
    _EN_DCTransferTypeReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCTransferTypeReply._cont = ASN1Dict([
        ('sourceengNB', _EN_DCTransferTypeReply_sourceengNB),
        ('targeteNB', _EN_DCTransferTypeReply_targeteNB),
        ('iE-Extensions', _EN_DCTransferTypeReply_iE_Extensions),
        ])
    EN_DCTransferTypeReply._ext = []
    
    #-----< EN-DCTransferTypeReply-ExtIEs >-----#
    EN_DCTransferTypeReply_ExtIEs = CLASS(name='EN-DCTransferTypeReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCTransferTypeReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONeNBIdentification >-----#
    EN_DCSONeNBIdentification = SEQ(name='EN-DCSONeNBIdentification', mode=MODE_TYPE)
    _EN_DCSONeNBIdentification_globaleNBID = SEQ(name='globaleNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _EN_DCSONeNBIdentification_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _EN_DCSONeNBIdentification_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONeNBIdentification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DCSONeNBIdentification_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DCSONeNBIdentification_iE_Extensions__item__id),
        ('criticality', ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONeNBIdentification_iE_Extensions__item_._ext = None
    _EN_DCSONeNBIdentification_iE_Extensions._cont = __EN_DCSONeNBIdentification_iE_Extensions__item_
    _EN_DCSONeNBIdentification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONeNBIdentification._cont = ASN1Dict([
        ('globaleNBID', _EN_DCSONeNBIdentification_globaleNBID),
        ('selectedTAI', _EN_DCSONeNBIdentification_selectedTAI),
        ('iE-Extensions', _EN_DCSONeNBIdentification_iE_Extensions),
        ])
    EN_DCSONeNBIdentification._ext = []
    
    #-----< EN-DCSONeNBIdentification-ExtIEs >-----#
    EN_DCSONeNBIdentification_ExtIEs = CLASS(name='EN-DCSONeNBIdentification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONeNBIdentification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONengNBIdentification >-----#
    EN_DCSONengNBIdentification = SEQ(name='EN-DCSONengNBIdentification', mode=MODE_TYPE)
    _EN_DCSONengNBIdentification_globalengNBID = SEQ(name='globalengNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-en-gNB-ID')))
    _EN_DCSONengNBIdentification_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _EN_DCSONengNBIdentification_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONengNBIdentification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DCSONengNBIdentification_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DCSONengNBIdentification_iE_Extensions__item__id),
        ('criticality', ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONengNBIdentification_iE_Extensions__item_._ext = None
    _EN_DCSONengNBIdentification_iE_Extensions._cont = __EN_DCSONengNBIdentification_iE_Extensions__item_
    _EN_DCSONengNBIdentification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONengNBIdentification._cont = ASN1Dict([
        ('globalengNBID', _EN_DCSONengNBIdentification_globalengNBID),
        ('selectedTAI', _EN_DCSONengNBIdentification_selectedTAI),
        ('iE-Extensions', _EN_DCSONengNBIdentification_iE_Extensions),
        ])
    EN_DCSONengNBIdentification._ext = []
    
    #-----< EN-DCSONengNBIdentification-ExtIEs >-----#
    EN_DCSONengNBIdentification_ExtIEs = CLASS(name='EN-DCSONengNBIdentification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONengNBIdentification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EndIndication >-----#
    EndIndication = ENUM(name='EndIndication', mode=MODE_TYPE)
    EndIndication._cont = ASN1Dict([('no-further-data', 0), ('further-data-exists', 1)])
    EndIndication._ext = []
    
    #-----< EnhancedCoverageRestricted >-----#
    EnhancedCoverageRestricted = ENUM(name='EnhancedCoverageRestricted', mode=MODE_TYPE)
    EnhancedCoverageRestricted._cont = ASN1Dict([('restricted', 0)])
    EnhancedCoverageRestricted._ext = []
    
    #-----< CE-ModeBRestricted >-----#
    CE_ModeBRestricted = ENUM(name='CE-ModeBRestricted', mode=MODE_TYPE)
    CE_ModeBRestricted._cont = ASN1Dict([('restricted', 0), ('not-restricted', 1)])
    CE_ModeBRestricted._ext = []
    
    #-----< EPLMNs >-----#
    EPLMNs = SEQ_OF(name='EPLMNs', mode=MODE_TYPE)
    _EPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    EPLMNs._cont = _EPLMNs__item_
    EPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name='EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([('direct', 0), ('change-of-serve-cell', 1), ('stop-change-of-serve-cell', 2)])
    EventType._ext = []
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name='E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RABInformationList >-----#
    E_RABInformationList = SEQ_OF(name='E-RABInformationList', mode=MODE_TYPE)
    _E_RABInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABInformationList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABInformationList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABInformationList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationListItem')))
    ___E_RABInformationList__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', ____E_RABInformationList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABInformationList__item__id._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__id._const_tab_at = None
    __E_RABInformationList__item__id._const_tab_id = 'id'
    __E_RABInformationList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABInformationList__item__criticality._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABInformationList__item__criticality._const_tab_id = 'criticality'
    __E_RABInformationList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABInformationList__item__value._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__value._const_tab_at = ('..', 'id')
    __E_RABInformationList__item__value._const_tab_id = 'Value'
    _E_RABInformationList__item_._cont = ASN1Dict([
        ('id', __E_RABInformationList__item__id),
        ('criticality', __E_RABInformationList__item__criticality),
        ('value', __E_RABInformationList__item__value),
        ])
    _E_RABInformationList__item_._ext = None
    E_RABInformationList._cont = _E_RABInformationList__item_
    E_RABInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABInformationListIEs >-----#
    E_RABInformationListIEs = CLASS(name='E-RABInformationListIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABInformationListIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationListItem')))
    E_RABInformationListIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Value', _E_RABInformationListIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABInformationListItem >-----#
    E_RABInformationListItem = SEQ(name='E-RABInformationListItem', mode=MODE_TYPE)
    _E_RABInformationListItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABInformationListItem_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABInformationListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABInformationListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABInformationListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABInformationListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSRequestInfo')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ____E_RABInformationListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABInformationListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABInformationListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABInformationListItem_iE_Extensions__item__id),
        ('criticality', ___E_RABInformationListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABInformationListItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABInformationListItem_iE_Extensions__item_._ext = None
    _E_RABInformationListItem_iE_Extensions._cont = __E_RABInformationListItem_iE_Extensions__item_
    _E_RABInformationListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABInformationListItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABInformationListItem_e_RAB_ID),
        ('dL-Forwarding', _E_RABInformationListItem_dL_Forwarding),
        ('iE-Extensions', _E_RABInformationListItem_iE_Extensions),
        ])
    E_RABInformationListItem._ext = []
    
    #-----< E-RABInformationListItem-ExtIEs >-----#
    E_RABInformationListItem_ExtIEs = CLASS(name='E-RABInformationListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABInformationListItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSRequestInfo')))
    _E_RABInformationListItem_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABInformationListItem_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    _E_RABInformationListItem_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    E_RABInformationListItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _E_RABInformationListItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _E_RABInformationListItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _E_RABInformationListItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _E_RABInformationListItem_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABList >-----#
    E_RABList = SEQ_OF(name='E-RABList', mode=MODE_TYPE)
    _E_RABList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABItem')))
    ___E_RABList__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'ignore'), ('Value', ____E_RABList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABList__item__id._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__id._const_tab_at = None
    __E_RABList__item__id._const_tab_id = 'id'
    __E_RABList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABList__item__criticality._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABList__item__criticality._const_tab_id = 'criticality'
    __E_RABList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABList__item__value._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__value._const_tab_at = ('..', 'id')
    __E_RABList__item__value._const_tab_id = 'Value'
    _E_RABList__item_._cont = ASN1Dict([
        ('id', __E_RABList__item__id),
        ('criticality', __E_RABList__item__criticality),
        ('value', __E_RABList__item__value),
        ])
    _E_RABList__item_._ext = None
    E_RABList._cont = _E_RABList__item_
    E_RABList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABItemIEs >-----#
    E_RABItemIEs = CLASS(name='E-RABItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABItem')))
    E_RABItemIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'ignore'), ('Value', _E_RABItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABItem >-----#
    E_RABItem = SEQ(name='E-RABItem', mode=MODE_TYPE)
    _E_RABItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__id._const_tab = ____E_RABItem_iE_Extensions__item__id_tab
    ___E_RABItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__criticality._const_tab = ____E_RABItem_iE_Extensions__item__criticality_tab
    ___E_RABItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABItem_iE_Extensions__item__extensionValue_tab
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABItem_iE_Extensions__item__id),
        ('criticality', ___E_RABItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABItem_iE_Extensions__item_._ext = None
    _E_RABItem_iE_Extensions._cont = __E_RABItem_iE_Extensions__item_
    _E_RABItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABItem_e_RAB_ID),
        ('cause', _E_RABItem_cause),
        ('iE-Extensions', _E_RABItem_iE_Extensions),
        ])
    E_RABItem._ext = []
    
    #-----< E-RABItem-ExtIEs >-----#
    E_RABItem_ExtIEs = CLASS(name='E-RABItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABLevelQoSParameters >-----#
    E_RABLevelQoSParameters = SEQ(name='E-RABLevelQoSParameters', mode=MODE_TYPE)
    _E_RABLevelQoSParameters_qCI = INT(name='qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'QCI')))
    _E_RABLevelQoSParameters_allocationRetentionPriority = SEQ(name='allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AllocationAndRetentionPriority')))
    _E_RABLevelQoSParameters_gbrQosInformation = SEQ(name='gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RABLevelQoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABLevelQoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABLevelQoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 273), ('criticality', 'ignore'), ('Extension', _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABLevelQoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABLevelQoSParameters_iE_Extensions__item__id),
        ('criticality', ___E_RABLevelQoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue),
        ])
    __E_RABLevelQoSParameters_iE_Extensions__item_._ext = None
    _E_RABLevelQoSParameters_iE_Extensions._cont = __E_RABLevelQoSParameters_iE_Extensions__item_
    _E_RABLevelQoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABLevelQoSParameters._cont = ASN1Dict([
        ('qCI', _E_RABLevelQoSParameters_qCI),
        ('allocationRetentionPriority', _E_RABLevelQoSParameters_allocationRetentionPriority),
        ('gbrQosInformation', _E_RABLevelQoSParameters_gbrQosInformation),
        ('iE-Extensions', _E_RABLevelQoSParameters_iE_Extensions),
        ])
    E_RABLevelQoSParameters._ext = []
    
    #-----< E-RABSecurityResultList >-----#
    E_RABSecurityResultList = SEQ_OF(name='E-RABSecurityResultList', mode=MODE_TYPE)
    _E_RABSecurityResultList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSecurityResultList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABSecurityResultList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSecurityResultList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABSecurityResultItem')))
    ___E_RABSecurityResultList__item__id_tab._val = ASN1Set(rv=[dict([('id', 334), ('criticality', 'ignore'), ('Value', ____E_RABSecurityResultList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSecurityResultList__item__id._const_tab = ___E_RABSecurityResultList__item__id_tab
    __E_RABSecurityResultList__item__id._const_tab_at = None
    __E_RABSecurityResultList__item__id._const_tab_id = 'id'
    __E_RABSecurityResultList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABSecurityResultList__item__criticality._const_tab = ___E_RABSecurityResultList__item__id_tab
    __E_RABSecurityResultList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABSecurityResultList__item__criticality._const_tab_id = 'criticality'
    __E_RABSecurityResultList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABSecurityResultList__item__value._const_tab = ___E_RABSecurityResultList__item__id_tab
    __E_RABSecurityResultList__item__value._const_tab_at = ('..', 'id')
    __E_RABSecurityResultList__item__value._const_tab_id = 'Value'
    _E_RABSecurityResultList__item_._cont = ASN1Dict([
        ('id', __E_RABSecurityResultList__item__id),
        ('criticality', __E_RABSecurityResultList__item__criticality),
        ('value', __E_RABSecurityResultList__item__value),
        ])
    _E_RABSecurityResultList__item_._ext = None
    E_RABSecurityResultList._cont = _E_RABSecurityResultList__item_
    E_RABSecurityResultList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABSecurityResultListIEs >-----#
    E_RABSecurityResultListIEs = CLASS(name='E-RABSecurityResultListIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSecurityResultListIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABSecurityResultItem')))
    E_RABSecurityResultListIEs._val = ASN1Set(rv=[dict([('id', 334), ('criticality', 'ignore'), ('Value', _E_RABSecurityResultListIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSecurityResultItem >-----#
    E_RABSecurityResultItem = SEQ(name='E-RABSecurityResultItem', mode=MODE_TYPE)
    _E_RABSecurityResultItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABSecurityResultItem_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecurityResult')))
    _E_RABSecurityResultItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABSecurityResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABSecurityResultItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABSecurityResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSecurityResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSecurityResultItem_iE_Extensions__item__id._const_tab = ____E_RABSecurityResultItem_iE_Extensions__item__id_tab
    ___E_RABSecurityResultItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABSecurityResultItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABSecurityResultItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABSecurityResultItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSecurityResultItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSecurityResultItem_iE_Extensions__item__criticality._const_tab = ____E_RABSecurityResultItem_iE_Extensions__item__criticality_tab
    ___E_RABSecurityResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABSecurityResultItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABSecurityResultItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSecurityResultItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABSecurityResultItem_iE_Extensions__item__extensionValue_tab
    ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABSecurityResultItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABSecurityResultItem_iE_Extensions__item__id),
        ('criticality', ___E_RABSecurityResultItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABSecurityResultItem_iE_Extensions__item_._ext = None
    _E_RABSecurityResultItem_iE_Extensions._cont = __E_RABSecurityResultItem_iE_Extensions__item_
    _E_RABSecurityResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABSecurityResultItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABSecurityResultItem_e_RAB_ID),
        ('securityResult', _E_RABSecurityResultItem_securityResult),
        ('iE-Extensions', _E_RABSecurityResultItem_iE_Extensions),
        ])
    E_RABSecurityResultItem._ext = []
    
    #-----< E-RABSecurityResultItem-ExtIEs >-----#
    E_RABSecurityResultItem_ExtIEs = CLASS(name='E-RABSecurityResultItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABSecurityResultItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABUsageReportList >-----#
    E_RABUsageReportList = SEQ_OF(name='E-RABUsageReportList', mode=MODE_TYPE)
    _E_RABUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABUsageReportList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABUsageReportList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABUsageReportList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportItem')))
    ___E_RABUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'ignore'), ('Value', ____E_RABUsageReportList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABUsageReportList__item__id._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__id._const_tab_at = None
    __E_RABUsageReportList__item__id._const_tab_id = 'id'
    __E_RABUsageReportList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABUsageReportList__item__criticality._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABUsageReportList__item__criticality._const_tab_id = 'criticality'
    __E_RABUsageReportList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABUsageReportList__item__value._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__value._const_tab_at = ('..', 'id')
    __E_RABUsageReportList__item__value._const_tab_id = 'Value'
    _E_RABUsageReportList__item_._cont = ASN1Dict([
        ('id', __E_RABUsageReportList__item__id),
        ('criticality', __E_RABUsageReportList__item__criticality),
        ('value', __E_RABUsageReportList__item__value),
        ])
    _E_RABUsageReportList__item_._ext = None
    E_RABUsageReportList._cont = _E_RABUsageReportList__item_
    E_RABUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< E-RABUsageReportItemIEs >-----#
    E_RABUsageReportItemIEs = CLASS(name='E-RABUsageReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABUsageReportItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportItem')))
    E_RABUsageReportItemIEs._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'ignore'), ('Value', _E_RABUsageReportItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABUsageReportItem >-----#
    E_RABUsageReportItem = SEQ(name='E-RABUsageReportItem', mode=MODE_TYPE)
    _E_RABUsageReportItem_startTimestamp = OCT_STR(name='startTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_startTimestamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReportItem_endTimestamp = OCT_STR(name='endTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_endTimestamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReportItem_usageCountUL = INT(name='usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReportItem_usageCountDL = INT(name='usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABUsageReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABUsageReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABUsageReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__id_tab
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABUsageReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABUsageReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABUsageReportItem_iE_Extensions__item__id),
        ('criticality', ___E_RABUsageReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABUsageReportItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABUsageReportItem_iE_Extensions__item_._ext = None
    _E_RABUsageReportItem_iE_Extensions._cont = __E_RABUsageReportItem_iE_Extensions__item_
    _E_RABUsageReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABUsageReportItem._cont = ASN1Dict([
        ('startTimestamp', _E_RABUsageReportItem_startTimestamp),
        ('endTimestamp', _E_RABUsageReportItem_endTimestamp),
        ('usageCountUL', _E_RABUsageReportItem_usageCountUL),
        ('usageCountDL', _E_RABUsageReportItem_usageCountDL),
        ('iE-Extensions', _E_RABUsageReportItem_iE_Extensions),
        ])
    E_RABUsageReportItem._ext = []
    
    #-----< E-RABUsageReportItem-ExtIEs >-----#
    E_RABUsageReportItem_ExtIEs = CLASS(name='E-RABUsageReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABUsageReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABQoSParameters-ExtIEs >-----#
    E_RABQoSParameters_ExtIEs = CLASS(name='E-RABQoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABQoSParameters_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    _E_RABQoSParameters_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    E_RABQoSParameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 273), ('criticality', 'ignore'), ('Extension', _E_RABQoSParameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _E_RABQoSParameters_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Ethernet-Type >-----#
    Ethernet_Type = ENUM(name='Ethernet-Type', mode=MODE_TYPE)
    Ethernet_Type._cont = ASN1Dict([('true', 0)])
    Ethernet_Type._ext = []
    
    #-----< EUTRAN-CGI >-----#
    EUTRAN_CGI = SEQ(name='EUTRAN-CGI', mode=MODE_TYPE)
    _EUTRAN_CGI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _EUTRAN_CGI_cell_ID = BIT_STR(name='cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdentity')))
    _EUTRAN_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab = ____EUTRAN_CGI_iE_Extensions__item__id_tab
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab = ____EUTRAN_CGI_iE_Extensions__item__criticality_tab
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_CGI_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_CGI_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_CGI_iE_Extensions__item_._ext = None
    _EUTRAN_CGI_iE_Extensions._cont = __EUTRAN_CGI_iE_Extensions__item_
    _EUTRAN_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_CGI._cont = ASN1Dict([
        ('pLMNidentity', _EUTRAN_CGI_pLMNidentity),
        ('cell-ID', _EUTRAN_CGI_cell_ID),
        ('iE-Extensions', _EUTRAN_CGI_iE_Extensions),
        ])
    EUTRAN_CGI._ext = []
    
    #-----< EUTRAN-CGI-ExtIEs >-----#
    EUTRAN_CGI_ExtIEs = CLASS(name='EUTRAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EUTRAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRANRoundTripDelayEstimationInfo >-----#
    EUTRANRoundTripDelayEstimationInfo = INT(name='EUTRANRoundTripDelayEstimationInfo', mode=MODE_TYPE)
    EUTRANRoundTripDelayEstimationInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< EventL1LoggedMDTConfig >-----#
    EventL1LoggedMDTConfig = SEQ(name='EventL1LoggedMDTConfig', mode=MODE_TYPE)
    _EventL1LoggedMDTConfig_l1Threshold = CHOICE(name='l1Threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MeasurementThresholdL1LoggedMDT')))
    _EventL1LoggedMDTConfig_hysteresis = INT(name='hysteresis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Hysteresis')))
    _EventL1LoggedMDTConfig_timeToTrigger = ENUM(name='timeToTrigger', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TimeToTrigger')))
    _EventL1LoggedMDTConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventL1LoggedMDTConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_at = None
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EventL1LoggedMDTConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EventL1LoggedMDTConfig_iE_Extensions__item__id),
        ('criticality', ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue),
        ])
    __EventL1LoggedMDTConfig_iE_Extensions__item_._ext = None
    _EventL1LoggedMDTConfig_iE_Extensions._cont = __EventL1LoggedMDTConfig_iE_Extensions__item_
    _EventL1LoggedMDTConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventL1LoggedMDTConfig._cont = ASN1Dict([
        ('l1Threshold', _EventL1LoggedMDTConfig_l1Threshold),
        ('hysteresis', _EventL1LoggedMDTConfig_hysteresis),
        ('timeToTrigger', _EventL1LoggedMDTConfig_timeToTrigger),
        ('iE-Extensions', _EventL1LoggedMDTConfig_iE_Extensions),
        ])
    EventL1LoggedMDTConfig._ext = []
    
    #-----< EventL1LoggedMDTConfig-ExtIEs >-----#
    EventL1LoggedMDTConfig_ExtIEs = CLASS(name='EventL1LoggedMDTConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EventL1LoggedMDTConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventTrigger >-----#
    EventTrigger = CHOICE(name='EventTrigger', mode=MODE_TYPE)
    _EventTrigger_outOfCoverage = ENUM(name='outOfCoverage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventTrigger_outOfCoverage._cont = ASN1Dict([('true', 0)])
    _EventTrigger_outOfCoverage._ext = []
    _EventTrigger_eventL1LoggedMDTConfig = SEQ(name='eventL1LoggedMDTConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EventL1LoggedMDTConfig')))
    _EventTrigger_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __EventTrigger_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___EventTrigger_choice_Extensions_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_id._const_tab = ___EventTrigger_choice_Extensions_id_tab
    __EventTrigger_choice_Extensions_id._const_tab_at = None
    __EventTrigger_choice_Extensions_id._const_tab_id = 'id'
    __EventTrigger_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___EventTrigger_choice_Extensions_criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_criticality._const_tab = ___EventTrigger_choice_Extensions_criticality_tab
    __EventTrigger_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __EventTrigger_choice_Extensions_criticality._const_tab_id = 'criticality'
    __EventTrigger_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___EventTrigger_choice_Extensions_value_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_value._const_tab = ___EventTrigger_choice_Extensions_value_tab
    __EventTrigger_choice_Extensions_value._const_tab_at = ('..', 'id')
    __EventTrigger_choice_Extensions_value._const_tab_id = 'Value'
    _EventTrigger_choice_Extensions._cont = ASN1Dict([
        ('id', __EventTrigger_choice_Extensions_id),
        ('criticality', __EventTrigger_choice_Extensions_criticality),
        ('value', __EventTrigger_choice_Extensions_value),
        ])
    _EventTrigger_choice_Extensions._ext = None
    EventTrigger._cont = ASN1Dict([
        ('outOfCoverage', _EventTrigger_outOfCoverage),
        ('eventL1LoggedMDTConfig', _EventTrigger_eventL1LoggedMDTConfig),
        ('choice-Extensions', _EventTrigger_choice_Extensions),
        ])
    EventTrigger._ext = None
    
    #-----< EventTrigger-ExtIEs >-----#
    EventTrigger_ExtIEs = CLASS(name='EventTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    EventTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name='ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedActivity = SEQ(name='expectedActivity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name='expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        ('expectedActivity', _ExpectedUEBehaviour_expectedActivity),
        ('expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        ('iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name='ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name='ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name='expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name='expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation = ENUM(name='sourceofUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        ('expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        ('expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        ('sourceofUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation),
        ('iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name='ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name='ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name='ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name='SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([('subscription-information', 0), ('statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name='ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([('sec15', 0), ('sec30', 1), ('sec60', 2), ('sec90', 3), ('sec120', 4), ('sec180', 5), ('long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExtendedBitRate >-----#
    ExtendedBitRate = INT(name='ExtendedBitRate', mode=MODE_TYPE)
    ExtendedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10000000001, ub=4000000000000)], ev=[], er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name='ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedRepetitionPeriod >-----#
    ExtendedRepetitionPeriod = INT(name='ExtendedRepetitionPeriod', mode=MODE_TYPE)
    ExtendedRepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=131071)], ev=None, er=[])
    
    #-----< Extended-UEIdentityIndexValue >-----#
    Extended_UEIdentityIndexValue = BIT_STR(name='Extended-UEIdentityIndexValue', mode=MODE_TYPE)
    Extended_UEIdentityIndexValue._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< FiveGSTAC >-----#
    FiveGSTAC = OCT_STR(name='FiveGSTAC', mode=MODE_TYPE)
    FiveGSTAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< FiveGSTAI >-----#
    FiveGSTAI = SEQ(name='FiveGSTAI', mode=MODE_TYPE)
    _FiveGSTAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _FiveGSTAI_fiveGSTAC = OCT_STR(name='fiveGSTAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAC')))
    _FiveGSTAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveGSTAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___FiveGSTAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveGSTAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__id._const_tab = ____FiveGSTAI_iE_Extensions__item__id_tab
    ___FiveGSTAI_iE_Extensions__item__id._const_tab_at = None
    ___FiveGSTAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveGSTAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveGSTAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab = ____FiveGSTAI_iE_Extensions__item__criticality_tab
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveGSTAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveGSTAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab = ____FiveGSTAI_iE_Extensions__item__extensionValue_tab
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveGSTAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveGSTAI_iE_Extensions__item__id),
        ('criticality', ___FiveGSTAI_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveGSTAI_iE_Extensions__item__extensionValue),
        ])
    __FiveGSTAI_iE_Extensions__item_._ext = None
    _FiveGSTAI_iE_Extensions._cont = __FiveGSTAI_iE_Extensions__item_
    _FiveGSTAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveGSTAI._cont = ASN1Dict([
        ('pLMNidentity', _FiveGSTAI_pLMNidentity),
        ('fiveGSTAC', _FiveGSTAI_fiveGSTAC),
        ('iE-Extensions', _FiveGSTAI_iE_Extensions),
        ])
    FiveGSTAI._ext = []
    
    #-----< FiveGSTAI-ExtIEs >-----#
    FiveGSTAI_ExtIEs = CLASS(name='FiveGSTAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    FiveGSTAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveQI >-----#
    FiveQI = INT(name='FiveQI', mode=MODE_TYPE)
    FiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ForbiddenInterRATs >-----#
    ForbiddenInterRATs = ENUM(name='ForbiddenInterRATs', mode=MODE_TYPE)
    ForbiddenInterRATs._cont = ASN1Dict([('all', 0), ('geran', 1), ('utran', 2), ('cdma2000', 3), ('geranandutran', 4), ('cdma2000andutran', 5)])
    ForbiddenInterRATs._ext = ['geranandutran', 'cdma2000andutran']
    
    #-----< ForbiddenTAs >-----#
    ForbiddenTAs = SEQ_OF(name='ForbiddenTAs', mode=MODE_TYPE)
    _ForbiddenTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTAs-Item')))
    ForbiddenTAs._cont = _ForbiddenTAs__item_
    ForbiddenTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenTAs-Item >-----#
    ForbiddenTAs_Item = SEQ(name='ForbiddenTAs-Item', mode=MODE_TYPE)
    _ForbiddenTAs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _ForbiddenTAs_Item_forbiddenTACs = SEQ_OF(name='forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTACs')))
    _ForbiddenTAs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenTAs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ForbiddenTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ForbiddenTAs_Item_iE_Extensions__item__id),
        ('criticality', ___ForbiddenTAs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenTAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenTAs_Item_iE_Extensions._cont = __ForbiddenTAs_Item_iE_Extensions__item_
    _ForbiddenTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenTAs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ForbiddenTAs_Item_pLMN_Identity),
        ('forbiddenTACs', _ForbiddenTAs_Item_forbiddenTACs),
        ('iE-Extensions', _ForbiddenTAs_Item_iE_Extensions),
        ])
    ForbiddenTAs_Item._ext = []
    
    #-----< ForbiddenTAs-Item-ExtIEs >-----#
    ForbiddenTAs_Item_ExtIEs = CLASS(name='ForbiddenTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ForbiddenTAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name='ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< ForbiddenLAs >-----#
    ForbiddenLAs = SEQ_OF(name='ForbiddenLAs', mode=MODE_TYPE)
    _ForbiddenLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLAs-Item')))
    ForbiddenLAs._cont = _ForbiddenLAs__item_
    ForbiddenLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenLAs-Item >-----#
    ForbiddenLAs_Item = SEQ(name='ForbiddenLAs-Item', mode=MODE_TYPE)
    _ForbiddenLAs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _ForbiddenLAs_Item_forbiddenLACs = SEQ_OF(name='forbiddenLACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLACs')))
    _ForbiddenLAs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenLAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenLAs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ForbiddenLAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ForbiddenLAs_Item_iE_Extensions__item__id),
        ('criticality', ___ForbiddenLAs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenLAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenLAs_Item_iE_Extensions._cont = __ForbiddenLAs_Item_iE_Extensions__item_
    _ForbiddenLAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenLAs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ForbiddenLAs_Item_pLMN_Identity),
        ('forbiddenLACs', _ForbiddenLAs_Item_forbiddenLACs),
        ('iE-Extensions', _ForbiddenLAs_Item_iE_Extensions),
        ])
    ForbiddenLAs_Item._ext = []
    
    #-----< ForbiddenLAs-Item-ExtIEs >-----#
    ForbiddenLAs_Item_ExtIEs = CLASS(name='ForbiddenLAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ForbiddenLAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenLACs >-----#
    ForbiddenLACs = SEQ_OF(name='ForbiddenLACs', mode=MODE_TYPE)
    _ForbiddenLACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    ForbiddenLACs._cont = _ForbiddenLACs__item_
    ForbiddenLACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name='GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name='e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name='e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name='e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name='e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 256), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QosInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        ('e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        ('e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        ('e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        ('e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        ('iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name='GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _GBR_QosInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 256), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name='GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GUMMEI >-----#
    GUMMEI = SEQ(name='GUMMEI', mode=MODE_TYPE)
    _GUMMEI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _GUMMEI_mME_Group_ID = OCT_STR(name='mME-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _GUMMEI_mME_Code = OCT_STR(name='mME-Code', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    _GUMMEI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUMMEI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GUMMEI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GUMMEI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__id._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__id._const_tab_at = None
    ___GUMMEI_iE_Extensions__item__id._const_tab_id = 'id'
    ___GUMMEI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GUMMEI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__criticality._const_tab = ____GUMMEI_iE_Extensions__item__criticality_tab
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GUMMEI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab = ____GUMMEI_iE_Extensions__item__extensionValue_tab
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GUMMEI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GUMMEI_iE_Extensions__item__id),
        ('criticality', ___GUMMEI_iE_Extensions__item__criticality),
        ('extensionValue', ___GUMMEI_iE_Extensions__item__extensionValue),
        ])
    __GUMMEI_iE_Extensions__item_._ext = None
    _GUMMEI_iE_Extensions._cont = __GUMMEI_iE_Extensions__item_
    _GUMMEI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUMMEI._cont = ASN1Dict([
        ('pLMN-Identity', _GUMMEI_pLMN_Identity),
        ('mME-Group-ID', _GUMMEI_mME_Group_ID),
        ('mME-Code', _GUMMEI_mME_Code),
        ('iE-Extensions', _GUMMEI_iE_Extensions),
        ])
    GUMMEI._ext = []
    
    #-----< GUMMEI-ExtIEs >-----#
    GUMMEI_ExtIEs = CLASS(name='GUMMEI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GUMMEI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEIType >-----#
    GUMMEIType = ENUM(name='GUMMEIType', mode=MODE_TYPE)
    GUMMEIType._cont = ASN1Dict([('native', 0), ('mapped', 1), ('mappedFrom5G', 2)])
    GUMMEIType._ext = ['mappedFrom5G']
    
    #-----< GWContextReleaseIndication >-----#
    GWContextReleaseIndication = ENUM(name='GWContextReleaseIndication', mode=MODE_TYPE)
    GWContextReleaseIndication._cont = ASN1Dict([('true', 0)])
    GWContextReleaseIndication._ext = []
    
    #-----< HandoverFlag >-----#
    HandoverFlag = ENUM(name='HandoverFlag', mode=MODE_TYPE)
    HandoverFlag._cont = ASN1Dict([('handoverPreparation', 0)])
    HandoverFlag._ext = []
    
    #-----< HandoverRestrictionList >-----#
    HandoverRestrictionList = SEQ(name='HandoverRestrictionList', mode=MODE_TYPE)
    _HandoverRestrictionList_servingPLMN = OCT_STR(name='servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _HandoverRestrictionList_equivalentPLMNs = SEQ_OF(name='equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EPLMNs')), opt=True)
    _HandoverRestrictionList_forbiddenTAs = SEQ_OF(name='forbiddenTAs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTAs')), opt=True)
    _HandoverRestrictionList_forbiddenLAs = SEQ_OF(name='forbiddenLAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLAs')), opt=True)
    _HandoverRestrictionList_forbiddenInterRATs = ENUM(name='forbiddenInterRATs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenInterRATs')), opt=True)
    _HandoverRestrictionList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___HandoverRestrictionList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UnlicensedSpectrumRestriction')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictionin5GS')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Restrictions')))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 336), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverRestrictionList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverRestrictionList_iE_Extensions__item__id),
        ('criticality', ___HandoverRestrictionList_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __HandoverRestrictionList_iE_Extensions__item_._ext = None
    _HandoverRestrictionList_iE_Extensions._cont = __HandoverRestrictionList_iE_Extensions__item_
    _HandoverRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRestrictionList._cont = ASN1Dict([
        ('servingPLMN', _HandoverRestrictionList_servingPLMN),
        ('equivalentPLMNs', _HandoverRestrictionList_equivalentPLMNs),
        ('forbiddenTAs', _HandoverRestrictionList_forbiddenTAs),
        ('forbiddenLAs', _HandoverRestrictionList_forbiddenLAs),
        ('forbiddenInterRATs', _HandoverRestrictionList_forbiddenInterRATs),
        ('iE-Extensions', _HandoverRestrictionList_iE_Extensions),
        ])
    HandoverRestrictionList._ext = []
    
    #-----< HandoverRestrictionList-ExtIEs >-----#
    HandoverRestrictionList_ExtIEs = CLASS(name='HandoverRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _HandoverRestrictionList_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _HandoverRestrictionList_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UnlicensedSpectrumRestriction')))
    _HandoverRestrictionList_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions')))
    _HandoverRestrictionList_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictionin5GS')))
    _HandoverRestrictionList_ExtIEs_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _HandoverRestrictionList_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Restrictions')))
    HandoverRestrictionList_ExtIEs._val = ASN1Set(rv=[dict([('id', 261), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 336), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverType >-----#
    HandoverType = ENUM(name='HandoverType', mode=MODE_TYPE)
    HandoverType._cont = ASN1Dict([('intralte', 0), ('ltetoutran', 1), ('ltetogeran', 2), ('utrantolte', 3), ('gerantolte', 4), ('eps-to-5gs', 5), ('fivegs-to-eps', 6)])
    HandoverType._ext = ['eps-to-5gs', 'fivegs-to-eps']
    
    #-----< HFN >-----#
    HFN = INT(name='HFN', mode=MODE_TYPE)
    HFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< HFNModified >-----#
    HFNModified = INT(name='HFNModified', mode=MODE_TYPE)
    HFNModified._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< HFNforPDCP-SNlength18 >-----#
    HFNforPDCP_SNlength18 = INT(name='HFNforPDCP-SNlength18', mode=MODE_TYPE)
    HFNforPDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< Hysteresis >-----#
    Hysteresis = INT(name='Hysteresis', mode=MODE_TYPE)
    Hysteresis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    
    #-----< Masked-IMEISV >-----#
    Masked_IMEISV = BIT_STR(name='Masked-IMEISV', mode=MODE_TYPE)
    Masked_IMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< ImmediateMDT >-----#
    ImmediateMDT = SEQ(name='ImmediateMDT', mode=MODE_TYPE)
    _ImmediateMDT_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDT_m1reportingTrigger = ENUM(name='m1reportingTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1ReportingTrigger')))
    _ImmediateMDT_m1thresholdeventA2 = SEQ(name='m1thresholdeventA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1ThresholdEventA2')), opt=True)
    _ImmediateMDT_m1periodicReporting = SEQ(name='m1periodicReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1PeriodicReporting')), opt=True)
    _ImmediateMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ImmediateMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M3Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M4Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M5Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Location-Info')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M6Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M7Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasurementConfiguration')))
    ____ImmediateMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 172), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'conditional')]), dict([('id', 174), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'conditional')]), dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__id._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___ImmediateMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ImmediateMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ImmediateMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ImmediateMDT_iE_Extensions__item__id),
        ('criticality', ___ImmediateMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___ImmediateMDT_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDT_iE_Extensions__item_._ext = None
    _ImmediateMDT_iE_Extensions._cont = __ImmediateMDT_iE_Extensions__item_
    _ImmediateMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDT._cont = ASN1Dict([
        ('measurementsToActivate', _ImmediateMDT_measurementsToActivate),
        ('m1reportingTrigger', _ImmediateMDT_m1reportingTrigger),
        ('m1thresholdeventA2', _ImmediateMDT_m1thresholdeventA2),
        ('m1periodicReporting', _ImmediateMDT_m1periodicReporting),
        ('iE-Extensions', _ImmediateMDT_iE_Extensions),
        ])
    ImmediateMDT._ext = []
    
    #-----< ImmediateMDT-ExtIEs >-----#
    ImmediateMDT_ExtIEs = CLASS(name='ImmediateMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ImmediateMDT_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M3Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M4Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M5Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Location-Info')))
    _ImmediateMDT_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M6Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M7Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _ImmediateMDT_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    _ImmediateMDT_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasurementConfiguration')))
    ImmediateMDT_ExtIEs._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 172), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_1), ('presence', 'conditional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_2), ('presence', 'conditional')]), dict([('id', 174), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_4), ('presence', 'conditional')]), dict([('id', 221), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_5), ('presence', 'conditional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE)
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< InformationOnRecommendedCellsAndENBsForPaging >-----#
    InformationOnRecommendedCellsAndENBsForPaging = SEQ(name='InformationOnRecommendedCellsAndENBsForPaging', mode=MODE_TYPE)
    _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging = SEQ(name='recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellsForPaging')))
    _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging = SEQ(name='recommendENBsForPaging', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBsForPaging')))
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id),
        ('criticality', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue),
        ])
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_._ext = None
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions._cont = __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationOnRecommendedCellsAndENBsForPaging._cont = ASN1Dict([
        ('recommendedCellsForPaging', _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging),
        ('recommendENBsForPaging', _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging),
        ('iE-Extensions', _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions),
        ])
    InformationOnRecommendedCellsAndENBsForPaging._ext = []
    
    #-----< InformationOnRecommendedCellsAndENBsForPaging-ExtIEs >-----#
    InformationOnRecommendedCellsAndENBsForPaging_ExtIEs = CLASS(name='InformationOnRecommendedCellsAndENBsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InformationOnRecommendedCellsAndENBsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionAlgorithms >-----#
    IntegrityProtectionAlgorithms = BIT_STR(name='IntegrityProtectionAlgorithms', mode=MODE_TYPE)
    IntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionIndication >-----#
    IntegrityProtectionIndication = ENUM(name='IntegrityProtectionIndication', mode=MODE_TYPE)
    IntegrityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('not-needed', 2)])
    IntegrityProtectionIndication._ext = []
    
    #-----< IntegrityProtectionResult >-----#
    IntegrityProtectionResult = ENUM(name='IntegrityProtectionResult', mode=MODE_TYPE)
    IntegrityProtectionResult._cont = ASN1Dict([('performed', 0), ('not-performed', 1)])
    IntegrityProtectionResult._ext = []
    
    #-----< IntendedNumberOfPagingAttempts >-----#
    IntendedNumberOfPagingAttempts = INT(name='IntendedNumberOfPagingAttempts', mode=MODE_TYPE)
    IntendedNumberOfPagingAttempts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name='InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IntersystemMeasurementConfiguration >-----#
    IntersystemMeasurementConfiguration = SEQ(name='IntersystemMeasurementConfiguration', mode=MODE_TYPE)
    _IntersystemMeasurementConfiguration_rSRP = INT(name='rSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_rSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_rSRQ = INT(name='rSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_rSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_sINR = INT(name='sINR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_sINR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_interSystemMeasurementParameters = SEQ(name='interSystemMeasurementParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementParameters')))
    _IntersystemMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __IntersystemMeasurementConfiguration_iE_Extensions__item_._ext = None
    _IntersystemMeasurementConfiguration_iE_Extensions._cont = __IntersystemMeasurementConfiguration_iE_Extensions__item_
    _IntersystemMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemMeasurementConfiguration._cont = ASN1Dict([
        ('rSRP', _IntersystemMeasurementConfiguration_rSRP),
        ('rSRQ', _IntersystemMeasurementConfiguration_rSRQ),
        ('sINR', _IntersystemMeasurementConfiguration_sINR),
        ('interSystemMeasurementParameters', _IntersystemMeasurementConfiguration_interSystemMeasurementParameters),
        ('iE-Extensions', _IntersystemMeasurementConfiguration_iE_Extensions),
        ])
    IntersystemMeasurementConfiguration._ext = []
    
    #-----< IntersystemMeasurementConfiguration-ExtIEs >-----#
    IntersystemMeasurementConfiguration_ExtIEs = CLASS(name='IntersystemMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    IntersystemMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemMeasurementParameters >-----#
    InterSystemMeasurementParameters = SEQ(name='InterSystemMeasurementParameters', mode=MODE_TYPE)
    _InterSystemMeasurementParameters_measurementDuration = INT(name='measurementDuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementParameters_measurementDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _InterSystemMeasurementParameters_interSystemMeasurementList = SEQ_OF(name='interSystemMeasurementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementList')), opt=True)
    _InterSystemMeasurementParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemMeasurementParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InterSystemMeasurementParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterSystemMeasurementParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterSystemMeasurementParameters_iE_Extensions__item__id),
        ('criticality', ___InterSystemMeasurementParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue),
        ])
    __InterSystemMeasurementParameters_iE_Extensions__item_._ext = None
    _InterSystemMeasurementParameters_iE_Extensions._cont = __InterSystemMeasurementParameters_iE_Extensions__item_
    _InterSystemMeasurementParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemMeasurementParameters._cont = ASN1Dict([
        ('measurementDuration', _InterSystemMeasurementParameters_measurementDuration),
        ('interSystemMeasurementList', _InterSystemMeasurementParameters_interSystemMeasurementList),
        ('iE-Extensions', _InterSystemMeasurementParameters_iE_Extensions),
        ])
    InterSystemMeasurementParameters._ext = []
    
    #-----< InterSystemMeasurementParameters-ExtIEs >-----#
    InterSystemMeasurementParameters_ExtIEs = CLASS(name='InterSystemMeasurementParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InterSystemMeasurementParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemMeasurementList >-----#
    InterSystemMeasurementList = SEQ_OF(name='InterSystemMeasurementList', mode=MODE_TYPE)
    _InterSystemMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementItem')))
    InterSystemMeasurementList._cont = _InterSystemMeasurementList__item_
    InterSystemMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< InterSystemMeasurementItem >-----#
    InterSystemMeasurementItem = SEQ(name='InterSystemMeasurementItem', mode=MODE_TYPE)
    _InterSystemMeasurementItem_freqBandIndicatorNR = INT(name='freqBandIndicatorNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_freqBandIndicatorNR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _InterSystemMeasurementItem_sSBfrequencies = INT(name='sSBfrequencies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_sSBfrequencies._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _InterSystemMeasurementItem_subcarrierSpacingSSB = ENUM(name='subcarrierSpacingSSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_subcarrierSpacingSSB._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3), ('kHz240', 4)])
    _InterSystemMeasurementItem_subcarrierSpacingSSB._ext = []
    _InterSystemMeasurementItem_maxRSIndexCellQual = INT(name='maxRSIndexCellQual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_maxRSIndexCellQual._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _InterSystemMeasurementItem_sMTC = OCT_STR(name='sMTC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_threshRS_Index_r15 = OCT_STR(name='threshRS-Index-r15', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_sSBToMeasure = OCT_STR(name='sSBToMeasure', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_sSRSSIMeasurement = OCT_STR(name='sSRSSIMeasurement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_quantityConfigNR_R15 = OCT_STR(name='quantityConfigNR-R15', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_excludedCellsToAddModList = OCT_STR(name='excludedCellsToAddModList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemMeasurementItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InterSystemMeasurementItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____InterSystemMeasurementItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__id_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterSystemMeasurementItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterSystemMeasurementItem_iE_Extensions__item__id),
        ('criticality', ___InterSystemMeasurementItem_iE_Extensions__item__criticality),
        ('extensionValue', ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue),
        ])
    __InterSystemMeasurementItem_iE_Extensions__item_._ext = None
    _InterSystemMeasurementItem_iE_Extensions._cont = __InterSystemMeasurementItem_iE_Extensions__item_
    _InterSystemMeasurementItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemMeasurementItem._cont = ASN1Dict([
        ('freqBandIndicatorNR', _InterSystemMeasurementItem_freqBandIndicatorNR),
        ('sSBfrequencies', _InterSystemMeasurementItem_sSBfrequencies),
        ('subcarrierSpacingSSB', _InterSystemMeasurementItem_subcarrierSpacingSSB),
        ('maxRSIndexCellQual', _InterSystemMeasurementItem_maxRSIndexCellQual),
        ('sMTC', _InterSystemMeasurementItem_sMTC),
        ('threshRS-Index-r15', _InterSystemMeasurementItem_threshRS_Index_r15),
        ('sSBToMeasure', _InterSystemMeasurementItem_sSBToMeasure),
        ('sSRSSIMeasurement', _InterSystemMeasurementItem_sSRSSIMeasurement),
        ('quantityConfigNR-R15', _InterSystemMeasurementItem_quantityConfigNR_R15),
        ('excludedCellsToAddModList', _InterSystemMeasurementItem_excludedCellsToAddModList),
        ('iE-Extensions', _InterSystemMeasurementItem_iE_Extensions),
        ])
    InterSystemMeasurementItem._ext = None
    
    #-----< InterSystemMeasurementItem-ExtIEs >-----#
    InterSystemMeasurementItem_ExtIEs = CLASS(name='InterSystemMeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InterSystemMeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONConfigurationTransfer >-----#
    IntersystemSONConfigurationTransfer = OCT_STR(name='IntersystemSONConfigurationTransfer', mode=MODE_TYPE)
    
    #-----< IMSvoiceEPSfallbackfrom5G >-----#
    IMSvoiceEPSfallbackfrom5G = ENUM(name='IMSvoiceEPSfallbackfrom5G', mode=MODE_TYPE)
    IMSvoiceEPSfallbackfrom5G._cont = ASN1Dict([('true', 0)])
    IMSvoiceEPSfallbackfrom5G._ext = []
    
    #-----< IAB-Authorized >-----#
    IAB_Authorized = ENUM(name='IAB-Authorized', mode=MODE_TYPE)
    IAB_Authorized._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    IAB_Authorized._ext = []
    
    #-----< IAB-Node-Indication >-----#
    IAB_Node_Indication = ENUM(name='IAB-Node-Indication', mode=MODE_TYPE)
    IAB_Node_Indication._cont = ASN1Dict([('true', 0)])
    IAB_Node_Indication._ext = []
    
    #-----< IAB-Supported >-----#
    IAB_Supported = ENUM(name='IAB-Supported', mode=MODE_TYPE)
    IAB_Supported._cont = ASN1Dict([('true', 0)])
    IAB_Supported._ext = []
    
    #-----< KillAllWarningMessages >-----#
    KillAllWarningMessages = ENUM(name='KillAllWarningMessages', mode=MODE_TYPE)
    KillAllWarningMessages._cont = ASN1Dict([('true', 0)])
    KillAllWarningMessages._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name='LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _LAI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LAI_iE_Extensions__item__id),
        ('criticality', ___LAI_iE_Extensions__item__criticality),
        ('extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        ('pLMNidentity', _LAI_pLMNidentity),
        ('lAC', _LAI_lAC),
        ('iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = []
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name='LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCell-Item >-----#
    LastVisitedCell_Item = CHOICE(name='LastVisitedCell-Item', mode=MODE_TYPE)
    _LastVisitedCell_Item_e_UTRAN_Cell = SEQ(name='e-UTRAN-Cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCell_Item_uTRAN_Cell = OCT_STR(name='uTRAN-Cell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCell_Item_gERAN_Cell = CHOICE(name='gERAN-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedGERANCellInformation')))
    _LastVisitedCell_Item_nG_RAN_Cell = OCT_STR(name='nG-RAN-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedNGRANCellInformation')))
    LastVisitedCell_Item._cont = ASN1Dict([
        ('e-UTRAN-Cell', _LastVisitedCell_Item_e_UTRAN_Cell),
        ('uTRAN-Cell', _LastVisitedCell_Item_uTRAN_Cell),
        ('gERAN-Cell', _LastVisitedCell_Item_gERAN_Cell),
        ('nG-RAN-Cell', _LastVisitedCell_Item_nG_RAN_Cell),
        ])
    LastVisitedCell_Item._ext = ['nG-RAN-Cell']
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = SEQ(name='LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    _LastVisitedEUTRANCellInformation_global_Cell_ID = SEQ(name='global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _LastVisitedEUTRANCellInformation_cellType = SEQ(name='cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellType')))
    _LastVisitedEUTRANCellInformation_time_UE_StayedInCell = INT(name='time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedEUTRANCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedPSCellList')))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id),
        ('criticality', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedEUTRANCellInformation_iE_Extensions._cont = __LastVisitedEUTRANCellInformation_iE_Extensions__item_
    _LastVisitedEUTRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedEUTRANCellInformation._cont = ASN1Dict([
        ('global-Cell-ID', _LastVisitedEUTRANCellInformation_global_Cell_ID),
        ('cellType', _LastVisitedEUTRANCellInformation_cellType),
        ('time-UE-StayedInCell', _LastVisitedEUTRANCellInformation_time_UE_StayedInCell),
        ('iE-Extensions', _LastVisitedEUTRANCellInformation_iE_Extensions),
        ])
    LastVisitedEUTRANCellInformation._ext = []
    
    #-----< LastVisitedEUTRANCellInformation-ExtIEs >-----#
    LastVisitedEUTRANCellInformation_ExtIEs = CLASS(name='LastVisitedEUTRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedPSCellList')))
    LastVisitedEUTRANCellInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LastVisitedPSCellList >-----#
    LastVisitedPSCellList = SEQ_OF(name='LastVisitedPSCellList', mode=MODE_TYPE)
    _LastVisitedPSCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedPSCellInformation')))
    LastVisitedPSCellList._cont = _LastVisitedPSCellList__item_
    LastVisitedPSCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LastVisitedPSCellInformation >-----#
    LastVisitedPSCellInformation = SEQ(name='LastVisitedPSCellInformation', mode=MODE_TYPE)
    _LastVisitedPSCellInformation_pSCellID = SEQ(name='pSCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')), opt=True)
    _LastVisitedPSCellInformation_timeStay = INT(name='timeStay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LastVisitedPSCellInformation_timeStay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    _LastVisitedPSCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedPSCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedPSCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedPSCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedPSCellInformation_iE_Extensions__item__id),
        ('criticality', ___LastVisitedPSCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedPSCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedPSCellInformation_iE_Extensions._cont = __LastVisitedPSCellInformation_iE_Extensions__item_
    _LastVisitedPSCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedPSCellInformation._cont = ASN1Dict([
        ('pSCellID', _LastVisitedPSCellInformation_pSCellID),
        ('timeStay', _LastVisitedPSCellInformation_timeStay),
        ('iE-Extensions', _LastVisitedPSCellInformation_iE_Extensions),
        ])
    LastVisitedPSCellInformation._ext = []
    
    #-----< LastVisitedPSCellInformation-ExtIEs >-----#
    LastVisitedPSCellInformation_ExtIEs = CLASS(name='LastVisitedPSCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LastVisitedPSCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedNGRANCellInformation >-----#
    LastVisitedNGRANCellInformation = OCT_STR(name='LastVisitedNGRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name='LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = CHOICE(name='LastVisitedGERANCellInformation', mode=MODE_TYPE)
    _LastVisitedGERANCellInformation_undefined = NULL(name='undefined', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LastVisitedGERANCellInformation._cont = ASN1Dict([
        ('undefined', _LastVisitedGERANCellInformation_undefined),
        ])
    LastVisitedGERANCellInformation._ext = []
    
    #-----< L3-Information >-----#
    L3_Information = OCT_STR(name='L3-Information', mode=MODE_TYPE)
    
    #-----< LPPa-PDU >-----#
    LPPa_PDU = OCT_STR(name='LPPa-PDU', mode=MODE_TYPE)
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name='LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name='Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< ListeningSubframePattern >-----#
    ListeningSubframePattern = SEQ(name='ListeningSubframePattern', mode=MODE_TYPE)
    _ListeningSubframePattern_pattern_period = ENUM(name='pattern-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ListeningSubframePattern_pattern_period._cont = ASN1Dict([('ms1280', 0), ('ms2560', 1), ('ms5120', 2), ('ms10240', 3)])
    _ListeningSubframePattern_pattern_period._ext = []
    _ListeningSubframePattern_pattern_offset = INT(name='pattern-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ListeningSubframePattern_pattern_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=[], er=[])
    _ListeningSubframePattern_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ListeningSubframePattern_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ListeningSubframePattern_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ListeningSubframePattern_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab = ____ListeningSubframePattern_iE_Extensions__item__id_tab
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab_at = None
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab_id = 'id'
    ___ListeningSubframePattern_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ListeningSubframePattern_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab = ____ListeningSubframePattern_iE_Extensions__item__criticality_tab
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab = ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ListeningSubframePattern_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ListeningSubframePattern_iE_Extensions__item__id),
        ('criticality', ___ListeningSubframePattern_iE_Extensions__item__criticality),
        ('extensionValue', ___ListeningSubframePattern_iE_Extensions__item__extensionValue),
        ])
    __ListeningSubframePattern_iE_Extensions__item_._ext = None
    _ListeningSubframePattern_iE_Extensions._cont = __ListeningSubframePattern_iE_Extensions__item_
    _ListeningSubframePattern_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ListeningSubframePattern._cont = ASN1Dict([
        ('pattern-period', _ListeningSubframePattern_pattern_period),
        ('pattern-offset', _ListeningSubframePattern_pattern_offset),
        ('iE-Extensions', _ListeningSubframePattern_iE_Extensions),
        ])
    ListeningSubframePattern._ext = []
    
    #-----< ListeningSubframePattern-ExtIEs >-----#
    ListeningSubframePattern_ExtIEs = CLASS(name='ListeningSubframePattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ListeningSubframePattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggedMDT >-----#
    LoggedMDT = SEQ(name='LoggedMDT', mode=MODE_TYPE)
    _LoggedMDT_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingInterval')))
    _LoggedMDT_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingDuration')))
    _LoggedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LoggedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMDTTrigger')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasurementConfiguration')))
    ____LoggedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__id._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___LoggedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LoggedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LoggedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LoggedMDT_iE_Extensions__item__id),
        ('criticality', ___LoggedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___LoggedMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDT_iE_Extensions__item_._ext = None
    _LoggedMDT_iE_Extensions._cont = __LoggedMDT_iE_Extensions__item_
    _LoggedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDT._cont = ASN1Dict([
        ('loggingInterval', _LoggedMDT_loggingInterval),
        ('loggingDuration', _LoggedMDT_loggingDuration),
        ('iE-Extensions', _LoggedMDT_iE_Extensions),
        ])
    LoggedMDT._ext = []
    
    #-----< LoggedMDT-ExtIEs >-----#
    LoggedMDT_ExtIEs = CLASS(name='LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _LoggedMDT_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _LoggedMDT_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    _LoggedMDT_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMDTTrigger')))
    _LoggedMDT_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasurementConfiguration')))
    LoggedMDT_ExtIEs._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Extension', _LoggedMDT_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _LoggedMDT_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _LoggedMDT_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Extension', _LoggedMDT_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name='LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([('ms1280', 0), ('ms2560', 1), ('ms5120', 2), ('ms10240', 3), ('ms20480', 4), ('ms30720', 5), ('ms40960', 6), ('ms61440', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name='LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([('m10', 0), ('m20', 1), ('m40', 2), ('m60', 3), ('m90', 4), ('m120', 5)])
    LoggingDuration._ext = None
    
    #-----< LoggedMBSFNMDT >-----#
    LoggedMBSFNMDT = SEQ(name='LoggedMBSFNMDT', mode=MODE_TYPE)
    _LoggedMBSFNMDT_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingInterval')))
    _LoggedMBSFNMDT_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingDuration')))
    _LoggedMBSFNMDT_mBSFN_ResultToLog = SEQ_OF(name='mBSFN-ResultToLog', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MBSFN-ResultToLog')), opt=True)
    _LoggedMBSFNMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMBSFNMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LoggedMBSFNMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LoggedMBSFNMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__id_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LoggedMBSFNMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LoggedMBSFNMDT_iE_Extensions__item__id),
        ('criticality', ___LoggedMBSFNMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMBSFNMDT_iE_Extensions__item_._ext = None
    _LoggedMBSFNMDT_iE_Extensions._cont = __LoggedMBSFNMDT_iE_Extensions__item_
    _LoggedMBSFNMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMBSFNMDT._cont = ASN1Dict([
        ('loggingInterval', _LoggedMBSFNMDT_loggingInterval),
        ('loggingDuration', _LoggedMBSFNMDT_loggingDuration),
        ('mBSFN-ResultToLog', _LoggedMBSFNMDT_mBSFN_ResultToLog),
        ('iE-Extensions', _LoggedMBSFNMDT_iE_Extensions),
        ])
    LoggedMBSFNMDT._ext = []
    
    #-----< LoggedMBSFNMDT-ExtIEs >-----#
    LoggedMBSFNMDT_ExtIEs = CLASS(name='LoggedMBSFNMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LoggedMBSFNMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggedMDTTrigger >-----#
    LoggedMDTTrigger = CHOICE(name='LoggedMDTTrigger', mode=MODE_TYPE)
    _LoggedMDTTrigger_periodical = NULL(name='periodical', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LoggedMDTTrigger_eventTrigger = CHOICE(name='eventTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EventTrigger')))
    LoggedMDTTrigger._cont = ASN1Dict([
        ('periodical', _LoggedMDTTrigger_periodical),
        ('eventTrigger', _LoggedMDTTrigger_eventTrigger),
        ])
    LoggedMDTTrigger._ext = []
    
    #-----< LTE-M-Indication >-----#
    LTE_M_Indication = ENUM(name='LTE-M-Indication', mode=MODE_TYPE)
    LTE_M_Indication._cont = ASN1Dict([('lte-m', 0)])
    LTE_M_Indication._ext = []
    
    #-----< LTE-NTN-TAI-Information >-----#
    LTE_NTN_TAI_Information = SEQ(name='LTE-NTN-TAI-Information', mode=MODE_TYPE)
    _LTE_NTN_TAI_Information_servingPLMN = OCT_STR(name='servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _LTE_NTN_TAI_Information_tACList_In_LTE_NTN = SEQ_OF(name='tACList-In-LTE-NTN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TACList-In-LTE-NTN')))
    _LTE_NTN_TAI_Information_uE_Location_Derived_TAC = OCT_STR(name='uE-Location-Derived-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAC')), opt=True)
    _LTE_NTN_TAI_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTE_NTN_TAI_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LTE_NTN_TAI_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTE_NTN_TAI_Information_iE_Extensions__item__id._const_tab = ____LTE_NTN_TAI_Information_iE_Extensions__item__id_tab
    ___LTE_NTN_TAI_Information_iE_Extensions__item__id._const_tab_at = None
    ___LTE_NTN_TAI_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality._const_tab = ____LTE_NTN_TAI_Information_iE_Extensions__item__criticality_tab
    ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue._const_tab = ____LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue_tab
    ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LTE_NTN_TAI_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LTE_NTN_TAI_Information_iE_Extensions__item__id),
        ('criticality', ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue),
        ])
    __LTE_NTN_TAI_Information_iE_Extensions__item_._ext = None
    _LTE_NTN_TAI_Information_iE_Extensions._cont = __LTE_NTN_TAI_Information_iE_Extensions__item_
    _LTE_NTN_TAI_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTE_NTN_TAI_Information._cont = ASN1Dict([
        ('servingPLMN', _LTE_NTN_TAI_Information_servingPLMN),
        ('tACList-In-LTE-NTN', _LTE_NTN_TAI_Information_tACList_In_LTE_NTN),
        ('uE-Location-Derived-TAC', _LTE_NTN_TAI_Information_uE_Location_Derived_TAC),
        ('iE-Extensions', _LTE_NTN_TAI_Information_iE_Extensions),
        ])
    LTE_NTN_TAI_Information._ext = []
    
    #-----< LTE-NTN-TAI-Information-ExtIEs >-----#
    LTE_NTN_TAI_Information_ExtIEs = CLASS(name='LTE-NTN-TAI-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LTE_NTN_TAI_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3Configuration >-----#
    M3Configuration = SEQ(name='M3Configuration', mode=MODE_TYPE)
    _M3Configuration_m3period = ENUM(name='m3period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M3period')))
    _M3Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M3Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M3Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M3Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__id._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M3Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M3Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M3Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__criticality._const_tab = ____M3Configuration_iE_Extensions__item__criticality_tab
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M3Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab = ____M3Configuration_iE_Extensions__item__extensionValue_tab
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M3Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M3Configuration_iE_Extensions__item__id),
        ('criticality', ___M3Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M3Configuration_iE_Extensions__item__extensionValue),
        ])
    __M3Configuration_iE_Extensions__item_._ext = None
    _M3Configuration_iE_Extensions._cont = __M3Configuration_iE_Extensions__item_
    _M3Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M3Configuration._cont = ASN1Dict([
        ('m3period', _M3Configuration_m3period),
        ('iE-Extensions', _M3Configuration_iE_Extensions),
        ])
    M3Configuration._ext = []
    
    #-----< M3Configuration-ExtIEs >-----#
    M3Configuration_ExtIEs = CLASS(name='M3Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M3Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3period >-----#
    M3period = ENUM(name='M3period', mode=MODE_TYPE)
    M3period._cont = ASN1Dict([('ms100', 0), ('ms1000', 1), ('ms10000', 2), ('ms1024', 3), ('ms1280', 4), ('ms2048', 5), ('ms2560', 6), ('ms5120', 7), ('ms10240', 8), ('min1', 9)])
    M3period._ext = ['ms1024', 'ms1280', 'ms2048', 'ms2560', 'ms5120', 'ms10240', 'min1']
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name='M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name='m4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name='m4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M4Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__criticality_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__extensionValue_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M4Configuration_iE_Extensions__item__id),
        ('criticality', ___M4Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        ('m4period', _M4Configuration_m4period),
        ('m4-links-to-log', _M4Configuration_m4_links_to_log),
        ('iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name='M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name='M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name='M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name='m5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name='m5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M5Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__criticality_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__extensionValue_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M5Configuration_iE_Extensions__item__id),
        ('criticality', ___M5Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        ('m5period', _M5Configuration_m5period),
        ('m5-links-to-log', _M5Configuration_m5_links_to_log),
        ('iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name='M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name='M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name='M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name='m6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M6report-Interval')))
    _M6Configuration_m6delay_threshold = ENUM(name='m6delay-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M6delay-threshold')), opt=True)
    _M6Configuration_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M6Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__criticality_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__extensionValue_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Configuration_iE_Extensions__item__id),
        ('criticality', ___M6Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        ('m6report-Interval', _M6Configuration_m6report_Interval),
        ('m6delay-threshold', _M6Configuration_m6delay_threshold),
        ('m6-links-to-log', _M6Configuration_m6_links_to_log),
        ('iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name='M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name='M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3)])
    M6report_Interval._ext = []
    
    #-----< M6delay-threshold >-----#
    M6delay_threshold = ENUM(name='M6delay-threshold', mode=MODE_TYPE)
    M6delay_threshold._cont = ASN1Dict([('ms30', 0), ('ms40', 1), ('ms50', 2), ('ms60', 3), ('ms70', 4), ('ms80', 5), ('ms90', 6), ('ms100', 7), ('ms150', 8), ('ms300', 9), ('ms500', 10), ('ms750', 11)])
    M6delay_threshold._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name='M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name='m7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M7Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__criticality_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__extensionValue_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Configuration_iE_Extensions__item__id),
        ('criticality', ___M7Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        ('m7period', _M7Configuration_m7period),
        ('m7-links-to-log', _M7Configuration_m7_links_to_log),
        ('iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name='M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name='M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediate-MDT-only', 0), ('immediate-MDT-and-Trace', 1), ('logged-MDT-only', 2), ('logged-MBSFN-MDT', 3)])
    MDT_Activation._ext = ['logged-MBSFN-MDT']
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = BIT_STR(name='MDT-Location-Info', mode=MODE_TYPE)
    MDT_Location_Info._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDT-Activation')))
    _MDT_Configuration_areaScopeOfMDT = CHOICE(name='areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AreaScopeOfMDT')))
    _MDT_Configuration_mDTMode = CHOICE(name='mDTMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDTMode')))
    _MDT_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 178), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        ('mdt-Activation', _MDT_Configuration_mdt_Activation),
        ('areaScopeOfMDT', _MDT_Configuration_areaScopeOfMDT),
        ('mDTMode', _MDT_Configuration_mDTMode),
        ('iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name='MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 178), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ManagementBasedMDTAllowed >-----#
    ManagementBasedMDTAllowed = ENUM(name='ManagementBasedMDTAllowed', mode=MODE_TYPE)
    ManagementBasedMDTAllowed._cont = ASN1Dict([('allowed', 0)])
    ManagementBasedMDTAllowed._ext = []
    
    #-----< MBSFN-ResultToLog >-----#
    MBSFN_ResultToLog = SEQ_OF(name='MBSFN-ResultToLog', mode=MODE_TYPE)
    _MBSFN_ResultToLog__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MBSFN-ResultToLogInfo')))
    MBSFN_ResultToLog._cont = _MBSFN_ResultToLog__item_
    MBSFN_ResultToLog._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MBSFN-ResultToLogInfo >-----#
    MBSFN_ResultToLogInfo = SEQ(name='MBSFN-ResultToLogInfo', mode=MODE_TYPE)
    _MBSFN_ResultToLogInfo_mBSFN_AreaId = INT(name='mBSFN-AreaId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBSFN_ResultToLogInfo_mBSFN_AreaId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _MBSFN_ResultToLogInfo_carrierFreq = INT(name='carrierFreq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EARFCN')))
    _MBSFN_ResultToLogInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFN_ResultToLogInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab_at = None
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSFN_ResultToLogInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSFN_ResultToLogInfo_iE_Extensions__item__id),
        ('criticality', ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue),
        ])
    __MBSFN_ResultToLogInfo_iE_Extensions__item_._ext = None
    _MBSFN_ResultToLogInfo_iE_Extensions._cont = __MBSFN_ResultToLogInfo_iE_Extensions__item_
    _MBSFN_ResultToLogInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFN_ResultToLogInfo._cont = ASN1Dict([
        ('mBSFN-AreaId', _MBSFN_ResultToLogInfo_mBSFN_AreaId),
        ('carrierFreq', _MBSFN_ResultToLogInfo_carrierFreq),
        ('iE-Extensions', _MBSFN_ResultToLogInfo_iE_Extensions),
        ])
    MBSFN_ResultToLogInfo._ext = []
    
    #-----< MBSFN-ResultToLogInfo-ExtIEs >-----#
    MBSFN_ResultToLogInfo_ExtIEs = CLASS(name='MBSFN-ResultToLogInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    MBSFN_ResultToLogInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name='MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name='PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([('immediate-MDT', 0), ('logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< MDTMode >-----#
    MDTMode = CHOICE(name='MDTMode', mode=MODE_TYPE)
    _MDTMode_immediateMDT = SEQ(name='immediateMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ImmediateMDT')))
    _MDTMode_loggedMDT = SEQ(name='loggedMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggedMDT')))
    _MDTMode_mDTMode_Extension = SEQ(name='mDTMode-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDTMode-Extension')))
    MDTMode._cont = ASN1Dict([
        ('immediateMDT', _MDTMode_immediateMDT),
        ('loggedMDT', _MDTMode_loggedMDT),
        ('mDTMode-Extension', _MDTMode_mDTMode_Extension),
        ])
    MDTMode._ext = ['mDTMode-Extension']
    
    #-----< MDTMode-Extension >-----#
    MDTMode_Extension = SEQ(name='MDTMode-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _MDTMode_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    __MDTMode_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___MDTMode_Extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMBSFNMDT')))
    __MDTMode_Extension_id_tab._val = ASN1Set(rv=[dict([('id', 197), ('criticality', 'ignore'), ('Value', ___MDTMode_Extension_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _MDTMode_Extension_id._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_id._const_tab_at = None
    _MDTMode_Extension_id._const_tab_id = 'id'
    _MDTMode_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    _MDTMode_Extension_criticality._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_criticality._const_tab_at = ('..', 'id')
    _MDTMode_Extension_criticality._const_tab_id = 'criticality'
    _MDTMode_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    _MDTMode_Extension_value._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_value._const_tab_at = ('..', 'id')
    _MDTMode_Extension_value._const_tab_id = 'Value'
    MDTMode_Extension._cont = ASN1Dict([
        ('id', _MDTMode_Extension_id),
        ('criticality', _MDTMode_Extension_criticality),
        ('value', _MDTMode_Extension_value),
        ])
    MDTMode_Extension._ext = None
    
    #-----< MDTMode-ExtensionIE >-----#
    MDTMode_ExtensionIE = CLASS(name='MDTMode-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MDTMode_ExtensionIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMBSFNMDT')))
    MDTMode_ExtensionIE._val = ASN1Set(rv=[dict([('id', 197), ('criticality', 'ignore'), ('Value', _MDTMode_ExtensionIE_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MeasurementThresholdA2 >-----#
    MeasurementThresholdA2 = CHOICE(name='MeasurementThresholdA2', mode=MODE_TYPE)
    _MeasurementThresholdA2_threshold_RSRP = INT(name='threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdA2_threshold_RSRQ = INT(name='threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRQ')))
    MeasurementThresholdA2._cont = ASN1Dict([
        ('threshold-RSRP', _MeasurementThresholdA2_threshold_RSRP),
        ('threshold-RSRQ', _MeasurementThresholdA2_threshold_RSRQ),
        ])
    MeasurementThresholdA2._ext = []
    
    #-----< MeasurementThresholdL1LoggedMDT >-----#
    MeasurementThresholdL1LoggedMDT = CHOICE(name='MeasurementThresholdL1LoggedMDT', mode=MODE_TYPE)
    _MeasurementThresholdL1LoggedMDT_threshold_RSRP = INT(name='threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdL1LoggedMDT_threshold_RSRQ = INT(name='threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRQ')))
    _MeasurementThresholdL1LoggedMDT_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_at = None
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_id = 'id'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_id = 'Value'
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._cont = ASN1Dict([
        ('id', __MeasurementThresholdL1LoggedMDT_choice_Extensions_id),
        ('criticality', __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality),
        ('value', __MeasurementThresholdL1LoggedMDT_choice_Extensions_value),
        ])
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._ext = None
    MeasurementThresholdL1LoggedMDT._cont = ASN1Dict([
        ('threshold-RSRP', _MeasurementThresholdL1LoggedMDT_threshold_RSRP),
        ('threshold-RSRQ', _MeasurementThresholdL1LoggedMDT_threshold_RSRQ),
        ('choice-Extensions', _MeasurementThresholdL1LoggedMDT_choice_Extensions),
        ])
    MeasurementThresholdL1LoggedMDT._ext = None
    
    #-----< MeasurementThresholdL1LoggedMDT-ExtIEs >-----#
    MeasurementThresholdL1LoggedMDT_ExtIEs = CLASS(name='MeasurementThresholdL1LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    MeasurementThresholdL1LoggedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name='MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name='MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< MMEname >-----#
    MMEname = STR_PRINT(name='MMEname', mode=MODE_TYPE)
    MMEname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< MMEPagingTarget >-----#
    MMEPagingTarget = CHOICE(name='MMEPagingTarget', mode=MODE_TYPE)
    _MMEPagingTarget_global_ENB_ID = SEQ(name='global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _MMEPagingTarget_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    MMEPagingTarget._cont = ASN1Dict([
        ('global-ENB-ID', _MMEPagingTarget_global_ENB_ID),
        ('tAI', _MMEPagingTarget_tAI),
        ])
    MMEPagingTarget._ext = []
    
    #-----< MMERelaySupportIndicator >-----#
    MMERelaySupportIndicator = ENUM(name='MMERelaySupportIndicator', mode=MODE_TYPE)
    MMERelaySupportIndicator._cont = ASN1Dict([('true', 0)])
    MMERelaySupportIndicator._ext = []
    
    #-----< MME-Group-ID >-----#
    MME_Group_ID = OCT_STR(name='MME-Group-ID', mode=MODE_TYPE)
    MME_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MME-Code >-----#
    MME_Code = OCT_STR(name='MME-Code', mode=MODE_TYPE)
    MME_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MME-UE-S1AP-ID >-----#
    MME_UE_S1AP_ID = INT(name='MME-UE-S1AP-ID', mode=MODE_TYPE)
    MME_UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< M-TMSI >-----#
    M_TMSI = OCT_STR(name='M-TMSI', mode=MODE_TYPE)
    M_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< MSClassmark2 >-----#
    MSClassmark2 = OCT_STR(name='MSClassmark2', mode=MODE_TYPE)
    
    #-----< MSClassmark3 >-----#
    MSClassmark3 = OCT_STR(name='MSClassmark3', mode=MODE_TYPE)
    
    #-----< MutingAvailabilityIndication >-----#
    MutingAvailabilityIndication = ENUM(name='MutingAvailabilityIndication', mode=MODE_TYPE)
    MutingAvailabilityIndication._cont = ASN1Dict([('available', 0), ('unavailable', 1)])
    MutingAvailabilityIndication._ext = []
    
    #-----< MutingPatternInformation >-----#
    MutingPatternInformation = SEQ(name='MutingPatternInformation', mode=MODE_TYPE)
    _MutingPatternInformation_muting_pattern_period = ENUM(name='muting-pattern-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MutingPatternInformation_muting_pattern_period._cont = ASN1Dict([('ms0', 0), ('ms1280', 1), ('ms2560', 2), ('ms5120', 3), ('ms10240', 4)])
    _MutingPatternInformation_muting_pattern_period._ext = []
    _MutingPatternInformation_muting_pattern_offset = INT(name='muting-pattern-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MutingPatternInformation_muting_pattern_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=[], er=[])
    _MutingPatternInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MutingPatternInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MutingPatternInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____MutingPatternInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab = ____MutingPatternInformation_iE_Extensions__item__id_tab
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab_at = None
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MutingPatternInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MutingPatternInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab = ____MutingPatternInformation_iE_Extensions__item__criticality_tab
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MutingPatternInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab = ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MutingPatternInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MutingPatternInformation_iE_Extensions__item__id),
        ('criticality', ___MutingPatternInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MutingPatternInformation_iE_Extensions__item__extensionValue),
        ])
    __MutingPatternInformation_iE_Extensions__item_._ext = None
    _MutingPatternInformation_iE_Extensions._cont = __MutingPatternInformation_iE_Extensions__item_
    _MutingPatternInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MutingPatternInformation._cont = ASN1Dict([
        ('muting-pattern-period', _MutingPatternInformation_muting_pattern_period),
        ('muting-pattern-offset', _MutingPatternInformation_muting_pattern_offset),
        ('iE-Extensions', _MutingPatternInformation_iE_Extensions),
        ])
    MutingPatternInformation._ext = []
    
    #-----< MutingPatternInformation-ExtIEs >-----#
    MutingPatternInformation_ExtIEs = CLASS(name='MutingPatternInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    MutingPatternInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-ConfigurationNR >-----#
    MDT_ConfigurationNR = OCT_STR(name='MDT-ConfigurationNR', mode=MODE_TYPE)
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name='NAS-PDU', mode=MODE_TYPE)
    
    #-----< NASSecurityParametersfromE-UTRAN >-----#
    NASSecurityParametersfromE_UTRAN = OCT_STR(name='NASSecurityParametersfromE-UTRAN', mode=MODE_TYPE)
    
    #-----< NASSecurityParameterstoE-UTRAN >-----#
    NASSecurityParameterstoE_UTRAN = OCT_STR(name='NASSecurityParameterstoE-UTRAN', mode=MODE_TYPE)
    
    #-----< NB-IoT-DefaultPagingDRX >-----#
    NB_IoT_DefaultPagingDRX = ENUM(name='NB-IoT-DefaultPagingDRX', mode=MODE_TYPE)
    NB_IoT_DefaultPagingDRX._cont = ASN1Dict([('v128', 0), ('v256', 1), ('v512', 2), ('v1024', 3)])
    NB_IoT_DefaultPagingDRX._ext = []
    
    #-----< NB-IoT-PagingDRX >-----#
    NB_IoT_PagingDRX = ENUM(name='NB-IoT-PagingDRX', mode=MODE_TYPE)
    NB_IoT_PagingDRX._cont = ASN1Dict([('v32', 0), ('v64', 1), ('v128', 2), ('v256', 3), ('v512', 4), ('v1024', 5)])
    NB_IoT_PagingDRX._ext = []
    
    #-----< NB-IoT-Paging-eDRXInformation >-----#
    NB_IoT_Paging_eDRXInformation = SEQ(name='NB-IoT-Paging-eDRXInformation', mode=MODE_TYPE)
    _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle = ENUM(name='nB-IoT-paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRX-Cycle')))
    _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow = ENUM(name='nB-IoT-pagingTimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingTimeWindow')), opt=True)
    _NB_IoT_Paging_eDRXInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id),
        ('criticality', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_._ext = None
    _NB_IoT_Paging_eDRXInformation_iE_Extensions._cont = __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_
    _NB_IoT_Paging_eDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NB_IoT_Paging_eDRXInformation._cont = ASN1Dict([
        ('nB-IoT-paging-eDRX-Cycle', _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle),
        ('nB-IoT-pagingTimeWindow', _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow),
        ('iE-Extensions', _NB_IoT_Paging_eDRXInformation_iE_Extensions),
        ])
    NB_IoT_Paging_eDRXInformation._ext = []
    
    #-----< NB-IoT-Paging-eDRXInformation-ExtIEs >-----#
    NB_IoT_Paging_eDRXInformation_ExtIEs = CLASS(name='NB-IoT-Paging-eDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NB_IoT_Paging_eDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NB-IoT-Paging-eDRX-Cycle >-----#
    NB_IoT_Paging_eDRX_Cycle = ENUM(name='NB-IoT-Paging-eDRX-Cycle', mode=MODE_TYPE)
    NB_IoT_Paging_eDRX_Cycle._cont = ASN1Dict([('hf2', 0), ('hf4', 1), ('hf6', 2), ('hf8', 3), ('hf10', 4), ('hf12', 5), ('hf14', 6), ('hf16', 7), ('hf32', 8), ('hf64', 9), ('hf128', 10), ('hf256', 11), ('hf512', 12), ('hf1024', 13)])
    NB_IoT_Paging_eDRX_Cycle._ext = []
    
    #-----< NB-IoT-PagingTimeWindow >-----#
    NB_IoT_PagingTimeWindow = ENUM(name='NB-IoT-PagingTimeWindow', mode=MODE_TYPE)
    NB_IoT_PagingTimeWindow._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15)])
    NB_IoT_PagingTimeWindow._ext = []
    
    #-----< NB-IoT-RLF-Report-Container >-----#
    NB_IoT_RLF_Report_Container = OCT_STR(name='NB-IoT-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< NB-IoT-UEIdentityIndexValue >-----#
    NB_IoT_UEIdentityIndexValue = BIT_STR(name='NB-IoT-UEIdentityIndexValue', mode=MODE_TYPE)
    NB_IoT_UEIdentityIndexValue._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< NextPagingAreaScope >-----#
    NextPagingAreaScope = ENUM(name='NextPagingAreaScope', mode=MODE_TYPE)
    NextPagingAreaScope._cont = ASN1Dict([('same', 0), ('changed', 1)])
    NextPagingAreaScope._ext = []
    
    #-----< NotifySourceeNB >-----#
    NotifySourceeNB = ENUM(name='NotifySourceeNB', mode=MODE_TYPE)
    NotifySourceeNB._cont = ASN1Dict([('notifySource', 0)])
    NotifySourceeNB._ext = []
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name='NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = SEQ(name='NR-CGI', mode=MODE_TYPE)
    _NR_CGI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _NR_CGI_nRCellIdentity = BIT_STR(name='nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRCellIdentity')))
    _NR_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__id._const_tab = ____NR_CGI_iE_Extensions__item__id_tab
    ___NR_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__criticality._const_tab = ____NR_CGI_iE_Extensions__item__criticality_tab
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_CGI_iE_Extensions__item__id),
        ('criticality', ___NR_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_CGI_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_iE_Extensions__item_._ext = None
    _NR_CGI_iE_Extensions._cont = __NR_CGI_iE_Extensions__item_
    _NR_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI._cont = ASN1Dict([
        ('pLMNIdentity', _NR_CGI_pLMNIdentity),
        ('nRCellIdentity', _NR_CGI_nRCellIdentity),
        ('iE-Extensions', _NR_CGI_iE_Extensions),
        ])
    NR_CGI._ext = []
    
    #-----< NR-CGI-ExtIEs >-----#
    NR_CGI_ExtIEs = CLASS(name='NR-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NR_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRencryptionAlgorithms >-----#
    NRencryptionAlgorithms = BIT_STR(name='NRencryptionAlgorithms', mode=MODE_TYPE)
    NRencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRintegrityProtectionAlgorithms >-----#
    NRintegrityProtectionAlgorithms = BIT_STR(name='NRintegrityProtectionAlgorithms', mode=MODE_TYPE)
    NRintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRrestrictioninEPSasSecondaryRAT >-----#
    NRrestrictioninEPSasSecondaryRAT = ENUM(name='NRrestrictioninEPSasSecondaryRAT', mode=MODE_TYPE)
    NRrestrictioninEPSasSecondaryRAT._cont = ASN1Dict([('nRrestrictedinEPSasSecondaryRAT', 0)])
    NRrestrictioninEPSasSecondaryRAT._ext = []
    
    #-----< NRrestrictionin5GS >-----#
    NRrestrictionin5GS = ENUM(name='NRrestrictionin5GS', mode=MODE_TYPE)
    NRrestrictionin5GS._cont = ASN1Dict([('nRrestrictedin5GS', 0)])
    NRrestrictionin5GS._ext = []
    
    #-----< NRUESecurityCapabilities >-----#
    NRUESecurityCapabilities = SEQ(name='NRUESecurityCapabilities', mode=MODE_TYPE)
    _NRUESecurityCapabilities_nRencryptionAlgorithms = BIT_STR(name='nRencryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRencryptionAlgorithms')))
    _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms = BIT_STR(name='nRintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRintegrityProtectionAlgorithms')))
    _NRUESecurityCapabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESecurityCapabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__id_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESecurityCapabilities_iE_Extensions__item__id),
        ('criticality', ___NRUESecurityCapabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __NRUESecurityCapabilities_iE_Extensions__item_._ext = None
    _NRUESecurityCapabilities_iE_Extensions._cont = __NRUESecurityCapabilities_iE_Extensions__item_
    _NRUESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESecurityCapabilities._cont = ASN1Dict([
        ('nRencryptionAlgorithms', _NRUESecurityCapabilities_nRencryptionAlgorithms),
        ('nRintegrityProtectionAlgorithms', _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms),
        ('iE-Extensions', _NRUESecurityCapabilities_iE_Extensions),
        ])
    NRUESecurityCapabilities._ext = []
    
    #-----< NRUESecurityCapabilities-ExtIEs >-----#
    NRUESecurityCapabilities_ExtIEs = CLASS(name='NRUESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRUESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NumberofBroadcastRequest >-----#
    NumberofBroadcastRequest = INT(name='NumberofBroadcastRequest', mode=MODE_TYPE)
    NumberofBroadcastRequest._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name='NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name='NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = []
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name='NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name='NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate = INT(name='uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uEaggregateMaximumBitRate', _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate),
        ('iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name='NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OldBSS-ToNewBSS-Information >-----#
    OldBSS_ToNewBSS_Information = OCT_STR(name='OldBSS-ToNewBSS-Information', mode=MODE_TYPE)
    
    #-----< OverloadAction >-----#
    OverloadAction = ENUM(name='OverloadAction', mode=MODE_TYPE)
    OverloadAction._cont = ASN1Dict([('reject-non-emergency-mo-dt', 0), ('reject-rrc-cr-signalling', 1), ('permit-emergency-sessions-and-mobile-terminated-services-only', 2), ('permit-high-priority-sessions-and-mobile-terminated-services-only', 3), ('reject-delay-tolerant-access', 4), ('permit-high-priority-sessions-and-exception-reporting-and-mobile-terminated-services-only', 5), ('not-accept-mo-data-or-delay-tolerant-access-from-CP-CIoT', 6)])
    OverloadAction._ext = ['permit-high-priority-sessions-and-mobile-terminated-services-only', 'reject-delay-tolerant-access', 'permit-high-priority-sessions-and-exception-reporting-and-mobile-terminated-services-only', 'not-accept-mo-data-or-delay-tolerant-access-from-CP-CIoT']
    
    #-----< OverloadResponse >-----#
    OverloadResponse = CHOICE(name='OverloadResponse', mode=MODE_TYPE)
    _OverloadResponse_overloadAction = ENUM(name='overloadAction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'OverloadAction')))
    OverloadResponse._cont = ASN1Dict([
        ('overloadAction', _OverloadResponse_overloadAction),
        ])
    OverloadResponse._ext = []
    
    #-----< Packet-LossRate >-----#
    Packet_LossRate = INT(name='Packet-LossRate', mode=MODE_TYPE)
    Packet_LossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< PagingAttemptInformation >-----#
    PagingAttemptInformation = SEQ(name='PagingAttemptInformation', mode=MODE_TYPE)
    _PagingAttemptInformation_pagingAttemptCount = INT(name='pagingAttemptCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingAttemptCount')))
    _PagingAttemptInformation_intendedNumberOfPagingAttempts = INT(name='intendedNumberOfPagingAttempts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntendedNumberOfPagingAttempts')))
    _PagingAttemptInformation_nextPagingAreaScope = ENUM(name='nextPagingAreaScope', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NextPagingAreaScope')), opt=True)
    _PagingAttemptInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAttemptInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PagingAttemptInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab = ____PagingAttemptInformation_iE_Extensions__item__id_tab
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_at = None
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PagingAttemptInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab = ____PagingAttemptInformation_iE_Extensions__item__criticality_tab
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab = ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PagingAttemptInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PagingAttemptInformation_iE_Extensions__item__id),
        ('criticality', ___PagingAttemptInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PagingAttemptInformation_iE_Extensions__item__extensionValue),
        ])
    __PagingAttemptInformation_iE_Extensions__item_._ext = None
    _PagingAttemptInformation_iE_Extensions._cont = __PagingAttemptInformation_iE_Extensions__item_
    _PagingAttemptInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAttemptInformation._cont = ASN1Dict([
        ('pagingAttemptCount', _PagingAttemptInformation_pagingAttemptCount),
        ('intendedNumberOfPagingAttempts', _PagingAttemptInformation_intendedNumberOfPagingAttempts),
        ('nextPagingAreaScope', _PagingAttemptInformation_nextPagingAreaScope),
        ('iE-Extensions', _PagingAttemptInformation_iE_Extensions),
        ])
    PagingAttemptInformation._ext = []
    
    #-----< PagingAttemptInformation-ExtIEs >-----#
    PagingAttemptInformation_ExtIEs = CLASS(name='PagingAttemptInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PagingAttemptInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptCount >-----#
    PagingAttemptCount = INT(name='PagingAttemptCount', mode=MODE_TYPE)
    PagingAttemptCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< Paging-eDRXInformation >-----#
    Paging_eDRXInformation = SEQ(name='Paging-eDRXInformation', mode=MODE_TYPE)
    _Paging_eDRXInformation_paging_eDRX_Cycle = ENUM(name='paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRX-Cycle')))
    _Paging_eDRXInformation_pagingTimeWindow = ENUM(name='pagingTimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingTimeWindow')), opt=True)
    _Paging_eDRXInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_eDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Paging_eDRXInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_eDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__id_tab
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___Paging_eDRXInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_eDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Paging_eDRXInformation_iE_Extensions__item__id),
        ('criticality', ___Paging_eDRXInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___Paging_eDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __Paging_eDRXInformation_iE_Extensions__item_._ext = None
    _Paging_eDRXInformation_iE_Extensions._cont = __Paging_eDRXInformation_iE_Extensions__item_
    _Paging_eDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_eDRXInformation._cont = ASN1Dict([
        ('paging-eDRX-Cycle', _Paging_eDRXInformation_paging_eDRX_Cycle),
        ('pagingTimeWindow', _Paging_eDRXInformation_pagingTimeWindow),
        ('iE-Extensions', _Paging_eDRXInformation_iE_Extensions),
        ])
    Paging_eDRXInformation._ext = []
    
    #-----< Paging-eDRXInformation-ExtIEs >-----#
    Paging_eDRXInformation_ExtIEs = CLASS(name='Paging-eDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Paging_eDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging-eDRX-Cycle >-----#
    Paging_eDRX_Cycle = ENUM(name='Paging-eDRX-Cycle', mode=MODE_TYPE)
    Paging_eDRX_Cycle._cont = ASN1Dict([('hfhalf', 0), ('hf1', 1), ('hf2', 2), ('hf4', 3), ('hf6', 4), ('hf8', 5), ('hf10', 6), ('hf12', 7), ('hf14', 8), ('hf16', 9), ('hf32', 10), ('hf64', 11), ('hf128', 12), ('hf256', 13)])
    Paging_eDRX_Cycle._ext = []
    
    #-----< PagingTimeWindow >-----#
    PagingTimeWindow = ENUM(name='PagingTimeWindow', mode=MODE_TYPE)
    PagingTimeWindow._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15)])
    PagingTimeWindow._ext = []
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name='PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([('v32', 0), ('v64', 1), ('v128', 2), ('v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name='PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([('priolevel1', 0), ('priolevel2', 1), ('priolevel3', 2), ('priolevel4', 3), ('priolevel5', 4), ('priolevel6', 5), ('priolevel7', 6), ('priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< PagingProbabilityInformation >-----#
    PagingProbabilityInformation = ENUM(name='PagingProbabilityInformation', mode=MODE_TYPE)
    PagingProbabilityInformation._cont = ASN1Dict([('p00', 0), ('p05', 1), ('p10', 2), ('p15', 3), ('p20', 4), ('p25', 5), ('p30', 6), ('p35', 7), ('p40', 8), ('p45', 9), ('p50', 10), ('p55', 11), ('p60', 12), ('p65', 13), ('p70', 14), ('p75', 15), ('p80', 16), ('p85', 17), ('p90', 18), ('p95', 19), ('p100', 20)])
    PagingProbabilityInformation._ext = []
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name='PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([('voice', 0)])
    PagingCause._ext = []
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name='PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pc5QoSFlowList = SEQ_OF(name='pc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSFlowList')))
    _PC5QoSParameters_pc5LinkAggregatedBitRates = INT(name='pc5LinkAggregatedBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSParameters_iE_Extensions__item__id),
        ('criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        ('pc5QoSFlowList', _PC5QoSParameters_pc5QoSFlowList),
        ('pc5LinkAggregatedBitRates', _PC5QoSParameters_pc5LinkAggregatedBitRates),
        ('iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name='PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowList >-----#
    PC5QoSFlowList = SEQ_OF(name='PC5QoSFlowList', mode=MODE_TYPE)
    _PC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSFlowItem')))
    PC5QoSFlowList._cont = _PC5QoSFlowList__item_
    PC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5QoSFlowItem >-----#
    PC5QoSFlowItem = SEQ(name='PC5QoSFlowItem', mode=MODE_TYPE)
    _PC5QoSFlowItem_pQI = INT(name='pQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveQI')))
    _PC5QoSFlowItem_pc5FlowBitRates = SEQ(name='pc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSFlowItem_range = ENUM(name='range', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Range')), opt=True)
    _PC5QoSFlowItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSFlowItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__id_tab
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSFlowItem_iE_Extensions__item__id),
        ('criticality', ___PC5QoSFlowItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSFlowItem_iE_Extensions__item_._ext = None
    _PC5QoSFlowItem_iE_Extensions._cont = __PC5QoSFlowItem_iE_Extensions__item_
    _PC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSFlowItem._cont = ASN1Dict([
        ('pQI', _PC5QoSFlowItem_pQI),
        ('pc5FlowBitRates', _PC5QoSFlowItem_pc5FlowBitRates),
        ('range', _PC5QoSFlowItem_range),
        ('iE-Extensions', _PC5QoSFlowItem_iE_Extensions),
        ])
    PC5QoSFlowItem._ext = []
    
    #-----< PC5QoSFlowItem-ExtIEs >-----#
    PC5QoSFlowItem_ExtIEs = CLASS(name='PC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name='PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name='guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name='maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5FlowBitRates_iE_Extensions__item__id),
        ('criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        ('guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        ('maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        ('iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name='PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name='PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCP-SNExtended >-----#
    PDCP_SNExtended = INT(name='PDCP-SNExtended', mode=MODE_TYPE)
    PDCP_SNExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< PDCP-SNlength18 >-----#
    PDCP_SNlength18 = INT(name='PDCP-SNlength18', mode=MODE_TYPE)
    PDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< PendingDataIndication >-----#
    PendingDataIndication = ENUM(name='PendingDataIndication', mode=MODE_TYPE)
    PendingDataIndication._cont = ASN1Dict([('true', 0)])
    PendingDataIndication._ext = []
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name='M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__criticality_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1PeriodicReporting_iE_Extensions__item__id),
        ('criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        ('extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        ('reportInterval', _M1PeriodicReporting_reportInterval),
        ('reportAmount', _M1PeriodicReporting_reportAmount),
        ('iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name='M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNidentity >-----#
    PLMNidentity = OCT_STR(name='PLMNidentity', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TBCD-STRING')))
    
    #-----< PLMNAreaBasedQMC >-----#
    PLMNAreaBasedQMC = SEQ(name='PLMNAreaBasedQMC', mode=MODE_TYPE)
    _PLMNAreaBasedQMC_plmnListforQMC = SEQ_OF(name='plmnListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNListforQMC')))
    _PLMNAreaBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNAreaBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PLMNAreaBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLMNAreaBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLMNAreaBasedQMC_iE_Extensions__item__id),
        ('criticality', ___PLMNAreaBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __PLMNAreaBasedQMC_iE_Extensions__item_._ext = None
    _PLMNAreaBasedQMC_iE_Extensions._cont = __PLMNAreaBasedQMC_iE_Extensions__item_
    _PLMNAreaBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNAreaBasedQMC._cont = ASN1Dict([
        ('plmnListforQMC', _PLMNAreaBasedQMC_plmnListforQMC),
        ('iE-Extensions', _PLMNAreaBasedQMC_iE_Extensions),
        ])
    PLMNAreaBasedQMC._ext = []
    
    #-----< PLMNAreaBasedQMC-ExtIEs >-----#
    PLMNAreaBasedQMC_ExtIEs = CLASS(name='PLMNAreaBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PLMNAreaBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNListforQMC >-----#
    PLMNListforQMC = SEQ_OF(name='PLMNListforQMC', mode=MODE_TYPE)
    _PLMNListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    PLMNListforQMC._cont = _PLMNListforQMC__item_
    PLMNListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name='Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProSeAuthorized >-----#
    ProSeAuthorized = SEQ(name='ProSeAuthorized', mode=MODE_TYPE)
    _ProSeAuthorized_proSeDirectDiscovery = ENUM(name='proSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ProSeDirectDiscovery')), opt=True)
    _ProSeAuthorized_proSeDirectCommunication = ENUM(name='proSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ProSeDirectCommunication')), opt=True)
    _ProSeAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ProSeAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ____ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 216), ('criticality', 'ignore'), ('Extension', _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ProSeAuthorized_iE_Extensions__item__id),
        ('criticality', ___ProSeAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __ProSeAuthorized_iE_Extensions__item_._ext = None
    _ProSeAuthorized_iE_Extensions._cont = __ProSeAuthorized_iE_Extensions__item_
    _ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProSeAuthorized._cont = ASN1Dict([
        ('proSeDirectDiscovery', _ProSeAuthorized_proSeDirectDiscovery),
        ('proSeDirectCommunication', _ProSeAuthorized_proSeDirectCommunication),
        ('iE-Extensions', _ProSeAuthorized_iE_Extensions),
        ])
    ProSeAuthorized._ext = []
    
    #-----< ProSeAuthorized-ExtIEs >-----#
    ProSeAuthorized_ExtIEs = CLASS(name='ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ProSeAuthorized_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[dict([('id', 216), ('criticality', 'ignore'), ('Extension', _ProSeAuthorized_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ProSeDirectDiscovery >-----#
    ProSeDirectDiscovery = ENUM(name='ProSeDirectDiscovery', mode=MODE_TYPE)
    ProSeDirectDiscovery._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeDirectDiscovery._ext = []
    
    #-----< ProSeUEtoNetworkRelaying >-----#
    ProSeUEtoNetworkRelaying = ENUM(name='ProSeUEtoNetworkRelaying', mode=MODE_TYPE)
    ProSeUEtoNetworkRelaying._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeUEtoNetworkRelaying._ext = []
    
    #-----< ProSeDirectCommunication >-----#
    ProSeDirectCommunication = ENUM(name='ProSeDirectCommunication', mode=MODE_TYPE)
    ProSeDirectCommunication._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeDirectCommunication._ext = []
    
    #-----< PS-ServiceNotAvailable >-----#
    PS_ServiceNotAvailable = ENUM(name='PS-ServiceNotAvailable', mode=MODE_TYPE)
    PS_ServiceNotAvailable._cont = ASN1Dict([('ps-service-not-available', 0)])
    PS_ServiceNotAvailable._ext = []
    
    #-----< PSCellInformation >-----#
    PSCellInformation = SEQ(name='PSCellInformation', mode=MODE_TYPE)
    _PSCellInformation_nCGI = SEQ(name='nCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NR-CGI')))
    _PSCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PSCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PSCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____PSCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__id._const_tab = ____PSCellInformation_iE_Extensions__item__id_tab
    ___PSCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___PSCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PSCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PSCellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab = ____PSCellInformation_iE_Extensions__item__criticality_tab
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PSCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PSCellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab = ____PSCellInformation_iE_Extensions__item__extensionValue_tab
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PSCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PSCellInformation_iE_Extensions__item__id),
        ('criticality', ___PSCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PSCellInformation_iE_Extensions__item__extensionValue),
        ])
    __PSCellInformation_iE_Extensions__item_._ext = None
    _PSCellInformation_iE_Extensions._cont = __PSCellInformation_iE_Extensions__item_
    _PSCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PSCellInformation._cont = ASN1Dict([
        ('nCGI', _PSCellInformation_nCGI),
        ('iE-Extensions', _PSCellInformation_iE_Extensions),
        ])
    PSCellInformation._ext = []
    
    #-----< PSCellInformation-ExtIEs >-----#
    PSCellInformation_ExtIEs = CLASS(name='PSCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PSCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QCI >-----#
    QCI = INT(name='QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RACSIndication >-----#
    RACSIndication = ENUM(name='RACSIndication', mode=MODE_TYPE)
    RACSIndication._cont = ASN1Dict([('true', 0)])
    RACSIndication._ext = []
    
    #-----< RAN-UE-NGAP-ID >-----#
    RAN_UE_NGAP_ID = INT(name='RAN-UE-NGAP-ID', mode=MODE_TYPE)
    RAN_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Range >-----#
    Range = ENUM(name='Range', mode=MODE_TYPE)
    Range._cont = ASN1Dict([('m50', 0), ('m80', 1), ('m180', 2), ('m200', 3), ('m350', 4), ('m400', 5), ('m500', 6), ('m700', 7), ('m1000', 8)])
    Range._ext = []
    
    #-----< ReceiveStatusofULPDCPSDUs >-----#
    ReceiveStatusofULPDCPSDUs = BIT_STR(name='ReceiveStatusofULPDCPSDUs', mode=MODE_TYPE)
    ReceiveStatusofULPDCPSDUs._const_sz = ASN1Set(rv=[4096], rr=[], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsExtended >-----#
    ReceiveStatusOfULPDCPSDUsExtended = BIT_STR(name='ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsExtended._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = BIT_STR(name='ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    
    #-----< RecommendedCellsForPaging >-----#
    RecommendedCellsForPaging = SEQ(name='RecommendedCellsForPaging', mode=MODE_TYPE)
    _RecommendedCellsForPaging_recommendedCellList = SEQ_OF(name='recommendedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellList')))
    _RecommendedCellsForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellsForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__id_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedCellsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedCellsForPaging_iE_Extensions__item__id),
        ('criticality', ___RecommendedCellsForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellsForPaging_iE_Extensions__item_._ext = None
    _RecommendedCellsForPaging_iE_Extensions._cont = __RecommendedCellsForPaging_iE_Extensions__item_
    _RecommendedCellsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellsForPaging._cont = ASN1Dict([
        ('recommendedCellList', _RecommendedCellsForPaging_recommendedCellList),
        ('iE-Extensions', _RecommendedCellsForPaging_iE_Extensions),
        ])
    RecommendedCellsForPaging._ext = []
    
    #-----< RecommendedCellsForPaging-ExtIEs >-----#
    RecommendedCellsForPaging_ExtIEs = CLASS(name='RecommendedCellsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellList >-----#
    RecommendedCellList = SEQ_OF(name='RecommendedCellList', mode=MODE_TYPE)
    _RecommendedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RecommendedCellList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___RecommendedCellList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____RecommendedCellList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellItem')))
    ___RecommendedCellList__item__id_tab._val = ASN1Set(rv=[dict([('id', 214), ('criticality', 'ignore'), ('Value', ____RecommendedCellList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RecommendedCellList__item__id._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__id._const_tab_at = None
    __RecommendedCellList__item__id._const_tab_id = 'id'
    __RecommendedCellList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __RecommendedCellList__item__criticality._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__criticality._const_tab_at = ('..', 'id')
    __RecommendedCellList__item__criticality._const_tab_id = 'criticality'
    __RecommendedCellList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __RecommendedCellList__item__value._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__value._const_tab_at = ('..', 'id')
    __RecommendedCellList__item__value._const_tab_id = 'Value'
    _RecommendedCellList__item_._cont = ASN1Dict([
        ('id', __RecommendedCellList__item__id),
        ('criticality', __RecommendedCellList__item__criticality),
        ('value', __RecommendedCellList__item__value),
        ])
    _RecommendedCellList__item_._ext = None
    RecommendedCellList._cont = _RecommendedCellList__item_
    RecommendedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedCellItemIEs >-----#
    RecommendedCellItemIEs = CLASS(name='RecommendedCellItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RecommendedCellItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellItem')))
    RecommendedCellItemIEs._val = ASN1Set(rv=[dict([('id', 214), ('criticality', 'ignore'), ('Value', _RecommendedCellItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellItem >-----#
    RecommendedCellItem = SEQ(name='RecommendedCellItem', mode=MODE_TYPE)
    _RecommendedCellItem_eUTRAN_CGI = SEQ(name='eUTRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _RecommendedCellItem_timeStayedInCell = INT(name='timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecommendedCellItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _RecommendedCellItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab = ____RecommendedCellItem_iE_Extensions__item__id_tab
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedCellItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab = ____RecommendedCellItem_iE_Extensions__item__criticality_tab
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedCellItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedCellItem_iE_Extensions__item__id),
        ('criticality', ___RecommendedCellItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedCellItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellItem_iE_Extensions__item_._ext = None
    _RecommendedCellItem_iE_Extensions._cont = __RecommendedCellItem_iE_Extensions__item_
    _RecommendedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellItem._cont = ASN1Dict([
        ('eUTRAN-CGI', _RecommendedCellItem_eUTRAN_CGI),
        ('timeStayedInCell', _RecommendedCellItem_timeStayedInCell),
        ('iE-Extensions', _RecommendedCellItem_iE_Extensions),
        ])
    RecommendedCellItem._ext = []
    
    #-----< RecommendedCellsForPagingItem-ExtIEs >-----#
    RecommendedCellsForPagingItem_ExtIEs = CLASS(name='RecommendedCellsForPagingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPagingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBsForPaging >-----#
    RecommendedENBsForPaging = SEQ(name='RecommendedENBsForPaging', mode=MODE_TYPE)
    _RecommendedENBsForPaging_recommendedENBList = SEQ_OF(name='recommendedENBList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBList')))
    _RecommendedENBsForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedENBsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedENBsForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedENBsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__id_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedENBsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedENBsForPaging_iE_Extensions__item__id),
        ('criticality', ___RecommendedENBsForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedENBsForPaging_iE_Extensions__item_._ext = None
    _RecommendedENBsForPaging_iE_Extensions._cont = __RecommendedENBsForPaging_iE_Extensions__item_
    _RecommendedENBsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedENBsForPaging._cont = ASN1Dict([
        ('recommendedENBList', _RecommendedENBsForPaging_recommendedENBList),
        ('iE-Extensions', _RecommendedENBsForPaging_iE_Extensions),
        ])
    RecommendedENBsForPaging._ext = []
    
    #-----< RecommendedENBsForPaging-ExtIEs >-----#
    RecommendedENBsForPaging_ExtIEs = CLASS(name='RecommendedENBsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedENBsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBList >-----#
    RecommendedENBList = SEQ_OF(name='RecommendedENBList', mode=MODE_TYPE)
    _RecommendedENBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RecommendedENBList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___RecommendedENBList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____RecommendedENBList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBItem')))
    ___RecommendedENBList__item__id_tab._val = ASN1Set(rv=[dict([('id', 215), ('criticality', 'ignore'), ('Value', ____RecommendedENBList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __RecommendedENBList__item__id._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__id._const_tab_at = None
    __RecommendedENBList__item__id._const_tab_id = 'id'
    __RecommendedENBList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __RecommendedENBList__item__criticality._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__criticality._const_tab_at = ('..', 'id')
    __RecommendedENBList__item__criticality._const_tab_id = 'criticality'
    __RecommendedENBList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __RecommendedENBList__item__value._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__value._const_tab_at = ('..', 'id')
    __RecommendedENBList__item__value._const_tab_id = 'Value'
    _RecommendedENBList__item_._cont = ASN1Dict([
        ('id', __RecommendedENBList__item__id),
        ('criticality', __RecommendedENBList__item__criticality),
        ('value', __RecommendedENBList__item__value),
        ])
    _RecommendedENBList__item_._ext = None
    RecommendedENBList._cont = _RecommendedENBList__item_
    RecommendedENBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedENBItemIEs >-----#
    RecommendedENBItemIEs = CLASS(name='RecommendedENBItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RecommendedENBItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBItem')))
    RecommendedENBItemIEs._val = ASN1Set(rv=[dict([('id', 215), ('criticality', 'ignore'), ('Value', _RecommendedENBItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBItem >-----#
    RecommendedENBItem = SEQ(name='RecommendedENBItem', mode=MODE_TYPE)
    _RecommendedENBItem_mMEPagingTarget = CHOICE(name='mMEPagingTarget', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MMEPagingTarget')))
    _RecommendedENBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedENBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedENBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedENBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab = ____RecommendedENBItem_iE_Extensions__item__id_tab
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedENBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedENBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab = ____RecommendedENBItem_iE_Extensions__item__criticality_tab
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedENBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedENBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedENBItem_iE_Extensions__item__id),
        ('criticality', ___RecommendedENBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedENBItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedENBItem_iE_Extensions__item_._ext = None
    _RecommendedENBItem_iE_Extensions._cont = __RecommendedENBItem_iE_Extensions__item_
    _RecommendedENBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedENBItem._cont = ASN1Dict([
        ('mMEPagingTarget', _RecommendedENBItem_mMEPagingTarget),
        ('iE-Extensions', _RecommendedENBItem_iE_Extensions),
        ])
    RecommendedENBItem._ext = []
    
    #-----< RecommendedENBItem-ExtIEs >-----#
    RecommendedENBItem_ExtIEs = CLASS(name='RecommendedENBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedENBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeMMECapacity >-----#
    RelativeMMECapacity = INT(name='RelativeMMECapacity', mode=MODE_TYPE)
    RelativeMMECapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RelayNode-Indicator >-----#
    RelayNode_Indicator = ENUM(name='RelayNode-Indicator', mode=MODE_TYPE)
    RelayNode_Indicator._cont = ASN1Dict([('true', 0)])
    RelayNode_Indicator._ext = []
    
    #-----< RAC >-----#
    RAC = OCT_STR(name='RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAT-Restrictions >-----#
    RAT_Restrictions = SEQ_OF(name='RAT-Restrictions', mode=MODE_TYPE)
    _RAT_Restrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-RestrictionsItem')))
    RAT_Restrictions._cont = _RAT_Restrictions__item_
    RAT_Restrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RAT-RestrictionsItem >-----#
    RAT_RestrictionsItem = SEQ(name='RAT-RestrictionsItem', mode=MODE_TYPE)
    _RAT_RestrictionsItem_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _RAT_RestrictionsItem_rAT_RestrictionInformation = BIT_STR(name='rAT-RestrictionInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RAT_RestrictionsItem_rAT_RestrictionInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _RAT_RestrictionsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAT_RestrictionsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RAT_RestrictionsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RAT_RestrictionsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__id_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab_at = None
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAT_RestrictionsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAT_RestrictionsItem_iE_Extensions__item__id),
        ('criticality', ___RAT_RestrictionsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue),
        ])
    __RAT_RestrictionsItem_iE_Extensions__item_._ext = None
    _RAT_RestrictionsItem_iE_Extensions._cont = __RAT_RestrictionsItem_iE_Extensions__item_
    _RAT_RestrictionsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAT_RestrictionsItem._cont = ASN1Dict([
        ('pLMNidentity', _RAT_RestrictionsItem_pLMNidentity),
        ('rAT-RestrictionInformation', _RAT_RestrictionsItem_rAT_RestrictionInformation),
        ('iE-Extensions', _RAT_RestrictionsItem_iE_Extensions),
        ])
    RAT_RestrictionsItem._ext = []
    
    #-----< RAT-RestrictionsItem-ExtIEs >-----#
    RAT_RestrictionsItem_ExtIEs = CLASS(name='RAT-RestrictionsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RAT_RestrictionsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAT-Type >-----#
    RAT_Type = ENUM(name='RAT-Type', mode=MODE_TYPE)
    RAT_Type._cont = ASN1Dict([('nbiot', 0), ('nbiot-leo', 1), ('nbiot-meo', 2), ('nbiot-geo', 3), ('nbiot-othersat', 4), ('eutran-leo', 5), ('eutran-meo', 6), ('eutran-geo', 7), ('eutran-othersat', 8)])
    RAT_Type._ext = ['nbiot-leo', 'nbiot-meo', 'nbiot-geo', 'nbiot-othersat', 'eutran-leo', 'eutran-meo', 'eutran-geo', 'eutran-othersat']
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name='ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name='ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('min1', 8), ('min6', 9), ('min12', 10), ('min30', 11), ('min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name='M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([('periodic', 0), ('a2eventtriggered', 1), ('a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = ['a2eventtriggered-periodic']
    
    #-----< RequestType >-----#
    RequestType = SEQ(name='RequestType', mode=MODE_TYPE)
    _RequestType_eventType = ENUM(name='eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EventType')))
    _RequestType_reportArea = ENUM(name='reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportArea')))
    _RequestType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RequestType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____RequestType_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestTypeAdditionalInfo')))
    ____RequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'ignore'), ('Extension', _____RequestType_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RequestType_iE_Extensions__item__id._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__id._const_tab_at = None
    ___RequestType_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RequestType_iE_Extensions__item__criticality._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RequestType_iE_Extensions__item__extensionValue._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestType_iE_Extensions__item__id),
        ('criticality', ___RequestType_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestType_iE_Extensions__item__extensionValue),
        ])
    __RequestType_iE_Extensions__item_._ext = None
    _RequestType_iE_Extensions._cont = __RequestType_iE_Extensions__item_
    _RequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestType._cont = ASN1Dict([
        ('eventType', _RequestType_eventType),
        ('reportArea', _RequestType_reportArea),
        ('iE-Extensions', _RequestType_iE_Extensions),
        ])
    RequestType._ext = []
    
    #-----< RequestType-ExtIEs >-----#
    RequestType_ExtIEs = CLASS(name='RequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _RequestType_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestTypeAdditionalInfo')))
    RequestType_ExtIEs._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'ignore'), ('Extension', _RequestType_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestTypeAdditionalInfo >-----#
    RequestTypeAdditionalInfo = ENUM(name='RequestTypeAdditionalInfo', mode=MODE_TYPE)
    RequestTypeAdditionalInfo._cont = ASN1Dict([('includePSCell', 0)])
    RequestTypeAdditionalInfo._ext = []
    
    #-----< RIMTransfer >-----#
    RIMTransfer = SEQ(name='RIMTransfer', mode=MODE_TYPE)
    _RIMTransfer_rIMInformation = OCT_STR(name='rIMInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMInformation')))
    _RIMTransfer_rIMRoutingAddress = CHOICE(name='rIMRoutingAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMRoutingAddress')), opt=True)
    _RIMTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RIMTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RIMTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__id._const_tab = ____RIMTransfer_iE_Extensions__item__id_tab
    ___RIMTransfer_iE_Extensions__item__id._const_tab_at = None
    ___RIMTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___RIMTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RIMTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab = ____RIMTransfer_iE_Extensions__item__criticality_tab
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RIMTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RIMTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab = ____RIMTransfer_iE_Extensions__item__extensionValue_tab
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RIMTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RIMTransfer_iE_Extensions__item__id),
        ('criticality', ___RIMTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___RIMTransfer_iE_Extensions__item__extensionValue),
        ])
    __RIMTransfer_iE_Extensions__item_._ext = None
    _RIMTransfer_iE_Extensions._cont = __RIMTransfer_iE_Extensions__item_
    _RIMTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMTransfer._cont = ASN1Dict([
        ('rIMInformation', _RIMTransfer_rIMInformation),
        ('rIMRoutingAddress', _RIMTransfer_rIMRoutingAddress),
        ('iE-Extensions', _RIMTransfer_iE_Extensions),
        ])
    RIMTransfer._ext = []
    
    #-----< RIMTransfer-ExtIEs >-----#
    RIMTransfer_ExtIEs = CLASS(name='RIMTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RIMTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMInformation >-----#
    RIMInformation = OCT_STR(name='RIMInformation', mode=MODE_TYPE)
    
    #-----< RIMRoutingAddress >-----#
    RIMRoutingAddress = CHOICE(name='RIMRoutingAddress', mode=MODE_TYPE)
    _RIMRoutingAddress_gERAN_Cell_ID = SEQ(name='gERAN-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GERAN-Cell-ID')))
    _RIMRoutingAddress_targetRNC_ID = SEQ(name='targetRNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetRNC-ID')))
    _RIMRoutingAddress_eHRPD_Sector_ID = OCT_STR(name='eHRPD-Sector-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RIMRoutingAddress_eHRPD_Sector_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    RIMRoutingAddress._cont = ASN1Dict([
        ('gERAN-Cell-ID', _RIMRoutingAddress_gERAN_Cell_ID),
        ('targetRNC-ID', _RIMRoutingAddress_targetRNC_ID),
        ('eHRPD-Sector-ID', _RIMRoutingAddress_eHRPD_Sector_ID),
        ])
    RIMRoutingAddress._ext = ['targetRNC-ID', 'eHRPD-Sector-ID']
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name='ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([('ecgi', 0)])
    ReportArea._ext = []
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name='RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RLFReportInformation >-----#
    RLFReportInformation = SEQ(name='RLFReportInformation', mode=MODE_TYPE)
    _RLFReportInformation_uE_RLF_Report_Container = OCT_STR(name='uE-RLF-Report-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-RLF-Report-Container')))
    _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands = OCT_STR(name='uE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')), opt=True)
    _RLFReportInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLFReportInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RLFReportInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLFReportInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-RLF-Report-Container')))
    ____RLFReportInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 313), ('criticality', 'ignore'), ('Extension', _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RLFReportInformation_iE_Extensions__item__id._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__id._const_tab_at = None
    ___RLFReportInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLFReportInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLFReportInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLFReportInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLFReportInformation_iE_Extensions__item__id),
        ('criticality', ___RLFReportInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RLFReportInformation_iE_Extensions__item__extensionValue),
        ])
    __RLFReportInformation_iE_Extensions__item_._ext = None
    _RLFReportInformation_iE_Extensions._cont = __RLFReportInformation_iE_Extensions__item_
    _RLFReportInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLFReportInformation._cont = ASN1Dict([
        ('uE-RLF-Report-Container', _RLFReportInformation_uE_RLF_Report_Container),
        ('uE-RLF-Report-Container-for-extended-bands', _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands),
        ('iE-Extensions', _RLFReportInformation_iE_Extensions),
        ])
    RLFReportInformation._ext = []
    
    #-----< RLFReportInformation-ExtIEs >-----#
    RLFReportInformation_ExtIEs = CLASS(name='RLFReportInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _RLFReportInformation_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-RLF-Report-Container')))
    RLFReportInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 313), ('criticality', 'ignore'), ('Extension', _RLFReportInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name='RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RRC-Container >-----#
    RRC_Container = OCT_STR(name='RRC-Container', mode=MODE_TYPE)
    
    #-----< RRC-Establishment-Cause >-----#
    RRC_Establishment_Cause = ENUM(name='RRC-Establishment-Cause', mode=MODE_TYPE)
    RRC_Establishment_Cause._cont = ASN1Dict([('emergency', 0), ('highPriorityAccess', 1), ('mt-Access', 2), ('mo-Signalling', 3), ('mo-Data', 4), ('delay-TolerantAccess', 5), ('mo-VoiceCall', 6), ('mo-ExceptionData', 7)])
    RRC_Establishment_Cause._ext = ['delay-TolerantAccess', 'mo-VoiceCall', 'mo-ExceptionData']
    
    #-----< ECGIListForRestart >-----#
    ECGIListForRestart = SEQ_OF(name='ECGIListForRestart', mode=MODE_TYPE)
    _ECGIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGIListForRestart._cont = _ECGIListForRestart__item_
    ECGIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Routing-ID >-----#
    Routing_ID = INT(name='Routing-ID', mode=MODE_TYPE)
    Routing_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SecurityKey >-----#
    SecurityKey = BIT_STR(name='SecurityKey', mode=MODE_TYPE)
    SecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SecurityContext >-----#
    SecurityContext = SEQ(name='SecurityContext', mode=MODE_TYPE)
    _SecurityContext_nextHopChainingCount = INT(name='nextHopChainingCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SecurityContext_nextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _SecurityContext_nextHopParameter = BIT_STR(name='nextHopParameter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _SecurityContext_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityContext_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityContext_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityContext_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__id._const_tab = ____SecurityContext_iE_Extensions__item__id_tab
    ___SecurityContext_iE_Extensions__item__id._const_tab_at = None
    ___SecurityContext_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityContext_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityContext_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__criticality._const_tab = ____SecurityContext_iE_Extensions__item__criticality_tab
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityContext_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab = ____SecurityContext_iE_Extensions__item__extensionValue_tab
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityContext_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityContext_iE_Extensions__item__id),
        ('criticality', ___SecurityContext_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityContext_iE_Extensions__item__extensionValue),
        ])
    __SecurityContext_iE_Extensions__item_._ext = None
    _SecurityContext_iE_Extensions._cont = __SecurityContext_iE_Extensions__item_
    _SecurityContext_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityContext._cont = ASN1Dict([
        ('nextHopChainingCount', _SecurityContext_nextHopChainingCount),
        ('nextHopParameter', _SecurityContext_nextHopParameter),
        ('iE-Extensions', _SecurityContext_iE_Extensions),
        ])
    SecurityContext._ext = []
    
    #-----< SecurityContext-ExtIEs >-----#
    SecurityContext_ExtIEs = CLASS(name='SecurityContext-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecurityContext_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATType >-----#
    SecondaryRATType = ENUM(name='SecondaryRATType', mode=MODE_TYPE)
    SecondaryRATType._cont = ASN1Dict([('nR', 0), ('unlicensed', 1)])
    SecondaryRATType._ext = ['unlicensed']
    
    #-----< SecondaryRATDataUsageRequest >-----#
    SecondaryRATDataUsageRequest = ENUM(name='SecondaryRATDataUsageRequest', mode=MODE_TYPE)
    SecondaryRATDataUsageRequest._cont = ASN1Dict([('requested', 0)])
    SecondaryRATDataUsageRequest._ext = []
    
    #-----< SecondaryRATDataUsageReportList >-----#
    SecondaryRATDataUsageReportList = SEQ_OF(name='SecondaryRATDataUsageReportList', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SecondaryRATDataUsageReportList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___SecondaryRATDataUsageReportList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportItem')))
    ___SecondaryRATDataUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([('id', 265), ('criticality', 'ignore'), ('Value', ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SecondaryRATDataUsageReportList__item__id._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__id._const_tab_at = None
    __SecondaryRATDataUsageReportList__item__id._const_tab_id = 'id'
    __SecondaryRATDataUsageReportList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __SecondaryRATDataUsageReportList__item__criticality._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__criticality._const_tab_at = ('..', 'id')
    __SecondaryRATDataUsageReportList__item__criticality._const_tab_id = 'criticality'
    __SecondaryRATDataUsageReportList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __SecondaryRATDataUsageReportList__item__value._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__value._const_tab_at = ('..', 'id')
    __SecondaryRATDataUsageReportList__item__value._const_tab_id = 'Value'
    _SecondaryRATDataUsageReportList__item_._cont = ASN1Dict([
        ('id', __SecondaryRATDataUsageReportList__item__id),
        ('criticality', __SecondaryRATDataUsageReportList__item__criticality),
        ('value', __SecondaryRATDataUsageReportList__item__value),
        ])
    _SecondaryRATDataUsageReportList__item_._ext = None
    SecondaryRATDataUsageReportList._cont = _SecondaryRATDataUsageReportList__item_
    SecondaryRATDataUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SecondaryRATDataUsageReportItemIEs >-----#
    SecondaryRATDataUsageReportItemIEs = CLASS(name='SecondaryRATDataUsageReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportItem')))
    SecondaryRATDataUsageReportItemIEs._val = ASN1Set(rv=[dict([('id', 265), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReportItem >-----#
    SecondaryRATDataUsageReportItem = SEQ(name='SecondaryRATDataUsageReportItem', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _SecondaryRATDataUsageReportItem_secondaryRATType = ENUM(name='secondaryRATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATType')))
    _SecondaryRATDataUsageReportItem_e_RABUsageReportList = SEQ_OF(name='e-RABUsageReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportList')))
    _SecondaryRATDataUsageReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id),
        ('criticality', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue),
        ])
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_._ext = None
    _SecondaryRATDataUsageReportItem_iE_Extensions._cont = __SecondaryRATDataUsageReportItem_iE_Extensions__item_
    _SecondaryRATDataUsageReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReportItem._cont = ASN1Dict([
        ('e-RAB-ID', _SecondaryRATDataUsageReportItem_e_RAB_ID),
        ('secondaryRATType', _SecondaryRATDataUsageReportItem_secondaryRATType),
        ('e-RABUsageReportList', _SecondaryRATDataUsageReportItem_e_RABUsageReportList),
        ('iE-Extensions', _SecondaryRATDataUsageReportItem_iE_Extensions),
        ])
    SecondaryRATDataUsageReportItem._ext = []
    
    #-----< SecondaryRATDataUsageReportItem-ExtIEs >-----#
    SecondaryRATDataUsageReportItem_ExtIEs = CLASS(name='SecondaryRATDataUsageReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecondaryRATDataUsageReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityIndication >-----#
    SecurityIndication = SEQ(name='SecurityIndication', mode=MODE_TYPE)
    _SecurityIndication_integrityProtectionIndication = ENUM(name='integrityProtectionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntegrityProtectionIndication')))
    _SecurityIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__id._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__id._const_tab_at = None
    ___SecurityIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab = ____SecurityIndication_iE_Extensions__item__criticality_tab
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab = ____SecurityIndication_iE_Extensions__item__extensionValue_tab
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityIndication_iE_Extensions__item__id),
        ('criticality', ___SecurityIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityIndication_iE_Extensions__item__extensionValue),
        ])
    __SecurityIndication_iE_Extensions__item_._ext = None
    _SecurityIndication_iE_Extensions._cont = __SecurityIndication_iE_Extensions__item_
    _SecurityIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityIndication._cont = ASN1Dict([
        ('integrityProtectionIndication', _SecurityIndication_integrityProtectionIndication),
        ('iE-Extensions', _SecurityIndication_iE_Extensions),
        ])
    SecurityIndication._ext = []
    
    #-----< SecurityIndication-ExtIEs >-----#
    SecurityIndication_ExtIEs = CLASS(name='SecurityIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecurityIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityResult >-----#
    SecurityResult = SEQ(name='SecurityResult', mode=MODE_TYPE)
    _SecurityResult_integrityProtectionResult = ENUM(name='integrityProtectionResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntegrityProtectionResult')))
    _SecurityResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityResult_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__id._const_tab = ____SecurityResult_iE_Extensions__item__id_tab
    ___SecurityResult_iE_Extensions__item__id._const_tab_at = None
    ___SecurityResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__criticality._const_tab = ____SecurityResult_iE_Extensions__item__criticality_tab
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab = ____SecurityResult_iE_Extensions__item__extensionValue_tab
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityResult_iE_Extensions__item__id),
        ('criticality', ___SecurityResult_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityResult_iE_Extensions__item__extensionValue),
        ])
    __SecurityResult_iE_Extensions__item_._ext = None
    _SecurityResult_iE_Extensions._cont = __SecurityResult_iE_Extensions__item_
    _SecurityResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityResult._cont = ASN1Dict([
        ('integrityProtectionResult', _SecurityResult_integrityProtectionResult),
        ('iE-Extensions', _SecurityResult_iE_Extensions),
        ])
    SecurityResult._ext = []
    
    #-----< SecurityResult-ExtIEs >-----#
    SecurityResult_ExtIEs = CLASS(name='SecurityResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecurityResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfig >-----#
    SensorMeasConfig = ENUM(name='SensorMeasConfig', mode=MODE_TYPE)
    SensorMeasConfig._cont = ASN1Dict([('setup', 0)])
    SensorMeasConfig._ext = []
    
    #-----< SensorMeasConfigNameItem >-----#
    SensorMeasConfigNameItem = SEQ(name='SensorMeasConfigNameItem', mode=MODE_TYPE)
    _SensorMeasConfigNameItem_sensorNameConfig = CHOICE(name='sensorNameConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SensorNameConfig')))
    _SensorMeasConfigNameItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasConfigNameItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasConfigNameItem_iE_Extensions__item__id),
        ('criticality', ___SensorMeasConfigNameItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasConfigNameItem_iE_Extensions__item_._ext = None
    _SensorMeasConfigNameItem_iE_Extensions._cont = __SensorMeasConfigNameItem_iE_Extensions__item_
    _SensorMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasConfigNameItem._cont = ASN1Dict([
        ('sensorNameConfig', _SensorMeasConfigNameItem_sensorNameConfig),
        ('iE-Extensions', _SensorMeasConfigNameItem_iE_Extensions),
        ])
    SensorMeasConfigNameItem._ext = []
    
    #-----< SensorMeasConfigNameItem-ExtIEs >-----#
    SensorMeasConfigNameItem_ExtIEs = CLASS(name='SensorMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SensorMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfigNameList >-----#
    SensorMeasConfigNameList = SEQ_OF(name='SensorMeasConfigNameList', mode=MODE_TYPE)
    _SensorMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasConfigNameItem')))
    SensorMeasConfigNameList._cont = _SensorMeasConfigNameList__item_
    SensorMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SensorMeasurementConfiguration >-----#
    SensorMeasurementConfiguration = SEQ(name='SensorMeasurementConfiguration', mode=MODE_TYPE)
    _SensorMeasurementConfiguration_sensorMeasConfig = ENUM(name='sensorMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasConfig')))
    _SensorMeasurementConfiguration_sensorMeasConfigNameList = SEQ_OF(name='sensorMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SensorMeasConfigNameList')), opt=True)
    _SensorMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___SensorMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasurementConfiguration_iE_Extensions__item_._ext = None
    _SensorMeasurementConfiguration_iE_Extensions._cont = __SensorMeasurementConfiguration_iE_Extensions__item_
    _SensorMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasurementConfiguration._cont = ASN1Dict([
        ('sensorMeasConfig', _SensorMeasurementConfiguration_sensorMeasConfig),
        ('sensorMeasConfigNameList', _SensorMeasurementConfiguration_sensorMeasConfigNameList),
        ('iE-Extensions', _SensorMeasurementConfiguration_iE_Extensions),
        ])
    SensorMeasurementConfiguration._ext = []
    
    #-----< SensorMeasurementConfiguration-ExtIEs >-----#
    SensorMeasurementConfiguration_ExtIEs = CLASS(name='SensorMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SensorMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorNameConfig >-----#
    SensorNameConfig = CHOICE(name='SensorNameConfig', mode=MODE_TYPE)
    _SensorNameConfig_uncompensatedBarometricConfig = ENUM(name='uncompensatedBarometricConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_uncompensatedBarometricConfig._cont = ASN1Dict([('true', 0)])
    _SensorNameConfig_uncompensatedBarometricConfig._ext = []
    _SensorNameConfig_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SensorNameConfig_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___SensorNameConfig_choice_Extensions_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_id._const_tab = ___SensorNameConfig_choice_Extensions_id_tab
    __SensorNameConfig_choice_Extensions_id._const_tab_at = None
    __SensorNameConfig_choice_Extensions_id._const_tab_id = 'id'
    __SensorNameConfig_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___SensorNameConfig_choice_Extensions_criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_criticality._const_tab = ___SensorNameConfig_choice_Extensions_criticality_tab
    __SensorNameConfig_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_Extensions_criticality._const_tab_id = 'criticality'
    __SensorNameConfig_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___SensorNameConfig_choice_Extensions_value_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_value._const_tab = ___SensorNameConfig_choice_Extensions_value_tab
    __SensorNameConfig_choice_Extensions_value._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_Extensions_value._const_tab_id = 'Value'
    _SensorNameConfig_choice_Extensions._cont = ASN1Dict([
        ('id', __SensorNameConfig_choice_Extensions_id),
        ('criticality', __SensorNameConfig_choice_Extensions_criticality),
        ('value', __SensorNameConfig_choice_Extensions_value),
        ])
    _SensorNameConfig_choice_Extensions._ext = None
    SensorNameConfig._cont = ASN1Dict([
        ('uncompensatedBarometricConfig', _SensorNameConfig_uncompensatedBarometricConfig),
        ('choice-Extensions', _SensorNameConfig_choice_Extensions),
        ])
    SensorNameConfig._ext = None
    
    #-----< SensorNameConfig-ExtIEs >-----#
    SensorNameConfig_ExtIEs = CLASS(name='SensorNameConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    SensorNameConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name='SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name='ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([('qMC-for-streaming-service', 0), ('qMC-for-MTSI-service', 1)])
    ServiceType._ext = []
    
    #-----< SONInformation >-----#
    SONInformation = CHOICE(name='SONInformation', mode=MODE_TYPE)
    _SONInformation_sONInformationRequest = ENUM(name='sONInformationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformationRequest')))
    _SONInformation_sONInformationReply = SEQ(name='sONInformationReply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReply')))
    _SONInformation_sONInformation_Extension = SEQ(name='sONInformation-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation-Extension')))
    SONInformation._cont = ASN1Dict([
        ('sONInformationRequest', _SONInformation_sONInformationRequest),
        ('sONInformationReply', _SONInformation_sONInformationReply),
        ('sONInformation-Extension', _SONInformation_sONInformation_Extension),
        ])
    SONInformation._ext = ['sONInformation-Extension']
    
    #-----< SONInformation-Extension >-----#
    SONInformation_Extension = SEQ(name='SONInformation-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _SONInformation_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    __SONInformation_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___SONInformation_Extension_id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReport')))
    __SONInformation_Extension_id_tab._val = ASN1Set(rv=[dict([('id', 206), ('criticality', 'ignore'), ('Value', ___SONInformation_Extension_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _SONInformation_Extension_id._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_id._const_tab_at = None
    _SONInformation_Extension_id._const_tab_id = 'id'
    _SONInformation_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    _SONInformation_Extension_criticality._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_criticality._const_tab_at = ('..', 'id')
    _SONInformation_Extension_criticality._const_tab_id = 'criticality'
    _SONInformation_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    _SONInformation_Extension_value._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_value._const_tab_at = ('..', 'id')
    _SONInformation_Extension_value._const_tab_id = 'Value'
    SONInformation_Extension._cont = ASN1Dict([
        ('id', _SONInformation_Extension_id),
        ('criticality', _SONInformation_Extension_criticality),
        ('value', _SONInformation_Extension_value),
        ])
    SONInformation_Extension._ext = None
    
    #-----< SONInformation-ExtensionIE >-----#
    SONInformation_ExtensionIE = CLASS(name='SONInformation-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SONInformation_ExtensionIE_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReport')))
    SONInformation_ExtensionIE._val = ASN1Set(rv=[dict([('id', 206), ('criticality', 'ignore'), ('Value', _SONInformation_ExtensionIE_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SONInformationRequest >-----#
    SONInformationRequest = ENUM(name='SONInformationRequest', mode=MODE_TYPE)
    SONInformationRequest._cont = ASN1Dict([('x2TNL-Configuration-Info', 0), ('time-Synchronisation-Info', 1), ('activate-Muting', 2), ('deactivate-Muting', 3)])
    SONInformationRequest._ext = ['time-Synchronisation-Info', 'activate-Muting', 'deactivate-Muting']
    
    #-----< SONInformationReply >-----#
    SONInformationReply = SEQ(name='SONInformationReply', mode=MODE_TYPE)
    _SONInformationReply_x2TNLConfigurationInfo = SEQ(name='x2TNLConfigurationInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')), opt=True)
    _SONInformationReply_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONInformationReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SONInformationReply_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SONInformationReply_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSynchronisationInfo')))
    _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingPatternInformation')))
    ____SONInformationReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[dict([('id', 208), ('criticality', 'ignore'), ('Extension', _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], er=[])
    ___SONInformationReply_iE_Extensions__item__id._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__id._const_tab_at = None
    ___SONInformationReply_iE_Extensions__item__id._const_tab_id = 'id'
    ___SONInformationReply_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SONInformationReply_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SONInformationReply_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SONInformationReply_iE_Extensions__item__id),
        ('criticality', ___SONInformationReply_iE_Extensions__item__criticality),
        ('extensionValue', ___SONInformationReply_iE_Extensions__item__extensionValue),
        ])
    __SONInformationReply_iE_Extensions__item_._ext = None
    _SONInformationReply_iE_Extensions._cont = __SONInformationReply_iE_Extensions__item_
    _SONInformationReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONInformationReply._cont = ASN1Dict([
        ('x2TNLConfigurationInfo', _SONInformationReply_x2TNLConfigurationInfo),
        ('iE-Extensions', _SONInformationReply_iE_Extensions),
        ])
    SONInformationReply._ext = []
    
    #-----< SONInformationReply-ExtIEs >-----#
    SONInformationReply_ExtIEs = CLASS(name='SONInformationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SONInformationReply_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSynchronisationInfo')))
    _SONInformationReply_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingPatternInformation')))
    SONInformationReply_ExtIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _SONInformationReply_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[dict([('id', 208), ('criticality', 'ignore'), ('Extension', _SONInformationReply_ExtIEs_val_Extension_1), ('presence', 'optional')])], er=[])
    
    #-----< SONInformationReport >-----#
    SONInformationReport = CHOICE(name='SONInformationReport', mode=MODE_TYPE)
    _SONInformationReport_rLFReportInformation = SEQ(name='rLFReportInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RLFReportInformation')))
    SONInformationReport._cont = ASN1Dict([
        ('rLFReportInformation', _SONInformationReport_rLFReportInformation),
        ])
    SONInformationReport._ext = []
    
    #-----< SONConfigurationTransfer >-----#
    SONConfigurationTransfer = SEQ(name='SONConfigurationTransfer', mode=MODE_TYPE)
    _SONConfigurationTransfer_targeteNB_ID = SEQ(name='targeteNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargeteNB-ID')))
    _SONConfigurationTransfer_sourceeNB_ID = SEQ(name='sourceeNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceeNB-ID')))
    _SONConfigurationTransfer_sONInformation = CHOICE(name='sONInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation')))
    _SONConfigurationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SONConfigurationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')))
    _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationInformation')))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 209), ('criticality', 'ignore'), ('Extension', _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SONConfigurationTransfer_iE_Extensions__item__id),
        ('criticality', ___SONConfigurationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___SONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __SONConfigurationTransfer_iE_Extensions__item_._ext = None
    _SONConfigurationTransfer_iE_Extensions._cont = __SONConfigurationTransfer_iE_Extensions__item_
    _SONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONConfigurationTransfer._cont = ASN1Dict([
        ('targeteNB-ID', _SONConfigurationTransfer_targeteNB_ID),
        ('sourceeNB-ID', _SONConfigurationTransfer_sourceeNB_ID),
        ('sONInformation', _SONConfigurationTransfer_sONInformation),
        ('iE-Extensions', _SONConfigurationTransfer_iE_Extensions),
        ])
    SONConfigurationTransfer._ext = []
    
    #-----< SONConfigurationTransfer-ExtIEs >-----#
    SONConfigurationTransfer_ExtIEs = CLASS(name='SONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SONConfigurationTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')))
    _SONConfigurationTransfer_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationInformation')))
    SONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _SONConfigurationTransfer_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 209), ('criticality', 'ignore'), ('Extension', _SONConfigurationTransfer_ExtIEs_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< SynchronisationInformation >-----#
    SynchronisationInformation = SEQ(name='SynchronisationInformation', mode=MODE_TYPE)
    _SynchronisationInformation_sourceStratumLevel = INT(name='sourceStratumLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'StratumLevel')), opt=True)
    _SynchronisationInformation_listeningSubframePattern = SEQ(name='listeningSubframePattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ListeningSubframePattern')), opt=True)
    _SynchronisationInformation_aggressoreCGI_List = SEQ_OF(name='aggressoreCGI-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ECGI-List')), opt=True)
    _SynchronisationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SynchronisationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab = ____SynchronisationInformation_iE_Extensions__item__id_tab
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SynchronisationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SynchronisationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab = ____SynchronisationInformation_iE_Extensions__item__criticality_tab
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SynchronisationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SynchronisationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SynchronisationInformation_iE_Extensions__item__id),
        ('criticality', ___SynchronisationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SynchronisationInformation_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationInformation_iE_Extensions__item_._ext = None
    _SynchronisationInformation_iE_Extensions._cont = __SynchronisationInformation_iE_Extensions__item_
    _SynchronisationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationInformation._cont = ASN1Dict([
        ('sourceStratumLevel', _SynchronisationInformation_sourceStratumLevel),
        ('listeningSubframePattern', _SynchronisationInformation_listeningSubframePattern),
        ('aggressoreCGI-List', _SynchronisationInformation_aggressoreCGI_List),
        ('iE-Extensions', _SynchronisationInformation_iE_Extensions),
        ])
    SynchronisationInformation._ext = []
    
    #-----< SynchronisationInformation-ExtIEs >-----#
    SynchronisationInformation_ExtIEs = CLASS(name='SynchronisationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SynchronisationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Source-ToTarget-TransparentContainer >-----#
    Source_ToTarget_TransparentContainer = OCT_STR(name='Source-ToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceBSS-ToTargetBSS-TransparentContainer >-----#
    SourceBSS_ToTargetBSS_TransparentContainer = OCT_STR(name='SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceeNB-ID >-----#
    SourceeNB_ID = SEQ(name='SourceeNB-ID', mode=MODE_TYPE)
    _SourceeNB_ID_global_ENB_ID = SEQ(name='global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _SourceeNB_ID_selected_TAI = SEQ(name='selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _SourceeNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceeNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceeNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceeNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab = ____SourceeNB_ID_iE_Extensions__item__id_tab
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceeNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SourceeNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab = ____SourceeNB_ID_iE_Extensions__item__criticality_tab
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceeNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceeNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceeNB_ID_iE_Extensions__item__id),
        ('criticality', ___SourceeNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceeNB_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceeNB_ID_iE_Extensions__item_._ext = None
    _SourceeNB_ID_iE_Extensions._cont = __SourceeNB_ID_iE_Extensions__item_
    _SourceeNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceeNB_ID._cont = ASN1Dict([
        ('global-ENB-ID', _SourceeNB_ID_global_ENB_ID),
        ('selected-TAI', _SourceeNB_ID_selected_TAI),
        ('iE-Extensions', _SourceeNB_ID_iE_Extensions),
        ])
    SourceeNB_ID._ext = None
    
    #-----< SourceeNB-ID-ExtIEs >-----#
    SourceeNB_ID_ExtIEs = CLASS(name='SourceeNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SourceeNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCCOperationNotPossible >-----#
    SRVCCOperationNotPossible = ENUM(name='SRVCCOperationNotPossible', mode=MODE_TYPE)
    SRVCCOperationNotPossible._cont = ASN1Dict([('notPossible', 0)])
    SRVCCOperationNotPossible._ext = []
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name='SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([('possible', 0)])
    SRVCCOperationPossible._ext = []
    
    #-----< SRVCCHOIndication >-----#
    SRVCCHOIndication = ENUM(name='SRVCCHOIndication', mode=MODE_TYPE)
    SRVCCHOIndication._cont = ASN1Dict([('pSandCS', 0), ('cSonly', 1)])
    SRVCCHOIndication._ext = []
    
    #-----< SourceNodeID >-----#
    SourceNodeID = CHOICE(name='SourceNodeID', mode=MODE_TYPE)
    _SourceNodeID_sourceNgRanNode_ID = SEQ(name='sourceNgRanNode-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceNgRanNode-ID')))
    _SourceNodeID_sourceNodeID_Extension = SEQ(name='sourceNodeID-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID-Extension')))
    SourceNodeID._cont = ASN1Dict([
        ('sourceNgRanNode-ID', _SourceNodeID_sourceNgRanNode_ID),
        ('sourceNodeID-Extension', _SourceNodeID_sourceNodeID_Extension),
        ])
    SourceNodeID._ext = None
    
    #-----< SourceNodeID-Extension >-----#
    SourceNodeID_Extension = SEQ(name='SourceNodeID-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _SourceNodeID_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    __SourceNodeID_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_id._const_tab = __SourceNodeID_Extension_id_tab
    _SourceNodeID_Extension_id._const_tab_at = None
    _SourceNodeID_Extension_id._const_tab_id = 'id'
    _SourceNodeID_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __SourceNodeID_Extension_criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_criticality._const_tab = __SourceNodeID_Extension_criticality_tab
    _SourceNodeID_Extension_criticality._const_tab_at = ('..', 'id')
    _SourceNodeID_Extension_criticality._const_tab_id = 'criticality'
    _SourceNodeID_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __SourceNodeID_Extension_value_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_value._const_tab = __SourceNodeID_Extension_value_tab
    _SourceNodeID_Extension_value._const_tab_at = ('..', 'id')
    _SourceNodeID_Extension_value._const_tab_id = 'Value'
    SourceNodeID_Extension._cont = ASN1Dict([
        ('id', _SourceNodeID_Extension_id),
        ('criticality', _SourceNodeID_Extension_criticality),
        ('value', _SourceNodeID_Extension_value),
        ])
    SourceNodeID_Extension._ext = None
    
    #-----< SourceNodeID-ExtensionIE >-----#
    SourceNodeID_ExtensionIE = CLASS(name='SourceNodeID-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    SourceNodeID_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceeNB-ToTargeteNB-TransparentContainer >-----#
    SourceeNB_ToTargeteNB_TransparentContainer = SEQ(name='SourceeNB-ToTargeteNB-TransparentContainer', mode=MODE_TYPE)
    _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container = OCT_STR(name='rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RRC-Container')))
    _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList = SEQ_OF(name='e-RABInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationList')), opt=True)
    _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID = SEQ(name='targetCell-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP = INT(name='subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation = SEQ_OF(name='uE-HistoryInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformation')))
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MobilityInformation')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ContextatSource')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemMeasurementConfiguration')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyIndicator')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions._cont = __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceeNB_ToTargeteNB_TransparentContainer._cont = ASN1Dict([
        ('rRC-Container', _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container),
        ('e-RABInformationList', _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList),
        ('targetCell-ID', _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID),
        ('subscriberProfileIDforRFP', _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP),
        ('uE-HistoryInformation', _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation),
        ('iE-Extensions', _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions),
        ])
    SourceeNB_ToTargeteNB_TransparentContainer._ext = []
    
    #-----< SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs >-----#
    SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs = CLASS(name='SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MobilityInformation')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ContextatSource')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemMeasurementConfiguration')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyIndicator')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceNgRanNode-ID >-----#
    SourceNgRanNode_ID = SEQ(name='SourceNgRanNode-ID', mode=MODE_TYPE)
    _SourceNgRanNode_ID_global_RAN_NODE_ID = CHOICE(name='global-RAN-NODE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _SourceNgRanNode_ID_selected_TAI = SEQ(name='selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')))
    _SourceNgRanNode_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceNgRanNode_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceNgRanNode_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceNgRanNode_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__id_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceNgRanNode_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceNgRanNode_ID_iE_Extensions__item__id),
        ('criticality', ___SourceNgRanNode_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceNgRanNode_ID_iE_Extensions__item_._ext = None
    _SourceNgRanNode_ID_iE_Extensions._cont = __SourceNgRanNode_ID_iE_Extensions__item_
    _SourceNgRanNode_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceNgRanNode_ID._cont = ASN1Dict([
        ('global-RAN-NODE-ID', _SourceNgRanNode_ID_global_RAN_NODE_ID),
        ('selected-TAI', _SourceNgRanNode_ID_selected_TAI),
        ('iE-Extensions', _SourceNgRanNode_ID_iE_Extensions),
        ])
    SourceNgRanNode_ID._ext = []
    
    #-----< SourceNgRanNode-ID-ExtIEs >-----#
    SourceNgRanNode_ID_ExtIEs = CLASS(name='SourceNgRanNode-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SourceNgRanNode_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer >-----#
    SourceRNC_ToTargetRNC_TransparentContainer = OCT_STR(name='SourceRNC-ToTargetRNC-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceNgRanNode-ToTargetNgRanNode-TransparentContainer >-----#
    SourceNgRanNode_ToTargetNgRanNode_TransparentContainer = OCT_STR(name='SourceNgRanNode-ToTargetNgRanNode-TransparentContainer', mode=MODE_TYPE)
    
    #-----< ServedGUMMEIs >-----#
    ServedGUMMEIs = SEQ_OF(name='ServedGUMMEIs', mode=MODE_TYPE)
    _ServedGUMMEIs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIsItem')))
    ServedGUMMEIs._cont = _ServedGUMMEIs__item_
    ServedGUMMEIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServedGUMMEIsItem >-----#
    ServedGUMMEIsItem = SEQ(name='ServedGUMMEIsItem', mode=MODE_TYPE)
    _ServedGUMMEIsItem_servedPLMNs = SEQ_OF(name='servedPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedPLMNs')))
    _ServedGUMMEIsItem_servedGroupIDs = SEQ_OF(name='servedGroupIDs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedGroupIDs')))
    _ServedGUMMEIsItem_servedMMECs = SEQ_OF(name='servedMMECs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedMMECs')))
    _ServedGUMMEIsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedGUMMEIsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ServedGUMMEIsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedGUMMEIsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    ____ServedGUMMEIsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Extension', _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedGUMMEIsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedGUMMEIsItem_iE_Extensions__item__id),
        ('criticality', ___ServedGUMMEIsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue),
        ])
    __ServedGUMMEIsItem_iE_Extensions__item_._ext = None
    _ServedGUMMEIsItem_iE_Extensions._cont = __ServedGUMMEIsItem_iE_Extensions__item_
    _ServedGUMMEIsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedGUMMEIsItem._cont = ASN1Dict([
        ('servedPLMNs', _ServedGUMMEIsItem_servedPLMNs),
        ('servedGroupIDs', _ServedGUMMEIsItem_servedGroupIDs),
        ('servedMMECs', _ServedGUMMEIsItem_servedMMECs),
        ('iE-Extensions', _ServedGUMMEIsItem_iE_Extensions),
        ])
    ServedGUMMEIsItem._ext = []
    
    #-----< ServedGUMMEIsItem-ExtIEs >-----#
    ServedGUMMEIsItem_ExtIEs = CLASS(name='ServedGUMMEIsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ServedGUMMEIsItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    ServedGUMMEIsItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Extension', _ServedGUMMEIsItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedGroupIDs >-----#
    ServedGroupIDs = SEQ_OF(name='ServedGroupIDs', mode=MODE_TYPE)
    _ServedGroupIDs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    ServedGroupIDs._cont = _ServedGroupIDs__item_
    ServedGroupIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< ServedMMECs >-----#
    ServedMMECs = SEQ_OF(name='ServedMMECs', mode=MODE_TYPE)
    _ServedMMECs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    ServedMMECs._cont = _ServedMMECs__item_
    ServedMMECs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedPLMNs >-----#
    ServedPLMNs = SEQ_OF(name='ServedPLMNs', mode=MODE_TYPE)
    _ServedPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    ServedPLMNs._cont = _ServedPLMNs__item_
    ServedPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name='SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Subscription-Based-UE-DifferentiationInfo >-----#
    Subscription_Based_UE_DifferentiationInfo = SEQ(name='Subscription-Based-UE-DifferentiationInfo', mode=MODE_TYPE)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator = ENUM(name='periodicCommunicationIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._cont = ASN1Dict([('periodically', 0), ('ondemand', 1)])
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._ext = []
    _Subscription_Based_UE_DifferentiationInfo_periodicTime = INT(name='periodicTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=[], er=[])
    _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime = SEQ(name='scheduledCommunicationTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ScheduledCommunicationTime')), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication = ENUM(name='stationaryIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._cont = ASN1Dict([('stationary', 0), ('mobile', 1)])
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile = ENUM(name='trafficProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._cont = ASN1Dict([('single-packet', 0), ('dual-packets', 1), ('multiple-packets', 2)])
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._ext = []
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication = ENUM(name='batteryIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._cont = ASN1Dict([('battery-powered', 0), ('battery-powered-not-rechargeable-or-replaceable', 1), ('not-battery-powered', 2)])
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_at = None
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id),
        ('criticality', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue),
        ])
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._ext = None
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._cont = __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Subscription_Based_UE_DifferentiationInfo._cont = ASN1Dict([
        ('periodicCommunicationIndicator', _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator),
        ('periodicTime', _Subscription_Based_UE_DifferentiationInfo_periodicTime),
        ('scheduledCommunicationTime', _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime),
        ('stationaryIndication', _Subscription_Based_UE_DifferentiationInfo_stationaryIndication),
        ('trafficProfile', _Subscription_Based_UE_DifferentiationInfo_trafficProfile),
        ('batteryIndication', _Subscription_Based_UE_DifferentiationInfo_batteryIndication),
        ('iE-Extensions', _Subscription_Based_UE_DifferentiationInfo_iE_Extensions),
        ])
    Subscription_Based_UE_DifferentiationInfo._ext = []
    
    #-----< Subscription-Based-UE-DifferentiationInfo-ExtIEs >-----#
    Subscription_Based_UE_DifferentiationInfo_ExtIEs = CLASS(name='Subscription-Based-UE-DifferentiationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Subscription_Based_UE_DifferentiationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ScheduledCommunicationTime >-----#
    ScheduledCommunicationTime = SEQ(name='ScheduledCommunicationTime', mode=MODE_TYPE)
    _ScheduledCommunicationTime_dayofWeek = BIT_STR(name='dayofWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_dayofWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _ScheduledCommunicationTime_timeofDayStart = INT(name='timeofDayStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_timeofDayEnd = INT(name='timeofDayEnd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayEnd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ScheduledCommunicationTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ScheduledCommunicationTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__id_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_at = None
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ScheduledCommunicationTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ScheduledCommunicationTime_iE_Extensions__item__id),
        ('criticality', ___ScheduledCommunicationTime_iE_Extensions__item__criticality),
        ('extensionValue', ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue),
        ])
    __ScheduledCommunicationTime_iE_Extensions__item_._ext = None
    _ScheduledCommunicationTime_iE_Extensions._cont = __ScheduledCommunicationTime_iE_Extensions__item_
    _ScheduledCommunicationTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ScheduledCommunicationTime._cont = ASN1Dict([
        ('dayofWeek', _ScheduledCommunicationTime_dayofWeek),
        ('timeofDayStart', _ScheduledCommunicationTime_timeofDayStart),
        ('timeofDayEnd', _ScheduledCommunicationTime_timeofDayEnd),
        ('iE-Extensions', _ScheduledCommunicationTime_iE_Extensions),
        ])
    ScheduledCommunicationTime._ext = []
    
    #-----< ScheduledCommunicationTime-ExtIEs >-----#
    ScheduledCommunicationTime_ExtIEs = CLASS(name='ScheduledCommunicationTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ScheduledCommunicationTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedTAs >-----#
    SupportedTAs = SEQ_OF(name='SupportedTAs', mode=MODE_TYPE)
    _SupportedTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs-Item')))
    SupportedTAs._cont = _SupportedTAs__item_
    SupportedTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SupportedTAs-Item >-----#
    SupportedTAs_Item = SEQ(name='SupportedTAs-Item', mode=MODE_TYPE)
    _SupportedTAs_Item_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    _SupportedTAs_Item_broadcastPLMNs = SEQ_OF(name='broadcastPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BPLMNs')))
    _SupportedTAs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SupportedTAs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____SupportedTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Type')))
    ____SupportedTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 232), ('criticality', 'reject'), ('Extension', _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SupportedTAs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SupportedTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SupportedTAs_Item_iE_Extensions__item__id),
        ('criticality', ___SupportedTAs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SupportedTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __SupportedTAs_Item_iE_Extensions__item_._ext = None
    _SupportedTAs_Item_iE_Extensions._cont = __SupportedTAs_Item_iE_Extensions__item_
    _SupportedTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedTAs_Item._cont = ASN1Dict([
        ('tAC', _SupportedTAs_Item_tAC),
        ('broadcastPLMNs', _SupportedTAs_Item_broadcastPLMNs),
        ('iE-Extensions', _SupportedTAs_Item_iE_Extensions),
        ])
    SupportedTAs_Item._ext = []
    
    #-----< SupportedTAs-Item-ExtIEs >-----#
    SupportedTAs_Item_ExtIEs = CLASS(name='SupportedTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SupportedTAs_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Type')))
    SupportedTAs_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 232), ('criticality', 'reject'), ('Extension', _SupportedTAs_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< StratumLevel >-----#
    StratumLevel = INT(name='StratumLevel', mode=MODE_TYPE)
    StratumLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    
    #-----< SynchronisationStatus >-----#
    SynchronisationStatus = ENUM(name='SynchronisationStatus', mode=MODE_TYPE)
    SynchronisationStatus._cont = ASN1Dict([('synchronous', 0), ('asynchronous', 1)])
    SynchronisationStatus._ext = []
    
    #-----< TimeSynchronisationInfo >-----#
    TimeSynchronisationInfo = SEQ(name='TimeSynchronisationInfo', mode=MODE_TYPE)
    _TimeSynchronisationInfo_stratumLevel = INT(name='stratumLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'StratumLevel')))
    _TimeSynchronisationInfo_synchronisationStatus = ENUM(name='synchronisationStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationStatus')))
    _TimeSynchronisationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSynchronisationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TimeSynchronisationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSynchronisationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingAvailabilityIndication')))
    ____TimeSynchronisationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Extension', _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab_at = None
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSynchronisationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSynchronisationInfo_iE_Extensions__item__id),
        ('criticality', ___TimeSynchronisationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue),
        ])
    __TimeSynchronisationInfo_iE_Extensions__item_._ext = None
    _TimeSynchronisationInfo_iE_Extensions._cont = __TimeSynchronisationInfo_iE_Extensions__item_
    _TimeSynchronisationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSynchronisationInfo._cont = ASN1Dict([
        ('stratumLevel', _TimeSynchronisationInfo_stratumLevel),
        ('synchronisationStatus', _TimeSynchronisationInfo_synchronisationStatus),
        ('iE-Extensions', _TimeSynchronisationInfo_iE_Extensions),
        ])
    TimeSynchronisationInfo._ext = []
    
    #-----< TimeSynchronisationInfo-ExtIEs >-----#
    TimeSynchronisationInfo_ExtIEs = CLASS(name='TimeSynchronisationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TimeSynchronisationInfo_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingAvailabilityIndication')))
    TimeSynchronisationInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 207), ('criticality', 'ignore'), ('Extension', _TimeSynchronisationInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S-TMSI >-----#
    S_TMSI = SEQ(name='S-TMSI', mode=MODE_TYPE)
    _S_TMSI_mMEC = OCT_STR(name='mMEC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    _S_TMSI_m_TMSI = OCT_STR(name='m-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M-TMSI')))
    _S_TMSI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S_TMSI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___S_TMSI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____S_TMSI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__id._const_tab = ____S_TMSI_iE_Extensions__item__id_tab
    ___S_TMSI_iE_Extensions__item__id._const_tab_at = None
    ___S_TMSI_iE_Extensions__item__id._const_tab_id = 'id'
    ___S_TMSI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____S_TMSI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__criticality._const_tab = ____S_TMSI_iE_Extensions__item__criticality_tab
    ___S_TMSI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___S_TMSI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___S_TMSI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____S_TMSI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab = ____S_TMSI_iE_Extensions__item__extensionValue_tab
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __S_TMSI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___S_TMSI_iE_Extensions__item__id),
        ('criticality', ___S_TMSI_iE_Extensions__item__criticality),
        ('extensionValue', ___S_TMSI_iE_Extensions__item__extensionValue),
        ])
    __S_TMSI_iE_Extensions__item_._ext = None
    _S_TMSI_iE_Extensions._cont = __S_TMSI_iE_Extensions__item_
    _S_TMSI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S_TMSI._cont = ASN1Dict([
        ('mMEC', _S_TMSI_mMEC),
        ('m-TMSI', _S_TMSI_m_TMSI),
        ('iE-Extensions', _S_TMSI_iE_Extensions),
        ])
    S_TMSI._ext = []
    
    #-----< S-TMSI-ExtIEs >-----#
    S_TMSI_ExtIEs = CLASS(name='S-TMSI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    S_TMSI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name='TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TACList-In-LTE-NTN >-----#
    TACList_In_LTE_NTN = SEQ_OF(name='TACList-In-LTE-NTN', mode=MODE_TYPE)
    _TACList_In_LTE_NTN__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    TACList_In_LTE_NTN._cont = _TACList_In_LTE_NTN__item_
    TACList_In_LTE_NTN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name='TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name='tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__criticality_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedMDT_iE_Extensions__item__id),
        ('criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        ('tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        ('iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name='TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name='TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIListforWarning >-----#
    TAIListforWarning = SEQ_OF(name='TAIListforWarning', mode=MODE_TYPE)
    _TAIListforWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforWarning._cont = _TAIListforWarning__item_
    TAIListforWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name='TAI', mode=MODE_TYPE)
    _TAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _TAI_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_iE_Extensions__item__id),
        ('criticality', ___TAI_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        ('pLMNidentity', _TAI_pLMNidentity),
        ('tAC', _TAI_tAC),
        ('iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = []
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name='TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAI-Broadcast >-----#
    TAI_Broadcast = SEQ_OF(name='TAI-Broadcast', mode=MODE_TYPE)
    _TAI_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI-Broadcast-Item')))
    TAI_Broadcast._cont = _TAI_Broadcast__item_
    TAI_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI-Broadcast-Item >-----#
    TAI_Broadcast_Item = SEQ(name='TAI-Broadcast-Item', mode=MODE_TYPE)
    _TAI_Broadcast_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAI_Broadcast_Item_completedCellinTAI = SEQ_OF(name='completedCellinTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinTAI')))
    _TAI_Broadcast_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Broadcast_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__id_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_Broadcast_Item_iE_Extensions__item__id),
        ('criticality', ___TAI_Broadcast_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Broadcast_Item_iE_Extensions__item_._ext = None
    _TAI_Broadcast_Item_iE_Extensions._cont = __TAI_Broadcast_Item_iE_Extensions__item_
    _TAI_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Broadcast_Item._cont = ASN1Dict([
        ('tAI', _TAI_Broadcast_Item_tAI),
        ('completedCellinTAI', _TAI_Broadcast_Item_completedCellinTAI),
        ('iE-Extensions', _TAI_Broadcast_Item_iE_Extensions),
        ])
    TAI_Broadcast_Item._ext = []
    
    #-----< TAI-Broadcast-Item-ExtIEs >-----#
    TAI_Broadcast_Item_ExtIEs = CLASS(name='TAI-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAI-Cancelled >-----#
    TAI_Cancelled = SEQ_OF(name='TAI-Cancelled', mode=MODE_TYPE)
    _TAI_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI-Cancelled-Item')))
    TAI_Cancelled._cont = _TAI_Cancelled__item_
    TAI_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI-Cancelled-Item >-----#
    TAI_Cancelled_Item = SEQ(name='TAI-Cancelled-Item', mode=MODE_TYPE)
    _TAI_Cancelled_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAI_Cancelled_Item_cancelledCellinTAI = SEQ_OF(name='cancelledCellinTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinTAI')))
    _TAI_Cancelled_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Cancelled_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__id_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_Cancelled_Item_iE_Extensions__item__id),
        ('criticality', ___TAI_Cancelled_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Cancelled_Item_iE_Extensions__item_._ext = None
    _TAI_Cancelled_Item_iE_Extensions._cont = __TAI_Cancelled_Item_iE_Extensions__item_
    _TAI_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Cancelled_Item._cont = ASN1Dict([
        ('tAI', _TAI_Cancelled_Item_tAI),
        ('cancelledCellinTAI', _TAI_Cancelled_Item_cancelledCellinTAI),
        ('iE-Extensions', _TAI_Cancelled_Item_iE_Extensions),
        ])
    TAI_Cancelled_Item._ext = []
    
    #-----< TAI-Cancelled-Item-ExtIEs >-----#
    TAI_Cancelled_Item_ExtIEs = CLASS(name='TAI-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name='TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name='tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__criticality_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__extensionValue_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedMDT_iE_Extensions__item__id),
        ('criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        ('tAListforMDT', _TABasedMDT_tAListforMDT),
        ('iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name='TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name='TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedQMC >-----#
    TABasedQMC = SEQ(name='TABasedQMC', mode=MODE_TYPE)
    _TABasedQMC_tAListforQMC = SEQ_OF(name='tAListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAListforQMC')))
    _TABasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TABasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__id._const_tab = ____TABasedQMC_iE_Extensions__item__id_tab
    ___TABasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TABasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab = ____TABasedQMC_iE_Extensions__item__criticality_tab
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TABasedQMC_iE_Extensions__item__extensionValue_tab
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedQMC_iE_Extensions__item__id),
        ('criticality', ___TABasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TABasedQMC_iE_Extensions__item_._ext = None
    _TABasedQMC_iE_Extensions._cont = __TABasedQMC_iE_Extensions__item_
    _TABasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedQMC._cont = ASN1Dict([
        ('tAListforQMC', _TABasedQMC_tAListforQMC),
        ('iE-Extensions', _TABasedQMC_iE_Extensions),
        ])
    TABasedQMC._ext = []
    
    #-----< TABasedQMC-ExtIEs >-----#
    TABasedQMC_ExtIEs = CLASS(name='TABasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TABasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforQMC >-----#
    TAListforQMC = SEQ_OF(name='TAListforQMC', mode=MODE_TYPE)
    _TAListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    TAListforQMC._cont = _TAListforQMC__item_
    TAListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIBasedQMC >-----#
    TAIBasedQMC = SEQ(name='TAIBasedQMC', mode=MODE_TYPE)
    _TAIBasedQMC_tAIListforQMC = SEQ_OF(name='tAIListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforQMC')))
    _TAIBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab = ____TAIBasedQMC_iE_Extensions__item__id_tab
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab = ____TAIBasedQMC_iE_Extensions__item__criticality_tab
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedQMC_iE_Extensions__item__id),
        ('criticality', ___TAIBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedQMC_iE_Extensions__item_._ext = None
    _TAIBasedQMC_iE_Extensions._cont = __TAIBasedQMC_iE_Extensions__item_
    _TAIBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedQMC._cont = ASN1Dict([
        ('tAIListforQMC', _TAIBasedQMC_tAIListforQMC),
        ('iE-Extensions', _TAIBasedQMC_iE_Extensions),
        ])
    TAIBasedQMC._ext = []
    
    #-----< TAIBasedQMC-ExtIEs >-----#
    TAIBasedQMC_ExtIEs = CLASS(name='TAIBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforQMC >-----#
    TAIListforQMC = SEQ_OF(name='TAIListforQMC', mode=MODE_TYPE)
    _TAIListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforQMC._cont = _TAIListforQMC__item_
    TAIListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CompletedCellinTAI >-----#
    CompletedCellinTAI = SEQ_OF(name='CompletedCellinTAI', mode=MODE_TYPE)
    _CompletedCellinTAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinTAI-Item')))
    CompletedCellinTAI._cont = _CompletedCellinTAI__item_
    CompletedCellinTAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellinTAI-Item >-----#
    CompletedCellinTAI_Item = SEQ(name='CompletedCellinTAI-Item', mode=MODE_TYPE)
    _CompletedCellinTAI_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CompletedCellinTAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellinTAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellinTAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellinTAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellinTAI_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellinTAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellinTAI_Item_iE_Extensions__item_._ext = None
    _CompletedCellinTAI_Item_iE_Extensions._cont = __CompletedCellinTAI_Item_iE_Extensions__item_
    _CompletedCellinTAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellinTAI_Item._cont = ASN1Dict([
        ('eCGI', _CompletedCellinTAI_Item_eCGI),
        ('iE-Extensions', _CompletedCellinTAI_Item_iE_Extensions),
        ])
    CompletedCellinTAI_Item._ext = []
    
    #-----< CompletedCellinTAI-Item-ExtIEs >-----#
    CompletedCellinTAI_Item_ExtIEs = CLASS(name='CompletedCellinTAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CompletedCellinTAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name='TBCD-STRING', mode=MODE_TYPE)
    TBCD_STRING._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name='TargetID', mode=MODE_TYPE)
    _TargetID_targeteNB_ID = SEQ(name='targeteNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargeteNB-ID')))
    _TargetID_targetRNC_ID = SEQ(name='targetRNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetRNC-ID')))
    _TargetID_cGI = SEQ(name='cGI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CGI')))
    _TargetID_targetgNgRanNode_ID = SEQ(name='targetgNgRanNode-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetNgRanNode-ID')))
    TargetID._cont = ASN1Dict([
        ('targeteNB-ID', _TargetID_targeteNB_ID),
        ('targetRNC-ID', _TargetID_targetRNC_ID),
        ('cGI', _TargetID_cGI),
        ('targetgNgRanNode-ID', _TargetID_targetgNgRanNode_ID),
        ])
    TargetID._ext = ['targetgNgRanNode-ID']
    
    #-----< TargeteNB-ID >-----#
    TargeteNB_ID = SEQ(name='TargeteNB-ID', mode=MODE_TYPE)
    _TargeteNB_ID_global_ENB_ID = SEQ(name='global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _TargeteNB_ID_selected_TAI = SEQ(name='selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TargeteNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TargeteNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab = ____TargeteNB_ID_iE_Extensions__item__id_tab
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargeteNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ID_iE_Extensions__item__criticality_tab
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargeteNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargeteNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargeteNB_ID_iE_Extensions__item__id),
        ('criticality', ___TargeteNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargeteNB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ID_iE_Extensions__item_._ext = None
    _TargeteNB_ID_iE_Extensions._cont = __TargeteNB_ID_iE_Extensions__item_
    _TargeteNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ID._cont = ASN1Dict([
        ('global-ENB-ID', _TargeteNB_ID_global_ENB_ID),
        ('selected-TAI', _TargeteNB_ID_selected_TAI),
        ('iE-Extensions', _TargeteNB_ID_iE_Extensions),
        ])
    TargeteNB_ID._ext = []
    
    #-----< TargeteNB-ID-ExtIEs >-----#
    TargeteNB_ID_ExtIEs = CLASS(name='TargeteNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargeteNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name='TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _TargetRNC_ID_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')), opt=True)
    _TargetRNC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RNC-ID')))
    _TargetRNC_ID_extendedRNC_ID = INT(name='extendedRNC-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRNC-ID')), opt=True)
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__criticality_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRNC_ID_iE_Extensions__item__id),
        ('criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        ('lAI', _TargetRNC_ID_lAI),
        ('rAC', _TargetRNC_ID_rAC),
        ('rNC-ID', _TargetRNC_ID_rNC_ID),
        ('extendedRNC-ID', _TargetRNC_ID_extendedRNC_ID),
        ('iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = []
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name='TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetNgRanNode-ID >-----#
    TargetNgRanNode_ID = SEQ(name='TargetNgRanNode-ID', mode=MODE_TYPE)
    _TargetNgRanNode_ID_global_RAN_NODE_ID = CHOICE(name='global-RAN-NODE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _TargetNgRanNode_ID_selected_TAI = SEQ(name='selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')))
    _TargetNgRanNode_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNgRanNode_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargetNgRanNode_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetNgRanNode_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__id_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetNgRanNode_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetNgRanNode_ID_iE_Extensions__item__id),
        ('criticality', ___TargetNgRanNode_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetNgRanNode_ID_iE_Extensions__item_._ext = None
    _TargetNgRanNode_ID_iE_Extensions._cont = __TargetNgRanNode_ID_iE_Extensions__item_
    _TargetNgRanNode_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNgRanNode_ID._cont = ASN1Dict([
        ('global-RAN-NODE-ID', _TargetNgRanNode_ID_global_RAN_NODE_ID),
        ('selected-TAI', _TargetNgRanNode_ID_selected_TAI),
        ('iE-Extensions', _TargetNgRanNode_ID_iE_Extensions),
        ])
    TargetNgRanNode_ID._ext = []
    
    #-----< TargetNgRanNode-ID-ExtIEs >-----#
    TargetNgRanNode_ID_ExtIEs = CLASS(name='TargetNgRanNode-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargetNgRanNode_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-RAN-NODE-ID >-----#
    Global_RAN_NODE_ID = CHOICE(name='Global-RAN-NODE-ID', mode=MODE_TYPE)
    _Global_RAN_NODE_ID_gNB = SEQ(name='gNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB')))
    _Global_RAN_NODE_ID_ng_eNB = SEQ(name='ng-eNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NG-eNB')))
    Global_RAN_NODE_ID._cont = ASN1Dict([
        ('gNB', _Global_RAN_NODE_ID_gNB),
        ('ng-eNB', _Global_RAN_NODE_ID_ng_eNB),
        ])
    Global_RAN_NODE_ID._ext = []
    
    #-----< GNB >-----#
    GNB = SEQ(name='GNB', mode=MODE_TYPE)
    _GNB_global_gNB_ID = SEQ(name='global-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-GNB-ID')))
    _GNB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__id._const_tab = ____GNB_iE_Extensions__item__id_tab
    ___GNB_iE_Extensions__item__id._const_tab_at = None
    ___GNB_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__criticality._const_tab = ____GNB_iE_Extensions__item__criticality_tab
    ___GNB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__extensionValue._const_tab = ____GNB_iE_Extensions__item__extensionValue_tab
    ___GNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_iE_Extensions__item__id),
        ('criticality', ___GNB_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_iE_Extensions__item__extensionValue),
        ])
    __GNB_iE_Extensions__item_._ext = None
    _GNB_iE_Extensions._cont = __GNB_iE_Extensions__item_
    _GNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB._cont = ASN1Dict([
        ('global-gNB-ID', _GNB_global_gNB_ID),
        ('iE-Extensions', _GNB_iE_Extensions),
        ])
    GNB._ext = []
    
    #-----< GNB-ExtIEs >-----#
    GNB_ExtIEs = CLASS(name='GNB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GNB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-GNB-ID >-----#
    Global_GNB_ID = SEQ(name='Global-GNB-ID', mode=MODE_TYPE)
    _Global_GNB_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_GNB_ID_gNB_ID = CHOICE(name='gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB-Identity')))
    _Global_GNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_GNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_GNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____Global_GNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab = ____Global_GNB_ID_iE_Extensions__item__id_tab
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___Global_GNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Global_GNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab = ____Global_GNB_ID_iE_Extensions__item__criticality_tab
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Global_GNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Global_GNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Global_GNB_ID_iE_Extensions__item__id),
        ('criticality', ___Global_GNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___Global_GNB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_GNB_ID_iE_Extensions__item_._ext = None
    _Global_GNB_ID_iE_Extensions._cont = __Global_GNB_ID_iE_Extensions__item_
    _Global_GNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_GNB_ID._cont = ASN1Dict([
        ('pLMN-Identity', _Global_GNB_ID_pLMN_Identity),
        ('gNB-ID', _Global_GNB_ID_gNB_ID),
        ('iE-Extensions', _Global_GNB_ID_iE_Extensions),
        ])
    Global_GNB_ID._ext = []
    
    #-----< Global-GNB-ID-ExtIEs >-----#
    Global_GNB_ID_ExtIEs = CLASS(name='Global-GNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Global_GNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-Identity >-----#
    GNB_Identity = CHOICE(name='GNB-Identity', mode=MODE_TYPE)
    _GNB_Identity_gNB_ID = BIT_STR(name='gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB-ID')))
    GNB_Identity._cont = ASN1Dict([
        ('gNB-ID', _GNB_Identity_gNB_ID),
        ])
    GNB_Identity._ext = []
    
    #-----< NG-eNB >-----#
    NG_eNB = SEQ(name='NG-eNB', mode=MODE_TYPE)
    _NG_eNB_global_ng_eNB_ID = SEQ(name='global-ng-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _NG_eNB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_eNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NG_eNB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____NG_eNB_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__id._const_tab = ____NG_eNB_iE_Extensions__item__id_tab
    ___NG_eNB_iE_Extensions__item__id._const_tab_at = None
    ___NG_eNB_iE_Extensions__item__id._const_tab_id = 'id'
    ___NG_eNB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NG_eNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__criticality._const_tab = ____NG_eNB_iE_Extensions__item__criticality_tab
    ___NG_eNB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NG_eNB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NG_eNB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NG_eNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab = ____NG_eNB_iE_Extensions__item__extensionValue_tab
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NG_eNB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NG_eNB_iE_Extensions__item__id),
        ('criticality', ___NG_eNB_iE_Extensions__item__criticality),
        ('extensionValue', ___NG_eNB_iE_Extensions__item__extensionValue),
        ])
    __NG_eNB_iE_Extensions__item_._ext = None
    _NG_eNB_iE_Extensions._cont = __NG_eNB_iE_Extensions__item_
    _NG_eNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_eNB._cont = ASN1Dict([
        ('global-ng-eNB-ID', _NG_eNB_global_ng_eNB_ID),
        ('iE-Extensions', _NG_eNB_iE_Extensions),
        ])
    NG_eNB._ext = []
    
    #-----< NG-eNB-ExtIEs >-----#
    NG_eNB_ExtIEs = CLASS(name='NG-eNB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NG_eNB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-ID >-----#
    GNB_ID = BIT_STR(name='GNB-ID', mode=MODE_TYPE)
    GNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    
    #-----< TargeteNB-ToSourceeNB-TransparentContainer >-----#
    TargeteNB_ToSourceeNB_TransparentContainer = SEQ(name='TargeteNB-ToSourceeNB-TransparentContainer', mode=MODE_TYPE)
    _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container = OCT_STR(name='rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RRC-Container')))
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoList')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RACSIndication')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABSecurityResultList')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 318), ('criticality', 'ignore'), ('Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_._ext = None
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions._cont = __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ToSourceeNB_TransparentContainer._cont = ASN1Dict([
        ('rRC-Container', _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container),
        ('iE-Extensions', _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions),
        ])
    TargeteNB_ToSourceeNB_TransparentContainer._ext = []
    
    #-----< TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs >-----#
    TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs = CLASS(name='TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoList')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RACSIndication')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABSecurityResultList')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 318), ('criticality', 'ignore'), ('Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Target-ToSource-TransparentContainer >-----#
    Target_ToSource_TransparentContainer = OCT_STR(name='Target-ToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer >-----#
    TargetRNC_ToSourceRNC_TransparentContainer = OCT_STR(name='TargetRNC-ToSourceRNC-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetBSS-ToSourceBSS-TransparentContainer >-----#
    TargetBSS_ToSourceBSS_TransparentContainer = OCT_STR(name='TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetNgRanNode-ToSourceNgRanNode-TransparentContainer >-----#
    TargetNgRanNode_ToSourceNgRanNode_TransparentContainer = OCT_STR(name='TargetNgRanNode-ToSourceNgRanNode-TransparentContainer', mode=MODE_TYPE)
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name='M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_measurementThreshold = CHOICE(name='measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MeasurementThresholdA2')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        ('criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        ('extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        ('measurementThreshold', _M1ThresholdEventA2_measurementThreshold),
        ('iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name='M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name='Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name='Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< TimeToTrigger >-----#
    TimeToTrigger = ENUM(name='TimeToTrigger', mode=MODE_TYPE)
    TimeToTrigger._cont = ASN1Dict([('ms0', 0), ('ms40', 1), ('ms64', 2), ('ms80', 3), ('ms100', 4), ('ms128', 5), ('ms160', 6), ('ms256', 7), ('ms320', 8), ('ms480', 9), ('ms512', 10), ('ms640', 11), ('ms1024', 12), ('ms1280', 13), ('ms2560', 14), ('ms5120', 15)])
    TimeToTrigger._ext = None
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name='Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name='Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TimeSinceSecondaryNodeRelease >-----#
    TimeSinceSecondaryNodeRelease = OCT_STR(name='TimeSinceSecondaryNodeRelease', mode=MODE_TYPE)
    TimeSinceSecondaryNodeRelease._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TransportInformation >-----#
    TransportInformation = SEQ(name='TransportInformation', mode=MODE_TYPE)
    _TransportInformation_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TransportInformation_uL_GTP_TEID = OCT_STR(name='uL-GTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    TransportInformation._cont = ASN1Dict([
        ('transportLayerAddress', _TransportInformation_transportLayerAddress),
        ('uL-GTP-TEID', _TransportInformation_uL_GTP_TEID),
        ])
    TransportInformation._ext = []
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name='TraceActivation', mode=MODE_TYPE)
    _TraceActivation_e_UTRAN_Trace_ID = OCT_STR(name='e-UTRAN-Trace-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name='interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAppLayerMeasConfig')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-ConfigurationNR')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'URI-Address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 162), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 316), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceActivation_iE_Extensions__item__id),
        ('criticality', ___TraceActivation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        ('e-UTRAN-Trace-ID', _TraceActivation_e_UTRAN_Trace_ID),
        ('interfacesToTrace', _TraceActivation_interfacesToTrace),
        ('traceDepth', _TraceActivation_traceDepth),
        ('traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        ('iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name='TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAppLayerMeasConfig')))
    _TraceActivation_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-ConfigurationNR')))
    _TraceActivation_ExtIEs_val_Extension_3 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'URI-Address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([('id', 162), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 316), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2), ('minimumWithoutVendorSpecificExtension', 3), ('mediumWithoutVendorSpecificExtension', 4), ('maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< E-UTRAN-Trace-ID >-----#
    E_UTRAN_Trace_ID = OCT_STR(name='E-UTRAN-Trace-ID', mode=MODE_TYPE)
    E_UTRAN_Trace_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TrafficLoadReductionIndication >-----#
    TrafficLoadReductionIndication = INT(name='TrafficLoadReductionIndication', mode=MODE_TYPE)
    TrafficLoadReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=99)], ev=None, er=[])
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name='TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name='uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TunnelInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__criticality_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__extensionValue_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TunnelInformation_iE_Extensions__item__id),
        ('criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        ('transportLayerAddress', _TunnelInformation_transportLayerAddress),
        ('uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        ('iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name='Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< TAIListForRestart >-----#
    TAIListForRestart = SEQ_OF(name='TAIListForRestart', mode=MODE_TYPE)
    _TAIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListForRestart._cont = _TAIListForRestart__item_
    TAIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< UEAggregateMaximumBitrate >-----#
    UEAggregateMaximumBitrate = SEQ(name='UEAggregateMaximumBitrate', mode=MODE_TYPE)
    _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL = INT(name='uEaggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL = INT(name='uEaggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 259), ('criticality', 'ignore'), ('Extension', _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'ignore'), ('Extension', _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitrate_iE_Extensions._cont = __UEAggregateMaximumBitrate_iE_Extensions__item_
    _UEAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitrate._cont = ASN1Dict([
        ('uEaggregateMaximumBitRateDL', _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL),
        ('uEaggregateMaximumBitRateUL', _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL),
        ('iE-Extensions', _UEAggregateMaximumBitrate_iE_Extensions),
        ])
    UEAggregateMaximumBitrate._ext = []
    
    #-----< UEAggregate-MaximumBitrates-ExtIEs >-----#
    UEAggregate_MaximumBitrates_ExtIEs = CLASS(name='UEAggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    UEAggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[dict([('id', 259), ('criticality', 'ignore'), ('Extension', _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'ignore'), ('Extension', _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEAppLayerMeasConfig >-----#
    UEAppLayerMeasConfig = SEQ(name='UEAppLayerMeasConfig', mode=MODE_TYPE)
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig = OCT_STR(name='containerForAppLayerMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _UEAppLayerMeasConfig_areaScopeOfQMC = CHOICE(name='areaScopeOfQMC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AreaScopeOfQMC')))
    _UEAppLayerMeasConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAppLayerMeasConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UEAppLayerMeasConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServiceType')))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'ignore'), ('Extension', _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_at = None
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAppLayerMeasConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAppLayerMeasConfig_iE_Extensions__item__id),
        ('criticality', ___UEAppLayerMeasConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue),
        ])
    __UEAppLayerMeasConfig_iE_Extensions__item_._ext = None
    _UEAppLayerMeasConfig_iE_Extensions._cont = __UEAppLayerMeasConfig_iE_Extensions__item_
    _UEAppLayerMeasConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAppLayerMeasConfig._cont = ASN1Dict([
        ('containerForAppLayerMeasConfig', _UEAppLayerMeasConfig_containerForAppLayerMeasConfig),
        ('areaScopeOfQMC', _UEAppLayerMeasConfig_areaScopeOfQMC),
        ('iE-Extensions', _UEAppLayerMeasConfig_iE_Extensions),
        ])
    UEAppLayerMeasConfig._ext = []
    
    #-----< UEAppLayerMeasConfig-ExtIEs >-----#
    UEAppLayerMeasConfig_ExtIEs = CLASS(name='UEAppLayerMeasConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UEAppLayerMeasConfig_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServiceType')))
    UEAppLayerMeasConfig_ExtIEs._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'ignore'), ('Extension', _UEAppLayerMeasConfig_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoRequest >-----#
    UECapabilityInfoRequest = ENUM(name='UECapabilityInfoRequest', mode=MODE_TYPE)
    UECapabilityInfoRequest._cont = ASN1Dict([('requested', 0)])
    UECapabilityInfoRequest._ext = []
    
    #-----< UE-RetentionInformation >-----#
    UE_RetentionInformation = ENUM(name='UE-RetentionInformation', mode=MODE_TYPE)
    UE_RetentionInformation._cont = ASN1Dict([('ues-retained', 0)])
    UE_RetentionInformation._ext = []
    
    #-----< UE-S1AP-IDs >-----#
    UE_S1AP_IDs = CHOICE(name='UE-S1AP-IDs', mode=MODE_TYPE)
    _UE_S1AP_IDs_uE_S1AP_ID_pair = SEQ(name='uE-S1AP-ID-pair', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-ID-pair')))
    _UE_S1AP_IDs_mME_UE_S1AP_ID = INT(name='mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    UE_S1AP_IDs._cont = ASN1Dict([
        ('uE-S1AP-ID-pair', _UE_S1AP_IDs_uE_S1AP_ID_pair),
        ('mME-UE-S1AP-ID', _UE_S1AP_IDs_mME_UE_S1AP_ID),
        ])
    UE_S1AP_IDs._ext = []
    
    #-----< UE-S1AP-ID-pair >-----#
    UE_S1AP_ID_pair = SEQ(name='UE-S1AP-ID-pair', mode=MODE_TYPE)
    _UE_S1AP_ID_pair_mME_UE_S1AP_ID = INT(name='mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UE_S1AP_ID_pair_eNB_UE_S1AP_ID = INT(name='eNB-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UE_S1AP_ID_pair_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_S1AP_ID_pair_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UE_S1AP_ID_pair_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab_at = None
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_S1AP_ID_pair_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_S1AP_ID_pair_iE_Extensions__item__id),
        ('criticality', ___UE_S1AP_ID_pair_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue),
        ])
    __UE_S1AP_ID_pair_iE_Extensions__item_._ext = None
    _UE_S1AP_ID_pair_iE_Extensions._cont = __UE_S1AP_ID_pair_iE_Extensions__item_
    _UE_S1AP_ID_pair_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_S1AP_ID_pair._cont = ASN1Dict([
        ('mME-UE-S1AP-ID', _UE_S1AP_ID_pair_mME_UE_S1AP_ID),
        ('eNB-UE-S1AP-ID', _UE_S1AP_ID_pair_eNB_UE_S1AP_ID),
        ('iE-Extensions', _UE_S1AP_ID_pair_iE_Extensions),
        ])
    UE_S1AP_ID_pair._ext = []
    
    #-----< UE-S1AP-ID-pair-ExtIEs >-----#
    UE_S1AP_ID_pair_ExtIEs = CLASS(name='UE-S1AP-ID-pair-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_S1AP_ID_pair_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItem >-----#
    UE_associatedLogicalS1_ConnectionItem = SEQ(name='UE-associatedLogicalS1-ConnectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID = INT(name='mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')), opt=True)
    _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID = INT(name='eNB-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')), opt=True)
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id),
        ('criticality', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions._cont = __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalS1_ConnectionItem._cont = ASN1Dict([
        ('mME-UE-S1AP-ID', _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID),
        ('eNB-UE-S1AP-ID', _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID),
        ('iE-Extensions', _UE_associatedLogicalS1_ConnectionItem_iE_Extensions),
        ])
    UE_associatedLogicalS1_ConnectionItem._ext = []
    
    #-----< UE-associatedLogicalS1-ConnectionItemExtIEs >-----#
    UE_associatedLogicalS1_ConnectionItemExtIEs = CLASS(name='UE-associatedLogicalS1-ConnectionItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalS1_ConnectionItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = BIT_STR(name='UEIdentityIndexValue', mode=MODE_TYPE)
    UEIdentityIndexValue._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< UE-HistoryInformation >-----#
    UE_HistoryInformation = SEQ_OF(name='UE-HistoryInformation', mode=MODE_TYPE)
    _UE_HistoryInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedCell-Item')))
    UE_HistoryInformation._cont = _UE_HistoryInformation__item_
    UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UE-HistoryInformationFromTheUE >-----#
    UE_HistoryInformationFromTheUE = OCT_STR(name='UE-HistoryInformationFromTheUE', mode=MODE_TYPE)
    
    #-----< UEPagingID >-----#
    UEPagingID = CHOICE(name='UEPagingID', mode=MODE_TYPE)
    _UEPagingID_s_TMSI = SEQ(name='s-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _UEPagingID_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IMSI')))
    UEPagingID._cont = ASN1Dict([
        ('s-TMSI', _UEPagingID_s_TMSI),
        ('iMSI', _UEPagingID_iMSI),
        ])
    UEPagingID._ext = []
    
    #-----< UERadioCapability >-----#
    UERadioCapability = OCT_STR(name='UERadioCapability', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPaging >-----#
    UERadioCapabilityForPaging = OCT_STR(name='UERadioCapabilityForPaging', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityID >-----#
    UERadioCapabilityID = OCT_STR(name='UERadioCapabilityID', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container >-----#
    UE_RLF_Report_Container = OCT_STR(name='UE-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container-for-extended-bands >-----#
    UE_RLF_Report_Container_for_extended_bands = OCT_STR(name='UE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE)
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name='UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_encryptionAlgorithms = BIT_STR(name='encryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EncryptionAlgorithms')))
    _UESecurityCapabilities_integrityProtectionAlgorithms = BIT_STR(name='integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESecurityCapabilities_iE_Extensions__item__id),
        ('criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        ('encryptionAlgorithms', _UESecurityCapabilities_encryptionAlgorithms),
        ('integrityProtectionAlgorithms', _UESecurityCapabilities_integrityProtectionAlgorithms),
        ('iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name='UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESidelinkAggregateMaximumBitrate >-----#
    UESidelinkAggregateMaximumBitrate = SEQ(name='UESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name='uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _UESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _UESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uESidelinkAggregateMaximumBitRate', _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        ('iE-Extensions', _UESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    UESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs >-----#
    UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs = CLASS(name='UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Usage-Type >-----#
    UE_Usage_Type = INT(name='UE-Usage-Type', mode=MODE_TYPE)
    UE_Usage_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UL-CP-SecurityInformation >-----#
    UL_CP_SecurityInformation = SEQ(name='UL-CP-SecurityInformation', mode=MODE_TYPE)
    _UL_CP_SecurityInformation_ul_NAS_MAC = BIT_STR(name='ul-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UL-NAS-MAC')))
    _UL_CP_SecurityInformation_ul_NAS_Count = BIT_STR(name='ul-NAS-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UL-NAS-Count')))
    _UL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UL_CP_SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CP_SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___UL_CP_SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _UL_CP_SecurityInformation_iE_Extensions._cont = __UL_CP_SecurityInformation_iE_Extensions__item_
    _UL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CP_SecurityInformation._cont = ASN1Dict([
        ('ul-NAS-MAC', _UL_CP_SecurityInformation_ul_NAS_MAC),
        ('ul-NAS-Count', _UL_CP_SecurityInformation_ul_NAS_Count),
        ('iE-Extensions', _UL_CP_SecurityInformation_iE_Extensions),
        ])
    UL_CP_SecurityInformation._ext = []
    
    #-----< UL-CP-SecurityInformation-ExtIEs >-----#
    UL_CP_SecurityInformation_ExtIEs = CLASS(name='UL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-NAS-MAC >-----#
    UL_NAS_MAC = BIT_STR(name='UL-NAS-MAC', mode=MODE_TYPE)
    UL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UL-NAS-Count >-----#
    UL_NAS_Count = BIT_STR(name='UL-NAS-Count', mode=MODE_TYPE)
    UL_NAS_Count._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< UnlicensedSpectrumRestriction >-----#
    UnlicensedSpectrumRestriction = ENUM(name='UnlicensedSpectrumRestriction', mode=MODE_TYPE)
    UnlicensedSpectrumRestriction._cont = ASN1Dict([('unlicensed-restricted', 0)])
    UnlicensedSpectrumRestriction._ext = []
    
    #-----< URI-Address >-----#
    URI_Address = STR_VIS(name='URI-Address', mode=MODE_TYPE)
    
    #-----< UserLocationInformation >-----#
    UserLocationInformation = SEQ(name='UserLocationInformation', mode=MODE_TYPE)
    _UserLocationInformation_eutran_cgi = SEQ(name='eutran-cgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _UserLocationInformation_tai = SEQ(name='tai', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _UserLocationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____UserLocationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 288), ('criticality', 'ignore'), ('Extension', _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Extension', _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformation_iE_Extensions__item__id._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformation_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformation_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformation_iE_Extensions__item_._ext = None
    _UserLocationInformation_iE_Extensions._cont = __UserLocationInformation_iE_Extensions__item_
    _UserLocationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformation._cont = ASN1Dict([
        ('eutran-cgi', _UserLocationInformation_eutran_cgi),
        ('tai', _UserLocationInformation_tai),
        ('iE-Extensions', _UserLocationInformation_iE_Extensions),
        ])
    UserLocationInformation._ext = []
    
    #-----< UserLocationInformation-ExtIEs >-----#
    UserLocationInformation_ExtIEs = CLASS(name='UserLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UserLocationInformation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _UserLocationInformation_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    UserLocationInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 288), ('criticality', 'ignore'), ('Extension', _UserLocationInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Extension', _UserLocationInformation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEUserPlaneCIoTSupportIndicator >-----#
    UEUserPlaneCIoTSupportIndicator = ENUM(name='UEUserPlaneCIoTSupportIndicator', mode=MODE_TYPE)
    UEUserPlaneCIoTSupportIndicator._cont = ASN1Dict([('supported', 0)])
    UEUserPlaneCIoTSupportIndicator._ext = []
    
    #-----< UE-Application-Layer-Measurement-Capability >-----#
    UE_Application_Layer_Measurement_Capability = BIT_STR(name='UE-Application-Layer-Measurement-Capability', mode=MODE_TYPE)
    UE_Application_Layer_Measurement_Capability._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< VoiceSupportMatchIndicator >-----#
    VoiceSupportMatchIndicator = ENUM(name='VoiceSupportMatchIndicator', mode=MODE_TYPE)
    VoiceSupportMatchIndicator._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    VoiceSupportMatchIndicator._ext = []
    
    #-----< V2XServicesAuthorized >-----#
    V2XServicesAuthorized = SEQ(name='V2XServicesAuthorized', mode=MODE_TYPE)
    _V2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'VehicleUE')), opt=True)
    _V2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PedestrianUE')), opt=True)
    _V2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __V2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___V2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__id_tab
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___V2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __V2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___V2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___V2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___V2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __V2XServicesAuthorized_iE_Extensions__item_._ext = None
    _V2XServicesAuthorized_iE_Extensions._cont = __V2XServicesAuthorized_iE_Extensions__item_
    _V2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    V2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _V2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _V2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _V2XServicesAuthorized_iE_Extensions),
        ])
    V2XServicesAuthorized._ext = []
    
    #-----< V2XServicesAuthorized-ExtIEs >-----#
    V2XServicesAuthorized_ExtIEs = CLASS(name='V2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    V2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name='VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name='PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< WarningAreaCoordinates >-----#
    WarningAreaCoordinates = OCT_STR(name='WarningAreaCoordinates', mode=MODE_TYPE)
    WarningAreaCoordinates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< WarningAreaList >-----#
    WarningAreaList = CHOICE(name='WarningAreaList', mode=MODE_TYPE)
    _WarningAreaList_cellIDList = SEQ_OF(name='cellIDList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ECGIList')))
    _WarningAreaList_trackingAreaListforWarning = SEQ_OF(name='trackingAreaListforWarning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforWarning')))
    _WarningAreaList_emergencyAreaIDList = SEQ_OF(name='emergencyAreaIDList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDList')))
    WarningAreaList._cont = ASN1Dict([
        ('cellIDList', _WarningAreaList_cellIDList),
        ('trackingAreaListforWarning', _WarningAreaList_trackingAreaListforWarning),
        ('emergencyAreaIDList', _WarningAreaList_emergencyAreaIDList),
        ])
    WarningAreaList._ext = []
    
    #-----< WarningType >-----#
    WarningType = OCT_STR(name='WarningType', mode=MODE_TYPE)
    WarningType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< WarningSecurityInfo >-----#
    WarningSecurityInfo = OCT_STR(name='WarningSecurityInfo', mode=MODE_TYPE)
    WarningSecurityInfo._const_sz = ASN1Set(rv=[50], rr=[], ev=None, er=[])
    
    #-----< WarningMessageContents >-----#
    WarningMessageContents = OCT_STR(name='WarningMessageContents', mode=MODE_TYPE)
    WarningMessageContents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9600)], ev=None, er=[])
    
    #-----< WLANMeasurementConfiguration >-----#
    WLANMeasurementConfiguration = SEQ(name='WLANMeasurementConfiguration', mode=MODE_TYPE)
    _WLANMeasurementConfiguration_wlanMeasConfig = ENUM(name='wlanMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasConfig')))
    _WLANMeasurementConfiguration_wlanMeasConfigNameList = SEQ_OF(name='wlanMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasConfigNameList')), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi = ENUM(name='wlan-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rssi._ext = []
    _WLANMeasurementConfiguration_wlan_rtt = ENUM(name='wlan-rtt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rtt._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rtt._ext = []
    _WLANMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementConfiguration_iE_Extensions__item_._ext = None
    _WLANMeasurementConfiguration_iE_Extensions._cont = __WLANMeasurementConfiguration_iE_Extensions__item_
    _WLANMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementConfiguration._cont = ASN1Dict([
        ('wlanMeasConfig', _WLANMeasurementConfiguration_wlanMeasConfig),
        ('wlanMeasConfigNameList', _WLANMeasurementConfiguration_wlanMeasConfigNameList),
        ('wlan-rssi', _WLANMeasurementConfiguration_wlan_rssi),
        ('wlan-rtt', _WLANMeasurementConfiguration_wlan_rtt),
        ('iE-Extensions', _WLANMeasurementConfiguration_iE_Extensions),
        ])
    WLANMeasurementConfiguration._ext = []
    
    #-----< WLANMeasurementConfiguration-ExtIEs >-----#
    WLANMeasurementConfiguration_ExtIEs = CLASS(name='WLANMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    WLANMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfigNameList >-----#
    WLANMeasConfigNameList = SEQ_OF(name='WLANMeasConfigNameList', mode=MODE_TYPE)
    _WLANMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANName')))
    WLANMeasConfigNameList._cont = _WLANMeasConfigNameList__item_
    WLANMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< WLANMeasConfig >-----#
    WLANMeasConfig = ENUM(name='WLANMeasConfig', mode=MODE_TYPE)
    WLANMeasConfig._cont = ASN1Dict([('setup', 0)])
    WLANMeasConfig._ext = []
    
    #-----< WLANName >-----#
    WLANName = OCT_STR(name='WLANName', mode=MODE_TYPE)
    WLANName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WUS-Assistance-Information >-----#
    WUS_Assistance_Information = SEQ(name='WUS-Assistance-Information', mode=MODE_TYPE)
    _WUS_Assistance_Information_pagingProbabilityInformation = ENUM(name='pagingProbabilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingProbabilityInformation')))
    _WUS_Assistance_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WUS_Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___WUS_Assistance_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__id_tab
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___WUS_Assistance_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WUS_Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WUS_Assistance_Information_iE_Extensions__item__id),
        ('criticality', ___WUS_Assistance_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___WUS_Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __WUS_Assistance_Information_iE_Extensions__item_._ext = None
    _WUS_Assistance_Information_iE_Extensions._cont = __WUS_Assistance_Information_iE_Extensions__item_
    _WUS_Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WUS_Assistance_Information._cont = ASN1Dict([
        ('pagingProbabilityInformation', _WUS_Assistance_Information_pagingProbabilityInformation),
        ('iE-Extensions', _WUS_Assistance_Information_iE_Extensions),
        ])
    WUS_Assistance_Information._ext = []
    
    #-----< WUS-Assistance-Information-ExtIEs >-----#
    WUS_Assistance_Information_ExtIEs = CLASS(name='WUS-Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    WUS_Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2TNLConfigurationInfo >-----#
    X2TNLConfigurationInfo = SEQ(name='X2TNLConfigurationInfo', mode=MODE_TYPE)
    _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses = SEQ_OF(name='eNBX2TransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENBX2TLAs')))
    _X2TNLConfigurationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __X2TNLConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___X2TNLConfigurationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLAs')))
    _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBIndirectX2TransportLayerAddresses')))
    ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Extension', _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __X2TNLConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___X2TNLConfigurationInfo_iE_Extensions__item__id),
        ('criticality', ___X2TNLConfigurationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __X2TNLConfigurationInfo_iE_Extensions__item_._ext = None
    _X2TNLConfigurationInfo_iE_Extensions._cont = __X2TNLConfigurationInfo_iE_Extensions__item_
    _X2TNLConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    X2TNLConfigurationInfo._cont = ASN1Dict([
        ('eNBX2TransportLayerAddresses', _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses),
        ('iE-Extensions', _X2TNLConfigurationInfo_iE_Extensions),
        ])
    X2TNLConfigurationInfo._ext = []
    
    #-----< X2TNLConfigurationInfo-ExtIEs >-----#
    X2TNLConfigurationInfo_ExtIEs = CLASS(name='X2TNLConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _X2TNLConfigurationInfo_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLAs')))
    _X2TNLConfigurationInfo_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBIndirectX2TransportLayerAddresses')))
    X2TNLConfigurationInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Extension', _X2TNLConfigurationInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _X2TNLConfigurationInfo_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBX2ExtTLAs >-----#
    ENBX2ExtTLAs = SEQ_OF(name='ENBX2ExtTLAs', mode=MODE_TYPE)
    _ENBX2ExtTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLA')))
    ENBX2ExtTLAs._cont = _ENBX2ExtTLAs__item_
    ENBX2ExtTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ENBX2ExtTLA >-----#
    ENBX2ExtTLA = SEQ(name='ENBX2ExtTLA', mode=MODE_TYPE)
    _ENBX2ExtTLA_iPsecTLA = BIT_STR(name='iPsecTLA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _ENBX2ExtTLA_gTPTLAa = SEQ_OF(name='gTPTLAa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENBX2GTPTLAs')), opt=True)
    _ENBX2ExtTLA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENBX2ExtTLA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENBX2ExtTLA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____ENBX2ExtTLA_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__id_tab
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab_at = None
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab_id = 'id'
    ___ENBX2ExtTLA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ENBX2ExtTLA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ENBX2ExtTLA_iE_Extensions__item__id),
        ('criticality', ___ENBX2ExtTLA_iE_Extensions__item__criticality),
        ('extensionValue', ___ENBX2ExtTLA_iE_Extensions__item__extensionValue),
        ])
    __ENBX2ExtTLA_iE_Extensions__item_._ext = None
    _ENBX2ExtTLA_iE_Extensions._cont = __ENBX2ExtTLA_iE_Extensions__item_
    _ENBX2ExtTLA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENBX2ExtTLA._cont = ASN1Dict([
        ('iPsecTLA', _ENBX2ExtTLA_iPsecTLA),
        ('gTPTLAa', _ENBX2ExtTLA_gTPTLAa),
        ('iE-Extensions', _ENBX2ExtTLA_iE_Extensions),
        ])
    ENBX2ExtTLA._ext = []
    
    #-----< ENBX2ExtTLA-ExtIEs >-----#
    ENBX2ExtTLA_ExtIEs = CLASS(name='ENBX2ExtTLA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENBX2ExtTLA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENBX2GTPTLAs >-----#
    ENBX2GTPTLAs = SEQ_OF(name='ENBX2GTPTLAs', mode=MODE_TYPE)
    _ENBX2GTPTLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBX2GTPTLAs._cont = _ENBX2GTPTLAs__item_
    ENBX2GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ENBIndirectX2TransportLayerAddresses >-----#
    ENBIndirectX2TransportLayerAddresses = SEQ_OF(name='ENBIndirectX2TransportLayerAddresses', mode=MODE_TYPE)
    _ENBIndirectX2TransportLayerAddresses__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBIndirectX2TransportLayerAddresses._cont = _ENBIndirectX2TransportLayerAddresses__item_
    ENBIndirectX2TransportLayerAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    _all_ = [
        _Additional_GUTI_gUMMEI,
        _Additional_GUTI_m_TMSI,
        ____Additional_GUTI_iE_Extensions__item__id_tab,
        ___Additional_GUTI_iE_Extensions__item__id,
        ____Additional_GUTI_iE_Extensions__item__criticality_tab,
        ___Additional_GUTI_iE_Extensions__item__criticality,
        ____Additional_GUTI_iE_Extensions__item__extensionValue_tab,
        ___Additional_GUTI_iE_Extensions__item__extensionValue,
        __Additional_GUTI_iE_Extensions__item_,
        _Additional_GUTI_iE_Extensions,
        Additional_GUTI,
        Additional_GUTI_ExtIEs,
        AdditionalRRMPriorityIndex,
        AerialUEsubscriptionInformation,
        _AreaScopeOfMDT_cellBased,
        _AreaScopeOfMDT_tABased,
        _AreaScopeOfMDT_pLMNWide,
        _AreaScopeOfMDT_tAIBased,
        AreaScopeOfMDT,
        _AreaScopeOfQMC_cellBased,
        _AreaScopeOfQMC_tABased,
        _AreaScopeOfQMC_tAIBased,
        _AreaScopeOfQMC_pLMNAreaBased,
        AreaScopeOfQMC,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__id,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue,
        __AssistanceDataForCECapableUEs_iE_Extensions__item_,
        _AssistanceDataForCECapableUEs_iE_Extensions,
        AssistanceDataForCECapableUEs,
        InformationForCECapableUEs_ExtIEs,
        _AssistanceDataForPaging_assistanceDataForRecommendedCells,
        _AssistanceDataForPaging_assistanceDataForCECapableUEs,
        _AssistanceDataForPaging_pagingAttemptInformation,
        ____AssistanceDataForPaging_iE_Extensions__item__id_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__id,
        ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__criticality,
        ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__extensionValue,
        __AssistanceDataForPaging_iE_Extensions__item_,
        _AssistanceDataForPaging_iE_Extensions,
        AssistanceDataForPaging,
        AssistanceDataForPaging_ExtIEs,
        _AssistanceDataForRecommendedCells_recommendedCellsForPaging,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__id,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue,
        __AssistanceDataForRecommendedCells_iE_Extensions__item_,
        _AssistanceDataForRecommendedCells_iE_Extensions,
        AssistanceDataForRecommendedCells,
        AssistanceDataForRecommendedCells_ExtIEs,
        ___Bearers_SubjectToStatusTransferList__item__id_tab,
        ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0,
        __Bearers_SubjectToStatusTransferList__item__id,
        __Bearers_SubjectToStatusTransferList__item__criticality,
        __Bearers_SubjectToStatusTransferList__item__value,
        _Bearers_SubjectToStatusTransferList__item_,
        Bearers_SubjectToStatusTransferList,
        Bearers_SubjectToStatusTransfer_ItemIEs,
        _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0,
        _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID,
        _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue,
        _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue,
        _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs,
        ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_,
        _Bearers_SubjectToStatusTransfer_Item_iE_Extensions,
        Bearers_SubjectToStatusTransfer_Item,
        Bearers_SubjectToStatusTransfer_ItemExtIEs,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5,
        ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab,
        ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0,
        __Bearers_SubjectToEarlyStatusTransferList__item__id,
        __Bearers_SubjectToEarlyStatusTransferList__item__criticality,
        __Bearers_SubjectToEarlyStatusTransferList__item__value,
        _Bearers_SubjectToEarlyStatusTransferList__item_,
        Bearers_SubjectToEarlyStatusTransferList,
        Bearers_SubjectToEarlyStatusTransfer_ItemIEs,
        _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0,
        _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID,
        _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_,
        _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions,
        Bearers_SubjectToEarlyStatusTransfer_Item,
        Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs,
        BearerType,
        BitRate,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfig,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList,
        _BluetoothMeasurementConfiguration_bt_rssi,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__id,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __BluetoothMeasurementConfiguration_iE_Extensions__item_,
        _BluetoothMeasurementConfiguration_iE_Extensions,
        BluetoothMeasurementConfiguration,
        BluetoothMeasurementConfiguration_ExtIEs,
        _BluetoothMeasConfigNameList__item_,
        BluetoothMeasConfigNameList,
        BluetoothMeasConfig,
        BluetoothName,
        _BPLMNs__item_,
        BPLMNs,
        _BroadcastCancelledAreaList_cellID_Cancelled,
        _BroadcastCancelledAreaList_tAI_Cancelled,
        _BroadcastCancelledAreaList_emergencyAreaID_Cancelled,
        BroadcastCancelledAreaList,
        _BroadcastCompletedAreaList_cellID_Broadcast,
        _BroadcastCompletedAreaList_tAI_Broadcast,
        _BroadcastCompletedAreaList_emergencyAreaID_Broadcast,
        BroadcastCompletedAreaList,
        _CancelledCellinEAI__item_,
        CancelledCellinEAI,
        _CancelledCellinEAI_Item_eCGI,
        _CancelledCellinEAI_Item_numberOfBroadcasts,
        ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__id,
        ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__criticality,
        ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue,
        __CancelledCellinEAI_Item_iE_Extensions__item_,
        _CancelledCellinEAI_Item_iE_Extensions,
        CancelledCellinEAI_Item,
        CancelledCellinEAI_Item_ExtIEs,
        _CancelledCellinTAI__item_,
        CancelledCellinTAI,
        _CancelledCellinTAI_Item_eCGI,
        _CancelledCellinTAI_Item_numberOfBroadcasts,
        ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__id,
        ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__criticality,
        ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue,
        __CancelledCellinTAI_Item_iE_Extensions__item_,
        _CancelledCellinTAI_Item_iE_Extensions,
        CancelledCellinTAI_Item,
        CancelledCellinTAI_Item_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_nas,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        CauseNas,
        CellAccessMode,
        _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID,
        _CellIdentifierAndCELevelForCECapableUEs_cELevel,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue,
        __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_,
        _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions,
        CellIdentifierAndCELevelForCECapableUEs,
        CellIdentifierAndCELevelForCECapableUEs_ExtIEs,
        CELevel,
        CE_mode_B_SupportIndicator,
        CellIdentity,
        _CellID_Broadcast__item_,
        CellID_Broadcast,
        _CellID_Broadcast_Item_eCGI,
        ____CellID_Broadcast_Item_iE_Extensions__item__id_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__id,
        ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__criticality,
        ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue,
        __CellID_Broadcast_Item_iE_Extensions__item_,
        _CellID_Broadcast_Item_iE_Extensions,
        CellID_Broadcast_Item,
        CellID_Broadcast_Item_ExtIEs,
        _CellID_Cancelled__item_,
        CellID_Cancelled,
        _CellID_Cancelled_Item_eCGI,
        _CellID_Cancelled_Item_numberOfBroadcasts,
        ____CellID_Cancelled_Item_iE_Extensions__item__id_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__id,
        ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__criticality,
        ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue,
        __CellID_Cancelled_Item_iE_Extensions__item_,
        _CellID_Cancelled_Item_iE_Extensions,
        CellID_Cancelled_Item,
        CellID_Cancelled_Item_ExtIEs,
        _CellBasedMDT_cellIdListforMDT,
        ____CellBasedMDT_iE_Extensions__item__id_tab,
        ___CellBasedMDT_iE_Extensions__item__id,
        ____CellBasedMDT_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_iE_Extensions__item__criticality,
        ____CellBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_iE_Extensions__item__extensionValue,
        __CellBasedMDT_iE_Extensions__item_,
        _CellBasedMDT_iE_Extensions,
        CellBasedMDT,
        CellBasedMDT_ExtIEs,
        _CellIdListforMDT__item_,
        CellIdListforMDT,
        _CellBasedQMC_cellIdListforQMC,
        ____CellBasedQMC_iE_Extensions__item__id_tab,
        ___CellBasedQMC_iE_Extensions__item__id,
        ____CellBasedQMC_iE_Extensions__item__criticality_tab,
        ___CellBasedQMC_iE_Extensions__item__criticality,
        ____CellBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___CellBasedQMC_iE_Extensions__item__extensionValue,
        __CellBasedQMC_iE_Extensions__item_,
        _CellBasedQMC_iE_Extensions,
        CellBasedQMC,
        CellBasedQMC_ExtIEs,
        _CellIdListforQMC__item_,
        CellIdListforQMC,
        Cdma2000PDU,
        Cdma2000RATType,
        Cdma2000SectorID,
        Cdma2000HOStatus,
        Cdma2000HORequiredIndication,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue,
        __Cdma2000OneXSRVCCInfo_iE_Extensions__item_,
        _Cdma2000OneXSRVCCInfo_iE_Extensions,
        Cdma2000OneXSRVCCInfo,
        Cdma2000OneXSRVCCInfo_ExtIEs,
        Cdma2000OneXMEID,
        Cdma2000OneXMSI,
        Cdma2000OneXPilot,
        Cdma2000OneXRAND,
        Cell_Size,
        _CellType_cell_Size,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        _CGI_pLMNidentity,
        _CGI_lAC,
        _CGI_cI,
        _CGI_rAC,
        ____CGI_iE_Extensions__item__id_tab,
        ___CGI_iE_Extensions__item__id,
        ____CGI_iE_Extensions__item__criticality_tab,
        ___CGI_iE_Extensions__item__criticality,
        ____CGI_iE_Extensions__item__extensionValue_tab,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        CGI_ExtIEs,
        CI,
        CNDomain,
        _CNTypeRestrictions__item_,
        CNTypeRestrictions,
        _CNTypeRestrictions_Item_pLMN_Identity,
        _CNTypeRestrictions_Item_cNType,
        ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__id,
        ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__criticality,
        ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue,
        __CNTypeRestrictions_Item_iE_Extensions__item_,
        _CNTypeRestrictions_Item_iE_Extensions,
        CNTypeRestrictions_Item,
        CNTypeRestrictions_Item_ExtIEs,
        CNType,
        ConcurrentWarningMessageIndicator,
        _ConnectedengNBList__item_,
        ConnectedengNBList,
        _ConnectedengNBItem_en_gNB_ID,
        _ConnectedengNBItem_supportedTAs,
        ____ConnectedengNBItem_iE_Extensions__item__id_tab,
        ___ConnectedengNBItem_iE_Extensions__item__id,
        ____ConnectedengNBItem_iE_Extensions__item__criticality_tab,
        ___ConnectedengNBItem_iE_Extensions__item__criticality,
        ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab,
        ___ConnectedengNBItem_iE_Extensions__item__extensionValue,
        __ConnectedengNBItem_iE_Extensions__item_,
        _ConnectedengNBItem_iE_Extensions,
        ConnectedengNBItem,
        ConnectedengNBItem_ExtIEs,
        _ContextatSource_sourceNG_RAN_node_ID,
        _ContextatSource_rAN_UE_NGAP_ID,
        ____ContextatSource_iE_Extensions__item__id_tab,
        ___ContextatSource_iE_Extensions__item__id,
        ____ContextatSource_iE_Extensions__item__criticality_tab,
        ___ContextatSource_iE_Extensions__item__criticality,
        ____ContextatSource_iE_Extensions__item__extensionValue_tab,
        ___ContextatSource_iE_Extensions__item__extensionValue,
        __ContextatSource_iE_Extensions__item_,
        _ContextatSource_iE_Extensions,
        ContextatSource,
        ContextatSource_ExtIEs,
        Correlation_ID,
        CSFallbackIndicator,
        AdditionalCSFallbackIndicator,
        CSG_Id,
        _CSG_IdList__item_,
        CSG_IdList,
        _CSG_IdList_Item_cSG_Id,
        ____CSG_IdList_Item_iE_Extensions__item__id_tab,
        ___CSG_IdList_Item_iE_Extensions__item__id,
        ____CSG_IdList_Item_iE_Extensions__item__criticality_tab,
        ___CSG_IdList_Item_iE_Extensions__item__criticality,
        ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab,
        ___CSG_IdList_Item_iE_Extensions__item__extensionValue,
        __CSG_IdList_Item_iE_Extensions__item_,
        _CSG_IdList_Item_iE_Extensions,
        CSG_IdList_Item,
        CSG_IdList_Item_ExtIEs,
        CSGMembershipStatus,
        _COUNTvalue_pDCP_SN,
        _COUNTvalue_hFN,
        ____COUNTvalue_iE_Extensions__item__id_tab,
        ___COUNTvalue_iE_Extensions__item__id,
        ____COUNTvalue_iE_Extensions__item__criticality_tab,
        ___COUNTvalue_iE_Extensions__item__criticality,
        ____COUNTvalue_iE_Extensions__item__extensionValue_tab,
        ___COUNTvalue_iE_Extensions__item__extensionValue,
        __COUNTvalue_iE_Extensions__item_,
        _COUNTvalue_iE_Extensions,
        COUNTvalue,
        COUNTvalue_ExtIEs,
        _COUNTValueExtended_pDCP_SNExtended,
        _COUNTValueExtended_hFNModified,
        ____COUNTValueExtended_iE_Extensions__item__id_tab,
        ___COUNTValueExtended_iE_Extensions__item__id,
        ____COUNTValueExtended_iE_Extensions__item__criticality_tab,
        ___COUNTValueExtended_iE_Extensions__item__criticality,
        ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueExtended_iE_Extensions__item__extensionValue,
        __COUNTValueExtended_iE_Extensions__item_,
        _COUNTValueExtended_iE_Extensions,
        COUNTValueExtended,
        COUNTValueExtended_ExtIEs,
        _COUNTvaluePDCP_SNlength18_pDCP_SNlength18,
        _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue,
        __COUNTvaluePDCP_SNlength18_iE_Extensions__item_,
        _COUNTvaluePDCP_SNlength18_iE_Extensions,
        COUNTvaluePDCP_SNlength18,
        COUNTvaluePDCP_SNlength18_ExtIEs,
        Coverage_Level,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        _DAPSRequestInfo_dAPSIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        ___DAPSResponseInfoList__item__id_tab,
        ____DAPSResponseInfoList__item__id_tab_val_Value_0,
        __DAPSResponseInfoList__item__id,
        __DAPSResponseInfoList__item__criticality,
        __DAPSResponseInfoList__item__value,
        _DAPSResponseInfoList__item_,
        DAPSResponseInfoList,
        DAPSResponseInfoListIEs,
        _DAPSResponseInfoListIEs_val_Value_0,
        _DAPSResponseInfoItem_e_RAB_ID,
        _DAPSResponseInfoItem_dAPSResponseInfo,
        ____DAPSResponseInfoItem_iE_Extensions__item__id_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__id,
        ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__criticality,
        ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue,
        __DAPSResponseInfoItem_iE_Extensions__item_,
        _DAPSResponseInfoItem_iE_Extensions,
        DAPSResponseInfoItem,
        DAPSResponseInfoItem_ExtIEs,
        _DAPSResponseInfo_dapsresponseindicator,
        ____DAPSResponseInfo_iE_Extensions__item__id_tab,
        ___DAPSResponseInfo_iE_Extensions__item__id,
        ____DAPSResponseInfo_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfo_iE_Extensions__item__criticality,
        ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfo_iE_Extensions__item__extensionValue,
        __DAPSResponseInfo_iE_Extensions__item_,
        _DAPSResponseInfo_iE_Extensions,
        DAPSResponseInfo,
        DAPSResponseInfo_ExtIEs,
        DataCodingScheme,
        DataSize,
        DCN_ID,
        _ServedDCNs__item_,
        ServedDCNs,
        _ServedDCNsItem_dCN_ID,
        _ServedDCNsItem_relativeDCNCapacity,
        ____ServedDCNsItem_iE_Extensions__item__id_tab,
        ___ServedDCNsItem_iE_Extensions__item__id,
        ____ServedDCNsItem_iE_Extensions__item__criticality_tab,
        ___ServedDCNsItem_iE_Extensions__item__criticality,
        ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab,
        ___ServedDCNsItem_iE_Extensions__item__extensionValue,
        __ServedDCNsItem_iE_Extensions__item_,
        _ServedDCNsItem_iE_Extensions,
        ServedDCNsItem,
        ServedDCNsItem_ExtIEs,
        _DL_CP_SecurityInformation_dl_NAS_MAC,
        ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__id,
        ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __DL_CP_SecurityInformation_iE_Extensions__item_,
        _DL_CP_SecurityInformation_iE_Extensions,
        DL_CP_SecurityInformation,
        DL_CP_SecurityInformation_ExtIEs,
        DL_Forwarding,
        DL_NAS_MAC,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18,
        DLCOUNT_PDCP_SNlength,
        Direct_Forwarding_Path_Availability,
        Data_Forwarding_Not_Possible,
        DLNASPDUDeliveryAckRequest,
        EARFCN,
        _ECGIList__item_,
        ECGIList,
        _PWSfailedECGIList__item_,
        PWSfailedECGIList,
        EDT_Session,
        _EmergencyAreaIDList__item_,
        EmergencyAreaIDList,
        EmergencyAreaID,
        _EmergencyAreaID_Broadcast__item_,
        EmergencyAreaID_Broadcast,
        _EmergencyAreaID_Broadcast_Item_emergencyAreaID,
        _EmergencyAreaID_Broadcast_Item_completedCellinEAI,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_,
        _EmergencyAreaID_Broadcast_Item_iE_Extensions,
        EmergencyAreaID_Broadcast_Item,
        EmergencyAreaID_Broadcast_Item_ExtIEs,
        _EmergencyAreaID_Cancelled__item_,
        EmergencyAreaID_Cancelled,
        _EmergencyAreaID_Cancelled_Item_emergencyAreaID,
        _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_,
        _EmergencyAreaID_Cancelled_Item_iE_Extensions,
        EmergencyAreaID_Cancelled_Item,
        EmergencyAreaID_Cancelled_Item_ExtIEs,
        _CompletedCellinEAI__item_,
        CompletedCellinEAI,
        _CompletedCellinEAI_Item_eCGI,
        ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__id,
        ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__criticality,
        ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue,
        __CompletedCellinEAI_Item_iE_Extensions__item_,
        _CompletedCellinEAI_Item_iE_Extensions,
        CompletedCellinEAI_Item,
        CompletedCellinEAI_Item_ExtIEs,
        _ECGI_List__item_,
        ECGI_List,
        _EmergencyAreaIDListForRestart__item_,
        EmergencyAreaIDListForRestart,
        EmergencyIndicator,
        _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions,
        ENB_EarlyStatusTransfer_TransparentContainer,
        ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ENB_ID,
        En_gNB_ID,
        _GERAN_Cell_ID_lAI,
        _GERAN_Cell_ID_rAC,
        _GERAN_Cell_ID_cI,
        ____GERAN_Cell_ID_iE_Extensions__item__id_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__id,
        ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__criticality,
        ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__extensionValue,
        __GERAN_Cell_ID_iE_Extensions__item_,
        _GERAN_Cell_ID_iE_Extensions,
        GERAN_Cell_ID,
        GERAN_Cell_ID_ExtIEs,
        _Global_ENB_ID_pLMNidentity,
        _Global_ENB_ID_eNB_ID,
        ____Global_ENB_ID_iE_Extensions__item__id_tab,
        ___Global_ENB_ID_iE_Extensions__item__id,
        ____Global_ENB_ID_iE_Extensions__item__criticality_tab,
        ___Global_ENB_ID_iE_Extensions__item__criticality,
        ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_ENB_ID_iE_Extensions__item__extensionValue,
        __Global_ENB_ID_iE_Extensions__item_,
        _Global_ENB_ID_iE_Extensions,
        Global_ENB_ID,
        GlobalENB_ID_ExtIEs,
        _Global_en_gNB_ID_pLMNidentity,
        _Global_en_gNB_ID_en_gNB_ID,
        ____Global_en_gNB_ID_iE_Extensions__item__id_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__id,
        ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__criticality,
        ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__extensionValue,
        __Global_en_gNB_ID_iE_Extensions__item_,
        _Global_en_gNB_ID_iE_Extensions,
        Global_en_gNB_ID,
        Global_en_gNB_ID_ExtIEs,
        _GUMMEIList__item_,
        GUMMEIList,
        _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_,
        _ENB_StatusTransfer_TransparentContainer_iE_Extensions,
        ENB_StatusTransfer_TransparentContainer,
        ENB_StatusTransfer_TransparentContainer_ExtIEs,
        ENB_UE_S1AP_ID,
        ENBname,
        _ENBX2TLAs__item_,
        ENBX2TLAs,
        EncryptionAlgorithms,
        _EN_DCSONConfigurationTransfer_transfertype,
        _EN_DCSONConfigurationTransfer_sONInformation,
        _EN_DCSONConfigurationTransfer_x2TNLConfigInfo,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __EN_DCSONConfigurationTransfer_iE_Extensions__item_,
        _EN_DCSONConfigurationTransfer_iE_Extensions,
        EN_DCSONConfigurationTransfer,
        EN_DCSONConfigurationTransfer_ExtIEs,
        _EN_DCSONTransferType_request,
        _EN_DCSONTransferType_reply,
        EN_DCSONTransferType,
        _EN_DCTransferTypeRequest_sourceeNB,
        _EN_DCTransferTypeRequest_targetengNB,
        _EN_DCTransferTypeRequest_targeteNB,
        _EN_DCTransferTypeRequest_associatedTAI,
        _EN_DCTransferTypeRequest_broadcast5GSTAI,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__id,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue,
        __EN_DCTransferTypeRequest_iE_Extensions__item_,
        _EN_DCTransferTypeRequest_iE_Extensions,
        EN_DCTransferTypeRequest,
        EN_DCTransferTypeRequest_ExtIEs,
        _EN_DCTransferTypeReply_sourceengNB,
        _EN_DCTransferTypeReply_targeteNB,
        ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__id,
        ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__criticality,
        ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue,
        __EN_DCTransferTypeReply_iE_Extensions__item_,
        _EN_DCTransferTypeReply_iE_Extensions,
        EN_DCTransferTypeReply,
        EN_DCTransferTypeReply_ExtIEs,
        _EN_DCSONeNBIdentification_globaleNBID,
        _EN_DCSONeNBIdentification_selectedTAI,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__id,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue,
        __EN_DCSONeNBIdentification_iE_Extensions__item_,
        _EN_DCSONeNBIdentification_iE_Extensions,
        EN_DCSONeNBIdentification,
        EN_DCSONeNBIdentification_ExtIEs,
        _EN_DCSONengNBIdentification_globalengNBID,
        _EN_DCSONengNBIdentification_selectedTAI,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__id,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue,
        __EN_DCSONengNBIdentification_iE_Extensions__item_,
        _EN_DCSONengNBIdentification_iE_Extensions,
        EN_DCSONengNBIdentification,
        EN_DCSONengNBIdentification_ExtIEs,
        EndIndication,
        EnhancedCoverageRestricted,
        CE_ModeBRestricted,
        _EPLMNs__item_,
        EPLMNs,
        EventType,
        E_RAB_ID,
        ___E_RABInformationList__item__id_tab,
        ____E_RABInformationList__item__id_tab_val_Value_0,
        __E_RABInformationList__item__id,
        __E_RABInformationList__item__criticality,
        __E_RABInformationList__item__value,
        _E_RABInformationList__item_,
        E_RABInformationList,
        E_RABInformationListIEs,
        _E_RABInformationListIEs_val_Value_0,
        _E_RABInformationListItem_e_RAB_ID,
        _E_RABInformationListItem_dL_Forwarding,
        ____E_RABInformationListItem_iE_Extensions__item__id_tab,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABInformationListItem_iE_Extensions__item__id,
        ___E_RABInformationListItem_iE_Extensions__item__criticality,
        ___E_RABInformationListItem_iE_Extensions__item__extensionValue,
        __E_RABInformationListItem_iE_Extensions__item_,
        _E_RABInformationListItem_iE_Extensions,
        E_RABInformationListItem,
        E_RABInformationListItem_ExtIEs,
        _E_RABInformationListItem_ExtIEs_val_Extension_0,
        _E_RABInformationListItem_ExtIEs_val_Extension_1,
        _E_RABInformationListItem_ExtIEs_val_Extension_2,
        _E_RABInformationListItem_ExtIEs_val_Extension_3,
        ___E_RABList__item__id_tab,
        ____E_RABList__item__id_tab_val_Value_0,
        __E_RABList__item__id,
        __E_RABList__item__criticality,
        __E_RABList__item__value,
        _E_RABList__item_,
        E_RABList,
        E_RABItemIEs,
        _E_RABItemIEs_val_Value_0,
        _E_RABItem_e_RAB_ID,
        _E_RABItem_cause,
        ____E_RABItem_iE_Extensions__item__id_tab,
        ___E_RABItem_iE_Extensions__item__id,
        ____E_RABItem_iE_Extensions__item__criticality_tab,
        ___E_RABItem_iE_Extensions__item__criticality,
        ____E_RABItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABItem_iE_Extensions__item__extensionValue,
        __E_RABItem_iE_Extensions__item_,
        _E_RABItem_iE_Extensions,
        E_RABItem,
        E_RABItem_ExtIEs,
        _E_RABLevelQoSParameters_qCI,
        _E_RABLevelQoSParameters_allocationRetentionPriority,
        _E_RABLevelQoSParameters_gbrQosInformation,
        ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab,
        _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABLevelQoSParameters_iE_Extensions__item__id,
        ___E_RABLevelQoSParameters_iE_Extensions__item__criticality,
        ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue,
        __E_RABLevelQoSParameters_iE_Extensions__item_,
        _E_RABLevelQoSParameters_iE_Extensions,
        E_RABLevelQoSParameters,
        ___E_RABSecurityResultList__item__id_tab,
        ____E_RABSecurityResultList__item__id_tab_val_Value_0,
        __E_RABSecurityResultList__item__id,
        __E_RABSecurityResultList__item__criticality,
        __E_RABSecurityResultList__item__value,
        _E_RABSecurityResultList__item_,
        E_RABSecurityResultList,
        E_RABSecurityResultListIEs,
        _E_RABSecurityResultListIEs_val_Value_0,
        _E_RABSecurityResultItem_e_RAB_ID,
        _E_RABSecurityResultItem_securityResult,
        ____E_RABSecurityResultItem_iE_Extensions__item__id_tab,
        ___E_RABSecurityResultItem_iE_Extensions__item__id,
        ____E_RABSecurityResultItem_iE_Extensions__item__criticality_tab,
        ___E_RABSecurityResultItem_iE_Extensions__item__criticality,
        ____E_RABSecurityResultItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABSecurityResultItem_iE_Extensions__item__extensionValue,
        __E_RABSecurityResultItem_iE_Extensions__item_,
        _E_RABSecurityResultItem_iE_Extensions,
        E_RABSecurityResultItem,
        E_RABSecurityResultItem_ExtIEs,
        ___E_RABUsageReportList__item__id_tab,
        ____E_RABUsageReportList__item__id_tab_val_Value_0,
        __E_RABUsageReportList__item__id,
        __E_RABUsageReportList__item__criticality,
        __E_RABUsageReportList__item__value,
        _E_RABUsageReportList__item_,
        E_RABUsageReportList,
        E_RABUsageReportItemIEs,
        _E_RABUsageReportItemIEs_val_Value_0,
        _E_RABUsageReportItem_startTimestamp,
        _E_RABUsageReportItem_endTimestamp,
        _E_RABUsageReportItem_usageCountUL,
        _E_RABUsageReportItem_usageCountDL,
        ____E_RABUsageReportItem_iE_Extensions__item__id_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__id,
        ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__criticality,
        ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__extensionValue,
        __E_RABUsageReportItem_iE_Extensions__item_,
        _E_RABUsageReportItem_iE_Extensions,
        E_RABUsageReportItem,
        E_RABUsageReportItem_ExtIEs,
        E_RABQoSParameters_ExtIEs,
        _E_RABQoSParameters_ExtIEs_val_Extension_0,
        _E_RABQoSParameters_ExtIEs_val_Extension_1,
        Ethernet_Type,
        _EUTRAN_CGI_pLMNidentity,
        _EUTRAN_CGI_cell_ID,
        ____EUTRAN_CGI_iE_Extensions__item__id_tab,
        ___EUTRAN_CGI_iE_Extensions__item__id,
        ____EUTRAN_CGI_iE_Extensions__item__criticality_tab,
        ___EUTRAN_CGI_iE_Extensions__item__criticality,
        ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_CGI_iE_Extensions__item__extensionValue,
        __EUTRAN_CGI_iE_Extensions__item_,
        _EUTRAN_CGI_iE_Extensions,
        EUTRAN_CGI,
        EUTRAN_CGI_ExtIEs,
        EUTRANRoundTripDelayEstimationInfo,
        _EventL1LoggedMDTConfig_l1Threshold,
        _EventL1LoggedMDTConfig_hysteresis,
        _EventL1LoggedMDTConfig_timeToTrigger,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__id,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue,
        __EventL1LoggedMDTConfig_iE_Extensions__item_,
        _EventL1LoggedMDTConfig_iE_Extensions,
        EventL1LoggedMDTConfig,
        EventL1LoggedMDTConfig_ExtIEs,
        _EventTrigger_outOfCoverage,
        _EventTrigger_eventL1LoggedMDTConfig,
        ___EventTrigger_choice_Extensions_id_tab,
        __EventTrigger_choice_Extensions_id,
        ___EventTrigger_choice_Extensions_criticality_tab,
        __EventTrigger_choice_Extensions_criticality,
        ___EventTrigger_choice_Extensions_value_tab,
        __EventTrigger_choice_Extensions_value,
        _EventTrigger_choice_Extensions,
        EventTrigger,
        EventTrigger_ExtIEs,
        _ExpectedUEBehaviour_expectedActivity,
        _ExpectedUEBehaviour_expectedHOInterval,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        ExpectedActivityPeriod,
        ExpectedIdlePeriod,
        SourceOfUEActivityBehaviourInformation,
        ExpectedHOInterval,
        ExtendedBitRate,
        ExtendedRNC_ID,
        ExtendedRepetitionPeriod,
        Extended_UEIdentityIndexValue,
        FiveGSTAC,
        _FiveGSTAI_pLMNidentity,
        _FiveGSTAI_fiveGSTAC,
        ____FiveGSTAI_iE_Extensions__item__id_tab,
        ___FiveGSTAI_iE_Extensions__item__id,
        ____FiveGSTAI_iE_Extensions__item__criticality_tab,
        ___FiveGSTAI_iE_Extensions__item__criticality,
        ____FiveGSTAI_iE_Extensions__item__extensionValue_tab,
        ___FiveGSTAI_iE_Extensions__item__extensionValue,
        __FiveGSTAI_iE_Extensions__item_,
        _FiveGSTAI_iE_Extensions,
        FiveGSTAI,
        FiveGSTAI_ExtIEs,
        FiveQI,
        ForbiddenInterRATs,
        _ForbiddenTAs__item_,
        ForbiddenTAs,
        _ForbiddenTAs_Item_pLMN_Identity,
        _ForbiddenTAs_Item_forbiddenTACs,
        ____ForbiddenTAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__id,
        ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenTAs_Item_iE_Extensions__item_,
        _ForbiddenTAs_Item_iE_Extensions,
        ForbiddenTAs_Item,
        ForbiddenTAs_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _ForbiddenLAs__item_,
        ForbiddenLAs,
        _ForbiddenLAs_Item_pLMN_Identity,
        _ForbiddenLAs_Item_forbiddenLACs,
        ____ForbiddenLAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__id,
        ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenLAs_Item_iE_Extensions__item_,
        _ForbiddenLAs_Item_iE_Extensions,
        ForbiddenLAs_Item,
        ForbiddenLAs_Item_ExtIEs,
        _ForbiddenLACs__item_,
        ForbiddenLACs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QosInformation_ExtIEs_val_Extension_0,
        _GBR_QosInformation_ExtIEs_val_Extension_1,
        _GBR_QosInformation_ExtIEs_val_Extension_2,
        _GBR_QosInformation_ExtIEs_val_Extension_3,
        GTP_TEID,
        _GUMMEI_pLMN_Identity,
        _GUMMEI_mME_Group_ID,
        _GUMMEI_mME_Code,
        ____GUMMEI_iE_Extensions__item__id_tab,
        ___GUMMEI_iE_Extensions__item__id,
        ____GUMMEI_iE_Extensions__item__criticality_tab,
        ___GUMMEI_iE_Extensions__item__criticality,
        ____GUMMEI_iE_Extensions__item__extensionValue_tab,
        ___GUMMEI_iE_Extensions__item__extensionValue,
        __GUMMEI_iE_Extensions__item_,
        _GUMMEI_iE_Extensions,
        GUMMEI,
        GUMMEI_ExtIEs,
        GUMMEIType,
        GWContextReleaseIndication,
        HandoverFlag,
        _HandoverRestrictionList_servingPLMN,
        _HandoverRestrictionList_equivalentPLMNs,
        _HandoverRestrictionList_forbiddenTAs,
        _HandoverRestrictionList_forbiddenLAs,
        _HandoverRestrictionList_forbiddenInterRATs,
        ____HandoverRestrictionList_iE_Extensions__item__id_tab,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5,
        ___HandoverRestrictionList_iE_Extensions__item__id,
        ___HandoverRestrictionList_iE_Extensions__item__criticality,
        ___HandoverRestrictionList_iE_Extensions__item__extensionValue,
        __HandoverRestrictionList_iE_Extensions__item_,
        _HandoverRestrictionList_iE_Extensions,
        HandoverRestrictionList,
        HandoverRestrictionList_ExtIEs,
        _HandoverRestrictionList_ExtIEs_val_Extension_0,
        _HandoverRestrictionList_ExtIEs_val_Extension_1,
        _HandoverRestrictionList_ExtIEs_val_Extension_2,
        _HandoverRestrictionList_ExtIEs_val_Extension_3,
        _HandoverRestrictionList_ExtIEs_val_Extension_4,
        _HandoverRestrictionList_ExtIEs_val_Extension_5,
        HandoverType,
        HFN,
        HFNModified,
        HFNforPDCP_SNlength18,
        Hysteresis,
        Masked_IMEISV,
        _ImmediateMDT_measurementsToActivate,
        _ImmediateMDT_m1reportingTrigger,
        _ImmediateMDT_m1thresholdeventA2,
        _ImmediateMDT_m1periodicReporting,
        ____ImmediateMDT_iE_Extensions__item__id_tab,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_8,
        ___ImmediateMDT_iE_Extensions__item__id,
        ___ImmediateMDT_iE_Extensions__item__criticality,
        ___ImmediateMDT_iE_Extensions__item__extensionValue,
        __ImmediateMDT_iE_Extensions__item_,
        _ImmediateMDT_iE_Extensions,
        ImmediateMDT,
        ImmediateMDT_ExtIEs,
        _ImmediateMDT_ExtIEs_val_Extension_0,
        _ImmediateMDT_ExtIEs_val_Extension_1,
        _ImmediateMDT_ExtIEs_val_Extension_2,
        _ImmediateMDT_ExtIEs_val_Extension_3,
        _ImmediateMDT_ExtIEs_val_Extension_4,
        _ImmediateMDT_ExtIEs_val_Extension_5,
        _ImmediateMDT_ExtIEs_val_Extension_6,
        _ImmediateMDT_ExtIEs_val_Extension_7,
        _ImmediateMDT_ExtIEs_val_Extension_8,
        IMSI,
        _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging,
        _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue,
        __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_,
        _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions,
        InformationOnRecommendedCellsAndENBsForPaging,
        InformationOnRecommendedCellsAndENBsForPaging_ExtIEs,
        IntegrityProtectionAlgorithms,
        IntegrityProtectionIndication,
        IntegrityProtectionResult,
        IntendedNumberOfPagingAttempts,
        InterfacesToTrace,
        _IntersystemMeasurementConfiguration_rSRP,
        _IntersystemMeasurementConfiguration_rSRQ,
        _IntersystemMeasurementConfiguration_sINR,
        _IntersystemMeasurementConfiguration_interSystemMeasurementParameters,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__id,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __IntersystemMeasurementConfiguration_iE_Extensions__item_,
        _IntersystemMeasurementConfiguration_iE_Extensions,
        IntersystemMeasurementConfiguration,
        IntersystemMeasurementConfiguration_ExtIEs,
        _InterSystemMeasurementParameters_measurementDuration,
        _InterSystemMeasurementParameters_interSystemMeasurementList,
        ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__id,
        ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__criticality,
        ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue,
        __InterSystemMeasurementParameters_iE_Extensions__item_,
        _InterSystemMeasurementParameters_iE_Extensions,
        InterSystemMeasurementParameters,
        InterSystemMeasurementParameters_ExtIEs,
        _InterSystemMeasurementList__item_,
        InterSystemMeasurementList,
        _InterSystemMeasurementItem_freqBandIndicatorNR,
        _InterSystemMeasurementItem_sSBfrequencies,
        _InterSystemMeasurementItem_subcarrierSpacingSSB,
        _InterSystemMeasurementItem_maxRSIndexCellQual,
        _InterSystemMeasurementItem_sMTC,
        _InterSystemMeasurementItem_threshRS_Index_r15,
        _InterSystemMeasurementItem_sSBToMeasure,
        _InterSystemMeasurementItem_sSRSSIMeasurement,
        _InterSystemMeasurementItem_quantityConfigNR_R15,
        _InterSystemMeasurementItem_excludedCellsToAddModList,
        ____InterSystemMeasurementItem_iE_Extensions__item__id_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__id,
        ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__criticality,
        ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue,
        __InterSystemMeasurementItem_iE_Extensions__item_,
        _InterSystemMeasurementItem_iE_Extensions,
        InterSystemMeasurementItem,
        InterSystemMeasurementItem_ExtIEs,
        IntersystemSONConfigurationTransfer,
        IMSvoiceEPSfallbackfrom5G,
        IAB_Authorized,
        IAB_Node_Indication,
        IAB_Supported,
        KillAllWarningMessages,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastVisitedCell_Item_e_UTRAN_Cell,
        _LastVisitedCell_Item_uTRAN_Cell,
        _LastVisitedCell_Item_gERAN_Cell,
        _LastVisitedCell_Item_nG_RAN_Cell,
        LastVisitedCell_Item,
        _LastVisitedEUTRANCellInformation_global_Cell_ID,
        _LastVisitedEUTRANCellInformation_cellType,
        _LastVisitedEUTRANCellInformation_time_UE_StayedInCell,
        ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedEUTRANCellInformation_iE_Extensions__item_,
        _LastVisitedEUTRANCellInformation_iE_Extensions,
        LastVisitedEUTRANCellInformation,
        LastVisitedEUTRANCellInformation_ExtIEs,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2,
        _LastVisitedPSCellList__item_,
        LastVisitedPSCellList,
        _LastVisitedPSCellInformation_pSCellID,
        _LastVisitedPSCellInformation_timeStay,
        ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__id,
        ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__criticality,
        ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedPSCellInformation_iE_Extensions__item_,
        _LastVisitedPSCellInformation_iE_Extensions,
        LastVisitedPSCellInformation,
        LastVisitedPSCellInformation_ExtIEs,
        LastVisitedNGRANCellInformation,
        LastVisitedUTRANCellInformation,
        _LastVisitedGERANCellInformation_undefined,
        LastVisitedGERANCellInformation,
        L3_Information,
        LPPa_PDU,
        LHN_ID,
        Links_to_log,
        _ListeningSubframePattern_pattern_period,
        _ListeningSubframePattern_pattern_offset,
        ____ListeningSubframePattern_iE_Extensions__item__id_tab,
        ___ListeningSubframePattern_iE_Extensions__item__id,
        ____ListeningSubframePattern_iE_Extensions__item__criticality_tab,
        ___ListeningSubframePattern_iE_Extensions__item__criticality,
        ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab,
        ___ListeningSubframePattern_iE_Extensions__item__extensionValue,
        __ListeningSubframePattern_iE_Extensions__item_,
        _ListeningSubframePattern_iE_Extensions,
        ListeningSubframePattern,
        ListeningSubframePattern_ExtIEs,
        _LoggedMDT_loggingInterval,
        _LoggedMDT_loggingDuration,
        ____LoggedMDT_iE_Extensions__item__id_tab,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_2,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_3,
        ___LoggedMDT_iE_Extensions__item__id,
        ___LoggedMDT_iE_Extensions__item__criticality,
        ___LoggedMDT_iE_Extensions__item__extensionValue,
        __LoggedMDT_iE_Extensions__item_,
        _LoggedMDT_iE_Extensions,
        LoggedMDT,
        LoggedMDT_ExtIEs,
        _LoggedMDT_ExtIEs_val_Extension_0,
        _LoggedMDT_ExtIEs_val_Extension_1,
        _LoggedMDT_ExtIEs_val_Extension_2,
        _LoggedMDT_ExtIEs_val_Extension_3,
        LoggingInterval,
        LoggingDuration,
        _LoggedMBSFNMDT_loggingInterval,
        _LoggedMBSFNMDT_loggingDuration,
        _LoggedMBSFNMDT_mBSFN_ResultToLog,
        ____LoggedMBSFNMDT_iE_Extensions__item__id_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__id,
        ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__criticality,
        ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue,
        __LoggedMBSFNMDT_iE_Extensions__item_,
        _LoggedMBSFNMDT_iE_Extensions,
        LoggedMBSFNMDT,
        LoggedMBSFNMDT_ExtIEs,
        _LoggedMDTTrigger_periodical,
        _LoggedMDTTrigger_eventTrigger,
        LoggedMDTTrigger,
        LTE_M_Indication,
        _LTE_NTN_TAI_Information_servingPLMN,
        _LTE_NTN_TAI_Information_tACList_In_LTE_NTN,
        _LTE_NTN_TAI_Information_uE_Location_Derived_TAC,
        ____LTE_NTN_TAI_Information_iE_Extensions__item__id_tab,
        ___LTE_NTN_TAI_Information_iE_Extensions__item__id,
        ____LTE_NTN_TAI_Information_iE_Extensions__item__criticality_tab,
        ___LTE_NTN_TAI_Information_iE_Extensions__item__criticality,
        ____LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue_tab,
        ___LTE_NTN_TAI_Information_iE_Extensions__item__extensionValue,
        __LTE_NTN_TAI_Information_iE_Extensions__item_,
        _LTE_NTN_TAI_Information_iE_Extensions,
        LTE_NTN_TAI_Information,
        LTE_NTN_TAI_Information_ExtIEs,
        _M3Configuration_m3period,
        ____M3Configuration_iE_Extensions__item__id_tab,
        ___M3Configuration_iE_Extensions__item__id,
        ____M3Configuration_iE_Extensions__item__criticality_tab,
        ___M3Configuration_iE_Extensions__item__criticality,
        ____M3Configuration_iE_Extensions__item__extensionValue_tab,
        ___M3Configuration_iE_Extensions__item__extensionValue,
        __M3Configuration_iE_Extensions__item_,
        _M3Configuration_iE_Extensions,
        M3Configuration,
        M3Configuration_ExtIEs,
        M3period,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        ___M4Configuration_iE_Extensions__item__id,
        ____M4Configuration_iE_Extensions__item__criticality_tab,
        ___M4Configuration_iE_Extensions__item__criticality,
        ____M4Configuration_iE_Extensions__item__extensionValue_tab,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ____M5Configuration_iE_Extensions__item__criticality_tab,
        ___M5Configuration_iE_Extensions__item__criticality,
        ____M5Configuration_iE_Extensions__item__extensionValue_tab,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6delay_threshold,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ____M6Configuration_iE_Extensions__item__criticality_tab,
        ___M6Configuration_iE_Extensions__item__criticality,
        ____M6Configuration_iE_Extensions__item__extensionValue_tab,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_Interval,
        M6delay_threshold,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ____M7Configuration_iE_Extensions__item__criticality_tab,
        ___M7Configuration_iE_Extensions__item__criticality,
        ____M7Configuration_iE_Extensions__item__extensionValue_tab,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        MDT_Activation,
        MDT_Location_Info,
        _MDT_Configuration_mdt_Activation,
        _MDT_Configuration_areaScopeOfMDT,
        _MDT_Configuration_mDTMode,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        ManagementBasedMDTAllowed,
        _MBSFN_ResultToLog__item_,
        MBSFN_ResultToLog,
        _MBSFN_ResultToLogInfo_mBSFN_AreaId,
        _MBSFN_ResultToLogInfo_carrierFreq,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__id,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue,
        __MBSFN_ResultToLogInfo_iE_Extensions__item_,
        _MBSFN_ResultToLogInfo_iE_Extensions,
        MBSFN_ResultToLogInfo,
        MBSFN_ResultToLogInfo_ExtIEs,
        _MDTPLMNList__item_,
        MDTPLMNList,
        PrivacyIndicator,
        _MDTMode_immediateMDT,
        _MDTMode_loggedMDT,
        _MDTMode_mDTMode_Extension,
        MDTMode,
        __MDTMode_Extension_id_tab,
        ___MDTMode_Extension_id_tab_val_Value_0,
        _MDTMode_Extension_id,
        _MDTMode_Extension_criticality,
        _MDTMode_Extension_value,
        MDTMode_Extension,
        MDTMode_ExtensionIE,
        _MDTMode_ExtensionIE_val_Value_0,
        MeasurementsToActivate,
        _MeasurementThresholdA2_threshold_RSRP,
        _MeasurementThresholdA2_threshold_RSRQ,
        MeasurementThresholdA2,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRP,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRQ,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_id,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_value,
        _MeasurementThresholdL1LoggedMDT_choice_Extensions,
        MeasurementThresholdL1LoggedMDT,
        MeasurementThresholdL1LoggedMDT_ExtIEs,
        MessageIdentifier,
        MobilityInformation,
        MMEname,
        _MMEPagingTarget_global_ENB_ID,
        _MMEPagingTarget_tAI,
        MMEPagingTarget,
        MMERelaySupportIndicator,
        MME_Group_ID,
        MME_Code,
        MME_UE_S1AP_ID,
        M_TMSI,
        MSClassmark2,
        MSClassmark3,
        MutingAvailabilityIndication,
        _MutingPatternInformation_muting_pattern_period,
        _MutingPatternInformation_muting_pattern_offset,
        ____MutingPatternInformation_iE_Extensions__item__id_tab,
        ___MutingPatternInformation_iE_Extensions__item__id,
        ____MutingPatternInformation_iE_Extensions__item__criticality_tab,
        ___MutingPatternInformation_iE_Extensions__item__criticality,
        ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab,
        ___MutingPatternInformation_iE_Extensions__item__extensionValue,
        __MutingPatternInformation_iE_Extensions__item_,
        _MutingPatternInformation_iE_Extensions,
        MutingPatternInformation,
        MutingPatternInformation_ExtIEs,
        MDT_ConfigurationNR,
        NAS_PDU,
        NASSecurityParametersfromE_UTRAN,
        NASSecurityParameterstoE_UTRAN,
        NB_IoT_DefaultPagingDRX,
        NB_IoT_PagingDRX,
        _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle,
        _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue,
        __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_,
        _NB_IoT_Paging_eDRXInformation_iE_Extensions,
        NB_IoT_Paging_eDRXInformation,
        NB_IoT_Paging_eDRXInformation_ExtIEs,
        NB_IoT_Paging_eDRX_Cycle,
        NB_IoT_PagingTimeWindow,
        NB_IoT_RLF_Report_Container,
        NB_IoT_UEIdentityIndexValue,
        NextPagingAreaScope,
        NotifySourceeNB,
        NRCellIdentity,
        _NR_CGI_pLMNIdentity,
        _NR_CGI_nRCellIdentity,
        ____NR_CGI_iE_Extensions__item__id_tab,
        ___NR_CGI_iE_Extensions__item__id,
        ____NR_CGI_iE_Extensions__item__criticality_tab,
        ___NR_CGI_iE_Extensions__item__criticality,
        ____NR_CGI_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_iE_Extensions__item__extensionValue,
        __NR_CGI_iE_Extensions__item_,
        _NR_CGI_iE_Extensions,
        NR_CGI,
        NR_CGI_ExtIEs,
        NRencryptionAlgorithms,
        NRintegrityProtectionAlgorithms,
        NRrestrictioninEPSasSecondaryRAT,
        NRrestrictionin5GS,
        _NRUESecurityCapabilities_nRencryptionAlgorithms,
        _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms,
        ____NRUESecurityCapabilities_iE_Extensions__item__id_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__id,
        ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__criticality,
        ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue,
        __NRUESecurityCapabilities_iE_Extensions__item_,
        _NRUESecurityCapabilities_iE_Extensions,
        NRUESecurityCapabilities,
        NRUESecurityCapabilities_ExtIEs,
        NumberofBroadcastRequest,
        NumberOfBroadcasts,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        OldBSS_ToNewBSS_Information,
        OverloadAction,
        _OverloadResponse_overloadAction,
        OverloadResponse,
        Packet_LossRate,
        _PagingAttemptInformation_pagingAttemptCount,
        _PagingAttemptInformation_intendedNumberOfPagingAttempts,
        _PagingAttemptInformation_nextPagingAreaScope,
        ____PagingAttemptInformation_iE_Extensions__item__id_tab,
        ___PagingAttemptInformation_iE_Extensions__item__id,
        ____PagingAttemptInformation_iE_Extensions__item__criticality_tab,
        ___PagingAttemptInformation_iE_Extensions__item__criticality,
        ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab,
        ___PagingAttemptInformation_iE_Extensions__item__extensionValue,
        __PagingAttemptInformation_iE_Extensions__item_,
        _PagingAttemptInformation_iE_Extensions,
        PagingAttemptInformation,
        PagingAttemptInformation_ExtIEs,
        PagingAttemptCount,
        _Paging_eDRXInformation_paging_eDRX_Cycle,
        _Paging_eDRXInformation_pagingTimeWindow,
        ____Paging_eDRXInformation_iE_Extensions__item__id_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__id,
        ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__criticality,
        ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__extensionValue,
        __Paging_eDRXInformation_iE_Extensions__item_,
        _Paging_eDRXInformation_iE_Extensions,
        Paging_eDRXInformation,
        Paging_eDRXInformation_ExtIEs,
        Paging_eDRX_Cycle,
        PagingTimeWindow,
        PagingDRX,
        PagingPriority,
        PagingProbabilityInformation,
        PagingCause,
        _PC5QoSParameters_pc5QoSFlowList,
        _PC5QoSParameters_pc5LinkAggregatedBitRates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5QoSFlowList__item_,
        PC5QoSFlowList,
        _PC5QoSFlowItem_pQI,
        _PC5QoSFlowItem_pc5FlowBitRates,
        _PC5QoSFlowItem_range,
        ____PC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__id,
        ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__criticality,
        ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __PC5QoSFlowItem_iE_Extensions__item_,
        _PC5QoSFlowItem_iE_Extensions,
        PC5QoSFlowItem,
        PC5QoSFlowItem_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        PDCP_SN,
        PDCP_SNExtended,
        PDCP_SNlength18,
        PendingDataIndication,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ____M1PeriodicReporting_iE_Extensions__item__criticality_tab,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        PLMNidentity,
        _PLMNAreaBasedQMC_plmnListforQMC,
        ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__id,
        ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__criticality,
        ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue,
        __PLMNAreaBasedQMC_iE_Extensions__item_,
        _PLMNAreaBasedQMC_iE_Extensions,
        PLMNAreaBasedQMC,
        PLMNAreaBasedQMC_ExtIEs,
        _PLMNListforQMC__item_,
        PLMNListforQMC,
        Port_Number,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        _ProSeAuthorized_proSeDirectDiscovery,
        _ProSeAuthorized_proSeDirectCommunication,
        ____ProSeAuthorized_iE_Extensions__item__id_tab,
        _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0,
        ___ProSeAuthorized_iE_Extensions__item__id,
        ___ProSeAuthorized_iE_Extensions__item__criticality,
        ___ProSeAuthorized_iE_Extensions__item__extensionValue,
        __ProSeAuthorized_iE_Extensions__item_,
        _ProSeAuthorized_iE_Extensions,
        ProSeAuthorized,
        ProSeAuthorized_ExtIEs,
        _ProSeAuthorized_ExtIEs_val_Extension_0,
        ProSeDirectDiscovery,
        ProSeUEtoNetworkRelaying,
        ProSeDirectCommunication,
        PS_ServiceNotAvailable,
        _PSCellInformation_nCGI,
        ____PSCellInformation_iE_Extensions__item__id_tab,
        ___PSCellInformation_iE_Extensions__item__id,
        ____PSCellInformation_iE_Extensions__item__criticality_tab,
        ___PSCellInformation_iE_Extensions__item__criticality,
        ____PSCellInformation_iE_Extensions__item__extensionValue_tab,
        ___PSCellInformation_iE_Extensions__item__extensionValue,
        __PSCellInformation_iE_Extensions__item_,
        _PSCellInformation_iE_Extensions,
        PSCellInformation,
        PSCellInformation_ExtIEs,
        QCI,
        RACSIndication,
        RAN_UE_NGAP_ID,
        Range,
        ReceiveStatusofULPDCPSDUs,
        ReceiveStatusOfULPDCPSDUsExtended,
        ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        _RecommendedCellsForPaging_recommendedCellList,
        ____RecommendedCellsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__id,
        ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__criticality,
        ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedCellsForPaging_iE_Extensions__item_,
        _RecommendedCellsForPaging_iE_Extensions,
        RecommendedCellsForPaging,
        RecommendedCellsForPaging_ExtIEs,
        ___RecommendedCellList__item__id_tab,
        ____RecommendedCellList__item__id_tab_val_Value_0,
        __RecommendedCellList__item__id,
        __RecommendedCellList__item__criticality,
        __RecommendedCellList__item__value,
        _RecommendedCellList__item_,
        RecommendedCellList,
        RecommendedCellItemIEs,
        _RecommendedCellItemIEs_val_Value_0,
        _RecommendedCellItem_eUTRAN_CGI,
        _RecommendedCellItem_timeStayedInCell,
        ____RecommendedCellItem_iE_Extensions__item__id_tab,
        ___RecommendedCellItem_iE_Extensions__item__id,
        ____RecommendedCellItem_iE_Extensions__item__criticality_tab,
        ___RecommendedCellItem_iE_Extensions__item__criticality,
        ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellItem_iE_Extensions__item__extensionValue,
        __RecommendedCellItem_iE_Extensions__item_,
        _RecommendedCellItem_iE_Extensions,
        RecommendedCellItem,
        RecommendedCellsForPagingItem_ExtIEs,
        _RecommendedENBsForPaging_recommendedENBList,
        ____RecommendedENBsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__id,
        ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__criticality,
        ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedENBsForPaging_iE_Extensions__item_,
        _RecommendedENBsForPaging_iE_Extensions,
        RecommendedENBsForPaging,
        RecommendedENBsForPaging_ExtIEs,
        ___RecommendedENBList__item__id_tab,
        ____RecommendedENBList__item__id_tab_val_Value_0,
        __RecommendedENBList__item__id,
        __RecommendedENBList__item__criticality,
        __RecommendedENBList__item__value,
        _RecommendedENBList__item_,
        RecommendedENBList,
        RecommendedENBItemIEs,
        _RecommendedENBItemIEs_val_Value_0,
        _RecommendedENBItem_mMEPagingTarget,
        ____RecommendedENBItem_iE_Extensions__item__id_tab,
        ___RecommendedENBItem_iE_Extensions__item__id,
        ____RecommendedENBItem_iE_Extensions__item__criticality_tab,
        ___RecommendedENBItem_iE_Extensions__item__criticality,
        ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedENBItem_iE_Extensions__item__extensionValue,
        __RecommendedENBItem_iE_Extensions__item_,
        _RecommendedENBItem_iE_Extensions,
        RecommendedENBItem,
        RecommendedENBItem_ExtIEs,
        RelativeMMECapacity,
        RelayNode_Indicator,
        RAC,
        _RAT_Restrictions__item_,
        RAT_Restrictions,
        _RAT_RestrictionsItem_pLMNidentity,
        _RAT_RestrictionsItem_rAT_RestrictionInformation,
        ____RAT_RestrictionsItem_iE_Extensions__item__id_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__id,
        ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__criticality,
        ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue,
        __RAT_RestrictionsItem_iE_Extensions__item_,
        _RAT_RestrictionsItem_iE_Extensions,
        RAT_RestrictionsItem,
        RAT_RestrictionsItem_ExtIEs,
        RAT_Type,
        ReportAmountMDT,
        ReportIntervalMDT,
        M1ReportingTrigger,
        _RequestType_eventType,
        _RequestType_reportArea,
        ____RequestType_iE_Extensions__item__id_tab,
        _____RequestType_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestType_iE_Extensions__item__id,
        ___RequestType_iE_Extensions__item__criticality,
        ___RequestType_iE_Extensions__item__extensionValue,
        __RequestType_iE_Extensions__item_,
        _RequestType_iE_Extensions,
        RequestType,
        RequestType_ExtIEs,
        _RequestType_ExtIEs_val_Extension_0,
        RequestTypeAdditionalInfo,
        _RIMTransfer_rIMInformation,
        _RIMTransfer_rIMRoutingAddress,
        ____RIMTransfer_iE_Extensions__item__id_tab,
        ___RIMTransfer_iE_Extensions__item__id,
        ____RIMTransfer_iE_Extensions__item__criticality_tab,
        ___RIMTransfer_iE_Extensions__item__criticality,
        ____RIMTransfer_iE_Extensions__item__extensionValue_tab,
        ___RIMTransfer_iE_Extensions__item__extensionValue,
        __RIMTransfer_iE_Extensions__item_,
        _RIMTransfer_iE_Extensions,
        RIMTransfer,
        RIMTransfer_ExtIEs,
        RIMInformation,
        _RIMRoutingAddress_gERAN_Cell_ID,
        _RIMRoutingAddress_targetRNC_ID,
        _RIMRoutingAddress_eHRPD_Sector_ID,
        RIMRoutingAddress,
        ReportArea,
        RepetitionPeriod,
        _RLFReportInformation_uE_RLF_Report_Container,
        _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands,
        ____RLFReportInformation_iE_Extensions__item__id_tab,
        _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___RLFReportInformation_iE_Extensions__item__id,
        ___RLFReportInformation_iE_Extensions__item__criticality,
        ___RLFReportInformation_iE_Extensions__item__extensionValue,
        __RLFReportInformation_iE_Extensions__item_,
        _RLFReportInformation_iE_Extensions,
        RLFReportInformation,
        RLFReportInformation_ExtIEs,
        _RLFReportInformation_ExtIEs_val_Extension_0,
        RNC_ID,
        RRC_Container,
        RRC_Establishment_Cause,
        _ECGIListForRestart__item_,
        ECGIListForRestart,
        Routing_ID,
        SecurityKey,
        _SecurityContext_nextHopChainingCount,
        _SecurityContext_nextHopParameter,
        ____SecurityContext_iE_Extensions__item__id_tab,
        ___SecurityContext_iE_Extensions__item__id,
        ____SecurityContext_iE_Extensions__item__criticality_tab,
        ___SecurityContext_iE_Extensions__item__criticality,
        ____SecurityContext_iE_Extensions__item__extensionValue_tab,
        ___SecurityContext_iE_Extensions__item__extensionValue,
        __SecurityContext_iE_Extensions__item_,
        _SecurityContext_iE_Extensions,
        SecurityContext,
        SecurityContext_ExtIEs,
        SecondaryRATType,
        SecondaryRATDataUsageRequest,
        ___SecondaryRATDataUsageReportList__item__id_tab,
        ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0,
        __SecondaryRATDataUsageReportList__item__id,
        __SecondaryRATDataUsageReportList__item__criticality,
        __SecondaryRATDataUsageReportList__item__value,
        _SecondaryRATDataUsageReportList__item_,
        SecondaryRATDataUsageReportList,
        SecondaryRATDataUsageReportItemIEs,
        _SecondaryRATDataUsageReportItemIEs_val_Value_0,
        _SecondaryRATDataUsageReportItem_e_RAB_ID,
        _SecondaryRATDataUsageReportItem_secondaryRATType,
        _SecondaryRATDataUsageReportItem_e_RABUsageReportList,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue,
        __SecondaryRATDataUsageReportItem_iE_Extensions__item_,
        _SecondaryRATDataUsageReportItem_iE_Extensions,
        SecondaryRATDataUsageReportItem,
        SecondaryRATDataUsageReportItem_ExtIEs,
        _SecurityIndication_integrityProtectionIndication,
        ____SecurityIndication_iE_Extensions__item__id_tab,
        ___SecurityIndication_iE_Extensions__item__id,
        ____SecurityIndication_iE_Extensions__item__criticality_tab,
        ___SecurityIndication_iE_Extensions__item__criticality,
        ____SecurityIndication_iE_Extensions__item__extensionValue_tab,
        ___SecurityIndication_iE_Extensions__item__extensionValue,
        __SecurityIndication_iE_Extensions__item_,
        _SecurityIndication_iE_Extensions,
        SecurityIndication,
        SecurityIndication_ExtIEs,
        _SecurityResult_integrityProtectionResult,
        ____SecurityResult_iE_Extensions__item__id_tab,
        ___SecurityResult_iE_Extensions__item__id,
        ____SecurityResult_iE_Extensions__item__criticality_tab,
        ___SecurityResult_iE_Extensions__item__criticality,
        ____SecurityResult_iE_Extensions__item__extensionValue_tab,
        ___SecurityResult_iE_Extensions__item__extensionValue,
        __SecurityResult_iE_Extensions__item_,
        _SecurityResult_iE_Extensions,
        SecurityResult,
        SecurityResult_ExtIEs,
        SensorMeasConfig,
        _SensorMeasConfigNameItem_sensorNameConfig,
        ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__id,
        ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__criticality,
        ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __SensorMeasConfigNameItem_iE_Extensions__item_,
        _SensorMeasConfigNameItem_iE_Extensions,
        SensorMeasConfigNameItem,
        SensorMeasConfigNameItem_ExtIEs,
        _SensorMeasConfigNameList__item_,
        SensorMeasConfigNameList,
        _SensorMeasurementConfiguration_sensorMeasConfig,
        _SensorMeasurementConfiguration_sensorMeasConfigNameList,
        ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__id,
        ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__criticality,
        ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __SensorMeasurementConfiguration_iE_Extensions__item_,
        _SensorMeasurementConfiguration_iE_Extensions,
        SensorMeasurementConfiguration,
        SensorMeasurementConfiguration_ExtIEs,
        _SensorNameConfig_uncompensatedBarometricConfig,
        ___SensorNameConfig_choice_Extensions_id_tab,
        __SensorNameConfig_choice_Extensions_id,
        ___SensorNameConfig_choice_Extensions_criticality_tab,
        __SensorNameConfig_choice_Extensions_criticality,
        ___SensorNameConfig_choice_Extensions_value_tab,
        __SensorNameConfig_choice_Extensions_value,
        _SensorNameConfig_choice_Extensions,
        SensorNameConfig,
        SensorNameConfig_ExtIEs,
        SerialNumber,
        ServiceType,
        _SONInformation_sONInformationRequest,
        _SONInformation_sONInformationReply,
        _SONInformation_sONInformation_Extension,
        SONInformation,
        __SONInformation_Extension_id_tab,
        ___SONInformation_Extension_id_tab_val_Value_0,
        _SONInformation_Extension_id,
        _SONInformation_Extension_criticality,
        _SONInformation_Extension_value,
        SONInformation_Extension,
        SONInformation_ExtensionIE,
        _SONInformation_ExtensionIE_val_Value_0,
        SONInformationRequest,
        _SONInformationReply_x2TNLConfigurationInfo,
        ____SONInformationReply_iE_Extensions__item__id_tab,
        _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0,
        _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1,
        ___SONInformationReply_iE_Extensions__item__id,
        ___SONInformationReply_iE_Extensions__item__criticality,
        ___SONInformationReply_iE_Extensions__item__extensionValue,
        __SONInformationReply_iE_Extensions__item_,
        _SONInformationReply_iE_Extensions,
        SONInformationReply,
        SONInformationReply_ExtIEs,
        _SONInformationReply_ExtIEs_val_Extension_0,
        _SONInformationReply_ExtIEs_val_Extension_1,
        _SONInformationReport_rLFReportInformation,
        SONInformationReport,
        _SONConfigurationTransfer_targeteNB_ID,
        _SONConfigurationTransfer_sourceeNB_ID,
        _SONConfigurationTransfer_sONInformation,
        ____SONConfigurationTransfer_iE_Extensions__item__id_tab,
        _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___SONConfigurationTransfer_iE_Extensions__item__id,
        ___SONConfigurationTransfer_iE_Extensions__item__criticality,
        ___SONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __SONConfigurationTransfer_iE_Extensions__item_,
        _SONConfigurationTransfer_iE_Extensions,
        SONConfigurationTransfer,
        SONConfigurationTransfer_ExtIEs,
        _SONConfigurationTransfer_ExtIEs_val_Extension_0,
        _SONConfigurationTransfer_ExtIEs_val_Extension_1,
        _SynchronisationInformation_sourceStratumLevel,
        _SynchronisationInformation_listeningSubframePattern,
        _SynchronisationInformation_aggressoreCGI_List,
        ____SynchronisationInformation_iE_Extensions__item__id_tab,
        ___SynchronisationInformation_iE_Extensions__item__id,
        ____SynchronisationInformation_iE_Extensions__item__criticality_tab,
        ___SynchronisationInformation_iE_Extensions__item__criticality,
        ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab,
        ___SynchronisationInformation_iE_Extensions__item__extensionValue,
        __SynchronisationInformation_iE_Extensions__item_,
        _SynchronisationInformation_iE_Extensions,
        SynchronisationInformation,
        SynchronisationInformation_ExtIEs,
        Source_ToTarget_TransparentContainer,
        SourceBSS_ToTargetBSS_TransparentContainer,
        _SourceeNB_ID_global_ENB_ID,
        _SourceeNB_ID_selected_TAI,
        ____SourceeNB_ID_iE_Extensions__item__id_tab,
        ___SourceeNB_ID_iE_Extensions__item__id,
        ____SourceeNB_ID_iE_Extensions__item__criticality_tab,
        ___SourceeNB_ID_iE_Extensions__item__criticality,
        ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab,
        ___SourceeNB_ID_iE_Extensions__item__extensionValue,
        __SourceeNB_ID_iE_Extensions__item_,
        _SourceeNB_ID_iE_Extensions,
        SourceeNB_ID,
        SourceeNB_ID_ExtIEs,
        SRVCCOperationNotPossible,
        SRVCCOperationPossible,
        SRVCCHOIndication,
        _SourceNodeID_sourceNgRanNode_ID,
        _SourceNodeID_sourceNodeID_Extension,
        SourceNodeID,
        __SourceNodeID_Extension_id_tab,
        _SourceNodeID_Extension_id,
        __SourceNodeID_Extension_criticality_tab,
        _SourceNodeID_Extension_criticality,
        __SourceNodeID_Extension_value_tab,
        _SourceNodeID_Extension_value,
        SourceNodeID_Extension,
        SourceNodeID_ExtensionIE,
        _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container,
        _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList,
        _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID,
        _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP,
        _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation,
        ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_,
        _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions,
        SourceeNB_ToTargeteNB_TransparentContainer,
        SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_10,
        _SourceNgRanNode_ID_global_RAN_NODE_ID,
        _SourceNgRanNode_ID_selected_TAI,
        ____SourceNgRanNode_ID_iE_Extensions__item__id_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__id,
        ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__criticality,
        ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue,
        __SourceNgRanNode_ID_iE_Extensions__item_,
        _SourceNgRanNode_ID_iE_Extensions,
        SourceNgRanNode_ID,
        SourceNgRanNode_ID_ExtIEs,
        SourceRNC_ToTargetRNC_TransparentContainer,
        SourceNgRanNode_ToTargetNgRanNode_TransparentContainer,
        _ServedGUMMEIs__item_,
        ServedGUMMEIs,
        _ServedGUMMEIsItem_servedPLMNs,
        _ServedGUMMEIsItem_servedGroupIDs,
        _ServedGUMMEIsItem_servedMMECs,
        ____ServedGUMMEIsItem_iE_Extensions__item__id_tab,
        _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServedGUMMEIsItem_iE_Extensions__item__id,
        ___ServedGUMMEIsItem_iE_Extensions__item__criticality,
        ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue,
        __ServedGUMMEIsItem_iE_Extensions__item_,
        _ServedGUMMEIsItem_iE_Extensions,
        ServedGUMMEIsItem,
        ServedGUMMEIsItem_ExtIEs,
        _ServedGUMMEIsItem_ExtIEs_val_Extension_0,
        _ServedGroupIDs__item_,
        ServedGroupIDs,
        _ServedMMECs__item_,
        ServedMMECs,
        _ServedPLMNs__item_,
        ServedPLMNs,
        SubscriberProfileIDforRFP,
        _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator,
        _Subscription_Based_UE_DifferentiationInfo_periodicTime,
        _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime,
        _Subscription_Based_UE_DifferentiationInfo_stationaryIndication,
        _Subscription_Based_UE_DifferentiationInfo_trafficProfile,
        _Subscription_Based_UE_DifferentiationInfo_batteryIndication,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue,
        __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_,
        _Subscription_Based_UE_DifferentiationInfo_iE_Extensions,
        Subscription_Based_UE_DifferentiationInfo,
        Subscription_Based_UE_DifferentiationInfo_ExtIEs,
        _ScheduledCommunicationTime_dayofWeek,
        _ScheduledCommunicationTime_timeofDayStart,
        _ScheduledCommunicationTime_timeofDayEnd,
        ____ScheduledCommunicationTime_iE_Extensions__item__id_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__id,
        ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__criticality,
        ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue,
        __ScheduledCommunicationTime_iE_Extensions__item_,
        _ScheduledCommunicationTime_iE_Extensions,
        ScheduledCommunicationTime,
        ScheduledCommunicationTime_ExtIEs,
        _SupportedTAs__item_,
        SupportedTAs,
        _SupportedTAs_Item_tAC,
        _SupportedTAs_Item_broadcastPLMNs,
        ____SupportedTAs_Item_iE_Extensions__item__id_tab,
        _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SupportedTAs_Item_iE_Extensions__item__id,
        ___SupportedTAs_Item_iE_Extensions__item__criticality,
        ___SupportedTAs_Item_iE_Extensions__item__extensionValue,
        __SupportedTAs_Item_iE_Extensions__item_,
        _SupportedTAs_Item_iE_Extensions,
        SupportedTAs_Item,
        SupportedTAs_Item_ExtIEs,
        _SupportedTAs_Item_ExtIEs_val_Extension_0,
        StratumLevel,
        SynchronisationStatus,
        _TimeSynchronisationInfo_stratumLevel,
        _TimeSynchronisationInfo_synchronisationStatus,
        ____TimeSynchronisationInfo_iE_Extensions__item__id_tab,
        _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___TimeSynchronisationInfo_iE_Extensions__item__id,
        ___TimeSynchronisationInfo_iE_Extensions__item__criticality,
        ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue,
        __TimeSynchronisationInfo_iE_Extensions__item_,
        _TimeSynchronisationInfo_iE_Extensions,
        TimeSynchronisationInfo,
        TimeSynchronisationInfo_ExtIEs,
        _TimeSynchronisationInfo_ExtIEs_val_Extension_0,
        _S_TMSI_mMEC,
        _S_TMSI_m_TMSI,
        ____S_TMSI_iE_Extensions__item__id_tab,
        ___S_TMSI_iE_Extensions__item__id,
        ____S_TMSI_iE_Extensions__item__criticality_tab,
        ___S_TMSI_iE_Extensions__item__criticality,
        ____S_TMSI_iE_Extensions__item__extensionValue_tab,
        ___S_TMSI_iE_Extensions__item__extensionValue,
        __S_TMSI_iE_Extensions__item_,
        _S_TMSI_iE_Extensions,
        S_TMSI,
        S_TMSI_ExtIEs,
        TAC,
        _TACList_In_LTE_NTN__item_,
        TACList_In_LTE_NTN,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ____TAIBasedMDT_iE_Extensions__item__criticality_tab,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TAIListforWarning__item_,
        TAIListforWarning,
        _TAI_pLMNidentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        _TAI_Broadcast__item_,
        TAI_Broadcast,
        _TAI_Broadcast_Item_tAI,
        _TAI_Broadcast_Item_completedCellinTAI,
        ____TAI_Broadcast_Item_iE_Extensions__item__id_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__id,
        ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__criticality,
        ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue,
        __TAI_Broadcast_Item_iE_Extensions__item_,
        _TAI_Broadcast_Item_iE_Extensions,
        TAI_Broadcast_Item,
        TAI_Broadcast_Item_ExtIEs,
        _TAI_Cancelled__item_,
        TAI_Cancelled,
        _TAI_Cancelled_Item_tAI,
        _TAI_Cancelled_Item_cancelledCellinTAI,
        ____TAI_Cancelled_Item_iE_Extensions__item__id_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__id,
        ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__criticality,
        ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue,
        __TAI_Cancelled_Item_iE_Extensions__item_,
        _TAI_Cancelled_Item_iE_Extensions,
        TAI_Cancelled_Item,
        TAI_Cancelled_Item_ExtIEs,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ____TABasedMDT_iE_Extensions__item__criticality_tab,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ____TABasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        _TABasedQMC_tAListforQMC,
        ____TABasedQMC_iE_Extensions__item__id_tab,
        ___TABasedQMC_iE_Extensions__item__id,
        ____TABasedQMC_iE_Extensions__item__criticality_tab,
        ___TABasedQMC_iE_Extensions__item__criticality,
        ____TABasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TABasedQMC_iE_Extensions__item__extensionValue,
        __TABasedQMC_iE_Extensions__item_,
        _TABasedQMC_iE_Extensions,
        TABasedQMC,
        TABasedQMC_ExtIEs,
        _TAListforQMC__item_,
        TAListforQMC,
        _TAIBasedQMC_tAIListforQMC,
        ____TAIBasedQMC_iE_Extensions__item__id_tab,
        ___TAIBasedQMC_iE_Extensions__item__id,
        ____TAIBasedQMC_iE_Extensions__item__criticality_tab,
        ___TAIBasedQMC_iE_Extensions__item__criticality,
        ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedQMC_iE_Extensions__item__extensionValue,
        __TAIBasedQMC_iE_Extensions__item_,
        _TAIBasedQMC_iE_Extensions,
        TAIBasedQMC,
        TAIBasedQMC_ExtIEs,
        _TAIListforQMC__item_,
        TAIListforQMC,
        _CompletedCellinTAI__item_,
        CompletedCellinTAI,
        _CompletedCellinTAI_Item_eCGI,
        ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__id,
        ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__criticality,
        ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue,
        __CompletedCellinTAI_Item_iE_Extensions__item_,
        _CompletedCellinTAI_Item_iE_Extensions,
        CompletedCellinTAI_Item,
        CompletedCellinTAI_Item_ExtIEs,
        TBCD_STRING,
        _TargetID_targeteNB_ID,
        _TargetID_targetRNC_ID,
        _TargetID_cGI,
        _TargetID_targetgNgRanNode_ID,
        TargetID,
        _TargeteNB_ID_global_ENB_ID,
        _TargeteNB_ID_selected_TAI,
        ____TargeteNB_ID_iE_Extensions__item__id_tab,
        ___TargeteNB_ID_iE_Extensions__item__id,
        ____TargeteNB_ID_iE_Extensions__item__criticality_tab,
        ___TargeteNB_ID_iE_Extensions__item__criticality,
        ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargeteNB_ID_iE_Extensions__item__extensionValue,
        __TargeteNB_ID_iE_Extensions__item_,
        _TargeteNB_ID_iE_Extensions,
        TargeteNB_ID,
        TargeteNB_ID_ExtIEs,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rAC,
        _TargetRNC_ID_rNC_ID,
        _TargetRNC_ID_extendedRNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ____TargetRNC_ID_iE_Extensions__item__criticality_tab,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        _TargetNgRanNode_ID_global_RAN_NODE_ID,
        _TargetNgRanNode_ID_selected_TAI,
        ____TargetNgRanNode_ID_iE_Extensions__item__id_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__id,
        ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__criticality,
        ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue,
        __TargetNgRanNode_ID_iE_Extensions__item_,
        _TargetNgRanNode_ID_iE_Extensions,
        TargetNgRanNode_ID,
        TargetNgRanNode_ID_ExtIEs,
        _Global_RAN_NODE_ID_gNB,
        _Global_RAN_NODE_ID_ng_eNB,
        Global_RAN_NODE_ID,
        _GNB_global_gNB_ID,
        ____GNB_iE_Extensions__item__id_tab,
        ___GNB_iE_Extensions__item__id,
        ____GNB_iE_Extensions__item__criticality_tab,
        ___GNB_iE_Extensions__item__criticality,
        ____GNB_iE_Extensions__item__extensionValue_tab,
        ___GNB_iE_Extensions__item__extensionValue,
        __GNB_iE_Extensions__item_,
        _GNB_iE_Extensions,
        GNB,
        GNB_ExtIEs,
        _Global_GNB_ID_pLMN_Identity,
        _Global_GNB_ID_gNB_ID,
        ____Global_GNB_ID_iE_Extensions__item__id_tab,
        ___Global_GNB_ID_iE_Extensions__item__id,
        ____Global_GNB_ID_iE_Extensions__item__criticality_tab,
        ___Global_GNB_ID_iE_Extensions__item__criticality,
        ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_GNB_ID_iE_Extensions__item__extensionValue,
        __Global_GNB_ID_iE_Extensions__item_,
        _Global_GNB_ID_iE_Extensions,
        Global_GNB_ID,
        Global_GNB_ID_ExtIEs,
        _GNB_Identity_gNB_ID,
        GNB_Identity,
        _NG_eNB_global_ng_eNB_ID,
        ____NG_eNB_iE_Extensions__item__id_tab,
        ___NG_eNB_iE_Extensions__item__id,
        ____NG_eNB_iE_Extensions__item__criticality_tab,
        ___NG_eNB_iE_Extensions__item__criticality,
        ____NG_eNB_iE_Extensions__item__extensionValue_tab,
        ___NG_eNB_iE_Extensions__item__extensionValue,
        __NG_eNB_iE_Extensions__item_,
        _NG_eNB_iE_Extensions,
        NG_eNB,
        NG_eNB_ExtIEs,
        GNB_ID,
        _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container,
        ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_,
        _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions,
        TargeteNB_ToSourceeNB_TransparentContainer,
        TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_2,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_3,
        Target_ToSource_TransparentContainer,
        TargetRNC_ToSourceRNC_TransparentContainer,
        TargetBSS_ToSourceBSS_TransparentContainer,
        TargetNgRanNode_ToSourceNgRanNode_TransparentContainer,
        _M1ThresholdEventA2_measurementThreshold,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        Threshold_RSRP,
        Threshold_RSRQ,
        TimeToTrigger,
        TimeToWait,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        TimeSinceSecondaryNodeRelease,
        _TransportInformation_transportLayerAddress,
        _TransportInformation_uL_GTP_TEID,
        TransportInformation,
        TransportLayerAddress,
        _TraceActivation_e_UTRAN_Trace_ID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        _TraceActivation_ExtIEs_val_Extension_2,
        _TraceActivation_ExtIEs_val_Extension_3,
        TraceDepth,
        E_UTRAN_Trace_ID,
        TrafficLoadReductionIndication,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ____TunnelInformation_iE_Extensions__item__criticality_tab,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ____TunnelInformation_iE_Extensions__item__extensionValue_tab,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _TAIListForRestart__item_,
        TAIListForRestart,
        _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL,
        _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL,
        ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0,
        _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__id,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitrate_iE_Extensions__item_,
        _UEAggregateMaximumBitrate_iE_Extensions,
        UEAggregateMaximumBitrate,
        UEAggregate_MaximumBitrates_ExtIEs,
        _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0,
        _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1,
        _UEAppLayerMeasConfig_containerForAppLayerMeasConfig,
        _UEAppLayerMeasConfig_areaScopeOfQMC,
        ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab,
        _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0,
        ___UEAppLayerMeasConfig_iE_Extensions__item__id,
        ___UEAppLayerMeasConfig_iE_Extensions__item__criticality,
        ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue,
        __UEAppLayerMeasConfig_iE_Extensions__item_,
        _UEAppLayerMeasConfig_iE_Extensions,
        UEAppLayerMeasConfig,
        UEAppLayerMeasConfig_ExtIEs,
        _UEAppLayerMeasConfig_ExtIEs_val_Extension_0,
        UECapabilityInfoRequest,
        UE_RetentionInformation,
        _UE_S1AP_IDs_uE_S1AP_ID_pair,
        _UE_S1AP_IDs_mME_UE_S1AP_ID,
        UE_S1AP_IDs,
        _UE_S1AP_ID_pair_mME_UE_S1AP_ID,
        _UE_S1AP_ID_pair_eNB_UE_S1AP_ID,
        ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__id,
        ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__criticality,
        ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue,
        __UE_S1AP_ID_pair_iE_Extensions__item_,
        _UE_S1AP_ID_pair_iE_Extensions,
        UE_S1AP_ID_pair,
        UE_S1AP_ID_pair_ExtIEs,
        _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID,
        _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_,
        _UE_associatedLogicalS1_ConnectionItem_iE_Extensions,
        UE_associatedLogicalS1_ConnectionItem,
        UE_associatedLogicalS1_ConnectionItemExtIEs,
        UEIdentityIndexValue,
        _UE_HistoryInformation__item_,
        UE_HistoryInformation,
        UE_HistoryInformationFromTheUE,
        _UEPagingID_s_TMSI,
        _UEPagingID_iMSI,
        UEPagingID,
        UERadioCapability,
        UERadioCapabilityForPaging,
        UERadioCapabilityID,
        UE_RLF_Report_Container,
        UE_RLF_Report_Container_for_extended_bands,
        _UESecurityCapabilities_encryptionAlgorithms,
        _UESecurityCapabilities_integrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ____UESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _UESidelinkAggregateMaximumBitrate_iE_Extensions,
        UESidelinkAggregateMaximumBitrate,
        UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs,
        UE_Usage_Type,
        _UL_CP_SecurityInformation_ul_NAS_MAC,
        _UL_CP_SecurityInformation_ul_NAS_Count,
        ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__id,
        ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __UL_CP_SecurityInformation_iE_Extensions__item_,
        _UL_CP_SecurityInformation_iE_Extensions,
        UL_CP_SecurityInformation,
        UL_CP_SecurityInformation_ExtIEs,
        UL_NAS_MAC,
        UL_NAS_Count,
        UnlicensedSpectrumRestriction,
        URI_Address,
        _UserLocationInformation_eutran_cgi,
        _UserLocationInformation_tai,
        ____UserLocationInformation_iE_Extensions__item__id_tab,
        _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___UserLocationInformation_iE_Extensions__item__id,
        ___UserLocationInformation_iE_Extensions__item__criticality,
        ___UserLocationInformation_iE_Extensions__item__extensionValue,
        __UserLocationInformation_iE_Extensions__item_,
        _UserLocationInformation_iE_Extensions,
        UserLocationInformation,
        UserLocationInformation_ExtIEs,
        _UserLocationInformation_ExtIEs_val_Extension_0,
        _UserLocationInformation_ExtIEs_val_Extension_1,
        UEUserPlaneCIoTSupportIndicator,
        UE_Application_Layer_Measurement_Capability,
        VoiceSupportMatchIndicator,
        _V2XServicesAuthorized_vehicleUE,
        _V2XServicesAuthorized_pedestrianUE,
        ____V2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__id,
        ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__criticality,
        ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __V2XServicesAuthorized_iE_Extensions__item_,
        _V2XServicesAuthorized_iE_Extensions,
        V2XServicesAuthorized,
        V2XServicesAuthorized_ExtIEs,
        VehicleUE,
        PedestrianUE,
        WarningAreaCoordinates,
        _WarningAreaList_cellIDList,
        _WarningAreaList_trackingAreaListforWarning,
        _WarningAreaList_emergencyAreaIDList,
        WarningAreaList,
        WarningType,
        WarningSecurityInfo,
        WarningMessageContents,
        _WLANMeasurementConfiguration_wlanMeasConfig,
        _WLANMeasurementConfiguration_wlanMeasConfigNameList,
        _WLANMeasurementConfiguration_wlan_rssi,
        _WLANMeasurementConfiguration_wlan_rtt,
        ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__id,
        ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__criticality,
        ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __WLANMeasurementConfiguration_iE_Extensions__item_,
        _WLANMeasurementConfiguration_iE_Extensions,
        WLANMeasurementConfiguration,
        WLANMeasurementConfiguration_ExtIEs,
        _WLANMeasConfigNameList__item_,
        WLANMeasConfigNameList,
        WLANMeasConfig,
        WLANName,
        _WUS_Assistance_Information_pagingProbabilityInformation,
        ____WUS_Assistance_Information_iE_Extensions__item__id_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__id,
        ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__criticality,
        ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__extensionValue,
        __WUS_Assistance_Information_iE_Extensions__item_,
        _WUS_Assistance_Information_iE_Extensions,
        WUS_Assistance_Information,
        WUS_Assistance_Information_ExtIEs,
        _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses,
        ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab,
        _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1,
        ___X2TNLConfigurationInfo_iE_Extensions__item__id,
        ___X2TNLConfigurationInfo_iE_Extensions__item__criticality,
        ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue,
        __X2TNLConfigurationInfo_iE_Extensions__item_,
        _X2TNLConfigurationInfo_iE_Extensions,
        X2TNLConfigurationInfo,
        X2TNLConfigurationInfo_ExtIEs,
        _X2TNLConfigurationInfo_ExtIEs_val_Extension_0,
        _X2TNLConfigurationInfo_ExtIEs_val_Extension_1,
        _ENBX2ExtTLAs__item_,
        ENBX2ExtTLAs,
        _ENBX2ExtTLA_iPsecTLA,
        _ENBX2ExtTLA_gTPTLAa,
        ____ENBX2ExtTLA_iE_Extensions__item__id_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__id,
        ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__criticality,
        ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__extensionValue,
        __ENBX2ExtTLA_iE_Extensions__item_,
        _ENBX2ExtTLA_iE_Extensions,
        ENBX2ExtTLA,
        ENBX2ExtTLA_ExtIEs,
        _ENBX2GTPTLAs__item_,
        ENBX2GTPTLAs,
        _ENBIndirectX2TransportLayerAddresses__item_,
        ENBIndirectX2TransportLayerAddresses,
    ]

class S1AP_PDU_Contents:

    _name_  = 'S1AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 1]
    
    _obj_ = [
        'E-RAB-IE-ContainerList',
        'E-RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        'HandoverRequired',
        'HandoverRequiredIEs',
        'HandoverCommand',
        'HandoverCommandIEs',
        'E-RABSubjecttoDataForwardingList',
        'E-RABDataForwardingItemIEs',
        'E-RABDataForwardingItem',
        'E-RABDataForwardingItem-ExtIEs',
        'HandoverPreparationFailure',
        'HandoverPreparationFailureIEs',
        'HandoverRequest',
        'HandoverRequestIEs',
        'E-RABToBeSetupListHOReq',
        'E-RABToBeSetupItemHOReqIEs',
        'E-RABToBeSetupItemHOReq',
        'E-RABToBeSetupItemHOReq-ExtIEs',
        'HandoverRequestAcknowledge',
        'HandoverRequestAcknowledgeIEs',
        'E-RABAdmittedList',
        'E-RABAdmittedItemIEs',
        'E-RABAdmittedItem',
        'E-RABAdmittedItem-ExtIEs',
        'E-RABFailedtoSetupListHOReqAck',
        'E-RABFailedtoSetupItemHOReqAckIEs',
        'E-RABFailedToSetupItemHOReqAck',
        'E-RABFailedToSetupItemHOReqAckExtIEs',
        'HandoverFailure',
        'HandoverFailureIEs',
        'HandoverNotify',
        'HandoverNotifyIEs',
        'PathSwitchRequest',
        'PathSwitchRequestIEs',
        'E-RABToBeSwitchedDLList',
        'E-RABToBeSwitchedDLItemIEs',
        'E-RABToBeSwitchedDLItem',
        'E-RABToBeSwitchedDLItem-ExtIEs',
        'PathSwitchRequestAcknowledge',
        'PathSwitchRequestAcknowledgeIEs',
        'E-RABToBeSwitchedULList',
        'E-RABToBeSwitchedULItemIEs',
        'E-RABToBeSwitchedULItem',
        'E-RABToBeSwitchedULItem-ExtIEs',
        'E-RABToBeUpdatedList',
        'E-RABToBeUpdatedItemIEs',
        'E-RABToBeUpdatedItem',
        'E-RABToBeUpdatedItem-ExtIEs',
        'PathSwitchRequestFailure',
        'PathSwitchRequestFailureIEs',
        'HandoverCancel',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledge',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccess',
        'HandoverSuccessIEs',
        'ENBEarlyStatusTransfer',
        'ENBEarlyStatusTransferIEs',
        'MMEEarlyStatusTransfer',
        'MMEEarlyStatusTransferIEs',
        'E-RABSetupRequest',
        'E-RABSetupRequestIEs',
        'E-RABToBeSetupListBearerSUReq',
        'E-RABToBeSetupItemBearerSUReqIEs',
        'E-RABToBeSetupItemBearerSUReq',
        'E-RABToBeSetupItemBearerSUReqExtIEs',
        'E-RABSetupResponse',
        'E-RABSetupResponseIEs',
        'E-RABSetupListBearerSURes',
        'E-RABSetupItemBearerSUResIEs',
        'E-RABSetupItemBearerSURes',
        'E-RABSetupItemBearerSUResExtIEs',
        'E-RABModifyRequest',
        'E-RABModifyRequestIEs',
        'E-RABToBeModifiedListBearerModReq',
        'E-RABToBeModifiedItemBearerModReqIEs',
        'E-RABToBeModifiedItemBearerModReq',
        'E-RABToBeModifyItemBearerModReqExtIEs',
        'E-RABModifyResponse',
        'E-RABModifyResponseIEs',
        'E-RABModifyListBearerModRes',
        'E-RABModifyItemBearerModResIEs',
        'E-RABModifyItemBearerModRes',
        'E-RABModifyItemBearerModResExtIEs',
        'E-RABReleaseCommand',
        'E-RABReleaseCommandIEs',
        'E-RABReleaseResponse',
        'E-RABReleaseResponseIEs',
        'E-RABReleaseListBearerRelComp',
        'E-RABReleaseItemBearerRelCompIEs',
        'E-RABReleaseItemBearerRelComp',
        'E-RABReleaseItemBearerRelCompExtIEs',
        'E-RABReleaseIndication',
        'E-RABReleaseIndicationIEs',
        'InitialContextSetupRequest',
        'InitialContextSetupRequestIEs',
        'E-RABToBeSetupListCtxtSUReq',
        'E-RABToBeSetupItemCtxtSUReqIEs',
        'E-RABToBeSetupItemCtxtSUReq',
        'E-RABToBeSetupItemCtxtSUReqExtIEs',
        'InitialContextSetupResponse',
        'InitialContextSetupResponseIEs',
        'E-RABSetupListCtxtSURes',
        'E-RABSetupItemCtxtSUResIEs',
        'E-RABSetupItemCtxtSURes',
        'E-RABSetupItemCtxtSUResExtIEs',
        'InitialContextSetupFailure',
        'InitialContextSetupFailureIEs',
        'Paging',
        'PagingIEs',
        'TAIList',
        'TAIItemIEs',
        'TAIItem',
        'TAIItemExtIEs',
        'UEContextReleaseRequest',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete',
        'UEContextReleaseComplete-IEs',
        'UEContextModificationRequest',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponse',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailure',
        'UEContextModificationFailureIEs',
        'UERadioCapabilityMatchRequest',
        'UERadioCapabilityMatchRequestIEs',
        'UERadioCapabilityMatchResponse',
        'UERadioCapabilityMatchResponseIEs',
        'DownlinkNASTransport',
        'DownlinkNASTransport-IEs',
        'InitialUEMessage',
        'InitialUEMessage-IEs',
        'UplinkNASTransport',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest',
        'RerouteNASRequest-IEs',
        'NASDeliveryIndication',
        'NASDeliveryIndicationIEs',
        'Reset',
        'ResetIEs',
        'ResetType',
        'ResetAll',
        'UE-associatedLogicalS1-ConnectionListRes',
        'UE-associatedLogicalS1-ConnectionItemRes',
        'ResetAcknowledge',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalS1-ConnectionListResAck',
        'UE-associatedLogicalS1-ConnectionItemResAck',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'S1SetupRequest',
        'S1SetupRequestIEs',
        'S1SetupResponse',
        'S1SetupResponseIEs',
        'S1SetupFailure',
        'S1SetupFailureIEs',
        'ENBConfigurationUpdate',
        'ENBConfigurationUpdateIEs',
        'ENBConfigurationUpdateAcknowledge',
        'ENBConfigurationUpdateAcknowledgeIEs',
        'ENBConfigurationUpdateFailure',
        'ENBConfigurationUpdateFailureIEs',
        'MMEConfigurationUpdate',
        'MMEConfigurationUpdateIEs',
        'MMEConfigurationUpdateAcknowledge',
        'MMEConfigurationUpdateAcknowledgeIEs',
        'MMEConfigurationUpdateFailure',
        'MMEConfigurationUpdateFailureIEs',
        'DownlinkS1cdma2000tunnelling',
        'DownlinkS1cdma2000tunnellingIEs',
        'UplinkS1cdma2000tunnelling',
        'UplinkS1cdma2000tunnellingIEs',
        'UECapabilityInfoIndication',
        'UECapabilityInfoIndicationIEs',
        'ENBStatusTransfer',
        'ENBStatusTransferIEs',
        'MMEStatusTransfer',
        'MMEStatusTransferIEs',
        'TraceStart',
        'TraceStartIEs',
        'TraceFailureIndication',
        'TraceFailureIndicationIEs',
        'DeactivateTrace',
        'DeactivateTraceIEs',
        'CellTrafficTrace',
        'CellTrafficTraceIEs',
        'LocationReportingControl',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndication',
        'LocationReportingFailureIndicationIEs',
        'LocationReport',
        'LocationReportIEs',
        'OverloadStart',
        'OverloadStartIEs',
        'OverloadStop',
        'OverloadStopIEs',
        'WriteReplaceWarningRequest',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponse',
        'WriteReplaceWarningResponseIEs',
        'ENBDirectInformationTransfer',
        'ENBDirectInformationTransferIEs',
        'Inter-SystemInformationTransferType',
        'MMEDirectInformationTransfer',
        'MMEDirectInformationTransferIEs',
        'ENBConfigurationTransfer',
        'ENBConfigurationTransferIEs',
        'MMEConfigurationTransfer',
        'MMEConfigurationTransferIEs',
        'PrivateMessage',
        'PrivateMessageIEs',
        'KillRequest',
        'KillRequestIEs',
        'KillResponse',
        'KillResponseIEs',
        'PWSRestartIndication',
        'PWSRestartIndicationIEs',
        'PWSFailureIndication',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedLPPaTransport',
        'DownlinkUEAssociatedLPPaTransport-IEs',
        'UplinkUEAssociatedLPPaTransport',
        'UplinkUEAssociatedLPPaTransport-IEs',
        'DownlinkNonUEAssociatedLPPaTransport',
        'DownlinkNonUEAssociatedLPPaTransport-IEs',
        'UplinkNonUEAssociatedLPPaTransport',
        'UplinkNonUEAssociatedLPPaTransport-IEs',
        'E-RABModificationIndication',
        'E-RABModificationIndicationIEs',
        'E-RABToBeModifiedListBearerModInd',
        'E-RABToBeModifiedItemBearerModIndIEs',
        'E-RABToBeModifiedItemBearerModInd',
        'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        'E-RABNotToBeModifiedListBearerModInd',
        'E-RABNotToBeModifiedItemBearerModIndIEs',
        'E-RABNotToBeModifiedItemBearerModInd',
        'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        'CSGMembershipInfo',
        'CSGMembershipInfo-ExtIEs',
        'E-RABModificationConfirm',
        'E-RABModificationConfirmIEs',
        'E-RABModifyListBearerModConf',
        'E-RABModifyItemBearerModConfIEs',
        'E-RABModifyItemBearerModConf',
        'E-RABModifyItemBearerModConfExtIEs',
        'UEContextModificationIndication',
        'UEContextModificationIndicationIEs',
        'UEContextModificationConfirm',
        'UEContextModificationConfirmIEs',
        'UEContextSuspendRequest',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponse',
        'UEContextSuspendResponseIEs',
        'UEContextResumeRequest',
        'UEContextResumeRequestIEs',
        'E-RABFailedToResumeListResumeReq',
        'E-RABFailedToResumeItemResumeReqIEs',
        'E-RABFailedToResumeItemResumeReq',
        'E-RABFailedToResumeItemResumeReq-ExtIEs',
        'UEContextResumeResponse',
        'UEContextResumeResponseIEs',
        'E-RABFailedToResumeListResumeRes',
        'E-RABFailedToResumeItemResumeResIEs',
        'E-RABFailedToResumeItemResumeRes',
        'E-RABFailedToResumeItemResumeRes-ExtIEs',
        'UEContextResumeFailure',
        'UEContextResumeFailureIEs',
        'ConnectionEstablishmentIndication',
        'ConnectionEstablishmentIndicationIEs',
        'RetrieveUEInformation',
        'RetrieveUEInformationIEs',
        'UEInformationTransfer',
        'UEInformationTransferIEs',
        'ENBCPRelocationIndication',
        'ENBCPRelocationIndicationIEs',
        'MMECPRelocationIndication',
        'MMECPRelocationIndicationIEs',
        'SecondaryRATDataUsageReport',
        'SecondaryRATDataUsageReportIEs',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponse',
        'UERadioCapabilityIDMappingResponseIEs',
        ]
    _type_ = [
        'E-RAB-IE-ContainerList',
        'E-RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        'HandoverRequired',
        'HandoverCommand',
        'E-RABSubjecttoDataForwardingList',
        'E-RABDataForwardingItem',
        'HandoverPreparationFailure',
        'HandoverRequest',
        'E-RABToBeSetupListHOReq',
        'E-RABToBeSetupItemHOReq',
        'HandoverRequestAcknowledge',
        'E-RABAdmittedList',
        'E-RABAdmittedItem',
        'E-RABFailedtoSetupListHOReqAck',
        'E-RABFailedToSetupItemHOReqAck',
        'HandoverFailure',
        'HandoverNotify',
        'PathSwitchRequest',
        'E-RABToBeSwitchedDLList',
        'E-RABToBeSwitchedDLItem',
        'PathSwitchRequestAcknowledge',
        'E-RABToBeSwitchedULList',
        'E-RABToBeSwitchedULItem',
        'E-RABToBeUpdatedList',
        'E-RABToBeUpdatedItem',
        'PathSwitchRequestFailure',
        'HandoverCancel',
        'HandoverCancelAcknowledge',
        'HandoverSuccess',
        'ENBEarlyStatusTransfer',
        'MMEEarlyStatusTransfer',
        'E-RABSetupRequest',
        'E-RABToBeSetupListBearerSUReq',
        'E-RABToBeSetupItemBearerSUReq',
        'E-RABSetupResponse',
        'E-RABSetupListBearerSURes',
        'E-RABSetupItemBearerSURes',
        'E-RABModifyRequest',
        'E-RABToBeModifiedListBearerModReq',
        'E-RABToBeModifiedItemBearerModReq',
        'E-RABModifyResponse',
        'E-RABModifyListBearerModRes',
        'E-RABModifyItemBearerModRes',
        'E-RABReleaseCommand',
        'E-RABReleaseResponse',
        'E-RABReleaseListBearerRelComp',
        'E-RABReleaseItemBearerRelComp',
        'E-RABReleaseIndication',
        'InitialContextSetupRequest',
        'E-RABToBeSetupListCtxtSUReq',
        'E-RABToBeSetupItemCtxtSUReq',
        'InitialContextSetupResponse',
        'E-RABSetupListCtxtSURes',
        'E-RABSetupItemCtxtSURes',
        'InitialContextSetupFailure',
        'Paging',
        'TAIList',
        'TAIItem',
        'UEContextReleaseRequest',
        'UEContextReleaseCommand',
        'UEContextReleaseComplete',
        'UEContextModificationRequest',
        'UEContextModificationResponse',
        'UEContextModificationFailure',
        'UERadioCapabilityMatchRequest',
        'UERadioCapabilityMatchResponse',
        'DownlinkNASTransport',
        'InitialUEMessage',
        'UplinkNASTransport',
        'NASNonDeliveryIndication',
        'RerouteNASRequest',
        'NASDeliveryIndication',
        'Reset',
        'ResetType',
        'ResetAll',
        'UE-associatedLogicalS1-ConnectionListRes',
        'ResetAcknowledge',
        'UE-associatedLogicalS1-ConnectionListResAck',
        'ErrorIndication',
        'S1SetupRequest',
        'S1SetupResponse',
        'S1SetupFailure',
        'ENBConfigurationUpdate',
        'ENBConfigurationUpdateAcknowledge',
        'ENBConfigurationUpdateFailure',
        'MMEConfigurationUpdate',
        'MMEConfigurationUpdateAcknowledge',
        'MMEConfigurationUpdateFailure',
        'DownlinkS1cdma2000tunnelling',
        'UplinkS1cdma2000tunnelling',
        'UECapabilityInfoIndication',
        'ENBStatusTransfer',
        'MMEStatusTransfer',
        'TraceStart',
        'TraceFailureIndication',
        'DeactivateTrace',
        'CellTrafficTrace',
        'LocationReportingControl',
        'LocationReportingFailureIndication',
        'LocationReport',
        'OverloadStart',
        'OverloadStop',
        'WriteReplaceWarningRequest',
        'WriteReplaceWarningResponse',
        'ENBDirectInformationTransfer',
        'Inter-SystemInformationTransferType',
        'MMEDirectInformationTransfer',
        'ENBConfigurationTransfer',
        'MMEConfigurationTransfer',
        'PrivateMessage',
        'KillRequest',
        'KillResponse',
        'PWSRestartIndication',
        'PWSFailureIndication',
        'DownlinkUEAssociatedLPPaTransport',
        'UplinkUEAssociatedLPPaTransport',
        'DownlinkNonUEAssociatedLPPaTransport',
        'UplinkNonUEAssociatedLPPaTransport',
        'E-RABModificationIndication',
        'E-RABToBeModifiedListBearerModInd',
        'E-RABToBeModifiedItemBearerModInd',
        'E-RABNotToBeModifiedListBearerModInd',
        'E-RABNotToBeModifiedItemBearerModInd',
        'CSGMembershipInfo',
        'E-RABModificationConfirm',
        'E-RABModifyListBearerModConf',
        'E-RABModifyItemBearerModConf',
        'UEContextModificationIndication',
        'UEContextModificationConfirm',
        'UEContextSuspendRequest',
        'UEContextSuspendResponse',
        'UEContextResumeRequest',
        'E-RABFailedToResumeListResumeReq',
        'E-RABFailedToResumeItemResumeReq',
        'UEContextResumeResponse',
        'E-RABFailedToResumeListResumeRes',
        'E-RABFailedToResumeItemResumeRes',
        'UEContextResumeFailure',
        'ConnectionEstablishmentIndication',
        'RetrieveUEInformation',
        'UEInformationTransfer',
        'ENBCPRelocationIndication',
        'MMECPRelocationIndication',
        'SecondaryRATDataUsageReport',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingResponse',
        ]
    _set_ = [
        'HandoverRequiredIEs',
        'HandoverCommandIEs',
        'E-RABDataForwardingItemIEs',
        'E-RABDataForwardingItem-ExtIEs',
        'HandoverPreparationFailureIEs',
        'HandoverRequestIEs',
        'E-RABToBeSetupItemHOReqIEs',
        'E-RABToBeSetupItemHOReq-ExtIEs',
        'HandoverRequestAcknowledgeIEs',
        'E-RABAdmittedItemIEs',
        'E-RABAdmittedItem-ExtIEs',
        'E-RABFailedtoSetupItemHOReqAckIEs',
        'E-RABFailedToSetupItemHOReqAckExtIEs',
        'HandoverFailureIEs',
        'HandoverNotifyIEs',
        'PathSwitchRequestIEs',
        'E-RABToBeSwitchedDLItemIEs',
        'E-RABToBeSwitchedDLItem-ExtIEs',
        'PathSwitchRequestAcknowledgeIEs',
        'E-RABToBeSwitchedULItemIEs',
        'E-RABToBeSwitchedULItem-ExtIEs',
        'E-RABToBeUpdatedItemIEs',
        'E-RABToBeUpdatedItem-ExtIEs',
        'PathSwitchRequestFailureIEs',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccessIEs',
        'ENBEarlyStatusTransferIEs',
        'MMEEarlyStatusTransferIEs',
        'E-RABSetupRequestIEs',
        'E-RABToBeSetupItemBearerSUReqIEs',
        'E-RABToBeSetupItemBearerSUReqExtIEs',
        'E-RABSetupResponseIEs',
        'E-RABSetupItemBearerSUResIEs',
        'E-RABSetupItemBearerSUResExtIEs',
        'E-RABModifyRequestIEs',
        'E-RABToBeModifiedItemBearerModReqIEs',
        'E-RABToBeModifyItemBearerModReqExtIEs',
        'E-RABModifyResponseIEs',
        'E-RABModifyItemBearerModResIEs',
        'E-RABModifyItemBearerModResExtIEs',
        'E-RABReleaseCommandIEs',
        'E-RABReleaseResponseIEs',
        'E-RABReleaseItemBearerRelCompIEs',
        'E-RABReleaseItemBearerRelCompExtIEs',
        'E-RABReleaseIndicationIEs',
        'InitialContextSetupRequestIEs',
        'E-RABToBeSetupItemCtxtSUReqIEs',
        'E-RABToBeSetupItemCtxtSUReqExtIEs',
        'InitialContextSetupResponseIEs',
        'E-RABSetupItemCtxtSUResIEs',
        'E-RABSetupItemCtxtSUResExtIEs',
        'InitialContextSetupFailureIEs',
        'PagingIEs',
        'TAIItemIEs',
        'TAIItemExtIEs',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete-IEs',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailureIEs',
        'UERadioCapabilityMatchRequestIEs',
        'UERadioCapabilityMatchResponseIEs',
        'DownlinkNASTransport-IEs',
        'InitialUEMessage-IEs',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest-IEs',
        'NASDeliveryIndicationIEs',
        'ResetIEs',
        'UE-associatedLogicalS1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalS1-ConnectionItemResAck',
        'ErrorIndicationIEs',
        'S1SetupRequestIEs',
        'S1SetupResponseIEs',
        'S1SetupFailureIEs',
        'ENBConfigurationUpdateIEs',
        'ENBConfigurationUpdateAcknowledgeIEs',
        'ENBConfigurationUpdateFailureIEs',
        'MMEConfigurationUpdateIEs',
        'MMEConfigurationUpdateAcknowledgeIEs',
        'MMEConfigurationUpdateFailureIEs',
        'DownlinkS1cdma2000tunnellingIEs',
        'UplinkS1cdma2000tunnellingIEs',
        'UECapabilityInfoIndicationIEs',
        'ENBStatusTransferIEs',
        'MMEStatusTransferIEs',
        'TraceStartIEs',
        'TraceFailureIndicationIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndicationIEs',
        'LocationReportIEs',
        'OverloadStartIEs',
        'OverloadStopIEs',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponseIEs',
        'ENBDirectInformationTransferIEs',
        'MMEDirectInformationTransferIEs',
        'ENBConfigurationTransferIEs',
        'MMEConfigurationTransferIEs',
        'PrivateMessageIEs',
        'KillRequestIEs',
        'KillResponseIEs',
        'PWSRestartIndicationIEs',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedLPPaTransport-IEs',
        'UplinkUEAssociatedLPPaTransport-IEs',
        'DownlinkNonUEAssociatedLPPaTransport-IEs',
        'UplinkNonUEAssociatedLPPaTransport-IEs',
        'E-RABModificationIndicationIEs',
        'E-RABToBeModifiedItemBearerModIndIEs',
        'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        'E-RABNotToBeModifiedItemBearerModIndIEs',
        'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        'CSGMembershipInfo-ExtIEs',
        'E-RABModificationConfirmIEs',
        'E-RABModifyItemBearerModConfIEs',
        'E-RABModifyItemBearerModConfExtIEs',
        'UEContextModificationIndicationIEs',
        'UEContextModificationConfirmIEs',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponseIEs',
        'UEContextResumeRequestIEs',
        'E-RABFailedToResumeItemResumeReqIEs',
        'E-RABFailedToResumeItemResumeReq-ExtIEs',
        'UEContextResumeResponseIEs',
        'E-RABFailedToResumeItemResumeResIEs',
        'E-RABFailedToResumeItemResumeRes-ExtIEs',
        'UEContextResumeFailureIEs',
        'ConnectionEstablishmentIndicationIEs',
        'RetrieveUEInformationIEs',
        'UEInformationTransferIEs',
        'ENBCPRelocationIndicationIEs',
        'MMECPRelocationIndicationIEs',
        'SecondaryRATDataUsageReportIEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'HandoverRequiredIEs',
        'HandoverCommandIEs',
        'E-RABDataForwardingItemIEs',
        'E-RABDataForwardingItem-ExtIEs',
        'HandoverPreparationFailureIEs',
        'HandoverRequestIEs',
        'E-RABToBeSetupItemHOReqIEs',
        'E-RABToBeSetupItemHOReq-ExtIEs',
        'HandoverRequestAcknowledgeIEs',
        'E-RABAdmittedItemIEs',
        'E-RABAdmittedItem-ExtIEs',
        'E-RABFailedtoSetupItemHOReqAckIEs',
        'E-RABFailedToSetupItemHOReqAckExtIEs',
        'HandoverFailureIEs',
        'HandoverNotifyIEs',
        'PathSwitchRequestIEs',
        'E-RABToBeSwitchedDLItemIEs',
        'E-RABToBeSwitchedDLItem-ExtIEs',
        'PathSwitchRequestAcknowledgeIEs',
        'E-RABToBeSwitchedULItemIEs',
        'E-RABToBeSwitchedULItem-ExtIEs',
        'E-RABToBeUpdatedItemIEs',
        'E-RABToBeUpdatedItem-ExtIEs',
        'PathSwitchRequestFailureIEs',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccessIEs',
        'ENBEarlyStatusTransferIEs',
        'MMEEarlyStatusTransferIEs',
        'E-RABSetupRequestIEs',
        'E-RABToBeSetupItemBearerSUReqIEs',
        'E-RABToBeSetupItemBearerSUReqExtIEs',
        'E-RABSetupResponseIEs',
        'E-RABSetupItemBearerSUResIEs',
        'E-RABSetupItemBearerSUResExtIEs',
        'E-RABModifyRequestIEs',
        'E-RABToBeModifiedItemBearerModReqIEs',
        'E-RABToBeModifyItemBearerModReqExtIEs',
        'E-RABModifyResponseIEs',
        'E-RABModifyItemBearerModResIEs',
        'E-RABModifyItemBearerModResExtIEs',
        'E-RABReleaseCommandIEs',
        'E-RABReleaseResponseIEs',
        'E-RABReleaseItemBearerRelCompIEs',
        'E-RABReleaseItemBearerRelCompExtIEs',
        'E-RABReleaseIndicationIEs',
        'InitialContextSetupRequestIEs',
        'E-RABToBeSetupItemCtxtSUReqIEs',
        'E-RABToBeSetupItemCtxtSUReqExtIEs',
        'InitialContextSetupResponseIEs',
        'E-RABSetupItemCtxtSUResIEs',
        'E-RABSetupItemCtxtSUResExtIEs',
        'InitialContextSetupFailureIEs',
        'PagingIEs',
        'TAIItemIEs',
        'TAIItemExtIEs',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete-IEs',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailureIEs',
        'UERadioCapabilityMatchRequestIEs',
        'UERadioCapabilityMatchResponseIEs',
        'DownlinkNASTransport-IEs',
        'InitialUEMessage-IEs',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest-IEs',
        'NASDeliveryIndicationIEs',
        'ResetIEs',
        'UE-associatedLogicalS1-ConnectionItemRes',
        'ResetAcknowledgeIEs',
        'UE-associatedLogicalS1-ConnectionItemResAck',
        'ErrorIndicationIEs',
        'S1SetupRequestIEs',
        'S1SetupResponseIEs',
        'S1SetupFailureIEs',
        'ENBConfigurationUpdateIEs',
        'ENBConfigurationUpdateAcknowledgeIEs',
        'ENBConfigurationUpdateFailureIEs',
        'MMEConfigurationUpdateIEs',
        'MMEConfigurationUpdateAcknowledgeIEs',
        'MMEConfigurationUpdateFailureIEs',
        'DownlinkS1cdma2000tunnellingIEs',
        'UplinkS1cdma2000tunnellingIEs',
        'UECapabilityInfoIndicationIEs',
        'ENBStatusTransferIEs',
        'MMEStatusTransferIEs',
        'TraceStartIEs',
        'TraceFailureIndicationIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndicationIEs',
        'LocationReportIEs',
        'OverloadStartIEs',
        'OverloadStopIEs',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponseIEs',
        'ENBDirectInformationTransferIEs',
        'MMEDirectInformationTransferIEs',
        'ENBConfigurationTransferIEs',
        'MMEConfigurationTransferIEs',
        'PrivateMessageIEs',
        'KillRequestIEs',
        'KillResponseIEs',
        'PWSRestartIndicationIEs',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedLPPaTransport-IEs',
        'UplinkUEAssociatedLPPaTransport-IEs',
        'DownlinkNonUEAssociatedLPPaTransport-IEs',
        'UplinkNonUEAssociatedLPPaTransport-IEs',
        'E-RABModificationIndicationIEs',
        'E-RABToBeModifiedItemBearerModIndIEs',
        'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        'E-RABNotToBeModifiedItemBearerModIndIEs',
        'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        'CSGMembershipInfo-ExtIEs',
        'E-RABModificationConfirmIEs',
        'E-RABModifyItemBearerModConfIEs',
        'E-RABModifyItemBearerModConfExtIEs',
        'UEContextModificationIndicationIEs',
        'UEContextModificationConfirmIEs',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponseIEs',
        'UEContextResumeRequestIEs',
        'E-RABFailedToResumeItemResumeReqIEs',
        'E-RABFailedToResumeItemResumeReq-ExtIEs',
        'UEContextResumeResponseIEs',
        'E-RABFailedToResumeItemResumeResIEs',
        'E-RABFailedToResumeItemResumeRes-ExtIEs',
        'UEContextResumeFailureIEs',
        'ConnectionEstablishmentIndicationIEs',
        'RetrieveUEInformationIEs',
        'UEInformationTransferIEs',
        'ENBCPRelocationIndicationIEs',
        'MMECPRelocationIndicationIEs',
        'SecondaryRATDataUsageReportIEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        ]
    _param_ = [
        'E-RAB-IE-ContainerList',
        'E-RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        ]
    
    #-----< E-RAB-IE-ContainerList >-----#
    E_RAB_IE_ContainerList = SEQ_OF(name='E-RAB-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< E-RAB-IE-ContainerPairList >-----#
    E_RAB_IE_ContainerPairList = SEQ_OF(name='E-RAB-IE-ContainerPairList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerPairList')), param=True)
    
    #-----< ProtocolError-IE-ContainerList >-----#
    ProtocolError_IE_ContainerList = SEQ_OF(name='ProtocolError-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< HandoverRequired >-----#
    HandoverRequired = SEQ(name='HandoverRequired', mode=MODE_TYPE)
    _HandoverRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverRequired_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TargetID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCHOIndication')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark2')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark3')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PS-ServiceNotAvailable')))
    ____HandoverRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9), ('presence', 'conditional')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10), ('presence', 'conditional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequired_protocolIEs__item__id._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequired_protocolIEs__item__criticality._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequired_protocolIEs__item__value._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequired_protocolIEs__item__id),
        ('criticality', ___HandoverRequired_protocolIEs__item__criticality),
        ('value', ___HandoverRequired_protocolIEs__item__value),
        ])
    __HandoverRequired_protocolIEs__item_._ext = None
    _HandoverRequired_protocolIEs._cont = __HandoverRequired_protocolIEs__item_
    _HandoverRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequired._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequired_protocolIEs),
        ])
    HandoverRequired._ext = []
    
    #-----< HandoverRequiredIEs >-----#
    HandoverRequiredIEs = CLASS(name='HandoverRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverRequiredIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverRequiredIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverRequiredIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TargetID')))
    _HandoverRequiredIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _HandoverRequiredIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCHOIndication')))
    _HandoverRequiredIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequiredIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequiredIEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark2')))
    _HandoverRequiredIEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark3')))
    _HandoverRequiredIEs_val_Value_11 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequiredIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _HandoverRequiredIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PS-ServiceNotAvailable')))
    HandoverRequiredIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_9), ('presence', 'conditional')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_10), ('presence', 'conditional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_13), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCommand >-----#
    HandoverCommand = SEQ(name='HandoverCommand', mode=MODE_TYPE)
    _HandoverCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParametersfromE-UTRAN')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 135), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommand_protocolIEs__item__id._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__id._const_tab_at = None
    ___HandoverCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCommand_protocolIEs__item__criticality._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverCommand_protocolIEs__item__value._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCommand_protocolIEs__item__id),
        ('criticality', ___HandoverCommand_protocolIEs__item__criticality),
        ('value', ___HandoverCommand_protocolIEs__item__value),
        ])
    __HandoverCommand_protocolIEs__item_._ext = None
    _HandoverCommand_protocolIEs._cont = __HandoverCommand_protocolIEs__item_
    _HandoverCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCommand._cont = ASN1Dict([
        ('protocolIEs', _HandoverCommand_protocolIEs),
        ])
    HandoverCommand._ext = []
    
    #-----< HandoverCommandIEs >-----#
    HandoverCommandIEs = CLASS(name='HandoverCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCommandIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverCommandIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParametersfromE-UTRAN')))
    _HandoverCommandIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _HandoverCommandIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _HandoverCommandIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverCommandIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 135), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSubjecttoDataForwardingList >-----#
    E_RABSubjecttoDataForwardingList = SEQ_OF(name='E-RABSubjecttoDataForwardingList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABSubjecttoDataForwardingList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSubjecttoDataForwardingList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABSubjecttoDataForwardingList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABDataForwardingItem')))
    ___E_RABSubjecttoDataForwardingList__item__id_tab._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSubjecttoDataForwardingList__item__id._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__id._const_tab_at = None
    __E_RABSubjecttoDataForwardingList__item__id._const_tab_id = 'id'
    __E_RABSubjecttoDataForwardingList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab_id = 'criticality'
    __E_RABSubjecttoDataForwardingList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABSubjecttoDataForwardingList__item__value._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__value._const_tab_at = ('..', 'id')
    __E_RABSubjecttoDataForwardingList__item__value._const_tab_id = 'Value'
    _E_RABSubjecttoDataForwardingList__item_._cont = ASN1Dict([
        ('id', __E_RABSubjecttoDataForwardingList__item__id),
        ('criticality', __E_RABSubjecttoDataForwardingList__item__criticality),
        ('value', __E_RABSubjecttoDataForwardingList__item__value),
        ])
    _E_RABSubjecttoDataForwardingList__item_._ext = None
    E_RABSubjecttoDataForwardingList._cont = _E_RABSubjecttoDataForwardingList__item_
    E_RABSubjecttoDataForwardingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABDataForwardingItemIEs >-----#
    E_RABDataForwardingItemIEs = CLASS(name='E-RABDataForwardingItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABDataForwardingItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABDataForwardingItem')))
    E_RABDataForwardingItemIEs._val = ASN1Set(rv=[dict([('id', 14), ('criticality', 'ignore'), ('Value', _E_RABDataForwardingItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABDataForwardingItem >-----#
    E_RABDataForwardingItem = SEQ(name='E-RABDataForwardingItem', mode=MODE_TYPE)
    _E_RABDataForwardingItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABDataForwardingItem_dL_transportLayerAddress = BIT_STR(name='dL-transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABDataForwardingItem_dL_gTP_TEID = OCT_STR(name='dL-gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABDataForwardingItem_uL_TransportLayerAddress = BIT_STR(name='uL-TransportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABDataForwardingItem_uL_GTP_TEID = OCT_STR(name='uL-GTP-TEID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABDataForwardingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABDataForwardingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABDataForwardingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABDataForwardingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__id_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABDataForwardingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABDataForwardingItem_iE_Extensions__item__id),
        ('criticality', ___E_RABDataForwardingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABDataForwardingItem_iE_Extensions__item_._ext = None
    _E_RABDataForwardingItem_iE_Extensions._cont = __E_RABDataForwardingItem_iE_Extensions__item_
    _E_RABDataForwardingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABDataForwardingItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABDataForwardingItem_e_RAB_ID),
        ('dL-transportLayerAddress', _E_RABDataForwardingItem_dL_transportLayerAddress),
        ('dL-gTP-TEID', _E_RABDataForwardingItem_dL_gTP_TEID),
        ('uL-TransportLayerAddress', _E_RABDataForwardingItem_uL_TransportLayerAddress),
        ('uL-GTP-TEID', _E_RABDataForwardingItem_uL_GTP_TEID),
        ('iE-Extensions', _E_RABDataForwardingItem_iE_Extensions),
        ])
    E_RABDataForwardingItem._ext = []
    
    #-----< E-RABDataForwardingItem-ExtIEs >-----#
    E_RABDataForwardingItem_ExtIEs = CLASS(name='E-RABDataForwardingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABDataForwardingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name='HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverPreparationFailure_protocolIEs__item__id),
        ('criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        ('value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        ('protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailureIEs >-----#
    HandoverPreparationFailureIEs = CLASS(name='HandoverPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverPreparationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverPreparationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverPreparationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverPreparationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverPreparationFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name='HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListHOReq')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParameterstoE-UTRAN')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'conditional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequest_protocolIEs__item__id),
        ('criticality', ___HandoverRequest_protocolIEs__item__criticality),
        ('value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequestIEs >-----#
    HandoverRequestIEs = CLASS(name='HandoverRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListHOReq')))
    _HandoverRequestIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _HandoverRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _HandoverRequestIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _HandoverRequestIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequestIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _HandoverRequestIEs_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParameterstoE-UTRAN')))
    _HandoverRequestIEs_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequestIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _HandoverRequestIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _HandoverRequestIEs_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestIEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _HandoverRequestIEs_val_Value_18 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _HandoverRequestIEs_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _HandoverRequestIEs_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _HandoverRequestIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _HandoverRequestIEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _HandoverRequestIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _HandoverRequestIEs_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_27 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _HandoverRequestIEs_val_Value_28 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _HandoverRequestIEs_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _HandoverRequestIEs_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _HandoverRequestIEs_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _HandoverRequestIEs_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _HandoverRequestIEs_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _HandoverRequestIEs_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    HandoverRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_11), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_12), ('presence', 'conditional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_36), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListHOReq >-----#
    E_RABToBeSetupListHOReq = SEQ_OF(name='E-RABToBeSetupListHOReq', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSetupListHOReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListHOReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeSetupListHOReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemHOReq')))
    ___E_RABToBeSetupListHOReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListHOReq__item__id._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__id._const_tab_at = None
    __E_RABToBeSetupListHOReq__item__id._const_tab_id = 'id'
    __E_RABToBeSetupListHOReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeSetupListHOReq__item__criticality._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListHOReq__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeSetupListHOReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeSetupListHOReq__item__value._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListHOReq__item__value._const_tab_id = 'Value'
    _E_RABToBeSetupListHOReq__item_._cont = ASN1Dict([
        ('id', __E_RABToBeSetupListHOReq__item__id),
        ('criticality', __E_RABToBeSetupListHOReq__item__criticality),
        ('value', __E_RABToBeSetupListHOReq__item__value),
        ])
    _E_RABToBeSetupListHOReq__item_._ext = None
    E_RABToBeSetupListHOReq._cont = _E_RABToBeSetupListHOReq__item_
    E_RABToBeSetupListHOReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemHOReqIEs >-----#
    E_RABToBeSetupItemHOReqIEs = CLASS(name='E-RABToBeSetupItemHOReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemHOReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemHOReq')))
    E_RABToBeSetupItemHOReqIEs._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _E_RABToBeSetupItemHOReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemHOReq >-----#
    E_RABToBeSetupItemHOReq = SEQ(name='E-RABToBeSetupItemHOReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemHOReq_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemHOReq_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemHOReq_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters = SEQ(name='e-RABlevelQosParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemHOReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Data-Forwarding-Not-Possible')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemHOReq_iE_Extensions._cont = __E_RABToBeSetupItemHOReq_iE_Extensions__item_
    _E_RABToBeSetupItemHOReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemHOReq._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeSetupItemHOReq_e_RAB_ID),
        ('transportLayerAddress', _E_RABToBeSetupItemHOReq_transportLayerAddress),
        ('gTP-TEID', _E_RABToBeSetupItemHOReq_gTP_TEID),
        ('e-RABlevelQosParameters', _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters),
        ('iE-Extensions', _E_RABToBeSetupItemHOReq_iE_Extensions),
        ])
    E_RABToBeSetupItemHOReq._ext = []
    
    #-----< E-RABToBeSetupItemHOReq-ExtIEs >-----#
    E_RABToBeSetupItemHOReq_ExtIEs = CLASS(name='E-RABToBeSetupItemHOReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Data-Forwarding-Not-Possible')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    E_RABToBeSetupItemHOReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 143), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name='HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedList')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedtoSetupListHOReqAck')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledgeIEs >-----#
    HandoverRequestAcknowledgeIEs = CLASS(name='HandoverRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequestAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedList')))
    _HandoverRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedtoSetupListHOReqAck')))
    _HandoverRequestAcknowledgeIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverRequestAcknowledgeIEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequestAcknowledgeIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledgeIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _HandoverRequestAcknowledgeIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    HandoverRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABAdmittedList >-----#
    E_RABAdmittedList = SEQ_OF(name='E-RABAdmittedList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABAdmittedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABAdmittedList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABAdmittedList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABAdmittedList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedItem')))
    ___E_RABAdmittedList__item__id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Value', ____E_RABAdmittedList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABAdmittedList__item__id._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__id._const_tab_at = None
    __E_RABAdmittedList__item__id._const_tab_id = 'id'
    __E_RABAdmittedList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABAdmittedList__item__criticality._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABAdmittedList__item__criticality._const_tab_id = 'criticality'
    __E_RABAdmittedList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABAdmittedList__item__value._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__value._const_tab_at = ('..', 'id')
    __E_RABAdmittedList__item__value._const_tab_id = 'Value'
    _E_RABAdmittedList__item_._cont = ASN1Dict([
        ('id', __E_RABAdmittedList__item__id),
        ('criticality', __E_RABAdmittedList__item__criticality),
        ('value', __E_RABAdmittedList__item__value),
        ])
    _E_RABAdmittedList__item_._ext = None
    E_RABAdmittedList._cont = _E_RABAdmittedList__item_
    E_RABAdmittedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABAdmittedItemIEs >-----#
    E_RABAdmittedItemIEs = CLASS(name='E-RABAdmittedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABAdmittedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedItem')))
    E_RABAdmittedItemIEs._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'ignore'), ('Value', _E_RABAdmittedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABAdmittedItem >-----#
    E_RABAdmittedItem = SEQ(name='E-RABAdmittedItem', mode=MODE_TYPE)
    _E_RABAdmittedItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABAdmittedItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABAdmittedItem_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABAdmittedItem_dL_transportLayerAddress = BIT_STR(name='dL-transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABAdmittedItem_dL_gTP_TEID = OCT_STR(name='dL-gTP-TEID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABAdmittedItem_uL_TransportLayerAddress = BIT_STR(name='uL-TransportLayerAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABAdmittedItem_uL_GTP_TEID = OCT_STR(name='uL-GTP-TEID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABAdmittedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABAdmittedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABAdmittedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABAdmittedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__id_tab
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABAdmittedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABAdmittedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABAdmittedItem_iE_Extensions__item__id),
        ('criticality', ___E_RABAdmittedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABAdmittedItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABAdmittedItem_iE_Extensions__item_._ext = None
    _E_RABAdmittedItem_iE_Extensions._cont = __E_RABAdmittedItem_iE_Extensions__item_
    _E_RABAdmittedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABAdmittedItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABAdmittedItem_e_RAB_ID),
        ('transportLayerAddress', _E_RABAdmittedItem_transportLayerAddress),
        ('gTP-TEID', _E_RABAdmittedItem_gTP_TEID),
        ('dL-transportLayerAddress', _E_RABAdmittedItem_dL_transportLayerAddress),
        ('dL-gTP-TEID', _E_RABAdmittedItem_dL_gTP_TEID),
        ('uL-TransportLayerAddress', _E_RABAdmittedItem_uL_TransportLayerAddress),
        ('uL-GTP-TEID', _E_RABAdmittedItem_uL_GTP_TEID),
        ('iE-Extensions', _E_RABAdmittedItem_iE_Extensions),
        ])
    E_RABAdmittedItem._ext = []
    
    #-----< E-RABAdmittedItem-ExtIEs >-----#
    E_RABAdmittedItem_ExtIEs = CLASS(name='E-RABAdmittedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABAdmittedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedtoSetupListHOReqAck >-----#
    E_RABFailedtoSetupListHOReqAck = SEQ_OF(name='E-RABFailedtoSetupListHOReqAck', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedtoSetupListHOReqAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedtoSetupListHOReqAck__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABFailedtoSetupListHOReqAck__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToSetupItemHOReqAck')))
    ___E_RABFailedtoSetupListHOReqAck__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'ignore'), ('Value', ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab_at = None
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab_id = 'id'
    __E_RABFailedtoSetupListHOReqAck__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab_at = ('..', 'id')
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab_id = 'criticality'
    __E_RABFailedtoSetupListHOReqAck__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab_at = ('..', 'id')
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab_id = 'Value'
    _E_RABFailedtoSetupListHOReqAck__item_._cont = ASN1Dict([
        ('id', __E_RABFailedtoSetupListHOReqAck__item__id),
        ('criticality', __E_RABFailedtoSetupListHOReqAck__item__criticality),
        ('value', __E_RABFailedtoSetupListHOReqAck__item__value),
        ])
    _E_RABFailedtoSetupListHOReqAck__item_._ext = None
    E_RABFailedtoSetupListHOReqAck._cont = _E_RABFailedtoSetupListHOReqAck__item_
    E_RABFailedtoSetupListHOReqAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedtoSetupItemHOReqAckIEs >-----#
    E_RABFailedtoSetupItemHOReqAckIEs = CLASS(name='E-RABFailedtoSetupItemHOReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToSetupItemHOReqAck')))
    E_RABFailedtoSetupItemHOReqAckIEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'ignore'), ('Value', _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToSetupItemHOReqAck >-----#
    E_RABFailedToSetupItemHOReqAck = SEQ(name='E-RABFailedToSetupItemHOReqAck', mode=MODE_TYPE)
    _E_RABFailedToSetupItemHOReqAck_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToSetupItemHOReqAck_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id),
        ('criticality', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_._ext = None
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions._cont = __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToSetupItemHOReqAck._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABFailedToSetupItemHOReqAck_e_RAB_ID),
        ('cause', _E_RABFailedToSetupItemHOReqAck_cause),
        ('iE-Extensions', _E_RABFailedToSetupItemHOReqAck_iE_Extensions),
        ])
    E_RABFailedToSetupItemHOReqAck._ext = []
    
    #-----< E-RABFailedToSetupItemHOReqAckExtIEs >-----#
    E_RABFailedToSetupItemHOReqAckExtIEs = CLASS(name='E-RABFailedToSetupItemHOReqAckExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToSetupItemHOReqAckExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverFailure >-----#
    HandoverFailure = SEQ(name='HandoverFailure', mode=MODE_TYPE)
    _HandoverFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverFailure_protocolIEs__item__id._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverFailure_protocolIEs__item__criticality._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverFailure_protocolIEs__item__value._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverFailure_protocolIEs__item__id),
        ('criticality', ___HandoverFailure_protocolIEs__item__criticality),
        ('value', ___HandoverFailure_protocolIEs__item__value),
        ])
    __HandoverFailure_protocolIEs__item_._ext = None
    _HandoverFailure_protocolIEs._cont = __HandoverFailure_protocolIEs__item_
    _HandoverFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverFailure._cont = ASN1Dict([
        ('protocolIEs', _HandoverFailure_protocolIEs),
        ])
    HandoverFailure._ext = []
    
    #-----< HandoverFailureIEs >-----#
    HandoverFailureIEs = CLASS(name='HandoverFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverNotify >-----#
    HandoverNotify = SEQ(name='HandoverNotify', mode=MODE_TYPE)
    _HandoverNotify_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverNotify_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverNotify_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NotifySourceeNB')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____HandoverNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverNotify_protocolIEs__item__id._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__id._const_tab_at = None
    ___HandoverNotify_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverNotify_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverNotify_protocolIEs__item__criticality._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverNotify_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverNotify_protocolIEs__item__value._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverNotify_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverNotify_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverNotify_protocolIEs__item__id),
        ('criticality', ___HandoverNotify_protocolIEs__item__criticality),
        ('value', ___HandoverNotify_protocolIEs__item__value),
        ])
    __HandoverNotify_protocolIEs__item_._ext = None
    _HandoverNotify_protocolIEs._cont = __HandoverNotify_protocolIEs__item_
    _HandoverNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverNotify._cont = ASN1Dict([
        ('protocolIEs', _HandoverNotify_protocolIEs),
        ])
    HandoverNotify._ext = []
    
    #-----< HandoverNotifyIEs >-----#
    HandoverNotifyIEs = CLASS(name='HandoverNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverNotifyIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverNotifyIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverNotifyIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _HandoverNotifyIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _HandoverNotifyIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _HandoverNotifyIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _HandoverNotifyIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _HandoverNotifyIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NotifySourceeNB')))
    _HandoverNotifyIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    HandoverNotifyIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverNotifyIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HandoverNotifyIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequest >-----#
    PathSwitchRequest = SEQ(name='PathSwitchRequest', mode=MODE_TYPE)
    _PathSwitchRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLList')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____PathSwitchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequest_protocolIEs__item__id._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequest_protocolIEs__item__value._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequest_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequest_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequest_protocolIEs__item__value),
        ])
    __PathSwitchRequest_protocolIEs__item_._ext = None
    _PathSwitchRequest_protocolIEs._cont = __PathSwitchRequest_protocolIEs__item_
    _PathSwitchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequest._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequest_protocolIEs),
        ])
    PathSwitchRequest._ext = []
    
    #-----< PathSwitchRequestIEs >-----#
    PathSwitchRequestIEs = CLASS(name='PathSwitchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLList')))
    _PathSwitchRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _PathSwitchRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _PathSwitchRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _PathSwitchRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _PathSwitchRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _PathSwitchRequestIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _PathSwitchRequestIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _PathSwitchRequestIEs_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _PathSwitchRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _PathSwitchRequestIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _PathSwitchRequestIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    PathSwitchRequestIEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_15), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedDLList >-----#
    E_RABToBeSwitchedDLList = SEQ_OF(name='E-RABToBeSwitchedDLList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSwitchedDLList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSwitchedDLList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeSwitchedDLList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLItem')))
    ___E_RABToBeSwitchedDLList__item__id_tab._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'reject'), ('Value', ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSwitchedDLList__item__id._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__id._const_tab_at = None
    __E_RABToBeSwitchedDLList__item__id._const_tab_id = 'id'
    __E_RABToBeSwitchedDLList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeSwitchedDLList__item__criticality._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeSwitchedDLList__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeSwitchedDLList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeSwitchedDLList__item__value._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeSwitchedDLList__item__value._const_tab_id = 'Value'
    _E_RABToBeSwitchedDLList__item_._cont = ASN1Dict([
        ('id', __E_RABToBeSwitchedDLList__item__id),
        ('criticality', __E_RABToBeSwitchedDLList__item__criticality),
        ('value', __E_RABToBeSwitchedDLList__item__value),
        ])
    _E_RABToBeSwitchedDLList__item_._ext = None
    E_RABToBeSwitchedDLList._cont = _E_RABToBeSwitchedDLList__item_
    E_RABToBeSwitchedDLList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSwitchedDLItemIEs >-----#
    E_RABToBeSwitchedDLItemIEs = CLASS(name='E-RABToBeSwitchedDLItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSwitchedDLItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLItem')))
    E_RABToBeSwitchedDLItemIEs._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'reject'), ('Value', _E_RABToBeSwitchedDLItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedDLItem >-----#
    E_RABToBeSwitchedDLItem = SEQ(name='E-RABToBeSwitchedDLItem', mode=MODE_TYPE)
    _E_RABToBeSwitchedDLItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSwitchedDLItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSwitchedDLItem_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSwitchedDLItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 332), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_._ext = None
    _E_RABToBeSwitchedDLItem_iE_Extensions._cont = __E_RABToBeSwitchedDLItem_iE_Extensions__item_
    _E_RABToBeSwitchedDLItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSwitchedDLItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeSwitchedDLItem_e_RAB_ID),
        ('transportLayerAddress', _E_RABToBeSwitchedDLItem_transportLayerAddress),
        ('gTP-TEID', _E_RABToBeSwitchedDLItem_gTP_TEID),
        ('iE-Extensions', _E_RABToBeSwitchedDLItem_iE_Extensions),
        ])
    E_RABToBeSwitchedDLItem._ext = []
    
    #-----< E-RABToBeSwitchedDLItem-ExtIEs >-----#
    E_RABToBeSwitchedDLItem_ExtIEs = CLASS(name='E-RABToBeSwitchedDLItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSwitchedDLItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    E_RABToBeSwitchedDLItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 332), ('criticality', 'ignore'), ('Extension', _E_RABToBeSwitchedDLItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestAcknowledge >-----#
    PathSwitchRequestAcknowledge = SEQ(name='PathSwitchRequestAcknowledge', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeUpdatedList')))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequestAcknowledge_protocolIEs__item__value),
        ])
    __PathSwitchRequestAcknowledge_protocolIEs__item_._ext = None
    _PathSwitchRequestAcknowledge_protocolIEs._cont = __PathSwitchRequestAcknowledge_protocolIEs__item_
    _PathSwitchRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequestAcknowledge_protocolIEs),
        ])
    PathSwitchRequestAcknowledge._ext = []
    
    #-----< PathSwitchRequestAcknowledgeIEs >-----#
    PathSwitchRequestAcknowledgeIEs = CLASS(name='PathSwitchRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_24 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_26 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeUpdatedList')))
    PathSwitchRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_26), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedULList >-----#
    E_RABToBeSwitchedULList = SEQ_OF(name='E-RABToBeSwitchedULList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSwitchedULList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSwitchedULList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeSwitchedULList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULItem')))
    ___E_RABToBeSwitchedULList__item__id_tab._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSwitchedULList__item__id._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__id._const_tab_at = None
    __E_RABToBeSwitchedULList__item__id._const_tab_id = 'id'
    __E_RABToBeSwitchedULList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeSwitchedULList__item__criticality._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeSwitchedULList__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeSwitchedULList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeSwitchedULList__item__value._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeSwitchedULList__item__value._const_tab_id = 'Value'
    _E_RABToBeSwitchedULList__item_._cont = ASN1Dict([
        ('id', __E_RABToBeSwitchedULList__item__id),
        ('criticality', __E_RABToBeSwitchedULList__item__criticality),
        ('value', __E_RABToBeSwitchedULList__item__value),
        ])
    _E_RABToBeSwitchedULList__item_._ext = None
    E_RABToBeSwitchedULList._cont = _E_RABToBeSwitchedULList__item_
    E_RABToBeSwitchedULList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSwitchedULItemIEs >-----#
    E_RABToBeSwitchedULItemIEs = CLASS(name='E-RABToBeSwitchedULItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSwitchedULItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULItem')))
    E_RABToBeSwitchedULItemIEs._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', _E_RABToBeSwitchedULItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedULItem >-----#
    E_RABToBeSwitchedULItem = SEQ(name='E-RABToBeSwitchedULItem', mode=MODE_TYPE)
    _E_RABToBeSwitchedULItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSwitchedULItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSwitchedULItem_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSwitchedULItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSwitchedULItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeSwitchedULItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeSwitchedULItem_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSwitchedULItem_iE_Extensions__item_._ext = None
    _E_RABToBeSwitchedULItem_iE_Extensions._cont = __E_RABToBeSwitchedULItem_iE_Extensions__item_
    _E_RABToBeSwitchedULItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSwitchedULItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeSwitchedULItem_e_RAB_ID),
        ('transportLayerAddress', _E_RABToBeSwitchedULItem_transportLayerAddress),
        ('gTP-TEID', _E_RABToBeSwitchedULItem_gTP_TEID),
        ('iE-Extensions', _E_RABToBeSwitchedULItem_iE_Extensions),
        ])
    E_RABToBeSwitchedULItem._ext = []
    
    #-----< E-RABToBeSwitchedULItem-ExtIEs >-----#
    E_RABToBeSwitchedULItem_ExtIEs = CLASS(name='E-RABToBeSwitchedULItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeSwitchedULItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeUpdatedList >-----#
    E_RABToBeUpdatedList = SEQ_OF(name='E-RABToBeUpdatedList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeUpdatedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeUpdatedList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeUpdatedList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeUpdatedList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeUpdatedItem')))
    ___E_RABToBeUpdatedList__item__id_tab._val = ASN1Set(rv=[dict([('id', 342), ('criticality', 'ignore'), ('Value', ____E_RABToBeUpdatedList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeUpdatedList__item__id._const_tab = ___E_RABToBeUpdatedList__item__id_tab
    __E_RABToBeUpdatedList__item__id._const_tab_at = None
    __E_RABToBeUpdatedList__item__id._const_tab_id = 'id'
    __E_RABToBeUpdatedList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeUpdatedList__item__criticality._const_tab = ___E_RABToBeUpdatedList__item__id_tab
    __E_RABToBeUpdatedList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeUpdatedList__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeUpdatedList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeUpdatedList__item__value._const_tab = ___E_RABToBeUpdatedList__item__id_tab
    __E_RABToBeUpdatedList__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeUpdatedList__item__value._const_tab_id = 'Value'
    _E_RABToBeUpdatedList__item_._cont = ASN1Dict([
        ('id', __E_RABToBeUpdatedList__item__id),
        ('criticality', __E_RABToBeUpdatedList__item__criticality),
        ('value', __E_RABToBeUpdatedList__item__value),
        ])
    _E_RABToBeUpdatedList__item_._ext = None
    E_RABToBeUpdatedList._cont = _E_RABToBeUpdatedList__item_
    E_RABToBeUpdatedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeUpdatedItemIEs >-----#
    E_RABToBeUpdatedItemIEs = CLASS(name='E-RABToBeUpdatedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeUpdatedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeUpdatedItem')))
    E_RABToBeUpdatedItemIEs._val = ASN1Set(rv=[dict([('id', 342), ('criticality', 'ignore'), ('Value', _E_RABToBeUpdatedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeUpdatedItem >-----#
    E_RABToBeUpdatedItem = SEQ(name='E-RABToBeUpdatedItem', mode=MODE_TYPE)
    _E_RABToBeUpdatedItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeUpdatedItem_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')), opt=True)
    _E_RABToBeUpdatedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeUpdatedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeUpdatedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeUpdatedItem_iE_Extensions__item__id._const_tab = ____E_RABToBeUpdatedItem_iE_Extensions__item__id_tab
    ___E_RABToBeUpdatedItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeUpdatedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality._const_tab = ____E_RABToBeUpdatedItem_iE_Extensions__item__criticality_tab
    ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeUpdatedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeUpdatedItem_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeUpdatedItem_iE_Extensions__item_._ext = None
    _E_RABToBeUpdatedItem_iE_Extensions._cont = __E_RABToBeUpdatedItem_iE_Extensions__item_
    _E_RABToBeUpdatedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeUpdatedItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeUpdatedItem_e_RAB_ID),
        ('securityIndication', _E_RABToBeUpdatedItem_securityIndication),
        ('iE-Extensions', _E_RABToBeUpdatedItem_iE_Extensions),
        ])
    E_RABToBeUpdatedItem._ext = []
    
    #-----< E-RABToBeUpdatedItem-ExtIEs >-----#
    E_RABToBeUpdatedItem_ExtIEs = CLASS(name='E-RABToBeUpdatedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeUpdatedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestFailure >-----#
    PathSwitchRequestFailure = SEQ(name='PathSwitchRequestFailure', mode=MODE_TYPE)
    _PathSwitchRequestFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequestFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequestFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestFailure_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequestFailure_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequestFailure_protocolIEs__item__value),
        ])
    __PathSwitchRequestFailure_protocolIEs__item_._ext = None
    _PathSwitchRequestFailure_protocolIEs._cont = __PathSwitchRequestFailure_protocolIEs__item_
    _PathSwitchRequestFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestFailure._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequestFailure_protocolIEs),
        ])
    PathSwitchRequestFailure._ext = []
    
    #-----< PathSwitchRequestFailureIEs >-----#
    PathSwitchRequestFailureIEs = CLASS(name='PathSwitchRequestFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _PathSwitchRequestFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    PathSwitchRequestFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name='HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCancel_protocolIEs__item__id),
        ('criticality', ___HandoverCancel_protocolIEs__item__criticality),
        ('value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        ('protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancelIEs >-----#
    HandoverCancelIEs = CLASS(name='HandoverCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCancelIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCancelIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCancelIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    HandoverCancelIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverCancelIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HandoverCancelIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _HandoverCancelIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancelAcknowledge >-----#
    HandoverCancelAcknowledge = SEQ(name='HandoverCancelAcknowledge', mode=MODE_TYPE)
    _HandoverCancelAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancelAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCancelAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCancelAcknowledge_protocolIEs__item__id),
        ('criticality', ___HandoverCancelAcknowledge_protocolIEs__item__criticality),
        ('value', ___HandoverCancelAcknowledge_protocolIEs__item__value),
        ])
    __HandoverCancelAcknowledge_protocolIEs__item_._ext = None
    _HandoverCancelAcknowledge_protocolIEs._cont = __HandoverCancelAcknowledge_protocolIEs__item_
    _HandoverCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancelAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _HandoverCancelAcknowledge_protocolIEs),
        ])
    HandoverCancelAcknowledge._ext = []
    
    #-----< HandoverCancelAcknowledgeIEs >-----#
    HandoverCancelAcknowledgeIEs = CLASS(name='HandoverCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCancelAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverSuccess >-----#
    HandoverSuccess = SEQ(name='HandoverSuccess', mode=MODE_TYPE)
    _HandoverSuccess_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverSuccess_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____HandoverSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____HandoverSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverSuccess_protocolIEs__item__id._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__id._const_tab_at = None
    ___HandoverSuccess_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverSuccess_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverSuccess_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___HandoverSuccess_protocolIEs__item__value._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverSuccess_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverSuccess_protocolIEs__item__id),
        ('criticality', ___HandoverSuccess_protocolIEs__item__criticality),
        ('value', ___HandoverSuccess_protocolIEs__item__value),
        ])
    __HandoverSuccess_protocolIEs__item_._ext = None
    _HandoverSuccess_protocolIEs._cont = __HandoverSuccess_protocolIEs__item_
    _HandoverSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverSuccess._cont = ASN1Dict([
        ('protocolIEs', _HandoverSuccess_protocolIEs),
        ])
    HandoverSuccess._ext = []
    
    #-----< HandoverSuccessIEs >-----#
    HandoverSuccessIEs = CLASS(name='HandoverSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverSuccessIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverSuccessIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    HandoverSuccessIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverSuccessIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _HandoverSuccessIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENBEarlyStatusTransfer >-----#
    ENBEarlyStatusTransfer = SEQ(name='ENBEarlyStatusTransfer', mode=MODE_TYPE)
    _ENBEarlyStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBEarlyStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 321), ('criticality', 'reject'), ('Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBEarlyStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBEarlyStatusTransfer_protocolIEs__item__id),
        ('criticality', ___ENBEarlyStatusTransfer_protocolIEs__item__criticality),
        ('value', ___ENBEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __ENBEarlyStatusTransfer_protocolIEs__item_._ext = None
    _ENBEarlyStatusTransfer_protocolIEs._cont = __ENBEarlyStatusTransfer_protocolIEs__item_
    _ENBEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBEarlyStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _ENBEarlyStatusTransfer_protocolIEs),
        ])
    ENBEarlyStatusTransfer._ext = []
    
    #-----< ENBEarlyStatusTransferIEs >-----#
    ENBEarlyStatusTransferIEs = CLASS(name='ENBEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBEarlyStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ENBEarlyStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBEarlyStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ENBEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _ENBEarlyStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _ENBEarlyStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 321), ('criticality', 'reject'), ('Value', _ENBEarlyStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MMEEarlyStatusTransfer >-----#
    MMEEarlyStatusTransfer = SEQ(name='MMEEarlyStatusTransfer', mode=MODE_TYPE)
    _MMEEarlyStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEEarlyStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 321), ('criticality', 'reject'), ('Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEEarlyStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEEarlyStatusTransfer_protocolIEs__item__id),
        ('criticality', ___MMEEarlyStatusTransfer_protocolIEs__item__criticality),
        ('value', ___MMEEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __MMEEarlyStatusTransfer_protocolIEs__item_._ext = None
    _MMEEarlyStatusTransfer_protocolIEs._cont = __MMEEarlyStatusTransfer_protocolIEs__item_
    _MMEEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEEarlyStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _MMEEarlyStatusTransfer_protocolIEs),
        ])
    MMEEarlyStatusTransfer._ext = []
    
    #-----< MMEEarlyStatusTransferIEs >-----#
    MMEEarlyStatusTransferIEs = CLASS(name='MMEEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEEarlyStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMEEarlyStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _MMEEarlyStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    MMEEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _MMEEarlyStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _MMEEarlyStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 321), ('criticality', 'reject'), ('Value', _MMEEarlyStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupRequest >-----#
    E_RABSetupRequest = SEQ(name='E-RABSetupRequest', mode=MODE_TYPE)
    _E_RABSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListBearerSUReq')))
    ____E_RABSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABSetupRequest_protocolIEs__item__id),
        ('criticality', ___E_RABSetupRequest_protocolIEs__item__criticality),
        ('value', ___E_RABSetupRequest_protocolIEs__item__value),
        ])
    __E_RABSetupRequest_protocolIEs__item_._ext = None
    _E_RABSetupRequest_protocolIEs._cont = __E_RABSetupRequest_protocolIEs__item_
    _E_RABSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _E_RABSetupRequest_protocolIEs),
        ])
    E_RABSetupRequest._ext = []
    
    #-----< E-RABSetupRequestIEs >-----#
    E_RABSetupRequestIEs = CLASS(name='E-RABSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABSetupRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListBearerSUReq')))
    E_RABSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _E_RABSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _E_RABSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _E_RABSetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 16), ('criticality', 'reject'), ('Value', _E_RABSetupRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListBearerSUReq >-----#
    E_RABToBeSetupListBearerSUReq = SEQ_OF(name='E-RABToBeSetupListBearerSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupListBearerSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListBearerSUReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeSetupListBearerSUReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemBearerSUReq')))
    ___E_RABToBeSetupListBearerSUReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'reject'), ('Value', ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab_at = None
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab_id = 'id'
    __E_RABToBeSetupListBearerSUReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeSetupListBearerSUReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab_id = 'Value'
    _E_RABToBeSetupListBearerSUReq__item_._cont = ASN1Dict([
        ('id', __E_RABToBeSetupListBearerSUReq__item__id),
        ('criticality', __E_RABToBeSetupListBearerSUReq__item__criticality),
        ('value', __E_RABToBeSetupListBearerSUReq__item__value),
        ])
    _E_RABToBeSetupListBearerSUReq__item_._ext = None
    E_RABToBeSetupListBearerSUReq._cont = _E_RABToBeSetupListBearerSUReq__item_
    E_RABToBeSetupListBearerSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemBearerSUReqIEs >-----#
    E_RABToBeSetupItemBearerSUReqIEs = CLASS(name='E-RABToBeSetupItemBearerSUReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemBearerSUReq')))
    E_RABToBeSetupItemBearerSUReqIEs._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'reject'), ('Value', _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemBearerSUReq >-----#
    E_RABToBeSetupItemBearerSUReq = SEQ(name='E-RABToBeSetupItemBearerSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemBearerSUReq_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters = SEQ(name='e-RABlevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemBearerSUReq_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemBearerSUReq_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemBearerSUReq_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions._cont = __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemBearerSUReq._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeSetupItemBearerSUReq_e_RAB_ID),
        ('e-RABlevelQoSParameters', _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters),
        ('transportLayerAddress', _E_RABToBeSetupItemBearerSUReq_transportLayerAddress),
        ('gTP-TEID', _E_RABToBeSetupItemBearerSUReq_gTP_TEID),
        ('nAS-PDU', _E_RABToBeSetupItemBearerSUReq_nAS_PDU),
        ('iE-Extensions', _E_RABToBeSetupItemBearerSUReq_iE_Extensions),
        ])
    E_RABToBeSetupItemBearerSUReq._ext = []
    
    #-----< E-RABToBeSetupItemBearerSUReqExtIEs >-----#
    E_RABToBeSetupItemBearerSUReqExtIEs = CLASS(name='E-RABToBeSetupItemBearerSUReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    E_RABToBeSetupItemBearerSUReqExtIEs._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupResponse >-----#
    E_RABSetupResponse = SEQ(name='E-RABSetupResponse', mode=MODE_TYPE)
    _E_RABSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListBearerSURes')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    ____E_RABSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABSetupResponse_protocolIEs__item__id),
        ('criticality', ___E_RABSetupResponse_protocolIEs__item__criticality),
        ('value', ___E_RABSetupResponse_protocolIEs__item__value),
        ])
    __E_RABSetupResponse_protocolIEs__item_._ext = None
    _E_RABSetupResponse_protocolIEs._cont = __E_RABSetupResponse_protocolIEs__item_
    _E_RABSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _E_RABSetupResponse_protocolIEs),
        ])
    E_RABSetupResponse._ext = []
    
    #-----< E-RABSetupResponseIEs >-----#
    E_RABSetupResponseIEs = CLASS(name='E-RABSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListBearerSURes')))
    _E_RABSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABSetupResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    E_RABSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _E_RABSetupResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupListBearerSURes >-----#
    E_RABSetupListBearerSURes = SEQ_OF(name='E-RABSetupListBearerSURes', mode=MODE_TYPE)
    _E_RABSetupListBearerSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSetupListBearerSURes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABSetupListBearerSURes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemBearerSURes')))
    ___E_RABSetupListBearerSURes__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'ignore'), ('Value', ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSetupListBearerSURes__item__id._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__id._const_tab_at = None
    __E_RABSetupListBearerSURes__item__id._const_tab_id = 'id'
    __E_RABSetupListBearerSURes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABSetupListBearerSURes__item__criticality._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__criticality._const_tab_at = ('..', 'id')
    __E_RABSetupListBearerSURes__item__criticality._const_tab_id = 'criticality'
    __E_RABSetupListBearerSURes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABSetupListBearerSURes__item__value._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__value._const_tab_at = ('..', 'id')
    __E_RABSetupListBearerSURes__item__value._const_tab_id = 'Value'
    _E_RABSetupListBearerSURes__item_._cont = ASN1Dict([
        ('id', __E_RABSetupListBearerSURes__item__id),
        ('criticality', __E_RABSetupListBearerSURes__item__criticality),
        ('value', __E_RABSetupListBearerSURes__item__value),
        ])
    _E_RABSetupListBearerSURes__item_._ext = None
    E_RABSetupListBearerSURes._cont = _E_RABSetupListBearerSURes__item_
    E_RABSetupListBearerSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABSetupItemBearerSUResIEs >-----#
    E_RABSetupItemBearerSUResIEs = CLASS(name='E-RABSetupItemBearerSUResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupItemBearerSUResIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemBearerSURes')))
    E_RABSetupItemBearerSUResIEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'ignore'), ('Value', _E_RABSetupItemBearerSUResIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupItemBearerSURes >-----#
    E_RABSetupItemBearerSURes = SEQ(name='E-RABSetupItemBearerSURes', mode=MODE_TYPE)
    _E_RABSetupItemBearerSURes_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABSetupItemBearerSURes_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABSetupItemBearerSURes_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABSetupItemBearerSURes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABSetupItemBearerSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABSetupItemBearerSURes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABSetupItemBearerSURes_iE_Extensions__item__id),
        ('criticality', ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue),
        ])
    __E_RABSetupItemBearerSURes_iE_Extensions__item_._ext = None
    _E_RABSetupItemBearerSURes_iE_Extensions._cont = __E_RABSetupItemBearerSURes_iE_Extensions__item_
    _E_RABSetupItemBearerSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABSetupItemBearerSURes._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABSetupItemBearerSURes_e_RAB_ID),
        ('transportLayerAddress', _E_RABSetupItemBearerSURes_transportLayerAddress),
        ('gTP-TEID', _E_RABSetupItemBearerSURes_gTP_TEID),
        ('iE-Extensions', _E_RABSetupItemBearerSURes_iE_Extensions),
        ])
    E_RABSetupItemBearerSURes._ext = []
    
    #-----< E-RABSetupItemBearerSUResExtIEs >-----#
    E_RABSetupItemBearerSUResExtIEs = CLASS(name='E-RABSetupItemBearerSUResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABSetupItemBearerSUResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyRequest >-----#
    E_RABModifyRequest = SEQ(name='E-RABModifyRequest', mode=MODE_TYPE)
    _E_RABModifyRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModifyRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModReq')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageRequest')))
    ____E_RABModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABModifyRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABModifyRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABModifyRequest_protocolIEs__item__id),
        ('criticality', ___E_RABModifyRequest_protocolIEs__item__criticality),
        ('value', ___E_RABModifyRequest_protocolIEs__item__value),
        ])
    __E_RABModifyRequest_protocolIEs__item_._ext = None
    _E_RABModifyRequest_protocolIEs._cont = __E_RABModifyRequest_protocolIEs__item_
    _E_RABModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModifyRequest._cont = ASN1Dict([
        ('protocolIEs', _E_RABModifyRequest_protocolIEs),
        ])
    E_RABModifyRequest._ext = []
    
    #-----< E-RABModifyRequestIEs >-----#
    E_RABModifyRequestIEs = CLASS(name='E-RABModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModifyRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModifyRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABModifyRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModReq')))
    _E_RABModifyRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageRequest')))
    E_RABModifyRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _E_RABModifyRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _E_RABModifyRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _E_RABModifyRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _E_RABModifyRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'ignore'), ('Value', _E_RABModifyRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedListBearerModReq >-----#
    E_RABToBeModifiedListBearerModReq = SEQ_OF(name='E-RABToBeModifiedListBearerModReq', mode=MODE_TYPE)
    _E_RABToBeModifiedListBearerModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeModifiedListBearerModReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeModifiedListBearerModReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModReq')))
    ___E_RABToBeModifiedListBearerModReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab_at = None
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab_id = 'id'
    __E_RABToBeModifiedListBearerModReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeModifiedListBearerModReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab_id = 'Value'
    _E_RABToBeModifiedListBearerModReq__item_._cont = ASN1Dict([
        ('id', __E_RABToBeModifiedListBearerModReq__item__id),
        ('criticality', __E_RABToBeModifiedListBearerModReq__item__criticality),
        ('value', __E_RABToBeModifiedListBearerModReq__item__value),
        ])
    _E_RABToBeModifiedListBearerModReq__item_._ext = None
    E_RABToBeModifiedListBearerModReq._cont = _E_RABToBeModifiedListBearerModReq__item_
    E_RABToBeModifiedListBearerModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeModifiedItemBearerModReqIEs >-----#
    E_RABToBeModifiedItemBearerModReqIEs = CLASS(name='E-RABToBeModifiedItemBearerModReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModReq')))
    E_RABToBeModifiedItemBearerModReqIEs._val = ASN1Set(rv=[dict([('id', 36), ('criticality', 'reject'), ('Value', _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedItemBearerModReq >-----#
    E_RABToBeModifiedItemBearerModReq = SEQ(name='E-RABToBeModifiedItemBearerModReq', mode=MODE_TYPE)
    _E_RABToBeModifiedItemBearerModReq_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters = SEQ(name='e-RABLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeModifiedItemBearerModReq_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportInformation')))
    ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Extension', _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_._ext = None
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions._cont = __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeModifiedItemBearerModReq._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeModifiedItemBearerModReq_e_RAB_ID),
        ('e-RABLevelQoSParameters', _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters),
        ('nAS-PDU', _E_RABToBeModifiedItemBearerModReq_nAS_PDU),
        ('iE-Extensions', _E_RABToBeModifiedItemBearerModReq_iE_Extensions),
        ])
    E_RABToBeModifiedItemBearerModReq._ext = []
    
    #-----< E-RABToBeModifyItemBearerModReqExtIEs >-----#
    E_RABToBeModifyItemBearerModReqExtIEs = CLASS(name='E-RABToBeModifyItemBearerModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportInformation')))
    E_RABToBeModifyItemBearerModReqExtIEs._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Extension', _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyResponse >-----#
    E_RABModifyResponse = SEQ(name='E-RABModifyResponse', mode=MODE_TYPE)
    _E_RABModifyResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModifyResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModifyResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABModifyResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModRes')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    ____E_RABModifyResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABModifyResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABModifyResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABModifyResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABModifyResponse_protocolIEs__item__id),
        ('criticality', ___E_RABModifyResponse_protocolIEs__item__criticality),
        ('value', ___E_RABModifyResponse_protocolIEs__item__value),
        ])
    __E_RABModifyResponse_protocolIEs__item_._ext = None
    _E_RABModifyResponse_protocolIEs._cont = __E_RABModifyResponse_protocolIEs__item_
    _E_RABModifyResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModifyResponse._cont = ASN1Dict([
        ('protocolIEs', _E_RABModifyResponse_protocolIEs),
        ])
    E_RABModifyResponse._ext = []
    
    #-----< E-RABModifyResponseIEs >-----#
    E_RABModifyResponseIEs = CLASS(name='E-RABModifyResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModifyResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModifyResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModRes')))
    _E_RABModifyResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModifyResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABModifyResponseIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _E_RABModifyResponseIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    E_RABModifyResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _E_RABModifyResponseIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyListBearerModRes >-----#
    E_RABModifyListBearerModRes = SEQ_OF(name='E-RABModifyListBearerModRes', mode=MODE_TYPE)
    _E_RABModifyListBearerModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABModifyListBearerModRes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABModifyListBearerModRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModRes')))
    ___E_RABModifyListBearerModRes__item__id_tab._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABModifyListBearerModRes__item__id._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__id._const_tab_at = None
    __E_RABModifyListBearerModRes__item__id._const_tab_id = 'id'
    __E_RABModifyListBearerModRes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABModifyListBearerModRes__item__criticality._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__criticality._const_tab_at = ('..', 'id')
    __E_RABModifyListBearerModRes__item__criticality._const_tab_id = 'criticality'
    __E_RABModifyListBearerModRes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABModifyListBearerModRes__item__value._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__value._const_tab_at = ('..', 'id')
    __E_RABModifyListBearerModRes__item__value._const_tab_id = 'Value'
    _E_RABModifyListBearerModRes__item_._cont = ASN1Dict([
        ('id', __E_RABModifyListBearerModRes__item__id),
        ('criticality', __E_RABModifyListBearerModRes__item__criticality),
        ('value', __E_RABModifyListBearerModRes__item__value),
        ])
    _E_RABModifyListBearerModRes__item_._ext = None
    E_RABModifyListBearerModRes._cont = _E_RABModifyListBearerModRes__item_
    E_RABModifyListBearerModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABModifyItemBearerModResIEs >-----#
    E_RABModifyItemBearerModResIEs = CLASS(name='E-RABModifyItemBearerModResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyItemBearerModResIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModRes')))
    E_RABModifyItemBearerModResIEs._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', _E_RABModifyItemBearerModResIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyItemBearerModRes >-----#
    E_RABModifyItemBearerModRes = SEQ(name='E-RABModifyItemBearerModRes', mode=MODE_TYPE)
    _E_RABModifyItemBearerModRes_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABModifyItemBearerModRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABModifyItemBearerModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABModifyItemBearerModRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABModifyItemBearerModRes_iE_Extensions__item__id),
        ('criticality', ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue),
        ])
    __E_RABModifyItemBearerModRes_iE_Extensions__item_._ext = None
    _E_RABModifyItemBearerModRes_iE_Extensions._cont = __E_RABModifyItemBearerModRes_iE_Extensions__item_
    _E_RABModifyItemBearerModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABModifyItemBearerModRes._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABModifyItemBearerModRes_e_RAB_ID),
        ('iE-Extensions', _E_RABModifyItemBearerModRes_iE_Extensions),
        ])
    E_RABModifyItemBearerModRes._ext = []
    
    #-----< E-RABModifyItemBearerModResExtIEs >-----#
    E_RABModifyItemBearerModResExtIEs = CLASS(name='E-RABModifyItemBearerModResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABModifyItemBearerModResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseCommand >-----#
    E_RABReleaseCommand = SEQ(name='E-RABReleaseCommand', mode=MODE_TYPE)
    _E_RABReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    ____E_RABReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABReleaseCommand_protocolIEs__item__id),
        ('criticality', ___E_RABReleaseCommand_protocolIEs__item__criticality),
        ('value', ___E_RABReleaseCommand_protocolIEs__item__value),
        ])
    __E_RABReleaseCommand_protocolIEs__item_._ext = None
    _E_RABReleaseCommand_protocolIEs._cont = __E_RABReleaseCommand_protocolIEs__item_
    _E_RABReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _E_RABReleaseCommand_protocolIEs),
        ])
    E_RABReleaseCommand._ext = []
    
    #-----< E-RABReleaseCommandIEs >-----#
    E_RABReleaseCommandIEs = CLASS(name='E-RABReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseCommandIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABReleaseCommandIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseCommandIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    E_RABReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _E_RABReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _E_RABReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _E_RABReleaseCommandIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _E_RABReleaseCommandIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _E_RABReleaseCommandIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseResponse >-----#
    E_RABReleaseResponse = SEQ(name='E-RABReleaseResponse', mode=MODE_TYPE)
    _E_RABReleaseResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseListBearerRelComp')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____E_RABReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABReleaseResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABReleaseResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABReleaseResponse_protocolIEs__item__id),
        ('criticality', ___E_RABReleaseResponse_protocolIEs__item__criticality),
        ('value', ___E_RABReleaseResponse_protocolIEs__item__value),
        ])
    __E_RABReleaseResponse_protocolIEs__item_._ext = None
    _E_RABReleaseResponse_protocolIEs._cont = __E_RABReleaseResponse_protocolIEs__item_
    _E_RABReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseResponse._cont = ASN1Dict([
        ('protocolIEs', _E_RABReleaseResponse_protocolIEs),
        ])
    E_RABReleaseResponse._ext = []
    
    #-----< E-RABReleaseResponseIEs >-----#
    E_RABReleaseResponseIEs = CLASS(name='E-RABReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseListBearerRelComp')))
    _E_RABReleaseResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABReleaseResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _E_RABReleaseResponseIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    E_RABReleaseResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _E_RABReleaseResponseIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseListBearerRelComp >-----#
    E_RABReleaseListBearerRelComp = SEQ_OF(name='E-RABReleaseListBearerRelComp', mode=MODE_TYPE)
    _E_RABReleaseListBearerRelComp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABReleaseListBearerRelComp__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABReleaseListBearerRelComp__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseItemBearerRelComp')))
    ___E_RABReleaseListBearerRelComp__item__id_tab._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABReleaseListBearerRelComp__item__id._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__id._const_tab_at = None
    __E_RABReleaseListBearerRelComp__item__id._const_tab_id = 'id'
    __E_RABReleaseListBearerRelComp__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab_at = ('..', 'id')
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab_id = 'criticality'
    __E_RABReleaseListBearerRelComp__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABReleaseListBearerRelComp__item__value._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__value._const_tab_at = ('..', 'id')
    __E_RABReleaseListBearerRelComp__item__value._const_tab_id = 'Value'
    _E_RABReleaseListBearerRelComp__item_._cont = ASN1Dict([
        ('id', __E_RABReleaseListBearerRelComp__item__id),
        ('criticality', __E_RABReleaseListBearerRelComp__item__criticality),
        ('value', __E_RABReleaseListBearerRelComp__item__value),
        ])
    _E_RABReleaseListBearerRelComp__item_._ext = None
    E_RABReleaseListBearerRelComp._cont = _E_RABReleaseListBearerRelComp__item_
    E_RABReleaseListBearerRelComp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABReleaseItemBearerRelCompIEs >-----#
    E_RABReleaseItemBearerRelCompIEs = CLASS(name='E-RABReleaseItemBearerRelCompIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseItemBearerRelCompIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseItemBearerRelComp')))
    E_RABReleaseItemBearerRelCompIEs._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _E_RABReleaseItemBearerRelCompIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseItemBearerRelComp >-----#
    E_RABReleaseItemBearerRelComp = SEQ(name='E-RABReleaseItemBearerRelComp', mode=MODE_TYPE)
    _E_RABReleaseItemBearerRelComp_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABReleaseItemBearerRelComp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab_at = None
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id),
        ('criticality', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue),
        ])
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_._ext = None
    _E_RABReleaseItemBearerRelComp_iE_Extensions._cont = __E_RABReleaseItemBearerRelComp_iE_Extensions__item_
    _E_RABReleaseItemBearerRelComp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABReleaseItemBearerRelComp._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABReleaseItemBearerRelComp_e_RAB_ID),
        ('iE-Extensions', _E_RABReleaseItemBearerRelComp_iE_Extensions),
        ])
    E_RABReleaseItemBearerRelComp._ext = []
    
    #-----< E-RABReleaseItemBearerRelCompExtIEs >-----#
    E_RABReleaseItemBearerRelCompExtIEs = CLASS(name='E-RABReleaseItemBearerRelCompExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABReleaseItemBearerRelCompExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseIndication >-----#
    E_RABReleaseIndication = SEQ(name='E-RABReleaseIndication', mode=MODE_TYPE)
    _E_RABReleaseIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABReleaseIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____E_RABReleaseIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABReleaseIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABReleaseIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABReleaseIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABReleaseIndication_protocolIEs__item__id),
        ('criticality', ___E_RABReleaseIndication_protocolIEs__item__criticality),
        ('value', ___E_RABReleaseIndication_protocolIEs__item__value),
        ])
    __E_RABReleaseIndication_protocolIEs__item_._ext = None
    _E_RABReleaseIndication_protocolIEs._cont = __E_RABReleaseIndication_protocolIEs__item_
    _E_RABReleaseIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseIndication._cont = ASN1Dict([
        ('protocolIEs', _E_RABReleaseIndication_protocolIEs),
        ])
    E_RABReleaseIndication._ext = []
    
    #-----< E-RABReleaseIndicationIEs >-----#
    E_RABReleaseIndicationIEs = CLASS(name='E-RABReleaseIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _E_RABReleaseIndicationIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    E_RABReleaseIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _E_RABReleaseIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _E_RABReleaseIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _E_RABReleaseIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _E_RABReleaseIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _E_RABReleaseIndicationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupRequest >-----#
    InitialContextSetupRequest = SEQ(name='InitialContextSetupRequest', mode=MODE_TYPE)
    _InitialContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListCtxtSUReq')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'conditional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupRequest_protocolIEs__item__value),
        ])
    __InitialContextSetupRequest_protocolIEs__item_._ext = None
    _InitialContextSetupRequest_protocolIEs._cont = __InitialContextSetupRequest_protocolIEs__item_
    _InitialContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupRequest_protocolIEs),
        ])
    InitialContextSetupRequest._ext = []
    
    #-----< InitialContextSetupRequestIEs >-----#
    InitialContextSetupRequestIEs = CLASS(name='InitialContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListCtxtSUReq')))
    _InitialContextSetupRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _InitialContextSetupRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _InitialContextSetupRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _InitialContextSetupRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _InitialContextSetupRequestIEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _InitialContextSetupRequestIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _InitialContextSetupRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _InitialContextSetupRequestIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _InitialContextSetupRequestIEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _InitialContextSetupRequestIEs_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _InitialContextSetupRequestIEs_val_Value_17 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _InitialContextSetupRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _InitialContextSetupRequestIEs_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _InitialContextSetupRequestIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _InitialContextSetupRequestIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _InitialContextSetupRequestIEs_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_27 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _InitialContextSetupRequestIEs_val_Value_28 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _InitialContextSetupRequestIEs_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _InitialContextSetupRequestIEs_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _InitialContextSetupRequestIEs_val_Value_31 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _InitialContextSetupRequestIEs_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _InitialContextSetupRequestIEs_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_35 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _InitialContextSetupRequestIEs_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    InitialContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_18), ('presence', 'conditional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 196), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_36), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListCtxtSUReq >-----#
    E_RABToBeSetupListCtxtSUReq = SEQ_OF(name='E-RABToBeSetupListCtxtSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupListCtxtSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListCtxtSUReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeSetupListCtxtSUReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemCtxtSUReq')))
    ___E_RABToBeSetupListCtxtSUReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'reject'), ('Value', ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab_at = None
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab_id = 'id'
    __E_RABToBeSetupListCtxtSUReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeSetupListCtxtSUReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab_id = 'Value'
    _E_RABToBeSetupListCtxtSUReq__item_._cont = ASN1Dict([
        ('id', __E_RABToBeSetupListCtxtSUReq__item__id),
        ('criticality', __E_RABToBeSetupListCtxtSUReq__item__criticality),
        ('value', __E_RABToBeSetupListCtxtSUReq__item__value),
        ])
    _E_RABToBeSetupListCtxtSUReq__item_._ext = None
    E_RABToBeSetupListCtxtSUReq._cont = _E_RABToBeSetupListCtxtSUReq__item_
    E_RABToBeSetupListCtxtSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemCtxtSUReqIEs >-----#
    E_RABToBeSetupItemCtxtSUReqIEs = CLASS(name='E-RABToBeSetupItemCtxtSUReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemCtxtSUReq')))
    E_RABToBeSetupItemCtxtSUReqIEs._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'reject'), ('Value', _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemCtxtSUReq >-----#
    E_RABToBeSetupItemCtxtSUReq = SEQ(name='E-RABToBeSetupItemCtxtSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters = SEQ(name='e-RABlevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemCtxtSUReq_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemCtxtSUReq_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')), opt=True)
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions._cont = __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemCtxtSUReq._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID),
        ('e-RABlevelQoSParameters', _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters),
        ('transportLayerAddress', _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress),
        ('gTP-TEID', _E_RABToBeSetupItemCtxtSUReq_gTP_TEID),
        ('nAS-PDU', _E_RABToBeSetupItemCtxtSUReq_nAS_PDU),
        ('iE-Extensions', _E_RABToBeSetupItemCtxtSUReq_iE_Extensions),
        ])
    E_RABToBeSetupItemCtxtSUReq._ext = []
    
    #-----< E-RABToBeSetupItemCtxtSUReqExtIEs >-----#
    E_RABToBeSetupItemCtxtSUReqExtIEs = CLASS(name='E-RABToBeSetupItemCtxtSUReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityIndication')))
    E_RABToBeSetupItemCtxtSUReqExtIEs._val = ASN1Set(rv=[dict([('id', 156), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'reject'), ('Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupResponse >-----#
    InitialContextSetupResponse = SEQ(name='InitialContextSetupResponse', mode=MODE_TYPE)
    _InitialContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListCtxtSURes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupResponse_protocolIEs__item__value),
        ])
    __InitialContextSetupResponse_protocolIEs__item_._ext = None
    _InitialContextSetupResponse_protocolIEs._cont = __InitialContextSetupResponse_protocolIEs__item_
    _InitialContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupResponse_protocolIEs),
        ])
    InitialContextSetupResponse._ext = []
    
    #-----< InitialContextSetupResponseIEs >-----#
    InitialContextSetupResponseIEs = CLASS(name='InitialContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListCtxtSURes')))
    _InitialContextSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _InitialContextSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupListCtxtSURes >-----#
    E_RABSetupListCtxtSURes = SEQ_OF(name='E-RABSetupListCtxtSURes', mode=MODE_TYPE)
    _E_RABSetupListCtxtSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSetupListCtxtSURes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABSetupListCtxtSURes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemCtxtSURes')))
    ___E_RABSetupListCtxtSURes__item__id_tab._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Value', ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSetupListCtxtSURes__item__id._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__id._const_tab_at = None
    __E_RABSetupListCtxtSURes__item__id._const_tab_id = 'id'
    __E_RABSetupListCtxtSURes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABSetupListCtxtSURes__item__criticality._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__criticality._const_tab_at = ('..', 'id')
    __E_RABSetupListCtxtSURes__item__criticality._const_tab_id = 'criticality'
    __E_RABSetupListCtxtSURes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABSetupListCtxtSURes__item__value._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__value._const_tab_at = ('..', 'id')
    __E_RABSetupListCtxtSURes__item__value._const_tab_id = 'Value'
    _E_RABSetupListCtxtSURes__item_._cont = ASN1Dict([
        ('id', __E_RABSetupListCtxtSURes__item__id),
        ('criticality', __E_RABSetupListCtxtSURes__item__criticality),
        ('value', __E_RABSetupListCtxtSURes__item__value),
        ])
    _E_RABSetupListCtxtSURes__item_._ext = None
    E_RABSetupListCtxtSURes._cont = _E_RABSetupListCtxtSURes__item_
    E_RABSetupListCtxtSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABSetupItemCtxtSUResIEs >-----#
    E_RABSetupItemCtxtSUResIEs = CLASS(name='E-RABSetupItemCtxtSUResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupItemCtxtSUResIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemCtxtSURes')))
    E_RABSetupItemCtxtSUResIEs._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Value', _E_RABSetupItemCtxtSUResIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupItemCtxtSURes >-----#
    E_RABSetupItemCtxtSURes = SEQ(name='E-RABSetupItemCtxtSURes', mode=MODE_TYPE)
    _E_RABSetupItemCtxtSURes_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABSetupItemCtxtSURes_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABSetupItemCtxtSURes_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABSetupItemCtxtSURes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id),
        ('criticality', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue),
        ])
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_._ext = None
    _E_RABSetupItemCtxtSURes_iE_Extensions._cont = __E_RABSetupItemCtxtSURes_iE_Extensions__item_
    _E_RABSetupItemCtxtSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABSetupItemCtxtSURes._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABSetupItemCtxtSURes_e_RAB_ID),
        ('transportLayerAddress', _E_RABSetupItemCtxtSURes_transportLayerAddress),
        ('gTP-TEID', _E_RABSetupItemCtxtSURes_gTP_TEID),
        ('iE-Extensions', _E_RABSetupItemCtxtSURes_iE_Extensions),
        ])
    E_RABSetupItemCtxtSURes._ext = []
    
    #-----< E-RABSetupItemCtxtSUResExtIEs >-----#
    E_RABSetupItemCtxtSUResExtIEs = CLASS(name='E-RABSetupItemCtxtSUResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABSetupItemCtxtSUResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupFailure >-----#
    InitialContextSetupFailure = SEQ(name='InitialContextSetupFailure', mode=MODE_TYPE)
    _InitialContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupFailure_protocolIEs__item__value),
        ])
    __InitialContextSetupFailure_protocolIEs__item_._ext = None
    _InitialContextSetupFailure_protocolIEs._cont = __InitialContextSetupFailure_protocolIEs__item_
    _InitialContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupFailure_protocolIEs),
        ])
    InitialContextSetupFailure._ext = []
    
    #-----< InitialContextSetupFailureIEs >-----#
    InitialContextSetupFailureIEs = CLASS(name='InitialContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _InitialContextSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name='Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEPagingID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNDomain')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIList')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Extended-UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____Paging_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____Paging_protocolIEs__item__id_tab_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataSize')))
    _____Paging_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WUS-Assistance-Information')))
    _____Paging_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingCause')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = 'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__value._const_tab_id = 'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Paging_protocolIEs__item__id),
        ('criticality', ___Paging_protocolIEs__item__criticality),
        ('value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        ('protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name='PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEIdentityIndexValue')))
    _PagingIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEPagingID')))
    _PagingIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNDomain')))
    _PagingIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIList')))
    _PagingIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _PagingIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _PagingIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForPaging')))
    _PagingIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRXInformation')))
    _PagingIEs_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Extended-UEIdentityIndexValue')))
    _PagingIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRXInformation')))
    _PagingIEs_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-UEIdentityIndexValue')))
    _PagingIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _PagingIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _PagingIEs_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataSize')))
    _PagingIEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WUS-Assistance-Information')))
    _PagingIEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingDRX')))
    _PagingIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingCause')))
    PagingIEs._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_18), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TAIList >-----#
    TAIList = SEQ_OF(name='TAIList', mode=MODE_TYPE)
    _TAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TAIList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___TAIList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____TAIList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIItem')))
    ___TAIList__item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', ____TAIList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TAIList__item__id._const_tab = ___TAIList__item__id_tab
    __TAIList__item__id._const_tab_at = None
    __TAIList__item__id._const_tab_id = 'id'
    __TAIList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __TAIList__item__criticality._const_tab = ___TAIList__item__id_tab
    __TAIList__item__criticality._const_tab_at = ('..', 'id')
    __TAIList__item__criticality._const_tab_id = 'criticality'
    __TAIList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __TAIList__item__value._const_tab = ___TAIList__item__id_tab
    __TAIList__item__value._const_tab_at = ('..', 'id')
    __TAIList__item__value._const_tab_id = 'Value'
    _TAIList__item_._cont = ASN1Dict([
        ('id', __TAIList__item__id),
        ('criticality', __TAIList__item__criticality),
        ('value', __TAIList__item__value),
        ])
    _TAIList__item_._ext = None
    TAIList._cont = _TAIList__item_
    TAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TAIItemIEs >-----#
    TAIItemIEs = CLASS(name='TAIItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TAIItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIItem')))
    TAIItemIEs._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', _TAIItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TAIItem >-----#
    TAIItem = SEQ(name='TAIItem', mode=MODE_TYPE)
    _TAIItem_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__id._const_tab = ____TAIItem_iE_Extensions__item__id_tab
    ___TAIItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__criticality._const_tab = ____TAIItem_iE_Extensions__item__criticality_tab
    ___TAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab = ____TAIItem_iE_Extensions__item__extensionValue_tab
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIItem_iE_Extensions__item__id),
        ('criticality', ___TAIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIItem_iE_Extensions__item__extensionValue),
        ])
    __TAIItem_iE_Extensions__item_._ext = None
    _TAIItem_iE_Extensions._cont = __TAIItem_iE_Extensions__item_
    _TAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIItem._cont = ASN1Dict([
        ('tAI', _TAIItem_tAI),
        ('iE-Extensions', _TAIItem_iE_Extensions),
        ])
    TAIItem._ext = []
    
    #-----< TAIItemExtIEs >-----#
    TAIItemExtIEs = CLASS(name='TAIItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name='UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GWContextReleaseIndication')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequest-IEs >-----#
    UEContextReleaseRequest_IEs = CLASS(name='UEContextReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextReleaseRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GWContextReleaseIndication')))
    _UEContextReleaseRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    UEContextReleaseRequest_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _UEContextReleaseRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 164), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _UEContextReleaseRequest_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name='UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-IDs')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommand-IEs >-----#
    UEContextReleaseCommand_IEs = CLASS(name='UEContextReleaseCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseCommand_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-IDs')))
    _UEContextReleaseCommand_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    UEContextReleaseCommand_IEs._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'reject'), ('Value', _UEContextReleaseCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommand_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name='UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseComplete-IEs >-----#
    UEContextReleaseComplete_IEs = CLASS(name='UEContextReleaseComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseComplete_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextReleaseComplete_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _UEContextReleaseComplete_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _UEContextReleaseComplete_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _UEContextReleaseComplete_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _UEContextReleaseComplete_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    UEContextReleaseComplete_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name='UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationNotPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'conditional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name='UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _UEContextModificationRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _UEContextModificationRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _UEContextModificationRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _UEContextModificationRequestIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _UEContextModificationRequestIEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _UEContextModificationRequestIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationNotPossible')))
    _UEContextModificationRequestIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _UEContextModificationRequestIEs_val_Value_17 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextModificationRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _UEContextModificationRequestIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _UEContextModificationRequestIEs_val_Value_22 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_9), ('presence', 'conditional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 308), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_22), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name='UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name='UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name='UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name='UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityMatchRequest >-----#
    UERadioCapabilityMatchRequest = SEQ(name='UERadioCapabilityMatchRequest', mode=MODE_TYPE)
    _UERadioCapabilityMatchRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityMatchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityMatchRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityMatchRequest_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityMatchRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityMatchRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityMatchRequest_protocolIEs._cont = __UERadioCapabilityMatchRequest_protocolIEs__item_
    _UERadioCapabilityMatchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityMatchRequest._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityMatchRequest_protocolIEs),
        ])
    UERadioCapabilityMatchRequest._ext = []
    
    #-----< UERadioCapabilityMatchRequestIEs >-----#
    UERadioCapabilityMatchRequestIEs = CLASS(name='UERadioCapabilityMatchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityMatchRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UERadioCapabilityMatchRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UERadioCapabilityMatchRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UERadioCapabilityMatchRequestIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityMatchRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UERadioCapabilityMatchRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UERadioCapabilityMatchRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _UERadioCapabilityMatchRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _UERadioCapabilityMatchRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityMatchResponse >-----#
    UERadioCapabilityMatchResponse = SEQ(name='UERadioCapabilityMatchResponse', mode=MODE_TYPE)
    _UERadioCapabilityMatchResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityMatchResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'VoiceSupportMatchIndicator')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityMatchResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityMatchResponse_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityMatchResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityMatchResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityMatchResponse_protocolIEs._cont = __UERadioCapabilityMatchResponse_protocolIEs__item_
    _UERadioCapabilityMatchResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityMatchResponse._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityMatchResponse_protocolIEs),
        ])
    UERadioCapabilityMatchResponse._ext = []
    
    #-----< UERadioCapabilityMatchResponseIEs >-----#
    UERadioCapabilityMatchResponseIEs = CLASS(name='UERadioCapabilityMatchResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityMatchResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UERadioCapabilityMatchResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UERadioCapabilityMatchResponseIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'VoiceSupportMatchIndicator')))
    _UERadioCapabilityMatchResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityMatchResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UERadioCapabilityMatchResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UERadioCapabilityMatchResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _UERadioCapabilityMatchResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UERadioCapabilityMatchResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNASTransport >-----#
    DownlinkNASTransport = SEQ(name='DownlinkNASTransport', mode=MODE_TYPE)
    _DownlinkNASTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNASTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____DownlinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DLNASPDUDeliveryAckRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UECapabilityInfoRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    ____DownlinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkNASTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkNASTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkNASTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkNASTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkNASTransport_protocolIEs__item__value),
        ])
    __DownlinkNASTransport_protocolIEs__item_._ext = None
    _DownlinkNASTransport_protocolIEs._cont = __DownlinkNASTransport_protocolIEs__item_
    _DownlinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNASTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkNASTransport_protocolIEs),
        ])
    DownlinkNASTransport._ext = []
    
    #-----< DownlinkNASTransport-IEs >-----#
    DownlinkNASTransport_IEs = CLASS(name='DownlinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkNASTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkNASTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkNASTransport_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _DownlinkNASTransport_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _DownlinkNASTransport_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _DownlinkNASTransport_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _DownlinkNASTransport_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _DownlinkNASTransport_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DLNASPDUDeliveryAckRequest')))
    _DownlinkNASTransport_IEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _DownlinkNASTransport_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _DownlinkNASTransport_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _DownlinkNASTransport_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UECapabilityInfoRequest')))
    _DownlinkNASTransport_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _DownlinkNASTransport_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _DownlinkNASTransport_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _DownlinkNASTransport_IEs_val_Value_15 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _DownlinkNASTransport_IEs_val_Value_16 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _DownlinkNASTransport_IEs_val_Value_17 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    DownlinkNASTransport_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 299), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_17), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUEMessage >-----#
    InitialUEMessage = SEQ(name='InitialUEMessage', mode=MODE_TYPE)
    _InitialUEMessage_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialUEMessage_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialUEMessage_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____InitialUEMessage_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelayNode-Indicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Coverage-Level')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EDT-Session')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Node-Indication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____InitialUEMessage_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 246), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialUEMessage_protocolIEs__item__id._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__id._const_tab_at = None
    ___InitialUEMessage_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialUEMessage_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialUEMessage_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___InitialUEMessage_protocolIEs__item__value._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialUEMessage_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialUEMessage_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialUEMessage_protocolIEs__item__id),
        ('criticality', ___InitialUEMessage_protocolIEs__item__criticality),
        ('value', ___InitialUEMessage_protocolIEs__item__value),
        ])
    __InitialUEMessage_protocolIEs__item_._ext = None
    _InitialUEMessage_protocolIEs._cont = __InitialUEMessage_protocolIEs__item_
    _InitialUEMessage_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialUEMessage._cont = ASN1Dict([
        ('protocolIEs', _InitialUEMessage_protocolIEs),
        ])
    InitialUEMessage._ext = []
    
    #-----< InitialUEMessage-IEs >-----#
    InitialUEMessage_IEs = CLASS(name='InitialUEMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialUEMessage_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialUEMessage_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _InitialUEMessage_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _InitialUEMessage_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _InitialUEMessage_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _InitialUEMessage_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _InitialUEMessage_IEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _InitialUEMessage_IEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _InitialUEMessage_IEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _InitialUEMessage_IEs_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _InitialUEMessage_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelayNode-Indicator')))
    _InitialUEMessage_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    _InitialUEMessage_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _InitialUEMessage_IEs_val_Value_13 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _InitialUEMessage_IEs_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _InitialUEMessage_IEs_val_Value_15 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _InitialUEMessage_IEs_val_Value_16 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    _InitialUEMessage_IEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    _InitialUEMessage_IEs_val_Value_18 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _InitialUEMessage_IEs_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Coverage-Level')))
    _InitialUEMessage_IEs_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _InitialUEMessage_IEs_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EDT-Session')))
    _InitialUEMessage_IEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Node-Indication')))
    _InitialUEMessage_IEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    InitialUEMessage_IEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 246), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_18), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_19), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_20), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_21), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_22), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_23), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNASTransport >-----#
    UplinkNASTransport = SEQ(name='UplinkNASTransport', mode=MODE_TYPE)
    _UplinkNASTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkNASTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UplinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____UplinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkNASTransport_protocolIEs__item__id._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkNASTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkNASTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UplinkNASTransport_protocolIEs__item__value._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkNASTransport_protocolIEs__item__id),
        ('criticality', ___UplinkNASTransport_protocolIEs__item__criticality),
        ('value', ___UplinkNASTransport_protocolIEs__item__value),
        ])
    __UplinkNASTransport_protocolIEs__item_._ext = None
    _UplinkNASTransport_protocolIEs._cont = __UplinkNASTransport_protocolIEs__item_
    _UplinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNASTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkNASTransport_protocolIEs),
        ])
    UplinkNASTransport._ext = []
    
    #-----< UplinkNASTransport-IEs >-----#
    UplinkNASTransport_IEs = CLASS(name='UplinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkNASTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkNASTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkNASTransport_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _UplinkNASTransport_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _UplinkNASTransport_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _UplinkNASTransport_IEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _UplinkNASTransport_IEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _UplinkNASTransport_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _UplinkNASTransport_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _UplinkNASTransport_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    UplinkNASTransport_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASNonDeliveryIndication >-----#
    NASNonDeliveryIndication = SEQ(name='NASNonDeliveryIndication', mode=MODE_TYPE)
    _NASNonDeliveryIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __NASNonDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___NASNonDeliveryIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___NASNonDeliveryIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NASNonDeliveryIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __NASNonDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NASNonDeliveryIndication_protocolIEs__item__id),
        ('criticality', ___NASNonDeliveryIndication_protocolIEs__item__criticality),
        ('value', ___NASNonDeliveryIndication_protocolIEs__item__value),
        ])
    __NASNonDeliveryIndication_protocolIEs__item_._ext = None
    _NASNonDeliveryIndication_protocolIEs._cont = __NASNonDeliveryIndication_protocolIEs__item_
    _NASNonDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASNonDeliveryIndication._cont = ASN1Dict([
        ('protocolIEs', _NASNonDeliveryIndication_protocolIEs),
        ])
    NASNonDeliveryIndication._ext = []
    
    #-----< NASNonDeliveryIndication-IEs >-----#
    NASNonDeliveryIndication_IEs = CLASS(name='NASNonDeliveryIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _NASNonDeliveryIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _NASNonDeliveryIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    NASNonDeliveryIndication_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name='RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Additional-GUTI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RerouteNASRequest_protocolIEs__item__id),
        ('criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        ('value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        ('protocolIEs', _RerouteNASRequest_protocolIEs),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequest-IEs >-----#
    RerouteNASRequest_IEs = CLASS(name='RerouteNASRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RerouteNASRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _RerouteNASRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _RerouteNASRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    _RerouteNASRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _RerouteNASRequest_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Additional-GUTI')))
    _RerouteNASRequest_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    RerouteNASRequest_IEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _RerouteNASRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'ignore'), ('Value', _RerouteNASRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'ignore'), ('Value', _RerouteNASRequest_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASDeliveryIndication >-----#
    NASDeliveryIndication = SEQ(name='NASDeliveryIndication', mode=MODE_TYPE)
    _NASDeliveryIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __NASDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___NASDeliveryIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____NASDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____NASDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___NASDeliveryIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NASDeliveryIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __NASDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NASDeliveryIndication_protocolIEs__item__id),
        ('criticality', ___NASDeliveryIndication_protocolIEs__item__criticality),
        ('value', ___NASDeliveryIndication_protocolIEs__item__value),
        ])
    __NASDeliveryIndication_protocolIEs__item_._ext = None
    _NASDeliveryIndication_protocolIEs._cont = __NASDeliveryIndication_protocolIEs__item_
    _NASDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASDeliveryIndication._cont = ASN1Dict([
        ('protocolIEs', _NASDeliveryIndication_protocolIEs),
        ])
    NASDeliveryIndication._ext = []
    
    #-----< NASDeliveryIndicationIEs >-----#
    NASDeliveryIndicationIEs = CLASS(name='NASDeliveryIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _NASDeliveryIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _NASDeliveryIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    NASDeliveryIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _NASDeliveryIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _NASDeliveryIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Reset >-----#
    Reset = SEQ(name='Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetType')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = 'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__value._const_tab_id = 'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Reset_protocolIEs__item__id),
        ('criticality', ___Reset_protocolIEs__item__criticality),
        ('value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        ('protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name='ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ResetIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetType')))
    ResetIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _ResetIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name='ResetType', mode=MODE_TYPE)
    _ResetType_s1_Interface = ENUM(name='s1-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAll')))
    _ResetType_partOfS1_Interface = SEQ_OF(name='partOfS1-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListRes')))
    ResetType._cont = ASN1Dict([
        ('s1-Interface', _ResetType_s1_Interface),
        ('partOfS1-Interface', _ResetType_partOfS1_Interface),
        ])
    ResetType._ext = []
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name='ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([('reset-all', 0)])
    ResetAll._ext = []
    
    #-----< UE-associatedLogicalS1-ConnectionListRes >-----#
    UE_associatedLogicalS1_ConnectionListRes = SEQ_OF(name='UE-associatedLogicalS1-ConnectionListRes', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionListRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalS1_ConnectionListRes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'reject'), ('Value', ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab_at = None
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab_id = 'id'
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalS1_ConnectionListRes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalS1_ConnectionListRes__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalS1_ConnectionListRes__item__id),
        ('criticality', __UE_associatedLogicalS1_ConnectionListRes__item__criticality),
        ('value', __UE_associatedLogicalS1_ConnectionListRes__item__value),
        ])
    _UE_associatedLogicalS1_ConnectionListRes__item_._ext = None
    UE_associatedLogicalS1_ConnectionListRes._cont = _UE_associatedLogicalS1_ConnectionListRes__item_
    UE_associatedLogicalS1_ConnectionListRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItemRes >-----#
    UE_associatedLogicalS1_ConnectionItemRes = CLASS(name='UE-associatedLogicalS1-ConnectionItemRes', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    UE_associatedLogicalS1_ConnectionItemRes._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'reject'), ('Value', _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name='ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListResAck')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 93), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetAcknowledge_protocolIEs__item__id),
        ('criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        ('value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ResetAcknowledge_protocolIEs),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name='ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListResAck')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 93), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionListResAck >-----#
    UE_associatedLogicalS1_ConnectionListResAck = SEQ_OF(name='UE-associatedLogicalS1-ConnectionListResAck', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionListResAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalS1_ConnectionListResAck__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab_at = None
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab_id = 'id'
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab_at = ('..', 'id')
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab_id = 'criticality'
    __UE_associatedLogicalS1_ConnectionListResAck__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab_at = ('..', 'id')
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab_id = 'Value'
    _UE_associatedLogicalS1_ConnectionListResAck__item_._cont = ASN1Dict([
        ('id', __UE_associatedLogicalS1_ConnectionListResAck__item__id),
        ('criticality', __UE_associatedLogicalS1_ConnectionListResAck__item__criticality),
        ('value', __UE_associatedLogicalS1_ConnectionListResAck__item__value),
        ])
    _UE_associatedLogicalS1_ConnectionListResAck__item_._ext = None
    UE_associatedLogicalS1_ConnectionListResAck._cont = _UE_associatedLogicalS1_ConnectionListResAck__item_
    UE_associatedLogicalS1_ConnectionListResAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItemResAck >-----#
    UE_associatedLogicalS1_ConnectionItemResAck = CLASS(name='UE-associatedLogicalS1-ConnectionItemResAck', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    UE_associatedLogicalS1_ConnectionItemResAck._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ErrorIndicationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupRequest >-----#
    S1SetupRequest = SEQ(name='S1SetupRequest', mode=MODE_TYPE)
    _S1SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____S1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ____S1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___S1SetupRequest_protocolIEs__item__id._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___S1SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___S1SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___S1SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___S1SetupRequest_protocolIEs__item__value._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___S1SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __S1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___S1SetupRequest_protocolIEs__item__id),
        ('criticality', ___S1SetupRequest_protocolIEs__item__criticality),
        ('value', ___S1SetupRequest_protocolIEs__item__value),
        ])
    __S1SetupRequest_protocolIEs__item_._ext = None
    _S1SetupRequest_protocolIEs._cont = __S1SetupRequest_protocolIEs__item_
    _S1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _S1SetupRequest_protocolIEs),
        ])
    S1SetupRequest._ext = []
    
    #-----< S1SetupRequestIEs >-----#
    S1SetupRequestIEs = CLASS(name='S1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _S1SetupRequestIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _S1SetupRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _S1SetupRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _S1SetupRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _S1SetupRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _S1SetupRequestIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _S1SetupRequestIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    S1SetupRequestIEs._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'reject'), ('Value', _S1SetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _S1SetupRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _S1SetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _S1SetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _S1SetupRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _S1SetupRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _S1SetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Value', _S1SetupRequestIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupResponse >-----#
    S1SetupResponse = SEQ(name='S1SetupResponse', mode=MODE_TYPE)
    _S1SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____S1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMERelaySupportIndicator')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Supported')))
    ____S1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 163), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 303), ('criticality', 'ignore'), ('Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___S1SetupResponse_protocolIEs__item__id._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___S1SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___S1SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___S1SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___S1SetupResponse_protocolIEs__item__value._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___S1SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __S1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___S1SetupResponse_protocolIEs__item__id),
        ('criticality', ___S1SetupResponse_protocolIEs__item__criticality),
        ('value', ___S1SetupResponse_protocolIEs__item__value),
        ])
    __S1SetupResponse_protocolIEs__item_._ext = None
    _S1SetupResponse_protocolIEs._cont = __S1SetupResponse_protocolIEs__item_
    _S1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _S1SetupResponse_protocolIEs),
        ])
    S1SetupResponse._ext = []
    
    #-----< S1SetupResponseIEs >-----#
    S1SetupResponseIEs = CLASS(name='S1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupResponseIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _S1SetupResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _S1SetupResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _S1SetupResponseIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMERelaySupportIndicator')))
    _S1SetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _S1SetupResponseIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _S1SetupResponseIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    _S1SetupResponseIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Supported')))
    S1SetupResponseIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _S1SetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 87), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 163), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 303), ('criticality', 'ignore'), ('Value', _S1SetupResponseIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupFailure >-----#
    S1SetupFailure = SEQ(name='S1SetupFailure', mode=MODE_TYPE)
    _S1SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____S1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____S1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___S1SetupFailure_protocolIEs__item__id._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___S1SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___S1SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___S1SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___S1SetupFailure_protocolIEs__item__value._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___S1SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __S1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___S1SetupFailure_protocolIEs__item__id),
        ('criticality', ___S1SetupFailure_protocolIEs__item__criticality),
        ('value', ___S1SetupFailure_protocolIEs__item__value),
        ])
    __S1SetupFailure_protocolIEs__item_._ext = None
    _S1SetupFailure_protocolIEs._cont = __S1SetupFailure_protocolIEs__item_
    _S1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _S1SetupFailure_protocolIEs),
        ])
    S1SetupFailure._ext = []
    
    #-----< S1SetupFailureIEs >-----#
    S1SetupFailureIEs = CLASS(name='S1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _S1SetupFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _S1SetupFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    S1SetupFailureIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _S1SetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _S1SetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _S1SetupFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdate >-----#
    ENBConfigurationUpdate = SEQ(name='ENBConfigurationUpdate', mode=MODE_TYPE)
    _ENBConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdate_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdate_protocolIEs__item_._ext = None
    _ENBConfigurationUpdate_protocolIEs._cont = __ENBConfigurationUpdate_protocolIEs__item_
    _ENBConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdate_protocolIEs),
        ])
    ENBConfigurationUpdate._ext = []
    
    #-----< ENBConfigurationUpdateIEs >-----#
    ENBConfigurationUpdateIEs = CLASS(name='ENBConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _ENBConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _ENBConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _ENBConfigurationUpdateIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _ENBConfigurationUpdateIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _ENBConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    _ENBConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ENBConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateAcknowledge >-----#
    ENBConfigurationUpdateAcknowledge = SEQ(name='ENBConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _ENBConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateAcknowledge_protocolIEs._cont = __ENBConfigurationUpdateAcknowledge_protocolIEs__item_
    _ENBConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdateAcknowledge_protocolIEs),
        ])
    ENBConfigurationUpdateAcknowledge._ext = []
    
    #-----< ENBConfigurationUpdateAcknowledgeIEs >-----#
    ENBConfigurationUpdateAcknowledgeIEs = CLASS(name='ENBConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateFailure >-----#
    ENBConfigurationUpdateFailure = SEQ(name='ENBConfigurationUpdateFailure', mode=MODE_TYPE)
    _ENBConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateFailure_protocolIEs._cont = __ENBConfigurationUpdateFailure_protocolIEs__item_
    _ENBConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdateFailure_protocolIEs),
        ])
    ENBConfigurationUpdateFailure._ext = []
    
    #-----< ENBConfigurationUpdateFailureIEs >-----#
    ENBConfigurationUpdateFailureIEs = CLASS(name='ENBConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ENBConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _ENBConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdate >-----#
    MMEConfigurationUpdate = SEQ(name='MMEConfigurationUpdate', mode=MODE_TYPE)
    _MMEConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    ____MMEConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'reject'), ('Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___MMEConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___MMEConfigurationUpdate_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdate_protocolIEs__item_._ext = None
    _MMEConfigurationUpdate_protocolIEs._cont = __MMEConfigurationUpdate_protocolIEs__item_
    _MMEConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _MMEConfigurationUpdate_protocolIEs),
        ])
    MMEConfigurationUpdate._ext = []
    
    #-----< MMEConfigurationUpdateIEs >-----#
    MMEConfigurationUpdateIEs = CLASS(name='MMEConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _MMEConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _MMEConfigurationUpdateIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _MMEConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    MMEConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _MMEConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'reject'), ('Value', _MMEConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdateAcknowledge >-----#
    MMEConfigurationUpdateAcknowledge = SEQ(name='MMEConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _MMEConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _MMEConfigurationUpdateAcknowledge_protocolIEs._cont = __MMEConfigurationUpdateAcknowledge_protocolIEs__item_
    _MMEConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _MMEConfigurationUpdateAcknowledge_protocolIEs),
        ])
    MMEConfigurationUpdateAcknowledge._ext = []
    
    #-----< MMEConfigurationUpdateAcknowledgeIEs >-----#
    MMEConfigurationUpdateAcknowledgeIEs = CLASS(name='MMEConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    MMEConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdateFailure >-----#
    MMEConfigurationUpdateFailure = SEQ(name='MMEConfigurationUpdateFailure', mode=MODE_TYPE)
    _MMEConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___MMEConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _MMEConfigurationUpdateFailure_protocolIEs._cont = __MMEConfigurationUpdateFailure_protocolIEs__item_
    _MMEConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _MMEConfigurationUpdateFailure_protocolIEs),
        ])
    MMEConfigurationUpdateFailure._ext = []
    
    #-----< MMEConfigurationUpdateFailureIEs >-----#
    MMEConfigurationUpdateFailureIEs = CLASS(name='MMEConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _MMEConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _MMEConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    MMEConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _MMEConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkS1cdma2000tunnelling >-----#
    DownlinkS1cdma2000tunnelling = SEQ(name='DownlinkS1cdma2000tunnelling', mode=MODE_TYPE)
    _DownlinkS1cdma2000tunnelling_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HOStatus')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_at = None
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id),
        ('criticality', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality),
        ('value', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value),
        ])
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_._ext = None
    _DownlinkS1cdma2000tunnelling_protocolIEs._cont = __DownlinkS1cdma2000tunnelling_protocolIEs__item_
    _DownlinkS1cdma2000tunnelling_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkS1cdma2000tunnelling._cont = ASN1Dict([
        ('protocolIEs', _DownlinkS1cdma2000tunnelling_protocolIEs),
        ])
    DownlinkS1cdma2000tunnelling._ext = []
    
    #-----< DownlinkS1cdma2000tunnellingIEs >-----#
    DownlinkS1cdma2000tunnellingIEs = CLASS(name='DownlinkS1cdma2000tunnellingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HOStatus')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    DownlinkS1cdma2000tunnellingIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkS1cdma2000tunnelling >-----#
    UplinkS1cdma2000tunnelling = SEQ(name='UplinkS1cdma2000tunnelling', mode=MODE_TYPE)
    _UplinkS1cdma2000tunnelling_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkS1cdma2000tunnelling_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000SectorID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HORequiredIndication')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXSRVCCInfo')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXRAND')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRANRoundTripDelayEstimationInfo')))
    ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 72), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'ignore'), ('Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_at = None
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkS1cdma2000tunnelling_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkS1cdma2000tunnelling_protocolIEs__item__id),
        ('criticality', ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality),
        ('value', ___UplinkS1cdma2000tunnelling_protocolIEs__item__value),
        ])
    __UplinkS1cdma2000tunnelling_protocolIEs__item_._ext = None
    _UplinkS1cdma2000tunnelling_protocolIEs._cont = __UplinkS1cdma2000tunnelling_protocolIEs__item_
    _UplinkS1cdma2000tunnelling_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkS1cdma2000tunnelling._cont = ASN1Dict([
        ('protocolIEs', _UplinkS1cdma2000tunnelling_protocolIEs),
        ])
    UplinkS1cdma2000tunnelling._ext = []
    
    #-----< UplinkS1cdma2000tunnellingIEs >-----#
    UplinkS1cdma2000tunnellingIEs = CLASS(name='UplinkS1cdma2000tunnellingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000SectorID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HORequiredIndication')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXSRVCCInfo')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXRAND')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRANRoundTripDelayEstimationInfo')))
    UplinkS1cdma2000tunnellingIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 72), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'ignore'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'ignore'), ('Value', _UplinkS1cdma2000tunnellingIEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoIndication >-----#
    UECapabilityInfoIndication = SEQ(name='UECapabilityInfoIndication', mode=MODE_TYPE)
    _UECapabilityInfoIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UECapabilityInfoIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UECapabilityInfoIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UECapabilityInfoIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-M-Indication')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    ____UECapabilityInfoIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 327), ('criticality', 'ignore'), ('Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab_at = None
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___UECapabilityInfoIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UECapabilityInfoIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __UECapabilityInfoIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UECapabilityInfoIndication_protocolIEs__item__id),
        ('criticality', ___UECapabilityInfoIndication_protocolIEs__item__criticality),
        ('value', ___UECapabilityInfoIndication_protocolIEs__item__value),
        ])
    __UECapabilityInfoIndication_protocolIEs__item_._ext = None
    _UECapabilityInfoIndication_protocolIEs._cont = __UECapabilityInfoIndication_protocolIEs__item_
    _UECapabilityInfoIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UECapabilityInfoIndication._cont = ASN1Dict([
        ('protocolIEs', _UECapabilityInfoIndication_protocolIEs),
        ])
    UECapabilityInfoIndication._ext = []
    
    #-----< UECapabilityInfoIndicationIEs >-----#
    UECapabilityInfoIndicationIEs = CLASS(name='UECapabilityInfoIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UECapabilityInfoIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UECapabilityInfoIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UECapabilityInfoIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UECapabilityInfoIndicationIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _UECapabilityInfoIndicationIEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _UECapabilityInfoIndicationIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-M-Indication')))
    _UECapabilityInfoIndicationIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UECapabilityInfoIndicationIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    UECapabilityInfoIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 198), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 327), ('criticality', 'ignore'), ('Value', _UECapabilityInfoIndicationIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBStatusTransfer >-----#
    ENBStatusTransfer = SEQ(name='ENBStatusTransfer', mode=MODE_TYPE)
    _ENBStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ____ENBStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'reject'), ('Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBStatusTransfer_protocolIEs__item__id),
        ('criticality', ___ENBStatusTransfer_protocolIEs__item__criticality),
        ('value', ___ENBStatusTransfer_protocolIEs__item__value),
        ])
    __ENBStatusTransfer_protocolIEs__item_._ext = None
    _ENBStatusTransfer_protocolIEs._cont = __ENBStatusTransfer_protocolIEs__item_
    _ENBStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _ENBStatusTransfer_protocolIEs),
        ])
    ENBStatusTransfer._ext = []
    
    #-----< ENBStatusTransferIEs >-----#
    ENBStatusTransferIEs = CLASS(name='ENBStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ENBStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ENBStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _ENBStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _ENBStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'reject'), ('Value', _ENBStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MMEStatusTransfer >-----#
    MMEStatusTransfer = SEQ(name='MMEStatusTransfer', mode=MODE_TYPE)
    _MMEStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ____MMEStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'reject'), ('Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEStatusTransfer_protocolIEs__item__id),
        ('criticality', ___MMEStatusTransfer_protocolIEs__item__criticality),
        ('value', ___MMEStatusTransfer_protocolIEs__item__value),
        ])
    __MMEStatusTransfer_protocolIEs__item_._ext = None
    _MMEStatusTransfer_protocolIEs._cont = __MMEStatusTransfer_protocolIEs__item_
    _MMEStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _MMEStatusTransfer_protocolIEs),
        ])
    MMEStatusTransfer._ext = []
    
    #-----< MMEStatusTransferIEs >-----#
    MMEStatusTransferIEs = CLASS(name='MMEStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMEStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _MMEStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    MMEStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _MMEStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _MMEStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'reject'), ('Value', _MMEStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name='TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceStart_protocolIEs__item__id),
        ('criticality', ___TraceStart_protocolIEs__item__criticality),
        ('value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        ('protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name='TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _TraceStartIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceFailureIndication >-----#
    TraceFailureIndication = SEQ(name='TraceFailureIndication', mode=MODE_TYPE)
    _TraceFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __TraceFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___TraceFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____TraceFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____TraceFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceFailureIndication_protocolIEs__item__id._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___TraceFailureIndication_protocolIEs__item__value._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceFailureIndication_protocolIEs__item__id),
        ('criticality', ___TraceFailureIndication_protocolIEs__item__criticality),
        ('value', ___TraceFailureIndication_protocolIEs__item__value),
        ])
    __TraceFailureIndication_protocolIEs__item_._ext = None
    _TraceFailureIndication_protocolIEs._cont = __TraceFailureIndication_protocolIEs__item_
    _TraceFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _TraceFailureIndication_protocolIEs),
        ])
    TraceFailureIndication._ext = []
    
    #-----< TraceFailureIndicationIEs >-----#
    TraceFailureIndicationIEs = CLASS(name='TraceFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TraceFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _TraceFailureIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _TraceFailureIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _TraceFailureIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    TraceFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _TraceFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _TraceFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _TraceFailureIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _TraceFailureIndicationIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name='DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name='DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _DeactivateTraceIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name='CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PrivacyIndicator')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellTrafficTrace_protocolIEs__item__id),
        ('criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        ('value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        ('protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name='CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _CellTrafficTraceIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellTrafficTraceIEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PrivacyIndicator')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name='LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReportingControl_protocolIEs__item__id),
        ('criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        ('value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        ('protocolIEs', _LocationReportingControl_protocolIEs),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name='LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportingControlIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportingControlIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _LocationReportingControlIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _LocationReportingControlIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _LocationReportingControlIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingFailureIndication >-----#
    LocationReportingFailureIndication = SEQ(name='LocationReportingFailureIndication', mode=MODE_TYPE)
    _LocationReportingFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReportingFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReportingFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReportingFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReportingFailureIndication_protocolIEs__item__id),
        ('criticality', ___LocationReportingFailureIndication_protocolIEs__item__criticality),
        ('value', ___LocationReportingFailureIndication_protocolIEs__item__value),
        ])
    __LocationReportingFailureIndication_protocolIEs__item_._ext = None
    _LocationReportingFailureIndication_protocolIEs._cont = __LocationReportingFailureIndication_protocolIEs__item_
    _LocationReportingFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _LocationReportingFailureIndication_protocolIEs),
        ])
    LocationReportingFailureIndication._ext = []
    
    #-----< LocationReportingFailureIndicationIEs >-----#
    LocationReportingFailureIndicationIEs = CLASS(name='LocationReportingFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportingFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    LocationReportingFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name='LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReport_protocolIEs__item__id),
        ('criticality', ___LocationReport_protocolIEs__item__criticality),
        ('value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        ('protocolIEs', _LocationReport_protocolIEs),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name='LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _LocationReportIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _LocationReportIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _LocationReportIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _LocationReportIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    LocationReportIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _LocationReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _LocationReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStart >-----#
    OverloadStart = SEQ(name='OverloadStart', mode=MODE_TYPE)
    _OverloadStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __OverloadStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___OverloadStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____OverloadStart_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'OverloadResponse')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TrafficLoadReductionIndication')))
    ____OverloadStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'reject'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OverloadStart_protocolIEs__item__id._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__id._const_tab_at = None
    ___OverloadStart_protocolIEs__item__id._const_tab_id = 'id'
    ___OverloadStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___OverloadStart_protocolIEs__item__criticality._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OverloadStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OverloadStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___OverloadStart_protocolIEs__item__value._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OverloadStart_protocolIEs__item__value._const_tab_id = 'Value'
    __OverloadStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OverloadStart_protocolIEs__item__id),
        ('criticality', ___OverloadStart_protocolIEs__item__criticality),
        ('value', ___OverloadStart_protocolIEs__item__value),
        ])
    __OverloadStart_protocolIEs__item_._ext = None
    _OverloadStart_protocolIEs._cont = __OverloadStart_protocolIEs__item_
    _OverloadStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStart._cont = ASN1Dict([
        ('protocolIEs', _OverloadStart_protocolIEs),
        ])
    OverloadStart._ext = []
    
    #-----< OverloadStartIEs >-----#
    OverloadStartIEs = CLASS(name='OverloadStartIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _OverloadStartIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'OverloadResponse')))
    _OverloadStartIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    _OverloadStartIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TrafficLoadReductionIndication')))
    OverloadStartIEs._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'reject'), ('Value', _OverloadStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _OverloadStartIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Value', _OverloadStartIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStop >-----#
    OverloadStop = SEQ(name='OverloadStop', mode=MODE_TYPE)
    _OverloadStop_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __OverloadStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___OverloadStop_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____OverloadStop_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____OverloadStop_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    ____OverloadStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _____OverloadStop_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__id._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__id._const_tab_at = None
    ___OverloadStop_protocolIEs__item__id._const_tab_id = 'id'
    ___OverloadStop_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___OverloadStop_protocolIEs__item__criticality._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OverloadStop_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OverloadStop_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___OverloadStop_protocolIEs__item__value._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OverloadStop_protocolIEs__item__value._const_tab_id = 'Value'
    __OverloadStop_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OverloadStop_protocolIEs__item__id),
        ('criticality', ___OverloadStop_protocolIEs__item__criticality),
        ('value', ___OverloadStop_protocolIEs__item__value),
        ])
    __OverloadStop_protocolIEs__item_._ext = None
    _OverloadStop_protocolIEs._cont = __OverloadStop_protocolIEs__item_
    _OverloadStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStop._cont = ASN1Dict([
        ('protocolIEs', _OverloadStop_protocolIEs),
        ])
    OverloadStop._ext = []
    
    #-----< OverloadStopIEs >-----#
    OverloadStopIEs = CLASS(name='OverloadStopIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _OverloadStopIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    OverloadStopIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _OverloadStopIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name='WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NumberofBroadcastRequest')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningType')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningSecurityInfo')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataCodingScheme')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningMessageContents')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConcurrentWarningMessageIndicator')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaCoordinates')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 114), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 115), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name='WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NumberofBroadcastRequest')))
    _WriteReplaceWarningRequestIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningType')))
    _WriteReplaceWarningRequestIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningSecurityInfo')))
    _WriteReplaceWarningRequestIEs_val_Value_8 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataCodingScheme')))
    _WriteReplaceWarningRequestIEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningMessageContents')))
    _WriteReplaceWarningRequestIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConcurrentWarningMessageIndicator')))
    _WriteReplaceWarningRequestIEs_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaCoordinates')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 114), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 144), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 115), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name='WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCompletedAreaList')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 120), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name='WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCompletedAreaList')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 120), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBDirectInformationTransfer >-----#
    ENBDirectInformationTransfer = SEQ(name='ENBDirectInformationTransfer', mode=MODE_TYPE)
    _ENBDirectInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBDirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBDirectInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBDirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ____ENBDirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'reject'), ('Value', _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBDirectInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBDirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBDirectInformationTransfer_protocolIEs__item__id),
        ('criticality', ___ENBDirectInformationTransfer_protocolIEs__item__criticality),
        ('value', ___ENBDirectInformationTransfer_protocolIEs__item__value),
        ])
    __ENBDirectInformationTransfer_protocolIEs__item_._ext = None
    _ENBDirectInformationTransfer_protocolIEs._cont = __ENBDirectInformationTransfer_protocolIEs__item_
    _ENBDirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBDirectInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _ENBDirectInformationTransfer_protocolIEs),
        ])
    ENBDirectInformationTransfer._ext = []
    
    #-----< ENBDirectInformationTransferIEs >-----#
    ENBDirectInformationTransferIEs = CLASS(name='ENBDirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBDirectInformationTransferIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ENBDirectInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'reject'), ('Value', _ENBDirectInformationTransferIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Inter-SystemInformationTransferType >-----#
    Inter_SystemInformationTransferType = CHOICE(name='Inter-SystemInformationTransferType', mode=MODE_TYPE)
    _Inter_SystemInformationTransferType_rIMTransfer = SEQ(name='rIMTransfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMTransfer')))
    Inter_SystemInformationTransferType._cont = ASN1Dict([
        ('rIMTransfer', _Inter_SystemInformationTransferType_rIMTransfer),
        ])
    Inter_SystemInformationTransferType._ext = []
    
    #-----< MMEDirectInformationTransfer >-----#
    MMEDirectInformationTransfer = SEQ(name='MMEDirectInformationTransfer', mode=MODE_TYPE)
    _MMEDirectInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEDirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEDirectInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEDirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ____MMEDirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'reject'), ('Value', _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEDirectInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEDirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEDirectInformationTransfer_protocolIEs__item__id),
        ('criticality', ___MMEDirectInformationTransfer_protocolIEs__item__criticality),
        ('value', ___MMEDirectInformationTransfer_protocolIEs__item__value),
        ])
    __MMEDirectInformationTransfer_protocolIEs__item_._ext = None
    _MMEDirectInformationTransfer_protocolIEs._cont = __MMEDirectInformationTransfer_protocolIEs__item_
    _MMEDirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEDirectInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _MMEDirectInformationTransfer_protocolIEs),
        ])
    MMEDirectInformationTransfer._ext = []
    
    #-----< MMEDirectInformationTransferIEs >-----#
    MMEDirectInformationTransferIEs = CLASS(name='MMEDirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEDirectInformationTransferIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    MMEDirectInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'reject'), ('Value', _MMEDirectInformationTransferIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationTransfer >-----#
    ENBConfigurationTransfer = SEQ(name='ENBConfigurationTransfer', mode=MODE_TYPE)
    _ENBConfigurationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____ENBConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 129), ('criticality', 'ignore'), ('Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 294), ('criticality', 'ignore'), ('Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'ignore'), ('Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationTransfer_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationTransfer_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationTransfer_protocolIEs__item__value),
        ])
    __ENBConfigurationTransfer_protocolIEs__item_._ext = None
    _ENBConfigurationTransfer_protocolIEs._cont = __ENBConfigurationTransfer_protocolIEs__item_
    _ENBConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationTransfer._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationTransfer_protocolIEs),
        ])
    ENBConfigurationTransfer._ext = []
    
    #-----< ENBConfigurationTransferIEs >-----#
    ENBConfigurationTransferIEs = CLASS(name='ENBConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _ENBConfigurationTransferIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _ENBConfigurationTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ENBConfigurationTransferIEs._val = ASN1Set(rv=[dict([('id', 129), ('criticality', 'ignore'), ('Value', _ENBConfigurationTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 294), ('criticality', 'ignore'), ('Value', _ENBConfigurationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'ignore'), ('Value', _ENBConfigurationTransferIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationTransfer >-----#
    MMEConfigurationTransfer = SEQ(name='MMEConfigurationTransfer', mode=MODE_TYPE)
    _MMEConfigurationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMEConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____MMEConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'ignore'), ('Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 295), ('criticality', 'ignore'), ('Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MMEConfigurationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMEConfigurationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MMEConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMEConfigurationTransfer_protocolIEs__item__id),
        ('criticality', ___MMEConfigurationTransfer_protocolIEs__item__criticality),
        ('value', ___MMEConfigurationTransfer_protocolIEs__item__value),
        ])
    __MMEConfigurationTransfer_protocolIEs__item_._ext = None
    _MMEConfigurationTransfer_protocolIEs._cont = __MMEConfigurationTransfer_protocolIEs__item_
    _MMEConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationTransfer._cont = ASN1Dict([
        ('protocolIEs', _MMEConfigurationTransfer_protocolIEs),
        ])
    MMEConfigurationTransfer._ext = []
    
    #-----< MMEConfigurationTransferIEs >-----#
    MMEConfigurationTransferIEs = CLASS(name='MMEConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _MMEConfigurationTransferIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _MMEConfigurationTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    MMEConfigurationTransferIEs._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'ignore'), ('Value', _MMEConfigurationTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 295), ('criticality', 'ignore'), ('Value', _MMEConfigurationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _MMEConfigurationTransferIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessageIEs >-----#
    PrivateMessageIEs = CLASS(name='PrivateMessageIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    PrivateMessageIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< KillRequest >-----#
    KillRequest = SEQ(name='KillRequest', mode=MODE_TYPE)
    _KillRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __KillRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___KillRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____KillRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'KillAllWarningMessages')))
    ____KillRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 191), ('criticality', 'reject'), ('Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___KillRequest_protocolIEs__item__id._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__id._const_tab_at = None
    ___KillRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___KillRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___KillRequest_protocolIEs__item__criticality._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___KillRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___KillRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___KillRequest_protocolIEs__item__value._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___KillRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __KillRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___KillRequest_protocolIEs__item__id),
        ('criticality', ___KillRequest_protocolIEs__item__criticality),
        ('value', ___KillRequest_protocolIEs__item__value),
        ])
    __KillRequest_protocolIEs__item_._ext = None
    _KillRequest_protocolIEs._cont = __KillRequest_protocolIEs__item_
    _KillRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    KillRequest._cont = ASN1Dict([
        ('protocolIEs', _KillRequest_protocolIEs),
        ])
    KillRequest._ext = []
    
    #-----< KillRequestIEs >-----#
    KillRequestIEs = CLASS(name='KillRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _KillRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _KillRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _KillRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _KillRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'KillAllWarningMessages')))
    KillRequestIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _KillRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _KillRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _KillRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 191), ('criticality', 'reject'), ('Value', _KillRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< KillResponse >-----#
    KillResponse = SEQ(name='KillResponse', mode=MODE_TYPE)
    _KillResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __KillResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___KillResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____KillResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCancelledAreaList')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____KillResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___KillResponse_protocolIEs__item__id._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__id._const_tab_at = None
    ___KillResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___KillResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___KillResponse_protocolIEs__item__criticality._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___KillResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___KillResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___KillResponse_protocolIEs__item__value._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___KillResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __KillResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___KillResponse_protocolIEs__item__id),
        ('criticality', ___KillResponse_protocolIEs__item__criticality),
        ('value', ___KillResponse_protocolIEs__item__value),
        ])
    __KillResponse_protocolIEs__item_._ext = None
    _KillResponse_protocolIEs._cont = __KillResponse_protocolIEs__item_
    _KillResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    KillResponse._cont = ASN1Dict([
        ('protocolIEs', _KillResponse_protocolIEs),
        ])
    KillResponse._ext = []
    
    #-----< KillResponseIEs >-----#
    KillResponseIEs = CLASS(name='KillResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _KillResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _KillResponseIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _KillResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCancelledAreaList')))
    _KillResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    KillResponseIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _KillResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _KillResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _KillResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _KillResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name='PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ECGIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDListForRestart')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 190), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSRestartIndication_protocolIEs__item__id),
        ('criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        ('value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name='PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ECGIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _PWSRestartIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDListForRestart')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 190), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name='PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PWSfailedECGIList')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 222), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSFailureIndication_protocolIEs__item__id),
        ('criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        ('value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name='PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PWSfailedECGIList')))
    _PWSFailureIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 222), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkUEAssociatedLPPaTransport >-----#
    DownlinkUEAssociatedLPPaTransport = SEQ(name='DownlinkUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _DownlinkUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _DownlinkUEAssociatedLPPaTransport_protocolIEs._cont = __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_
    _DownlinkUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkUEAssociatedLPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkUEAssociatedLPPaTransport_protocolIEs),
        ])
    DownlinkUEAssociatedLPPaTransport._ext = []
    
    #-----< DownlinkUEAssociatedLPPaTransport-IEs >-----#
    DownlinkUEAssociatedLPPaTransport_IEs = CLASS(name='DownlinkUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    DownlinkUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkUEAssociatedLPPaTransport >-----#
    UplinkUEAssociatedLPPaTransport = SEQ(name='UplinkUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _UplinkUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id),
        ('criticality', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        ('value', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _UplinkUEAssociatedLPPaTransport_protocolIEs._cont = __UplinkUEAssociatedLPPaTransport_protocolIEs__item_
    _UplinkUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkUEAssociatedLPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkUEAssociatedLPPaTransport_protocolIEs),
        ])
    UplinkUEAssociatedLPPaTransport._ext = []
    
    #-----< UplinkUEAssociatedLPPaTransport-IEs >-----#
    UplinkUEAssociatedLPPaTransport_IEs = CLASS(name='UplinkUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    UplinkUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNonUEAssociatedLPPaTransport >-----#
    DownlinkNonUEAssociatedLPPaTransport = SEQ(name='DownlinkNonUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Value', _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs._cont = __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNonUEAssociatedLPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkNonUEAssociatedLPPaTransport_protocolIEs),
        ])
    DownlinkNonUEAssociatedLPPaTransport._ext = []
    
    #-----< DownlinkNonUEAssociatedLPPaTransport-IEs >-----#
    DownlinkNonUEAssociatedLPPaTransport_IEs = CLASS(name='DownlinkNonUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    DownlinkNonUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Value', _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNonUEAssociatedLPPaTransport >-----#
    UplinkNonUEAssociatedLPPaTransport = SEQ(name='UplinkNonUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Value', _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id),
        ('criticality', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        ('value', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs._cont = __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNonUEAssociatedLPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkNonUEAssociatedLPPaTransport_protocolIEs),
        ])
    UplinkNonUEAssociatedLPPaTransport._ext = []
    
    #-----< UplinkNonUEAssociatedLPPaTransport-IEs >-----#
    UplinkNonUEAssociatedLPPaTransport_IEs = CLASS(name='UplinkNonUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    UplinkNonUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Value', _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'reject'), ('Value', _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModificationIndication >-----#
    E_RABModificationIndication = SEQ(name='E-RABModificationIndication', mode=MODE_TYPE)
    _E_RABModificationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModificationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModificationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABModificationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModInd')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedListBearerModInd')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    ____E_RABModificationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 199), ('criticality', 'reject'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 201), ('criticality', 'reject'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'reject'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab_at = None
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABModificationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABModificationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABModificationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABModificationIndication_protocolIEs__item__id),
        ('criticality', ___E_RABModificationIndication_protocolIEs__item__criticality),
        ('value', ___E_RABModificationIndication_protocolIEs__item__value),
        ])
    __E_RABModificationIndication_protocolIEs__item_._ext = None
    _E_RABModificationIndication_protocolIEs._cont = __E_RABModificationIndication_protocolIEs__item_
    _E_RABModificationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModificationIndication._cont = ASN1Dict([
        ('protocolIEs', _E_RABModificationIndication_protocolIEs),
        ])
    E_RABModificationIndication._ext = []
    
    #-----< E-RABModificationIndicationIEs >-----#
    E_RABModificationIndicationIEs = CLASS(name='E-RABModificationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModificationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModificationIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModificationIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModInd')))
    _E_RABModificationIndicationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedListBearerModInd')))
    _E_RABModificationIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    _E_RABModificationIndicationIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _E_RABModificationIndicationIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _E_RABModificationIndicationIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    E_RABModificationIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _E_RABModificationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _E_RABModificationIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 199), ('criticality', 'reject'), ('Value', _E_RABModificationIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 201), ('criticality', 'reject'), ('Value', _E_RABModificationIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'reject'), ('Value', _E_RABModificationIndicationIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _E_RABModificationIndicationIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _E_RABModificationIndicationIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _E_RABModificationIndicationIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedListBearerModInd >-----#
    E_RABToBeModifiedListBearerModInd = SEQ_OF(name='E-RABToBeModifiedListBearerModInd', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeModifiedListBearerModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeModifiedListBearerModInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABToBeModifiedListBearerModInd__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModInd')))
    ___E_RABToBeModifiedListBearerModInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'reject'), ('Value', ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab_at = None
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab_id = 'id'
    __E_RABToBeModifiedListBearerModInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab_at = ('..', 'id')
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab_id = 'criticality'
    __E_RABToBeModifiedListBearerModInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab_at = ('..', 'id')
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab_id = 'Value'
    _E_RABToBeModifiedListBearerModInd__item_._cont = ASN1Dict([
        ('id', __E_RABToBeModifiedListBearerModInd__item__id),
        ('criticality', __E_RABToBeModifiedListBearerModInd__item__criticality),
        ('value', __E_RABToBeModifiedListBearerModInd__item__value),
        ])
    _E_RABToBeModifiedListBearerModInd__item_._ext = None
    E_RABToBeModifiedListBearerModInd._cont = _E_RABToBeModifiedListBearerModInd__item_
    E_RABToBeModifiedListBearerModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeModifiedItemBearerModIndIEs >-----#
    E_RABToBeModifiedItemBearerModIndIEs = CLASS(name='E-RABToBeModifiedItemBearerModIndIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModInd')))
    E_RABToBeModifiedItemBearerModIndIEs._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'reject'), ('Value', _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedItemBearerModInd >-----#
    E_RABToBeModifiedItemBearerModInd = SEQ(name='E-RABToBeModifiedItemBearerModInd', mode=MODE_TYPE)
    _E_RABToBeModifiedItemBearerModInd_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeModifiedItemBearerModInd_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID = OCT_STR(name='dL-GTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id),
        ('criticality', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_._ext = None
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions._cont = __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeModifiedItemBearerModInd._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABToBeModifiedItemBearerModInd_e_RAB_ID),
        ('transportLayerAddress', _E_RABToBeModifiedItemBearerModInd_transportLayerAddress),
        ('dL-GTP-TEID', _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID),
        ('iE-Extensions', _E_RABToBeModifiedItemBearerModInd_iE_Extensions),
        ])
    E_RABToBeModifiedItemBearerModInd._ext = []
    
    #-----< E-RABToBeModifiedItemBearerModInd-ExtIEs >-----#
    E_RABToBeModifiedItemBearerModInd_ExtIEs = CLASS(name='E-RABToBeModifiedItemBearerModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeModifiedItemBearerModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABNotToBeModifiedListBearerModInd >-----#
    E_RABNotToBeModifiedListBearerModInd = SEQ_OF(name='E-RABNotToBeModifiedListBearerModInd', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABNotToBeModifiedListBearerModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABNotToBeModifiedListBearerModInd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABNotToBeModifiedListBearerModInd__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedItemBearerModInd')))
    ___E_RABNotToBeModifiedListBearerModInd__item__id_tab._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'reject'), ('Value', ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab_at = None
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab_id = 'id'
    __E_RABNotToBeModifiedListBearerModInd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab_at = ('..', 'id')
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab_id = 'criticality'
    __E_RABNotToBeModifiedListBearerModInd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab_at = ('..', 'id')
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab_id = 'Value'
    _E_RABNotToBeModifiedListBearerModInd__item_._cont = ASN1Dict([
        ('id', __E_RABNotToBeModifiedListBearerModInd__item__id),
        ('criticality', __E_RABNotToBeModifiedListBearerModInd__item__criticality),
        ('value', __E_RABNotToBeModifiedListBearerModInd__item__value),
        ])
    _E_RABNotToBeModifiedListBearerModInd__item_._ext = None
    E_RABNotToBeModifiedListBearerModInd._cont = _E_RABNotToBeModifiedListBearerModInd__item_
    E_RABNotToBeModifiedListBearerModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABNotToBeModifiedItemBearerModIndIEs >-----#
    E_RABNotToBeModifiedItemBearerModIndIEs = CLASS(name='E-RABNotToBeModifiedItemBearerModIndIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedItemBearerModInd')))
    E_RABNotToBeModifiedItemBearerModIndIEs._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'reject'), ('Value', _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABNotToBeModifiedItemBearerModInd >-----#
    E_RABNotToBeModifiedItemBearerModInd = SEQ(name='E-RABNotToBeModifiedItemBearerModInd', mode=MODE_TYPE)
    _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID = OCT_STR(name='dL-GTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_at = None
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id),
        ('criticality', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue),
        ])
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_._ext = None
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions._cont = __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABNotToBeModifiedItemBearerModInd._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID),
        ('transportLayerAddress', _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress),
        ('dL-GTP-TEID', _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID),
        ('iE-Extensions', _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions),
        ])
    E_RABNotToBeModifiedItemBearerModInd._ext = []
    
    #-----< E-RABNotToBeModifiedItemBearerModInd-ExtIEs >-----#
    E_RABNotToBeModifiedItemBearerModInd_ExtIEs = CLASS(name='E-RABNotToBeModifiedItemBearerModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABNotToBeModifiedItemBearerModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipInfo >-----#
    CSGMembershipInfo = SEQ(name='CSGMembershipInfo', mode=MODE_TYPE)
    _CSGMembershipInfo_cSGMembershipStatus = ENUM(name='cSGMembershipStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _CSGMembershipInfo_cSG_Id = BIT_STR(name='cSG-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _CSGMembershipInfo_cellAccessMode = ENUM(name='cellAccessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')), opt=True)
    _CSGMembershipInfo_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')), opt=True)
    _CSGMembershipInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSGMembershipInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CSGMembershipInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____CSGMembershipInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab = ____CSGMembershipInfo_iE_Extensions__item__id_tab
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab_at = None
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___CSGMembershipInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSGMembershipInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab = ____CSGMembershipInfo_iE_Extensions__item__criticality_tab
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab = ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CSGMembershipInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CSGMembershipInfo_iE_Extensions__item__id),
        ('criticality', ___CSGMembershipInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___CSGMembershipInfo_iE_Extensions__item__extensionValue),
        ])
    __CSGMembershipInfo_iE_Extensions__item_._ext = None
    _CSGMembershipInfo_iE_Extensions._cont = __CSGMembershipInfo_iE_Extensions__item_
    _CSGMembershipInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSGMembershipInfo._cont = ASN1Dict([
        ('cSGMembershipStatus', _CSGMembershipInfo_cSGMembershipStatus),
        ('cSG-Id', _CSGMembershipInfo_cSG_Id),
        ('cellAccessMode', _CSGMembershipInfo_cellAccessMode),
        ('pLMNidentity', _CSGMembershipInfo_pLMNidentity),
        ('iE-Extensions', _CSGMembershipInfo_iE_Extensions),
        ])
    CSGMembershipInfo._ext = []
    
    #-----< CSGMembershipInfo-ExtIEs >-----#
    CSGMembershipInfo_ExtIEs = CLASS(name='CSGMembershipInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CSGMembershipInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABModificationConfirm >-----#
    E_RABModificationConfirm = SEQ(name='E-RABModificationConfirm', mode=MODE_TYPE)
    _E_RABModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____E_RABModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModConf')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    ____E_RABModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 203), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___E_RABModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_RABModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __E_RABModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_RABModificationConfirm_protocolIEs__item__id),
        ('criticality', ___E_RABModificationConfirm_protocolIEs__item__criticality),
        ('value', ___E_RABModificationConfirm_protocolIEs__item__value),
        ])
    __E_RABModificationConfirm_protocolIEs__item_._ext = None
    _E_RABModificationConfirm_protocolIEs._cont = __E_RABModificationConfirm_protocolIEs__item_
    _E_RABModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _E_RABModificationConfirm_protocolIEs),
        ])
    E_RABModificationConfirm._ext = []
    
    #-----< E-RABModificationConfirmIEs >-----#
    E_RABModificationConfirmIEs = CLASS(name='E-RABModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModificationConfirmIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModConf')))
    _E_RABModificationConfirmIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModificationConfirmIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModificationConfirmIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABModificationConfirmIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    E_RABModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 203), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _E_RABModificationConfirmIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyListBearerModConf >-----#
    E_RABModifyListBearerModConf = SEQ_OF(name='E-RABModifyListBearerModConf', mode=MODE_TYPE)
    _E_RABModifyListBearerModConf__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABModifyListBearerModConf__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABModifyListBearerModConf__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModConf')))
    ___E_RABModifyListBearerModConf__item__id_tab._val = ASN1Set(rv=[dict([('id', 204), ('criticality', 'ignore'), ('Value', ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABModifyListBearerModConf__item__id._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__id._const_tab_at = None
    __E_RABModifyListBearerModConf__item__id._const_tab_id = 'id'
    __E_RABModifyListBearerModConf__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABModifyListBearerModConf__item__criticality._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__criticality._const_tab_at = ('..', 'id')
    __E_RABModifyListBearerModConf__item__criticality._const_tab_id = 'criticality'
    __E_RABModifyListBearerModConf__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABModifyListBearerModConf__item__value._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__value._const_tab_at = ('..', 'id')
    __E_RABModifyListBearerModConf__item__value._const_tab_id = 'Value'
    _E_RABModifyListBearerModConf__item_._cont = ASN1Dict([
        ('id', __E_RABModifyListBearerModConf__item__id),
        ('criticality', __E_RABModifyListBearerModConf__item__criticality),
        ('value', __E_RABModifyListBearerModConf__item__value),
        ])
    _E_RABModifyListBearerModConf__item_._ext = None
    E_RABModifyListBearerModConf._cont = _E_RABModifyListBearerModConf__item_
    E_RABModifyListBearerModConf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABModifyItemBearerModConfIEs >-----#
    E_RABModifyItemBearerModConfIEs = CLASS(name='E-RABModifyItemBearerModConfIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyItemBearerModConfIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModConf')))
    E_RABModifyItemBearerModConfIEs._val = ASN1Set(rv=[dict([('id', 204), ('criticality', 'ignore'), ('Value', _E_RABModifyItemBearerModConfIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyItemBearerModConf >-----#
    E_RABModifyItemBearerModConf = SEQ(name='E-RABModifyItemBearerModConf', mode=MODE_TYPE)
    _E_RABModifyItemBearerModConf_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABModifyItemBearerModConf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABModifyItemBearerModConf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab_at = None
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABModifyItemBearerModConf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABModifyItemBearerModConf_iE_Extensions__item__id),
        ('criticality', ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue),
        ])
    __E_RABModifyItemBearerModConf_iE_Extensions__item_._ext = None
    _E_RABModifyItemBearerModConf_iE_Extensions._cont = __E_RABModifyItemBearerModConf_iE_Extensions__item_
    _E_RABModifyItemBearerModConf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABModifyItemBearerModConf._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABModifyItemBearerModConf_e_RAB_ID),
        ('iE-Extensions', _E_RABModifyItemBearerModConf_iE_Extensions),
        ])
    E_RABModifyItemBearerModConf._ext = []
    
    #-----< E-RABModifyItemBearerModConfExtIEs >-----#
    E_RABModifyItemBearerModConfExtIEs = CLASS(name='E-RABModifyItemBearerModConfExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABModifyItemBearerModConfExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationIndication >-----#
    UEContextModificationIndication = SEQ(name='UEContextModificationIndication', mode=MODE_TYPE)
    _UEContextModificationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    ____UEContextModificationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'reject'), ('Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationIndication_protocolIEs__item__id),
        ('criticality', ___UEContextModificationIndication_protocolIEs__item__criticality),
        ('value', ___UEContextModificationIndication_protocolIEs__item__value),
        ])
    __UEContextModificationIndication_protocolIEs__item_._ext = None
    _UEContextModificationIndication_protocolIEs._cont = __UEContextModificationIndication_protocolIEs__item_
    _UEContextModificationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationIndication._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationIndication_protocolIEs),
        ])
    UEContextModificationIndication._ext = []
    
    #-----< UEContextModificationIndicationIEs >-----#
    UEContextModificationIndicationIEs = CLASS(name='UEContextModificationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationIndicationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    UEContextModificationIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UEContextModificationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UEContextModificationIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 226), ('criticality', 'reject'), ('Value', _UEContextModificationIndicationIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationConfirm >-----#
    UEContextModificationConfirm = SEQ(name='UEContextModificationConfirm', mode=MODE_TYPE)
    _UEContextModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationConfirm_protocolIEs__item__id),
        ('criticality', ___UEContextModificationConfirm_protocolIEs__item__criticality),
        ('value', ___UEContextModificationConfirm_protocolIEs__item__value),
        ])
    __UEContextModificationConfirm_protocolIEs__item_._ext = None
    _UEContextModificationConfirm_protocolIEs._cont = __UEContextModificationConfirm_protocolIEs__item_
    _UEContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationConfirm_protocolIEs),
        ])
    UEContextModificationConfirm._ext = []
    
    #-----< UEContextModificationConfirmIEs >-----#
    UEContextModificationConfirmIEs = CLASS(name='UEContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _UEContextModificationConfirmIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationConfirmIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextModificationConfirmIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequest >-----#
    UEContextSuspendRequest = SEQ(name='UEContextSuspendRequest', mode=MODE_TYPE)
    _UEContextSuspendRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSuspendRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSuspendRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendRequest_protocolIEs__item__id),
        ('criticality', ___UEContextSuspendRequest_protocolIEs__item__criticality),
        ('value', ___UEContextSuspendRequest_protocolIEs__item__value),
        ])
    __UEContextSuspendRequest_protocolIEs__item_._ext = None
    _UEContextSuspendRequest_protocolIEs._cont = __UEContextSuspendRequest_protocolIEs__item_
    _UEContextSuspendRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextSuspendRequest_protocolIEs),
        ])
    UEContextSuspendRequest._ext = []
    
    #-----< UEContextSuspendRequestIEs >-----#
    UEContextSuspendRequestIEs = CLASS(name='UEContextSuspendRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextSuspendRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextSuspendRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextSuspendRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _UEContextSuspendRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _UEContextSuspendRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _UEContextSuspendRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _UEContextSuspendRequestIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    UEContextSuspendRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UEContextSuspendRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UEContextSuspendRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendResponse >-----#
    UEContextSuspendResponse = SEQ(name='UEContextSuspendResponse', mode=MODE_TYPE)
    _UEContextSuspendResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSuspendResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSuspendResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendResponse_protocolIEs__item__id),
        ('criticality', ___UEContextSuspendResponse_protocolIEs__item__criticality),
        ('value', ___UEContextSuspendResponse_protocolIEs__item__value),
        ])
    __UEContextSuspendResponse_protocolIEs__item_._ext = None
    _UEContextSuspendResponse_protocolIEs._cont = __UEContextSuspendResponse_protocolIEs__item_
    _UEContextSuspendResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextSuspendResponse_protocolIEs),
        ])
    UEContextSuspendResponse._ext = []
    
    #-----< UEContextSuspendResponseIEs >-----#
    UEContextSuspendResponseIEs = CLASS(name='UEContextSuspendResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextSuspendResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextSuspendResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextSuspendResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSuspendResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    UEContextSuspendResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextSuspendResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeRequest >-----#
    UEContextResumeRequest = SEQ(name='UEContextResumeRequest', mode=MODE_TYPE)
    _UEContextResumeRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    ____UEContextResumeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 235), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeRequest_protocolIEs__item__id),
        ('criticality', ___UEContextResumeRequest_protocolIEs__item__criticality),
        ('value', ___UEContextResumeRequest_protocolIEs__item__value),
        ])
    __UEContextResumeRequest_protocolIEs__item_._ext = None
    _UEContextResumeRequest_protocolIEs._cont = __UEContextResumeRequest_protocolIEs__item_
    _UEContextResumeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeRequest_protocolIEs),
        ])
    UEContextResumeRequest._ext = []
    
    #-----< UEContextResumeRequestIEs >-----#
    UEContextResumeRequestIEs = CLASS(name='UEContextResumeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeReq')))
    _UEContextResumeRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    UEContextResumeRequestIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 235), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _UEContextResumeRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeListResumeReq >-----#
    E_RABFailedToResumeListResumeReq = SEQ_OF(name='E-RABFailedToResumeListResumeReq', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedToResumeListResumeReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedToResumeListResumeReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABFailedToResumeListResumeReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeReq')))
    ___E_RABFailedToResumeListResumeReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'reject'), ('Value', ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedToResumeListResumeReq__item__id._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__id._const_tab_at = None
    __E_RABFailedToResumeListResumeReq__item__id._const_tab_id = 'id'
    __E_RABFailedToResumeListResumeReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab_id = 'criticality'
    __E_RABFailedToResumeListResumeReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABFailedToResumeListResumeReq__item__value._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__value._const_tab_at = ('..', 'id')
    __E_RABFailedToResumeListResumeReq__item__value._const_tab_id = 'Value'
    _E_RABFailedToResumeListResumeReq__item_._cont = ASN1Dict([
        ('id', __E_RABFailedToResumeListResumeReq__item__id),
        ('criticality', __E_RABFailedToResumeListResumeReq__item__criticality),
        ('value', __E_RABFailedToResumeListResumeReq__item__value),
        ])
    _E_RABFailedToResumeListResumeReq__item_._ext = None
    E_RABFailedToResumeListResumeReq._cont = _E_RABFailedToResumeListResumeReq__item_
    E_RABFailedToResumeListResumeReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedToResumeItemResumeReqIEs >-----#
    E_RABFailedToResumeItemResumeReqIEs = CLASS(name='E-RABFailedToResumeItemResumeReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedToResumeItemResumeReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeReq')))
    E_RABFailedToResumeItemResumeReqIEs._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'reject'), ('Value', _E_RABFailedToResumeItemResumeReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeItemResumeReq >-----#
    E_RABFailedToResumeItemResumeReq = SEQ(name='E-RABFailedToResumeItemResumeReq', mode=MODE_TYPE)
    _E_RABFailedToResumeItemResumeReq_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToResumeItemResumeReq_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToResumeItemResumeReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id),
        ('criticality', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_._ext = None
    _E_RABFailedToResumeItemResumeReq_iE_Extensions._cont = __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_
    _E_RABFailedToResumeItemResumeReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToResumeItemResumeReq._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABFailedToResumeItemResumeReq_e_RAB_ID),
        ('cause', _E_RABFailedToResumeItemResumeReq_cause),
        ('iE-Extensions', _E_RABFailedToResumeItemResumeReq_iE_Extensions),
        ])
    E_RABFailedToResumeItemResumeReq._ext = []
    
    #-----< E-RABFailedToResumeItemResumeReq-ExtIEs >-----#
    E_RABFailedToResumeItemResumeReq_ExtIEs = CLASS(name='E-RABFailedToResumeItemResumeReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToResumeItemResumeReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponse >-----#
    UEContextResumeResponse = SEQ(name='UEContextResumeResponse', mode=MODE_TYPE)
    _UEContextResumeResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    ____UEContextResumeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'reject'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeResponse_protocolIEs__item__id),
        ('criticality', ___UEContextResumeResponse_protocolIEs__item__criticality),
        ('value', ___UEContextResumeResponse_protocolIEs__item__value),
        ])
    __UEContextResumeResponse_protocolIEs__item_._ext = None
    _UEContextResumeResponse_protocolIEs._cont = __UEContextResumeResponse_protocolIEs__item_
    _UEContextResumeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeResponse_protocolIEs),
        ])
    UEContextResumeResponse._ext = []
    
    #-----< UEContextResumeResponseIEs >-----#
    UEContextResumeResponseIEs = CLASS(name='UEContextResumeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeRes')))
    _UEContextResumeResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextResumeResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _UEContextResumeResponseIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    UEContextResumeResponseIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'reject'), ('Value', _UEContextResumeResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextResumeResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeListResumeRes >-----#
    E_RABFailedToResumeListResumeRes = SEQ_OF(name='E-RABFailedToResumeListResumeRes', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedToResumeListResumeRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedToResumeListResumeRes__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ___E_RABFailedToResumeListResumeRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeRes')))
    ___E_RABFailedToResumeListResumeRes__item__id_tab._val = ASN1Set(rv=[dict([('id', 238), ('criticality', 'reject'), ('Value', ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedToResumeListResumeRes__item__id._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__id._const_tab_at = None
    __E_RABFailedToResumeListResumeRes__item__id._const_tab_id = 'id'
    __E_RABFailedToResumeListResumeRes__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab_at = ('..', 'id')
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab_id = 'criticality'
    __E_RABFailedToResumeListResumeRes__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    __E_RABFailedToResumeListResumeRes__item__value._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__value._const_tab_at = ('..', 'id')
    __E_RABFailedToResumeListResumeRes__item__value._const_tab_id = 'Value'
    _E_RABFailedToResumeListResumeRes__item_._cont = ASN1Dict([
        ('id', __E_RABFailedToResumeListResumeRes__item__id),
        ('criticality', __E_RABFailedToResumeListResumeRes__item__criticality),
        ('value', __E_RABFailedToResumeListResumeRes__item__value),
        ])
    _E_RABFailedToResumeListResumeRes__item_._ext = None
    E_RABFailedToResumeListResumeRes._cont = _E_RABFailedToResumeListResumeRes__item_
    E_RABFailedToResumeListResumeRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedToResumeItemResumeResIEs >-----#
    E_RABFailedToResumeItemResumeResIEs = CLASS(name='E-RABFailedToResumeItemResumeResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedToResumeItemResumeResIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeRes')))
    E_RABFailedToResumeItemResumeResIEs._val = ASN1Set(rv=[dict([('id', 238), ('criticality', 'reject'), ('Value', _E_RABFailedToResumeItemResumeResIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeItemResumeRes >-----#
    E_RABFailedToResumeItemResumeRes = SEQ(name='E-RABFailedToResumeItemResumeRes', mode=MODE_TYPE)
    _E_RABFailedToResumeItemResumeRes_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToResumeItemResumeRes_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToResumeItemResumeRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id),
        ('criticality', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_._ext = None
    _E_RABFailedToResumeItemResumeRes_iE_Extensions._cont = __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_
    _E_RABFailedToResumeItemResumeRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToResumeItemResumeRes._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABFailedToResumeItemResumeRes_e_RAB_ID),
        ('cause', _E_RABFailedToResumeItemResumeRes_cause),
        ('iE-Extensions', _E_RABFailedToResumeItemResumeRes_iE_Extensions),
        ])
    E_RABFailedToResumeItemResumeRes._ext = []
    
    #-----< E-RABFailedToResumeItemResumeRes-ExtIEs >-----#
    E_RABFailedToResumeItemResumeRes_ExtIEs = CLASS(name='E-RABFailedToResumeItemResumeRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToResumeItemResumeRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeFailure >-----#
    UEContextResumeFailure = SEQ(name='UEContextResumeFailure', mode=MODE_TYPE)
    _UEContextResumeFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeFailure_protocolIEs__item__id),
        ('criticality', ___UEContextResumeFailure_protocolIEs__item__criticality),
        ('value', ___UEContextResumeFailure_protocolIEs__item__value),
        ])
    __UEContextResumeFailure_protocolIEs__item_._ext = None
    _UEContextResumeFailure_protocolIEs._cont = __UEContextResumeFailure_protocolIEs__item_
    _UEContextResumeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeFailure_protocolIEs),
        ])
    UEContextResumeFailure._ext = []
    
    #-----< UEContextResumeFailureIEs >-----#
    UEContextResumeFailureIEs = CLASS(name='UEContextResumeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextResumeFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionEstablishmentIndication >-----#
    ConnectionEstablishmentIndication = SEQ(name='ConnectionEstablishmentIndication', mode=MODE_TYPE)
    _ConnectionEstablishmentIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ConnectionEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ConnectionEstablishmentIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DL-CP-SecurityInformation')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 252), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ConnectionEstablishmentIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ConnectionEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ConnectionEstablishmentIndication_protocolIEs__item__id),
        ('criticality', ___ConnectionEstablishmentIndication_protocolIEs__item__criticality),
        ('value', ___ConnectionEstablishmentIndication_protocolIEs__item__value),
        ])
    __ConnectionEstablishmentIndication_protocolIEs__item_._ext = None
    _ConnectionEstablishmentIndication_protocolIEs._cont = __ConnectionEstablishmentIndication_protocolIEs__item_
    _ConnectionEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ConnectionEstablishmentIndication._cont = ASN1Dict([
        ('protocolIEs', _ConnectionEstablishmentIndication_protocolIEs),
        ])
    ConnectionEstablishmentIndication._ext = []
    
    #-----< ConnectionEstablishmentIndicationIEs >-----#
    ConnectionEstablishmentIndicationIEs = CLASS(name='ConnectionEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ConnectionEstablishmentIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _ConnectionEstablishmentIndicationIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DL-CP-SecurityInformation')))
    _ConnectionEstablishmentIndicationIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _ConnectionEstablishmentIndicationIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _ConnectionEstablishmentIndicationIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _ConnectionEstablishmentIndicationIEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    ConnectionEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 252), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEInformation >-----#
    RetrieveUEInformation = SEQ(name='RetrieveUEInformation', mode=MODE_TYPE)
    _RetrieveUEInformation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEInformation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____RetrieveUEInformation_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ____RetrieveUEInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Value', _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_id = 'id'
    ___RetrieveUEInformation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RetrieveUEInformation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_id = 'Value'
    __RetrieveUEInformation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RetrieveUEInformation_protocolIEs__item__id),
        ('criticality', ___RetrieveUEInformation_protocolIEs__item__criticality),
        ('value', ___RetrieveUEInformation_protocolIEs__item__value),
        ])
    __RetrieveUEInformation_protocolIEs__item_._ext = None
    _RetrieveUEInformation_protocolIEs._cont = __RetrieveUEInformation_protocolIEs__item_
    _RetrieveUEInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEInformation._cont = ASN1Dict([
        ('protocolIEs', _RetrieveUEInformation_protocolIEs),
        ])
    RetrieveUEInformation._ext = []
    
    #-----< RetrieveUEInformationIEs >-----#
    RetrieveUEInformationIEs = CLASS(name='RetrieveUEInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RetrieveUEInformationIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    RetrieveUEInformationIEs._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Value', _RetrieveUEInformationIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInformationTransfer >-----#
    UEInformationTransfer = SEQ(name='UEInformationTransfer', mode=MODE_TYPE)
    _UEInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UEInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    ____UEInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 252), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEInformationTransfer_protocolIEs__item__id._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UEInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UEInformationTransfer_protocolIEs__item__value._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UEInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEInformationTransfer_protocolIEs__item__id),
        ('criticality', ___UEInformationTransfer_protocolIEs__item__criticality),
        ('value', ___UEInformationTransfer_protocolIEs__item__value),
        ])
    __UEInformationTransfer_protocolIEs__item_._ext = None
    _UEInformationTransfer_protocolIEs._cont = __UEInformationTransfer_protocolIEs__item_
    _UEInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _UEInformationTransfer_protocolIEs),
        ])
    UEInformationTransfer._ext = []
    
    #-----< UEInformationTransferIEs >-----#
    UEInformationTransferIEs = CLASS(name='UEInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEInformationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _UEInformationTransferIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _UEInformationTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UEInformationTransferIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _UEInformationTransferIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _UEInformationTransferIEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    UEInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Value', _UEInformationTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 252), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBCPRelocationIndication >-----#
    ENBCPRelocationIndication = SEQ(name='ENBCPRelocationIndication', mode=MODE_TYPE)
    _ENBCPRelocationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBCPRelocationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____ENBCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UL-CP-SecurityInformation')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ____ENBCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'reject'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBCPRelocationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBCPRelocationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBCPRelocationIndication_protocolIEs__item__id),
        ('criticality', ___ENBCPRelocationIndication_protocolIEs__item__criticality),
        ('value', ___ENBCPRelocationIndication_protocolIEs__item__value),
        ])
    __ENBCPRelocationIndication_protocolIEs__item_._ext = None
    _ENBCPRelocationIndication_protocolIEs._cont = __ENBCPRelocationIndication_protocolIEs__item_
    _ENBCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBCPRelocationIndication._cont = ASN1Dict([
        ('protocolIEs', _ENBCPRelocationIndication_protocolIEs),
        ])
    ENBCPRelocationIndication._ext = []
    
    #-----< ENBCPRelocationIndicationIEs >-----#
    ENBCPRelocationIndicationIEs = CLASS(name='ENBCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBCPRelocationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBCPRelocationIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _ENBCPRelocationIndicationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _ENBCPRelocationIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _ENBCPRelocationIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UL-CP-SecurityInformation')))
    _ENBCPRelocationIndicationIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-NTN-TAI-Information')))
    ENBCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'reject'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'ignore'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 254), ('criticality', 'reject'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _ENBCPRelocationIndicationIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMECPRelocationIndication >-----#
    MMECPRelocationIndication = SEQ(name='MMECPRelocationIndication', mode=MODE_TYPE)
    _MMECPRelocationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMECPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMECPRelocationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____MMECPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____MMECPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___MMECPRelocationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MMECPRelocationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __MMECPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MMECPRelocationIndication_protocolIEs__item__id),
        ('criticality', ___MMECPRelocationIndication_protocolIEs__item__criticality),
        ('value', ___MMECPRelocationIndication_protocolIEs__item__value),
        ])
    __MMECPRelocationIndication_protocolIEs__item_._ext = None
    _MMECPRelocationIndication_protocolIEs._cont = __MMECPRelocationIndication_protocolIEs__item_
    _MMECPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMECPRelocationIndication._cont = ASN1Dict([
        ('protocolIEs', _MMECPRelocationIndication_protocolIEs),
        ])
    MMECPRelocationIndication._ext = []
    
    #-----< MMECPRelocationIndicationIEs >-----#
    MMECPRelocationIndicationIEs = CLASS(name='MMECPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMECPRelocationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMECPRelocationIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    MMECPRelocationIndicationIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'reject'), ('Value', _MMECPRelocationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _MMECPRelocationIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReport >-----#
    SecondaryRATDataUsageReport = SEQ(name='SecondaryRATDataUsageReport', mode=MODE_TYPE)
    _SecondaryRATDataUsageReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __SecondaryRATDataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___SecondaryRATDataUsageReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverFlag')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 266), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_id = 'id'
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATDataUsageReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_id = 'Value'
    __SecondaryRATDataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATDataUsageReport_protocolIEs__item__id),
        ('criticality', ___SecondaryRATDataUsageReport_protocolIEs__item__criticality),
        ('value', ___SecondaryRATDataUsageReport_protocolIEs__item__value),
        ])
    __SecondaryRATDataUsageReport_protocolIEs__item_._ext = None
    _SecondaryRATDataUsageReport_protocolIEs._cont = __SecondaryRATDataUsageReport_protocolIEs__item_
    _SecondaryRATDataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReport._cont = ASN1Dict([
        ('protocolIEs', _SecondaryRATDataUsageReport_protocolIEs),
        ])
    SecondaryRATDataUsageReport._ext = []
    
    #-----< SecondaryRATDataUsageReportIEs >-----#
    SecondaryRATDataUsageReportIEs = CLASS(name='SecondaryRATDataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _SecondaryRATDataUsageReportIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverFlag')))
    _SecondaryRATDataUsageReportIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _SecondaryRATDataUsageReportIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    SecondaryRATDataUsageReportIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 266), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 189), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingRequest >-----#
    UERadioCapabilityIDMappingRequest = SEQ(name='UERadioCapabilityIDMappingRequest', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingRequest_protocolIEs._cont = __UERadioCapabilityIDMappingRequest_protocolIEs__item_
    _UERadioCapabilityIDMappingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingRequest._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingRequest_protocolIEs),
        ])
    UERadioCapabilityIDMappingRequest._ext = []
    
    #-----< UERadioCapabilityIDMappingRequestIEs >-----#
    UERadioCapabilityIDMappingRequestIEs = CLASS(name='UERadioCapabilityIDMappingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingRequestIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityIDMappingRequestIEs._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingResponse >-----#
    UERadioCapabilityIDMappingResponse = SEQ(name='UERadioCapabilityIDMappingResponse', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingResponse_protocolIEs._cont = __UERadioCapabilityIDMappingResponse_protocolIEs__item_
    _UERadioCapabilityIDMappingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingResponse._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingResponse_protocolIEs),
        ])
    UERadioCapabilityIDMappingResponse._ext = []
    
    #-----< UERadioCapabilityIDMappingResponseIEs >-----#
    UERadioCapabilityIDMappingResponseIEs = CLASS(name='UERadioCapabilityIDMappingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityIDMappingResponseIEs._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____HandoverRequired_protocolIEs__item__id_tab,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13,
        ___HandoverRequired_protocolIEs__item__id,
        ___HandoverRequired_protocolIEs__item__criticality,
        ___HandoverRequired_protocolIEs__item__value,
        __HandoverRequired_protocolIEs__item_,
        _HandoverRequired_protocolIEs,
        HandoverRequired,
        HandoverRequiredIEs,
        _HandoverRequiredIEs_val_Value_0,
        _HandoverRequiredIEs_val_Value_1,
        _HandoverRequiredIEs_val_Value_2,
        _HandoverRequiredIEs_val_Value_3,
        _HandoverRequiredIEs_val_Value_4,
        _HandoverRequiredIEs_val_Value_5,
        _HandoverRequiredIEs_val_Value_6,
        _HandoverRequiredIEs_val_Value_7,
        _HandoverRequiredIEs_val_Value_8,
        _HandoverRequiredIEs_val_Value_9,
        _HandoverRequiredIEs_val_Value_10,
        _HandoverRequiredIEs_val_Value_11,
        _HandoverRequiredIEs_val_Value_12,
        _HandoverRequiredIEs_val_Value_13,
        ____HandoverCommand_protocolIEs__item__id_tab,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8,
        ___HandoverCommand_protocolIEs__item__id,
        ___HandoverCommand_protocolIEs__item__criticality,
        ___HandoverCommand_protocolIEs__item__value,
        __HandoverCommand_protocolIEs__item_,
        _HandoverCommand_protocolIEs,
        HandoverCommand,
        HandoverCommandIEs,
        _HandoverCommandIEs_val_Value_0,
        _HandoverCommandIEs_val_Value_1,
        _HandoverCommandIEs_val_Value_2,
        _HandoverCommandIEs_val_Value_3,
        _HandoverCommandIEs_val_Value_4,
        _HandoverCommandIEs_val_Value_5,
        _HandoverCommandIEs_val_Value_6,
        _HandoverCommandIEs_val_Value_7,
        _HandoverCommandIEs_val_Value_8,
        ___E_RABSubjecttoDataForwardingList__item__id_tab,
        ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0,
        __E_RABSubjecttoDataForwardingList__item__id,
        __E_RABSubjecttoDataForwardingList__item__criticality,
        __E_RABSubjecttoDataForwardingList__item__value,
        _E_RABSubjecttoDataForwardingList__item_,
        E_RABSubjecttoDataForwardingList,
        E_RABDataForwardingItemIEs,
        _E_RABDataForwardingItemIEs_val_Value_0,
        _E_RABDataForwardingItem_e_RAB_ID,
        _E_RABDataForwardingItem_dL_transportLayerAddress,
        _E_RABDataForwardingItem_dL_gTP_TEID,
        _E_RABDataForwardingItem_uL_TransportLayerAddress,
        _E_RABDataForwardingItem_uL_GTP_TEID,
        ____E_RABDataForwardingItem_iE_Extensions__item__id_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__id,
        ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__criticality,
        ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue,
        __E_RABDataForwardingItem_iE_Extensions__item_,
        _E_RABDataForwardingItem_iE_Extensions,
        E_RABDataForwardingItem,
        E_RABDataForwardingItem_ExtIEs,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailureIEs,
        _HandoverPreparationFailureIEs_val_Value_0,
        _HandoverPreparationFailureIEs_val_Value_1,
        _HandoverPreparationFailureIEs_val_Value_2,
        _HandoverPreparationFailureIEs_val_Value_3,
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequestIEs,
        _HandoverRequestIEs_val_Value_0,
        _HandoverRequestIEs_val_Value_1,
        _HandoverRequestIEs_val_Value_2,
        _HandoverRequestIEs_val_Value_3,
        _HandoverRequestIEs_val_Value_4,
        _HandoverRequestIEs_val_Value_5,
        _HandoverRequestIEs_val_Value_6,
        _HandoverRequestIEs_val_Value_7,
        _HandoverRequestIEs_val_Value_8,
        _HandoverRequestIEs_val_Value_9,
        _HandoverRequestIEs_val_Value_10,
        _HandoverRequestIEs_val_Value_11,
        _HandoverRequestIEs_val_Value_12,
        _HandoverRequestIEs_val_Value_13,
        _HandoverRequestIEs_val_Value_14,
        _HandoverRequestIEs_val_Value_15,
        _HandoverRequestIEs_val_Value_16,
        _HandoverRequestIEs_val_Value_17,
        _HandoverRequestIEs_val_Value_18,
        _HandoverRequestIEs_val_Value_19,
        _HandoverRequestIEs_val_Value_20,
        _HandoverRequestIEs_val_Value_21,
        _HandoverRequestIEs_val_Value_22,
        _HandoverRequestIEs_val_Value_23,
        _HandoverRequestIEs_val_Value_24,
        _HandoverRequestIEs_val_Value_25,
        _HandoverRequestIEs_val_Value_26,
        _HandoverRequestIEs_val_Value_27,
        _HandoverRequestIEs_val_Value_28,
        _HandoverRequestIEs_val_Value_29,
        _HandoverRequestIEs_val_Value_30,
        _HandoverRequestIEs_val_Value_31,
        _HandoverRequestIEs_val_Value_32,
        _HandoverRequestIEs_val_Value_33,
        _HandoverRequestIEs_val_Value_34,
        _HandoverRequestIEs_val_Value_35,
        _HandoverRequestIEs_val_Value_36,
        ___E_RABToBeSetupListHOReq__item__id_tab,
        ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListHOReq__item__id,
        __E_RABToBeSetupListHOReq__item__criticality,
        __E_RABToBeSetupListHOReq__item__value,
        _E_RABToBeSetupListHOReq__item_,
        E_RABToBeSetupListHOReq,
        E_RABToBeSetupItemHOReqIEs,
        _E_RABToBeSetupItemHOReqIEs_val_Value_0,
        _E_RABToBeSetupItemHOReq_e_RAB_ID,
        _E_RABToBeSetupItemHOReq_transportLayerAddress,
        _E_RABToBeSetupItemHOReq_gTP_TEID,
        _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters,
        ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemHOReq_iE_Extensions__item_,
        _E_RABToBeSetupItemHOReq_iE_Extensions,
        E_RABToBeSetupItemHOReq,
        E_RABToBeSetupItemHOReq_ExtIEs,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_3,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledgeIEs,
        _HandoverRequestAcknowledgeIEs_val_Value_0,
        _HandoverRequestAcknowledgeIEs_val_Value_1,
        _HandoverRequestAcknowledgeIEs_val_Value_2,
        _HandoverRequestAcknowledgeIEs_val_Value_3,
        _HandoverRequestAcknowledgeIEs_val_Value_4,
        _HandoverRequestAcknowledgeIEs_val_Value_5,
        _HandoverRequestAcknowledgeIEs_val_Value_6,
        _HandoverRequestAcknowledgeIEs_val_Value_7,
        _HandoverRequestAcknowledgeIEs_val_Value_8,
        ___E_RABAdmittedList__item__id_tab,
        ____E_RABAdmittedList__item__id_tab_val_Value_0,
        __E_RABAdmittedList__item__id,
        __E_RABAdmittedList__item__criticality,
        __E_RABAdmittedList__item__value,
        _E_RABAdmittedList__item_,
        E_RABAdmittedList,
        E_RABAdmittedItemIEs,
        _E_RABAdmittedItemIEs_val_Value_0,
        _E_RABAdmittedItem_e_RAB_ID,
        _E_RABAdmittedItem_transportLayerAddress,
        _E_RABAdmittedItem_gTP_TEID,
        _E_RABAdmittedItem_dL_transportLayerAddress,
        _E_RABAdmittedItem_dL_gTP_TEID,
        _E_RABAdmittedItem_uL_TransportLayerAddress,
        _E_RABAdmittedItem_uL_GTP_TEID,
        ____E_RABAdmittedItem_iE_Extensions__item__id_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__id,
        ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__criticality,
        ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__extensionValue,
        __E_RABAdmittedItem_iE_Extensions__item_,
        _E_RABAdmittedItem_iE_Extensions,
        E_RABAdmittedItem,
        E_RABAdmittedItem_ExtIEs,
        ___E_RABFailedtoSetupListHOReqAck__item__id_tab,
        ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0,
        __E_RABFailedtoSetupListHOReqAck__item__id,
        __E_RABFailedtoSetupListHOReqAck__item__criticality,
        __E_RABFailedtoSetupListHOReqAck__item__value,
        _E_RABFailedtoSetupListHOReqAck__item_,
        E_RABFailedtoSetupListHOReqAck,
        E_RABFailedtoSetupItemHOReqAckIEs,
        _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0,
        _E_RABFailedToSetupItemHOReqAck_e_RAB_ID,
        _E_RABFailedToSetupItemHOReqAck_cause,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue,
        __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_,
        _E_RABFailedToSetupItemHOReqAck_iE_Extensions,
        E_RABFailedToSetupItemHOReqAck,
        E_RABFailedToSetupItemHOReqAckExtIEs,
        ____HandoverFailure_protocolIEs__item__id_tab,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverFailure_protocolIEs__item__id,
        ___HandoverFailure_protocolIEs__item__criticality,
        ___HandoverFailure_protocolIEs__item__value,
        __HandoverFailure_protocolIEs__item_,
        _HandoverFailure_protocolIEs,
        HandoverFailure,
        HandoverFailureIEs,
        _HandoverFailureIEs_val_Value_0,
        _HandoverFailureIEs_val_Value_1,
        _HandoverFailureIEs_val_Value_2,
        ____HandoverNotify_protocolIEs__item__id_tab,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_8,
        ___HandoverNotify_protocolIEs__item__id,
        ___HandoverNotify_protocolIEs__item__criticality,
        ___HandoverNotify_protocolIEs__item__value,
        __HandoverNotify_protocolIEs__item_,
        _HandoverNotify_protocolIEs,
        HandoverNotify,
        HandoverNotifyIEs,
        _HandoverNotifyIEs_val_Value_0,
        _HandoverNotifyIEs_val_Value_1,
        _HandoverNotifyIEs_val_Value_2,
        _HandoverNotifyIEs_val_Value_3,
        _HandoverNotifyIEs_val_Value_4,
        _HandoverNotifyIEs_val_Value_5,
        _HandoverNotifyIEs_val_Value_6,
        _HandoverNotifyIEs_val_Value_7,
        _HandoverNotifyIEs_val_Value_8,
        ____PathSwitchRequest_protocolIEs__item__id_tab,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_15,
        ___PathSwitchRequest_protocolIEs__item__id,
        ___PathSwitchRequest_protocolIEs__item__criticality,
        ___PathSwitchRequest_protocolIEs__item__value,
        __PathSwitchRequest_protocolIEs__item_,
        _PathSwitchRequest_protocolIEs,
        PathSwitchRequest,
        PathSwitchRequestIEs,
        _PathSwitchRequestIEs_val_Value_0,
        _PathSwitchRequestIEs_val_Value_1,
        _PathSwitchRequestIEs_val_Value_2,
        _PathSwitchRequestIEs_val_Value_3,
        _PathSwitchRequestIEs_val_Value_4,
        _PathSwitchRequestIEs_val_Value_5,
        _PathSwitchRequestIEs_val_Value_6,
        _PathSwitchRequestIEs_val_Value_7,
        _PathSwitchRequestIEs_val_Value_8,
        _PathSwitchRequestIEs_val_Value_9,
        _PathSwitchRequestIEs_val_Value_10,
        _PathSwitchRequestIEs_val_Value_11,
        _PathSwitchRequestIEs_val_Value_12,
        _PathSwitchRequestIEs_val_Value_13,
        _PathSwitchRequestIEs_val_Value_14,
        _PathSwitchRequestIEs_val_Value_15,
        ___E_RABToBeSwitchedDLList__item__id_tab,
        ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0,
        __E_RABToBeSwitchedDLList__item__id,
        __E_RABToBeSwitchedDLList__item__criticality,
        __E_RABToBeSwitchedDLList__item__value,
        _E_RABToBeSwitchedDLList__item_,
        E_RABToBeSwitchedDLList,
        E_RABToBeSwitchedDLItemIEs,
        _E_RABToBeSwitchedDLItemIEs_val_Value_0,
        _E_RABToBeSwitchedDLItem_e_RAB_ID,
        _E_RABToBeSwitchedDLItem_transportLayerAddress,
        _E_RABToBeSwitchedDLItem_gTP_TEID,
        ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab,
        _____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue,
        __E_RABToBeSwitchedDLItem_iE_Extensions__item_,
        _E_RABToBeSwitchedDLItem_iE_Extensions,
        E_RABToBeSwitchedDLItem,
        E_RABToBeSwitchedDLItem_ExtIEs,
        _E_RABToBeSwitchedDLItem_ExtIEs_val_Extension_0,
        ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__id,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__value,
        __PathSwitchRequestAcknowledge_protocolIEs__item_,
        _PathSwitchRequestAcknowledge_protocolIEs,
        PathSwitchRequestAcknowledge,
        PathSwitchRequestAcknowledgeIEs,
        _PathSwitchRequestAcknowledgeIEs_val_Value_0,
        _PathSwitchRequestAcknowledgeIEs_val_Value_1,
        _PathSwitchRequestAcknowledgeIEs_val_Value_2,
        _PathSwitchRequestAcknowledgeIEs_val_Value_3,
        _PathSwitchRequestAcknowledgeIEs_val_Value_4,
        _PathSwitchRequestAcknowledgeIEs_val_Value_5,
        _PathSwitchRequestAcknowledgeIEs_val_Value_6,
        _PathSwitchRequestAcknowledgeIEs_val_Value_7,
        _PathSwitchRequestAcknowledgeIEs_val_Value_8,
        _PathSwitchRequestAcknowledgeIEs_val_Value_9,
        _PathSwitchRequestAcknowledgeIEs_val_Value_10,
        _PathSwitchRequestAcknowledgeIEs_val_Value_11,
        _PathSwitchRequestAcknowledgeIEs_val_Value_12,
        _PathSwitchRequestAcknowledgeIEs_val_Value_13,
        _PathSwitchRequestAcknowledgeIEs_val_Value_14,
        _PathSwitchRequestAcknowledgeIEs_val_Value_15,
        _PathSwitchRequestAcknowledgeIEs_val_Value_16,
        _PathSwitchRequestAcknowledgeIEs_val_Value_17,
        _PathSwitchRequestAcknowledgeIEs_val_Value_18,
        _PathSwitchRequestAcknowledgeIEs_val_Value_19,
        _PathSwitchRequestAcknowledgeIEs_val_Value_20,
        _PathSwitchRequestAcknowledgeIEs_val_Value_21,
        _PathSwitchRequestAcknowledgeIEs_val_Value_22,
        _PathSwitchRequestAcknowledgeIEs_val_Value_23,
        _PathSwitchRequestAcknowledgeIEs_val_Value_24,
        _PathSwitchRequestAcknowledgeIEs_val_Value_25,
        _PathSwitchRequestAcknowledgeIEs_val_Value_26,
        ___E_RABToBeSwitchedULList__item__id_tab,
        ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0,
        __E_RABToBeSwitchedULList__item__id,
        __E_RABToBeSwitchedULList__item__criticality,
        __E_RABToBeSwitchedULList__item__value,
        _E_RABToBeSwitchedULList__item_,
        E_RABToBeSwitchedULList,
        E_RABToBeSwitchedULItemIEs,
        _E_RABToBeSwitchedULItemIEs_val_Value_0,
        _E_RABToBeSwitchedULItem_e_RAB_ID,
        _E_RABToBeSwitchedULItem_transportLayerAddress,
        _E_RABToBeSwitchedULItem_gTP_TEID,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__id,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue,
        __E_RABToBeSwitchedULItem_iE_Extensions__item_,
        _E_RABToBeSwitchedULItem_iE_Extensions,
        E_RABToBeSwitchedULItem,
        E_RABToBeSwitchedULItem_ExtIEs,
        ___E_RABToBeUpdatedList__item__id_tab,
        ____E_RABToBeUpdatedList__item__id_tab_val_Value_0,
        __E_RABToBeUpdatedList__item__id,
        __E_RABToBeUpdatedList__item__criticality,
        __E_RABToBeUpdatedList__item__value,
        _E_RABToBeUpdatedList__item_,
        E_RABToBeUpdatedList,
        E_RABToBeUpdatedItemIEs,
        _E_RABToBeUpdatedItemIEs_val_Value_0,
        _E_RABToBeUpdatedItem_e_RAB_ID,
        _E_RABToBeUpdatedItem_securityIndication,
        ____E_RABToBeUpdatedItem_iE_Extensions__item__id_tab,
        ___E_RABToBeUpdatedItem_iE_Extensions__item__id,
        ____E_RABToBeUpdatedItem_iE_Extensions__item__criticality_tab,
        ___E_RABToBeUpdatedItem_iE_Extensions__item__criticality,
        ____E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeUpdatedItem_iE_Extensions__item__extensionValue,
        __E_RABToBeUpdatedItem_iE_Extensions__item_,
        _E_RABToBeUpdatedItem_iE_Extensions,
        E_RABToBeUpdatedItem,
        E_RABToBeUpdatedItem_ExtIEs,
        ____PathSwitchRequestFailure_protocolIEs__item__id_tab,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PathSwitchRequestFailure_protocolIEs__item__id,
        ___PathSwitchRequestFailure_protocolIEs__item__criticality,
        ___PathSwitchRequestFailure_protocolIEs__item__value,
        __PathSwitchRequestFailure_protocolIEs__item_,
        _PathSwitchRequestFailure_protocolIEs,
        PathSwitchRequestFailure,
        PathSwitchRequestFailureIEs,
        _PathSwitchRequestFailureIEs_val_Value_0,
        _PathSwitchRequestFailureIEs_val_Value_1,
        _PathSwitchRequestFailureIEs_val_Value_2,
        _PathSwitchRequestFailureIEs_val_Value_3,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancelIEs,
        _HandoverCancelIEs_val_Value_0,
        _HandoverCancelIEs_val_Value_1,
        _HandoverCancelIEs_val_Value_2,
        ____HandoverCancelAcknowledge_protocolIEs__item__id_tab,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancelAcknowledge_protocolIEs__item__id,
        ___HandoverCancelAcknowledge_protocolIEs__item__criticality,
        ___HandoverCancelAcknowledge_protocolIEs__item__value,
        __HandoverCancelAcknowledge_protocolIEs__item_,
        _HandoverCancelAcknowledge_protocolIEs,
        HandoverCancelAcknowledge,
        HandoverCancelAcknowledgeIEs,
        _HandoverCancelAcknowledgeIEs_val_Value_0,
        _HandoverCancelAcknowledgeIEs_val_Value_1,
        _HandoverCancelAcknowledgeIEs_val_Value_2,
        ____HandoverSuccess_protocolIEs__item__id_tab,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1,
        ___HandoverSuccess_protocolIEs__item__id,
        ___HandoverSuccess_protocolIEs__item__criticality,
        ___HandoverSuccess_protocolIEs__item__value,
        __HandoverSuccess_protocolIEs__item_,
        _HandoverSuccess_protocolIEs,
        HandoverSuccess,
        HandoverSuccessIEs,
        _HandoverSuccessIEs_val_Value_0,
        _HandoverSuccessIEs_val_Value_1,
        ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBEarlyStatusTransfer_protocolIEs__item__id,
        ___ENBEarlyStatusTransfer_protocolIEs__item__criticality,
        ___ENBEarlyStatusTransfer_protocolIEs__item__value,
        __ENBEarlyStatusTransfer_protocolIEs__item_,
        _ENBEarlyStatusTransfer_protocolIEs,
        ENBEarlyStatusTransfer,
        ENBEarlyStatusTransferIEs,
        _ENBEarlyStatusTransferIEs_val_Value_0,
        _ENBEarlyStatusTransferIEs_val_Value_1,
        _ENBEarlyStatusTransferIEs_val_Value_2,
        ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEEarlyStatusTransfer_protocolIEs__item__id,
        ___MMEEarlyStatusTransfer_protocolIEs__item__criticality,
        ___MMEEarlyStatusTransfer_protocolIEs__item__value,
        __MMEEarlyStatusTransfer_protocolIEs__item_,
        _MMEEarlyStatusTransfer_protocolIEs,
        MMEEarlyStatusTransfer,
        MMEEarlyStatusTransferIEs,
        _MMEEarlyStatusTransferIEs_val_Value_0,
        _MMEEarlyStatusTransferIEs_val_Value_1,
        _MMEEarlyStatusTransferIEs_val_Value_2,
        ____E_RABSetupRequest_protocolIEs__item__id_tab,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___E_RABSetupRequest_protocolIEs__item__id,
        ___E_RABSetupRequest_protocolIEs__item__criticality,
        ___E_RABSetupRequest_protocolIEs__item__value,
        __E_RABSetupRequest_protocolIEs__item_,
        _E_RABSetupRequest_protocolIEs,
        E_RABSetupRequest,
        E_RABSetupRequestIEs,
        _E_RABSetupRequestIEs_val_Value_0,
        _E_RABSetupRequestIEs_val_Value_1,
        _E_RABSetupRequestIEs_val_Value_2,
        _E_RABSetupRequestIEs_val_Value_3,
        ___E_RABToBeSetupListBearerSUReq__item__id_tab,
        ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListBearerSUReq__item__id,
        __E_RABToBeSetupListBearerSUReq__item__criticality,
        __E_RABToBeSetupListBearerSUReq__item__value,
        _E_RABToBeSetupListBearerSUReq__item_,
        E_RABToBeSetupListBearerSUReq,
        E_RABToBeSetupItemBearerSUReqIEs,
        _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0,
        _E_RABToBeSetupItemBearerSUReq_e_RAB_ID,
        _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters,
        _E_RABToBeSetupItemBearerSUReq_transportLayerAddress,
        _E_RABToBeSetupItemBearerSUReq_gTP_TEID,
        _E_RABToBeSetupItemBearerSUReq_nAS_PDU,
        ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_,
        _E_RABToBeSetupItemBearerSUReq_iE_Extensions,
        E_RABToBeSetupItemBearerSUReq,
        E_RABToBeSetupItemBearerSUReqExtIEs,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_4,
        ____E_RABSetupResponse_protocolIEs__item__id_tab,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        ___E_RABSetupResponse_protocolIEs__item__id,
        ___E_RABSetupResponse_protocolIEs__item__criticality,
        ___E_RABSetupResponse_protocolIEs__item__value,
        __E_RABSetupResponse_protocolIEs__item_,
        _E_RABSetupResponse_protocolIEs,
        E_RABSetupResponse,
        E_RABSetupResponseIEs,
        _E_RABSetupResponseIEs_val_Value_0,
        _E_RABSetupResponseIEs_val_Value_1,
        _E_RABSetupResponseIEs_val_Value_2,
        _E_RABSetupResponseIEs_val_Value_3,
        _E_RABSetupResponseIEs_val_Value_4,
        _E_RABSetupResponseIEs_val_Value_5,
        ___E_RABSetupListBearerSURes__item__id_tab,
        ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0,
        __E_RABSetupListBearerSURes__item__id,
        __E_RABSetupListBearerSURes__item__criticality,
        __E_RABSetupListBearerSURes__item__value,
        _E_RABSetupListBearerSURes__item_,
        E_RABSetupListBearerSURes,
        E_RABSetupItemBearerSUResIEs,
        _E_RABSetupItemBearerSUResIEs_val_Value_0,
        _E_RABSetupItemBearerSURes_e_RAB_ID,
        _E_RABSetupItemBearerSURes_transportLayerAddress,
        _E_RABSetupItemBearerSURes_gTP_TEID,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__id,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue,
        __E_RABSetupItemBearerSURes_iE_Extensions__item_,
        _E_RABSetupItemBearerSURes_iE_Extensions,
        E_RABSetupItemBearerSURes,
        E_RABSetupItemBearerSUResExtIEs,
        ____E_RABModifyRequest_protocolIEs__item__id_tab,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABModifyRequest_protocolIEs__item__id,
        ___E_RABModifyRequest_protocolIEs__item__criticality,
        ___E_RABModifyRequest_protocolIEs__item__value,
        __E_RABModifyRequest_protocolIEs__item_,
        _E_RABModifyRequest_protocolIEs,
        E_RABModifyRequest,
        E_RABModifyRequestIEs,
        _E_RABModifyRequestIEs_val_Value_0,
        _E_RABModifyRequestIEs_val_Value_1,
        _E_RABModifyRequestIEs_val_Value_2,
        _E_RABModifyRequestIEs_val_Value_3,
        _E_RABModifyRequestIEs_val_Value_4,
        ___E_RABToBeModifiedListBearerModReq__item__id_tab,
        ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0,
        __E_RABToBeModifiedListBearerModReq__item__id,
        __E_RABToBeModifiedListBearerModReq__item__criticality,
        __E_RABToBeModifiedListBearerModReq__item__value,
        _E_RABToBeModifiedListBearerModReq__item_,
        E_RABToBeModifiedListBearerModReq,
        E_RABToBeModifiedItemBearerModReqIEs,
        _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0,
        _E_RABToBeModifiedItemBearerModReq_e_RAB_ID,
        _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters,
        _E_RABToBeModifiedItemBearerModReq_nAS_PDU,
        ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab,
        _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue,
        __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_,
        _E_RABToBeModifiedItemBearerModReq_iE_Extensions,
        E_RABToBeModifiedItemBearerModReq,
        E_RABToBeModifyItemBearerModReqExtIEs,
        _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0,
        ____E_RABModifyResponse_protocolIEs__item__id_tab,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_RABModifyResponse_protocolIEs__item__id,
        ___E_RABModifyResponse_protocolIEs__item__criticality,
        ___E_RABModifyResponse_protocolIEs__item__value,
        __E_RABModifyResponse_protocolIEs__item_,
        _E_RABModifyResponse_protocolIEs,
        E_RABModifyResponse,
        E_RABModifyResponseIEs,
        _E_RABModifyResponseIEs_val_Value_0,
        _E_RABModifyResponseIEs_val_Value_1,
        _E_RABModifyResponseIEs_val_Value_2,
        _E_RABModifyResponseIEs_val_Value_3,
        _E_RABModifyResponseIEs_val_Value_4,
        _E_RABModifyResponseIEs_val_Value_5,
        _E_RABModifyResponseIEs_val_Value_6,
        ___E_RABModifyListBearerModRes__item__id_tab,
        ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0,
        __E_RABModifyListBearerModRes__item__id,
        __E_RABModifyListBearerModRes__item__criticality,
        __E_RABModifyListBearerModRes__item__value,
        _E_RABModifyListBearerModRes__item_,
        E_RABModifyListBearerModRes,
        E_RABModifyItemBearerModResIEs,
        _E_RABModifyItemBearerModResIEs_val_Value_0,
        _E_RABModifyItemBearerModRes_e_RAB_ID,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__id,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue,
        __E_RABModifyItemBearerModRes_iE_Extensions__item_,
        _E_RABModifyItemBearerModRes_iE_Extensions,
        E_RABModifyItemBearerModRes,
        E_RABModifyItemBearerModResExtIEs,
        ____E_RABReleaseCommand_protocolIEs__item__id_tab,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABReleaseCommand_protocolIEs__item__id,
        ___E_RABReleaseCommand_protocolIEs__item__criticality,
        ___E_RABReleaseCommand_protocolIEs__item__value,
        __E_RABReleaseCommand_protocolIEs__item_,
        _E_RABReleaseCommand_protocolIEs,
        E_RABReleaseCommand,
        E_RABReleaseCommandIEs,
        _E_RABReleaseCommandIEs_val_Value_0,
        _E_RABReleaseCommandIEs_val_Value_1,
        _E_RABReleaseCommandIEs_val_Value_2,
        _E_RABReleaseCommandIEs_val_Value_3,
        _E_RABReleaseCommandIEs_val_Value_4,
        ____E_RABReleaseResponse_protocolIEs__item__id_tab,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_RABReleaseResponse_protocolIEs__item__id,
        ___E_RABReleaseResponse_protocolIEs__item__criticality,
        ___E_RABReleaseResponse_protocolIEs__item__value,
        __E_RABReleaseResponse_protocolIEs__item_,
        _E_RABReleaseResponse_protocolIEs,
        E_RABReleaseResponse,
        E_RABReleaseResponseIEs,
        _E_RABReleaseResponseIEs_val_Value_0,
        _E_RABReleaseResponseIEs_val_Value_1,
        _E_RABReleaseResponseIEs_val_Value_2,
        _E_RABReleaseResponseIEs_val_Value_3,
        _E_RABReleaseResponseIEs_val_Value_4,
        _E_RABReleaseResponseIEs_val_Value_5,
        _E_RABReleaseResponseIEs_val_Value_6,
        ___E_RABReleaseListBearerRelComp__item__id_tab,
        ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0,
        __E_RABReleaseListBearerRelComp__item__id,
        __E_RABReleaseListBearerRelComp__item__criticality,
        __E_RABReleaseListBearerRelComp__item__value,
        _E_RABReleaseListBearerRelComp__item_,
        E_RABReleaseListBearerRelComp,
        E_RABReleaseItemBearerRelCompIEs,
        _E_RABReleaseItemBearerRelCompIEs_val_Value_0,
        _E_RABReleaseItemBearerRelComp_e_RAB_ID,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue,
        __E_RABReleaseItemBearerRelComp_iE_Extensions__item_,
        _E_RABReleaseItemBearerRelComp_iE_Extensions,
        E_RABReleaseItemBearerRelComp,
        E_RABReleaseItemBearerRelCompExtIEs,
        ____E_RABReleaseIndication_protocolIEs__item__id_tab,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABReleaseIndication_protocolIEs__item__id,
        ___E_RABReleaseIndication_protocolIEs__item__criticality,
        ___E_RABReleaseIndication_protocolIEs__item__value,
        __E_RABReleaseIndication_protocolIEs__item_,
        _E_RABReleaseIndication_protocolIEs,
        E_RABReleaseIndication,
        E_RABReleaseIndicationIEs,
        _E_RABReleaseIndicationIEs_val_Value_0,
        _E_RABReleaseIndicationIEs_val_Value_1,
        _E_RABReleaseIndicationIEs_val_Value_2,
        _E_RABReleaseIndicationIEs_val_Value_3,
        _E_RABReleaseIndicationIEs_val_Value_4,
        ____InitialContextSetupRequest_protocolIEs__item__id_tab,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        ___InitialContextSetupRequest_protocolIEs__item__id,
        ___InitialContextSetupRequest_protocolIEs__item__criticality,
        ___InitialContextSetupRequest_protocolIEs__item__value,
        __InitialContextSetupRequest_protocolIEs__item_,
        _InitialContextSetupRequest_protocolIEs,
        InitialContextSetupRequest,
        InitialContextSetupRequestIEs,
        _InitialContextSetupRequestIEs_val_Value_0,
        _InitialContextSetupRequestIEs_val_Value_1,
        _InitialContextSetupRequestIEs_val_Value_2,
        _InitialContextSetupRequestIEs_val_Value_3,
        _InitialContextSetupRequestIEs_val_Value_4,
        _InitialContextSetupRequestIEs_val_Value_5,
        _InitialContextSetupRequestIEs_val_Value_6,
        _InitialContextSetupRequestIEs_val_Value_7,
        _InitialContextSetupRequestIEs_val_Value_8,
        _InitialContextSetupRequestIEs_val_Value_9,
        _InitialContextSetupRequestIEs_val_Value_10,
        _InitialContextSetupRequestIEs_val_Value_11,
        _InitialContextSetupRequestIEs_val_Value_12,
        _InitialContextSetupRequestIEs_val_Value_13,
        _InitialContextSetupRequestIEs_val_Value_14,
        _InitialContextSetupRequestIEs_val_Value_15,
        _InitialContextSetupRequestIEs_val_Value_16,
        _InitialContextSetupRequestIEs_val_Value_17,
        _InitialContextSetupRequestIEs_val_Value_18,
        _InitialContextSetupRequestIEs_val_Value_19,
        _InitialContextSetupRequestIEs_val_Value_20,
        _InitialContextSetupRequestIEs_val_Value_21,
        _InitialContextSetupRequestIEs_val_Value_22,
        _InitialContextSetupRequestIEs_val_Value_23,
        _InitialContextSetupRequestIEs_val_Value_24,
        _InitialContextSetupRequestIEs_val_Value_25,
        _InitialContextSetupRequestIEs_val_Value_26,
        _InitialContextSetupRequestIEs_val_Value_27,
        _InitialContextSetupRequestIEs_val_Value_28,
        _InitialContextSetupRequestIEs_val_Value_29,
        _InitialContextSetupRequestIEs_val_Value_30,
        _InitialContextSetupRequestIEs_val_Value_31,
        _InitialContextSetupRequestIEs_val_Value_32,
        _InitialContextSetupRequestIEs_val_Value_33,
        _InitialContextSetupRequestIEs_val_Value_34,
        _InitialContextSetupRequestIEs_val_Value_35,
        _InitialContextSetupRequestIEs_val_Value_36,
        ___E_RABToBeSetupListCtxtSUReq__item__id_tab,
        ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListCtxtSUReq__item__id,
        __E_RABToBeSetupListCtxtSUReq__item__criticality,
        __E_RABToBeSetupListCtxtSUReq__item__value,
        _E_RABToBeSetupListCtxtSUReq__item_,
        E_RABToBeSetupListCtxtSUReq,
        E_RABToBeSetupItemCtxtSUReqIEs,
        _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0,
        _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID,
        _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters,
        _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress,
        _E_RABToBeSetupItemCtxtSUReq_gTP_TEID,
        _E_RABToBeSetupItemCtxtSUReq_nAS_PDU,
        ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_,
        _E_RABToBeSetupItemCtxtSUReq_iE_Extensions,
        E_RABToBeSetupItemCtxtSUReq,
        E_RABToBeSetupItemCtxtSUReqExtIEs,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_4,
        ____InitialContextSetupResponse_protocolIEs__item__id_tab,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupResponse_protocolIEs__item__id,
        ___InitialContextSetupResponse_protocolIEs__item__criticality,
        ___InitialContextSetupResponse_protocolIEs__item__value,
        __InitialContextSetupResponse_protocolIEs__item_,
        _InitialContextSetupResponse_protocolIEs,
        InitialContextSetupResponse,
        InitialContextSetupResponseIEs,
        _InitialContextSetupResponseIEs_val_Value_0,
        _InitialContextSetupResponseIEs_val_Value_1,
        _InitialContextSetupResponseIEs_val_Value_2,
        _InitialContextSetupResponseIEs_val_Value_3,
        _InitialContextSetupResponseIEs_val_Value_4,
        ___E_RABSetupListCtxtSURes__item__id_tab,
        ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0,
        __E_RABSetupListCtxtSURes__item__id,
        __E_RABSetupListCtxtSURes__item__criticality,
        __E_RABSetupListCtxtSURes__item__value,
        _E_RABSetupListCtxtSURes__item_,
        E_RABSetupListCtxtSURes,
        E_RABSetupItemCtxtSUResIEs,
        _E_RABSetupItemCtxtSUResIEs_val_Value_0,
        _E_RABSetupItemCtxtSURes_e_RAB_ID,
        _E_RABSetupItemCtxtSURes_transportLayerAddress,
        _E_RABSetupItemCtxtSURes_gTP_TEID,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue,
        __E_RABSetupItemCtxtSURes_iE_Extensions__item_,
        _E_RABSetupItemCtxtSURes_iE_Extensions,
        E_RABSetupItemCtxtSURes,
        E_RABSetupItemCtxtSUResExtIEs,
        ____InitialContextSetupFailure_protocolIEs__item__id_tab,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___InitialContextSetupFailure_protocolIEs__item__id,
        ___InitialContextSetupFailure_protocolIEs__item__criticality,
        ___InitialContextSetupFailure_protocolIEs__item__value,
        __InitialContextSetupFailure_protocolIEs__item_,
        _InitialContextSetupFailure_protocolIEs,
        InitialContextSetupFailure,
        InitialContextSetupFailureIEs,
        _InitialContextSetupFailureIEs_val_Value_0,
        _InitialContextSetupFailureIEs_val_Value_1,
        _InitialContextSetupFailureIEs_val_Value_2,
        _InitialContextSetupFailureIEs_val_Value_3,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        _____Paging_protocolIEs__item__id_tab_val_Value_7,
        _____Paging_protocolIEs__item__id_tab_val_Value_8,
        _____Paging_protocolIEs__item__id_tab_val_Value_9,
        _____Paging_protocolIEs__item__id_tab_val_Value_10,
        _____Paging_protocolIEs__item__id_tab_val_Value_11,
        _____Paging_protocolIEs__item__id_tab_val_Value_12,
        _____Paging_protocolIEs__item__id_tab_val_Value_13,
        _____Paging_protocolIEs__item__id_tab_val_Value_14,
        _____Paging_protocolIEs__item__id_tab_val_Value_15,
        _____Paging_protocolIEs__item__id_tab_val_Value_16,
        _____Paging_protocolIEs__item__id_tab_val_Value_17,
        _____Paging_protocolIEs__item__id_tab_val_Value_18,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        _PagingIEs_val_Value_7,
        _PagingIEs_val_Value_8,
        _PagingIEs_val_Value_9,
        _PagingIEs_val_Value_10,
        _PagingIEs_val_Value_11,
        _PagingIEs_val_Value_12,
        _PagingIEs_val_Value_13,
        _PagingIEs_val_Value_14,
        _PagingIEs_val_Value_15,
        _PagingIEs_val_Value_16,
        _PagingIEs_val_Value_17,
        _PagingIEs_val_Value_18,
        ___TAIList__item__id_tab,
        ____TAIList__item__id_tab_val_Value_0,
        __TAIList__item__id,
        __TAIList__item__criticality,
        __TAIList__item__value,
        _TAIList__item_,
        TAIList,
        TAIItemIEs,
        _TAIItemIEs_val_Value_0,
        _TAIItem_tAI,
        ____TAIItem_iE_Extensions__item__id_tab,
        ___TAIItem_iE_Extensions__item__id,
        ____TAIItem_iE_Extensions__item__criticality_tab,
        ___TAIItem_iE_Extensions__item__criticality,
        ____TAIItem_iE_Extensions__item__extensionValue_tab,
        ___TAIItem_iE_Extensions__item__extensionValue,
        __TAIItem_iE_Extensions__item_,
        _TAIItem_iE_Extensions,
        TAIItem,
        TAIItemExtIEs,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequest_IEs,
        _UEContextReleaseRequest_IEs_val_Value_0,
        _UEContextReleaseRequest_IEs_val_Value_1,
        _UEContextReleaseRequest_IEs_val_Value_2,
        _UEContextReleaseRequest_IEs_val_Value_3,
        _UEContextReleaseRequest_IEs_val_Value_4,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommand_IEs,
        _UEContextReleaseCommand_IEs_val_Value_0,
        _UEContextReleaseCommand_IEs_val_Value_1,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseComplete_IEs,
        _UEContextReleaseComplete_IEs_val_Value_0,
        _UEContextReleaseComplete_IEs_val_Value_1,
        _UEContextReleaseComplete_IEs_val_Value_2,
        _UEContextReleaseComplete_IEs_val_Value_3,
        _UEContextReleaseComplete_IEs_val_Value_4,
        _UEContextReleaseComplete_IEs_val_Value_5,
        _UEContextReleaseComplete_IEs_val_Value_6,
        _UEContextReleaseComplete_IEs_val_Value_7,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        _UEContextModificationRequestIEs_val_Value_22,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__id,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__value,
        __UERadioCapabilityMatchRequest_protocolIEs__item_,
        _UERadioCapabilityMatchRequest_protocolIEs,
        UERadioCapabilityMatchRequest,
        UERadioCapabilityMatchRequestIEs,
        _UERadioCapabilityMatchRequestIEs_val_Value_0,
        _UERadioCapabilityMatchRequestIEs_val_Value_1,
        _UERadioCapabilityMatchRequestIEs_val_Value_2,
        _UERadioCapabilityMatchRequestIEs_val_Value_3,
        ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__id,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__value,
        __UERadioCapabilityMatchResponse_protocolIEs__item_,
        _UERadioCapabilityMatchResponse_protocolIEs,
        UERadioCapabilityMatchResponse,
        UERadioCapabilityMatchResponseIEs,
        _UERadioCapabilityMatchResponseIEs_val_Value_0,
        _UERadioCapabilityMatchResponseIEs_val_Value_1,
        _UERadioCapabilityMatchResponseIEs_val_Value_2,
        _UERadioCapabilityMatchResponseIEs_val_Value_3,
        ____DownlinkNASTransport_protocolIEs__item__id_tab,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17,
        ___DownlinkNASTransport_protocolIEs__item__id,
        ___DownlinkNASTransport_protocolIEs__item__criticality,
        ___DownlinkNASTransport_protocolIEs__item__value,
        __DownlinkNASTransport_protocolIEs__item_,
        _DownlinkNASTransport_protocolIEs,
        DownlinkNASTransport,
        DownlinkNASTransport_IEs,
        _DownlinkNASTransport_IEs_val_Value_0,
        _DownlinkNASTransport_IEs_val_Value_1,
        _DownlinkNASTransport_IEs_val_Value_2,
        _DownlinkNASTransport_IEs_val_Value_3,
        _DownlinkNASTransport_IEs_val_Value_4,
        _DownlinkNASTransport_IEs_val_Value_5,
        _DownlinkNASTransport_IEs_val_Value_6,
        _DownlinkNASTransport_IEs_val_Value_7,
        _DownlinkNASTransport_IEs_val_Value_8,
        _DownlinkNASTransport_IEs_val_Value_9,
        _DownlinkNASTransport_IEs_val_Value_10,
        _DownlinkNASTransport_IEs_val_Value_11,
        _DownlinkNASTransport_IEs_val_Value_12,
        _DownlinkNASTransport_IEs_val_Value_13,
        _DownlinkNASTransport_IEs_val_Value_14,
        _DownlinkNASTransport_IEs_val_Value_15,
        _DownlinkNASTransport_IEs_val_Value_16,
        _DownlinkNASTransport_IEs_val_Value_17,
        ____InitialUEMessage_protocolIEs__item__id_tab,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_23,
        ___InitialUEMessage_protocolIEs__item__id,
        ___InitialUEMessage_protocolIEs__item__criticality,
        ___InitialUEMessage_protocolIEs__item__value,
        __InitialUEMessage_protocolIEs__item_,
        _InitialUEMessage_protocolIEs,
        InitialUEMessage,
        InitialUEMessage_IEs,
        _InitialUEMessage_IEs_val_Value_0,
        _InitialUEMessage_IEs_val_Value_1,
        _InitialUEMessage_IEs_val_Value_2,
        _InitialUEMessage_IEs_val_Value_3,
        _InitialUEMessage_IEs_val_Value_4,
        _InitialUEMessage_IEs_val_Value_5,
        _InitialUEMessage_IEs_val_Value_6,
        _InitialUEMessage_IEs_val_Value_7,
        _InitialUEMessage_IEs_val_Value_8,
        _InitialUEMessage_IEs_val_Value_9,
        _InitialUEMessage_IEs_val_Value_10,
        _InitialUEMessage_IEs_val_Value_11,
        _InitialUEMessage_IEs_val_Value_12,
        _InitialUEMessage_IEs_val_Value_13,
        _InitialUEMessage_IEs_val_Value_14,
        _InitialUEMessage_IEs_val_Value_15,
        _InitialUEMessage_IEs_val_Value_16,
        _InitialUEMessage_IEs_val_Value_17,
        _InitialUEMessage_IEs_val_Value_18,
        _InitialUEMessage_IEs_val_Value_19,
        _InitialUEMessage_IEs_val_Value_20,
        _InitialUEMessage_IEs_val_Value_21,
        _InitialUEMessage_IEs_val_Value_22,
        _InitialUEMessage_IEs_val_Value_23,
        ____UplinkNASTransport_protocolIEs__item__id_tab,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_9,
        ___UplinkNASTransport_protocolIEs__item__id,
        ___UplinkNASTransport_protocolIEs__item__criticality,
        ___UplinkNASTransport_protocolIEs__item__value,
        __UplinkNASTransport_protocolIEs__item_,
        _UplinkNASTransport_protocolIEs,
        UplinkNASTransport,
        UplinkNASTransport_IEs,
        _UplinkNASTransport_IEs_val_Value_0,
        _UplinkNASTransport_IEs_val_Value_1,
        _UplinkNASTransport_IEs_val_Value_2,
        _UplinkNASTransport_IEs_val_Value_3,
        _UplinkNASTransport_IEs_val_Value_4,
        _UplinkNASTransport_IEs_val_Value_5,
        _UplinkNASTransport_IEs_val_Value_6,
        _UplinkNASTransport_IEs_val_Value_7,
        _UplinkNASTransport_IEs_val_Value_8,
        _UplinkNASTransport_IEs_val_Value_9,
        ____NASNonDeliveryIndication_protocolIEs__item__id_tab,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3,
        ___NASNonDeliveryIndication_protocolIEs__item__id,
        ___NASNonDeliveryIndication_protocolIEs__item__criticality,
        ___NASNonDeliveryIndication_protocolIEs__item__value,
        __NASNonDeliveryIndication_protocolIEs__item_,
        _NASNonDeliveryIndication_protocolIEs,
        NASNonDeliveryIndication,
        NASNonDeliveryIndication_IEs,
        _NASNonDeliveryIndication_IEs_val_Value_0,
        _NASNonDeliveryIndication_IEs_val_Value_1,
        _NASNonDeliveryIndication_IEs_val_Value_2,
        _NASNonDeliveryIndication_IEs_val_Value_3,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        RerouteNASRequest,
        RerouteNASRequest_IEs,
        _RerouteNASRequest_IEs_val_Value_0,
        _RerouteNASRequest_IEs_val_Value_1,
        _RerouteNASRequest_IEs_val_Value_2,
        _RerouteNASRequest_IEs_val_Value_3,
        _RerouteNASRequest_IEs_val_Value_4,
        _RerouteNASRequest_IEs_val_Value_5,
        ____NASDeliveryIndication_protocolIEs__item__id_tab,
        _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        ___NASDeliveryIndication_protocolIEs__item__id,
        ___NASDeliveryIndication_protocolIEs__item__criticality,
        ___NASDeliveryIndication_protocolIEs__item__value,
        __NASDeliveryIndication_protocolIEs__item_,
        _NASDeliveryIndication_protocolIEs,
        NASDeliveryIndication,
        NASDeliveryIndicationIEs,
        _NASDeliveryIndicationIEs_val_Value_0,
        _NASDeliveryIndicationIEs_val_Value_1,
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetType_s1_Interface,
        _ResetType_partOfS1_Interface,
        ResetType,
        ResetAll,
        ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab,
        ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0,
        __UE_associatedLogicalS1_ConnectionListRes__item__id,
        __UE_associatedLogicalS1_ConnectionListRes__item__criticality,
        __UE_associatedLogicalS1_ConnectionListRes__item__value,
        _UE_associatedLogicalS1_ConnectionListRes__item_,
        UE_associatedLogicalS1_ConnectionListRes,
        UE_associatedLogicalS1_ConnectionItemRes,
        _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab,
        ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0,
        __UE_associatedLogicalS1_ConnectionListResAck__item__id,
        __UE_associatedLogicalS1_ConnectionListResAck__item__criticality,
        __UE_associatedLogicalS1_ConnectionListResAck__item__value,
        _UE_associatedLogicalS1_ConnectionListResAck__item_,
        UE_associatedLogicalS1_ConnectionListResAck,
        UE_associatedLogicalS1_ConnectionItemResAck,
        _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____S1SetupRequest_protocolIEs__item__id_tab,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7,
        ___S1SetupRequest_protocolIEs__item__id,
        ___S1SetupRequest_protocolIEs__item__criticality,
        ___S1SetupRequest_protocolIEs__item__value,
        __S1SetupRequest_protocolIEs__item_,
        _S1SetupRequest_protocolIEs,
        S1SetupRequest,
        S1SetupRequestIEs,
        _S1SetupRequestIEs_val_Value_0,
        _S1SetupRequestIEs_val_Value_1,
        _S1SetupRequestIEs_val_Value_2,
        _S1SetupRequestIEs_val_Value_3,
        _S1SetupRequestIEs_val_Value_4,
        _S1SetupRequestIEs_val_Value_5,
        _S1SetupRequestIEs_val_Value_6,
        _S1SetupRequestIEs_val_Value_7,
        ____S1SetupResponse_protocolIEs__item__id_tab,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___S1SetupResponse_protocolIEs__item__id,
        ___S1SetupResponse_protocolIEs__item__criticality,
        ___S1SetupResponse_protocolIEs__item__value,
        __S1SetupResponse_protocolIEs__item_,
        _S1SetupResponse_protocolIEs,
        S1SetupResponse,
        S1SetupResponseIEs,
        _S1SetupResponseIEs_val_Value_0,
        _S1SetupResponseIEs_val_Value_1,
        _S1SetupResponseIEs_val_Value_2,
        _S1SetupResponseIEs_val_Value_3,
        _S1SetupResponseIEs_val_Value_4,
        _S1SetupResponseIEs_val_Value_5,
        _S1SetupResponseIEs_val_Value_6,
        _S1SetupResponseIEs_val_Value_7,
        ____S1SetupFailure_protocolIEs__item__id_tab,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___S1SetupFailure_protocolIEs__item__id,
        ___S1SetupFailure_protocolIEs__item__criticality,
        ___S1SetupFailure_protocolIEs__item__value,
        __S1SetupFailure_protocolIEs__item_,
        _S1SetupFailure_protocolIEs,
        S1SetupFailure,
        S1SetupFailureIEs,
        _S1SetupFailureIEs_val_Value_0,
        _S1SetupFailureIEs_val_Value_1,
        _S1SetupFailureIEs_val_Value_2,
        ____ENBConfigurationUpdate_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___ENBConfigurationUpdate_protocolIEs__item__id,
        ___ENBConfigurationUpdate_protocolIEs__item__criticality,
        ___ENBConfigurationUpdate_protocolIEs__item__value,
        __ENBConfigurationUpdate_protocolIEs__item_,
        _ENBConfigurationUpdate_protocolIEs,
        ENBConfigurationUpdate,
        ENBConfigurationUpdateIEs,
        _ENBConfigurationUpdateIEs_val_Value_0,
        _ENBConfigurationUpdateIEs_val_Value_1,
        _ENBConfigurationUpdateIEs_val_Value_2,
        _ENBConfigurationUpdateIEs_val_Value_3,
        _ENBConfigurationUpdateIEs_val_Value_4,
        _ENBConfigurationUpdateIEs_val_Value_5,
        _ENBConfigurationUpdateIEs_val_Value_6,
        ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __ENBConfigurationUpdateAcknowledge_protocolIEs__item_,
        _ENBConfigurationUpdateAcknowledge_protocolIEs,
        ENBConfigurationUpdateAcknowledge,
        ENBConfigurationUpdateAcknowledgeIEs,
        _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__id,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__value,
        __ENBConfigurationUpdateFailure_protocolIEs__item_,
        _ENBConfigurationUpdateFailure_protocolIEs,
        ENBConfigurationUpdateFailure,
        ENBConfigurationUpdateFailureIEs,
        _ENBConfigurationUpdateFailureIEs_val_Value_0,
        _ENBConfigurationUpdateFailureIEs_val_Value_1,
        _ENBConfigurationUpdateFailureIEs_val_Value_2,
        ____MMEConfigurationUpdate_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___MMEConfigurationUpdate_protocolIEs__item__id,
        ___MMEConfigurationUpdate_protocolIEs__item__criticality,
        ___MMEConfigurationUpdate_protocolIEs__item__value,
        __MMEConfigurationUpdate_protocolIEs__item_,
        _MMEConfigurationUpdate_protocolIEs,
        MMEConfigurationUpdate,
        MMEConfigurationUpdateIEs,
        _MMEConfigurationUpdateIEs_val_Value_0,
        _MMEConfigurationUpdateIEs_val_Value_1,
        _MMEConfigurationUpdateIEs_val_Value_2,
        _MMEConfigurationUpdateIEs_val_Value_3,
        ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __MMEConfigurationUpdateAcknowledge_protocolIEs__item_,
        _MMEConfigurationUpdateAcknowledge_protocolIEs,
        MMEConfigurationUpdateAcknowledge,
        MMEConfigurationUpdateAcknowledgeIEs,
        _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__id,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__value,
        __MMEConfigurationUpdateFailure_protocolIEs__item_,
        _MMEConfigurationUpdateFailure_protocolIEs,
        MMEConfigurationUpdateFailure,
        MMEConfigurationUpdateFailureIEs,
        _MMEConfigurationUpdateFailureIEs_val_Value_0,
        _MMEConfigurationUpdateFailureIEs_val_Value_1,
        _MMEConfigurationUpdateFailureIEs_val_Value_2,
        ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value,
        __DownlinkS1cdma2000tunnelling_protocolIEs__item_,
        _DownlinkS1cdma2000tunnelling_protocolIEs,
        DownlinkS1cdma2000tunnelling,
        DownlinkS1cdma2000tunnellingIEs,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_0,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_1,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_2,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_3,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_4,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_5,
        ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__id,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__value,
        __UplinkS1cdma2000tunnelling_protocolIEs__item_,
        _UplinkS1cdma2000tunnelling_protocolIEs,
        UplinkS1cdma2000tunnelling,
        UplinkS1cdma2000tunnellingIEs,
        _UplinkS1cdma2000tunnellingIEs_val_Value_0,
        _UplinkS1cdma2000tunnellingIEs_val_Value_1,
        _UplinkS1cdma2000tunnellingIEs_val_Value_2,
        _UplinkS1cdma2000tunnellingIEs_val_Value_3,
        _UplinkS1cdma2000tunnellingIEs_val_Value_4,
        _UplinkS1cdma2000tunnellingIEs_val_Value_5,
        _UplinkS1cdma2000tunnellingIEs_val_Value_6,
        _UplinkS1cdma2000tunnellingIEs_val_Value_7,
        _UplinkS1cdma2000tunnellingIEs_val_Value_8,
        ____UECapabilityInfoIndication_protocolIEs__item__id_tab,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7,
        ___UECapabilityInfoIndication_protocolIEs__item__id,
        ___UECapabilityInfoIndication_protocolIEs__item__criticality,
        ___UECapabilityInfoIndication_protocolIEs__item__value,
        __UECapabilityInfoIndication_protocolIEs__item_,
        _UECapabilityInfoIndication_protocolIEs,
        UECapabilityInfoIndication,
        UECapabilityInfoIndicationIEs,
        _UECapabilityInfoIndicationIEs_val_Value_0,
        _UECapabilityInfoIndicationIEs_val_Value_1,
        _UECapabilityInfoIndicationIEs_val_Value_2,
        _UECapabilityInfoIndicationIEs_val_Value_3,
        _UECapabilityInfoIndicationIEs_val_Value_4,
        _UECapabilityInfoIndicationIEs_val_Value_5,
        _UECapabilityInfoIndicationIEs_val_Value_6,
        _UECapabilityInfoIndicationIEs_val_Value_7,
        ____ENBStatusTransfer_protocolIEs__item__id_tab,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBStatusTransfer_protocolIEs__item__id,
        ___ENBStatusTransfer_protocolIEs__item__criticality,
        ___ENBStatusTransfer_protocolIEs__item__value,
        __ENBStatusTransfer_protocolIEs__item_,
        _ENBStatusTransfer_protocolIEs,
        ENBStatusTransfer,
        ENBStatusTransferIEs,
        _ENBStatusTransferIEs_val_Value_0,
        _ENBStatusTransferIEs_val_Value_1,
        _ENBStatusTransferIEs_val_Value_2,
        ____MMEStatusTransfer_protocolIEs__item__id_tab,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEStatusTransfer_protocolIEs__item__id,
        ___MMEStatusTransfer_protocolIEs__item__criticality,
        ___MMEStatusTransfer_protocolIEs__item__value,
        __MMEStatusTransfer_protocolIEs__item_,
        _MMEStatusTransfer_protocolIEs,
        MMEStatusTransfer,
        MMEStatusTransferIEs,
        _MMEStatusTransferIEs_val_Value_0,
        _MMEStatusTransferIEs_val_Value_1,
        _MMEStatusTransferIEs_val_Value_2,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____TraceFailureIndication_protocolIEs__item__id_tab,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___TraceFailureIndication_protocolIEs__item__id,
        ___TraceFailureIndication_protocolIEs__item__criticality,
        ___TraceFailureIndication_protocolIEs__item__value,
        __TraceFailureIndication_protocolIEs__item_,
        _TraceFailureIndication_protocolIEs,
        TraceFailureIndication,
        TraceFailureIndicationIEs,
        _TraceFailureIndicationIEs_val_Value_0,
        _TraceFailureIndicationIEs_val_Value_1,
        _TraceFailureIndicationIEs_val_Value_2,
        _TraceFailureIndicationIEs_val_Value_3,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        _LocationReportingControlIEs_val_Value_1,
        _LocationReportingControlIEs_val_Value_2,
        ____LocationReportingFailureIndication_protocolIEs__item__id_tab,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingFailureIndication_protocolIEs__item__id,
        ___LocationReportingFailureIndication_protocolIEs__item__criticality,
        ___LocationReportingFailureIndication_protocolIEs__item__value,
        __LocationReportingFailureIndication_protocolIEs__item_,
        _LocationReportingFailureIndication_protocolIEs,
        LocationReportingFailureIndication,
        LocationReportingFailureIndicationIEs,
        _LocationReportingFailureIndicationIEs_val_Value_0,
        _LocationReportingFailureIndicationIEs_val_Value_1,
        _LocationReportingFailureIndicationIEs_val_Value_2,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_3,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_4,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_5,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_6,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        _LocationReportIEs_val_Value_3,
        _LocationReportIEs_val_Value_4,
        _LocationReportIEs_val_Value_5,
        _LocationReportIEs_val_Value_6,
        ____OverloadStart_protocolIEs__item__id_tab,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_0,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_1,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_2,
        ___OverloadStart_protocolIEs__item__id,
        ___OverloadStart_protocolIEs__item__criticality,
        ___OverloadStart_protocolIEs__item__value,
        __OverloadStart_protocolIEs__item_,
        _OverloadStart_protocolIEs,
        OverloadStart,
        OverloadStartIEs,
        _OverloadStartIEs_val_Value_0,
        _OverloadStartIEs_val_Value_1,
        _OverloadStartIEs_val_Value_2,
        ____OverloadStop_protocolIEs__item__id_tab,
        _____OverloadStop_protocolIEs__item__id_tab_val_Value_0,
        ___OverloadStop_protocolIEs__item__id,
        ___OverloadStop_protocolIEs__item__criticality,
        ___OverloadStop_protocolIEs__item__value,
        __OverloadStop_protocolIEs__item_,
        _OverloadStop_protocolIEs,
        OverloadStop,
        OverloadStopIEs,
        _OverloadStopIEs_val_Value_0,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        _WriteReplaceWarningRequestIEs_val_Value_5,
        _WriteReplaceWarningRequestIEs_val_Value_6,
        _WriteReplaceWarningRequestIEs_val_Value_7,
        _WriteReplaceWarningRequestIEs_val_Value_8,
        _WriteReplaceWarningRequestIEs_val_Value_9,
        _WriteReplaceWarningRequestIEs_val_Value_10,
        _WriteReplaceWarningRequestIEs_val_Value_11,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ____ENBDirectInformationTransfer_protocolIEs__item__id_tab,
        _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___ENBDirectInformationTransfer_protocolIEs__item__id,
        ___ENBDirectInformationTransfer_protocolIEs__item__criticality,
        ___ENBDirectInformationTransfer_protocolIEs__item__value,
        __ENBDirectInformationTransfer_protocolIEs__item_,
        _ENBDirectInformationTransfer_protocolIEs,
        ENBDirectInformationTransfer,
        ENBDirectInformationTransferIEs,
        _ENBDirectInformationTransferIEs_val_Value_0,
        _Inter_SystemInformationTransferType_rIMTransfer,
        Inter_SystemInformationTransferType,
        ____MMEDirectInformationTransfer_protocolIEs__item__id_tab,
        _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___MMEDirectInformationTransfer_protocolIEs__item__id,
        ___MMEDirectInformationTransfer_protocolIEs__item__criticality,
        ___MMEDirectInformationTransfer_protocolIEs__item__value,
        __MMEDirectInformationTransfer_protocolIEs__item_,
        _MMEDirectInformationTransfer_protocolIEs,
        MMEDirectInformationTransfer,
        MMEDirectInformationTransferIEs,
        _MMEDirectInformationTransferIEs_val_Value_0,
        ____ENBConfigurationTransfer_protocolIEs__item__id_tab,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationTransfer_protocolIEs__item__id,
        ___ENBConfigurationTransfer_protocolIEs__item__criticality,
        ___ENBConfigurationTransfer_protocolIEs__item__value,
        __ENBConfigurationTransfer_protocolIEs__item_,
        _ENBConfigurationTransfer_protocolIEs,
        ENBConfigurationTransfer,
        ENBConfigurationTransferIEs,
        _ENBConfigurationTransferIEs_val_Value_0,
        _ENBConfigurationTransferIEs_val_Value_1,
        _ENBConfigurationTransferIEs_val_Value_2,
        ____MMEConfigurationTransfer_protocolIEs__item__id_tab,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEConfigurationTransfer_protocolIEs__item__id,
        ___MMEConfigurationTransfer_protocolIEs__item__criticality,
        ___MMEConfigurationTransfer_protocolIEs__item__value,
        __MMEConfigurationTransfer_protocolIEs__item_,
        _MMEConfigurationTransfer_protocolIEs,
        MMEConfigurationTransfer,
        MMEConfigurationTransferIEs,
        _MMEConfigurationTransferIEs_val_Value_0,
        _MMEConfigurationTransferIEs_val_Value_1,
        _MMEConfigurationTransferIEs_val_Value_2,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessageIEs,
        ____KillRequest_protocolIEs__item__id_tab,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_0,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_1,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_2,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_3,
        ___KillRequest_protocolIEs__item__id,
        ___KillRequest_protocolIEs__item__criticality,
        ___KillRequest_protocolIEs__item__value,
        __KillRequest_protocolIEs__item_,
        _KillRequest_protocolIEs,
        KillRequest,
        KillRequestIEs,
        _KillRequestIEs_val_Value_0,
        _KillRequestIEs_val_Value_1,
        _KillRequestIEs_val_Value_2,
        _KillRequestIEs_val_Value_3,
        ____KillResponse_protocolIEs__item__id_tab,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_0,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_1,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_2,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_3,
        ___KillResponse_protocolIEs__item__id,
        ___KillResponse_protocolIEs__item__criticality,
        ___KillResponse_protocolIEs__item__value,
        __KillResponse_protocolIEs__item_,
        _KillResponse_protocolIEs,
        KillResponse,
        KillResponseIEs,
        _KillResponseIEs_val_Value_0,
        _KillResponseIEs_val_Value_1,
        _KillResponseIEs_val_Value_2,
        _KillResponseIEs_val_Value_3,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        _PWSRestartIndicationIEs_val_Value_2,
        _PWSRestartIndicationIEs_val_Value_3,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value,
        __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_,
        _DownlinkUEAssociatedLPPaTransport_protocolIEs,
        DownlinkUEAssociatedLPPaTransport,
        DownlinkUEAssociatedLPPaTransport_IEs,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3,
        ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value,
        __UplinkUEAssociatedLPPaTransport_protocolIEs__item_,
        _UplinkUEAssociatedLPPaTransport_protocolIEs,
        UplinkUEAssociatedLPPaTransport,
        UplinkUEAssociatedLPPaTransport_IEs,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3,
        ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value,
        __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_,
        _DownlinkNonUEAssociatedLPPaTransport_protocolIEs,
        DownlinkNonUEAssociatedLPPaTransport,
        DownlinkNonUEAssociatedLPPaTransport_IEs,
        _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0,
        _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1,
        ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value,
        __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_,
        _UplinkNonUEAssociatedLPPaTransport_protocolIEs,
        UplinkNonUEAssociatedLPPaTransport,
        UplinkNonUEAssociatedLPPaTransport_IEs,
        _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0,
        _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1,
        ____E_RABModificationIndication_protocolIEs__item__id_tab,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7,
        ___E_RABModificationIndication_protocolIEs__item__id,
        ___E_RABModificationIndication_protocolIEs__item__criticality,
        ___E_RABModificationIndication_protocolIEs__item__value,
        __E_RABModificationIndication_protocolIEs__item_,
        _E_RABModificationIndication_protocolIEs,
        E_RABModificationIndication,
        E_RABModificationIndicationIEs,
        _E_RABModificationIndicationIEs_val_Value_0,
        _E_RABModificationIndicationIEs_val_Value_1,
        _E_RABModificationIndicationIEs_val_Value_2,
        _E_RABModificationIndicationIEs_val_Value_3,
        _E_RABModificationIndicationIEs_val_Value_4,
        _E_RABModificationIndicationIEs_val_Value_5,
        _E_RABModificationIndicationIEs_val_Value_6,
        _E_RABModificationIndicationIEs_val_Value_7,
        ___E_RABToBeModifiedListBearerModInd__item__id_tab,
        ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0,
        __E_RABToBeModifiedListBearerModInd__item__id,
        __E_RABToBeModifiedListBearerModInd__item__criticality,
        __E_RABToBeModifiedListBearerModInd__item__value,
        _E_RABToBeModifiedListBearerModInd__item_,
        E_RABToBeModifiedListBearerModInd,
        E_RABToBeModifiedItemBearerModIndIEs,
        _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0,
        _E_RABToBeModifiedItemBearerModInd_e_RAB_ID,
        _E_RABToBeModifiedItemBearerModInd_transportLayerAddress,
        _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue,
        __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_,
        _E_RABToBeModifiedItemBearerModInd_iE_Extensions,
        E_RABToBeModifiedItemBearerModInd,
        E_RABToBeModifiedItemBearerModInd_ExtIEs,
        ___E_RABNotToBeModifiedListBearerModInd__item__id_tab,
        ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0,
        __E_RABNotToBeModifiedListBearerModInd__item__id,
        __E_RABNotToBeModifiedListBearerModInd__item__criticality,
        __E_RABNotToBeModifiedListBearerModInd__item__value,
        _E_RABNotToBeModifiedListBearerModInd__item_,
        E_RABNotToBeModifiedListBearerModInd,
        E_RABNotToBeModifiedItemBearerModIndIEs,
        _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0,
        _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID,
        _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress,
        _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue,
        __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_,
        _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions,
        E_RABNotToBeModifiedItemBearerModInd,
        E_RABNotToBeModifiedItemBearerModInd_ExtIEs,
        _CSGMembershipInfo_cSGMembershipStatus,
        _CSGMembershipInfo_cSG_Id,
        _CSGMembershipInfo_cellAccessMode,
        _CSGMembershipInfo_pLMNidentity,
        ____CSGMembershipInfo_iE_Extensions__item__id_tab,
        ___CSGMembershipInfo_iE_Extensions__item__id,
        ____CSGMembershipInfo_iE_Extensions__item__criticality_tab,
        ___CSGMembershipInfo_iE_Extensions__item__criticality,
        ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab,
        ___CSGMembershipInfo_iE_Extensions__item__extensionValue,
        __CSGMembershipInfo_iE_Extensions__item_,
        _CSGMembershipInfo_iE_Extensions,
        CSGMembershipInfo,
        CSGMembershipInfo_ExtIEs,
        ____E_RABModificationConfirm_protocolIEs__item__id_tab,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6,
        ___E_RABModificationConfirm_protocolIEs__item__id,
        ___E_RABModificationConfirm_protocolIEs__item__criticality,
        ___E_RABModificationConfirm_protocolIEs__item__value,
        __E_RABModificationConfirm_protocolIEs__item_,
        _E_RABModificationConfirm_protocolIEs,
        E_RABModificationConfirm,
        E_RABModificationConfirmIEs,
        _E_RABModificationConfirmIEs_val_Value_0,
        _E_RABModificationConfirmIEs_val_Value_1,
        _E_RABModificationConfirmIEs_val_Value_2,
        _E_RABModificationConfirmIEs_val_Value_3,
        _E_RABModificationConfirmIEs_val_Value_4,
        _E_RABModificationConfirmIEs_val_Value_5,
        _E_RABModificationConfirmIEs_val_Value_6,
        ___E_RABModifyListBearerModConf__item__id_tab,
        ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0,
        __E_RABModifyListBearerModConf__item__id,
        __E_RABModifyListBearerModConf__item__criticality,
        __E_RABModifyListBearerModConf__item__value,
        _E_RABModifyListBearerModConf__item_,
        E_RABModifyListBearerModConf,
        E_RABModifyItemBearerModConfIEs,
        _E_RABModifyItemBearerModConfIEs_val_Value_0,
        _E_RABModifyItemBearerModConf_e_RAB_ID,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__id,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue,
        __E_RABModifyItemBearerModConf_iE_Extensions__item_,
        _E_RABModifyItemBearerModConf_iE_Extensions,
        E_RABModifyItemBearerModConf,
        E_RABModifyItemBearerModConfExtIEs,
        ____UEContextModificationIndication_protocolIEs__item__id_tab,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextModificationIndication_protocolIEs__item__id,
        ___UEContextModificationIndication_protocolIEs__item__criticality,
        ___UEContextModificationIndication_protocolIEs__item__value,
        __UEContextModificationIndication_protocolIEs__item_,
        _UEContextModificationIndication_protocolIEs,
        UEContextModificationIndication,
        UEContextModificationIndicationIEs,
        _UEContextModificationIndicationIEs_val_Value_0,
        _UEContextModificationIndicationIEs_val_Value_1,
        _UEContextModificationIndicationIEs_val_Value_2,
        ____UEContextModificationConfirm_protocolIEs__item__id_tab,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationConfirm_protocolIEs__item__id,
        ___UEContextModificationConfirm_protocolIEs__item__criticality,
        ___UEContextModificationConfirm_protocolIEs__item__value,
        __UEContextModificationConfirm_protocolIEs__item_,
        _UEContextModificationConfirm_protocolIEs,
        UEContextModificationConfirm,
        UEContextModificationConfirmIEs,
        _UEContextModificationConfirmIEs_val_Value_0,
        _UEContextModificationConfirmIEs_val_Value_1,
        _UEContextModificationConfirmIEs_val_Value_2,
        _UEContextModificationConfirmIEs_val_Value_3,
        ____UEContextSuspendRequest_protocolIEs__item__id_tab,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6,
        ___UEContextSuspendRequest_protocolIEs__item__id,
        ___UEContextSuspendRequest_protocolIEs__item__criticality,
        ___UEContextSuspendRequest_protocolIEs__item__value,
        __UEContextSuspendRequest_protocolIEs__item_,
        _UEContextSuspendRequest_protocolIEs,
        UEContextSuspendRequest,
        UEContextSuspendRequestIEs,
        _UEContextSuspendRequestIEs_val_Value_0,
        _UEContextSuspendRequestIEs_val_Value_1,
        _UEContextSuspendRequestIEs_val_Value_2,
        _UEContextSuspendRequestIEs_val_Value_3,
        _UEContextSuspendRequestIEs_val_Value_4,
        _UEContextSuspendRequestIEs_val_Value_5,
        _UEContextSuspendRequestIEs_val_Value_6,
        ____UEContextSuspendResponse_protocolIEs__item__id_tab,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendResponse_protocolIEs__item__id,
        ___UEContextSuspendResponse_protocolIEs__item__criticality,
        ___UEContextSuspendResponse_protocolIEs__item__value,
        __UEContextSuspendResponse_protocolIEs__item_,
        _UEContextSuspendResponse_protocolIEs,
        UEContextSuspendResponse,
        UEContextSuspendResponseIEs,
        _UEContextSuspendResponseIEs_val_Value_0,
        _UEContextSuspendResponseIEs_val_Value_1,
        _UEContextSuspendResponseIEs_val_Value_2,
        _UEContextSuspendResponseIEs_val_Value_3,
        ____UEContextResumeRequest_protocolIEs__item__id_tab,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeRequest_protocolIEs__item__id,
        ___UEContextResumeRequest_protocolIEs__item__criticality,
        ___UEContextResumeRequest_protocolIEs__item__value,
        __UEContextResumeRequest_protocolIEs__item_,
        _UEContextResumeRequest_protocolIEs,
        UEContextResumeRequest,
        UEContextResumeRequestIEs,
        _UEContextResumeRequestIEs_val_Value_0,
        _UEContextResumeRequestIEs_val_Value_1,
        _UEContextResumeRequestIEs_val_Value_2,
        _UEContextResumeRequestIEs_val_Value_3,
        ___E_RABFailedToResumeListResumeReq__item__id_tab,
        ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0,
        __E_RABFailedToResumeListResumeReq__item__id,
        __E_RABFailedToResumeListResumeReq__item__criticality,
        __E_RABFailedToResumeListResumeReq__item__value,
        _E_RABFailedToResumeListResumeReq__item_,
        E_RABFailedToResumeListResumeReq,
        E_RABFailedToResumeItemResumeReqIEs,
        _E_RABFailedToResumeItemResumeReqIEs_val_Value_0,
        _E_RABFailedToResumeItemResumeReq_e_RAB_ID,
        _E_RABFailedToResumeItemResumeReq_cause,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue,
        __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_,
        _E_RABFailedToResumeItemResumeReq_iE_Extensions,
        E_RABFailedToResumeItemResumeReq,
        E_RABFailedToResumeItemResumeReq_ExtIEs,
        ____UEContextResumeResponse_protocolIEs__item__id_tab,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5,
        ___UEContextResumeResponse_protocolIEs__item__id,
        ___UEContextResumeResponse_protocolIEs__item__criticality,
        ___UEContextResumeResponse_protocolIEs__item__value,
        __UEContextResumeResponse_protocolIEs__item_,
        _UEContextResumeResponse_protocolIEs,
        UEContextResumeResponse,
        UEContextResumeResponseIEs,
        _UEContextResumeResponseIEs_val_Value_0,
        _UEContextResumeResponseIEs_val_Value_1,
        _UEContextResumeResponseIEs_val_Value_2,
        _UEContextResumeResponseIEs_val_Value_3,
        _UEContextResumeResponseIEs_val_Value_4,
        _UEContextResumeResponseIEs_val_Value_5,
        ___E_RABFailedToResumeListResumeRes__item__id_tab,
        ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0,
        __E_RABFailedToResumeListResumeRes__item__id,
        __E_RABFailedToResumeListResumeRes__item__criticality,
        __E_RABFailedToResumeListResumeRes__item__value,
        _E_RABFailedToResumeListResumeRes__item_,
        E_RABFailedToResumeListResumeRes,
        E_RABFailedToResumeItemResumeResIEs,
        _E_RABFailedToResumeItemResumeResIEs_val_Value_0,
        _E_RABFailedToResumeItemResumeRes_e_RAB_ID,
        _E_RABFailedToResumeItemResumeRes_cause,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue,
        __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_,
        _E_RABFailedToResumeItemResumeRes_iE_Extensions,
        E_RABFailedToResumeItemResumeRes,
        E_RABFailedToResumeItemResumeRes_ExtIEs,
        ____UEContextResumeFailure_protocolIEs__item__id_tab,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeFailure_protocolIEs__item__id,
        ___UEContextResumeFailure_protocolIEs__item__criticality,
        ___UEContextResumeFailure_protocolIEs__item__value,
        __UEContextResumeFailure_protocolIEs__item_,
        _UEContextResumeFailure_protocolIEs,
        UEContextResumeFailure,
        UEContextResumeFailureIEs,
        _UEContextResumeFailureIEs_val_Value_0,
        _UEContextResumeFailureIEs_val_Value_1,
        _UEContextResumeFailureIEs_val_Value_2,
        _UEContextResumeFailureIEs_val_Value_3,
        ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10,
        ___ConnectionEstablishmentIndication_protocolIEs__item__id,
        ___ConnectionEstablishmentIndication_protocolIEs__item__criticality,
        ___ConnectionEstablishmentIndication_protocolIEs__item__value,
        __ConnectionEstablishmentIndication_protocolIEs__item_,
        _ConnectionEstablishmentIndication_protocolIEs,
        ConnectionEstablishmentIndication,
        ConnectionEstablishmentIndicationIEs,
        _ConnectionEstablishmentIndicationIEs_val_Value_0,
        _ConnectionEstablishmentIndicationIEs_val_Value_1,
        _ConnectionEstablishmentIndicationIEs_val_Value_2,
        _ConnectionEstablishmentIndicationIEs_val_Value_3,
        _ConnectionEstablishmentIndicationIEs_val_Value_4,
        _ConnectionEstablishmentIndicationIEs_val_Value_5,
        _ConnectionEstablishmentIndicationIEs_val_Value_6,
        _ConnectionEstablishmentIndicationIEs_val_Value_7,
        _ConnectionEstablishmentIndicationIEs_val_Value_8,
        _ConnectionEstablishmentIndicationIEs_val_Value_9,
        _ConnectionEstablishmentIndicationIEs_val_Value_10,
        ____RetrieveUEInformation_protocolIEs__item__id_tab,
        _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0,
        ___RetrieveUEInformation_protocolIEs__item__id,
        ___RetrieveUEInformation_protocolIEs__item__criticality,
        ___RetrieveUEInformation_protocolIEs__item__value,
        __RetrieveUEInformation_protocolIEs__item_,
        _RetrieveUEInformation_protocolIEs,
        RetrieveUEInformation,
        RetrieveUEInformationIEs,
        _RetrieveUEInformationIEs_val_Value_0,
        ____UEInformationTransfer_protocolIEs__item__id_tab,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___UEInformationTransfer_protocolIEs__item__id,
        ___UEInformationTransfer_protocolIEs__item__criticality,
        ___UEInformationTransfer_protocolIEs__item__value,
        __UEInformationTransfer_protocolIEs__item_,
        _UEInformationTransfer_protocolIEs,
        UEInformationTransfer,
        UEInformationTransferIEs,
        _UEInformationTransferIEs_val_Value_0,
        _UEInformationTransferIEs_val_Value_1,
        _UEInformationTransferIEs_val_Value_2,
        _UEInformationTransferIEs_val_Value_3,
        _UEInformationTransferIEs_val_Value_4,
        _UEInformationTransferIEs_val_Value_5,
        ____ENBCPRelocationIndication_protocolIEs__item__id_tab,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_5,
        ___ENBCPRelocationIndication_protocolIEs__item__id,
        ___ENBCPRelocationIndication_protocolIEs__item__criticality,
        ___ENBCPRelocationIndication_protocolIEs__item__value,
        __ENBCPRelocationIndication_protocolIEs__item_,
        _ENBCPRelocationIndication_protocolIEs,
        ENBCPRelocationIndication,
        ENBCPRelocationIndicationIEs,
        _ENBCPRelocationIndicationIEs_val_Value_0,
        _ENBCPRelocationIndicationIEs_val_Value_1,
        _ENBCPRelocationIndicationIEs_val_Value_2,
        _ENBCPRelocationIndicationIEs_val_Value_3,
        _ENBCPRelocationIndicationIEs_val_Value_4,
        _ENBCPRelocationIndicationIEs_val_Value_5,
        ____MMECPRelocationIndication_protocolIEs__item__id_tab,
        _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        ___MMECPRelocationIndication_protocolIEs__item__id,
        ___MMECPRelocationIndication_protocolIEs__item__criticality,
        ___MMECPRelocationIndication_protocolIEs__item__value,
        __MMECPRelocationIndication_protocolIEs__item_,
        _MMECPRelocationIndication_protocolIEs,
        MMECPRelocationIndication,
        MMECPRelocationIndicationIEs,
        _MMECPRelocationIndicationIEs_val_Value_0,
        _MMECPRelocationIndicationIEs_val_Value_1,
        ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5,
        ___SecondaryRATDataUsageReport_protocolIEs__item__id,
        ___SecondaryRATDataUsageReport_protocolIEs__item__criticality,
        ___SecondaryRATDataUsageReport_protocolIEs__item__value,
        __SecondaryRATDataUsageReport_protocolIEs__item_,
        _SecondaryRATDataUsageReport_protocolIEs,
        SecondaryRATDataUsageReport,
        SecondaryRATDataUsageReportIEs,
        _SecondaryRATDataUsageReportIEs_val_Value_0,
        _SecondaryRATDataUsageReportIEs_val_Value_1,
        _SecondaryRATDataUsageReportIEs_val_Value_2,
        _SecondaryRATDataUsageReportIEs_val_Value_3,
        _SecondaryRATDataUsageReportIEs_val_Value_4,
        _SecondaryRATDataUsageReportIEs_val_Value_5,
        ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value,
        __UERadioCapabilityIDMappingRequest_protocolIEs__item_,
        _UERadioCapabilityIDMappingRequest_protocolIEs,
        UERadioCapabilityIDMappingRequest,
        UERadioCapabilityIDMappingRequestIEs,
        _UERadioCapabilityIDMappingRequestIEs_val_Value_0,
        ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value,
        __UERadioCapabilityIDMappingResponse_protocolIEs__item_,
        _UERadioCapabilityIDMappingResponse_protocolIEs,
        UERadioCapabilityIDMappingResponse,
        UERadioCapabilityIDMappingResponseIEs,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_0,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_1,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_2,
    ]

class S1AP_PDU_Descriptions:

    _name_  = 'S1AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 0]
    
    _obj_ = [
        'S1AP-ELEMENTARY-PROCEDURE',
        'S1AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'S1AP-ELEMENTARY-PROCEDURES',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverNotification',
        'pathSwitchRequest',
        'e-RABSetup',
        'e-RABModify',
        'e-RABRelease',
        'e-RABReleaseIndication',
        'initialContextSetup',
        'uEContextReleaseRequest',
        'paging',
        'downlinkNASTransport',
        'initialUEMessage',
        'uplinkNASTransport',
        'nASNonDeliveryIndication',
        'handoverCancel',
        'reset',
        'errorIndication',
        's1Setup',
        'eNBConfigurationUpdate',
        'mMEConfigurationUpdate',
        'downlinkS1cdma2000tunnelling',
        'uplinkS1cdma2000tunnelling',
        'uEContextModification',
        'uECapabilityInfoIndication',
        'uEContextRelease',
        'eNBStatusTransfer',
        'mMEStatusTransfer',
        'deactivateTrace',
        'traceStart',
        'traceFailureIndication',
        'cellTrafficTrace',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'locationReport',
        'overloadStart',
        'overloadStop',
        'writeReplaceWarning',
        'eNBDirectInformationTransfer',
        'mMEDirectInformationTransfer',
        'eNBConfigurationTransfer',
        'mMEConfigurationTransfer',
        'privateMessage',
        'pWSRestartIndication',
        'kill',
        'downlinkUEAssociatedLPPaTransport',
        'uplinkUEAssociatedLPPaTransport',
        'downlinkNonUEAssociatedLPPaTransport',
        'uplinkNonUEAssociatedLPPaTransport',
        'uERadioCapabilityMatch',
        'e-RABModificationIndication',
        'uEContextModificationIndication',
        'rerouteNASRequest',
        'pWSFailureIndication',
        'uEContextSuspend',
        'uEContextResume',
        'connectionEstablishmentIndication',
        'nASDeliveryIndication',
        'retrieveUEInformation',
        'uEInformationTransfer',
        'eNBCPRelocationIndication',
        'mMECPRelocationIndication',
        'secondaryRATDataUsageReport',
        'uERadioCapabilityIDMapping',
        'handoverSuccess',
        'eNBEarlyStatusTransfer',
        'mMEEarlyStatusTransfer',
        ]
    _type_ = [
        'S1AP-ELEMENTARY-PROCEDURE',
        'S1AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'S1AP-ELEMENTARY-PROCEDURES',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverNotification',
        'pathSwitchRequest',
        'e-RABSetup',
        'e-RABModify',
        'e-RABRelease',
        'e-RABReleaseIndication',
        'initialContextSetup',
        'uEContextReleaseRequest',
        'paging',
        'downlinkNASTransport',
        'initialUEMessage',
        'uplinkNASTransport',
        'nASNonDeliveryIndication',
        'handoverCancel',
        'reset',
        'errorIndication',
        's1Setup',
        'eNBConfigurationUpdate',
        'mMEConfigurationUpdate',
        'downlinkS1cdma2000tunnelling',
        'uplinkS1cdma2000tunnelling',
        'uEContextModification',
        'uECapabilityInfoIndication',
        'uEContextRelease',
        'eNBStatusTransfer',
        'mMEStatusTransfer',
        'deactivateTrace',
        'traceStart',
        'traceFailureIndication',
        'cellTrafficTrace',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'locationReport',
        'overloadStart',
        'overloadStop',
        'writeReplaceWarning',
        'eNBDirectInformationTransfer',
        'mMEDirectInformationTransfer',
        'eNBConfigurationTransfer',
        'mMEConfigurationTransfer',
        'privateMessage',
        'pWSRestartIndication',
        'kill',
        'downlinkUEAssociatedLPPaTransport',
        'uplinkUEAssociatedLPPaTransport',
        'downlinkNonUEAssociatedLPPaTransport',
        'uplinkNonUEAssociatedLPPaTransport',
        'uERadioCapabilityMatch',
        'e-RABModificationIndication',
        'uEContextModificationIndication',
        'rerouteNASRequest',
        'pWSFailureIndication',
        'uEContextSuspend',
        'uEContextResume',
        'connectionEstablishmentIndication',
        'nASDeliveryIndication',
        'retrieveUEInformation',
        'uEInformationTransfer',
        'eNBCPRelocationIndication',
        'mMECPRelocationIndication',
        'secondaryRATDataUsageReport',
        'uERadioCapabilityIDMapping',
        'handoverSuccess',
        'eNBEarlyStatusTransfer',
        'mMEEarlyStatusTransfer',
        ]
    _class_ = [
        'S1AP-ELEMENTARY-PROCEDURE',
        'S1AP-ELEMENTARY-PROCEDURES',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverNotification',
        'pathSwitchRequest',
        'e-RABSetup',
        'e-RABModify',
        'e-RABRelease',
        'e-RABReleaseIndication',
        'initialContextSetup',
        'uEContextReleaseRequest',
        'paging',
        'downlinkNASTransport',
        'initialUEMessage',
        'uplinkNASTransport',
        'nASNonDeliveryIndication',
        'handoverCancel',
        'reset',
        'errorIndication',
        's1Setup',
        'eNBConfigurationUpdate',
        'mMEConfigurationUpdate',
        'downlinkS1cdma2000tunnelling',
        'uplinkS1cdma2000tunnelling',
        'uEContextModification',
        'uECapabilityInfoIndication',
        'uEContextRelease',
        'eNBStatusTransfer',
        'mMEStatusTransfer',
        'deactivateTrace',
        'traceStart',
        'traceFailureIndication',
        'cellTrafficTrace',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'locationReport',
        'overloadStart',
        'overloadStop',
        'writeReplaceWarning',
        'eNBDirectInformationTransfer',
        'mMEDirectInformationTransfer',
        'eNBConfigurationTransfer',
        'mMEConfigurationTransfer',
        'privateMessage',
        'pWSRestartIndication',
        'kill',
        'downlinkUEAssociatedLPPaTransport',
        'uplinkUEAssociatedLPPaTransport',
        'downlinkNonUEAssociatedLPPaTransport',
        'uplinkNonUEAssociatedLPPaTransport',
        'uERadioCapabilityMatch',
        'e-RABModificationIndication',
        'uEContextModificationIndication',
        'rerouteNASRequest',
        'pWSFailureIndication',
        'uEContextSuspend',
        'uEContextResume',
        'connectionEstablishmentIndication',
        'nASDeliveryIndication',
        'retrieveUEInformation',
        'uEInformationTransfer',
        'eNBCPRelocationIndication',
        'mMECPRelocationIndication',
        'secondaryRATDataUsageReport',
        'uERadioCapabilityIDMapping',
        'handoverSuccess',
        'eNBEarlyStatusTransfer',
        'mMEEarlyStatusTransfer',
        ]
    _param_ = [
        ]
    
    #-----< S1AP-ELEMENTARY-PROCEDURE >-----#
    S1AP_ELEMENTARY_PROCEDURE = CLASS(name='S1AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _S1AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _S1AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')), default='ignore')
    S1AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _S1AP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _S1AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< S1AP-PDU >-----#
    S1AP_PDU = CHOICE(name='S1AP-PDU', mode=MODE_TYPE)
    _S1AP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'InitiatingMessage')))
    _S1AP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _S1AP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    S1AP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _S1AP_PDU_initiatingMessage),
        ('successfulOutcome', _S1AP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _S1AP_PDU_unsuccessfulOutcome),
        ])
    S1AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 39), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46), ('procedureCode', 53), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49), ('procedureCode', 63), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 62), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 64), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 66), ('criticality', 'ignore')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 39), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46), ('procedureCode', 53), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49), ('procedureCode', 63), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 62), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 64), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 66), ('criticality', 'ignore')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 39), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46), ('procedureCode', 53), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49), ('procedureCode', 63), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 62), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 64), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 66), ('criticality', 'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< S1AP-ELEMENTARY-PROCEDURES >-----#
    S1AP_ELEMENTARY_PROCEDURES = CLASS(name='S1AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    S1AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('procedureCode', 39), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46), ('procedureCode', 53), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49), ('procedureCode', 63), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), ('procedureCode', 62), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), ('procedureCode', 64), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), ('procedureCode', 66), ('criticality', 'ignore')])], er=[])
    
    #-----< S1AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    S1AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='S1AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    S1AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('procedureCode', 36), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('procedureCode', 48), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('procedureCode', 50), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('procedureCode', 53), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), ('procedureCode', 63), ('criticality', 'reject')])], er=[])
    
    #-----< S1AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    S1AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='S1AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    S1AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 27), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), ('procedureCode', 40), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), ('procedureCode', 39), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), ('procedureCode', 52), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), ('procedureCode', 61), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), ('procedureCode', 62), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), ('procedureCode', 64), ('criticality', 'ignore')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), ('procedureCode', 66), ('criticality', 'ignore')])], er=[])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name='handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([('InitiatingMessage', _handoverPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< handoverResourceAllocation >-----#
    handoverResourceAllocation = CLASS(name='handoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverResourceAllocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _handoverResourceAllocation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverResourceAllocation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    handoverResourceAllocation._val = dict([('InitiatingMessage', _handoverResourceAllocation_val_InitiatingMessage), ('SuccessfulOutcome', _handoverResourceAllocation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _handoverResourceAllocation_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< handoverNotification >-----#
    handoverNotification = CLASS(name='handoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    handoverNotification._val = dict([('InitiatingMessage', _handoverNotification_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< pathSwitchRequest >-----#
    pathSwitchRequest = CLASS(name='pathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pathSwitchRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _pathSwitchRequest_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _pathSwitchRequest_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    pathSwitchRequest._val = dict([('InitiatingMessage', _pathSwitchRequest_val_InitiatingMessage), ('SuccessfulOutcome', _pathSwitchRequest_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _pathSwitchRequest_val_UnsuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< e-RABSetup >-----#
    e_RABSetup = CLASS(name='e-RABSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _e_RABSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    e_RABSetup._val = dict([('InitiatingMessage', _e_RABSetup_val_InitiatingMessage), ('SuccessfulOutcome', _e_RABSetup_val_SuccessfulOutcome), ('procedureCode', 5), ('criticality', 'reject')])
    
    #-----< e-RABModify >-----#
    e_RABModify = CLASS(name='e-RABModify', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABModify_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _e_RABModify_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    e_RABModify._val = dict([('InitiatingMessage', _e_RABModify_val_InitiatingMessage), ('SuccessfulOutcome', _e_RABModify_val_SuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< e-RABRelease >-----#
    e_RABRelease = CLASS(name='e-RABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _e_RABRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    e_RABRelease._val = dict([('InitiatingMessage', _e_RABRelease_val_InitiatingMessage), ('SuccessfulOutcome', _e_RABRelease_val_SuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< e-RABReleaseIndication >-----#
    e_RABReleaseIndication = CLASS(name='e-RABReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABReleaseIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    e_RABReleaseIndication._val = dict([('InitiatingMessage', _e_RABReleaseIndication_val_InitiatingMessage), ('procedureCode', 8), ('criticality', 'ignore')])
    
    #-----< initialContextSetup >-----#
    initialContextSetup = CLASS(name='initialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _initialContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _initialContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _initialContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    initialContextSetup._val = dict([('InitiatingMessage', _initialContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _initialContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _initialContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name='uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([('InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name='paging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    paging._val = dict([('InitiatingMessage', _paging_val_InitiatingMessage), ('procedureCode', 10), ('criticality', 'ignore')])
    
    #-----< downlinkNASTransport >-----#
    downlinkNASTransport = CLASS(name='downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkNASTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    downlinkNASTransport._val = dict([('InitiatingMessage', _downlinkNASTransport_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< initialUEMessage >-----#
    initialUEMessage = CLASS(name='initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _initialUEMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    initialUEMessage._val = dict([('InitiatingMessage', _initialUEMessage_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< uplinkNASTransport >-----#
    uplinkNASTransport = CLASS(name='uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkNASTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    uplinkNASTransport._val = dict([('InitiatingMessage', _uplinkNASTransport_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< nASNonDeliveryIndication >-----#
    nASNonDeliveryIndication = CLASS(name='nASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _nASNonDeliveryIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    nASNonDeliveryIndication._val = dict([('InitiatingMessage', _nASNonDeliveryIndication_val_InitiatingMessage), ('procedureCode', 16), ('criticality', 'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name='handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _handoverCancel_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    handoverCancel._val = dict([('InitiatingMessage', _handoverCancel_val_InitiatingMessage), ('SuccessfulOutcome', _handoverCancel_val_SuccessfulOutcome), ('procedureCode', 4), ('criticality', 'reject')])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 14), ('criticality', 'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< s1Setup >-----#
    s1Setup = CLASS(name='s1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _s1Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _s1Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _s1Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    s1Setup._val = dict([('InitiatingMessage', _s1Setup_val_InitiatingMessage), ('SuccessfulOutcome', _s1Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _s1Setup_val_UnsuccessfulOutcome), ('procedureCode', 17), ('criticality', 'reject')])
    
    #-----< eNBConfigurationUpdate >-----#
    eNBConfigurationUpdate = CLASS(name='eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _eNBConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _eNBConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    eNBConfigurationUpdate._val = dict([('InitiatingMessage', _eNBConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _eNBConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _eNBConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 29), ('criticality', 'reject')])
    
    #-----< mMEConfigurationUpdate >-----#
    mMEConfigurationUpdate = CLASS(name='mMEConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _mMEConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _mMEConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    mMEConfigurationUpdate._val = dict([('InitiatingMessage', _mMEConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _mMEConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mMEConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 30), ('criticality', 'reject')])
    
    #-----< downlinkS1cdma2000tunnelling >-----#
    downlinkS1cdma2000tunnelling = CLASS(name='downlinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkS1cdma2000tunnelling_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    downlinkS1cdma2000tunnelling._val = dict([('InitiatingMessage', _downlinkS1cdma2000tunnelling_val_InitiatingMessage), ('procedureCode', 19), ('criticality', 'ignore')])
    
    #-----< uplinkS1cdma2000tunnelling >-----#
    uplinkS1cdma2000tunnelling = CLASS(name='uplinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkS1cdma2000tunnelling_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    uplinkS1cdma2000tunnelling._val = dict([('InitiatingMessage', _uplinkS1cdma2000tunnelling_val_InitiatingMessage), ('procedureCode', 20), ('criticality', 'ignore')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name='uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([('InitiatingMessage', _uEContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), ('procedureCode', 21), ('criticality', 'reject')])
    
    #-----< uECapabilityInfoIndication >-----#
    uECapabilityInfoIndication = CLASS(name='uECapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uECapabilityInfoIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    uECapabilityInfoIndication._val = dict([('InitiatingMessage', _uECapabilityInfoIndication_val_InitiatingMessage), ('procedureCode', 22), ('criticality', 'ignore')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name='uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([('InitiatingMessage', _uEContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), ('procedureCode', 23), ('criticality', 'reject')])
    
    #-----< eNBStatusTransfer >-----#
    eNBStatusTransfer = CLASS(name='eNBStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    eNBStatusTransfer._val = dict([('InitiatingMessage', _eNBStatusTransfer_val_InitiatingMessage), ('procedureCode', 24), ('criticality', 'ignore')])
    
    #-----< mMEStatusTransfer >-----#
    mMEStatusTransfer = CLASS(name='mMEStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    mMEStatusTransfer._val = dict([('InitiatingMessage', _mMEStatusTransfer_val_InitiatingMessage), ('procedureCode', 25), ('criticality', 'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name='deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([('InitiatingMessage', _deactivateTrace_val_InitiatingMessage), ('procedureCode', 26), ('criticality', 'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name='traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([('InitiatingMessage', _traceStart_val_InitiatingMessage), ('procedureCode', 27), ('criticality', 'ignore')])
    
    #-----< traceFailureIndication >-----#
    traceFailureIndication = CLASS(name='traceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _traceFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    traceFailureIndication._val = dict([('InitiatingMessage', _traceFailureIndication_val_InitiatingMessage), ('procedureCode', 28), ('criticality', 'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name='cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([('InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), ('procedureCode', 42), ('criticality', 'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name='locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([('InitiatingMessage', _locationReportingControl_val_InitiatingMessage), ('procedureCode', 31), ('criticality', 'ignore')])
    
    #-----< locationReportingFailureIndication >-----#
    locationReportingFailureIndication = CLASS(name='locationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReportingFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    locationReportingFailureIndication._val = dict([('InitiatingMessage', _locationReportingFailureIndication_val_InitiatingMessage), ('procedureCode', 32), ('criticality', 'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name='locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([('InitiatingMessage', _locationReport_val_InitiatingMessage), ('procedureCode', 33), ('criticality', 'ignore')])
    
    #-----< overloadStart >-----#
    overloadStart = CLASS(name='overloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _overloadStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    overloadStart._val = dict([('InitiatingMessage', _overloadStart_val_InitiatingMessage), ('procedureCode', 34), ('criticality', 'ignore')])
    
    #-----< overloadStop >-----#
    overloadStop = CLASS(name='overloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _overloadStop_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    overloadStop._val = dict([('InitiatingMessage', _overloadStop_val_InitiatingMessage), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name='writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([('InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), ('SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< eNBDirectInformationTransfer >-----#
    eNBDirectInformationTransfer = CLASS(name='eNBDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBDirectInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    eNBDirectInformationTransfer._val = dict([('InitiatingMessage', _eNBDirectInformationTransfer_val_InitiatingMessage), ('procedureCode', 37), ('criticality', 'ignore')])
    
    #-----< mMEDirectInformationTransfer >-----#
    mMEDirectInformationTransfer = CLASS(name='mMEDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEDirectInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    mMEDirectInformationTransfer._val = dict([('InitiatingMessage', _mMEDirectInformationTransfer_val_InitiatingMessage), ('procedureCode', 38), ('criticality', 'ignore')])
    
    #-----< eNBConfigurationTransfer >-----#
    eNBConfigurationTransfer = CLASS(name='eNBConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    eNBConfigurationTransfer._val = dict([('InitiatingMessage', _eNBConfigurationTransfer_val_InitiatingMessage), ('procedureCode', 40), ('criticality', 'ignore')])
    
    #-----< mMEConfigurationTransfer >-----#
    mMEConfigurationTransfer = CLASS(name='mMEConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEConfigurationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    mMEConfigurationTransfer._val = dict([('InitiatingMessage', _mMEConfigurationTransfer_val_InitiatingMessage), ('procedureCode', 41), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 39), ('criticality', 'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name='pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([('InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), ('procedureCode', 49), ('criticality', 'ignore')])
    
    #-----< kill >-----#
    kill = CLASS(name='kill', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _kill_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _kill_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    kill._val = dict([('InitiatingMessage', _kill_val_InitiatingMessage), ('SuccessfulOutcome', _kill_val_SuccessfulOutcome), ('procedureCode', 43), ('criticality', 'reject')])
    
    #-----< downlinkUEAssociatedLPPaTransport >-----#
    downlinkUEAssociatedLPPaTransport = CLASS(name='downlinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    downlinkUEAssociatedLPPaTransport._val = dict([('InitiatingMessage', _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage), ('procedureCode', 44), ('criticality', 'ignore')])
    
    #-----< uplinkUEAssociatedLPPaTransport >-----#
    uplinkUEAssociatedLPPaTransport = CLASS(name='uplinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    uplinkUEAssociatedLPPaTransport._val = dict([('InitiatingMessage', _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage), ('procedureCode', 45), ('criticality', 'ignore')])
    
    #-----< downlinkNonUEAssociatedLPPaTransport >-----#
    downlinkNonUEAssociatedLPPaTransport = CLASS(name='downlinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    downlinkNonUEAssociatedLPPaTransport._val = dict([('InitiatingMessage', _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage), ('procedureCode', 46), ('criticality', 'ignore')])
    
    #-----< uplinkNonUEAssociatedLPPaTransport >-----#
    uplinkNonUEAssociatedLPPaTransport = CLASS(name='uplinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    uplinkNonUEAssociatedLPPaTransport._val = dict([('InitiatingMessage', _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage), ('procedureCode', 47), ('criticality', 'ignore')])
    
    #-----< uERadioCapabilityMatch >-----#
    uERadioCapabilityMatch = CLASS(name='uERadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityMatch_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _uERadioCapabilityMatch_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    uERadioCapabilityMatch._val = dict([('InitiatingMessage', _uERadioCapabilityMatch_val_InitiatingMessage), ('SuccessfulOutcome', _uERadioCapabilityMatch_val_SuccessfulOutcome), ('procedureCode', 48), ('criticality', 'reject')])
    
    #-----< e-RABModificationIndication >-----#
    e_RABModificationIndication = CLASS(name='e-RABModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABModificationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _e_RABModificationIndication_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    e_RABModificationIndication._val = dict([('InitiatingMessage', _e_RABModificationIndication_val_InitiatingMessage), ('SuccessfulOutcome', _e_RABModificationIndication_val_SuccessfulOutcome), ('procedureCode', 50), ('criticality', 'reject')])
    
    #-----< uEContextModificationIndication >-----#
    uEContextModificationIndication = CLASS(name='uEContextModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModificationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _uEContextModificationIndication_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    uEContextModificationIndication._val = dict([('InitiatingMessage', _uEContextModificationIndication_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextModificationIndication_val_SuccessfulOutcome), ('procedureCode', 53), ('criticality', 'reject')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name='rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([('InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), ('procedureCode', 52), ('criticality', 'reject')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name='pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([('InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), ('procedureCode', 51), ('criticality', 'ignore')])
    
    #-----< uEContextSuspend >-----#
    uEContextSuspend = CLASS(name='uEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextSuspend_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _uEContextSuspend_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    uEContextSuspend._val = dict([('InitiatingMessage', _uEContextSuspend_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextSuspend_val_SuccessfulOutcome), ('procedureCode', 55), ('criticality', 'reject')])
    
    #-----< uEContextResume >-----#
    uEContextResume = CLASS(name='uEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextResume_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _uEContextResume_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _uEContextResume_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    uEContextResume._val = dict([('InitiatingMessage', _uEContextResume_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextResume_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextResume_val_UnsuccessfulOutcome), ('procedureCode', 56), ('criticality', 'reject')])
    
    #-----< connectionEstablishmentIndication >-----#
    connectionEstablishmentIndication = CLASS(name='connectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _connectionEstablishmentIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    connectionEstablishmentIndication._val = dict([('InitiatingMessage', _connectionEstablishmentIndication_val_InitiatingMessage), ('procedureCode', 54), ('criticality', 'reject')])
    
    #-----< nASDeliveryIndication >-----#
    nASDeliveryIndication = CLASS(name='nASDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _nASDeliveryIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    nASDeliveryIndication._val = dict([('InitiatingMessage', _nASDeliveryIndication_val_InitiatingMessage), ('procedureCode', 57), ('criticality', 'ignore')])
    
    #-----< retrieveUEInformation >-----#
    retrieveUEInformation = CLASS(name='retrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _retrieveUEInformation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    retrieveUEInformation._val = dict([('InitiatingMessage', _retrieveUEInformation_val_InitiatingMessage), ('procedureCode', 58), ('criticality', 'reject')])
    
    #-----< uEInformationTransfer >-----#
    uEInformationTransfer = CLASS(name='uEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    uEInformationTransfer._val = dict([('InitiatingMessage', _uEInformationTransfer_val_InitiatingMessage), ('procedureCode', 59), ('criticality', 'reject')])
    
    #-----< eNBCPRelocationIndication >-----#
    eNBCPRelocationIndication = CLASS(name='eNBCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBCPRelocationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    eNBCPRelocationIndication._val = dict([('InitiatingMessage', _eNBCPRelocationIndication_val_InitiatingMessage), ('procedureCode', 60), ('criticality', 'reject')])
    
    #-----< mMECPRelocationIndication >-----#
    mMECPRelocationIndication = CLASS(name='mMECPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMECPRelocationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    mMECPRelocationIndication._val = dict([('InitiatingMessage', _mMECPRelocationIndication_val_InitiatingMessage), ('procedureCode', 61), ('criticality', 'reject')])
    
    #-----< secondaryRATDataUsageReport >-----#
    secondaryRATDataUsageReport = CLASS(name='secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _secondaryRATDataUsageReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    secondaryRATDataUsageReport._val = dict([('InitiatingMessage', _secondaryRATDataUsageReport_val_InitiatingMessage), ('procedureCode', 62), ('criticality', 'ignore')])
    
    #-----< uERadioCapabilityIDMapping >-----#
    uERadioCapabilityIDMapping = CLASS(name='uERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityIDMapping_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _uERadioCapabilityIDMapping_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    uERadioCapabilityIDMapping._val = dict([('InitiatingMessage', _uERadioCapabilityIDMapping_val_InitiatingMessage), ('SuccessfulOutcome', _uERadioCapabilityIDMapping_val_SuccessfulOutcome), ('procedureCode', 63), ('criticality', 'reject')])
    
    #-----< handoverSuccess >-----#
    handoverSuccess = CLASS(name='handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverSuccess_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    handoverSuccess._val = dict([('InitiatingMessage', _handoverSuccess_val_InitiatingMessage), ('procedureCode', 64), ('criticality', 'ignore')])
    
    #-----< eNBEarlyStatusTransfer >-----#
    eNBEarlyStatusTransfer = CLASS(name='eNBEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBEarlyStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    eNBEarlyStatusTransfer._val = dict([('InitiatingMessage', _eNBEarlyStatusTransfer_val_InitiatingMessage), ('procedureCode', 65), ('criticality', 'reject')])
    
    #-----< mMEEarlyStatusTransfer >-----#
    mMEEarlyStatusTransfer = CLASS(name='mMEEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEEarlyStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    mMEEarlyStatusTransfer._val = dict([('InitiatingMessage', _mMEEarlyStatusTransfer_val_InitiatingMessage), ('procedureCode', 66), ('criticality', 'ignore')])
    
    _all_ = [
        _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _S1AP_ELEMENTARY_PROCEDURE_procedureCode,
        _S1AP_ELEMENTARY_PROCEDURE_criticality,
        S1AP_ELEMENTARY_PROCEDURE,
        _S1AP_PDU_initiatingMessage,
        _S1AP_PDU_successfulOutcome,
        _S1AP_PDU_unsuccessfulOutcome,
        S1AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        S1AP_ELEMENTARY_PROCEDURES,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        S1AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        S1AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        handoverResourceAllocation,
        _handoverResourceAllocation_val_InitiatingMessage,
        _handoverResourceAllocation_val_SuccessfulOutcome,
        _handoverResourceAllocation_val_UnsuccessfulOutcome,
        handoverNotification,
        _handoverNotification_val_InitiatingMessage,
        pathSwitchRequest,
        _pathSwitchRequest_val_InitiatingMessage,
        _pathSwitchRequest_val_SuccessfulOutcome,
        _pathSwitchRequest_val_UnsuccessfulOutcome,
        e_RABSetup,
        _e_RABSetup_val_InitiatingMessage,
        _e_RABSetup_val_SuccessfulOutcome,
        e_RABModify,
        _e_RABModify_val_InitiatingMessage,
        _e_RABModify_val_SuccessfulOutcome,
        e_RABRelease,
        _e_RABRelease_val_InitiatingMessage,
        _e_RABRelease_val_SuccessfulOutcome,
        e_RABReleaseIndication,
        _e_RABReleaseIndication_val_InitiatingMessage,
        initialContextSetup,
        _initialContextSetup_val_InitiatingMessage,
        _initialContextSetup_val_SuccessfulOutcome,
        _initialContextSetup_val_UnsuccessfulOutcome,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        downlinkNASTransport,
        _downlinkNASTransport_val_InitiatingMessage,
        initialUEMessage,
        _initialUEMessage_val_InitiatingMessage,
        uplinkNASTransport,
        _uplinkNASTransport_val_InitiatingMessage,
        nASNonDeliveryIndication,
        _nASNonDeliveryIndication_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        _handoverCancel_val_SuccessfulOutcome,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        s1Setup,
        _s1Setup_val_InitiatingMessage,
        _s1Setup_val_SuccessfulOutcome,
        _s1Setup_val_UnsuccessfulOutcome,
        eNBConfigurationUpdate,
        _eNBConfigurationUpdate_val_InitiatingMessage,
        _eNBConfigurationUpdate_val_SuccessfulOutcome,
        _eNBConfigurationUpdate_val_UnsuccessfulOutcome,
        mMEConfigurationUpdate,
        _mMEConfigurationUpdate_val_InitiatingMessage,
        _mMEConfigurationUpdate_val_SuccessfulOutcome,
        _mMEConfigurationUpdate_val_UnsuccessfulOutcome,
        downlinkS1cdma2000tunnelling,
        _downlinkS1cdma2000tunnelling_val_InitiatingMessage,
        uplinkS1cdma2000tunnelling,
        _uplinkS1cdma2000tunnelling_val_InitiatingMessage,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uECapabilityInfoIndication,
        _uECapabilityInfoIndication_val_InitiatingMessage,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        eNBStatusTransfer,
        _eNBStatusTransfer_val_InitiatingMessage,
        mMEStatusTransfer,
        _mMEStatusTransfer_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        traceFailureIndication,
        _traceFailureIndication_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReportingFailureIndication,
        _locationReportingFailureIndication_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        overloadStart,
        _overloadStart_val_InitiatingMessage,
        overloadStop,
        _overloadStop_val_InitiatingMessage,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        eNBDirectInformationTransfer,
        _eNBDirectInformationTransfer_val_InitiatingMessage,
        mMEDirectInformationTransfer,
        _mMEDirectInformationTransfer_val_InitiatingMessage,
        eNBConfigurationTransfer,
        _eNBConfigurationTransfer_val_InitiatingMessage,
        mMEConfigurationTransfer,
        _mMEConfigurationTransfer_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        kill,
        _kill_val_InitiatingMessage,
        _kill_val_SuccessfulOutcome,
        downlinkUEAssociatedLPPaTransport,
        _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage,
        uplinkUEAssociatedLPPaTransport,
        _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage,
        downlinkNonUEAssociatedLPPaTransport,
        _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage,
        uplinkNonUEAssociatedLPPaTransport,
        _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage,
        uERadioCapabilityMatch,
        _uERadioCapabilityMatch_val_InitiatingMessage,
        _uERadioCapabilityMatch_val_SuccessfulOutcome,
        e_RABModificationIndication,
        _e_RABModificationIndication_val_InitiatingMessage,
        _e_RABModificationIndication_val_SuccessfulOutcome,
        uEContextModificationIndication,
        _uEContextModificationIndication_val_InitiatingMessage,
        _uEContextModificationIndication_val_SuccessfulOutcome,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        uEContextSuspend,
        _uEContextSuspend_val_InitiatingMessage,
        _uEContextSuspend_val_SuccessfulOutcome,
        uEContextResume,
        _uEContextResume_val_InitiatingMessage,
        _uEContextResume_val_SuccessfulOutcome,
        _uEContextResume_val_UnsuccessfulOutcome,
        connectionEstablishmentIndication,
        _connectionEstablishmentIndication_val_InitiatingMessage,
        nASDeliveryIndication,
        _nASDeliveryIndication_val_InitiatingMessage,
        retrieveUEInformation,
        _retrieveUEInformation_val_InitiatingMessage,
        uEInformationTransfer,
        _uEInformationTransfer_val_InitiatingMessage,
        eNBCPRelocationIndication,
        _eNBCPRelocationIndication_val_InitiatingMessage,
        mMECPRelocationIndication,
        _mMECPRelocationIndication_val_InitiatingMessage,
        secondaryRATDataUsageReport,
        _secondaryRATDataUsageReport_val_InitiatingMessage,
        uERadioCapabilityIDMapping,
        _uERadioCapabilityIDMapping_val_InitiatingMessage,
        _uERadioCapabilityIDMapping_val_SuccessfulOutcome,
        handoverSuccess,
        _handoverSuccess_val_InitiatingMessage,
        eNBEarlyStatusTransfer,
        _eNBEarlyStatusTransfer_val_InitiatingMessage,
        mMEEarlyStatusTransfer,
        _mMEEarlyStatusTransfer_val_InitiatingMessage,
    ]

class SonTransfer_IEs:

    _name_  = 'SonTransfer-IEs'
    _oid_   = []
    
    _obj_ = [
        'SONtransferApplicationIdentity',
        'SONtransferRequestContainer',
        'SONtransferResponseContainer',
        'SONtransferCause',
        'CellLoadReportingCause',
        'HOReportingCause',
        'CellActivationCause',
        'CellStateIndicationCause',
        'FailureEventReportingCause',
        'CellLoadReportingResponse',
        'CompositeAvailableCapacityGroup',
        'EUTRANcellLoadReportingResponse',
        'EUTRANResponse',
        'EHRPD-Sector-ID',
        'IRAT-Cell-ID',
        'RequestedCellList',
        'MultiCellLoadReportingRequest',
        'ReportingCellList-Item',
        'ReportingCellList',
        'MultiCellLoadReportingResponse',
        'MultiCellLoadReportingResponse-Item',
        'NumberOfMeasurementReportingLevels',
        'EventTriggeredCellLoadReportingRequest',
        'OverloadFlag',
        'EventTriggeredCellLoadReportingResponse',
        'HOReport',
        'HoType',
        'HoReportType',
        'CandidateCellList',
        'CandidatePCIList',
        'CandidatePCI',
        'CellActivationRequest',
        'CellsToActivateList',
        'CellsToActivateList-Item',
        'CellActivationResponse',
        'ActivatedCellsList',
        'ActivatedCellsList-Item',
        'CellStateIndication',
        'NotificationCellList',
        'NotificationCellList-Item',
        'NotifyFlag',
        'FailureEventReport',
        'TooEarlyInterRATHOReportReportFromEUTRAN',
        'MobilityInformation',
        'EHRPDCapacityValue',
        'EHRPDSectorCapacityClassValue',
        'EHRPDSectorLoadReportingResponse',
        'EHRPDCompositeAvailableCapacity',
        'EHRPDMultiSectorLoadReportingResponseItem',
        'maxnoofIRATReportingCells',
        'maxnoofcandidateCells',
        'maxnoofCellineNB',
        ]
    _type_ = [
        'SONtransferApplicationIdentity',
        'SONtransferRequestContainer',
        'SONtransferResponseContainer',
        'SONtransferCause',
        'CellLoadReportingCause',
        'HOReportingCause',
        'CellActivationCause',
        'CellStateIndicationCause',
        'FailureEventReportingCause',
        'CellLoadReportingResponse',
        'CompositeAvailableCapacityGroup',
        'EUTRANcellLoadReportingResponse',
        'EUTRANResponse',
        'EHRPD-Sector-ID',
        'IRAT-Cell-ID',
        'RequestedCellList',
        'MultiCellLoadReportingRequest',
        'ReportingCellList-Item',
        'ReportingCellList',
        'MultiCellLoadReportingResponse',
        'MultiCellLoadReportingResponse-Item',
        'NumberOfMeasurementReportingLevels',
        'EventTriggeredCellLoadReportingRequest',
        'OverloadFlag',
        'EventTriggeredCellLoadReportingResponse',
        'HOReport',
        'HoType',
        'HoReportType',
        'CandidateCellList',
        'CandidatePCIList',
        'CandidatePCI',
        'CellActivationRequest',
        'CellsToActivateList',
        'CellsToActivateList-Item',
        'CellActivationResponse',
        'ActivatedCellsList',
        'ActivatedCellsList-Item',
        'CellStateIndication',
        'NotificationCellList',
        'NotificationCellList-Item',
        'NotifyFlag',
        'FailureEventReport',
        'TooEarlyInterRATHOReportReportFromEUTRAN',
        'MobilityInformation',
        'EHRPDCapacityValue',
        'EHRPDSectorCapacityClassValue',
        'EHRPDSectorLoadReportingResponse',
        'EHRPDCompositeAvailableCapacity',
        'EHRPDMultiSectorLoadReportingResponseItem',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxnoofIRATReportingCells',
        'maxnoofcandidateCells',
        'maxnoofCellineNB',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SONtransferApplicationIdentity >-----#
    SONtransferApplicationIdentity = ENUM(name='SONtransferApplicationIdentity', mode=MODE_TYPE)
    SONtransferApplicationIdentity._cont = ASN1Dict([('cell-load-reporting', 0), ('multi-cell-load-reporting', 1), ('event-triggered-cell-load-reporting', 2), ('ho-reporting', 3), ('eutran-cell-activation', 4), ('energy-savings-indication', 5), ('failure-event-reporting', 6)])
    SONtransferApplicationIdentity._ext = ['multi-cell-load-reporting', 'event-triggered-cell-load-reporting', 'ho-reporting', 'eutran-cell-activation', 'energy-savings-indication', 'failure-event-reporting']
    
    #-----< SONtransferRequestContainer >-----#
    SONtransferRequestContainer = CHOICE(name='SONtransferRequestContainer', mode=MODE_TYPE)
    _SONtransferRequestContainer_cellLoadReporting = NULL(name='cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferRequestContainer_multiCellLoadReporting = SEQ(name='multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingRequest')))
    _SONtransferRequestContainer_eventTriggeredCellLoadReporting = SEQ(name='eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EventTriggeredCellLoadReportingRequest')))
    _SONtransferRequestContainer_hOReporting = SEQ(name='hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HOReport')))
    _SONtransferRequestContainer_eutranCellActivation = SEQ(name='eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationRequest')))
    _SONtransferRequestContainer_energySavingsIndication = SEQ(name='energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellStateIndication')))
    _SONtransferRequestContainer_failureEventReporting = CHOICE(name='failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'FailureEventReport')))
    SONtransferRequestContainer._cont = ASN1Dict([
        ('cellLoadReporting', _SONtransferRequestContainer_cellLoadReporting),
        ('multiCellLoadReporting', _SONtransferRequestContainer_multiCellLoadReporting),
        ('eventTriggeredCellLoadReporting', _SONtransferRequestContainer_eventTriggeredCellLoadReporting),
        ('hOReporting', _SONtransferRequestContainer_hOReporting),
        ('eutranCellActivation', _SONtransferRequestContainer_eutranCellActivation),
        ('energySavingsIndication', _SONtransferRequestContainer_energySavingsIndication),
        ('failureEventReporting', _SONtransferRequestContainer_failureEventReporting),
        ])
    SONtransferRequestContainer._ext = ['multiCellLoadReporting', 'eventTriggeredCellLoadReporting', 'hOReporting', 'eutranCellActivation', 'energySavingsIndication', 'failureEventReporting']
    
    #-----< SONtransferResponseContainer >-----#
    SONtransferResponseContainer = CHOICE(name='SONtransferResponseContainer', mode=MODE_TYPE)
    _SONtransferResponseContainer_cellLoadReporting = CHOICE(name='cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingResponse')))
    _SONtransferResponseContainer_multiCellLoadReporting = SEQ_OF(name='multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingResponse')))
    _SONtransferResponseContainer_eventTriggeredCellLoadReporting = SEQ(name='eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EventTriggeredCellLoadReportingResponse')))
    _SONtransferResponseContainer_hOReporting = NULL(name='hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferResponseContainer_eutranCellActivation = SEQ(name='eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationResponse')))
    _SONtransferResponseContainer_energySavingsIndication = NULL(name='energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferResponseContainer_failureEventReporting = NULL(name='failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SONtransferResponseContainer._cont = ASN1Dict([
        ('cellLoadReporting', _SONtransferResponseContainer_cellLoadReporting),
        ('multiCellLoadReporting', _SONtransferResponseContainer_multiCellLoadReporting),
        ('eventTriggeredCellLoadReporting', _SONtransferResponseContainer_eventTriggeredCellLoadReporting),
        ('hOReporting', _SONtransferResponseContainer_hOReporting),
        ('eutranCellActivation', _SONtransferResponseContainer_eutranCellActivation),
        ('energySavingsIndication', _SONtransferResponseContainer_energySavingsIndication),
        ('failureEventReporting', _SONtransferResponseContainer_failureEventReporting),
        ])
    SONtransferResponseContainer._ext = ['multiCellLoadReporting', 'eventTriggeredCellLoadReporting', 'hOReporting', 'eutranCellActivation', 'energySavingsIndication', 'failureEventReporting']
    
    #-----< SONtransferCause >-----#
    SONtransferCause = CHOICE(name='SONtransferCause', mode=MODE_TYPE)
    _SONtransferCause_cellLoadReporting = ENUM(name='cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_multiCellLoadReporting = ENUM(name='multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_eventTriggeredCellLoadReporting = ENUM(name='eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_hOReporting = ENUM(name='hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HOReportingCause')))
    _SONtransferCause_eutranCellActivation = ENUM(name='eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationCause')))
    _SONtransferCause_energySavingsIndication = ENUM(name='energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellStateIndicationCause')))
    _SONtransferCause_failureEventReporting = ENUM(name='failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'FailureEventReportingCause')))
    SONtransferCause._cont = ASN1Dict([
        ('cellLoadReporting', _SONtransferCause_cellLoadReporting),
        ('multiCellLoadReporting', _SONtransferCause_multiCellLoadReporting),
        ('eventTriggeredCellLoadReporting', _SONtransferCause_eventTriggeredCellLoadReporting),
        ('hOReporting', _SONtransferCause_hOReporting),
        ('eutranCellActivation', _SONtransferCause_eutranCellActivation),
        ('energySavingsIndication', _SONtransferCause_energySavingsIndication),
        ('failureEventReporting', _SONtransferCause_failureEventReporting),
        ])
    SONtransferCause._ext = ['multiCellLoadReporting', 'eventTriggeredCellLoadReporting', 'hOReporting', 'eutranCellActivation', 'energySavingsIndication', 'failureEventReporting']
    
    #-----< CellLoadReportingCause >-----#
    CellLoadReportingCause = ENUM(name='CellLoadReportingCause', mode=MODE_TYPE)
    CellLoadReportingCause._cont = ASN1Dict([('application-container-syntax-error', 0), ('inconsistent-reporting-cell-identifier', 1), ('unspecified', 2)])
    CellLoadReportingCause._ext = []
    
    #-----< HOReportingCause >-----#
    HOReportingCause = ENUM(name='HOReportingCause', mode=MODE_TYPE)
    HOReportingCause._cont = ASN1Dict([('application-container-syntax-error', 0), ('inconsistent-reporting-cell-identifier', 1), ('unspecified', 2)])
    HOReportingCause._ext = []
    
    #-----< CellActivationCause >-----#
    CellActivationCause = ENUM(name='CellActivationCause', mode=MODE_TYPE)
    CellActivationCause._cont = ASN1Dict([('application-container-syntax-error', 0), ('inconsistent-reporting-cell-identifier', 1), ('unspecified', 2)])
    CellActivationCause._ext = []
    
    #-----< CellStateIndicationCause >-----#
    CellStateIndicationCause = ENUM(name='CellStateIndicationCause', mode=MODE_TYPE)
    CellStateIndicationCause._cont = ASN1Dict([('application-container-syntax-error', 0), ('inconsistent-reporting-cell-identifier', 1), ('unspecified', 2)])
    CellStateIndicationCause._ext = []
    
    #-----< FailureEventReportingCause >-----#
    FailureEventReportingCause = ENUM(name='FailureEventReportingCause', mode=MODE_TYPE)
    FailureEventReportingCause._cont = ASN1Dict([('application-container-syntax-error', 0), ('inconsistent-reporting-cell-identifier', 1), ('unspecified', 2)])
    FailureEventReportingCause._ext = []
    
    #-----< CellLoadReportingResponse >-----#
    CellLoadReportingResponse = CHOICE(name='CellLoadReportingResponse', mode=MODE_TYPE)
    _CellLoadReportingResponse_eUTRAN = SEQ(name='eUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANcellLoadReportingResponse')))
    _CellLoadReportingResponse_uTRAN = OCT_STR(name='uTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellLoadReportingResponse_gERAN = OCT_STR(name='gERAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellLoadReportingResponse_eHRPD = SEQ(name='eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorLoadReportingResponse')))
    CellLoadReportingResponse._cont = ASN1Dict([
        ('eUTRAN', _CellLoadReportingResponse_eUTRAN),
        ('uTRAN', _CellLoadReportingResponse_uTRAN),
        ('gERAN', _CellLoadReportingResponse_gERAN),
        ('eHRPD', _CellLoadReportingResponse_eHRPD),
        ])
    CellLoadReportingResponse._ext = ['eHRPD']
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = OCT_STR(name='CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    
    #-----< EUTRANcellLoadReportingResponse >-----#
    EUTRANcellLoadReportingResponse = SEQ(name='EUTRANcellLoadReportingResponse', mode=MODE_TYPE)
    _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup = OCT_STR(name='compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CompositeAvailableCapacityGroup')))
    EUTRANcellLoadReportingResponse._cont = ASN1Dict([
        ('compositeAvailableCapacityGroup', _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup),
        ])
    EUTRANcellLoadReportingResponse._ext = []
    
    #-----< EUTRANResponse >-----#
    EUTRANResponse = SEQ(name='EUTRANResponse', mode=MODE_TYPE)
    _EUTRANResponse_cell_ID = OCT_STR(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRANResponse_eUTRANcellLoadReportingResponse = SEQ(name='eUTRANcellLoadReportingResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANcellLoadReportingResponse')))
    EUTRANResponse._cont = ASN1Dict([
        ('cell-ID', _EUTRANResponse_cell_ID),
        ('eUTRANcellLoadReportingResponse', _EUTRANResponse_eUTRANcellLoadReportingResponse),
        ])
    EUTRANResponse._ext = []
    
    #-----< EHRPD-Sector-ID >-----#
    EHRPD_Sector_ID = OCT_STR(name='EHRPD-Sector-ID', mode=MODE_TYPE)
    EHRPD_Sector_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IRAT-Cell-ID >-----#
    IRAT_Cell_ID = CHOICE(name='IRAT-Cell-ID', mode=MODE_TYPE)
    _IRAT_Cell_ID_eUTRAN = OCT_STR(name='eUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_uTRAN = OCT_STR(name='uTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_gERAN = OCT_STR(name='gERAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_eHRPD = OCT_STR(name='eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPD-Sector-ID')))
    IRAT_Cell_ID._cont = ASN1Dict([
        ('eUTRAN', _IRAT_Cell_ID_eUTRAN),
        ('uTRAN', _IRAT_Cell_ID_uTRAN),
        ('gERAN', _IRAT_Cell_ID_gERAN),
        ('eHRPD', _IRAT_Cell_ID_eHRPD),
        ])
    IRAT_Cell_ID._ext = ['eHRPD']
    
    #-----< RequestedCellList >-----#
    RequestedCellList = SEQ_OF(name='RequestedCellList', mode=MODE_TYPE)
    _RequestedCellList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    RequestedCellList._cont = _RequestedCellList__item_
    RequestedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingRequest >-----#
    MultiCellLoadReportingRequest = SEQ(name='MultiCellLoadReportingRequest', mode=MODE_TYPE)
    _MultiCellLoadReportingRequest_requestedCellList = SEQ_OF(name='requestedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'RequestedCellList')))
    MultiCellLoadReportingRequest._cont = ASN1Dict([
        ('requestedCellList', _MultiCellLoadReportingRequest_requestedCellList),
        ])
    MultiCellLoadReportingRequest._ext = []
    
    #-----< ReportingCellList-Item >-----#
    ReportingCellList_Item = SEQ(name='ReportingCellList-Item', mode=MODE_TYPE)
    _ReportingCellList_Item_cell_ID = CHOICE(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    ReportingCellList_Item._cont = ASN1Dict([
        ('cell-ID', _ReportingCellList_Item_cell_ID),
        ])
    ReportingCellList_Item._ext = []
    
    #-----< ReportingCellList >-----#
    ReportingCellList = SEQ_OF(name='ReportingCellList', mode=MODE_TYPE)
    _ReportingCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'ReportingCellList-Item')))
    ReportingCellList._cont = _ReportingCellList__item_
    ReportingCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingResponse >-----#
    MultiCellLoadReportingResponse = SEQ_OF(name='MultiCellLoadReportingResponse', mode=MODE_TYPE)
    _MultiCellLoadReportingResponse__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingResponse-Item')))
    MultiCellLoadReportingResponse._cont = _MultiCellLoadReportingResponse__item_
    MultiCellLoadReportingResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingResponse-Item >-----#
    MultiCellLoadReportingResponse_Item = CHOICE(name='MultiCellLoadReportingResponse-Item', mode=MODE_TYPE)
    _MultiCellLoadReportingResponse_Item_eUTRANResponse = SEQ(name='eUTRANResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANResponse')))
    _MultiCellLoadReportingResponse_Item_uTRANResponse = OCT_STR(name='uTRANResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiCellLoadReportingResponse_Item_gERANResponse = OCT_STR(name='gERANResponse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiCellLoadReportingResponse_Item_eHRPD = SEQ(name='eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDMultiSectorLoadReportingResponseItem')))
    MultiCellLoadReportingResponse_Item._cont = ASN1Dict([
        ('eUTRANResponse', _MultiCellLoadReportingResponse_Item_eUTRANResponse),
        ('uTRANResponse', _MultiCellLoadReportingResponse_Item_uTRANResponse),
        ('gERANResponse', _MultiCellLoadReportingResponse_Item_gERANResponse),
        ('eHRPD', _MultiCellLoadReportingResponse_Item_eHRPD),
        ])
    MultiCellLoadReportingResponse_Item._ext = ['eHRPD']
    
    #-----< NumberOfMeasurementReportingLevels >-----#
    NumberOfMeasurementReportingLevels = ENUM(name='NumberOfMeasurementReportingLevels', mode=MODE_TYPE)
    NumberOfMeasurementReportingLevels._cont = ASN1Dict([('rl2', 0), ('rl3', 1), ('rl4', 2), ('rl5', 3), ('rl10', 4)])
    NumberOfMeasurementReportingLevels._ext = []
    
    #-----< EventTriggeredCellLoadReportingRequest >-----#
    EventTriggeredCellLoadReportingRequest = SEQ(name='EventTriggeredCellLoadReportingRequest', mode=MODE_TYPE)
    _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels = ENUM(name='numberOfMeasurementReportingLevels', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NumberOfMeasurementReportingLevels')))
    EventTriggeredCellLoadReportingRequest._cont = ASN1Dict([
        ('numberOfMeasurementReportingLevels', _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels),
        ])
    EventTriggeredCellLoadReportingRequest._ext = []
    
    #-----< OverloadFlag >-----#
    OverloadFlag = ENUM(name='OverloadFlag', mode=MODE_TYPE)
    OverloadFlag._cont = ASN1Dict([('overload', 0)])
    OverloadFlag._ext = []
    
    #-----< EventTriggeredCellLoadReportingResponse >-----#
    EventTriggeredCellLoadReportingResponse = SEQ(name='EventTriggeredCellLoadReportingResponse', mode=MODE_TYPE)
    _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse = CHOICE(name='cellLoadReportingResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingResponse')))
    _EventTriggeredCellLoadReportingResponse_overloadFlag = ENUM(name='overloadFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'OverloadFlag')), opt=True)
    EventTriggeredCellLoadReportingResponse._cont = ASN1Dict([
        ('cellLoadReportingResponse', _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse),
        ('overloadFlag', _EventTriggeredCellLoadReportingResponse_overloadFlag),
        ])
    EventTriggeredCellLoadReportingResponse._ext = []
    
    #-----< HOReport >-----#
    HOReport = SEQ(name='HOReport', mode=MODE_TYPE)
    _HOReport_hoType = ENUM(name='hoType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HoType')))
    _HOReport_hoReportType = ENUM(name='hoReportType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HoReportType')))
    _HOReport_hosourceID = CHOICE(name='hosourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    _HOReport_hoTargetID = CHOICE(name='hoTargetID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    _HOReport_candidateCellList = SEQ_OF(name='candidateCellList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CandidateCellList')))
    _HOReport_candidatePCIList = SEQ_OF(name='candidatePCIList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CandidatePCIList')), opt=True)
    HOReport._cont = ASN1Dict([
        ('hoType', _HOReport_hoType),
        ('hoReportType', _HOReport_hoReportType),
        ('hosourceID', _HOReport_hosourceID),
        ('hoTargetID', _HOReport_hoTargetID),
        ('candidateCellList', _HOReport_candidateCellList),
        ('candidatePCIList', _HOReport_candidatePCIList),
        ])
    HOReport._ext = ['candidatePCIList']
    
    #-----< HoType >-----#
    HoType = ENUM(name='HoType', mode=MODE_TYPE)
    HoType._cont = ASN1Dict([('ltetoutran', 0), ('ltetogeran', 1)])
    HoType._ext = []
    
    #-----< HoReportType >-----#
    HoReportType = ENUM(name='HoReportType', mode=MODE_TYPE)
    HoReportType._cont = ASN1Dict([('unnecessaryhotoanotherrat', 0), ('earlyirathandover', 1)])
    HoReportType._ext = ['earlyirathandover']
    
    #-----< CandidateCellList >-----#
    CandidateCellList = SEQ_OF(name='CandidateCellList', mode=MODE_TYPE)
    _CandidateCellList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    CandidateCellList._cont = _CandidateCellList__item_
    CandidateCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CandidatePCIList >-----#
    CandidatePCIList = SEQ_OF(name='CandidatePCIList', mode=MODE_TYPE)
    _CandidatePCIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'CandidatePCI')))
    CandidatePCIList._cont = _CandidatePCIList__item_
    CandidatePCIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CandidatePCI >-----#
    CandidatePCI = SEQ(name='CandidatePCI', mode=MODE_TYPE)
    _CandidatePCI_pCI = INT(name='pCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_pCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _CandidatePCI_eARFCN = OCT_STR(name='eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CandidatePCI._cont = ASN1Dict([
        ('pCI', _CandidatePCI_pCI),
        ('eARFCN', _CandidatePCI_eARFCN),
        ])
    CandidatePCI._ext = []
    
    #-----< CellActivationRequest >-----#
    CellActivationRequest = SEQ(name='CellActivationRequest', mode=MODE_TYPE)
    _CellActivationRequest_cellsToActivateList = SEQ_OF(name='cellsToActivateList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellsToActivateList')))
    _CellActivationRequest_minimumActivationTime = INT(name='minimumActivationTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CellActivationRequest_minimumActivationTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=None, er=[])
    CellActivationRequest._cont = ASN1Dict([
        ('cellsToActivateList', _CellActivationRequest_cellsToActivateList),
        ('minimumActivationTime', _CellActivationRequest_minimumActivationTime),
        ])
    CellActivationRequest._ext = []
    
    #-----< CellsToActivateList >-----#
    CellsToActivateList = SEQ_OF(name='CellsToActivateList', mode=MODE_TYPE)
    _CellsToActivateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'CellsToActivateList-Item')))
    CellsToActivateList._cont = _CellsToActivateList__item_
    CellsToActivateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellsToActivateList-Item >-----#
    CellsToActivateList_Item = SEQ(name='CellsToActivateList-Item', mode=MODE_TYPE)
    _CellsToActivateList_Item_cell_ID = OCT_STR(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CellsToActivateList_Item._cont = ASN1Dict([
        ('cell-ID', _CellsToActivateList_Item_cell_ID),
        ])
    CellsToActivateList_Item._ext = []
    
    #-----< CellActivationResponse >-----#
    CellActivationResponse = SEQ(name='CellActivationResponse', mode=MODE_TYPE)
    _CellActivationResponse_activatedCellsList = SEQ_OF(name='activatedCellsList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'ActivatedCellsList')))
    CellActivationResponse._cont = ASN1Dict([
        ('activatedCellsList', _CellActivationResponse_activatedCellsList),
        ])
    CellActivationResponse._ext = []
    
    #-----< ActivatedCellsList >-----#
    ActivatedCellsList = SEQ_OF(name='ActivatedCellsList', mode=MODE_TYPE)
    _ActivatedCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'ActivatedCellsList-Item')))
    ActivatedCellsList._cont = _ActivatedCellsList__item_
    ActivatedCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ActivatedCellsList-Item >-----#
    ActivatedCellsList_Item = SEQ(name='ActivatedCellsList-Item', mode=MODE_TYPE)
    _ActivatedCellsList_Item_cell_ID = OCT_STR(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ActivatedCellsList_Item._cont = ASN1Dict([
        ('cell-ID', _ActivatedCellsList_Item_cell_ID),
        ])
    ActivatedCellsList_Item._ext = []
    
    #-----< CellStateIndication >-----#
    CellStateIndication = SEQ(name='CellStateIndication', mode=MODE_TYPE)
    _CellStateIndication_notificationCellList = SEQ_OF(name='notificationCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NotificationCellList')))
    CellStateIndication._cont = ASN1Dict([
        ('notificationCellList', _CellStateIndication_notificationCellList),
        ])
    CellStateIndication._ext = []
    
    #-----< NotificationCellList >-----#
    NotificationCellList = SEQ_OF(name='NotificationCellList', mode=MODE_TYPE)
    _NotificationCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'NotificationCellList-Item')))
    NotificationCellList._cont = _NotificationCellList__item_
    NotificationCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NotificationCellList-Item >-----#
    NotificationCellList_Item = SEQ(name='NotificationCellList-Item', mode=MODE_TYPE)
    _NotificationCellList_Item_cell_ID = OCT_STR(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NotificationCellList_Item_notifyFlag = ENUM(name='notifyFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NotifyFlag')))
    NotificationCellList_Item._cont = ASN1Dict([
        ('cell-ID', _NotificationCellList_Item_cell_ID),
        ('notifyFlag', _NotificationCellList_Item_notifyFlag),
        ])
    NotificationCellList_Item._ext = []
    
    #-----< NotifyFlag >-----#
    NotifyFlag = ENUM(name='NotifyFlag', mode=MODE_TYPE)
    NotifyFlag._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    NotifyFlag._ext = []
    
    #-----< FailureEventReport >-----#
    FailureEventReport = CHOICE(name='FailureEventReport', mode=MODE_TYPE)
    _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN = SEQ(name='tooEarlyInterRATHOReportFromEUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'TooEarlyInterRATHOReportReportFromEUTRAN')))
    FailureEventReport._cont = ASN1Dict([
        ('tooEarlyInterRATHOReportFromEUTRAN', _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN),
        ])
    FailureEventReport._ext = []
    
    #-----< TooEarlyInterRATHOReportReportFromEUTRAN >-----#
    TooEarlyInterRATHOReportReportFromEUTRAN = SEQ(name='TooEarlyInterRATHOReportReportFromEUTRAN', mode=MODE_TYPE)
    _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer = OCT_STR(name='uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation = BIT_STR(name='mobilityInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MobilityInformation')), opt=True)
    TooEarlyInterRATHOReportReportFromEUTRAN._cont = ASN1Dict([
        ('uERLFReportContainer', _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer),
        ('mobilityInformation', _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation),
        ])
    TooEarlyInterRATHOReportReportFromEUTRAN._ext = []
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name='MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< EHRPDCapacityValue >-----#
    EHRPDCapacityValue = INT(name='EHRPDCapacityValue', mode=MODE_TYPE)
    EHRPDCapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< EHRPDSectorCapacityClassValue >-----#
    EHRPDSectorCapacityClassValue = INT(name='EHRPDSectorCapacityClassValue', mode=MODE_TYPE)
    EHRPDSectorCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< EHRPDSectorLoadReportingResponse >-----#
    EHRPDSectorLoadReportingResponse = SEQ(name='EHRPDSectorLoadReportingResponse', mode=MODE_TYPE)
    _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity = SEQ(name='dL-EHRPD-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCompositeAvailableCapacity')))
    _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity = SEQ(name='uL-EHRPD-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCompositeAvailableCapacity')))
    EHRPDSectorLoadReportingResponse._cont = ASN1Dict([
        ('dL-EHRPD-CompositeAvailableCapacity', _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity),
        ('uL-EHRPD-CompositeAvailableCapacity', _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity),
        ])
    EHRPDSectorLoadReportingResponse._ext = []
    
    #-----< EHRPDCompositeAvailableCapacity >-----#
    EHRPDCompositeAvailableCapacity = SEQ(name='EHRPDCompositeAvailableCapacity', mode=MODE_TYPE)
    _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue = INT(name='eHRPDSectorCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorCapacityClassValue')))
    _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue = INT(name='eHRPDCapacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCapacityValue')))
    EHRPDCompositeAvailableCapacity._cont = ASN1Dict([
        ('eHRPDSectorCapacityClassValue', _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue),
        ('eHRPDCapacityValue', _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue),
        ])
    EHRPDCompositeAvailableCapacity._ext = []
    
    #-----< EHRPDMultiSectorLoadReportingResponseItem >-----#
    EHRPDMultiSectorLoadReportingResponseItem = SEQ(name='EHRPDMultiSectorLoadReportingResponseItem', mode=MODE_TYPE)
    _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID = OCT_STR(name='eHRPD-Sector-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPD-Sector-ID')))
    _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse = SEQ(name='eHRPDSectorLoadReportingResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorLoadReportingResponse')))
    EHRPDMultiSectorLoadReportingResponseItem._cont = ASN1Dict([
        ('eHRPD-Sector-ID', _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID),
        ('eHRPDSectorLoadReportingResponse', _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse),
        ])
    EHRPDMultiSectorLoadReportingResponseItem._ext = []
    
    #-----< maxnoofIRATReportingCells >-----#
    maxnoofIRATReportingCells = INT(name='maxnoofIRATReportingCells', mode=MODE_VALUE)
    maxnoofIRATReportingCells._val = 128
    
    #-----< maxnoofcandidateCells >-----#
    maxnoofcandidateCells = INT(name='maxnoofcandidateCells', mode=MODE_VALUE)
    maxnoofcandidateCells._val = 16
    
    #-----< maxnoofCellineNB >-----#
    maxnoofCellineNB = INT(name='maxnoofCellineNB', mode=MODE_VALUE)
    maxnoofCellineNB._val = 256
    
    _all_ = [
        SONtransferApplicationIdentity,
        _SONtransferRequestContainer_cellLoadReporting,
        _SONtransferRequestContainer_multiCellLoadReporting,
        _SONtransferRequestContainer_eventTriggeredCellLoadReporting,
        _SONtransferRequestContainer_hOReporting,
        _SONtransferRequestContainer_eutranCellActivation,
        _SONtransferRequestContainer_energySavingsIndication,
        _SONtransferRequestContainer_failureEventReporting,
        SONtransferRequestContainer,
        _SONtransferResponseContainer_cellLoadReporting,
        _SONtransferResponseContainer_multiCellLoadReporting,
        _SONtransferResponseContainer_eventTriggeredCellLoadReporting,
        _SONtransferResponseContainer_hOReporting,
        _SONtransferResponseContainer_eutranCellActivation,
        _SONtransferResponseContainer_energySavingsIndication,
        _SONtransferResponseContainer_failureEventReporting,
        SONtransferResponseContainer,
        _SONtransferCause_cellLoadReporting,
        _SONtransferCause_multiCellLoadReporting,
        _SONtransferCause_eventTriggeredCellLoadReporting,
        _SONtransferCause_hOReporting,
        _SONtransferCause_eutranCellActivation,
        _SONtransferCause_energySavingsIndication,
        _SONtransferCause_failureEventReporting,
        SONtransferCause,
        CellLoadReportingCause,
        HOReportingCause,
        CellActivationCause,
        CellStateIndicationCause,
        FailureEventReportingCause,
        _CellLoadReportingResponse_eUTRAN,
        _CellLoadReportingResponse_uTRAN,
        _CellLoadReportingResponse_gERAN,
        _CellLoadReportingResponse_eHRPD,
        CellLoadReportingResponse,
        CompositeAvailableCapacityGroup,
        _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup,
        EUTRANcellLoadReportingResponse,
        _EUTRANResponse_cell_ID,
        _EUTRANResponse_eUTRANcellLoadReportingResponse,
        EUTRANResponse,
        EHRPD_Sector_ID,
        _IRAT_Cell_ID_eUTRAN,
        _IRAT_Cell_ID_uTRAN,
        _IRAT_Cell_ID_gERAN,
        _IRAT_Cell_ID_eHRPD,
        IRAT_Cell_ID,
        _RequestedCellList__item_,
        RequestedCellList,
        _MultiCellLoadReportingRequest_requestedCellList,
        MultiCellLoadReportingRequest,
        _ReportingCellList_Item_cell_ID,
        ReportingCellList_Item,
        _ReportingCellList__item_,
        ReportingCellList,
        _MultiCellLoadReportingResponse__item_,
        MultiCellLoadReportingResponse,
        _MultiCellLoadReportingResponse_Item_eUTRANResponse,
        _MultiCellLoadReportingResponse_Item_uTRANResponse,
        _MultiCellLoadReportingResponse_Item_gERANResponse,
        _MultiCellLoadReportingResponse_Item_eHRPD,
        MultiCellLoadReportingResponse_Item,
        NumberOfMeasurementReportingLevels,
        _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels,
        EventTriggeredCellLoadReportingRequest,
        OverloadFlag,
        _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse,
        _EventTriggeredCellLoadReportingResponse_overloadFlag,
        EventTriggeredCellLoadReportingResponse,
        _HOReport_hoType,
        _HOReport_hoReportType,
        _HOReport_hosourceID,
        _HOReport_hoTargetID,
        _HOReport_candidateCellList,
        _HOReport_candidatePCIList,
        HOReport,
        HoType,
        HoReportType,
        _CandidateCellList__item_,
        CandidateCellList,
        _CandidatePCIList__item_,
        CandidatePCIList,
        _CandidatePCI_pCI,
        _CandidatePCI_eARFCN,
        CandidatePCI,
        _CellActivationRequest_cellsToActivateList,
        _CellActivationRequest_minimumActivationTime,
        CellActivationRequest,
        _CellsToActivateList__item_,
        CellsToActivateList,
        _CellsToActivateList_Item_cell_ID,
        CellsToActivateList_Item,
        _CellActivationResponse_activatedCellsList,
        CellActivationResponse,
        _ActivatedCellsList__item_,
        ActivatedCellsList,
        _ActivatedCellsList_Item_cell_ID,
        ActivatedCellsList_Item,
        _CellStateIndication_notificationCellList,
        CellStateIndication,
        _NotificationCellList__item_,
        NotificationCellList,
        _NotificationCellList_Item_cell_ID,
        _NotificationCellList_Item_notifyFlag,
        NotificationCellList_Item,
        NotifyFlag,
        _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN,
        FailureEventReport,
        _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer,
        _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation,
        TooEarlyInterRATHOReportReportFromEUTRAN,
        MobilityInformation,
        EHRPDCapacityValue,
        EHRPDSectorCapacityClassValue,
        _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity,
        _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity,
        EHRPDSectorLoadReportingResponse,
        _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue,
        _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue,
        EHRPDCompositeAvailableCapacity,
        _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID,
        _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse,
        EHRPDMultiSectorLoadReportingResponseItem,
        maxnoofIRATReportingCells,
        maxnoofcandidateCells,
        maxnoofCellineNB,
    ]

init_modules(S1AP_CommonDataTypes, S1AP_Constants, S1AP_Containers, S1AP_IEs, S1AP_PDU_Contents, S1AP_PDU_Descriptions, SonTransfer_IEs)
